rem MakeLibOpt.bat
rem Kevin Carmody - 2008.03.25
rem Called by MakeLib.bat files.

if "%1"=="?"  goto SYNTAX
if "%1"=="/?" goto SYNTAX
goto PARPARSE

:SYNTAX
  echo.
  echo MakeLib.bat
  echo Makes %MV_LIBNAME% library
  echo.
  echo Syntax:
  echo MakeLib [/X] [/-X] [/T] [/P] [/ML] [/ND] [/DO]
  echo   /X          Use xHarbour, must precede other options,
  echo                 default if MG_CMP set to XHARBOUR, see below
  echo   /-X         Use Harbour, must precede other options,
  echo                 default if MG_CMP missing or not set to XHARBOUR
  echo   /T          Use Turbo Assembler during C compile
  echo   /P          Pause at end
  echo   /ML         Build library in MiniGui library folder
  echo   /ND         Do not delete temporary files after compile and build
  echo   /DO         Delete temporary files only, no compile or build
  echo   Spacing between parameters must be as shown.
  echo.
  pause
  echo You may set the following environment variables.  
  echo Locations in these variables must not have a trailing backslash.
  echo.
  echo   MG_BCC      Location of BCC, default C:\Borland\BCC55
  echo   MG_ROOT     Location of MinuGui, default C:\MiniGui
  echo   MG_HRB      Location of Harbour, default (MG_ROOT)\Harbour
  echo   MG_LIB      Location of Harbour MiniGui libraries, default (MG_ROOT)\Lib
  echo   MG_XHRB     Location of xHarbour, default C:\xHarbour
  echo   MG_XLIB     Location of xHarbour MiniGui libraries, default (MG_ROOT)\xLib
  echo   MG_CMP      If set to XHARBOUR, then use xHarbour by default: 
  echo                 /X is not necessary, may be overridden by /-X
  echo   MG_LBLD     If set to MINIGUI, then build library in MiniGui library folder
  echo.
  set MV_PAUSE=Y
  set MV_EXIT=Y
  goto END

:SYNTERR
  echo Type MakeLib.bat ? for syntax.
  set MV_PAUSE=Y
  set MV_EXIT=Y
  goto END

:PARPARSE
  set MV_EXIT=N
  set MV_LIBNAME=%1
  set MV_USEXHRB=N
  set MV_USETASM=N
  set MV_PAUSE=N
  set MV_DODEL=Y
  set MV_DODONLY=N
  set MV_MGLIB=N
  if exist C:\Minigui\BATCH\xMySet.bat call C:\Minigui\BATCH\xmyset.bat
  if "%MG_CMP%"=="XHARBOUR" set MV_USEXHRB=Y
  if "%MG_BCC%"==""  set MG_BCC=c:\borland\bcc55
  if "%MG_ROOT%"=="" set MG_ROOT=c:\minigui
  if "%MG_HRB%"==""  set MG_HRB=%MG_ROOT%\harbour
  if "%MG_LIB%"==""  set MG_LIB=%MG_ROOT%\lib
  if "%MG_XHRB%"=="" set MG_XHRB=c:\xharbour
  if "%MG_XLIB%"=="" set MG_XLIB=%MG_ROOT%\xlib
  if %MV_USEXHRB%==N set MV_HRB=%MG_HRB%
  if %MV_USEXHRB%==N set MV_LIB=%MG_LIB%
  if %MV_USEXHRB%==Y set MV_HRB=%MG_XHRB%
  if %MV_USEXHRB%==Y set MV_LIB=%MG_XLIB%
  shift
  if %1==M set MV_MGLIB=Y
  if %1==m set MV_MGLIB=Y
  if %1==H set MV_MGLIB=N
  if %1==h set MV_MGLIB=N
  if "%MG_LBLD%"=="MINIGUI" set MV_MGLIB=Y
:PARMORE
  shift
  if "%1"=="" goto SETBUILD
  if %1==?   goto SYNTAX
  if %1==/?  goto SYNTAX
  if %1==/x  goto XHARBSET
  if %1==/X  goto XHARBSET
  if %1==/-x goto HARBSET
  if %1==/-X goto HARBSET
  if %1==/t  goto TASMSET
  if %1==/T  goto TASMSET
  if %1==/p  goto PAUSESET
  if %1==/P  goto PAUSESET
  if %1==/ml goto MLSET
  if %1==/ML goto MLSET
  if %1==/nd goto DELSET
  if %1==/ND goto DELSET
  if %1==/do goto DONLYSET
  if %1==/DO goto DONLYSET
  echo Unknown option %1
  goto SYNTERR
:XHARBSET
  set MV_USEXHRB=Y
  set MV_HRB=%MG_XHRB%
  set MV_LIB=%MG_XLIB%
  goto PARMORE
:HARBSET
  set MV_USEXHRB=N
  set MV_HRB=%MG_HRB%
  set MV_LIB=%MG_LIB%
  goto PARMORE
:TASMSET
  set MV_USETASM=Y
  goto PARMORE
:PAUSESET
  set MV_PAUSE=Y
  goto PARMORE
:MLSET
  set MV_MGLIB=Y
  goto PARMORE
:DELSET
  set MV_DODEL=N
  goto PARMORE
:DONLYSET
  set MV_DODONLY=Y
  goto PARMORE

:SETBUILD
  if %MV_MGLIB%==Y set MV_BUILD=%MV_LIB%
  if %MV_MGLIB%==N set MV_BUILD=%MV_HRB%\lib

:TASMCHECK
  if %MV_USETASM%==N goto END
  if exist %MG_BCC%\bin\tasm32.exe goto END
  echo Assembler TASM32.EXE required but not found in %MG_BCC%\bin.
  echo %MV_LIBNAME%.lib not built.
  set MV_PAUSE=Y
  set MV_EXIT=Y
  goto END

:END