/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 DEFINE BKGBRUSH definition
 (C) P.Chornyj <myorg63@mail.ru>
 HMG Extended Build 30

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

/* Brush Styles */
#define BS_SOLID            0
#define BS_NULL             1
#define BS_HOLLOW           BS_NULL
#define BS_HATCHED          2
#define BS_PATTERN          3

/* Hatch Styles */
#define HS_HORIZONTAL       0       /* ----- */
#define HS_VERTICAL         1       /* ||||| */
#define HS_FDIAGONAL        2       /* \\\\\ */
#define HS_BDIAGONAL        3       /* ///// */
#define HS_CROSS            4       /* +++++ */
#define HS_DIAGCROSS        5       /* xxxxx */
/*
#define COLOR_SCROLLBAR         0
#define COLOR_BACKGROUND        1
#define COLOR_ACTIVECAPTION     2
#define COLOR_INACTIVECAPTION   3
#define COLOR_MENU              4
#define COLOR_WINDOW            5
#define COLOR_WINDOWFRAME       6
#define COLOR_MENUTEXT          7
#define COLOR_WINDOWTEXT        8
#define COLOR_CAPTIONTEXT       9
#define COLOR_ACTIVEBORDER      10
#define COLOR_INACTIVEBORDER    11
#define COLOR_APPWORKSPACE      12
#define COLOR_HIGHLIGHT         13
#define COLOR_HIGHLIGHTTEXT     14
#define COLOR_BTNFACE           15
#define COLOR_BTNSHADOW         16
#define COLOR_GRAYTEXT          17
#define COLOR_BTNTEXT           18
#define COLOR_INACTIVECAPTIONTEXT 19
#define COLOR_BTNHIGHLIGHT      20
*/
/* WINVER >= 0x0400
#define COLOR_3DDKSHADOW 21
#define COLOR_3DLIGHT    22
#define COLOR_INFOTEXT   23
#define COLOR_INFOBK     24
*/
/* WINVER >= 0x0500
#define COLOR_HOTLIGHT   26
#define COLOR_GRADIENTACTIVECAPTION 27
#define COLOR_GRADIENTINACTIVECAPTION 28
*/
#xtranslate DEFINE BKGBRUSH <brush> SOLID IN [ WINDOW ] <parent> ;
       [ COLOR <aColor1> ] ; 
       [ <nodelete: NODELETE> ] ; 
=>;
       <brush> := SetWndBrush( <"parent">, <.nodelete.>, BS_SOLID, NIL, <aColor1>, NIL)

#xtranslate DEFINE BKGBRUSH <brush> HATCHED IN [ WINDOW ] <parent> ;
       [ [HATCHSTYLE] <hatch> ] ;
       [ COLOR <aColor1> ] ; 
       [ <nodelete: NODELETE> ] ; 
=>;
       <brush> := SetWndBrush( <"parent">, <.nodelete.>, BS_HATCHED, <hatch>, <aColor1>, NIL)

#xtranslate DEFINE BKGBRUSH <brush> PATTERN IN [ WINDOW ] <parent> ;
       [ BITMAP <bitmap> ] ;
       [ <nodelete: NODELETE> ] ; 
=>;
       <brush> := SetWndBrush( <"parent">, <.nodelete.>, BS_PATTERN, NIL, NIL, <"bitmap"> )

#xtranslate DELETE BRUSH <brush> ;
=>;
       DeleteBrush( <brush> )
