/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#define IDC_ARROW   32512
#define IDC_IBEAM   32513
#define IDC_WAIT   32514
#define IDC_CROSS   32515
#define IDC_UPARROW   32516
#define IDC_SIZENWSE   32642
#define IDC_SIZENESW   32643
#define IDC_SIZEWE   32644
#define IDC_SIZENS   32645
#define IDC_SIZEALL   32646
#define IDC_NO   32648
#define IDC_APPSTARTING   32650
#define IDC_HELP   32651

#command SETFOCUS <n> OF <w>;
   =>;
   DoMethod ( <"w"> , <"n"> , 'SetFocus' )

#command ADD ITEM <i> TO <n> OF <p> ;
   =>;
   DoMethod ( <"p"> , <"n"> , 'AddItem' , <i> )

#command ADD COLUMN [ INDEX <index> ] [ CAPTION <caption> ] [ WIDTH <width> ] [ JUSTIFY <justify> ] TO <control> OF <parent> ;
   =>;
   DoMethod ( <"parent"> , <"control"> , 'AddColumn' , <index> , <caption> , <width> , <justify> )

#command DELETE COLUMN [ INDEX ] <index> FROM <control> OF <parent> ;
   =>;
   DoMethod ( <"parent"> , <"control"> , 'DeleteColumn' , <index> )

#command DELETE ITEM <i> FROM <n> OF <p>;
   =>;
   DoMethod ( <"p"> , <"n"> , 'DeleteItem' , <i> )

#command DELETE ITEM ALL FROM <n> OF <p>;
   =>;
   DoMethod ( <"p"> , <"n"> , 'DeleteAllItems' )

#command ENABLE CONTROL <control> OF <form>;
   =>;
   SetProperty ( <"form"> , <"control"> , 'Enabled' , .T. )

#command SHOW CONTROL <control> OF <form>;
   =>;
   DoMethod ( <"form"> , <"control"> , 'Show' )

#command HIDE CONTROL <control> OF <form>;
   =>;
   DoMethod ( <"form"> , <"control"> , 'Hide' )

#command DISABLE CONTROL <control> OF <form>;
   =>;
   SetProperty ( <"form"> , <"control"> , 'Enabled' , .F. )

#command RELEASE CONTROL <control> OF <form>;
   =>;
   DoMethod ( <"form"> , <"control"> , 'Release' )

#translate MODIFY [ PROPERTY ] [ CONTROL ] <Arg2> OF <Arg1> <Arg3> <Arg4> ;
=> ;
SetProperty ( <"Arg1"> , <"Arg2"> , <"Arg3"> , <Arg4> )

#xtranslate MODIFY [ PROPERTY ] [ CONTROL ] <Arg2> OF <Arg1> <Arg3> ( <Arg4> ) <Arg5> ;
=> ;
SetProperty ( <"Arg1"> , <"Arg2"> , <"Arg3"> , <Arg4> , <Arg5> )

#xtranslate FETCH [ PROPERTY ] [ CONTROL ] <Arg2> OF <Arg1> <Arg3> TO <Arg4> ;
=> ;
<Arg4> := GetProperty ( <"Arg1"> , <"Arg2"> , <"Arg3"> )

#xtranslate FETCH [ PROPERTY ] [ CONTROL ] <Arg2> OF <Arg1> <Arg3> (<Arg4>) TO <Arg5> ;
=> ;
<Arg5> := GetProperty ( <"Arg1"> , <"Arg2"> , <"Arg3"> , <Arg4> )

#xtranslate MODIFY [ PROPERTY ] [ CONTROL ] <Arg2> OF <Arg1> <Arg3> .T. ;
=> ;
SetProperty ( <"Arg1"> , <"Arg2"> , <"Arg3"> , .T. )

#xtranslate MODIFY [ PROPERTY ] [ CONTROL ] <Arg2> OF <Arg1> <Arg3> .F. ;
=> ;
SetProperty ( <"Arg1"> , <"Arg2"> , <"Arg3"> , .F. )

#xtranslate MODIFY [ PROPERTY ] [ CONTROL ] <Arg2> OF <Arg1> <Arg3> { <Arg4, ...> } ;
=> ;
SetProperty ( <"Arg1"> , <"Arg2"> , <"Arg3"> , \{<Arg4>\} )

#translate SET MULTIPLE <x:ON,OFF> [<warning: WARNING>] ;
=> ;
_HMG_lMultiple := ( Upper(<(x)>) == "ON" ) ; IIF ( _HMG_lMultiple == .F. .AND. _HMG_IsMultiple == .T. , ( IIF ( <.warning.> , ( InitMessages() , MsgStop(_HMG_MESSAGE\[4\]) ) , ) , ExitProcess(0) ) , )

#translate CRLF => HB_OsNewLine()

#translate SET AUTOSCROLL OFF => _HMG_AutoScroll := .F.
#translate SET AUTOSCROLL ON =>  _HMG_AutoScroll := .T.

#translate SET CONTEXTMENUS OFF => _HMG_ShowContextMenus := .F.
#translate SET CONTEXTMENUS ON =>  _HMG_ShowContextMenus := .T.

#translate SET CONTEXTMENU OFF => _HMG_ShowContextMenus := .F.
#translate SET CONTEXTMENU ON =>  _HMG_ShowContextMenus := .T.

#translate SET CONTEXT MENU OFF => _HMG_ShowContextMenus := .F.
#translate SET CONTEXT MENU ON =>  _HMG_ShowContextMenus := .T.

#translate SET PROGRAMMATICCHANGE OFF => _HMG_ProgrammaticChange := .F.
#translate SET PROGRAMMATICCHANGE ON => _HMG_ProgrammaticChange := .T.

#xcommand SET SHOWDETAILERROR <x:ON,OFF> => _lShowDetailError( Upper(<(x)>) == "ON" )

#command CLEAN MEMORY => if( IsWinNT(), CleanProgramMemory(), )

#command SET EVENTS FUNCTION TO <name> => SetEventsFunc( <"name"> )

#xcommand EXIT PROCEDURE <name> ;
=> ;
INIT PROCEDURE <name> ;;
   MsgStop ('EXIT PROCEDURE Statement is not Supported in MiniGUI. Use Main Window ON RELEASE Event Procedure Instead. Program Terminated','MiniGUI Error') ;;
   ExitProcess()

#xcommand DRAW PANEL IN WINDOW <parent> ;
      AT <frow>,<fcol> ;
      TO <trow>,<tcol> ;
=>;
      DrawWindowBoxRaised( <"parent">, <frow>, <fcol>, <trow>, <tcol> )

#xcommand DRAW BOX IN WINDOW <parent> ;
      AT <frow>,<fcol> ;
      TO <trow>,<tcol> ;
=>;
      DrawWindowBoxIn( <"parent">, <frow>, <fcol>, <trow>, <tcol> )

#xcommand DRAW GRADIENT IN WINDOW <parent> ;
      AT <frow>,<fcol> ;
      TO <trow>,<tcol> ;
      [ BEGINCOLOR <aColor1> ] ;
      [ ENDCOLOR <aColor2> ] ;
      [ <vertical: VERTICAL> ] ;
      [ BORDER <border> ] ;
=>;
      DrawGradient( <"parent">, <frow>, <fcol>, <trow>, <tcol>,;
                    <aColor1>, <aColor2>, <.vertical.>, <border> )
