/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

////////////////////////////
// MiniGUI pseudo-functions
////////////////////////////

#xtranslate MsgInfo( <c>, <t> ) => MsgInfo ( <c>, <t>, , .F. )
#xtranslate MsgStop( <c>, <t> ) => MsgStop ( <c>, <t>, , .F. )
#xtranslate MsgYesNo( <c>, <t>) => MsgYesNo(<c>, <t>, , , .F.)
#xtranslate MsgAlert( <c>, <t>) => MsgExclamation( <c>, <t>, , .F. )
#xtranslate MsgExclamation( <c>, <t> ) => MsgExclamation( <c>, <t>, , .F. )
#xtranslate MsgYesNoCancel( <c>, <t> ) => MsgYesNoCancel( <c>, <t>, , .F.)
#xtranslate MsgRetryCancel( <c>, <t> ) => MsgRetryCancel( <c>, <t>, , .F. )
#xtranslate MsgOkCancel( <c>, <t> ) => MsgOkCancel( <c>, <t>, , .F. )

#translate _RestoreWindow ( <FormName> ) ;
=> ;
Restore( GetFormHandle( <FormName> ) )

#translate _MaximizeWindow ( <FormName> ) ;
=> ;
Maximize( GetFormHandle( <FormName> ) )

#translate _MinimizeWindow ( <FormName> ) ;
=> ;
Minimize( GetFormHandle( <FormName> ) )

#translate GetSpecialFolder ( <nCSIDL> ) ;
=> ;
C_GetSpecialFolder( <nCSIDL> )

#translate GetWindowsFolder () ;
=> ;
GetWindowsDir ()

#translate GetSystemFolder () ;
=> ;
GetSystemDir ()

#translate GetTempFolder () ;
=> ;
cFilePath( GetTempDir() )

#translate GetMyDocumentsFolder () ;
=> ;
GetSpecialFolder ( CSIDL_PERSONAL )

#translate GetDesktopFolder () ;
=> ;
GetSpecialFolder ( CSIDL_DESKTOPDIRECTORY )

#translate GetApplicationDataFolder () ;
=> ;
GetSpecialFolder( CSIDL_APPDATA )

#translate GetStartUpFolder () ;
=> ;
cFilePath( GetExeFilename() )

#translate GetModuleFilename ( <hInstance> ) ;
=> ;
GetExeFilename ()

#translate IsWinNT () ;
=> ;
( GetE("OS") == "Windows_NT" )

#translate IsVista () ;
=> ;
( 'Vista' $ WindowsVersion() \[1\] )

#translate DoMethod ( <FormName> , "SaveAs", <FileName> ) ;
=> ;
WndCopy( GetFormHandle( <FormName> ), .f., <FileName> )

#translate DoMethod ( <FormName> , <ControlName> , "SaveAs", <FileName> ) ;
=> ;
WndCopy( GetControlHandle( <ControlName> , <FormName> ), .t., <FileName> )

#translate IsControlDefined ( <ControlName> , <FormName> ) ;
=> ;
_IsControlDefined ( <"ControlName"> , <"FormName"> )

#translate IsWindowActive ( <FormName> ) ;
=> ;
_IsWIndowActive ( <"FormName"> ) 

#translate IsWindowDefined ( <FormName> ) ;
=> ;
_IsWindowDefined ( <"FormName"> )

#translate GetHotKeyName ( <ControlName> , <FormName> ) ;
=> ;
_GetHotKeyName ( <"ControlName"> , <"FormName"> )

#translate GetHotKeyValue ( <ControlName> , <FormName> ) ;
=> ;
_GetHotKeyValue ( <"ControlName"> , <"FormName"> )

#translate IsErrorLogActive () ;
=> ;
_HMG_CreateErrorLog

#translate _GetErrorlogFile () ;
=> ;
_HMG_ErrorLogFile

#translate And ( <p1> , <p2> ) ;
=> ;
HB_BitAnd( <p1> , <p2> )

////////////////////////////////////////////        
// Variable type identifier pseudo-functions
////////////////////////////////////////////
#ifndef HB_COMMON_CH_

   /* Type checking macros */
   #translate ISNIL( <xValue> )       => ( <xValue> == NIL )
   #translate ISARRAY( <xValue> )     => hb_IsArray( <xValue> )
   #translate ISBLOCK( <xValue> )     => hb_IsBlock( <xValue> )
   #translate ISCHARACTER( <xValue> ) => hb_IsString( <xValue> )
   #translate ISDATE( <xValue> )      => hb_IsDate( <xValue> )
   #translate ISLOGICAL( <xValue> )   => hb_IsLogical( <xValue> )
   #translate ISMEMO( <xValue> )      => hb_IsMemo( <xValue> )
   #translate ISNUMBER( <xValue> )    => hb_IsNumeric( <xValue> )
   #translate ISOBJECT( <xValue> )    => hb_IsObject( <xValue> )

#endif

#translate ISCHAR( <xValue> )    => hb_IsString( <xValue> )
#translate ISSTRING( <xValue> )  => hb_IsString( <xValue> )
#translate ISNUMERIC( <xValue> ) => hb_IsNumeric( <xValue> )

#translate IFNIL( <v1>,<exp1>,<exp2> )       => IF( (<v1>) == NIL,<exp1>,<exp2> )
#translate IFARRAY( <v1>,<exp1>,<exp2> )     => IF( ISARRAY( <v1> ),<exp1>,<exp2> )
#translate IFBLOCK( <v1>,<exp1>,<exp2> )     => IF( ISBLOCK( <v1> ),<exp1>,<exp2> )
#translate IFCHARACTER( <v1>,<exp1>,<exp2> ) => IF( ISCHARACTER( <v1> ),<exp1>,<exp2> )
#translate IFCHAR( <v1>,<exp1>,<exp2> )      => IF( ISCHAR( <v1> ),<exp1>,<exp2> )
#translate IFSTRING( <v1>,<exp1>,<exp2> )    => IF( ISSTRING( <v1> ),<exp1>,<exp2> )
#translate IFDATE( <v1>,<exp1>,<exp2> )      => IF( ISDATE( <v1> ),<exp1>,<exp2> )
#translate IFLOGICAL( <v1>,<exp1>,<exp2> )   => IF( ISLOGICAL( <v1> ),<exp1>,<exp2> )
#translate IFNUMBER( <v1>,<exp1>,<exp2> )    => IF( ISNUMBER( <v1> ),<exp1>,<exp2> )
#translate IFNUMERIC( <v1>,<exp1>,<exp2> )   => IF( ISNUMERIC( <v1> ),<exp1>,<exp2> )
#translate IFOBJECT( <v1>,<exp1>,<exp2> )    => IF( ISOBJECT( <v1> ),<exp1>,<exp2> )
#translate IFEMPTY( <v1>,<exp1>,<exp2> )     => IF( EMPTY( <v1> ),<exp1>,<exp2> )


/////////////////////////////////////
// Abbreviated flow control modifiers
/////////////////////////////////////

#xcommand BREAKIF <log>  => IF ( <log> ) ; BREAK ; END
#xcommand EXITIF <log>   => IF ( <log> ) ; EXIT ; END
#xcommand LOOPIF <log>   => IF ( <log> ) ; LOOP ; END

// Extended commands

#command  REPEAT         => DO WHILE .T.
#command  UNTIL <lCond>  => IF !<lCond> ; EXIT ; END ; ENDDO

#ifndef HB_COMMON_CH_

   /* Friendly logical aliases */
   #define TRUE		.T.
   #define FALSE	.F.
   #define YES		.T.
   #define NO		.F.

   /* DEFAULT and UPDATE commands */
   #xcommand DEFAULT <v1> TO <x1> [, <vn> TO <xn> ] => ;
                                IF <v1> == NIL ; <v1> := <x1> ; END ;
                                [; IF <vn> == NIL ; <vn> := <xn> ; END ]

   #command UPDATE <v1> IF <exp> TO <v2> ;
         =>                           ;
         IF <exp> ; <v1> := <v2> ; END

   /* To suppress unused variable -w2 warnings.
      It can be used in codeblocks, too. */
   #define HB_SYMBOL_UNUSED( symbol )  ( symbol := ( symbol ) )

#endif

#xtranslate frac( <num> ) => ( <num> - int( <num> ) )
