/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

/* HMG 1.0 Experimental Build 7 */

#define WM_USER                 0x0400
#define TTM_SETTIPBKCOLOR       (WM_USER + 19)
#define TTM_SETTIPTEXTCOLOR     (WM_USER + 20)
#define TTM_SETMAXTIPWIDTH      (WM_USER + 24)
#define TTM_SETTITLE            (WM_USER + 32)
#define TTI_NONE                0
#define TTI_INFO                1
#define TTI_WARNING             2
#define TTI_ERROR               3

#xcommand SET TOOLTIP <x:ON,OFF> => _lSetToolTip ( Upper(<(x)>) == "ON" )

#xcommand  SET TOOLTIPSTYLE BALLOON ;
      => ;
	_SetToolTipBalloon ( .T. )

#xcommand  SET TOOLTIPSTYLE STANDARD ;
      => ;
	_SetToolTipBalloon ( .F. )

#xcommand SET TOOLTIPBALLOON <x:ON,OFF> => _SetToolTipBalloon ( Upper(<(x)>) == "ON" )
#xcommand SET TOOLTIP BALLOON <x:ON,OFF> => _SetToolTipBalloon ( Upper(<(x)>) == "ON" )

#translate IsToolTipBalloonActive => _SetToolTipBalloon ()

#xcommand SET TOOLTIP TEXTCOLOR TO <color> OF <form> ;
   => ;
   SendMessage( GetFormToolTipHandle (<"form">), TTM_SETTIPTEXTCOLOR, RGB(<color>\[1\], <color>\[2\], <color>\[3\]), 0 )

#xcommand SET TOOLTIP BACKCOLOR TO <color> OF <form> ;
   => ;
   SendMessage( GetFormToolTipHandle (<"form">), TTM_SETTIPBKCOLOR, RGB(<color>\[1\], <color>\[2\], <color>\[3\]), 0 )

#xcommand SET TOOLTIP MAXWIDTH TO <w> OF <form> ;
   => ;
   SendMessage( GetFormToolTipHandle (<"form">), TTM_SETMAXTIPWIDTH, 0, <w> )

#xcommand ADD TOOLTIPICON INFO WITH MESSAGE <message> OF <form> ;
   => ;
   SendMessageString( GetFormToolTipHandle (<"form">), TTM_SETTITLE, TTI_INFO, <message> )

#xcommand ADD TOOLTIPICON WARNING WITH MESSAGE <message> OF <form> ;
   => ;
   SendMessageString( GetFormToolTipHandle (<"form">), TTM_SETTITLE, TTI_WARNING, <message> )

#xcommand ADD TOOLTIPICON ERROR WITH MESSAGE <message> OF <form> ;
   => ;
   SendMessageString( GetFormToolTipHandle (<"form">), TTM_SETTITLE, TTI_ERROR, <message> )

#xcommand CLEAR TOOLTIPICON OF <form> ;
   => ;
   SendMessageString( GetFormToolTipHandle (<"form">), TTM_SETTITLE, TTI_NONE, "" )
