/*
 * Harbour MiniGUI Project source code:
 * The declarations for all minigui defined functions/procedures.
 *
 * Copyright 2007 Grigory Filatov <gfilatov@freemail.ru>
 * www - http://www.hmgextended.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA (or visit the web site http://www.gnu.org/).
 *
 */

#ifndef MG_EXTERN_CH_
#define MG_EXTERN_CH_

/* Harbour functions/procedures */

EXTERNAL _ActivateAllWindows  
EXTERNAL _ActivateMdiWindow  
EXTERNAL _ActivateScrSaver  
EXTERNAL _ActivateWindow  
EXTERNAL _AddGridColumn  
EXTERNAL _AddGridRow  
EXTERNAL _AddImageMaskedToImageList  
EXTERNAL _AddImageToImageList  
EXTERNAL _AddItem  
EXTERNAL _AddTabControl  
EXTERNAL _AddTabPage  
EXTERNAL _AddToolBarToSpliBox  
EXTERNAL _AutoAdjust  
EXTERNAL _BeginDialog  
EXTERNAL _BeginDragImage  
EXTERNAL _BeginFrame  
EXTERNAL _BeginIni  
EXTERNAL _BeginMessageBar  
EXTERNAL _BeginScrSaver  
EXTERNAL _BeginTab  
EXTERNAL _BeginTabPage  
EXTERNAL _BeginToolBar  
EXTERNAL _BeginToolBarEx  
EXTERNAL _BrowseDelete  
EXTERNAL _BrowseDown  
EXTERNAL _BrowseEdit  
EXTERNAL _BrowseEnd  
EXTERNAL _BrowseGetValue  
EXTERNAL _BrowseHome  
EXTERNAL _BrowseInPlaceAppend  
EXTERNAL _BrowseInPlaceEdit  
EXTERNAL _BrowseNext  
EXTERNAL _BrowseOnChange  
EXTERNAL _BrowsePrior  
EXTERNAL _BrowseRefresh  
EXTERNAL _BrowseSetValue  
EXTERNAL _BrowseSync  
EXTERNAL _BrowseUp  
EXTERNAL _BrowseUpdate  
EXTERNAL _BrowseVscrollFastUpdate  
EXTERNAL _BrowseVscrollUpdate  
EXTERNAL _CenterWindow  
EXTERNAL _CheckMenuItem  
EXTERNAL _CloseActiveMdi  
EXTERNAL _CloseAnimateBox  
EXTERNAL _ClosePlayer  
EXTERNAL _Collapse  
EXTERNAL _CreatePopUpChevron  
EXTERNAL _DataBaseRichEditBoxSave  
EXTERNAL _DataCheckBoxRefresh  
EXTERNAL _DataCheckBoxSave  
EXTERNAL _DataComboRefresh  
EXTERNAL _DataDatePickerRefresh  
EXTERNAL _DataDatePickerSave  
EXTERNAL _DataEditBoxRefresh  
EXTERNAL _DataEditBoxSave  
EXTERNAL _DataGetBoxRefresh  
EXTERNAL _DataGetBoxSave  
EXTERNAL _DataRichEditBoxGetAutoFont  
EXTERNAL _DataRichEditBoxGetValue  
EXTERNAL _DataRichEditBoxOpen  
EXTERNAL _DataRichEditBoxRefresh  
EXTERNAL _DataRichEditBoxSave  
EXTERNAL _DataRichEditBoxSetAutoFont  
EXTERNAL _DataRichEditBoxSetValue  
EXTERNAL _DataTextBoxRefresh  
EXTERNAL _DataTextBoxSave  
EXTERNAL _DECRYPT  
EXTERNAL _DefineAnimateBox  
EXTERNAL _DefineBrowse  
EXTERNAL _DefineBtnTextBox  
EXTERNAL _DefineButton  
EXTERNAL _DefineCharMaskTextbox  
EXTERNAL _DefineCheckBox  
EXTERNAL _DefineCheckButton  
EXTERNAL _DefineChildMDIWindow  
EXTERNAL _DefineCombo  
EXTERNAL _DefineComboEx  
EXTERNAL _DefineContextMenu  
EXTERNAL _DefineControlContextMenu  
EXTERNAL _DefineDatePick  
EXTERNAL _DefineDialog  
EXTERNAL _DefineDropDownMenu  
EXTERNAL _DefineEditbox  
EXTERNAL _DefineFont  
EXTERNAL _DefineFrame  
EXTERNAL _DefineGetBox  
EXTERNAL _DefineGrid  
EXTERNAL _DefineHotKey  
EXTERNAL _DefineHotKeyBox  
EXTERNAL _DefineHyperLink  
EXTERNAL _DefineImage  
EXTERNAL _DefineImageButton  
EXTERNAL _DefineImageCheckButton  
EXTERNAL _DefineImageList  
EXTERNAL _DefineIPAddress  
EXTERNAL _DefineItemMessage  
EXTERNAL _DefineLabel  
EXTERNAL _DefineLetterOrDigitHotKey  
EXTERNAL _DefineListbox  
EXTERNAL _DefineMainMenu  
EXTERNAL _DefineMaskedTextbox  
EXTERNAL _DefineMenuItem  
EXTERNAL _DefineMenuPopup  
EXTERNAL _DefineModalWindow  
EXTERNAL _DefineMonthCal  
EXTERNAL _DefineNotifyMenu  
EXTERNAL _DefineOwnerButton  
EXTERNAL _DefinePlayer  
EXTERNAL _DefineProgressBar  
EXTERNAL _DefineRadioGroup  
EXTERNAL _DefineRichEditBox  
EXTERNAL _DefineSeparator  
EXTERNAL _DefineSlider  
EXTERNAL _DefineSpinner  
EXTERNAL _DefineSplitBox  
EXTERNAL _DefineSplitChildWindow  
EXTERNAL _DefineTab  
EXTERNAL _DefineTextBox  
EXTERNAL _DefineTimePick  
EXTERNAL _DefineTimer  
EXTERNAL _DefineToolBar  
EXTERNAL _DefineToolButton  
EXTERNAL _DefineTree  
EXTERNAL _DefineTreeItem  
EXTERNAL _DefineTreeNode  
EXTERNAL _DefineWindow  
EXTERNAL _DeleteAllItems  
EXTERNAL _DeleteGridColumn  
EXTERNAL _DeleteItem  
EXTERNAL _DeleteTabPage  
EXTERNAL _DelIniEntry  
EXTERNAL _DelIniSection  
EXTERNAL _DestroyAnimateBox  
EXTERNAL _DestroyBtnPicture  
EXTERNAL _DestroyBtnPictureMask  
EXTERNAL _DestroyImageList  
EXTERNAL _DestroyPlayer  
EXTERNAL _DisableControl  
EXTERNAL _DisableMenuItem  
EXTERNAL _DisableToolbarButton  
EXTERNAL _DoControlEventProcedure  
EXTERNAL _DoWindowEventProcedure  
EXTERNAL _DragEnterImage  
EXTERNAL _DrawImageFromImageList  
EXTERNAL _dummy  
EXTERNAL _EditItem  
EXTERNAL _EditItemOk  
EXTERNAL _EditRecord  
EXTERNAL _EjectPlayer  
EXTERNAL _EnableControl  
EXTERNAL _EnableListViewUpdate  
EXTERNAL _EnableMenuItem  
EXTERNAL _EnableToolbarButton  
EXTERNAL _ENCRYPT  
EXTERNAL _EndDialog  
EXTERNAL _EndDragImage  
EXTERNAL _EndIni  
EXTERNAL _EndMdiChildWindow  
EXTERNAL _EndMenu  
EXTERNAL _EndMenuPopup  
EXTERNAL _EndMessageBar  
EXTERNAL _EndSplitBox  
EXTERNAL _EndSplitChildWindow  
EXTERNAL _EndTab  
EXTERNAL _EndTabPage  
EXTERNAL _EndToolBar  
EXTERNAL _EndTree  
EXTERNAL _EndTreeNode  
EXTERNAL _EndWindow  
EXTERNAL _EraseControl  
EXTERNAL _EraseFontDef  
EXTERNAL _EraseImage  
EXTERNAL _Execute  
EXTERNAL _Expand  
EXTERNAL _ExtDisableControl  
EXTERNAL _ExtEnableControl  
EXTERNAL _GenActivateId  
EXTERNAL _GetAddress  
EXTERNAL _GetBackColor  
EXTERNAL _GetBoxSetNextFocus  
EXTERNAL _GetBoxSetPreviousFocus  
EXTERNAL _GetBrowseAllowAppend  
EXTERNAL _GetBrowseAllowDelete  
EXTERNAL _GetBrowseAllowEdit  
EXTERNAL _GetCaption  
EXTERNAL _GetCaretPos  
EXTERNAL _GetColumnWidth  
EXTERNAL _GetComboItemValue  
EXTERNAL _GetCompactPath  
EXTERNAL _GetControlAction  
EXTERNAL _GetControlCol  
EXTERNAL _GetControlFree  
EXTERNAL _GetControlHeight  
EXTERNAL _GetControlRow  
EXTERNAL _GetControlWidth  
EXTERNAL _GetDatePickerDateFormat  
EXTERNAL _GetDefinedStatusBarItemValue  
EXTERNAL _GetDropDownWidth  
EXTERNAL _GetFocusedControl  
EXTERNAL _GetFontBold  
EXTERNAL _GetFontColor  
EXTERNAL _GetFontItalic  
EXTERNAL _GetFontName  
EXTERNAL _GetFontSize  
EXTERNAL _GetFontStrikeOut  
EXTERNAL _GetFontUnderline  
EXTERNAL _GetGetBoxValidMessage  
EXTERNAL _GetGridCellData  
EXTERNAL _GetGridCellValue  
EXTERNAL _GetHotKey  
EXTERNAL _GetHotKeyName  
EXTERNAL _GetHotKeyValue  
EXTERNAL _GetId  
EXTERNAL _GetImageCount  
EXTERNAL _GetIni  
EXTERNAL _GetItem  
EXTERNAL _GetItemCount  
EXTERNAL _GetMenuItemCaption  
EXTERNAL _GetMultiCaption  
EXTERNAL _GetMultiImage  
EXTERNAL _GetParent  
EXTERNAL _GetPicture  
EXTERNAL _GetPictureData  
EXTERNAL _GetPlayerLength  
EXTERNAL _GetPlayerPosition  
EXTERNAL _GetRadioGroupReadOnly  
EXTERNAL _GetRangeMax  
EXTERNAL _GetRangeMin  
EXTERNAL _GetSection  
EXTERNAL _GetSectionNames  
EXTERNAL _GetShortPathName  
EXTERNAL _GetStatusItemWidth  
EXTERNAL _GetToolTip  
EXTERNAL _GetValue  
EXTERNAL _GetWindowProperty  
EXTERNAL _GraphPrint  
EXTERNAL _GridEnd  
EXTERNAL _GridHome  
EXTERNAL _GridInplaceEdit  
EXTERNAL _GridInplaceEditOK  
EXTERNAL _GridInplaceKbdEdit  
EXTERNAL _GridNext  
EXTERNAL _GridPgDn  
EXTERNAL _GridPgUp  
EXTERNAL _GridPrior  
EXTERNAL _GridScrollToPos  
EXTERNAL _HideControl  
EXTERNAL _HideWindow  
EXTERNAL _ImageListSetBkColor  
EXTERNAL _InputWindowCancel  
EXTERNAL _InputWindowOk  
EXTERNAL _IsChild  
EXTERNAL _IsChildOfActiveWindow  
EXTERNAL _IsComboExtend  
EXTERNAL _IsControlDefined  
EXTERNAL _IsControlEnabled  
EXTERNAL _IsControlSplitBoxed  
EXTERNAL _IsControlVisible  
EXTERNAL _IsControlVisibleFromHandle  
EXTERNAL _IsMenuItemChecked  
EXTERNAL _IsMenuItemEnabled  
EXTERNAL _IsWindowActive  
EXTERNAL _IsWindowDefined  
EXTERNAL _lSetToolTip  
EXTERNAL _lShowDetailError  
EXTERNAL _lValidScrSaver  
EXTERNAL _MdiChildClose  
EXTERNAL _MdiChildCloseAll  
EXTERNAL _MdiChildRestoreAll  
EXTERNAL _MdiWindowsActivate  
EXTERNAL _MdiWindowsCascade  
EXTERNAL _MdiWindowsIcons  
EXTERNAL _MdiWindowsRestore  
EXTERNAL _MdiWindowsTile  
EXTERNAL _MoveImage  
EXTERNAL _OnGetMinMaxInfo  
EXTERNAL _OpenAnimateBox  
EXTERNAL _OpenPlayer  
EXTERNAL _OpenPlayerDialog  
EXTERNAL _ParseGridControls  
EXTERNAL _PausePlayer  
EXTERNAL _PiePrint  
EXTERNAL _PlayAnimateBox  
EXTERNAL _PlayPlayer  
EXTERNAL _PlayPlayerReverse  
EXTERNAL _PopEventInfo  
EXTERNAL _ProcessInitProcedure  
EXTERNAL _PushEventInfo  
EXTERNAL _PushKey  
EXTERNAL _RangeCheck  
EXTERNAL _Refresh  
EXTERNAL _RefreshDataControls  
EXTERNAL _ReleaseControl  
EXTERNAL _ReleaseDialog  
EXTERNAL _ReleaseFont  
EXTERNAL _ReleaseHotKey  
EXTERNAL _ReleaseScrSaver  
EXTERNAL _ReleaseWindow  
EXTERNAL _RemoveImageFromImageList  
EXTERNAL _RemoveProperty  
EXTERNAL _ResumePlayer  
EXTERNAL _SaveData  
EXTERNAL _SeekAnimateBox  
EXTERNAL _SetActivationFlag  
EXTERNAL _SetActivationFocus  
EXTERNAL _SetAddress  
EXTERNAL _SetAddressControlProcedure
EXTERNAL _SetBackColor  
EXTERNAL _SetBrowseAllowAppend  
EXTERNAL _SetBrowseAllowDelete  
EXTERNAL _SetBrowseAllowEdit  
EXTERNAL _SetBtnPictureMask  
EXTERNAL _SetCaretPos  
EXTERNAL _SetColumnsWidthAuto  
EXTERNAL _SetColumnsWidthAutoH  
EXTERNAL _SetColumnWidth  
EXTERNAL _SetColumnWidthAuto  
EXTERNAL _SetColumnWidthAutoH  
EXTERNAL _SetControlAction  
EXTERNAL _SetControlCaption  
EXTERNAL _SetControlCol  
EXTERNAL _SetControlHeight  
EXTERNAL _SetControlRow  
EXTERNAL _SetControlSizePos  
EXTERNAL _SetControlWidth  
EXTERNAL _SetDatePickerDateFormat  
EXTERNAL _SetDropDownWidth  
EXTERNAL _SetErrorLogFile  
EXTERNAL _SetFocus  
EXTERNAL _SetFocusedSplitChild  
EXTERNAL _SetFontBold  
EXTERNAL _SetFontColor  
EXTERNAL _SetFontItalic  
EXTERNAL _SetFontName  
EXTERNAL _SetFontSize  
EXTERNAL _SetFontStrikeOut  
EXTERNAL _SetFontUnderline  
EXTERNAL _SetGetAutoFont  
EXTERNAL _SetGetBoxValidMessage  
EXTERNAL _SetGetBoxValue  
EXTERNAL _SetGetRichValue  
EXTERNAL _SetGridCellValue  
EXTERNAL _SetIni  
EXTERNAL _SetItem  
EXTERNAL _SetMenuItemBitmap  
EXTERNAL _SetMenuItemCaption  
EXTERNAL _SetMenuItemFont  
EXTERNAL _SetMultiCaption  
EXTERNAL _SetMultiImage  
EXTERNAL _SetNextFocus  
EXTERNAL _SetNotifyIconName  
EXTERNAL _SetNotifyIconTooltip  
EXTERNAL _SetPicture  
EXTERNAL _SetPlayerPositionEnd  
EXTERNAL _SetPlayerPositionHome  
EXTERNAL _SetPlayerRepeatOff  
EXTERNAL _SetPlayerRepeatOn  
EXTERNAL _SetPlayerSpeed  
EXTERNAL _SetPlayerVolume  
EXTERNAL _SetPlayerZoom  
EXTERNAL _SetPolyWindowRgn  
EXTERNAL _SetRadioGroupReadOnly  
EXTERNAL _SetRangeMax  
EXTERNAL _SetRangeMin  
EXTERNAL _SetStatusBarKbd  
EXTERNAL _SetStatusClock  
EXTERNAL _SetStatusIcon  
EXTERNAL _SetStatusItemAction  
EXTERNAL _SetStatusItemWidth  
EXTERNAL _SetStatusKeybrd  
EXTERNAL _SetStatusWidth  
EXTERNAL _SetTextEditReadOnly  
EXTERNAL _SetToolTip  
EXTERNAL _SetToolTipBalloon  
EXTERNAL _SetValue  
EXTERNAL _SetWindowBackColor  
EXTERNAL _SetWindowProperty  
EXTERNAL _SetWindowRgn  
EXTERNAL _SetWindowSizePos  
EXTERNAL _ShowControl  
EXTERNAL _ShowControlContextMenu  
EXTERNAL _ShowWindow  
EXTERNAL _StopAnimateBox  
EXTERNAL _StopPlayer  
EXTERNAL _UncheckMenuItem  
EXTERNAL _UpdateGridColors  
EXTERNAL ABM  
EXTERNAL ABM2  
EXTERNAL ABMListado  
EXTERNAL ABMListadoEvento  
EXTERNAL ABMListadoImprimir  
EXTERNAL ActivateMdiChildWindow  
EXTERNAL AMPM  
EXTERNAL AToC  
EXTERNAL BmpSize  
EXTERNAL BrowseForFolder  
EXTERNAL cFileNoExt  
EXTERNAL cFileNoPath  
EXTERNAL cFilePath  
EXTERNAL CharMaskTekstOK  
EXTERNAL CreateRegistryKey  
EXTERNAL CToA  
EXTERNAL Darker  
EXTERNAL DB_CODE  
EXTERNAL DB_ENCRYPT  
EXTERNAL DB_UNENCRYPT  
EXTERNAL DeleteRegistryKey  
EXTERNAL DeleteRegistryVar  
EXTERNAL DestroyActiveMdi  
EXTERNAL DialogProc  
EXTERNAL DisableDialogItem  
EXTERNAL DisplayHelpTopic  
EXTERNAL DoMethod  
EXTERNAL drawarc  
EXTERNAL drawellipse  
EXTERNAL DrawGradient  
EXTERNAL drawline  
EXTERNAL drawpie  
EXTERNAL drawpiegraph  
EXTERNAL drawpolybezier  
EXTERNAL drawpolygon  
EXTERNAL drawrect  
EXTERNAL drawroundrect  
EXTERNAL drawtextout  
EXTERNAL DrawWindowBoxIn  
EXTERNAL DrawWindowBoxRaised  
EXTERNAL easyreport  
EXTERNAL EnableDialogItem  
EXTERNAL EraseDialog  
EXTERNAL EraseWindow  
EXTERNAL Events  
EXTERNAL ExitGradientFunc  
EXTERNAL extreport  
EXTERNAL FI_CODE  
EXTERNAL FI_DECODE  
EXTERNAL GetActiveMdiHandle  
EXTERNAL GetApplicationDataFolder  
EXTERNAL GetColor  
EXTERNAL GetControlContainerHandle  
EXTERNAL GetControlHandle  
EXTERNAL GetControlId  
EXTERNAL GetControlIndex  
EXTERNAL GetControlName  
EXTERNAL GetControlPageMap  
EXTERNAL GetControlParentHandle  
EXTERNAL GetControlTabPage  
EXTERNAL GetControlType  
EXTERNAL GetControlValue  
EXTERNAL GetData  
EXTERNAL GetDesktopFolder  
EXTERNAL GetFile  
EXTERNAL GetFolder  
EXTERNAL GetFont  
EXTERNAL GetFontHandle  
EXTERNAL GetFontParam  
EXTERNAL GetFormHandle  
EXTERNAL GetFormIndex  
EXTERNAL GetFormName  
EXTERNAL GetFormToolTipHandle  
EXTERNAL GetMyDocumentsFolder  
EXTERNAL GetNumFromCellText  
EXTERNAL GETNumFromCellTextSP  
EXTERNAL GetNumFromText  
EXTERNAL GETNumFromTextSP  
EXTERNAL GetNumMask  
EXTERNAL GetObjectByClientMDI  
EXTERNAL GetObjectByHandle  
EXTERNAL GetProgramFilesFolder  
EXTERNAL GetProperty  
EXTERNAL GetRegistryValue  
EXTERNAL GetSpecialFolder  
EXTERNAL GetSystemFolder  
EXTERNAL GetTempFolder  
EXTERNAL GetWindowsFolder  
EXTERNAL GetWindowType  
EXTERNAL GraphShow  
EXTERNAL HTML_END  
EXTERNAL HTML_ERRORLOG  
EXTERNAL HTML_INI  
EXTERNAL HTML_LINE  
EXTERNAL HTML_LINETEXT  
EXTERNAL httpconnect  
EXTERNAL Init  
EXTERNAL InitDialogAnimateBox  
EXTERNAL InitDialogBrowse  
EXTERNAL InitDialogBtnTextBox  
EXTERNAL InitDialogButtonImage  
EXTERNAL InitDialogCheckButton  
EXTERNAL InitDialogComboBox  
EXTERNAL InitDialogDatePicker  
EXTERNAL InitDialogEdit  
EXTERNAL InitDialogGrid  
EXTERNAL InitDialogImage  
EXTERNAL InitDialogLabel  
EXTERNAL InitDialogListBox  
EXTERNAL InitDialogMaskedTextBox  
EXTERNAL InitDialogMonthCalendar  
EXTERNAL InitDialogProgressBar  
EXTERNAL InitDialogRadioGroup  
EXTERNAL InitDialogSlider  
EXTERNAL InitDialogTab  
EXTERNAL InitDialogTextBox  
EXTERNAL InitDialogTree  
EXTERNAL InitMessages  
EXTERNAL InputBox
EXTERNAL InputWindow
EXTERNAL InstallEventHandler
EXTERNAL InstallMethodHandler
EXTERNAL InstallPropertyHandler
EXTERNAL IsAppXPThemed  
EXTERNAL IsRegistryKey  
EXTERNAL IsThemed  
EXTERNAL IsXPThemeActive  
EXTERNAL Lighter  
EXTERNAL MdiEvents  
EXTERNAL MiniGuiVersion  
EXTERNAL ModalDialogProc  
EXTERNAL MsgBox  
EXTERNAL MsgExclamation  
EXTERNAL MsgInfo  
EXTERNAL MsgMiniGuiError  
EXTERNAL MsgOkCancel  
EXTERNAL MsgRetryCancel  
EXTERNAL MsgStop  
EXTERNAL MsgYesNo  
EXTERNAL MsgYesNoCancel  
EXTERNAL NoArray  
EXTERNAL OBTNEVENTS  
EXTERNAL OEDITEVENTS  
EXTERNAL OGETEVENTS  
EXTERNAL OSPINEVENTS  
EXTERNAL OwnButtonPaint  
EXTERNAL PlayWave  
EXTERNAL PlayWaveFromResource  
EXTERNAL ProcessCharMask  
EXTERNAL ProcessInPlaceKbdEdit  
EXTERNAL ProcessMessages  
EXTERNAL ProcessNumText  
EXTERNAL Putfile  
EXTERNAL Random  
EXTERNAL RC_CURSOR  
EXTERNAL ReleaseAllWindows  
EXTERNAL SendData  
EXTERNAL SetHelpFile  
EXTERNAL SetProperty  
EXTERNAL SetRegistryValue  
EXTERNAL SetWndBrush  
EXTERNAL ShowError  
EXTERNAL ToUnicode  
EXTERNAL TreeView_GetBkColor  
EXTERNAL TreeView_GetIndent  
EXTERNAL TreeView_GetItemHeight  
EXTERNAL TreeView_GetLineColor  
EXTERNAL TreeView_GetTextColor  
EXTERNAL TreeView_SetBkColor  
EXTERNAL TreeView_SetIndent  
EXTERNAL TreeView_SetItemHeight  
EXTERNAL TreeView_SetLineColor  
EXTERNAL TreeView_SetTextColor  
EXTERNAL UpdateTab  
EXTERNAL VirtualChildControlFocusProcess  
EXTERNAL WindowsVersion  
EXTERNAL xChar  
EXTERNAL xValue  

/* C-functions */

EXTERNAL _DOMDIMESSAGELOOP  
EXTERNAL _DOMESSAGELOOP  
EXTERNAL _EXITGRADIENTFUNC  
EXTERNAL _GETBTNPICTUREHANDLE  
EXTERNAL _GETPRIVATEPROFILESECTION  
EXTERNAL _GETPRIVATEPROFILESECTIONNAMES  
EXTERNAL _HMG_SETHSCROLLVALUE  
EXTERNAL _HMG_SETVSCROLLVALUE  
EXTERNAL _INITGRADIENTFUNC  
EXTERNAL _NEWMENUSTYLE  
EXTERNAL _ONDESTROYMENU  
EXTERNAL _ONDRAWMENUITEM  
EXTERNAL _ONMEASUREMENUITEM  
EXTERNAL _PROCESSMESS  
EXTERNAL _SETBTNICON  
EXTERNAL _SETBTNPICTURE  
EXTERNAL _SETFONT  
EXTERNAL _SETFONTHANDLE  
EXTERNAL ADDDIALOGPAGES  
EXTERNAL ADDLISTVIEWBITMAP  
EXTERNAL ADDLISTVIEWITEMS  
EXTERNAL ADDSPLITBOXITEM  
EXTERNAL ADDTABBITMAP  
EXTERNAL ADDTREEITEM  
EXTERNAL ADDTREEVIEWBITMAP  
EXTERNAL ADJUSTFLOATTOOLBAR  
EXTERNAL ALPHABLEND  
EXTERNAL AND  
EXTERNAL APPENDMENUPOPUP  
EXTERNAL APPENDMENUSEPARATOR  
EXTERNAL APPENDMENUSTRING  
EXTERNAL ARCDRAW  
EXTERNAL ARRANGEICONICWINDOWS  
EXTERNAL BITMAPSIZE  
EXTERNAL BRINGWINDOWTOTOP  
EXTERNAL C_BROWSEFORFOLDER  
EXTERNAL C_CENTER  
EXTERNAL C_GETDLLSPECIALFOLDER  
EXTERNAL C_GETFILE  
EXTERNAL C_GETHOTKEY  
EXTERNAL C_GETHOTKEYNAME  
EXTERNAL C_GETHOTKEYVALUE  
EXTERNAL C_GETSPECIALFOLDER  
EXTERNAL C_MSGBOX  
EXTERNAL C_MSGEXCLAMATION  
EXTERNAL C_MSGINFO  
EXTERNAL C_MSGOKCANCEL  
EXTERNAL C_MSGRETRYCANCEL  
EXTERNAL C_MSGSTOP  
EXTERNAL C_MSGYESNO  
EXTERNAL C_MSGYESNO_ID  
EXTERNAL C_MSGYESNOCANCEL  
EXTERNAL C_PLAYWAVE  
EXTERNAL C_PUTFILE  
EXTERNAL C_SETPICTURE  
EXTERNAL C_SETPOLYWINDOWRGN  
EXTERNAL C_SETWINDOWRGN  
EXTERNAL CDISABLETOOLBARBUTTON  
EXTERNAL CENABLETOOLBARBUTTON  
EXTERNAL CHANGENOTIFYICON  
EXTERNAL CHANGEPASSWORD  
EXTERNAL CHANGESTYLE  
EXTERNAL CHARXOR  
EXTERNAL CHECKBIT  
EXTERNAL CHECKBUTTONBAR  
EXTERNAL CHECKDLGBUTTON  
EXTERNAL CHECKDLGBUTTON  
EXTERNAL CHECKRADIOBUTTON  
EXTERNAL CHOOSECOLOR  
EXTERNAL CHOOSEFONT  
EXTERNAL CLEANPROGRAMMEMORY  
EXTERNAL CLEARIPADDRESS  
EXTERNAL CLOSEANIMATE  
EXTERNAL CLOSETHEMEDATA  
EXTERNAL COMBOADDDATASTRINGEX  
EXTERNAL COMBOADDSTRING  
EXTERNAL COMBOADDSTRING  
EXTERNAL COMBOADDSTRINGEX  
EXTERNAL COMBOBOXDELETEITEMEX  
EXTERNAL COMBOBOXDELETESTRING  
EXTERNAL COMBOBOXGETITEMCOUNT  
EXTERNAL COMBOBOXRESET  
EXTERNAL COMBOGETCURSEL  
EXTERNAL COMBOGETSTRING  
EXTERNAL COMBOINSERTSTRING  
EXTERNAL COMBOINSERTSTRINGEX  
EXTERNAL COMBOSETCURSEL  
EXTERNAL COMBOSETSTRING  
EXTERNAL COPYRTFTOCLIPBOARD  
EXTERNAL COPYTOCLIPBOARD  
EXTERNAL CREATECARET  
EXTERNAL CREATEDLGTEMPLATE  
EXTERNAL CREATEFOLDER  
EXTERNAL CREATEGRADIENTBRUSH  
EXTERNAL CREATEHATCHBRUSH  
EXTERNAL CREATEMENU  
EXTERNAL CREATEPATTERNBRUSH  
EXTERNAL CREATEPOPUPCHEVRON  
EXTERNAL CREATEPOPUPMENU  
EXTERNAL CREATESOLIDBRUSH  
EXTERNAL CSHOWCONTROL  
EXTERNAL CURSORAPPSTARTING  
EXTERNAL CURSORARROW  
EXTERNAL CURSORCROSS  
EXTERNAL CURSORHAND  
EXTERNAL CURSORHELP  
EXTERNAL CURSORIBEAM  
EXTERNAL CURSORNO  
EXTERNAL CURSORSIZEALL  
EXTERNAL CURSORSIZENESW  
EXTERNAL CURSORSIZENS  
EXTERNAL CURSORSIZENWSE  
EXTERNAL CURSORSIZEWE  
EXTERNAL CURSORUPARROW  
EXTERNAL CURSORWAIT  
EXTERNAL CUSTOMIZETOOLBAR  
EXTERNAL DEFFRAMEPROC  
EXTERNAL DEFMDICHILDPROC  
EXTERNAL DEFWINDOWPROC  
EXTERNAL DELETEOBJECT  
EXTERNAL DELINIENTRY  
EXTERNAL DELINISECTION  
EXTERNAL DESTROYANIMATE  
EXTERNAL DESTROYCARET  
EXTERNAL DESTROYMENU  
EXTERNAL DESTROYWINDOW  
EXTERNAL DISABLEWINDOW  
EXTERNAL DRAGACCEPTFILES
EXTERNAL DRAGFINISH
EXTERNAL DRAGQUERYFILES
EXTERNAL DRAWBUTTON  
EXTERNAL DRAWFOCUSRECT  
EXTERNAL DRAWGLYPH  
EXTERNAL DRAWGLYPHMASK  
EXTERNAL DRAWTEXT  
EXTERNAL DRAWTHEMEBACKGROUND  
EXTERNAL DRAWTHEMEPARENTBACKGROUND  
EXTERNAL ELLIPSEDRAW  
EXTERNAL ENABLETHEMEDIALOGTEXTURE  
EXTERNAL ENABLEWINDOW  
EXTERNAL ENDDIALOG  
EXTERNAL ENDUXTHEME  
EXTERNAL EXITPROCESS  
EXTERNAL EXTRACTICON  
EXTERNAL FILECURSOR  
EXTERNAL FILLGRADIENT  
EXTERNAL FILLRECT  
EXTERNAL FINDCOMBOINEXACT  
EXTERNAL FINDRESOURCE  
EXTERNAL FINDWINDOWEX  
EXTERNAL GET3DEDGEHEIGHT  
EXTERNAL GET3DEDGEWIDTH  
EXTERNAL GETACTIVEWINDOW  
EXTERNAL GETALTSTATE  
EXTERNAL GETAUTOFONTRTF  
EXTERNAL GETBANDCOUNT  
EXTERNAL GETBITMAPSIZE  
EXTERNAL GETBLUE  
EXTERNAL GETBORDERHEIGHT  
EXTERNAL GETBORDERWIDTH  
EXTERNAL GETBUTTONBAR  
EXTERNAL GETBUTTONBARCOUNT  
EXTERNAL GETBUTTONBARRECT  
EXTERNAL GETBUTTONPOS  
EXTERNAL GETCLIENTRECT  
EXTERNAL GETCLIPBOARDDATA  
EXTERNAL GETCOMPACTPATH  
EXTERNAL GETCOMPUTERNAME  
EXTERNAL GETCURRENTFOLDER  
EXTERNAL GETCURSORCOL  
EXTERNAL GETCURSORPOS  
EXTERNAL GETCURSORROW  
EXTERNAL GETDATEPICKDAY  
EXTERNAL GETDATEPICKHOUR  
EXTERNAL GETDATEPICKMINUTE  
EXTERNAL GETDATEPICKMONTH  
EXTERNAL GETDATEPICKSECOND  
EXTERNAL GETDATEPICKYEAR  
EXTERNAL GETDC  
EXTERNAL GETDESKTOPHEIGHT  
EXTERNAL GETDESKTOPWIDTH  
EXTERNAL GETDIALOGITEMHANDLE  
EXTERNAL GETDLGCTRLID  
EXTERNAL GETDLGITEMTEXT  
EXTERNAL GETDLGITEMTEXT  
EXTERNAL GETDLLVERSION  
EXTERNAL GETDRAWITEMHANDLE  
EXTERNAL GETDROPDOWNWIDTH  
EXTERNAL GETDS  
EXTERNAL GETEDITTEXT  
EXTERNAL GETESCAPESTATE  
EXTERNAL GETEXEFILENAME  
EXTERNAL GETFOCUS  
EXTERNAL GETFONTRTF  
EXTERNAL GETFOREGROUNDWINDOW  
EXTERNAL GETGREEN  
EXTERNAL GETGRIDCOLUMN  
EXTERNAL GETGRIDDISPINFOINDEX  
EXTERNAL GETGRIDNEWSTATE  
EXTERNAL GETGRIDOLDSTATE  
EXTERNAL GETGRIDVKEY  
EXTERNAL GETHELPDATA  
EXTERNAL GETHSCROLLBARHEIGHT  
EXTERNAL GETHWNDFROM  
EXTERNAL GETICONSIZE  
EXTERNAL GETIMAGELIST  
EXTERNAL GETIMAGELISTVIEWITEMS  
EXTERNAL GETINSTANCE  
EXTERNAL GETIPADDRESS  
EXTERNAL GETITEMBAR  
EXTERNAL GETITEMPOS  
EXTERNAL GETKEYSTATE  
EXTERNAL GETMENU  
EXTERNAL GETMENUBARHEIGHT  
EXTERNAL GETMENUBITMAPHEIGHT  
EXTERNAL GETMENUCOLORS  
EXTERNAL GETMENUITEMCOUNT  
EXTERNAL GETMONTHCALDAY  
EXTERNAL GETMONTHCALFIRSTDAYOFWEEK  
EXTERNAL GETMONTHCALMONTH  
EXTERNAL GETMONTHCALYEAR  
EXTERNAL GETMSKTEXTLPARAM  
EXTERNAL GETMSKTEXTMESSAGE  
EXTERNAL GETMSKTEXTWPARAM  
EXTERNAL GETNEXTDLGTABITEM  
EXTERNAL GETNEXTWINDOW  
EXTERNAL GETNOTIFYCODE  
EXTERNAL GETNOTIFYID  
EXTERNAL GETOBJECTTYPE  
EXTERNAL GETOWNBTNCTLTYPE  
EXTERNAL GETOWNBTNDC  
EXTERNAL GETOWNBTNHANDLE  
EXTERNAL GETOWNBTNITEMACTION  
EXTERNAL GETOWNBTNRECT  
EXTERNAL GETOWNBTNSTATE  
EXTERNAL GETPREVWINDOW  
EXTERNAL GETPRIVATEPROFILESTRING  
EXTERNAL GETPROP  
EXTERNAL GETRC  
EXTERNAL GETRED  
EXTERNAL GETSCROLLPOS  
EXTERNAL GETSCROLLRANGEMAX  
EXTERNAL GETSHORTPATHNAME  
EXTERNAL GETSIZETOOLBAR  
EXTERNAL GETSPINNERVALUE  
EXTERNAL GETSTOCKOBJECT  
EXTERNAL GETSYSCOLOR  
EXTERNAL GETSYSTEMDIR  
EXTERNAL GETTABBEDCONTROLBRUSH  
EXTERNAL GETTABBRUSH  
EXTERNAL GETTEMPDIR  
EXTERNAL GETTEXTHEIGHT  
EXTERNAL GETTEXTMETRIC  
EXTERNAL GETTEXTWIDTH  
EXTERNAL GETTITLEHEIGHT  
EXTERNAL GETUSERNAME  
EXTERNAL GETVSCROLLBARWIDTH  
EXTERNAL GETWINDOW  
EXTERNAL GETWINDOWBRUSH  
EXTERNAL GETWINDOWCOL  
EXTERNAL GETWINDOWFROMDC  
EXTERNAL GETWINDOWHEIGHT  
EXTERNAL GETWINDOWLONG  
EXTERNAL GETWINDOWRECT  
EXTERNAL GETWINDOWROW  
EXTERNAL GETWINDOWSDIR  
EXTERNAL GETWINDOWSTATE  
EXTERNAL GETWINDOWTEXT  
EXTERNAL GETWINDOWWIDTH  
EXTERNAL HIDECARET  
EXTERNAL HIDEWINDOW  
EXTERNAL HIWORD  
EXTERNAL IL_ADD  
EXTERNAL IL_ADDINDIRECT  
EXTERNAL IL_ADDMASKED  
EXTERNAL IL_ADDMASKEDINDIRECT  
EXTERNAL IL_BEGINDRAG  
EXTERNAL IL_DESTROY  
EXTERNAL IL_DRAGENTER  
EXTERNAL IL_DRAGMOVE  
EXTERNAL IL_DRAW  
EXTERNAL IL_ENDDRAG  
EXTERNAL IL_ERASEIMAGE  
EXTERNAL IL_GETIMAGECOUNT  
EXTERNAL IL_REMOVE  
EXTERNAL IL_SETBKCOLOR  
EXTERNAL IMAGELIST_DESTROY  
EXTERNAL INITANIMATE  
EXTERNAL INITBROWSE  
EXTERNAL INITBTNTEXTBOX  
EXTERNAL INITBUTTON  
EXTERNAL INITCHARMASKTEXTBOX  
EXTERNAL INITCHECKBOX  
EXTERNAL INITCHECKBUTTON  
EXTERNAL INITCOMBOBOX  
EXTERNAL INITCOMBOBOXEX  
EXTERNAL INITDATEPICK  
EXTERNAL INITDIALOG  
EXTERNAL INITDUMMY  
EXTERNAL INITEDITBOX  
EXTERNAL INITEXCOMMONCONTROLS  
EXTERNAL INITFONT  
EXTERNAL INITFRAME  
EXTERNAL INITGETBOX  
EXTERNAL INITHOTKEY  
EXTERNAL INITHOTKEYBOX  
EXTERNAL INITHYPERLINK  
EXTERNAL INITIMAGE  
EXTERNAL INITIMAGEBUTTON  
EXTERNAL INITIMAGECHECKBUTTON  
EXTERNAL INITIMAGELIST  
EXTERNAL INITIPADDRESS  
EXTERNAL INITITEMBAR  
EXTERNAL INITLABEL  
EXTERNAL INITLISTBOX  
EXTERNAL INITLISTVIEW  
EXTERNAL INITLISTVIEWCOLUMNS  
EXTERNAL INITMASKEDTEXTBOX  
EXTERNAL INITMDICHILDWINDOW  
EXTERNAL INITMDICLIENTWINDOW  
EXTERNAL INITMDIWINDOW  
EXTERNAL INITMESSAGEBAR  
EXTERNAL INITMINMAXINFO  
EXTERNAL INITMODALDIALOG  
EXTERNAL INITMODALWINDOW  
EXTERNAL INITMONTHCAL  
EXTERNAL INITMULTILISTBOX  
EXTERNAL INITOWNERBUTTON  
EXTERNAL INITPLAYER  
EXTERNAL INITPROGRESSBAR  
EXTERNAL INITRADIOBUTTON  
EXTERNAL INITRADIOGROUP  
EXTERNAL INITRICHEDITBOX  
EXTERNAL INITSLIDER  
EXTERNAL INITSPINNER  
EXTERNAL INITSPLITBOX  
EXTERNAL INITSPLITCHILDWINDOW  
EXTERNAL INITTABCONTROL  
EXTERNAL INITTEXTBOX  
EXTERNAL INITTIMEPICK  
EXTERNAL INITTIMER  
EXTERNAL INITTOOLBAR  
EXTERNAL INITTOOLBAREX  
EXTERNAL INITTOOLBUTTON  
EXTERNAL INITTOOLBUTTONEX  
EXTERNAL INITTOOLTIP  
EXTERNAL INITTREE  
EXTERNAL INITTREEVIEWBITMAP  
EXTERNAL INITUXTHEME  
EXTERNAL INITVSCROLLBAR  
EXTERNAL INITVSCROLLBARBUTTON  
EXTERNAL INITWINDOW  
EXTERNAL INSERTBACKSPACE  
EXTERNAL INSERTDOWN  
EXTERNAL INSERTNEXT  
EXTERNAL INSERTPOINT  
EXTERNAL INSERTPRIOR  
EXTERNAL INSERTRETURN  
EXTERNAL INSERTSHIFTTAB  
EXTERNAL INSERTTAB  
EXTERNAL INSERTUP  
EXTERNAL INVALIDATERECT  
EXTERNAL ISAPPTHEMED  
EXTERNAL ISBUTTONBARCHECKED  
EXTERNAL ISBUTTONENABLED  
EXTERNAL ISCAPSLOCKACTIVE  
EXTERNAL ISDLGBUTTONCHECKED  
EXTERNAL ISDLGBUTTONCHECKED  
EXTERNAL ISENABLEDGRADIENT  
EXTERNAL ISEXERUNNING  
EXTERNAL ISINSERTACTIVE  
EXTERNAL ISMENU  
EXTERNAL ISNUMLOCKACTIVE  
EXTERNAL ISOEMTEXT  
EXTERNAL ISSCROLLLOCKACTIVE  
EXTERNAL ISTABSTOP  
EXTERNAL ISTHEMEACTIVE  
EXTERNAL ISWINDOWENABLED  
EXTERNAL ISWINDOWHANDLER  
EXTERNAL ISWINDOWSIZED  
EXTERNAL ISWINDOWSTYLE  
EXTERNAL ISWINDOWVISIBLE  
EXTERNAL KEYBD_EVENT  
EXTERNAL KEYTOGGLE  
EXTERNAL KEYTOGGLENT  
EXTERNAL KILLTIMER  
EXTERNAL LINEDRAW  
EXTERNAL LISTBOXADDSTRING  
EXTERNAL LISTBOXDELETESTRING  
EXTERNAL LISTBOXGETCURSEL  
EXTERNAL LISTBOXGETITEMCOUNT  
EXTERNAL LISTBOXGETMULTISEL  
EXTERNAL LISTBOXGETSTRING  
EXTERNAL LISTBOXINSERTSTRING  
EXTERNAL LISTBOXRESET  
EXTERNAL LISTBOXSETCURSEL  
EXTERNAL LISTBOXSETMULTISEL  
EXTERNAL LISTVIEW_ADDCOLUMN  
EXTERNAL LISTVIEW_DELETECOLUMN  
EXTERNAL LISTVIEW_ENSUREVISIBLE  
EXTERNAL LISTVIEW_GETBKCOLOR  
EXTERNAL LISTVIEW_GETCOLUMNWIDTH  
EXTERNAL LISTVIEW_GETFIRSTITEM  
EXTERNAL LISTVIEW_GETITEMRECT  
EXTERNAL LISTVIEW_GETSUBITEMRECT  
EXTERNAL LISTVIEW_GETTEXTCOLOR  
EXTERNAL LISTVIEW_GETTOPINDEX  
EXTERNAL LISTVIEW_HITTEST  
EXTERNAL LISTVIEW_REDRAWITEMS  
EXTERNAL LISTVIEW_SCROLL  
EXTERNAL LISTVIEW_SETBKCOLOR  
EXTERNAL LISTVIEW_SETCOLUMNWIDTH  
EXTERNAL LISTVIEW_SETCOLUMNWIDTHAUTO  
EXTERNAL LISTVIEW_SETCOLUMNWIDTHAUTOH  
EXTERNAL LISTVIEW_SETCURSEL  
EXTERNAL LISTVIEW_SETITEMCOUNT  
EXTERNAL LISTVIEW_SETTEXTBKCOLOR  
EXTERNAL LISTVIEW_SETTEXTCOLOR  
EXTERNAL LISTVIEW_UPDATE  
EXTERNAL LISTVIEWDELETESTRING  
EXTERNAL LISTVIEWGETCOUNTPERPAGE  
EXTERNAL LISTVIEWGETITEM  
EXTERNAL LISTVIEWGETITEMCOUNT  
EXTERNAL LISTVIEWGETITEMROW  
EXTERNAL LISTVIEWGETMULTISEL  
EXTERNAL LISTVIEWRESET  
EXTERNAL LISTVIEWSETITEM  
EXTERNAL LISTVIEWSETMULTISEL  
EXTERNAL LOADBITMAP  
EXTERNAL LOADCURSOR  
EXTERNAL LOADCURSORFROMFILE  
EXTERNAL LOADICON  
EXTERNAL LOADRESOURCE  
EXTERNAL LOADTRAYICON  
EXTERNAL LOWORD  
EXTERNAL MAXIMIZE  
EXTERNAL MAXTEXTBTNTOOLBAR  
EXTERNAL MCIFUNC  
EXTERNAL MEMORYSTATUS  
EXTERNAL MENUITEM_SETBITMAPS  
EXTERNAL MENUITEM_SETCHECKMARKS  
EXTERNAL MENUITEM_SETFONT  
EXTERNAL MESSAGEBOXINDIRECT  
EXTERNAL MINIMIZE  
EXTERNAL MOVEWINDOW  
EXTERNAL OPENANIMATE  
EXTERNAL OPENTHEMEDATA  
EXTERNAL PAINTBKGND  
EXTERNAL PIEDRAW  
EXTERNAL PLAYANIMATE  
EXTERNAL PLAYASTERISK  
EXTERNAL PLAYBEEP  
EXTERNAL PLAYEXCLAMATION  
EXTERNAL PLAYHAND  
EXTERNAL PLAYOK  
EXTERNAL PLAYQUESTION  
EXTERNAL POLYBEZIERDRAW  
EXTERNAL POLYGONDRAW  
EXTERNAL POSTMESSAGE  
EXTERNAL POSTQUITMESSAGE  
EXTERNAL PTINRECT  
EXTERNAL REBARHEIGHT  
EXTERNAL RECTDRAW  
EXTERNAL REDEFBTNTEXTBOX  
EXTERNAL REDRAWWINDOW  
EXTERNAL REDRAWWINDOWCONTROLRECT  
EXTERNAL REFRESHITEMBAR  
EXTERNAL REGCLOSEKEY  
EXTERNAL REGCONNECTREGISTRY  
EXTERNAL REGCREATEKEY  
EXTERNAL REGDELETEKEY  
EXTERNAL REGDELETEVALUEA  
EXTERNAL REGENUMKEYEXA  
EXTERNAL REGENUMVALUEA  
EXTERNAL REGISTERMDIWINDOW  
EXTERNAL REGISTERSPLITCHILDWINDOW  
EXTERNAL REGISTERWINDOW  
EXTERNAL REGOPENKEYEXA  
EXTERNAL REGQUERYVALUEEXA  
EXTERNAL REGSETVALUEEXA  
EXTERNAL RELEASECONTROL  
EXTERNAL RELEASEDC  
EXTERNAL RELEASEHOTKEY  
EXTERNAL REMOVEFOLDER  
EXTERNAL REMOVEPROP  
EXTERNAL RESIZEFLOATTOOLBAR  
EXTERNAL RESIZESPLITBOXITEM  
EXTERNAL RESOURCEFREE  
EXTERNAL RESTORE  
EXTERNAL RETRIVETEXTFROMCLIPBOARD  
EXTERNAL ROUNDRECTDRAW  
EXTERNAL SEEKANIMATE  
EXTERNAL SELECTOBJECT  
EXTERNAL SENDMESSAGE  
EXTERNAL SENDMESSAGESTRING  
EXTERNAL SETACTIVEWINDOW  
EXTERNAL SETARROWCURSOR  
EXTERNAL SETAUTOFONTRTF  
EXTERNAL SETBCBC  
EXTERNAL SETBKCOLOR  
EXTERNAL SETBKGNDCOLOR  
EXTERNAL SETBKMODE  
EXTERNAL SETBRCCD  
EXTERNAL SETBUTTONID  
EXTERNAL SETBUTTONTIP  
EXTERNAL SETCHEVRONIMAGE  
EXTERNAL SETCHEVRONSTYLESPLITBOXITEM  
EXTERNAL SETCURRENTFOLDER  
EXTERNAL SETCURSORPOS  
EXTERNAL SETDATEPICK  
EXTERNAL SETDATEPICKBKCOLOR  
EXTERNAL SETDATEPICKERDATEFORMAT  
EXTERNAL SETDATEPICKFONTCOLOR  
EXTERNAL SETDATEPICKNULL  
EXTERNAL SETDATEPICKTITLEBKCOLOR  
EXTERNAL SETDATEPICKTITLEFONTCOLOR  
EXTERNAL SETDATEPICKTRLFONTCOLOR  
EXTERNAL SETDIALOGITEMTEXT  
EXTERNAL SETDLGITEMINT  
EXTERNAL SETDLGITEMTEXT  
EXTERNAL SETDROPDOWNWIDTH  
EXTERNAL SETEVENTSFUNC  
EXTERNAL SETFOCUS  
EXTERNAL SETFONTNAMESIZE  
EXTERNAL SETFONTRTF  
EXTERNAL SETFOREGROUNDWINDOW  
EXTERNAL SETGRIDCOLUMNHEADER  
EXTERNAL SETGRIDCOLUMNHEADERIMAGE
EXTERNAL SETGRIDQUERYDATA  
EXTERNAL SETGRIDQUERYIMAGE  
EXTERNAL SETHANDCURSOR  
EXTERNAL SETHOTKEYVALUE  
EXTERNAL SETIMAGELISTVIEWITEMS  
EXTERNAL SETIPADDRESS  
EXTERNAL SETITEMBAR  
EXTERNAL SETMENU  
EXTERNAL SETMENUBITMAPHEIGHT  
EXTERNAL SETMENUCOLORS  
EXTERNAL SETMENUCURSORTYPE  
EXTERNAL SETMENUSELECTEDITEM3D  
EXTERNAL SETMENUSEPARATORTYPE  
EXTERNAL SETMINMAXINFO  
EXTERNAL SETMONTHCAL  
EXTERNAL SETMONTHCALBKCOLOR  
EXTERNAL SETMONTHCALFIRSTDAYOFWEEK  
EXTERNAL SETMONTHCALFONTCOLOR  
EXTERNAL SETMONTHCALMONTHBKCOLOR  
EXTERNAL SETMONTHCALTITLEBKCOLOR  
EXTERNAL SETMONTHCALTITLEFONTCOLOR  
EXTERNAL SETMONTHCALTRLFONTCOLOR  
EXTERNAL SETPOSMONTHCAL  
EXTERNAL SETPROGRESSBARBARCOLOR  
EXTERNAL SETPROGRESSBARBKCOLOR  
EXTERNAL SETPROGRESSBARRANGE  
EXTERNAL SETPROP  
EXTERNAL SETRADIOSTYLE  
EXTERNAL SETRESCURSOR  
EXTERNAL SETROWSBUTTON  
EXTERNAL SETSCROLLINFO  
EXTERNAL SETSCROLLPOS  
EXTERNAL SETSCROLLRANGE  
EXTERNAL SETSLIDERRANGE  
EXTERNAL SETSPINNERINCREMENT  
EXTERNAL SETSPINNERRANGE  
EXTERNAL SETSPINNERVALUE  
EXTERNAL SETSTATUSBARSIZE  
EXTERNAL SETSTATUSITEMICON  
EXTERNAL SETTABCAPTION  
EXTERNAL SETTABSTOP  
EXTERNAL SETTEXTCOLOR  
EXTERNAL SETTEXTEDITREADONLY  
EXTERNAL SETTIMEPICK 
EXTERNAL SETTOOLBUTTONCAPTION 
EXTERNAL SETTOOLTIP  
EXTERNAL SETWAITCURSOR  
EXTERNAL SETWINDOWBACKGROUND  
EXTERNAL SETWINDOWBRUSH  
EXTERNAL SETWINDOWCURSOR  
EXTERNAL SETWINDOWLONG  
EXTERNAL SETWINDOWPOS  
EXTERNAL SETWINDOWSTYLE  
EXTERNAL SETWINDOWTEXT  
EXTERNAL SETWINDOWTHEME  
EXTERNAL SHELLABOUT  
EXTERNAL SHELLEXECUTE  
EXTERNAL SHOWCARET  
EXTERNAL SHOWCURSOR  
EXTERNAL SHOWNOTIFYICON  
EXTERNAL SHOWWINDOW  
EXTERNAL SIZECLIENTWINDOW  
EXTERNAL SIZEREBAR  
EXTERNAL STOPANIMATE  
EXTERNAL STOPWAVE  
EXTERNAL STREAMIN  
EXTERNAL STREAMOUT  
EXTERNAL SYSTEMPARAMETERSINFO  
EXTERNAL TABCTRL_DELETEITEM  
EXTERNAL TABCTRL_GETCURSEL  
EXTERNAL TABCTRL_INSERTITEM  
EXTERNAL TABCTRL_SETCURSEL  
EXTERNAL TEXTDRAW  
EXTERNAL TRACKPOPUPMENU  
EXTERNAL TRANSLATEMDISYSACCEL  
EXTERNAL TRANSPARENTBLT  
EXTERNAL TREEVIEW_DELETEALLITEMS  
EXTERNAL TREEVIEW_DELETEITEM  
EXTERNAL TREEVIEW_GETCHILD  
EXTERNAL TREEVIEW_GETCOUNT  
EXTERNAL TREEVIEW_GETITEM  
EXTERNAL TREEVIEW_GETNEXTSIBLING  
EXTERNAL TREEVIEW_GETPARENT  
EXTERNAL TREEVIEW_GETPREVSIBLING  
EXTERNAL TREEVIEW_GETSELECTION  
EXTERNAL TREEVIEW_GETSELECTIONID  
EXTERNAL TREEVIEW_SELECTITEM  
EXTERNAL TREEVIEW_SETITEM  
EXTERNAL UNCHECKDLGBUTTON  
EXTERNAL UNREGISTERWINDOW  
EXTERNAL UPDATEWINDOW  
EXTERNAL VERIFYPASSWORD  
EXTERNAL WAITRUN  
EXTERNAL WAITRUNPIPE  
EXTERNAL WAITRUNTERM
EXTERNAL WINHELP  
EXTERNAL WINVERSION  
EXTERNAL WNDBOXIN  
EXTERNAL WNDBOXRAISED  
EXTERNAL WNDCOPY  
EXTERNAL WRITEPRIVATEPROFILESTRING  
EXTERNAL XCHECKMENUITEM  
EXTERNAL XDISABLEMENUITEM  
EXTERNAL XENABLEMENUITEM  
EXTERNAL XGETMENUCAPTION  
EXTERNAL XGETMENUCHECKSTATE  
EXTERNAL XGETMENUENABLEDSTATE  
EXTERNAL XSETMENUCAPTION  
EXTERNAL XUNCHECKMENUITEM  

#endif /* MG_EXTERN_CH_ */
