/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-05 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Copyright 2006 Grigory Filatov <gfilatov@freemail.ru>
*/

#include "minigui.ch"

#command @ <row>,<col> ANIMATERES <name>	;
		[ <dummy1: OF, PARENT> <parent> ] ;
		[ WIDTH <w> ] 			;
		[ HEIGHT <h> ] 			;
		FILE <file>			;
		ID <n>				;
		[ TOOLTIP <tooltip> ] 		;
		[ HELPID <helpid> ] 		;
		[ <invisible : INVISIBLE> ] ;
	=>;
	_DefineAnimateRes ( <"name">, <"parent">, <col>, <row>, <w>, <h>, <file>, <n>, ;
			<tooltip>, <helpid>, <.invisible.> )

Static lBusy := .F.

*-----------------------------------------------------------------------------*
Procedure Main
*-----------------------------------------------------------------------------*

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 309 HEIGHT IF(IsXPThemeActive(), 168, 162) ;
		TITLE 'Copying Files...' ;
		MAIN ;
		NOMINIMIZE NOMAXIMIZE NOSIZE ;
		ON INIT InitResAnim() ;
		FONT 'MS Sans Serif' SIZE 9

		@ 107, 218 BUTTON Btn_Cancel ;
			CAPTION "Cancel" ;
			ACTION Form_1.Release ;
			WIDTH 74 HEIGHT 23 DEFAULT

		@ 73, 8 LABEL Label_1 ;
			VALUE 'ANI.EXE' ;
			AUTOSIZE

		@ 90, 8 PROGRESSBAR Progress_1 RANGE 0, 65535 ;
			WIDTH 284 HEIGHT 12

		@ 115, 28 LABEL Label_2 ;
			VALUE 'E-mail me at:' ;
			AUTOSIZE

		@ 115, 94 HYPERLINK Label_3 ;
			VALUE 'gfilatov@freemail.ru' ;
			ADDRESS "gfilatov@freemail.ru?cc=&bcc=" +	;
				"&subject=AVI%20Animation%20Feedback:"	;
			AUTOSIZE					;
			TRANSPARENT HANDCURSOR

		DEFINE TIMER Timer_1 INTERVAL 2000 ACTION Animate_Progress()

		ON KEY ESCAPE ACTION Form_1.Btn_Cancel.OnClick

	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return

*-----------------------------------------------------------------------------*
Procedure InitResAnim
*-----------------------------------------------------------------------------*

	@ 0,0 ANIMATERES Anim_1 ;
		OF Form_1 ;
		WIDTH 300 HEIGHT 60 ;
		FILE "Shell32.dll" ;
		ID 161

	Form_1.Anim_1.Play

	Animate_Progress()

Return

*-----------------------------------------------------------------------------*
Procedure Animate_Progress
*-----------------------------------------------------------------------------*
Local i

	IF .NOT. lBusy

		lBusy := .T.

		For i = 0 To 65535 Step 5
			Form_1.Progress_1.Value := i
			Do Events
		Next i

		lBusy := .F.

	ENDIF

Return

*-----------------------------------------------------------------------------*
Function _DefineAnimateRes ( ControlName, ParentForm, x, y, w, h, cFile, nRes, ;
                              tooltip, HelpId, invisible )
*-----------------------------------------------------------------------------*
Local i, cParentForm, mVar, ControlHandle

	DEFAULT h         TO 50
	DEFAULT w         TO 200
	DEFAULT invisible TO FALSE

	if _HMG_BeginWindowActive = TRUE
		ParentForm := _HMG_ActiveFormName
	endif

	if _HMG_FrameLevel > 0
		x 	:= x + _HMG_ActiveFrameCol [_HMG_FrameLevel]
		y 	:= y + _HMG_ActiveFrameRow [_HMG_FrameLevel]
		ParentForm := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
	EndIf

	If .Not. _IsWindowDefined (ParentForm)
		MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated")
		Return Nil
	Endif

	If _IsControlDefined (ControlName,ParentForm)
		MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program Terminated")
		Return Nil
	endif

	mVar := '_' + ParentForm + '_' + ControlName
	Public &mVar. := Len(_HMG_aControlNames) + 1

	cParentForm := ParentForm

	ParentForm = GetFormHandle (ParentForm)

	ControlHandle := InitAnimateRes ( ParentForm, 0, x, y, w, h, cFile, nRes, invisible )

	If _HMG_BeginTabActive = TRUE
		aAdd ( _HMG_ActiveTabCurrentPageMap , Controlhandle )
	EndIf

	if valtype(tooltip) != "U"
		SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
	endif

	aAdd ( _HMG_aControlType , "ANIMATE" )
	aAdd ( _HMG_aControlNames , ControlName )
	aAdd ( _HMG_aControlHandles , ControlHandle )
	aAdd ( _HMG_aControlParentHandles , ParentForm )
	aAdd ( _HMG_aControlIds , 0 )
	aAdd ( _HMG_aControlProcedures , "" )
	aAdd ( _HMG_aControlPageMap , {} )
	aAdd ( _HMG_aControlValue , Nil )
	aAdd ( _HMG_aControlInputMask , "" )
	aAdd ( _HMG_aControllostFocusProcedure , "" )
	aAdd ( _HMG_aControlGotFocusProcedure , "" )
	aAdd ( _HMG_aControlChangeProcedure , "" )
	aAdd ( _HMG_aControlDeleted , FALSE )
	aAdd ( _HMG_aControlBkColor , {} )
	aAdd ( _HMG_aControlFontColor , {} )
	aAdd ( _HMG_aControlDblClick , "" )
	aAdd ( _HMG_aControlHeadClick , {} )
	aAdd ( _HMG_aControlRow , y )
	aAdd ( _HMG_aControlCol , x )
	aAdd ( _HMG_aControlWidth , w )
	aAdd ( _HMG_aControlHeight , h )
	aAdd ( _HMG_aControlSpacing , 0 )
	aAdd ( _HMG_aControlContainerRow , iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 ) )
	aAdd ( _HMG_aControlContainerCol , iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 ) )
	aAdd ( _HMG_aControlPicture , "" )
	aAdd ( _HMG_aControlContainerHandle , 0 )
	aAdd ( _HMG_aControlFontName , '' )
	aAdd ( _HMG_aControlFontSize , 0 )
	aAdd ( _HMG_aControlFontAttributes , {FALSE,FALSE,FALSE,FALSE} )
	aAdd ( _HMG_aControlToolTip  , tooltip  )
	aAdd ( _HMG_aControlRangeMin  , 0  )
	aAdd ( _HMG_aControlRangeMax  , 0  )
	aAdd ( _HMG_aControlCaption  , ''  )
	aAdd ( _HMG_aControlVisible  , if(invisible,FALSE,TRUE) )
	aAdd ( _HMG_aControlHelpId  , HelpId )
	aAdd ( _HMG_aControlFontHandle  , 0 )
	aAdd ( _HMG_aControlBrushHandle  , 0 )
	aAdd ( _HMG_aControlEnabled  , .T. )
	aAdd ( _HMG_aControlMiscData1  , 0 )

Return Nil


#pragma BEGINDUMP


#define _WIN32_IE      0x0500
#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400
#include <shlobj.h>

#include <windows.h>
#include <mmsystem.h>
#include <commctrl.h>
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"

HB_FUNC ( INITANIMATERES )
{
	HWND hwnd;
	HWND AnimationCtrl;
	HINSTANCE avi;

	int Style = WS_CHILD | WS_VISIBLE | ACS_TRANSPARENT | ACS_CENTER | ACS_AUTOPLAY ;

	INITCOMMONCONTROLSEX  i;
	i.dwSize = sizeof(INITCOMMONCONTROLSEX);
	i.dwICC = ICC_DATE_CLASSES;
	InitCommonControlsEx(&i);

	hwnd = (HWND) hb_parnl (1);

	if ( ! hb_parl (9) )
	{
		Style = Style | WS_VISIBLE ;
	}

	avi = LoadLibrary( hb_parc(7) ) ;

	AnimationCtrl = CreateWindowEx(0,	//Style
			ANIMATE_CLASS,		//Class Name
			NULL,			//Window name
			Style,			//Window Style
			hb_parni(3) ,		//Left
			hb_parni(4) ,		//Top
			hb_parni(5) ,		//Right
			hb_parni(6) ,		//Bottom
			hwnd,			//Handle of parent
			(HMENU)hb_parni(2),	//Menu
			avi,			//hInstance
			NULL ) ;		//User defined style

	Animate_OpenEx( (HWND) AnimationCtrl, avi, hb_parnl(8) ) ;

	hb_retnl ( (LONG) AnimationCtrl ) ;
}

#pragma ENDDUMP