/*
 * MINIGUI - Harbour Win32 GUI library Demo
 * Copyright 2002 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * BreakMenu demo
 * (c) 2006 Vladimir Chumachenko <ChVolodymyr@yandex.ru>
 *  HMG 1.0 Experimental Build 17
*/

#include "MiniGUI.ch"


#xcommand ITEM <caption> ;
	[ ACTION <action> ] ;
	[ NAME <name> ] ;
	[ IMAGE <image> ] ;
	[ <checked :CHECKED> ] ;
	[ MESSAGE <message> ] ;
	[ <disabled :DISABLED> ] ;
	[ <breakmenu :BREAKMENU> [ <separator :SEPARATOR> ] ] ;
=> ;
	_DefineMenuItem ( <caption>, <{action}>, <"name">, <image>, <.checked.>, <.disabled.>, <message>, <.breakmenu.>, <.separator.> )


#xcommand MENUITEM <caption> ;
	[ ACTION <action> ] ;
	[ NAME <name> ] ;
	[ IMAGE <image> ] ;
	[ <checked :CHECKED> ] ;
	[ MESSAGE <message> ] ;
	[ <disabled :DISABLED> ] ;
	[ <breakmenu :BREAKMENU> [ <separator :SEPARATOR> ] ] ;
=> ;
	_DefineMenuItem ( <caption>, <{action}>, <"name">, <image>, <.checked.>, <.disabled.>, <message>, <.breakmenu.>, <.separator.> )


Procedure Main

Define window Form_1 ;
       At 0, 0 ;
       Width 400 ;
       Height 200 ;
       Title 'Menu Break Test' ;
       Main ;
       NotifyIcon 'demo.ico'

   Define main menu

      Popup 'File'

	Item 'Open'		Action MsgInfo ( 'File:Open'  )
	Item 'Save'		Action MsgInfo ( 'File:Save'  )
	Item 'Print'		Action MsgInfo ( 'File:Print' )
	Item 'Save As...'	Action MsgInfo ( 'File:Save As' ) Disabled
	Separator
	Item 'Exit' Action Form_1.Release

      End Popup

      Popup 'Test' 
	Item 'Item 1' Action MsgInfo ( 'Item 1' )
	Item 'Item 2' Action MsgInfo ( 'Item 2' )
	Item 'Item 3' Action MsgInfo ( 'Item 3' )
	
	// Remark:
	// Menu Item with BreakMenu clause begin a new column
	
	Item 'Item 3.1' Action MsgInfo ( 'Item 3.1' ) BreakMenu Separator
	Item 'Item 3.2' Action MsgInfo ( 'Item 3.2' )
	Separator
	Item 'Item 3.3' Action MsgInfo ( 'Item 3.3' )
	
	MenuItem 'Item 3.3.1' Action MsgInfo ( 'Item 3.3.1' ) BreakMenu
	MenuItem 'Item 3.3.2' Action MsgInfo ( 'Item 3.3.2' )

      End Popup

   End Menu
      
   Define context menu
     Item 'Open'	Action MsgInfo ( 'File:Open'  )
     
     Popup 'Save'
       Item 'Save'	 Action MsgInfo ( 'File:Save'  )
       Item 'Save As...' Action MsgInfo ( 'File:Save As' ) Disabled
     End Popup
     
     Item 'Print'	Action MsgInfo ( 'File:Print' )
     Separator
     Item 'Exit'	Action Form_1.Release

     Item 'Item 1' Action MsgInfo ( 'Item 1' ) BreakMenu Separator
     Item 'Item 2' Action MsgInfo ( 'Item 2' )
     Item 'Item 3' Action MsgInfo ( 'Item 3' )
     
   End menu
   
   Define notify menu
     Item '1st file' Action MsgInfo ( '1st file opened' )
     Item '2nd file' Action MsgInfo ( '2nd file opened' )

     Item 'About' Action MsgInfo ( 'About dialog' ) BreakMenu Separator
     Separator
     Item 'Options' Action MsgInfo ( 'Options dialog' )
     Separator
     Item 'Exit' Action Form_1.Release

   End menu
      
End Window

Center window Form_1
Activate window Form_1

Return


// Replace for h_menu.prg

Function _DefineMenuItem ( caption , action , name , Image , checked , disabled , cMessage,lBreakMenu, lSeparator )
Local Controlhandle , mVar := '' , k := 0 , nBreakCode := 0
Local id

If lBreakMenu
   
   nBreakCode := 1   //  
   
   If lSeparator
      nBreakCode := 2  // ...   
   Endif
   
Endif
	If ( _HMG_xMenuType == 'MAIN' )

		Id := _GetId()
#ifdef __XHARBOUR__
		Controlhandle := AppendMenuString ( _HMG_xMenuPopuphandle [ _HMG_xMenuPopupLevel ], id, caption, nBreakCode )
#else
		ControlHandle := AppendMenuString ( _HMG_xMenuPopuphandle[ _HMG_SYSDATA[188] ], id, caption, nBreakCode )
#endif
		if Valtype ( image ) != 'U'
#ifdef __XHARBOUR__
			MenuItem_SetBitMaps ( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , Id , image , '' )
#else
			MenuItem_SetBitMaps ( _HMG_xMenuPopuphandle [_HMG_SYSDATA[188] ] , Id , image , '' )
#endif
		EndIf

		k := _GetControlFree()

		if valtype (name) != 'U'
			mVar := '_' + _HMG_xMainMenuParentName + '_' + Name
			Public &mVar. := k
		Else
			mVar := '_MenuDummyVar'
			Name := 'DummyMenuName'
			Public &mVar. := 0  
		EndIf

		_HMG_aControlType [k] := "MENU"
		_HMG_aControlNames  [k] :=  Name
		_HMG_aControlHandles  [k] :=  Controlhandle
		_HMG_aControlParentHandles  [k] := _HMG_xMainMenuParentHandle
		_HMG_aControlIds  [k] :=  id
		_HMG_aControlProcedures  [k] :=  action
#ifdef __XHARBOUR__
		_HMG_aControlPageMap  [k] := _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ]
#else
		_HMG_aControlPageMap  [k] := _HMG_xMenuPopuphandle [ _HMG_SYSDATA[188] ]
#endif
		_HMG_aControlValue  [k] :=	 cMessage
		_HMG_aControlInputMask	[k] :=	"" 
		_HMG_aControllostFocusProcedure  [k] :=  "" 
		_HMG_aControlGotFocusProcedure	[k] :=	"" 
		_HMG_aControlChangeProcedure  [k] :=  "" 
		_HMG_aControlDeleted  [k] :=  .F. 
		_HMG_aControlBkColor  [k] :=  Nil 
		_HMG_aControlFontColor [k] :=	Nil 
		_HMG_aControlDblClick	[k] := "" 
		_HMG_aControlHeadClick	[k] :=	{} 
		_HMG_aControlRow  [k] :=  0 
		_HMG_aControlCol   [k] := 0 
		_HMG_aControlWidth  [k] :=  0 
		_HMG_aControlHeight  [k] :=  0 
		_HMG_aControlSpacing  [k] :=  0 
		_HMG_aControlContainerRow  [k] :=  -1 
		_HMG_aControlContainerCol  [k] :=  -1 
		_HMG_aControlPicture  [k] :=  "" 
		_HMG_aControlContainerHandle  [k] :=  0 
		_HMG_aControlFontName  [k] :=  '' 
		_HMG_aControlFontSize  [k] :=  0 
		_HMG_aControlFontAttributes  [k] := {.f.,.f.,.f.,.f.} 
		_HMG_aControlToolTip   [k] :=  ''  
		_HMG_aControlRangeMin  [k] :=	0  
		_HMG_aControlRangeMax	[k] :=	0  
		_HMG_aControlCaption  [k] :=   Caption	
		_HMG_aControlVisible  [k] :=   .t. 
		_HMG_aControlHelpId  [k] :=   0 
		_HMG_aControlFontHandle  [k] :=   0 
		_HMG_aControlBrushHandle   [k] :=  0 
		_HMG_aControlEnabled  [k] :=   .T. 
		_HMG_aControlMiscData1 [k] := 0

		if checked == .t.
#ifdef __XHARBOUR__
			xCheckMenuItem ( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , id )
#else
			xCheckMenuItem ( _HMG_xMenuPopuphandle [_HMG_SYSDATA[188] ] , id )
#endif
		EndIf
//JP12b
		if disabled == .t.
#ifdef __XHARBOUR__
			xDisableMenuItem ( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , id )
#else
			xDisableMenuItem ( _HMG_xMenuPopuphandle [_HMG_SYSDATA[188] ] , id )
#endif
		EndIf
			
	Else

		id := _GetId()

		If ( _HMG_xContextPopupLevel > 0 )
			ControlHandle := AppendMenuString( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel], id, caption, nBreakCode )
		Else
			ControlHandle := AppendMenuString( _HMG_xContextMenuHandle, id, caption, nBreakCode )
		Endif

		if Valtype ( image ) != 'U'
			If ( _HMG_xContextPopupLevel > 0 )
				MenuItem_SetBitMaps( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id, image , '' )
			Else
				MenuItem_SetBitMaps( _HMG_xContextMenuHandle, id, image , '' )
			Endif

		EndIf

		k := _GetControlFree()

		if valtype (name) != 'U'
			mVar := '_' + _HMG_xContextMenuParentName + '_' + Name
			Public &mVar. := k
		Else
			mVar := '_MenuDummyVar'
			Name := 'DummyMenuName'
			Public &mVar. := 0  
		EndIf

		_HMG_aControlType  [k] :=   "MENU" 
		_HMG_aControlNames  [k] :=   Name 
		_HMG_aControlHandles  [k] :=   Controlhandle 
		_HMG_aControlParentHandles  [k] := _HMG_xContextMenuParentHandle
		_HMG_aControlIds  [k] :=   id 
		_HMG_aControlProcedures  [k] :=   action 
		_HMG_aControlPageMap  [k] :=  _HMG_xContextMenuHandle 
		_HMG_aControlValue  [k] :=   cMessage
		_HMG_aControlInputMask	 [k] :=  "" 
		_HMG_aControllostFocusProcedure  [k] :=   "" 
		_HMG_aControlGotFocusProcedure	[k] :=	 "" 
		_HMG_aControlChangeProcedure  [k] :=   "" 
		_HMG_aControlDeleted  [k] :=   .F. 
		_HMG_aControlBkColor  [k] :=   Nil 
		_HMG_aControlFontColor	[k] :=	 Nil 
		_HMG_aControlDblClick  [k] :=	"" 
		_HMG_aControlHeadClick	[k] :=	 {} 
		_HMG_aControlRow  [k] :=   0 
		_HMG_aControlCol  [k] :=   0 
		_HMG_aControlWidth  [k] :=   0 
		_HMG_aControlHeight   [k] :=  0 
		_HMG_aControlSpacing   [k] :=  0 
		_HMG_aControlContainerRow  [k] :=   -1 
		_HMG_aControlContainerCol  [k] :=   -1 
		_HMG_aControlPicture  [k] :=   "" 
		_HMG_aControlContainerHandle [k] :=    0 
		_HMG_aControlFontName  [k] :=	'' 
		_HMG_aControlFontSize  [k] :=	0 
		_HMG_aControlFontAttributes  [k] :=  {.f.,.f.,.f.,.f.} 
		_HMG_aControlToolTip   [k] :=	'' 
		_HMG_aControlRangeMin	[k] :=	 0  
		_HMG_aControlRangeMax  [k] :=	 0  
		_HMG_aControlCaption  [k] :=	Caption  
		_HMG_aControlVisible  [k] :=	.t. 
		_HMG_aControlHelpId   [k] :=   0 
		_HMG_aControlFontHandle  [k] :=   0 
		_HMG_aControlBrushHandle  [k] :=    0 
		_HMG_aControlEnabled  [k] :=	.T. 
		_HMG_aControlMiscData1 [k] := 0

		if checked == .t.
			If ( _HMG_xContextPopupLevel > 0 )
				xCheckMenuItem( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id )
			Else
				xCheckMenuItem( _HMG_xContextMenuHandle, id )
			Endif
		EndIf

//JP12b
		if disabled == .t.
			If ( _HMG_xContextPopupLevel > 0 )
				xDisableMenuItem( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id )
			Else
				xDisableMenuItem( _HMG_xContextMenuHandle, id )
			Endif
		EndIf

	EndIf

Return Nil


#pragma BEGINDUMP

#include <windows.h> 
#include <winuser.h> 
#include "hbapi.h"

// Replace for c_menu.c

HB_FUNC ( APPENDMENUSTRING )
{
  int n = hb_parni(4);

  // The MF_MENUBARBREAK and MF_MENUBREAK works similary,
  // but MF_MENUBARBREAK shows a vertical separator in the menu

  switch( n )
   {
    case 1:
      hb_retnl ( AppendMenu( (HMENU) hb_parnl(1), MF_STRING + MF_MENUBREAK, 
		 hb_parni(2), hb_parc(3)) ) ; break;
    case 2:
      hb_retnl ( AppendMenu( (HMENU) hb_parnl(1), MF_STRING + MF_MENUBARBREAK, 
		 hb_parni(2), hb_parc(3)) ) ; break;
    default: 
      hb_retnl ( AppendMenu( (HMENU) hb_parnl(1), MF_STRING, 
		 hb_parni(2), hb_parc(3)) ) ; break;
   }

}

#pragma ENDDUMP
