/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * FreeImage.dll should present to use this sample
 * http://freeimage.sourceforge.net/
 *
 * Copyright 2003-2008 Grigory Filatov <gfilatov@freemail.ru>
*/

ANNOUNCE RDDSYS

#include "FreeImage.ch"

#include "minigui.ch"
#include "winprint.ch"

#xcommand ON KEY SPACE [ OF <parent> ] ACTION <action> ;
=> ;
_DefineHotKey ( <"parent"> , 0 , VK_SPACE , <{action}> )

#xcommand ON KEY GRAYPLUS [ OF <parent> ] ACTION <action> ;
=> ;
_DefineHotKey ( <"parent"> , 0 , VK_ADD , <{action}> )

#xcommand ON KEY GRAYMINUS [ OF <parent> ] ACTION <action> ;
=> ;
_DefineHotKey ( <"parent"> , 0 , VK_SUBTRACT , <{action}> )

#define PROGRAM 'FreeImage Viewer Lite'
#define VERSION ' version 1.4.0'
#define COPYRIGHT ' 2003-2008 Grigory Filatov'
#define MsgAlert( c ) MsgAlert( c, "Attention" )

Static handle, nWidth, nHeight, cFile := "", nKoef := 1, aFiles := {}, nItem := 1, nLoadTime := 0, cSaveFile

Memvar nScrWidth, nScrHeight
Memvar nLen, nWidthOrig, nHeightOrig

Function Main( fname )
LOCAL nLen := 0, aDesk := GetDesktopArea()
PRIVATE nScrWidth := aDesk[3], nScrHeight := aDesk[4]

   default fname := "FreeView.jpg"

   IF !FILE('FreeImage.Dll')
      MsgAlert("Can't found the FreeImage.Dll")
      Return Nil
   ENDIF

   fi_Initialise()

   cFile := fname
   aFiles := DIRECTORY( "*.JPG" )
   Aeval( DIRECTORY( "*.JPEG" ), {|e| Aadd(aFiles, e)} )
   Aeval( DIRECTORY( "*.PNG" ), {|e| Aadd(aFiles, e)} )
   Aeval( DIRECTORY( "*.BMP" ), {|e| Aadd(aFiles, e)} )
   Aeval( DIRECTORY( "*.TIF" ), {|e| Aadd(aFiles, e)} )
   Aeval( DIRECTORY( "*.PSD" ), {|e| Aadd(aFiles, e)} )
   Aeval( DIRECTORY( "*.ICO" ), {|e| Aadd(aFiles, e)} )
   nLen := LEN( aFiles )
   nItem := ASCAN(aFiles, {|e| UPPER(e[1]) = UPPER(cFile)})

   SET CENTURY ON
   SET DATE GERMAN

   DEFINE WINDOW Form_Main ;
	AT 0,0 ;
	WIDTH 520 HEIGHT 354 ;
	TITLE PROGRAM ;
	ICON 'IMAGE' ;
	MAIN ;
	ON INIT IF( fname <> "FreeView.jpg", FileOpen(fname, .f.), ( handle := FI_Load( FIF_JPEG, fname, JPEG_DEFAULT ), ;
		nWidth  := FI_GetWidth( handle ), 	nHeight := FI_GetHeight( handle ), ;
		Form_Main.StatusBar.Item(1) := ltrim(str(nWidth)) + " x " + ltrim(str(nHeight)), ;
		Form_Main.StatusBar.Item(2) := ltrim(str(nItem)) + "/" + ltrim(str(nLen)), ;
		Form_Main.StatusBar.Item(3) := Str(nKoef*100, 4)+" %", ;
		Form_Main.StatusBar.Item(4) := ltrim(str(filesize(fname)/1024)) + " KB", ;
		Form_Main.StatusBar.Item(5) := dtoc(filedate(fname)) + " / " + filetime(fname), ;
		Form_Main.Width  := nWidth + GetBorderWidth() + 4, ;
		Form_Main.Height := nHeight + GetTitleHeight() + 64, ;
		PaintWindow() ) ) ;
	ON PAINT PaintWindow() ;
	ON RELEASE fi_Deinitialise() ;
	FONT 'MS Sans Serif' SIZE 9

	DEFINE MAIN MENU

		DEFINE POPUP "&File"
			MENUITEM "&Open"+Chr(9)+"   Ctrl+O" ACTION FileOpen()
			SEPARATOR
			MENUITEM "&Save"+Chr(9)+"   Ctrl+S" ACTION FileSave()
			MENUITEM "Save &as..."+Chr(9)+"   Ctrl+A" ACTION FileSaveAs()
			SEPARATOR
			MENUITEM "&Print"+Chr(9)+"   Ctrl+P" ACTION FilePrint()
			SEPARATOR
			MENUITEM "E&xit"+Chr(9)+"   Esc" ACTION ReleaseAllWindows()
		END POPUP

		DEFINE POPUP "&View"
			MENUITEM "&Information"+Chr(9)+"   Ctrl+I" ACTION PictInfo()
			SEPARATOR
			MENUITEM "&Full screen"+Chr(9)+"   Ctrl+Enter" ACTION FullScreen()
			SEPARATOR
			MENUITEM "&Zoom In"+Chr(9)+"   Gray +" ACTION Zoom( 1 )
			MENUITEM "Zoom &Out"+Chr(9)+"   Gray -" ACTION Zoom( -1 )
			MENUITEM "O&riginal size"+Chr(9)+"   Ctrl+H" ACTION Zoom( 0 )
		END POPUP

		DEFINE POPUP "&Help"
			MENUITEM "&About" ACTION MsgAbout()
		END POPUP
	END MENU

	ON KEY F12 ACTION Form_Main.Minimize

	ON KEY ESCAPE ACTION ReleaseAllWindows()

	ON KEY CONTROL+RETURN ACTION FullScreen()

	ON KEY CONTROL+O ACTION FileOpen()

	ON KEY CONTROL+S ACTION FileSave()

	ON KEY CONTROL+A ACTION FileSaveAs()

	ON KEY CONTROL+P ACTION FilePrint()

	ON KEY CONTROL+I ACTION PictInfo()

	ON KEY CONTROL+H ACTION Zoom( 0 )

	ON KEY GRAYPLUS ACTION Zoom( 1 )

	ON KEY GRAYMINUS ACTION Zoom( -1 )

	ON KEY HOME ACTION ( nItem := 1, Next( 0 ) )

	ON KEY END ACTION ( nItem := Len(aFiles), Next( 0 ) )

	ON KEY BACK ACTION Next( -1 )

	ON KEY SPACE ACTION Next( 1 )

 	@ 6,236 TEXTBOX Text_1 HEIGHT 20 WIDTH 80 VALUE IF(EMPTY(nLen), "", ltrim(str(nItem)) + "/" + ltrim(str(nLen)))

	DEFINE SPLITBOX

          DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 20, 20 FLAT

		BUTTON Button_1  ;
			PICTURE 'Open' ;
			TOOLTIP 'Open' ;
			ACTION FileOpen()

		BUTTON Button_2 ;
			PICTURE 'Save' ;
			TOOLTIP 'Save as' ;
			ACTION FileSaveAs()

		BUTTON Button_3;
			PICTURE 'Print' ;
			TOOLTIP 'Print' ;
			ACTION FilePrint() SEPARATOR

		BUTTON Button_4;
			PICTURE 'Info' ;
			TOOLTIP 'Info' ;
			ACTION PictInfo()

		BUTTON Button_5 ;
			PICTURE 'Zout' ;
			TOOLTIP 'Zoom out' ;
			ACTION Zoom( 1 )

		BUTTON Button_6 ;
			PICTURE 'Zin' ;
			TOOLTIP 'Zoom in' ;
			ACTION Zoom( -1 )

		BUTTON Button_7 ;
			PICTURE 'Left' ;
			TOOLTIP 'Previous' ;
			ACTION Next( -1 )

		BUTTON Button_8 ;
			PICTURE 'Right' ;
			TOOLTIP 'Next' ;
			ACTION Next( 1 )

          END TOOLBAR

	END SPLITBOX

	Form_Main.Button_2.Enabled := !EMPTY( nLen )
	Form_Main.Button_3.Enabled := !EMPTY( nLen )
	Form_Main.Button_4.Enabled := !EMPTY( nLen )
	Form_Main.Button_5.Enabled := !EMPTY( nLen )
	Form_Main.Button_6.Enabled := !EMPTY( nLen )
	Form_Main.Button_7.Enabled := ( nLen > 1 )
	Form_Main.Button_8.Enabled := ( nLen > 1 )

	DEFINE STATUSBAR
		STATUSITEM "No file loaded" WIDTH 80
		STATUSITEM "" WIDTH 60
		STATUSITEM "" WIDTH 52 ACTION Zoom( 0 )
		STATUSITEM "" WIDTH 80
		STATUSITEM "" WIDTH 124
		STATUSITEM "" WIDTH 200
	END STATUSBAR

   END WINDOW

   CENTER WINDOW Form_Main

   ACTIVATE WINDOW Form_Main

Return Nil

Static Function FileOpen( fname, lInit )
Local cPath := "\" + CurDir() + IF( Empty( CurDir() ), "", "\" ), ;
	nLen := LEN( aFiles ), nFormWidth, nFormHeight, nStart

   default fname := "", lInit := .t.

   IF Empty( fname )
      fname := GetFile( { {"Image files (*.bmp;*.jpg;*.jpeg;*.png;*.psd;*.tif;*.ico)", ;
			"*.bmp;*.jpg;*.jpeg;*.png;*.psd;*.tif;*.ico"} }, "Open", cPath )
   ELSE
      fname := IF( AT('"', fname) > 0, STRTRAN(fname, '"', ''), fname )
   ENDIF

   IF !Empty( fname ) .AND. File( fname )
      IF handle != Nil
         FI_Unload( handle )
         handle := Nil
      ENDIF
      cFile := fname
      IF lInit
         aFiles := DIRECTORY( "*.JPG" )
         Aeval( DIRECTORY( "*.JPEG" ), {|e| Aadd(aFiles, e)} )
         Aeval( DIRECTORY( "*.PNG" ), {|e| Aadd(aFiles, e)} )
         Aeval( DIRECTORY( "*.BMP" ), {|e| Aadd(aFiles, e)} )
         Aeval( DIRECTORY( "*.TIF" ), {|e| Aadd(aFiles, e)} )
         Aeval( DIRECTORY( "*.PSD" ), {|e| Aadd(aFiles, e)} )
         Aeval( DIRECTORY( "*.ICO" ), {|e| Aadd(aFiles, e)} )
         nLen := LEN( aFiles )
         nItem := ASCAN(aFiles, {|e| UPPER(e[1]) = UPPER(cFileNoPath(cFile))})
      ENDIF
      nKoef := 1

      nStart := Seconds()
      handle := FI_Load( fi_GetFileType(fname, 0), fname, 0 )
      nLoadTime := Seconds() - nStart

      nWidth  := FI_GetWidth( handle )
      nHeight := FI_GetHeight( handle )

      DO WHILE .T.
         nFormWidth  := Round( nWidth * nKoef, 0 ) + GetBorderWidth() + 4
         nFormHeight := Round( nHeight * nKoef, 0 ) + GetTitleHeight() + GetBorderHeight() + GetMenuBarHeight() + 60
         IF ( nFormWidth <= nScrWidth .AND. nFormHeight <= nScrHeight ) .OR. nKoef < 0.11
               EXIT
         ENDIF
         nKoef -= 0.01
      ENDDO

      Form_Main.Width := IF( nFormWidth < 400, 400, nFormWidth )
      Form_Main.Height := IF( nFormHeight < 100, 100, nFormHeight )

      IF !Form_Main.Button_2.Enabled .or. lInit
         Form_Main.Button_2.Enabled := .t.
         Form_Main.Button_3.Enabled := .t.
         Form_Main.Button_4.Enabled := .t.
         Form_Main.Button_5.Enabled := .t.
         Form_Main.Button_6.Enabled := ( nLen > 1 )
         Form_Main.Button_7.Enabled := ( nLen > 1 )
      ENDIF
      Form_Main.Text_1.Value := ltrim(str(nItem)) + "/" + ltrim(str(nLen))

      Form_Main.Title := cFileNoPath(fname) + ' - ' + PROGRAM + ;
         IF(nKoef # 1, " (Zoom: " + ltrim(str(Round( nKoef*nWidth, 0 ))) + " x " + ltrim(str(Round( nKoef*nHeight, 0 ))) + ")", "")
      Form_Main.StatusBar.Item(1) := ltrim(str(nWidth)) + " x " + ltrim(str(nHeight))
      Form_Main.StatusBar.Item(2) := ltrim(str(nItem)) + "/" + ltrim(str(nLen))
      Form_Main.StatusBar.Item(3) := Str(nKoef*100, 4)+" %"
      Form_Main.StatusBar.Item(4) := ltrim(str(aFiles[nItem][2]/1024)) + " KB"
      Form_Main.StatusBar.Item(5) := dtoc(aFiles[nItem][3]) + " / " + aFiles[nItem][4]

      PaintWindow(handle)
      Form_Main.Center
   ENDIF

Return Nil

Static Function FileSave()
Local cPath := "\" + CurDir() + IF( Empty( CurDir() ), "", "\" )
Local cExt := Lower( cFileExt( cFile ) ), nFif, nFormat, cSaveFile, nIndex
	
	IF handle == Nil
		Return Nil
	ENDIF

	IF cExt == "jpg" .OR. cExt == "jpeg"
		nFif := FIF_JPEG
		nFormat := JPEG_DEFAULT
		nIndex := 2
	ELSEIF cExt == "png"
		nFif := FIF_PNG
		nFormat := PNG_DEFAULT 
		nIndex := 3
	ELSE
		nFif := FIF_BMP
		nFormat := BMP_DEFAULT
		nIndex := 1
	ENDIF

	cSaveFile := PutFile( { {"Bmp files (*.bmp)", "*.bmp"}, {"Jpg files (*.jpg;*.jpeg)", "*.jpg;*.jpeg"}, ;
				{"Png files (*.png)", "*.png"} }, 'Save ...', cPath, .T., @nIndex )

	IF !Empty( cSaveFile )
		cSaveFile := IF( AT( ".", cSaveFile ) > 0, cFileNoPath(cSaveFile), cSaveFile )

		IF .NOT. FI_Save(nFif, handle, cSaveFile + "." + cExt, nFormat)
			MsgAlert( "Can't save a file" )
		ENDIF
	ENDIF

Return Nil

Static Function FileSaveAs()
Local cPath := "\" + CurDir() + IF( Empty( CurDir() ), "", "\" )
Local cExt := Lower( cFileExt( cFile ) ), nFif, nFormat, cSaveFile, nIndex
	
	IF handle == Nil
		Return Nil
	ENDIF

	IF cExt == "jpg" .OR. cExt == "jpeg"
		nIndex := 2
	ELSEIF cExt == "png"
		nIndex := 3
	ELSE
		nIndex := 1
	ENDIF
	cSaveFile := PutFile( { {"Bmp files (*.bmp)", "*.bmp"}, {"Jpg files (*.jpg;*.jpeg)", "*.jpg;*.jpeg"}, ;
				{"Png files (*.png)", "*.png"} }, 'Save Image As ...', cPath, .T., @nIndex )

	IF !Empty( cSaveFile )
		IF nIndex == 2
			nFif := FIF_JPEG
			nFormat := JPEG_DEFAULT
			cExt := "jpg"
		ELSEIF nIndex == 3
			nFif := FIF_PNG
			nFormat := PNG_DEFAULT 
			cExt := "png"
		ELSE
			nFif := FIF_BMP
			nFormat := BMP_DEFAULT
			cExt := "bmp"
		ENDIF

		cSaveFile := IF( AT( ".", cSaveFile ) > 0, cSaveFile, cSaveFile + "." + cExt )

		IF .NOT. FI_Save(nFif, handle, cSaveFile, nFormat)
			MsgAlert( "Can't save a file" )
		ENDIF
	ENDIF

Return Nil

Static Function FullScreen()
Local nMode := IF( nWidth < nScrWidth .AND. nHeight < nScrHeight, 0, 2 )
PRIVATE nLen := LEN( aFiles ), nWidthOrig := nWidth, nHeightOrig := nHeight

	cSaveFile := GetTempFolder() + "\" + cFileNoExt( cFile ) + ".bmp"

	DEFINE WINDOW Form_2 AT 0, 0 ;
		WIDTH GetDesktopWidth() HEIGHT GetDesktopHeight() ;
		CHILD TOPMOST NOSIZE NOCAPTION ;
		ON INIT ( FI_Save( FIF_BMP, handle, cSaveFile, BMP_DEFAULT ), ;
			DrawPicture( GetFormHandle("Form_2"), cSaveFile, nMode ), ;
			Form_2.Label_1.Value := cFile + " [ " + ltrim(str(nItem)) + " / " + ltrim(str(nLen)) + " ]" ) ;
		ON RELEASE ( Ferase( cSaveFile ), ;
			Form_Main.Width  := Round( nWidth * nKoef, 0 ) + GetBorderWidth() + 4, ;
			Form_Main.Height := Round( nHeight * nKoef, 0 ) + GetTitleHeight() + GetBorderHeight() + GetMenuBarHeight() + 60, ;
			IF( Form_Main.Width < 400, Form_Main.Width := 400, ), ;
			IF( Form_Main.Height < 100, Form_Main.Height := 100, ), Form_Main.Center ) ;
		BACKCOLOR BLACK

		ON KEY ESCAPE ACTION Form_2.Release

		ON KEY RETURN ACTION Form_2.Release

		ON KEY CONTROL+RETURN ACTION Form_2.Release

		ON KEY LEFT ACTION NextFS( -1 )

		ON KEY RIGHT ACTION NextFS( 1 )

		ON KEY UP ACTION ( nItem := 1, NextFS( 0 ) )

		ON KEY DOWN ACTION ( nItem := Len(aFiles), NextFS( 0 ) )

		ON KEY BACK ACTION NextFS( -1 )

		ON KEY SPACE ACTION NextFS( 1 )

		@ 0,0 LABEL Label_1 VALUE "" ;
			WIDTH nScrWidth HEIGHT 16 ;
			FONT 'Tahoma' SIZE 9 ;
			FONTCOLOR GREEN TRANSPARENT
	END WINDOW

	ACTIVATE WINDOW Form_2

Return Nil

Static Function NextFS( nOp )
Local nMode, fname, clone
Local nFormWidth := Form_2.Width, nFormHeight := Form_2.Height, nRatio := nWidth / nHeight, nW, nH

   IF nLen > 1
      Ferase( cSaveFile )
      FI_Unload( handle )

      IF nOp < 0
         nItem--
         nItem := IF(nItem < 1, nLen, nItem)
      ELSEIF nOp > 0
         nItem++
         nItem := IF(nItem > nLen, 1, nItem)
      ENDIF

      cFile := aFiles[nItem][1]
      cSaveFile := GetTempFolder() + "\" + cFileNoExt( cFile ) + ".bmp"

      fname := CurDrive() + ":\" + CurDir() + IF( Empty( CurDir() ), "", "\" ) + cFile

      handle := FI_Load( fi_GetFileType(fname, 0), fname, 0 )

      nWidth  := FI_GetWidth( handle )
      nHeight := FI_GetHeight( handle )

      nMode := IF( nWidth < nScrWidth .AND. nHeight < nScrHeight, 0, 2 )

      IF nWidth > nFormWidth .OR. nHeight > nFormHeight .OR. nWidthOrig >= nFormWidth .OR. nHeightOrig >= nFormHeight
		nW := nFormWidth
		nH := nFormHeight
		IF nRatio >= 1
			nH := Round( nHeight * ( 10 * nW / nWidth ) / 10, 0 )
		ELSE
			nW := Round( nWidth * ( 10 * nH / nHeight ) / 10, 0 )
		ENDIF
		nWidth := nW
		nHeight := nH
		clone := fi_Clone( handle )
                FI_Unload( handle )
		handle := FI_Rescale( clone, nWidth, nHeight, FILTER_BICUBIC )
		fi_Unload( clone )
      ENDIF

      FI_Save( FIF_BMP, handle, cSaveFile, BMP_DEFAULT )

      ERASE WINDOW Form_2
      DrawPicture( GetFormHandle("Form_2"), cSaveFile, nMode )

      Form_2.Label_1.Value := cFile + " [ " + ltrim(str(nItem)) + " / " + ltrim(str(nLen)) + " ]"
   ENDIF

Return Nil

Static Function Next( nOp )
LOCAL nLen := LEN( aFiles )

   IF nLen > 1
      InvalidateRect( _HMG_MainHandle, 0 )
      IF nOp < 0
         nItem--
         nItem := IF(nItem < 1, nLen, nItem)
      ELSEIF nOp > 0
         nItem++
         nItem := IF(nItem > nLen, 1, nItem)
      ENDIF

      FileOpen( aFiles[nItem][1], .f. )
   ELSE
      Form_Main.Text_1.Value := ltrim(str(nItem)) + "/" + ltrim(str(nLen))
   ENDIF

Return Nil

Static Function FilePrint()
Local nScale := 1 / 3.937, nX, nY, nH, nW

   IF !Empty( cFile ) .AND. File( cFile )

	INIT PRINTSYS

	SELECT BY DIALOG 

	IF HBPRNERROR != 0 
		Return Nil
	ENDIF

	SET UNITS MM    			// Sets @... units to milimeters
	SET PAPERSIZE DMPAPER_A4		// Sets paper size to A4

	IF nHeight >= nWidth
		SET ORIENTATION PORTRAIT	// Sets paper orientation to portrait
		nH := 250
		nW := 170
	ELSE
		SET ORIENTATION LANDSCAPE	// Sets paper orientation to landscape
		nH := 170
		nW := 250
	ENDIF

	SET BIN DMBIN_FIRST 			// Use first bin
	SET QUALITY DMRES_HIGH			// Sets print quality to high
	SET COLORMODE DMCOLOR_COLOR		// Set print color mode to color
	SET PREVIEW ON				// Enables print preview
	SET PREVIEW RECT 0, 0, nScrHeight, nScrWidth
	START DOC NAME Left(PROGRAM, 9)

		START PAGE

			DO WHILE .T.

				nX := Round( nHeight * nScale, 0 )
				nY := Round( nWidth * nScale, 0 )

				IF ( nX <= nH .AND. nY <= nW ) .OR. nScale < 0.15
					EXIT
				ENDIF

				nScale -= 0.05

			ENDDO

			@ 15,20 PICTURE cFile SIZE nX, nY

		END PAGE

	END DOC

	RELEASE PRINTSYS

   ENDIF

Return Nil

Static Function Zoom( nOp )
Local nPictWidth, nPictHeight

   IF handle == Nil
      Return Nil
   ENDIF

   IF Empty( nOp ) .AND. nKoef == 1
      Return Nil
   ENDIF

   IF Int( nKoef * 10 ) # Round(nKoef, 1) * 10
      nKoef := Int( nKoef * 10 ) / 10
   ELSE
      nKoef := Round( nKoef, 1 )
   ENDIF
   IF nOp < 0 .AND. nKoef > 0.11
      nKoef -= 0.1
   ELSEIF nOp > 0 .AND. nKoef < 9.9
      nKoef += 0.1
   ELSE
      nKoef := 1
   ENDIF

   nPictWidth := Round( nWidth * nKoef, 0 )
   nPictHeight := Round( nHeight * nKoef, 0 )

   Form_Main.Width  := nPictWidth + GetBorderWidth() + 4
   Form_Main.Height := nPictHeight + GetTitleHeight() + GetBorderHeight() + GetMenuBarHeight() + 60

   IF Form_Main.Width < 400
      Form_Main.Width := 400
   ENDIF
   IF Form_Main.Height < 100
      Form_Main.Height := 100
   ENDIF

   Form_Main.Title := cFileNoPath(cFile) + ' - ' + PROGRAM + ;
      IF(nKoef # 1, " (Zoom: " + ltrim(str(nPictWidth)) + " x " + ltrim(str(nPictHeight)) + ")", "")
   Form_Main.StatusBar.Item(3) := Str(nKoef*100, 4)+" %"

   Form_Main.Center

Return Nil

Static Function PictInfo()
Local cExt := Lower( cFileExt( cFile ) )
Local aLabel := {}, cLabel, aText := {}, cText, n

   Aadd(aLabel, "File name:")
   Aadd(aLabel, "Folder:")
   Aadd(aLabel, "Compression:")
   Aadd(aLabel, "Original size:")
   Aadd(aLabel, "Disk size:")
   Aadd(aLabel, "Current folder index:")
   Aadd(aLabel, "File date/time:")
   Aadd(aLabel, "Loaded in:")

   Aadd(aText, cFileNoPath(cFile))
   Aadd(aText, CurDrive() + ":\" + CurDir() + IF( Empty( CurDir() ), "", "\" ))
   IF cExt == "jpg"
      Aadd(aText, "JPG")
   ELSEIF cExt == "bmp"
      Aadd(aText, "None")
   ELSEIF cExt == "png"
      Aadd(aText, "PNG")
   ELSEIF cExt == "tif"
      Aadd(aText, "TIFF")
   ELSEIF cExt == "ico"
      Aadd(aText, "Windows ICON - None")
   ENDIF
   Aadd(aText, ltrim(str(nWidth)) + " x " + ltrim(str(nHeight)) + " Pixels")
   Aadd(aText, ltrim(str(aFiles[nItem][2]/1024)) + " KB (" + ltrim(str(aFiles[nItem][2])) + " Bytes)")
   Aadd(aText, ltrim(str(nItem)) + " / " + ltrim(str(Len(aFiles))))
   Aadd(aText, dtoc(aFiles[nItem][3]) + " / " + aFiles[nItem][4])
   Aadd(aText, ltrim(str(int(nLoadTime*1000))) + " milliseconds")

   DEFINE WINDOW Form_Info AT 0,0 ;
      WIDTH 360 HEIGHT 300 ;
      TITLE PROGRAM + " - Image properties" ;
      CHILD ;
      NOSIZE ;
      NOSYSMENU ;
      ON INIT Form_Info.Button_OK.SetFocus ;
      FONT 'MS Sans Serif' ; 
      SIZE 9

      @ 8,8 FRAME Frame_1 ; 
          WIDTH 338 ; 
          HEIGHT 212

      FOR n := 1 TO Len(aLabel)
         cLabel := "Label_" + ltrim(str(n))
         @ (n-1)*24 + 23, 20 LABEL &cLabel ;
            VALUE aLabel[n] ;
            WIDTH 100 HEIGHT 20
      NEXT

      FOR n := 1 TO Len(aText)
         cText := "Text_" + ltrim(str(n))
         @ (n-1)*24 + 21, 134 TEXTBOX &cText ;
            VALUE aText[n] ;
            HEIGHT 20 ;
            WIDTH 200 ;
            READONLY
      NEXT

      @ Form_Info.Height - 68 - IF(IsXPThemeActive(), 4, 0), Form_Info.Width/2 - 50 BUTTON Button_OK ;
         CAPTION "OK" ;
         ACTION Form_Info.Release ;
         WIDTH 96 HEIGHT 32

   END WINDOW

   CENTER WINDOW Form_Info

   ACTIVATE WINDOW Form_Info

Return Nil

Static Function PaintWindow()
Local pps, hDC

   IF handle == Nil
      Return -1
   ENDIF

   InvalidateRect( _HMG_MainHandle, 0 )

   pps := DefinePaintStru()
   hDC := BeginPaint( _HMG_MainHandle, pps )

   FI_WinDraw( handle, hDC, 36, 0, Round( nHeight * nKoef, 0 ) + 36, Round( nWidth * nKoef, 0 ) )

   EndPaint( _HMG_MainHandle, pps )

Return 0

Static Function MsgAbout()
return MsgInfo( padc(PROGRAM + VERSION, 40) + CRLF + ;
	padc("Copyright " + Chr(169) + COPYRIGHT, 40) + CRLF + CRLF + ;
	hb_compiler() + CRLF + version() + CRLF + ;
	Left(MiniGuiVersion(), 36) + CRLF + ;
	"FreeImage.dll version: "+FI_GetVersion() + CRLF + CRLF + ;
	padc("This program is Freeware!", 40), "About..." )

Function FileTime( cFileName )
Local aFiles := Directory( cFileName )

return IF( Len( aFiles ) == 1, aFiles[ 1, 4 ], '' )

Function cFileExt( cPathMask )
Local cExt := AllTrim( cFileNoPath( cPathMask ) )
Local n    := RAt( ".", cExt )

return AllTrim( If( n > 0 .and. Len( cExt ) > n, Right( cExt, Len( cExt ) - n ), "" ) )

Function Putfile ( aFilter, title, cIniFolder, nochangedir, nFilterIndex )
local c:='' , n
 
	IF aFilter == Nil
		aFilter:={}
	EndIf
 
	FOR n := 1 TO Len ( aFilter )
		c += aFilter [n] [1] + chr(0) + aFilter [n] [2] + chr(0)
	NEXT
 
Return C_PutFile ( c, title, cIniFolder, nochangedir, @nFilterIndex )
 

#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400
#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

#define NIL                        (0)  // Nothing...
//  Drawing styles

#define CENTER                      0
#define TILE                        1
#define STRETCH                     2

HB_FUNC ( DRAWPICTURE )
{    
    HWND       hWnd = ( HWND ) hb_parnl( 1 );
    HDC        dc = GetDC( hWnd );
    HANDLE     picture;
    BITMAP     bitmap;
    HDC        bits;
    HANDLE     old;
    
    POINT      size;
    POINT      origin = { NIL,NIL };

    RECT       box;
    int        row;
    int        col;

    int desktopx = GetSystemMetrics (SM_CXSCREEN);
    int desktopy = GetSystemMetrics (SM_CYSCREEN);

    if ((picture = LoadImage (NIL,hb_parc(2),IMAGE_BITMAP,NIL,NIL,LR_LOADFROMFILE)) == NULL) {
        hb_retl (FALSE);
        }

    if ((bits = CreateCompatibleDC (dc)) == NULL) {
        DeleteObject (picture);
        hb_retl (FALSE);
        }

    if ((old = SelectObject (bits,picture)) == NULL) {
        DeleteObject (picture);
        DeleteDC (bits);
        hb_retl (FALSE);
        }
    
    SetMapMode (bits,GetMapMode (dc));
    
    if (!GetObject (picture,sizeof (BITMAP), (LPSTR) &bitmap)) {
        SelectObject (bits,old);
        DeleteObject (picture);
        DeleteDC (bits);
        hb_retl (FALSE);
        }

    size.x = bitmap.bmWidth;
    size.y = bitmap.bmHeight;
    DPtoLP (dc,&size,1);
    
    origin.x = NIL;
    origin.y = NIL;
    DPtoLP (bits,&origin,1);

    switch (hb_parnl(3)) {

        case CENTER :

             box.left = (desktopx - size.x) / 2;
             box.top  = (desktopy - size.y) / 2;

             BitBlt (dc,
                     box.left,
                     box.top,
                     size.x,
                     size.y,
                     bits,
                     origin.x,
                     origin.y,
                     SRCCOPY);
             break;

        case TILE :

             for (row = NIL; row < ((desktopy / size.y) + 1); row++) {

                 for (col = NIL; col < ((desktopx / size.x) + 1); col++) {

                     box.left = col * size.x;
                     box.top = row * size.y;
    
                     BitBlt (dc,
                             box.left,
                             box.top,
                             size.x,
                             size.y,
                             bits,
                             origin.x,
                             origin.y,
                             SRCCOPY);
                     }
                 }
              break;

         case STRETCH :

              StretchBlt (dc,
                          NIL,
                          NIL,
                          desktopx,
                          desktopy,
                          bits,
                          origin.x,
                          origin.y,
                          size.x,
                          size.y,
                          SRCCOPY);
              break;
              }

    SelectObject (bits,old);    
    DeleteDC     (bits);
    DeleteObject (picture);
    ReleaseDC(hWnd, dc);

    hb_retl (TRUE);
}

HB_FUNC ( INVALIDATERECT )
{
   RECT rc;

   if( hb_pcount() > 2 )
   {
      rc.left = hb_parni( 3 );
      rc.top = hb_parni( 4 );
      rc.right = hb_parni( 5 );
      rc.bottom = hb_parni( 6 );
   }

   InvalidateRect(
    (HWND) hb_parnl( 1 ),	// handle of window with changed update region  
    ( hb_pcount() > 2 )? &rc:NULL,	// address of rectangle coordinates 
    hb_parni( 2 )	// erase-background flag 
   );
}

HB_FUNC ( DEFINEPAINTSTRU )
{
   PAINTSTRUCT *pps = (PAINTSTRUCT*) hb_xgrab( sizeof( PAINTSTRUCT ) );
   hb_retnl( (LONG) pps );
}

HB_FUNC ( BEGINPAINT )
{
   PAINTSTRUCT *pps = (PAINTSTRUCT*) hb_parnl( 2 );
   HDC hDC = BeginPaint( (HWND) hb_parnl( 1 ), pps );
   hb_retnl( (LONG) hDC );
}

HB_FUNC ( ENDPAINT )
{
   PAINTSTRUCT *pps = (PAINTSTRUCT*) hb_parnl( 2 );
   EndPaint( (HWND) hb_parnl( 1 ), pps );
   hb_xfree( pps );
}

HB_FUNC ( GETDESKTOPAREA ) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_reta(4);
	hb_storni((INT) rect.top, -1, 1);
	hb_storni((INT) rect.left, -1, 2);
	hb_storni((INT) rect.right - rect.left, -1, 3);
	hb_storni((INT) rect.bottom - rect.top, -1, 4);
}

HB_FUNC ( C_CENTER )
{
	RECT rect;
	int w, h, x, y;
	GetWindowRect((HWND) hb_parnl (1), &rect);
	w  = rect.right  - rect.left;
	h = rect.bottom - rect.top;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );
	x = rect.right - rect.left;
	y = rect.bottom - rect.top;
	SetWindowPos( (HWND) hb_parnl (1), HWND_TOP, (x - w) / 2, (y - h) / 2, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE ) ;
}

HB_FUNC ( C_PUTFILE )
{
    OPENFILENAME ofn;
    char buffer[512];
 
    int flags = OFN_FILEMUSTEXIST | OFN_EXPLORER ;
 
    if ( hb_parl(4) )
    {
        flags = flags | OFN_NOCHANGEDIR ;
    }
 
    strcpy( buffer, "" );
 
    memset( (void*) &ofn, 0, sizeof( OPENFILENAME ) );
    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = GetActiveWindow() ;
    ofn.lpstrFilter = hb_parc(1) ;
    ofn.lpstrFile = buffer;
    ofn.nMaxFile = 512;
    ofn.lpstrInitialDir = hb_parc(3);
    ofn.nFilterIndex    = hb_parni(5);
    ofn.lpstrTitle = hb_parc(2) ;
    ofn.Flags = flags;
 
    if( GetSaveFileName( &ofn ) )
    {
        hb_stornl(ofn.nFilterIndex, 5 );
        hb_retc( ofn.lpstrFile );
    }
    else
    {
        hb_retc( "" );
    }
}
 
#pragma ENDDUMP
