/*
 * MiniGUI Flashing Window Demo
*/

#include "minigui.ch"

#xcommand ON KEY WIN+SPACE [ OF <parent> ] ACTION <action> ;
=> ;
_DefineHotKey ( <"parent"> , MOD_WIN , VK_SPACE , <{action}> )

#define APP_TITLE "Hello World!"

Procedure Main
   Local hWnd

   SET MULTIPLE ON

   hWnd := FindWindow( APP_TITLE )

   IF hWnd > 0

      if IsIconic( hWnd )
         Restore( hWnd )
      else
         SetActiveWindow( hWnd )
         Minimize( hWnd )
         Restore( hWnd )
      endif

   ELSE

	DEFINE WINDOW Win_1 ;
		AT 0,0 ;
		WIDTH 400 ;
		HEIGHT 400 ;
		TITLE APP_TITLE ;
		MAIN ;
		ON MINIMIZE Flashing( NIL, 5, {|| IsIconic( _HMG_MainHandle ) } )

		ON KEY WIN+SPACE ACTION Minimize( FindWindow( APP_TITLE ) )

	END WINDOW

	CENTER WINDOW Win_1
	ACTIVATE WINDOW Win_1

   ENDIF

Return

/*
 *	Flashing( [<hWnd>], [<nBlinks>], [<bWhen>] )
*/
FUNCTION Flashing( hWnd, nBlinks, bWhen )
LOCAL lResult

	DEFAULT hWnd := GetActiveWindow(), nBlinks := 300, bWhen := { || .T. }

	IF ( lResult := Eval( bWhen ) )
		FlashWindow( hWnd, nBlinks, IsWinNT() )
	ENDIF

RETURN lResult


#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400
#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC( ISICONIC )
{
   hb_retl( IsIconic( ( HWND ) hb_parnl( 1 ) ) );
}

HB_FUNC ( FINDWINDOW )
{
   hb_retnl( ( LONG ) FindWindow( 0, hb_parc( 1 ) ) );
}

HB_FUNC( FLASHWINDOW )
{
   FLASHWINFO fi;

   fi.cbSize = sizeof( fi );
   fi.hwnd = (HWND) hb_parnl( 1 );
   fi.uCount = hb_parnl( 2 );
   fi.dwFlags = FLASHW_ALL;
   fi.dwTimeout = hb_parl( 3 ) ? 200 : 0;

   FlashWindowEx( &fi );
}

#pragma ENDDUMP
