/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-05 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
*/

#include "minigui.ch"

Procedure Main()

	DEFINE WINDOW Form_Main ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 480 ;
		TITLE 'Main Window' ;
		MAIN ;
		BACKCOLOR BLUE

	define button Btn_1
		row 290
		col Form_Main.Width - 344
		caption "Switch To Child"
		action IF( IsWindowDefined(Form_Child), SwitchToThisWindow( GetFormHandle( "Form_Child" ), 1 ), )
		default .t.
	end button

	define button Btn_2
		row 290
		col Form_Main.Width - 234
		caption "Cancel"
		action Form_Main.Release()
	end button

	END WINDOW

	DEFINE WINDOW Form_Child ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 480 ;
		TITLE 'Child Window' ;
		ON INIT IF(IsWinNT(), , Form_Child.Minimize) ;
		ON GOTFOCUS Form_Child.Btn_1.Setfocus ;
		BACKCOLOR GREEN

	DEFINE LABEL Label_1
		ROW 	205
		COL	Form_Main.Width - 294
		VALUE 'Fonts:' 
		WIDTH 48
		HEIGHT 16
		BACKCOLOR GREEN
	END LABEL

	DEFINE COMBOBOX Combo_1
		ROW	200
		COL	Form_Main.Width - 244
		ITEMS GetFonts()
		VALUE 1
		TOOLTIP 'Fonts'
	END COMBOBOX

	define button Btn_1
		row 290
		col Form_Main.Width - 244
		caption "Switch To Main"
		action SwitchToThisWindow( GetFormHandle( "Form_Main" ), 1 )
	end button

	END WINDOW

	CENTER WINDOW Form_Main
	CENTER WINDOW Form_Child

	ACTIVATE WINDOW Form_Child, Form_Main

return

Function GetFonts()
Local aTmp, aFonts := {}, nHandle := GetDC(NIL)

   aTmp := GetFontNames( nHandle )
   ReleaseDC( NIL, nHandle )
   aeval( aTmp, {|e| IF(aScan(aFonts, e) == 0, aAdd(aFonts, e), )} )

return aSort(aFonts)

*-----------------------------------------------------------------------------*
DECLARE DLL_TYPE_BOOL SwitchToThisWindow( DLL_TYPE_LONG hWnd, DLL_TYPE_BOOL lRestore ) ;
	IN USER32.DLL
*-----------------------------------------------------------------------------*

#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400
#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

static far int nFontIndex = 0;
static far BOOL bGetName = FALSE;

HB_FUNC ( GETDC )
{
   hb_retnl( (ULONG) GetDC( (HWND) hb_parnl(1) ) ) ;
}

HB_FUNC ( RELEASEDC )
{
   hb_retl( ReleaseDC( (HWND) hb_parnl(1), (HDC) hb_parnl(2) ) ) ;
}

// EnumFonts call back routine
#pragma argsused
static int CALLBACK EnumFontsCallBack( LOGFONT FAR *lpLogFont,
    TEXTMETRIC FAR *lpTextMetric, int nFontType, LPARAM lParam )
{
  ++nFontIndex;
  if ( bGetName )
    hb_storc( lpLogFont->lfFaceName, -1, nFontIndex );
  return 1;
}

// GetFontNames: Count and return an unsorted array of font names
HB_FUNC ( GETFONTNAMES )
{

  FONTENUMPROC lpEnumFontsCallBack = ( FONTENUMPROC )
      MakeProcInstance( ( FARPROC ) EnumFontsCallBack, GetModuleHandle( 0 ) );

  // Get the number of fonts
  nFontIndex = 0;
  bGetName = FALSE;
  EnumFonts( ( HDC ) hb_parnl( 1 ), NULL, lpEnumFontsCallBack, NULL );

  // Get the font names
  hb_reta( nFontIndex );
  nFontIndex = 0;
  bGetName = TRUE;
  EnumFonts( ( HDC ) hb_parnl( 1 ), NULL, lpEnumFontsCallBack, NULL );

}

#pragma ENDDUMP