/*
 * MiniGUI GetPassword Demo
 * Author: P.Chornyj <myorg63@mail.ru>
*/

#include "minigui.ch"

Procedure Main
Local cTargetName := "DOMAIN"
Local cUserName := "username"
Local cPassword := "mypassword"
Local lSave := .t.
Local nFlags := 0

	DEFINE WINDOW Win_1 ;
		AT 0,0 ;
		WIDTH 400 ;
		HEIGHT 400 ;
		TITLE 'Hello World!' ;
		MAIN ;
		ON INIT OnInit()
	
		DEFINE MAIN MENU
			DEFINE POPUP 'Test'
				MENUITEM 'Get Password' ACTION GetPassword( , "My Message", "My Caption", , cTargetName, @cUserName, @cPassword, lSave, nFlags )
				MENUITEM 'Get Password with User Logo' ACTION GetPassword( 0, "My Message", "My Caption", LoadBitmap("LOGO"), cTargetName, @cUserName, @cPassword, lSave, nFlags )
			END POPUP
		END MENU

	END WINDOW

	ACTIVATE WINDOW Win_1

Return


PROCEDURE OnInit

	IF !IsWinNT()
		MsgStop( 'This Program Runs In Win2000/XP Only!', 'Stop' )
		ReleaseAllWindows()
	ENDIF

RETURN


#define NO_ERROR			0 

#define ERROR_CANCELLED			1223 
#define ERROR_INVALID_FLAGS		1004 
#define ERROR_NO_SUCH_LOGON_SESSION	1312 

Function GetPassword( hWnd, cMessage, cCaption, hBitmap, cTargetName, cUserName, cPassword, lSave, nFlags )
Local pCredUI_Info 
Local cMsg := ""
Local nResult

	Default hWnd := GetActiveWindow(), hBitmap := 0

	pCredUI_Info := CredUI_Info( hWnd, cMessage, cCaption, hBitmap )

	nResult := CredUIPrompt( pCredUI_Info, cTargetName, 0, @cUserName, @cPassword, lSave, nFlags ) 

	if nResult == NO_ERROR
		cMsg := "User : " + cUserName + CRLF + ;
			"Password : " + cPassword
	elseif nResult == ERROR_CANCELLED
		cMsg := "User selected 'Cancel'." 
	elseif nResult == ERROR_INVALID_FLAGS
		cMsg := "ERROR_INVALID_FLAGS - take a look for documentation"
	elseif nResult == ERROR_INVALID_PARAMETER 
		cMsg := "ERROR_INVALID_PARAMETER - take a look for documentation"
	elseif nResult == ERROR_NO_SUCH_LOGON_SESSION 
		cMsg := "ERROR_NO_SUCH_LOGON_SESSION - take a look for documentation"
	else //-1000 
		cMsg := "Cannot load credui.dll"
	endif

	pCredUI_Info := Nil 

	MsgInfo(cMsg, "Result")

Return nResult


#pragma BEGINDUMP

#include <windows.h> 
#include "hbapi.h" 

#define CREDUI_MAX_CAPTION_LENGTH 128 
#define CREDUI_MAX_MESSAGE_LENGTH 32767 

#define CREDUI_MAX_PASSWORD_LENGTH 256 
#define CREDUI_MAX_USERNAME_LENGTH 513 

typedef struct _CREDUI_INFO 
{ 
	DWORD cbSize; 
	HWND hwndParent; 
	PCTSTR pszMessageText; 
	PCTSTR pszCaptionText; 
	HBITMAP hbmBanner; 
} CREDUI_INFO, *PCREDUI_INFO; 

typedef DWORD (CALLBACK* CredUIPromptForCredentials)(PCREDUI_INFO, PCTSTR, void*, DWORD, PCTSTR, ULONG, PCTSTR, ULONG, BOOL*, DWORD ); 
static PCREDUI_INFO hb_parCredUI_Info( int iParam ); 

HB_FUNC( CREDUIPROMPT ) 
{ 
	HINSTANCE hDLL = LoadLibrary( "credui.dll" ); 
	LONG lRes = -1000L; 

	if ( hDLL ) 
	{ 
		CredUIPromptForCredentials CredUIPrompt = (CredUIPromptForCredentials) GetProcAddress(hDLL, "CredUIPromptForCredentialsA"); 

		if ( CredUIPrompt != NULL ) 
		{ 
			PCREDUI_INFO pUiInfo = hb_parCredUI_Info( 1 ); 
			LPSTR pszTargetName = hb_parc( 2 ); 
			DWORD dwAuthError = hb_parni( 3 ); 
			LPSTR pszUserName = hb_parcx( 4 ); 
			LPSTR pszPassword = hb_parcx( 5 ); 
			BOOL pfSave = hb_parl( 6 ); 
			DWORD dwFlags = hb_parni( 7 ); 

			char* szUserName = hb_xgrab( CREDUI_MAX_USERNAME_LENGTH + 1 ); 
			char* szPassword = hb_xgrab( CREDUI_MAX_PASSWORD_LENGTH + 1 ); 

			strcpy( szUserName, pszUserName ); 
			strcpy( szPassword, pszPassword ); 

			lRes = CredUIPrompt( pUiInfo, pszTargetName, NULL, dwAuthError, szUserName, CREDUI_MAX_USERNAME_LENGTH, szPassword, CREDUI_MAX_PASSWORD_LENGTH, &pfSave, dwFlags ); 

			hb_storc( szUserName, 4 ); 
			hb_storc( szPassword, 5 ); 

			hb_xfree( szUserName ); 
			hb_xfree( szPassword ); 

			if ( ISBYREF(6) ) 
			{ 
				hb_storl( pfSave, 6 ); 
			} 
		} 

		FreeLibrary( hDLL ); 
	} 

	hb_retnl( lRes ); 
} 

/* 
	destructors, it's executed automatically 
*/ 

static HB_GARBAGE_FUNC( hb_CREDUI_INFO_Destructor ) 
{ 
	PCREDUI_INFO * ppCredUI_Info = (PCREDUI_INFO*) Cargo; 

	if( ppCredUI_Info && *ppCredUI_Info ) 
	{ 
		PCREDUI_INFO pInfo = ( PCREDUI_INFO ) ppCredUI_Info; 

		hb_xfree( (LPSTR) pInfo->pszMessageText ); 
		hb_xfree( (LPSTR) pInfo->pszCaptionText ); 

		if( pInfo->hbmBanner != NULL ) 
		{ 
			DeleteObject( pInfo->hbmBanner ); 
			pInfo->hbmBanner = NULL; 
		} 

		*ppCredUI_Info = NULL; 
	} 
} 

/* 
*/ 
static PCREDUI_INFO hb_parCredUI_Info( int iParam ) 
{ 
	PCREDUI_INFO pCredUI_Info = (PCREDUI_INFO) hb_parptrGC( hb_CREDUI_INFO_Destructor, iParam ); 

	if( pCredUI_Info ) 
	{ 
		return pCredUI_Info; 
	} 
	else 
	{ 
		return NULL; 
	} 
} 

HB_FUNC( CREDUI_INFO ) 
{ 
	CREDUI_INFO CredUI_Info = { 0 }; 
	PCREDUI_INFO pCredUI_Info; 

	CredUI_Info.cbSize = sizeof( CREDUI_INFO ); 
	CredUI_Info.hwndParent = ( HWND ) hb_parnl( 1 ); 
	CredUI_Info.pszMessageText = hb_strndup( hb_parc(2), CREDUI_MAX_MESSAGE_LENGTH - 1); 
	CredUI_Info.pszCaptionText = hb_strndup( hb_parc(3), CREDUI_MAX_CAPTION_LENGTH - 1); 

	//Note: The bitmap size is limited to 320x60 pixels. 
	if( GetObjectType((HGDIOBJ) hb_parnl(4)) == OBJ_BITMAP ) 
	{ 
		CredUI_Info.hbmBanner = ( HBITMAP ) hb_parnl( 4 ); 
	} 

	pCredUI_Info = ( PCREDUI_INFO ) hb_gcAlloc( sizeof(CREDUI_INFO), hb_CREDUI_INFO_Destructor ); 
	*pCredUI_Info = CredUI_Info; 

	hb_retptrGC( (void*) pCredUI_Info );
} 

#pragma ENDDUMP
