/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-08 Grigory Filatov <gfilatov@freemail.ru>
*/
ANNOUNCE RDDSYS

#include "minigui.ch"

#define PROGRAM 'InterNet State Checker'
#define COPYRIGHT ' Grigory Filatov, 2002-2008'
#define TIMER_INFO ': Timer is '

Static lTimer := .t.

*--------------------------------------------------------*
Procedure Main
*--------------------------------------------------------*

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 0 HEIGHT 0 ;
		TITLE PROGRAM ;
		MAIN NOSHOW ;
		ON INIT UpdateNotify() ;
		NOTIFYICON 'ICON_1' ;
		NOTIFYTOOLTIP PROGRAM + TIMER_INFO + IF( lTimer, "On", "Off" ) ;
		ON NOTIFYCLICK ShellAbout( "About " + PROGRAM + "#", PROGRAM + ' version 2.0' + CRLF + Chr(169) + COPYRIGHT, ;
					LoadTrayIcon(GetInstance(), "ICON_1") )

		DEFINE NOTIFY MENU
			ITEM 'Stop/Start Timer'	ACTION UpdateTimer() NAME Timer CHECKED
			ITEM 'OnLine Check'	ACTION UpdateNotify()
			SEPARATOR	
			ITEM 'About...'		ACTION MsgInfo(PROGRAM + ' version 2.0' + CRLF + Chr(169) + COPYRIGHT, ;
								'Built with Harbour and MiniGUI')
			ITEM 'Exit'		ACTION Form_1.Release
		END MENU

		DEFINE TIMER Timer_1 ;
			INTERVAL 5000 ;
			ACTION UpdateNotify()

	END WINDOW

	ACTIVATE WINDOW Form_1

Return

// Flags for InternetGetConnectedState and Ex

#define INTERNET_CONNECTION_MODEM       1
#define INTERNET_CONNECTION_LAN         2
#define INTERNET_CONNECTION_PROXY       4
#define INTERNET_CONNECTION_MODEM_BUSY  8 /* no longer used */
#define INTERNET_RAS_INSTALLED         16
#define INTERNET_CONNECTION_OFFLINE    32
#define INTERNET_CONNECTION_CONFIGURED 64

// Flag for InternetCheckConnection

#define FLAG_ICC_FORCE_CONNECTION       1

*--------------------------------------------------------*
Function IsConnected()
*--------------------------------------------------------*
	local nFlags := 0, lRet := .f.

	if CallDll32( "InternetGetConnectedState", "WININET.DLL", @nFlags, 0 ) == 1

		if CallDll32( "InternetCheckConnection", "WININET.DLL", "http://www.google.com", ;
			FLAG_ICC_FORCE_CONNECTION, 0 ) == 1

			lRet := .t.
		endif

	endif
  
RETURN lRet

*--------------------------------------------------------*
Procedure UpdateNotify()
*--------------------------------------------------------*

	Form_1.NotifyIcon := IF( IsConnected(), "ICON_GREEN", "ICON_RED" )

Return

*--------------------------------------------------------*
Procedure UpdateTimer()
*--------------------------------------------------------*

	lTimer := !lTimer

	Form_1.Timer.Checked := lTimer
	Form_1.Timer_1.Enabled := lTimer

	Form_1.NotifyTooltip := PROGRAM + TIMER_INFO + IF( lTimer, "On", "Off" )

Return
