/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-2005 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Copyright 2003-2005 Janusz Pora <januszpora@onet.eu>
*/

#include "minigui.ch"

Memvar cFileIni
Memvar MRUCount
Memvar aMRU_File
Memvar cMRU_Id
Memvar maxMRU_Files

Memvar mVar

Function Main
    Public cFileIni     := "MRU.ini"

    Public MRUCount     := 0      //Maintains a count of MRUs defined
    Public aMRU_File    := {}
    Public cMRU_Id      := 'IdMRU'
    Public maxMRU_Files := 4

    cFileIni := DISKNAME()+':\'+Curdir()+'\'+cFileIni


	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 480 ;
		TITLE 'MiniGUI MRU Demo (Based Upon a Contribution Of Janusz Pora)' ;
		ICON 'DEMO.ICO' ;
		MAIN ;
		FONT 'Arial' SIZE 10 ;
		ON INIT  MRU_Load()

		DEFINE STATUSBAR
			STATUSITEM '[x] Harbour Power Ready!' 
		END STATUSBAR

		ON KEY CONTROL+O ACTION Get_File_Click()

		DEFINE MAIN MENU 
			POPUP '&File'
				ITEM '&Open'+chr(9)+'Ctrl+O'		ACTION Get_File_Click() IMAGE "Open"
		        	SEPARATOR 
				DEFINE POPUP 'Recent Files' 
					ITEM ' (Empty) '	   	ACTION {|| Nil }  NAME &cMRU_Id
			        END POPUP
				ITEM '&Clear Recent Files' ACTION ClearMRUList( )
				SEPARATOR 
				ITEM 'E&xit'		        ACTION WinEnd_Click()
			END POPUP
			POPUP '&Info'
				ITEM 'About'		ACTION  MsgInfo ("MiniGUI MRU Demo","A COOL Feature ;)") 
			END POPUP
		END MENU


		@ 45,10 RICHEDITBOX Edit_1 ;
			WIDTH 610 ;
		 	HEIGHT 340 ;
			VALUE '' ;
			TOOLTIP 'RichEditBox'

	END WINDOW

	Form_1.IdMRU.Enabled  := .f.

	Form_1.Center

	ACTIVATE WINDOW Form_1

Return Nil

Function WinEnd_Click()
    MRU_unLoad()
    Thiswindow.release 
Return Nil

Function Read_file(cFile)
       
   If ! File( cFile )
	MSGSTOP("File I/O error, cannot proceed")
	RETURN NIL
   ENDIF

   Form_1.Edit_1.Value := MemoRead (cFile)

   if valtype(cMRU_Id) != "U"
	AddMRUItem( cfile )
   endif

Return NIL

Function Get_File_Click()
    LOCAL c_File := GetFile({{'Rich text File','*.rtf'},{'Text File','*.txt'}},'Get File')

    if !empty(c_File)
        Read_file(c_File)
    endif

RETURN NIL

#include "h_MRU.prg"
#include "InsertMenu.prg"
