/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-07 Roberto Lopez <harbourminigui@gmail.com>
 *
 * Copyright 2007 Grigory Filatov <gfilatov@freemail.ru>
*/

ANNOUNCE RDDSYS

#include "minigui.ch"

#define PROGRAM 'SysInfoTray'
#define VERSION ' version 1.01'
#define COPYRIGHT ' 2007 by Grigory Filatov'

#define NTRIM( n ) LTrim( Str( n ) )

#define GFSR_SYSTEMRESOURCES	0
#define GFSR_GDIRESOURCES	1
#define GFSR_USERRESOURCES	2

#define ICON_1		1001
#define ICON_2		1002
#define ICON_3		1003
#define ICON_4		1004
#define ICON_5		1005
#define ICON_6		1006
#define ICON_7		1007
#define ICON_8		1008
#define ICON_9		1009
#define ICON_10		1010
#define ICON_11		1011
#define ICON_12		1012

Static oReg, nTotalMem, cCfgFile, nShow

DECLARE WINDOW Form_1

Function Main()
Local lWinNT := IsWinNT()

	SET MULTIPLE OFF

	SET MENUSTYLE EXTENDED

	SetMenuTheme()

	SET EVENTS FUNCTION TO MYEVENTS

	nTotalMem := MemoryStatus(1) + 1
	cCfgFile := GetStartUpFolder() + "\SysInfoTray.ini"
	nShow := IF( lWinNT, 4, 1 )
	oReg := InitCpu()

	IF .not. lWinNT .and. FILE(cCfgFile)
		BEGIN INI FILE cCfgFile
			GET nShow SECTION "Data" ENTRY "Show" DEFAULT nShow
		END INI
	ENDIF

	DEFINE WINDOW Form_1 						;
		AT 0,0 							;
		WIDTH 0 HEIGHT 0 					;
		TITLE PROGRAM 						;
		MAIN NOSHOW 						;
		ON INIT UpdateNotify() 					;
		ON RELEASE ( EndCpu(), IF( lWinNT, , SaveParam() ) ) 	;
		NOTIFYICON 'MAIN' 					;
		NOTIFYTOOLTIP PROGRAM 					;
		ON NOTIFYCLICK IF( lWinNT, , ShowFreeResources() )

		DEFINE NOTIFY MENU 
			ITEM 'GDI Resources'	 ACTION {|| nShow := 1, ;
				Form_1.Sys.Checked := .F., ;
				Form_1.User.Checked := .F., ;
				Form_1.CPU.Checked := .F., ;
				Form_1.GDI.Checked := .T., UpdateNotify() } ;
				NAME GDI CHECKMARK "CHECK"
			ITEM 'System Resources'	 ACTION {|| nShow := 2, ;
				Form_1.User.Checked := .F., ;
				Form_1.CPU.Checked := .F., ;
				Form_1.GDI.Checked := .F., ;
				Form_1.Sys.Checked := .T., UpdateNotify() } ;
				NAME Sys CHECKMARK "CHECK"
			ITEM 'User Resources'	 ACTION {|| nShow := 3, ;
				Form_1.GDI.Checked := .F., ;
				Form_1.CPU.Checked := .F., ;
				Form_1.Sys.Checked := .F., ;
				Form_1.User.Checked := .T., UpdateNotify() } ;
				NAME User CHECKMARK "CHECK"
			ITEM 'CPU Usage'	 ACTION {|| nShow := 4, ;
				Form_1.Sys.Checked := .F., ;
				Form_1.User.Checked := .F., ;
				Form_1.GDI.Checked := .F., ;
				Form_1.CPU.Checked := .T., UpdateNotify() } ;
				NAME CPU CHECKMARK "CHECK"
			SEPARATOR	
			ITEM 'About...'		ACTION ShellAbout( "About " + PROGRAM + "#", PROGRAM + VERSION + CRLF + ;
				Chr(169) + COPYRIGHT, LoadTrayIcon(GetInstance(), "MAIN") ) IMAGE "INFO"
			SEPARATOR	
			ITEM 'Exit'		ACTION Form_1.Release IMAGE "EXIT"
		END MENU

		IF lWinNT == .T.
			Form_1.Sys.Enabled := .F.
			Form_1.User.Enabled := .F.
			Form_1.GDI.Enabled := .F.
		ENDIF
		IF nShow == 1
			Form_1.GDI.Checked := .T.
		ELSEIF nShow == 2
			Form_1.Sys.Checked := .T.
		ELSEIF nShow == 3
			Form_1.User.Checked := .T.
		ELSE
			Form_1.CPU.Checked := .T.
		ENDIF

		DEFINE TIMER Timer_1 ;
			INTERVAL IF(lWinNT, 1, 2) * 1000 ;
			ACTION UpdateNotify()

	END WINDOW

	ACTIVATE WINDOW Form_1

Return Nil

*--------------------------------------------------------*
Static Procedure SaveParam()
*--------------------------------------------------------*
   BEGIN INI FILE cCfgFile
	SET SECTION "Data" ENTRY "Show" TO nShow
   END INI

Return

*--------------------------------------------------------*
Static Procedure UpdateNotify()
*--------------------------------------------------------*
Local nUsage := IF( _HMG_IsXP, GetCPUUsageNT(), CpuUsage() )
Local nFreeMem := MemoryStatus(2)
Local iSystem := GetFreeSystemResources(GFSR_SYSTEMRESOURCES)
Local iGDI := GetFreeSystemResources(GFSR_GDIRESOURCES)
Local iUser := GetFreeSystemResources(GFSR_USERRESOURCES)

	iSystem := IFNUMBER(iSystem, iSystem, 0)
	iGDI := IFNUMBER(iGDI, iGDI, 0)
	iUser := IFNUMBER(iUser, iUser, 0)

	Form_1.NotifyTooltip := MemoryTooltip( nUsage, ;
		( nTotalMem - nFreeMem ) / nTotalMem * 100, nFreeMem )

	nUsage := IF(nShow == 1, iGDI, IF(nShow == 2, iSystem, IF(nShow == 3, iUser, nUsage)))
	Form_1.NotifyIcon := IconMeter( nUsage )

Return

*--------------------------------------------------------*
Static Function IconMeter( nUsed )
*--------------------------------------------------------*

Return IF( nUsed > 96, ICON_12, ;
       IF( nUsed > 87, ICON_11, ;
       IF( nUsed > 78, ICON_10, ;
       IF( nUsed > 69, ICON_9, ;
       IF( nUsed > 60, ICON_8, ;
       IF( nUsed > 51, ICON_7, ;
       IF( nUsed > 42, ICON_6, ;
       IF( nUsed > 33, ICON_5, ;
       IF( nUsed > 24, ICON_4, ;
       IF( nUsed > 15, ICON_3, ;
       IF( nUsed > 6, ICON_2, ;
		ICON_1 ) ) ) ) ) ) ) ) ) ) )

*--------------------------------------------------------*
Static Function MemoryTooltip( nUsage, nLoad, nFree )
*--------------------------------------------------------*

Return 'CPU Usage=' + Ltrim(Transform(nUsage, "999")) + ;
       '% Memory load=' + Ltrim(Transform(nLoad, "999")) + ;
       '% (' + Ltrim(Transform(nFree, "9999")) + ' MB Free)'

*--------------------------------------------------------*
Static Procedure ShowFreeResources()
*--------------------------------------------------------*
Local iSystem := GetFreeSystemResources(GFSR_SYSTEMRESOURCES)
Local iGDI := GetFreeSystemResources(GFSR_GDIRESOURCES)
Local iUser := GetFreeSystemResources(GFSR_USERRESOURCES)

IF ISNUMBER(iSystem) .and. ISNUMBER(iGDI) .and. ISNUMBER(iUser)
	MsgInfo( "Free GDI Resources: " + Chr(9) + NTRIM(iGDI) + "%" + CRLF + CRLF + ;
		"Free System Resources: " + Chr(9) + NTRIM(iSystem) + "%" + CRLF + CRLF + ;
		"Free User Resources: " + Chr(9) + NTRIM(iUser) + "%", , , .f. )
ELSE
	MsgStop( "Can not detect the Free System Resources!", , , .f. )
ENDIF

Return

*--------------------------------------------------------*
Static Procedure SetMenuTheme()
*--------------------------------------------------------*
Local aColors := GetMenuColors()

	SET MENUCURSOR FULL

	SET MENUSEPARATOR SINGLE RIGHTALIGN

	SET MENUITEM BORDER 3DSTYLE

	aColors[ MNUCLR_MENUITEMTEXT ]        := RGB(   0,   0,   0 ) 
	aColors[ MNUCLR_MENUITEMSELECTEDTEXT ]:= RGB(   0,   0,   0 )

	aColors[ MNUCLR_MENUITEMBACKGROUND1 ] := RGB( 248, 248, 248 )
	aColors[ MNUCLR_MENUITEMBACKGROUND2 ] := RGB( 248, 248, 248 )

	aColors[ MNUCLR_MENUITEMSELECTEDBACKGROUND1 ] := RGB( 255, 240, 192 )
	aColors[ MNUCLR_MENUITEMSELECTEDBACKGROUND2 ] := RGB( 255, 240, 192 )

	aColors[ MNUCLR_IMAGEBACKGROUND1 ] := RGB( 192, 216, 248 )
	aColors[ MNUCLR_IMAGEBACKGROUND2 ] := RGB( 128, 168, 220 )

	aColors[ MNUCLR_SEPARATOR1 ] := RGB( 104, 140, 200 )

	SetMenuColors( aColors )

Return

#define WM_TASKBAR	WM_USER+1043
#define ID_TASKBAR	0
#define WM_MOUSEMOVE	512
#define WM_LBUTTONDOWN	513
#define WM_RBUTTONDOWN	516
*--------------------------------------------------------*
FUNCTION MyEvents ( hWnd, nMsg, wParam, lParam )
*--------------------------------------------------------*
LOCAL result := 0, aPos, i

	SWITCH nMsg
	CASE WM_TASKBAR

		If wParam == ID_TASKBAR .and. lParam # WM_MOUSEMOVE

			SWITCH lParam

			CASE WM_LBUTTONDOWN

				i := Ascan ( _HMG_aFormhandles , hWnd )
				If i > 0
					_DoWindowEventProcedure ( _HMG_aFormNotifyIconLeftClick [i] , i )
				Endif
				EXIT

			CASE WM_RBUTTONDOWN

				If _HMG_ShowContextMenus == .T.

					aPos := GetCursorPos()

					i := Ascan ( _HMG_aFormhandles , hWnd )
					If i > 0
						If _HMG_aFormNotifyMenuHandle [i] != 0
							Form_1.Timer_1.Enabled := .F.
							TrackPopupMenu ( _HMG_aFormNotifyMenuHandle [i] , aPos[2] , aPos[1] , hWnd )
							Form_1.Timer_1.Enabled := .T.
						Endif
					Endif

				EndIf

			END
		EndIf
		EXIT
#ifdef __XHARBOUR__
	DEFAULT
#else
	OTHERWISE
#endif
		result := Events( hWnd, nMsg, wParam, lParam )
	END

RETURN result

*--------------------------------------------------------*
Static Function InitCpu()
*--------------------------------------------------------*
Local oReg, uVar

   If !IsWinNT()
      oReg := TReg32():New(HKEY_DYN_DATA,"PerfStats\StartStat")
      uVar := oReg:Get("KERNEL\CPUUsage","")
      oReg:Close()
      oReg := TReg32():New(HKEY_DYN_DATA,"PerfStats\StatData")
   Endif

Return oReg

*--------------------------------------------------------*
Static Function EndCpu()
*--------------------------------------------------------*
Local uVar

   If !IsWinNT()
      oReg:Close()
      oReg := TReg32():New(HKEY_DYN_DATA,"PerfStats\StopStat")
      uVar := oReg:Get("KERNEL\CPUUsage","")
      oReg:Close()
   Endif

Return .T.

*--------------------------------------------------------*
Static Function CpuUsage()
*--------------------------------------------------------*
Local uVar := chr(0)
Local uuVar := chr(0)

   If !IsWinNT()
      uVar := oReg:Get("KERNEL\CPUUsage","00")
   Else
      oReg := TReg32():New(HKEY_LOCAL_MACHINE,;
            "Software\Microsoft\Windows NT\CurrentVersion\Perflib\009")
      uuVar := oReg:Get("Counters","")
      uVar := Str(oReg:Get("% Processor Time",0))
      oReg:Close()
   Endif

Return Asc(uVar)

*--------------------------------------------------------*
DECLARE DLL_TYPE_INT ;
	_MyGetFreeSystemResources32@4( DLL_TYPE_INT ResType ) ;
	IN RSRC32.DLL ;
	ALIAS GetFreeSystemResources
*--------------------------------------------------------*

#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

#include <conio.h>
#include <stdio.h>

#define SystemBasicInformation       0
#define SystemPerformanceInformation 2
#define SystemTimeInformation        3

#define Li2Double(x) ((double)((x).HighPart) * 4.294967296E9 + (double)((x).LowPart))

typedef struct
{
    DWORD   dwUnknown1;
    ULONG   uKeMaximumIncrement;
    ULONG   uPageSize;
    ULONG   uMmNumberOfPhysicalPages;
    ULONG   uMmLowestPhysicalPage;
    ULONG   uMmHighestPhysicalPage;
    ULONG   uAllocationGranularity;
    PVOID   pLowestUserAddress;
    PVOID   pMmHighestUserAddress;
    ULONG   uKeActiveProcessors;
    BYTE    bKeNumberProcessors;
    BYTE    bUnknown2;
    WORD    wUnknown3;
} SYSTEM_BASIC_INFORMATION;

typedef struct
{
    LARGE_INTEGER   liIdleTime;
    DWORD           dwSpare[76];
} SYSTEM_PERFORMANCE_INFORMATION;

typedef struct
{
    LARGE_INTEGER liKeBootTime;
    LARGE_INTEGER liKeSystemTime;
    LARGE_INTEGER liExpTimeZoneBias;
    ULONG         uCurrentTimeZoneId;
    DWORD         dwReserved;
} SYSTEM_TIME_INFORMATION;

typedef LONG (WINAPI *PROCNTQSI)(UINT,PVOID,ULONG,PULONG);

PROCNTQSI NtQuerySystemInformation;


HB_FUNC( GETCPUUSAGENT )
{
    SYSTEM_PERFORMANCE_INFORMATION SysPerfInfo;
    SYSTEM_TIME_INFORMATION        SysTimeInfo;
    SYSTEM_BASIC_INFORMATION       SysBaseInfo;
    double                         dbIdleTime;
    double                         dbSystemTime;
    LONG                           status;
    LARGE_INTEGER                  liOldIdleTime;
    LARGE_INTEGER                  liOldSystemTime;
    int                            i = 0;

    NtQuerySystemInformation = (PROCNTQSI)GetProcAddress(
                                          GetModuleHandle("ntdll"),
                                         "NtQuerySystemInformation" );

    if (!NtQuerySystemInformation)
        hb_retni( 101 );

    // get number of processors in the system
    status = NtQuerySystemInformation(SystemBasicInformation,&SysBaseInfo,sizeof(SysBaseInfo),NULL);
    if (status != NO_ERROR)
        hb_retni( 101 );
    
    while(i < 2)
    {
	i++;

        // get new system time
	    status = NtQuerySystemInformation(SystemTimeInformation,&SysTimeInfo,sizeof(SysTimeInfo),0);
        if (status!=NO_ERROR)
            hb_retni( 101 );

        // get new CPU's idle time
        status = NtQuerySystemInformation(SystemPerformanceInformation,&SysPerfInfo,sizeof(SysPerfInfo),NULL);
        if (status != NO_ERROR)
            hb_retni( 101 );

        // if it's a first call - skip it
       if (liOldIdleTime.QuadPart != 0)
       {
            // CurrentValue = NewValue - OldValue
            dbIdleTime = Li2Double(SysPerfInfo.liIdleTime) - Li2Double(liOldIdleTime);
            dbSystemTime = Li2Double(SysTimeInfo.liKeSystemTime) - Li2Double(liOldSystemTime);

            // CurrentCpuIdle = IdleTime / SystemTime
            dbIdleTime = dbIdleTime / dbSystemTime;

            // CurrentCpuUsage% = 100 - (CurrentCpuIdle * 100) / NumberOfProcessors
            dbIdleTime = 100.0 - dbIdleTime * 100.0 / (double)SysBaseInfo.bKeNumberProcessors + 0.5;
       }

        // store new CPU's idle and system time
        liOldIdleTime = SysPerfInfo.liIdleTime;
        liOldSystemTime = SysTimeInfo.liKeSystemTime;
		
        // wait one second
        Sleep(1000);
    }
    hb_retni( (UINT)dbIdleTime );
}

HB_FUNC (C_SETPICTURE)
{
	HBITMAP hBitmap;

	hBitmap = (HBITMAP)LoadImage(0,hb_parc(2),IMAGE_BITMAP,hb_parni(3),hb_parni(4),LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap==NULL)
	{
		hBitmap = (HBITMAP)LoadImage(GetModuleHandle(NULL),hb_parc(2),IMAGE_BITMAP,hb_parni(3),hb_parni(4),LR_CREATEDIBSECTION);
	}

	SendMessage((HWND) hb_parnl (1),(UINT)STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBitmap);
}

#pragma ENDDUMP