/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-2007 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
*/

#include "minigui.ch"

PROCEDURE Main

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 400 ;
		HEIGHT 200 ;
		TITLE 'Transparency Sample By Grigory Filatov' ;
		MAIN

		DEFINE BUTTON Button_1
			ROW	10
			COL	10
			CAPTION 'Set Transparency ON'
			WIDTH	140
			ACTION	( Form_1.Slider_1.Value := 70, Slider_Change() )
			DEFAULT .T.
		END BUTTON

		DEFINE BUTTON Button_2
			ROW	40
			COL	10
			WIDTH	140
			CAPTION 'Set Transparency OFF'
			ACTION ( Form_1.Slider_1.Value := 100, Form_1.TextBox_1.Value := "100 %", ;
				RemoveTransparency( _HMG_MainHandle ) )
		END BUTTON

		DEFINE SLIDER Slider_1
			ROW	80
			COL	10
			VALUE	100
			WIDTH	310
			HEIGHT	50
			RANGEMIN 0
			RANGEMAX 100
			ON SCROLL Slider_Change()
			ON CHANGE Slider_Change()
		END SLIDER

		DEFINE TEXTBOX TextBox_1
			ROW	85
			COL	330
			VALUE	"100 %"
			WIDTH	50
			MAXLENGTH 5
		END TEXTBOX

	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return

Function Slider_Change
	Local nValue := Form_1.Slider_1.Value

	Form_1.TextBox_1.Value := Str(nValue, 3) + " %"

	If .not. SetTransparency( _HMG_MainHandle, (255 * nValue) / 100 )
		MsgStop( "This Sample Runs In Win2000/XP Only!", "Error" )
	EndIf

Return Nil

#define GWL_EXSTYLE	(-20)

#define WS_EX_LAYERED   524288
#define LWA_COLORKEY    1
#define LWA_ALPHA       2

/*
*/
FUNCTION SetTransparency( hWnd, nAlpha )
	LOCAL nRet, lRet := .F.

	IF nAlpha < 0
		nAlpha := 0
	ELSEIF nAlpha > 255
		nAlpha := 255
	ENDIF

	SetWindowLong( hWnd, GWL_EXSTYLE,  HB_BITOR( GetWindowLong( hWnd, GWL_EXSTYLE ), WS_EX_LAYERED ) )

	nRet := SetLayeredWindowAttributes( hWnd, 0, nAlpha, LWA_ALPHA )
	IF VALTYPE(nRet) == 'N'
		lRet := ( nRet > 0 )
	ENDIF

RETURN( lRet )

/*
*/
PROCEDURE RemoveTransparency( hWnd )

	SetWindowLong(hWnd, GWL_EXSTYLE, HB_BITAND( GetWindowLong( hWnd, GWL_EXSTYLE ), HB_BITNOT(WS_EX_LAYERED) ) )

	RedrawWindow( hWnd )

RETURN

/*
   SetLayeredWindowAttributes WRAPPER.
   The SetLayeredWindowAttributes function sets the opacity and transparency color key of a layered window.
   Parameters:
   - hwnd	Handle to the layered window.
   - crKey	Pointer to a COLORREF value that specifies the transparency color key to be used.
		(When making a certain color transparent...).
   - bAlpha	Alpha value used to describe the opacity of the layered window.
		0 = Invisible, 255 = Fully visible
   - dwFlags	Specifies an action to take. This parameter can be LWA_COLORKEY
		(When making a certain color transparent...) or LWA_ALPHA.
*/
DECLARE DLL_TYPE_BOOL SetLayeredWindowAttributes( ;
	DLL_TYPE_LONG hWnd, DLL_TYPE_INT crKey, DLL_TYPE_UINT bAlpha, DLL_TYPE_DWORD dwFlags ) ;
	IN USER32.DLL
