/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-2007 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
*/

#include "minigui.ch"

PROCEDURE Main

DEFINE WINDOW Form_1 ; 
	AT 0, 0 ; 
	WIDTH 450 ; 
	HEIGHT 350 ; 
	TITLE 'Transparency Color Sample' ; 
	MAIN 

	DEFINE LISTBOX ListBox_1 
		ROW 0 
		COL 1 
		WIDTH 440 
		HEIGHT 160 
		ITEMS { ' - 01 -' , ' - 02 -' , ' - 03 -' } 
		BACKCOLOR BLACK
		FONTCOLOR GREEN
		FONTBOLD .T. 
		VALUE 2 
	END LISTBOX 

	DEFINE BUTTONEX Button_1 
		ROW 220 
		COL 170 
		WIDTH 250 
		HEIGHT 28 
		CAPTION "Set Black Color Transparency ON" 
		ACTION SetColorTransparency (_HMG_MainHandle, 0) 
		FONTCOLOR BLUE
		FLAT .T. 
	END BUTTONEX

	DEFINE BUTTONEX Button_2 
		ROW 260 
		COL 170 
		WIDTH 250 
		HEIGHT 28 
		CAPTION "Set Black Color Transparency OFF" 
		ACTION SetTransparency (_HMG_MainHandle, 255) 
		FONTCOLOR BLUE
		FLAT .T. 
	END BUTTONEX

END WINDOW 

CENTER WINDOW Form_1 
ACTIVATE WINDOW Form_1 

RETURN


#define GWL_EXSTYLE (-20) 

#define WS_EX_LAYERED 524288 
#define LWA_COLORKEY 1 
#define LWA_ALPHA 2 

/* 
*/ 
FUNCTION SetTransparency( hWnd, nAlpha ) 
LOCAL nRet, lRet := .F. 

IF nAlpha < 0 
	nAlpha := 0 
ELSEIF nAlpha > 255 
	nAlpha := 255 
ENDIF 

SetWindowLong( hWnd, GWL_EXSTYLE, HB_BITOR( GetWindowLong( hWnd, GWL_EXSTYLE ), WS_EX_LAYERED ) ) 

nRet := SetLayeredWindowAttributes( hWnd, 0, nAlpha, LWA_ALPHA ) 
IF VALTYPE(nRet) == 'N' 
	lRet := ( nRet > 0 ) 
ENDIF 

RETURN( lRet ) 

/* 
*/ 
FUNCTION SetColorTransparency( hWnd, nColor ) 
LOCAL nRet, lRet := .F. 

SetWindowLong( hWnd, GWL_EXSTYLE, HB_BITOR( GetWindowLong( hWnd, GWL_EXSTYLE ), WS_EX_LAYERED ) ) 

nRet := SetLayeredWindowAttributes( hWnd, nColor, 0, LWA_COLORKEY ) 
IF VALTYPE(nRet) == 'N' 
	lRet := ( nRet > 0 ) 
ENDIF 

RETURN( lRet ) 

/* 
	SetLayeredWindowAttributes WRAPPER. 
	The SetLayeredWindowAttributes function sets the opacity and transparency color key of a layered window. 
	Parameters: 
	- hWnd		Handle to the layered window. 
	- crKey		Pointer to a COLORREF value that specifies the transparency color key to be used. 
			(When making a certain color transparent...). 
	- bAlpha	Alpha value used to describe the opacity of the layered window. 
			0 = Invisible, 255 = Fully visible 
	- dwFlags	Specifies an action to take. This parameter can be LWA_COLORKEY 
			(When making a certain color transparent...) or LWA_ALPHA. 
*/ 
DECLARE DLL_TYPE_BOOL SetLayeredWindowAttributes( ; 
	DLL_TYPE_LONG hWnd, DLL_TYPE_INT crKey, DLL_TYPE_UINT bAlpha, DLL_TYPE_DWORD dwFlags ) ; 
	IN USER32.DLL 
