/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-05 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Copyright 2005 Grigory Filatov <gfilatov@freemail.ru>
*/

ANNOUNCE RDDSYS

#include "minigui.ch"

#define PROGRAM 'ClipbrdClear'
#define VERSION ' version 1.0'
#define COPYRIGHT ' Grigory Filatov, 2005'

#define MsgAlert( c ) MsgExclamation( c, "Error" )

#define CF_MAXCOUNT 14

Static lClipbrdFull := .F.

*--------------------------------------------------------*
Procedure Main( ... )
*--------------------------------------------------------*
Local aPar, i, lClear := .F., lExit := .F.

	SET MULTIPLE OFF WARNING

	IF PCOUNT() > 0

		aPar := HB_aParams()

		For i := 1 To Len(aPar)
			IF valtype(aPar[i])=="C"
				IF Upper(aPar[i]) == "/CLEAR"
					lClear := .T.
					EXIT
				ENDIF
			ENDIF
		Next

		IF lClear
			For i := 1 To Len(aPar)
				IF valtype(aPar[i])=="C"
					IF Upper(aPar[i]) == "/EXIT"
						lExit := .T.
						EXIT
					ENDIF
				ENDIF
			Next
		ENDIF

	ENDIF

	lClipbrdFull := IsClipbrdFull()

	IF lClear
		ClipClear()
		PlayOK()
	ENDIF

	IF !lExit

		DEFINE WINDOW Form_1 ;
			AT 0,0 ;
			WIDTH 0 HEIGHT 0 ;
			TITLE PROGRAM ;
			MAIN NOSHOW ;
			NOTIFYICON IF(lClipbrdFull, "ICON_1", "ICON_2") ;
			NOTIFYTOOLTIP PROGRAM ;
			ON NOTIFYCLICK ClipClear()
		
			DEFINE NOTIFY MENU
				ITEM '&Clipboard Viewer'	ACTION _Execute( _HMG_MainHandle, "open", "CLIPBRD.EXE" )

				SEPARATOR

				ITEM '&About...'		ACTION ShellAbout( "", ;
					PROGRAM + VERSION + CRLF + ;
					"Copyright " + Chr(169) + COPYRIGHT, LoadMainIcon(GetInstance(), "ICON_2") )
				SEPARATOR

				ITEM 'E&xit'			ACTION Form_1.Release
			END MENU

		DEFINE TIMER Timer_1 	;
			INTERVAL 750	;
			ACTION ( lClipbrdFull := IsClipbrdFull(), Form_1.NotifyIcon := IF(lClipbrdFull, "ICON_1", "ICON_2") )

		END WINDOW

		ACTIVATE WINDOW Form_1

	ENDIF

Return

*--------------------------------------------------------*
Procedure ClipClear()
*--------------------------------------------------------*

	IF lClipbrdFull .AND. OpenClipboard( _HMG_MainHandle )

		IF .NOT. EmptyClipboard()
			MsgAlert( "The clipboard is not available now!" )
		ENDIF

		CloseClipboard()

	ENDIF

Return

*--------------------------------------------------------*
Function IsClipbrdFull()
*--------------------------------------------------------*
Local i, lRet := .F.

	For i := 1 To CF_MAXCOUNT
		If IsClipboardFormatAvailable( i )
			lRet := .T.
			EXIT
		EndIf
	Next

Return lRet


#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC( ISCLIPBOARDFORMATAVAILABLE )
{
   hb_retl( IsClipboardFormatAvailable( hb_parni(1) ) );
}

HB_FUNC( OPENCLIPBOARD )
{
   hb_retl( OpenClipboard( (HWND) hb_parnl(1) ) ) ;
}

HB_FUNC( CLOSECLIPBOARD )
{
   hb_retl( CloseClipboard() );
}

HB_FUNC( EMPTYCLIPBOARD )
{
   hb_retl( EmptyClipboard() ) ;
}

HB_FUNC( LOADTRAYICON )
{
	HICON himage;
	HINSTANCE hInstance  = (HINSTANCE) hb_parnl(1);  // handle to application instance
	LPCTSTR   lpIconName = (LPCTSTR)   hb_parc(2);   // name string or resource identifier

	himage = (HICON) LoadImage( hInstance,  lpIconName, IMAGE_ICON, 16, 16, LR_SHARED ) ;

	if (himage==NULL)
	{
		himage = (HICON) LoadImage( hInstance, lpIconName, IMAGE_ICON, 16, 16, LR_LOADFROMFILE + LR_DEFAULTSIZE ) ;
	}

	hb_retnl( (LONG) himage );
}

HB_FUNC( LOADMAINICON )
{
	HICON himage;
	HINSTANCE hInstance  = (HINSTANCE) hb_parnl(1);  // handle to application instance
	LPCTSTR   lpIconName = (LPCTSTR)   hb_parc(2);   // name string or resource identifier

	himage = (HICON) LoadImage( hInstance, lpIconName, IMAGE_ICON, 0, 0, LR_DEFAULTSIZE ) ;

	if (himage==NULL)
	{
		himage = (HICON) LoadImage( hInstance, lpIconName, IMAGE_ICON, 0, 0, LR_LOADFROMFILE + LR_DEFAULTSIZE ) ;
	}

	hb_retnl( (LONG) himage );
}

HB_FUNC( INITIMAGE )
{
	HWND  h;
	HBITMAP hBitmap;
	HWND hwnd;
	int Style;

	hwnd = (HWND) hb_parnl(1);

	Style = WS_CHILD | SS_BITMAP | SS_NOTIFY ;

	if ( ! hb_parl (8) )
	{
		Style = Style | WS_VISIBLE ;
	}

	h = CreateWindowEx( 0, "static", NULL, Style,
		hb_parni(3), hb_parni(4), 0, 0,
		hwnd, (HMENU) hb_parni(2), GetModuleHandle(NULL), NULL ) ;

	hBitmap = (HBITMAP) LoadImage(0,hb_parc(5),IMAGE_BITMAP,hb_parni(6),hb_parni(7),LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap==NULL)
	{
		hBitmap = (HBITMAP) LoadImage(GetModuleHandle(NULL),hb_parc(5),IMAGE_BITMAP,hb_parni(6),hb_parni(7),LR_CREATEDIBSECTION);
	}

	SendMessage( h, (UINT) STM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) hBitmap );

	hb_retnl( (LONG) h );
}

HB_FUNC( C_SETPICTURE )
{
	HBITMAP hBitmap;

	hBitmap = (HBITMAP) LoadImage(0,hb_parc(2),IMAGE_BITMAP,hb_parni(3),hb_parni(4),LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap==NULL)
	{
		hBitmap = (HBITMAP) LoadImage(GetModuleHandle(NULL),hb_parc(2),IMAGE_BITMAP,hb_parni(3),hb_parni(4),LR_CREATEDIBSECTION);
	}

	SendMessage( (HWND) hb_parnl (1), (UINT) STM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) hBitmap );

	hb_retnl( (LONG) hBitmap );
}

#pragma ENDDUMP
