#define __SYSDATA__
#include "minigui.ch"
#include "directry.ch"

*-----------------------------------------------------------------------------*
Function InputBox ( cInputPrompt , cDialogCaption , cDefaultValue , nTimeout , cTimeoutValue , lMultiLine )
*-----------------------------------------------------------------------------*

	Local RetVal , mo

	DEFAULT cInputPrompt		TO ""
	DEFAULT cDialogCaption	TO ""
	DEFAULT cDefaultValue	TO ""

	RetVal := ''

	If ValType (lMultiLine) != 'U'
		If lMultiLine == .T.
			mo := 150
		Else
			mo := 0
		EndIf
	Else
		mo := 0
	EndIf

	DEFINE WINDOW _InputBox 		;
		AT 0,0 				;
		WIDTH 350 			;
		HEIGHT 115 + mo	+ GetTitleHeight() ;
		TITLE cDialogCaption  		;
		ICON 'CHILD'			;
		MODAL 				;
		NOSIZE 				;
		FONT 'MS Sans Serif'			;
		SIZE 8

		ON KEY ESCAPE ACTION ( _HMG_DialogCancelled := .T. , _InputBox.Release )

		@ 10,10 LABEL _Label		;
			VALUE cInputPrompt	;
			WIDTH 280 

                If ValType (lMultiLine) != 'U' .and. lMultiLine == .T.
			@ 16,10 EDITBOX _TextBox	;
				VALUE cDefaultValue	;
				HEIGHT 40 + mo		;
				WIDTH 320		
                else
			@ 32,10 TEXTBOX _TextBox	;
				VALUE cDefaultValue	;
				HEIGHT 24 + mo		;
				WIDTH 320		;
				BOLD ;
				ON ENTER ( _HMG_DialogCancelled := .F. , RetVal := _InputBox._TextBox.Value , _InputBox.Release )

                endif

		@ 70+mo,150 BUTTON _Ok		;
			CAPTION if( Set ( _SET_LANGUAGE ) == 'ES', 'Aceptar' ,'Ok' )		;
			HEIGHT 26		;
			WIDTH 80		;
			ACTION ( _HMG_DialogCancelled := .F. , RetVal := _InputBox._TextBox.Value , _InputBox.Release ) 

		@ 70+mo,250 BUTTON _Cancel		;
			CAPTION if( Set ( _SET_LANGUAGE ) == 'ES', 'Cancelar', 'Cancel'	);
			HEIGHT 26		;
			WIDTH 80		;
			ACTION   ( _HMG_DialogCancelled := .T. , _InputBox.Release )

			If ValType (nTimeout) != 'U'

				If ValType (cTimeoutValue) != 'U'

					DEFINE TIMER _InputBox ;
					INTERVAL nTimeout ;
					ACTION  ( RetVal := cTimeoutValue , _InputBox.Release ) 

				Else

					DEFINE TIMER _InputBox ;
					INTERVAL nTimeout ;
					ACTION _InputBox.Release

				EndIf
	
			EndIf

	END WINDOW

	_InputBox._TextBox.SetFocus 

	CENTER WINDOW _InputBox

	ACTIVATE WINDOW _InputBox	

Return ( RetVal )

*--------------------------------------------------------*
Function GetFonts()
*--------------------------------------------------------*
   Local aTmp, aFonts := {}, nHandle := GetDC(NIL)

   aTmp := GetFontNames( nHandle )
   ReleaseDC( NIL, nHandle )
   aEval( aTmp, {|e| IF(aScan(aFonts, e) == 0 .AND. ;
	!"WST_" $ e .AND. !"Chess" $ e .AND. !"Math" $ e, aAdd(aFonts, e), )} )

return aSort( aFonts )

*--------------------------------------------------------*
Function FileTime( cFileName )
*--------------------------------------------------------*
Local aFiles := Directory( cFileName )

return IF( Len( aFiles ) == 1, aFiles[ 1, F_TIME ], '' )

*--------------------------------------------------------*
Static Procedure SaveParameter(cSection, cEntry, uValue)
*--------------------------------------------------------*
	SET DECIMALS TO
	BEGIN INI FILE cFileIni
		SET SECTION cSection ENTRY cEntry TO uValue
	END INI
	SET DECIMALS TO 2
return

*--------------------------------------------------------*
Static Function cFilePath( cPathMask )
*--------------------------------------------------------*
   LOCAL n := RAt( "\", cPathMask )

return If( n > 0, Upper( Left( cPathMask, n - 1) ), ;
	If( At( ":", cPathMask ) == 2, ;
           Upper( Left( cPathMask, 2 ) ), "" ) )

*--------------------------------------------------------*
Function Putfile( aFilter, title, cIniFolder, nochangedir, nFilterIndex )
*--------------------------------------------------------*
   Local c := '' , n
 
	DEFAULT nochangedir := .F.
 
	FOR n := 1 TO Len ( aFilter )
		c += aFilter [n] [1] + chr(0) + aFilter [n] [2] + chr(0)
	NEXT

Return C_PutFile( c, title, cIniFolder, nochangedir, @nFilterIndex )

*-----------------------------------------------------------------------------*
DECLARE DLL_TYPE_BOOL SwitchToThisWindow( DLL_TYPE_LONG hWnd, DLL_TYPE_BOOL lRestore ) ;
	IN USER32.DLL

*-----------------------------------------------------------------------------*
Function _GetIniSections()
*-----------------------------------------------------------------------------*
    Local cVar :=''
    Local n, aSections := {}

    cVar := GetSectionNames( cFileLng )
    while( asc(cVar) <> 0 .and. (n := at(chr(0), cVar)) > 0 )
        aadd(aSections, left(cVar, n - 1))
        cVar := substr(cVar, n + 1)
    end

Return aSections

*-----------------------------------------------------------------------------*
Function  _BrowseDelete (  ControlName , ParentForm , z  )
*-----------------------------------------------------------------------------*
   Local i , _BrowseRecMap , Value , _Alias , _RecNo , _BrowseArea 

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	If LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) == 0
		Return Nil
	EndIf

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

#ifdef __XHARBOUR__
	Value := _BrowseRecMap [ LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) ]
#else
	Value := _BrowseRecMap [ LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA[137] [i] ) ]
#endif

	If Value == 0
		Return Nil
	EndIf

	_Alias := Alias()
	_BrowseArea := _HMG_aControlSpacing [i]
	If Select (_BrowseArea) == 0
		Return Nil
	EndIf
	Select &_BrowseArea
	_RecNo := RecNo()

	Go Value

	If _HMG_aControlInputMask [i] == .t.
		If Rlock()
			Delete
			Skip
			if eof()
				Go Bottom
			EndIf
			DBunlock()
			If Set ( _SET_DELETED ) == .T.
				_BrowseSetValue( '' , '' , RecNo() , i , LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) )
			EndIf

		Else

			MsgStop('Record is being editied by another user. Retry later','Delete Record')

		EndIf

	Else

		Delete
		Skip
		if eof()
			Go Bottom
		EndIf
		If Set ( _SET_DELETED ) == .T.
			_BrowseSetValue( '' , '' , RecNo() , i , LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) )
		EndIf

	EndIf

	Go _RecNo
	_BrowseRefresh ( '' , '' , i )
	if Select( _Alias ) != 0
		Select &_Alias
	Else
		Select 0
	Endif

Return Nil

*------------------------------------------------------------------------------*
Function _InsertMenuItem ( ItemName , FormName ,caption , action , name , Image )
*------------------------------------------------------------------------------*
Local i , h , x
Local id, mVar, Controlhandle

	x := GetControlIndex ( ItemName , FormName )
	h := _HMG_aControlpageMap [ x ]

	If _HMG_aControlType [ x ] == "MENU"
		i := _HMG_aControlIds [ x ]
	ElseIf _HMG_aControlType [ x ] == "POPUP"
		i := _HMG_aControlSpacing [ x ]
	EndIf

	Id := _GetId()

	if valtype (name) != 'U'

		mVar := '_' + _HMG_xMainMenuParentName + '_' + Name
		Public &mVar. := Len(_HMG_aControlNames) + 1

	Else

		mVar := '_MenuDummyVar'
		Public &mVar. := 0  

	EndIf

	Controlhandle :=  InsertMenuItem ( h , i ,id , caption )

	if Valtype ( image ) != 'U'
		MenuItem_SetBitMaps ( h , Id , image , '' )
	EndIf

	aAdd ( _HMG_aControlType , "MENU" )
	aAdd ( _HMG_aControlNames , Name )
	aAdd ( _HMG_aControlHandles , Controlhandle )
	aAdd ( _HMG_aControlParentHandles , _HMG_xMainMenuParentHandle)
	aAdd ( _HMG_aControlIds , id )
	aAdd ( _HMG_aControlProcedures , action )
	aAdd ( _HMG_aControlPageMap , h  )
	aAdd ( _HMG_aControlValue , Nil )	
	aAdd ( _HMG_aControlInputMask , "" )	
	aAdd ( _HMG_aControllostFocusProcedure , "" )	
	aAdd ( _HMG_aControlGotFocusProcedure , "" )	
	aAdd ( _HMG_aControlChangeProcedure , "" )	
	aAdd ( _HMG_aControlDeleted , .F. )	
	aAdd ( _HMG_aControlBkColor , Nil ) 
	aAdd ( _HMG_aControlFontColor , Nil ) 
	aAdd ( _HMG_aControlDblClick , "" ) 
	aAdd ( _HMG_aControlHeadClick , {} ) 
	aAdd ( _HMG_aControlRow , 0 ) 
	aAdd ( _HMG_aControlCol , 0 ) 
	aAdd ( _HMG_aControlWidth , 0 ) 
	aAdd ( _HMG_aControlHeight , 0 ) 
	aAdd ( _HMG_aControlSpacing , 0 ) 
	aAdd ( _HMG_aControlContainerRow , -1 ) 
	aAdd ( _HMG_aControlContainerCol , -1 ) 
	aAdd ( _HMG_aControlPicture , "" ) 
	aAdd ( _HMG_aControlContainerHandle , 0 ) 
	aAdd ( _HMG_aControlFontName , '' )
	aAdd ( _HMG_aControlFontSize , 0 )
	aAdd ( _HMG_aControlFontAttributes , {.f.,.f.,.f.,.f.} )
	aAdd ( _HMG_aControlToolTip  , ''  )
	aAdd ( _HMG_aControlRangeMin  , 0  )
	aAdd ( _HMG_aControlRangeMax  , 0  )
	aAdd ( _HMG_aControlCaption  , Caption  )
	aAdd ( _HMG_aControlVisible  , .t. )
	aAdd ( _HMG_aControlHelpId  , 0 )
	aAdd ( _HMG_aControlFontHandle  , 0 )
	aAdd ( _HMG_aControlBrushHandle  , 0 )
	aAdd ( _HMG_aControlEnabled  , .T. )
	aAdd ( _HMG_aControlMiscData1 , 0 )

Return Nil

*------------------------------------------------------------------------------*
Function _ModifyMenuItem ( ItemName , FormName ,Caption , action , name , Image )
*------------------------------------------------------------------------------*
Local i , h , x
Local id, mVar, Controlhandle

	x := GetControlIndex ( ItemName , FormName )
	h := _HMG_aControlpageMap [ x ]

	If _HMG_aControlType [ x ] == "MENU"
		i := _HMG_aControlIds [ x ]
	ElseIf _HMG_aControlType [ x ] == "POPUP"
		i := _HMG_aControlSpacing [ x ]
	EndIf


	Id := _HMG_aControlIds [ x ]

	if valtype (name) != 'U'

		mVar := '_' + _HMG_xMainMenuParentName + '_' + Name
		Public &mVar. := x

	Else

		mVar := '_MenuDummyVar'
		Public &mVar. := 0  

	EndIf

	Controlhandle :=  ModifyMenuItem ( h , i ,id ,  Caption  )

	if Valtype ( image ) != 'U'
		MenuItem_SetBitMaps ( h , Id , image , '' )
	EndIf
	_HMG_aControlNames [ x ] := Name 
	_HMG_aControlProcedures [ x ] := action 
	_HMG_aControlHandles [ x ] := Controlhandle 
	_HMG_aControlCaption  [ x ] := Caption  

Return Nil

*------------------------------------------------------------------------------*
Function _RemoveMenuItem ( ItemName , FormName  )
*------------------------------------------------------------------------------*
Local i , h , x

	x := GetControlIndex ( ItemName , FormName )
	h := _HMG_aControlpageMap [ x ]

	If _HMG_aControlType [ x ] == "MENU"
		i := _HMG_aControlIds [ x ]
	ElseIf _HMG_aControlType [ x ] == "POPUP"
		i := _HMG_aControlSpacing [ x ]
	EndIf
	RemoveMenuItem ( h , i )

Return Nil

#define WM_COPYDATA           74
#define CDM_OPENDBF         2000

#define WM_MENUSELECT   287
#define WM_NOTIFY	78

#define MCN_FIRST           -750
#define MCN_LAST            -759
#define MCN_SELCHANGE       (MCN_FIRST + 1)
#define MCN_SELECT          (MCN_FIRST + 4)

#define NM_CLICK	(-2)
#define NM_DBLCLK	(-3)
#define NM_SETFOCUS      -7
#define NM_KILLFOCUS	(-8)

#define LVN_ITEMCHANGED	(-101)
#define LVN_COLUMNCLICK	(-108)
#define LVN_BEGINDRAG	(-109)

#define LVN_GETDISPINFO        (-150)
#define LVN_KEYDOWN	(-155)

#define DTN_FIRST	(-760)
#define DTN_DATETIMECHANGE (DTN_FIRST+1)

#define	TBN_FIRST	(-700)
#define TBN_DROPDOWN	(TBN_FIRST-10)
#define TTN_FIRST               (-520)       // tooltips
#ifdef UNICODE
#define TTN_NEEDTEXT        	(TTN_FIRST - 10)
#else
#define TTN_NEEDTEXT         	(TTN_FIRST - 0)
#endif
#define EN_SELCHANGE		1794

#define MsgYesNo( c, t ) MsgYesNo( c, t, , , .f. )
*------------------------------------------------------------------------------*
function MyEvents ( hWnd, nMsg, wParam, lParam )
*------------------------------------------------------------------------------*
Local i, x, ws, DeltaSelect, r, xs, xd, lvc, aCellData
Local hws, hwm, k, apos, _ThisQueryTemp, ControlCount
Local nCargo, cDbf:=""

	do case

	*(JK)*****************************************************************
	case nMsg == WM_COPYDATA
	**********************************************************************

           cDBF := GetSentMsg( lParam, @nCargo)
           IF !EMPTY(cDbf) .and. nCargo==CDM_OPENDBF .and. FILE(StrTran(cDbf, '"', ""))
              OpenDBF(cDBF)
           ENDIF

	***********************************************************************
	case nMsg == WM_MENUSELECT
	***********************************************************************
	case nMsg == WM_NOTIFY 
	***********************************************************************

		* Process ToolBar ToolTip .....................................

		If GetNotifyCode ( lParam ) = TTN_NEEDTEXT   // for tooltip TOOLBUTTON
			ws := GetNotifyId( lParam)  
			x  := Ascan ( _HMG_aControlIds , ws )
			if ( x > 0 ) .And. _HMG_aControlType [x] = "TOOLBUTTON"
				SetButtonTip ( lParam , _HMG_aControlToolTip [x] )
			endif
		endif

		i := Ascan ( _HMG_aControlHandles , GetHwndFrom (lParam) )

		if i > 0

			* Process Browse .....................................

			if _HMG_aControlType [i] = "BROWSE"
        
				* Browse Click ................................

				If	GetNotifyCode ( lParam ) == NM_CLICK  .or. ;
					GetNotifyCode ( lParam ) == LVN_BEGINDRAG	

					If LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) > 0 
						DeltaSelect := LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) - ascan ( _HMG_aControlRangeMax [i] , _HMG_aControlValue [i] )
						_HMG_aControlValue [i] :=  _HMG_aControlRangeMax [i] [ LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) ]
						_BrowseVscrollFastUpdate ( i , DeltaSelect )
						_BrowseOnChange (i)
					EndIf

					Return 0
					
				EndIf

 				* Browse Refresh On Column Size ..............

				If	GetNotifyCode ( lParam ) == -12

					hws := 0
					hwm := .F.
					For x := 1 To Len ( _HMG_aControlProcedures [i] )
						hws := hws + ListView_GetColumnWidth ( _HMG_aControlHandles [i] , x - 1 )
						If _HMG_aControlProcedures [i] [x] != ListView_GetColumnWidth ( _HMG_aControlHandles [i] , x - 1 )
							hwm := .T.
							_HMG_aControlProcedures [i] [x] := ListView_GetColumnWidth ( _HMG_aControlHandles [i] , x - 1 )
							_BrowseRefresh('','',i)
						EndIf
					Next x

					* Browse ReDraw Vertical ScrollBar If Needed ...

					If _HMG_aControlIds [i] != 0 .and. hwm == .T.
						if hws > _HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() - 4
							MoveWindow ( _HMG_aControlIds [i] , _HMG_aControlCol[i]+_HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() , _HMG_aControlRow[i] , GETVSCROLLBARWIDTH() , _HMG_aControlHeight[i] - GETHSCROLLBARHEIGHT() , .t. )
							MoveWindow ( _HMG_aControlMiscData1 [i] [1], _HMG_aControlCol[i]+_HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() , _HMG_aControlRow[i] + _HMG_aControlHeight[i] - GETHSCROLLBARHEIGHT() , GETVSCROLLBARWIDTH() , GETHSCROLLBARHEIGHT() , .t. )
						Else
							MoveWindow ( _HMG_aControlIds [i] , _HMG_aControlCol[i]+_HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() , _HMG_aControlRow[i] , GETVSCROLLBARWIDTH() , _HMG_aControlHeight[i] , .t. )
							MoveWindow ( _HMG_aControlMiscData1 [i] [1], _HMG_aControlCol[i]+_HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() , _HMG_aControlRow[i] + _HMG_aControlHeight[i] - GETHSCROLLBARHEIGHT() , 0 , 0 , .t. )
						EndIf
					EndIf

					Return 0

				EndIf

				* Browse Key Handling .........................

				If GetNotifyCode ( lParam ) = LVN_KEYDOWN

					Do Case

					Case GetGridvKey(lParam) == 78 // N

						if lGetKeyState(VK_CONTROL) // CTRL

							if _HMG_acontrolmiscdata1 [i] [2] == .T.
       								_BrowseEdit ( _hmg_acontrolhandles[i] , _HMG_acontrolmiscdata1 [i] [4] , _HMG_acontrolmiscdata1 [i] [5] , _HMG_acontrolmiscdata1 [i] [3] , _HMG_aControlInputMask [i] , .t. , _HMG_aControlFontColor [i] )  
							EndIf

						EndIf

					Case GetGridvKey(lParam) == 46 // DEL

						If _HMG_aControlPicture [i] == .t.
						        If MsgYesNo (_HMG_BRWLangMessage [1] , _HMG_BRWLangMessage [2] ) == .t.
								_BrowseDelete('','',i)
							EndIf
						EndIf

					Case GetGridvKey(lParam) == 36 // HOME

						_BrowseHome('','',i)
						Return 1				

					Case GetGridvKey(lParam) == 35 // END

						_BrowseEnd('','',i)
						Return 1				

					Case GetGridvKey(lParam) == 33 // PGUP

						_BrowsePrior('','',i)
						Return 1				

					Case GetGridvKey(lParam) == 34 // PGDN

						_BrowseNext('','',i)
						Return 1				

					Case GetGridvKey(lParam) == 38 // UP

						_BrowseUp('','',i)
						Return 1				

					Case GetGridvKey(lParam) == 40 // DOWN

						_BrowseDown('','',i)
						Return 1				

					EndCase

					Return 0

				EndIf

				* Browse Double Click .........................

				If GetNotifyCode ( lParam ) == NM_DBLCLK  
					
					_PushEventInfo()
					_HMG_ThisFormIndex := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles[i] )
					_HMG_ThisType := 'C'
					_HMG_ThisIndex := i
					_HMG_ThisFormName :=  _HMG_aFormNames [ _HMG_ThisFormIndex ]
					_HMG_ThisControlName :=  _HMG_aControlNames [_HMG_THISIndex]
					r := ListView_HitTest ( _HMG_aControlHandles [i] , GetCursorRow() - GetWindowRow ( _HMG_aControlHandles [i] )  , GetCursorCol() - GetWindowCol ( _HMG_aControlHandles [i] ) )
					If r [2] == 1
						ListView_Scroll( _HMG_aControlHandles [i] ,	-10000  , 0 ) 
						r := ListView_HitTest ( _HMG_aControlHandles [i] , GetCursorRow() - GetWindowRow ( _HMG_aControlHandles [i] )  , GetCursorCol() - GetWindowCol ( _HMG_aControlHandles [i] ) )
					Else
						r := LISTVIEW_GETSUBITEMRECT ( _HMG_aControlHandles [i]  , r[1] - 1 , r[2] - 1 )
						
                                                      *	CellCol				CellWidth				
						xs :=	( ( _HMG_aControlCol [i] + r [2] ) +( r[3] ))  -  ( _HMG_aControlCol [i] + _HMG_aControlWidth [i] )
						xd := 20
						If xs > -xd 
							ListView_Scroll( _HMG_aControlHandles [i] ,	xs + xd , 0 ) 
						Else
							If r [2] < 0
								ListView_Scroll( _HMG_aControlHandles [i] , r[2]	, 0 )
							EndIf
						EndIf
							r := ListView_HitTest ( _HMG_aControlHandles [i] , GetCursorRow() - GetWindowRow ( _HMG_aControlHandles [i] )  , GetCursorCol() - GetWindowCol ( _HMG_aControlHandles [i] ) )
						EndIf

						_HMG_ThisItemRowIndex := r[1]
						_HMG_ThisItemColIndex := r[2]
						If r [2] == 1
							r := LISTVIEW_GETITEMRECT ( _HMG_aControlHandles [i]  , r[1] - 1 )
						Else
							r := LISTVIEW_GETSUBITEMRECT ( _HMG_aControlHandles [i]  , r[1] - 1 , r[2] - 1 )
						EndIf
						_HMG_ThisItemCellRow := _HMG_aControlRow [i] + r [1]
						_HMG_ThisItemCellCol := _HMG_aControlCol [i] + r [2]
						_HMG_ThisItemCellWidth := r[3]
						_HMG_ThisItemCellHeight := r[4]

						if _hmg_acontrolmiscdata1 [i] [6] == .T. 
							_BrowseEdit ( _hmg_acontrolhandles[i] , _HMG_acontrolmiscdata1 [i] [4] , _HMG_acontrolmiscdata1 [i] [5] , _HMG_acontrolmiscdata1 [i] [3] , _HMG_aControlInputMask [i] , .f. , _HMG_aControlFontColor [i] )  
						Else 
							if valtype( _HMG_aControlDblClick [i] ) == 'B'
								Eval( _HMG_aControlDblClick [i]  )
							EndIf
						Endif

						_PopEventInfo()
						_HMG_ThisItemRowIndex := 0
						_HMG_ThisItemColIndex := 0
						_HMG_ThisItemCellRow := 0
						_HMG_ThisItemCellCol := 0
						_HMG_ThisItemCellWidth := 0
						_HMG_ThisItemCellHeight := 0

				EndIf

				* Browse LostFocus ............................

				If GetNotifyCode ( lParam ) = NM_KILLFOCUS
					_DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
					Return 0
				EndIf

				* Browse GotFocus ..............................

				If GetNotifyCode ( lParam ) = NM_SETFOCUS
					_DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
					Return 0
				EndIf

				* Browse Header Click .........................

				If GetNotifyCode ( lParam ) =  LVN_COLUMNCLICK
					if ValType ( _HMG_aControlHeadClick [i] ) == 'A'
						lvc := GetGridColumn(lParam) + 1
						if len (_HMG_aControlHeadClick [i]) >= lvc
							_DoControlEventProcedure ( _HMG_aControlHeadClick [i] [lvc] , i )
						EndIf					
					EndIf
					Return 0
				EndIf

			EndIf

			* ToolBar DropDown Button Click .......................

			If GetNotifyCode ( lParam ) == TBN_DROPDOWN 

				DefWindowProc( hWnd, TBN_DROPDOWN, wParam, lParam )
   				ws := GetButtonPos( lParam)  
		    		x  := Ascan ( _HMG_aControlIds , ws )
				k  :=_HMG_aControlValue[x]  
		    		if ( x > 0 ) .And. _HMG_aControlType [x] = "TOOLBUTTON"
					aPos := {0,0,0,0}
					GetWindowRect(_HMG_aControlHandles [i], aPos)
					ws := GetButtonBarRect(_HMG_aControlHandles [i], k-1)
					TrackPopupMenu ( _HMG_aControlRangeMax [x] , aPos[1]+LoWord(ws) ,aPos[2]+HiWord(ws)+(aPos[4]-aPos[2]-HiWord(ws))/2+1 , hWnd )
			    	EndIf

				Return 0

			EndIf

			* Grid Processing .....................................

			if _HMG_aControlType [i] = "GRID" .Or. _HMG_aControlType [i] = "MULTIGRID"

				If GetNotifyCode ( lParam ) = -181
					ReDrawWindow ( _hmg_acontrolhandles [i] )
				endif

				* Grid OnQueryData ............................

				If GetNotifyCode ( lParam ) = LVN_GETDISPINFO 

					if valtype( _HMG_aControlProcedures [i] ) == 'B'

							_PushEventInfo()
							_HMG_ThisFormIndex := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles[i] )
							_HMG_ThisType := 'C'
							_HMG_ThisIndex := i
							_HMG_ThisFormName :=  _HMG_aFormNames [ _HMG_ThisFormIndex ] 
							_HMG_ThisControlName :=  _HMG_aControlNames [_HMG_THISIndex]
							_ThisQueryTemp  := GETGRIDDISPINFOINDEX ( lParam )
							_HMG_ThisQueryRowIndex  := _ThisQueryTemp [1]
							_HMG_ThisQueryColIndex  := _ThisQueryTemp [2]
							Eval( _HMG_aControlProcedures [i]  )
							if Len ( _HMG_aControlBkColor [i] ) > 0 .And. _HMG_ThisQueryColIndex == 1
								SetGridQueryImage ( lParam , _HMG_ThisQueryData )
							Else
								SetGridQueryData ( lParam , _HMG_ThisQueryData )
							EndIf
							_HMG_ThisQueryRowIndex  := 0
							_HMG_ThisQueryColIndex  := 0
							_HMG_ThisQueryData := ""
							_PopEventInfo()

	 				EndIf

				EndIf

				* Grid LostFocus ..............................

				If GetNotifyCode ( lParam ) = NM_KILLFOCUS
					_DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
					Return 0
				EndIf

				* Grid GotFocus ...............................

				If GetNotifyCode ( lParam ) = NM_SETFOCUS
					_DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
					Return 0
				EndIf

				* Grid Change .................................
						
				If GetNotifyCode ( lParam ) = LVN_ITEMCHANGED
					If GetGridOldState(lParam) == 0 .and. GetGridNewState(lParam) != 0
						_DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i )
						Return 0
					EndIf
				EndIf

				* Grid Header Click ..........................

				If GetNotifyCode ( lParam ) =  LVN_COLUMNCLICK
					if ValType ( _HMG_aControlHeadClick [i] ) == 'A'
						lvc := GetGridColumn(lParam) + 1
						if len (_HMG_aControlHeadClick [i]) >= lvc
							_DoControlEventProcedure ( _HMG_aControlHeadClick [i] [lvc] , i )
							Return 0
						EndIf					
					EndIf
				EndIf

				* Grid Double Click ...........................

				If GetNotifyCode ( lParam ) == NM_DBLCLK  

					if _hmg_acontrolspacing [i] == .T.
						_EditItem ( _hmg_acontrolhandles [i] )
					Else

						if valtype(_HMG_aControlDblClick [i]  )=='B'

								_PushEventInfo()
								_HMG_ThisFormIndex := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles[i] )
								_HMG_ThisType := 'C'
								_HMG_ThisIndex := i
								_HMG_ThisFormName :=  _HMG_aFormNames [ _HMG_ThisFormIndex ]
								_HMG_ThisControlName :=  _HMG_aControlNames [_HMG_ThisIndex]
								aCellData := _GetGridCellData(i)

								_HMG_ThisItemRowIndex := aCellData [1]
								_HMG_ThisItemColIndex := aCellData [2]
								_HMG_ThisItemCellRow := aCellData [3]
								_HMG_ThisItemCellCol := aCellData [4]
								_HMG_ThisItemCellWidth := aCellData [5]
								_HMG_ThisItemCellHeight := aCellData [6]

								Eval( _HMG_aControlDblClick [i]  )
								_PopEventInfo()

								_HMG_ThisItemRowIndex := 0
								_HMG_ThisItemColIndex := 0
								_HMG_ThisItemCellRow := 0
								_HMG_ThisItemCellCol := 0
								_HMG_ThisItemCellWidth := 0
								_HMG_ThisItemCellHeight := 0

	 					EndIf

					EndIf

					Return 0

				EndIf

			EndIf

			* DatePicker Process ..................................

			if _HMG_aControlType [i] = "DATEPICK" 

				* DatePicker Change ............................

				If GetNotifyCode ( lParam ) = DTN_DATETIMECHANGE
					_DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i )
					Return 0
				EndIf

				* DatePicker LostFocus ........................

				If GetNotifyCode ( lParam ) = NM_KILLFOCUS
					_DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
					Return 0
				EndIf

				* DatePicker GotFocus .........................

				If GetNotifyCode ( lParam ) = NM_SETFOCUS
					_DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
					Return 0
				EndIf

			EndIf

			* StatusBar Process ...................................

			if _HMG_aControlType [i] = "MESSAGEBAR" 

				* StatusBar Click

				If GetNotifyCode ( lParam ) == NM_CLICK  
					DefWindowProc( hWnd, NM_CLICK, wParam, lParam )
					x := GetItemPos( lParam)  
					ControlCount := Len (_HMG_aControlHandles)
					For i := 1 to ControlCount
						if _HMG_aControlType [i] == "ITEMMESSAGE" .And. _HMG_aControlParentHandles [i] == hWnd
							If _HMG_aControlHandles  [i]  == x+1
								if _DoControlEventProcedure ( _HMG_aControlProcedures  [i] , i )
									Return 0
								EndIf
							EndIf
						End if
					Next i
				EndIf

			EndIf

		EndIf

	otherwise

		Events ( hWnd, nMsg, wParam, lParam )

    endcase

Return (0)


#pragma BEGINDUMP

#define _WIN32_IE      0x0500
#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400
#include <shlobj.h>

#include <windows.h>
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"
#include "commctrl.h"

LRESULT CALLBACK WndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static PHB_SYMB pSymbol = NULL;
	long int r;

	if ( ! pSymbol)
	{
		pSymbol = hb_dynsymSymbol( hb_dynsymGet( "MYEVENTS" ));
	}
        if ( pSymbol )
        {
	hb_vmPushSymbol( pSymbol );
	hb_vmPushNil();
	hb_vmPushLong( ( LONG ) hWnd );
	hb_vmPushLong( message );
	hb_vmPushLong( wParam );
	hb_vmPushLong( lParam );
	hb_vmDo( 4 );
        }
	r = hb_parnl( -1 );

	if ( r != 0 )
	{
		return r ;
	}
	else
	{
		return( DefWindowProc( hWnd, message, wParam, lParam ));
	}
}

HB_FUNC ( REGISTERWINDOW )
{
	WNDCLASS WndClass;

	HBRUSH hbrush = 0 ;

	WndClass.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC ;
	WndClass.lpfnWndProc   = WndProc;
	WndClass.cbClsExtra    = 0;
	WndClass.cbWndExtra    = 0;
	WndClass.hInstance     = GetModuleHandle( NULL );
	WndClass.hIcon         = LoadIcon(GetModuleHandle(NULL),  hb_parc(1) );
	if (WndClass.hIcon==NULL)
	{
		WndClass.hIcon= (HICON) LoadImage( GetModuleHandle(NULL), hb_parc(1), IMAGE_ICON, 0, 0, LR_LOADFROMFILE + LR_DEFAULTSIZE );
	}
	if (WndClass.hIcon==NULL)
	{
		WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	}
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);

	if ( hb_parni(3, 1) == -1 )
	{
		WndClass.hbrBackground = (HBRUSH)( COLOR_BTNFACE + 1 );
	}
	else
	{
		hbrush = CreateSolidBrush( RGB(hb_parni(3, 1), hb_parni(3, 2), hb_parni(3, 3)) );
		WndClass.hbrBackground = hbrush ;
	}

	WndClass.lpszMenuName  = NULL;
	WndClass.lpszClassName = hb_parc(2);

	if(!RegisterClass(&WndClass))
	{
	MessageBox(0, "Window Registration Failed!", "Error!",
	MB_ICONEXCLAMATION | MB_OK | MB_SYSTEMMODAL);
	ExitProcess(0);
	}
	hb_retnl ( (LONG) hbrush ) ;
}

static far int nFontIndex = 0;
static far BOOL bGetName = FALSE;

HB_FUNC( GETDC )
{
   hb_retnl( (ULONG) GetDC( (HWND) hb_parnl(1) ) );
}

HB_FUNC( RELEASEDC )
{
   hb_retl( ReleaseDC( (HWND) hb_parnl(1), (HDC) hb_parnl(2) ) );
}

// EnumFonts call back routine
#pragma argsused
static int CALLBACK EnumFontsCallBack( LOGFONT FAR *lpLogFont,
    TEXTMETRIC FAR *lpTextMetric, int nFontType, LPARAM lParam )
{
  ++nFontIndex;
  if ( bGetName )
    hb_storc( lpLogFont->lfFaceName, -1, nFontIndex );
  return 1;
}

// GetFontNames: Count and return an unsorted array of font names
HB_FUNC( GETFONTNAMES )
{
  FONTENUMPROC lpEnumFontsCallBack = ( FONTENUMPROC )
  MakeProcInstance( ( FARPROC ) EnumFontsCallBack, GetModuleHandle( 0 ) );

  // Get the number of fonts
  nFontIndex = 0;
  bGetName = FALSE;
  EnumFonts( ( HDC ) hb_parnl( 1 ), NULL, lpEnumFontsCallBack, NULL );

  // Get the font names
  hb_reta( nFontIndex );
  nFontIndex = 0;
  bGetName = TRUE;
  EnumFonts( ( HDC ) hb_parnl( 1 ), NULL, lpEnumFontsCallBack, NULL );
}

HB_FUNC( MODIFYMENUITEM )
{
   hb_retnl( ModifyMenu( (HMENU) hb_parnl(1), hb_parni(2), MF_BYCOMMAND | MF_STRING, hb_parni(3), hb_parc(4) ));
}

HB_FUNC( INSERTMENUITEM )
{
   hb_retnl( InsertMenu( (HMENU) hb_parnl(1), hb_parni(2), MF_BYCOMMAND | MF_STRING,  hb_parni(3), hb_parc(4)));
}

HB_FUNC( REMOVEMENUITEM )
{
   hb_retnl( RemoveMenu( (HMENU) hb_parnl(1), hb_parni(2), MF_BYCOMMAND  ));
}

HB_FUNC( ISICONIC )
{
   hb_retl( IsIconic( ( HWND ) hb_parnl( 1 ) ) );
}

HB_FUNC( FINDWINDOW )
{
   hb_retnl( ( LONG ) FindWindow( 0, hb_parc( 1 ) ) );
}

HB_FUNC( C_PUTFILE )
{
   OPENFILENAME ofn;
   char buffer[512];
 
   int flags = OFN_FILEMUSTEXIST | OFN_EXPLORER ;
 
   if ( hb_parl(4) )
   {
       flags = flags | OFN_NOCHANGEDIR ;
   }
 
   strcpy( buffer, "" );
 
   memset( (void*) &ofn, 0, sizeof( OPENFILENAME ) );
   ofn.lStructSize = sizeof(ofn);
   ofn.hwndOwner = GetActiveWindow() ;
   ofn.lpstrFilter = hb_parc(1) ;
   ofn.lpstrFile = buffer;
   ofn.nMaxFile = 512;
   ofn.lpstrInitialDir = hb_parc(3);
   ofn.nFilterIndex    = hb_parni(5);
   ofn.lpstrTitle = hb_parc(2) ;
   ofn.Flags = flags;
 
   if( GetSaveFileName( &ofn ) )
   {
       hb_stornl(ofn.nFilterIndex, 5 );
       hb_retc( ofn.lpstrFile );
   }
   else
   {
       hb_retc( "" );
   }
}


HB_FUNC( KEYBD_DEL )
{
	keybd_event(
		VK_DELETE,	// virtual-key code
		0,		// hardware scan code
		0,		// flags specifying various function options
		0		// additional data associated with keystroke
	);
} 

HB_FUNC( KEYBD_END )
{
	keybd_event(
		VK_END,	// virtual-key code
		0,		// hardware scan code
		0,		// flags specifying various function options
		0		// additional data associated with keystroke
	);
}

HB_FUNC( KEYBD_HOME )
{
	keybd_event(
		VK_HOME,	// virtual-key code
		0,		// hardware scan code
		0,		// flags specifying various function options
		0		// additional data associated with keystroke
	);
}

HB_FUNC( INSERT_CTRL_N )
{
	keybd_event(
		VK_CONTROL,	// virtual-key code
		0,		// hardware scan code
		0,		// flags specifying various function options
		0		// additional data associated with keystroke
	);

	keybd_event(
		78	,	// virtual-key code
		0,		// hardware scan code
		0,		// flags specifying various function options
		0		// additional data associated with keystroke
	);

	keybd_event(
		VK_CONTROL,	// virtual-key code
		0,		// hardware scan code
		KEYEVENTF_KEYUP,// flags specifying various function options
		0		// additional data associated with keystroke
	);
}

HB_FUNC( LGETKEYSTATE )
{
	hb_retl( 0x8000 & GetKeyState( hb_parni( 1 ) ) );
}

HB_FUNC( INITEDITBOX )
{
	HWND hwnd;
	HWND hbutton;
	int Style ;

	hwnd = (HWND) hb_parnl (1);

	Style = ES_MULTILINE | ES_WANTRETURN | WS_CHILD | WS_VSCROLL ;

	if ( hb_parl (10) )
	{
		Style = Style | ES_READONLY ;
	}

	if ( ! hb_parl (11) )
	{
		Style = Style | WS_VISIBLE ;
	}

	if ( ! hb_parl (12) )
	{
		Style = Style | WS_TABSTOP ;
	}

	hbutton = CreateWindowEx( WS_EX_CLIENTEDGE, "EDIT" , "" ,
	Style ,
	hb_parni(3), hb_parni(4) , hb_parni(5), hb_parni(6) ,
	hwnd,(HMENU)hb_parni(2) , GetModuleHandle(NULL) , NULL ) ;

	SendMessage ( hbutton , (UINT)EM_LIMITTEXT ,(WPARAM) hb_parni(9) , (LPARAM) 0 ) ;

	hb_retnl ( (LONG) hbutton );
}

HB_FUNC( GETSECTIONNAMES )
{
	TCHAR bBuffer[ 32767 ];
	DWORD dwLen ;
	char * lpFileName = hb_parc( 1 );

	dwLen = GetPrivateProfileSectionNames( bBuffer, sizeof( bBuffer ), lpFileName);

	hb_retclen( ( char * ) bBuffer, dwLen );
}

HB_FUNC( GETDESKTOPAREA ) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_reta(4);
	hb_storni((INT) rect.top, -1, 1);
	hb_storni((INT) rect.left, -1, 2);
	hb_storni((INT) rect.right - rect.left, -1, 3);
	hb_storni((INT) rect.bottom - rect.top, -1, 4);
}

HB_FUNC( MYSENDMSG )
{
	HWND hwnd;
	COPYDATASTRUCT cds;

	hwnd = (HWND) hb_parnl (1);

	cds.dwData = 2000;
	cds.lpData = hb_parc(2);       
	cds.cbData = strlen((char*)cds.lpData); 

	SendMessage(hwnd,WM_COPYDATA,0,(LPARAM)&cds);
}

HB_FUNC( GETSENTMSG )
{
   PCOPYDATASTRUCT pcds = (PCOPYDATASTRUCT) hb_parnl(1);
   if( pcds ) 
   {    
   if( pcds->lpData )
   {
     hb_retclen(  pcds->lpData,  pcds->cbData );
   }
   else 
   {
     hb_retc( "" );
   }
   }
   else 
   {
      hb_retc( "" );  
   }
   if ISBYREF(2)
   {
      hb_stornl( pcds->dwData, 2 );
   }
}

#pragma ENDDUMP
