/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-05 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Copyright 2005 Grigory Filatov <gfilatov@freemail.ru>
*/

#include "minigui.ch"
#include "Dbstruct.ch"

#define PROGRAM 'Food Additives'
#define VERSION ' version 1.0'
#define COPYRIGHT ' 2005 Grigory Filatov'

#define IDI_MAIN 1001
//#define COMBOBOXEX

MEMVAR cFileName
MEMVAR cGroupName
MEMVAR nDirect, aItems, lSearch

*--------------------------------------------------------*
Procedure Main()
*--------------------------------------------------------*
Local cExePath := GetExeFileName()

PRIVATE cFileName := cFilePath( cExePath ) + "\" + Lower( cFileNoExt( cExePath ) ) + ".dbf"
PRIVATE cGroupName := cFilePath( cExePath ) + "\GROUP.DBF"
PRIVATE nDirect := 1, aItems := {}, lSearch := .F.

	If !FILE(cFileName)
		MsgStop("DataBase is missing...", "Stop!")
		Return
	EndIf

	SET MULTIPLE OFF

	DEFINE WINDOW Form_1 									;
		AT 0,0 										;
		WIDTH 410 HEIGHT IF(IsThemed(), 466, 460)					;
		TITLE PROGRAM 									;
		ICON IDI_MAIN									;
		MAIN NOMAXIMIZE NOMINIMIZE NOSIZE						;
		ON INIT ( OpenTables(), DoMethod( 'Form_1', 'Combo_1', 'Setfocus' ) )		;
		ON RELEASE CloseTables()							;
		FONT "MS Sans Serif" SIZE 8

#ifdef COMBOBOXEX
	@ 34, 10 COMBOBOXEX Combo_1								;
		WIDTH Form_1.Width - 52 HEIGHT 260						;
		LISTWIDTH Form_1.Width - 26							;
		DISPLAYEDIT									;
		ON DISPLAYCHANGE ( lSearch := .T. )						;
		ON ENTER SearchItem( GetProperty( 'Form_1', 'Combo_1', 'DisplayValue' ) )	;
		ON CHANGE ( lSearch := .F., SeekValues(aItems[GetProperty('Form_1', 'Combo_1', 'Value')][1]) )

	@ 34, Form_1.Width - 37 BUTTON Button_3							;
            ICON 'MAIN'										;
            ACTION SearchItem( GetProperty( 'Form_1', 'Combo_1', 'DisplayValue' ) )		;
            WIDTH 21										;
            HEIGHT 21										;
            TOOLTIP "Search for item"
#else
	@ 34, 10 COMBOBOX Combo_1								;
		WIDTH Form_1.Width - 26 HEIGHT 260						;
		DISPLAYEDIT									;
		ON DISPLAYCHANGE ( lSearch := .T. )						;
		ON ENTER SearchItem( GetProperty( 'Form_1', 'Combo_1', 'DisplayValue' ) )	;
		ON CHANGE ( lSearch := .F., SeekValues(aItems[GetProperty('Form_1', 'Combo_1', 'Value')][1]) )
#endif
	@ 6, 70 RADIOGROUP Radio_1								;
		OPTIONS { 'Exxx number', 'Additive name' }					;
		VALUE nDirect									;
		WIDTH 88									;
		SPACING 4									;
		ON CHANGE ( lSearch := .F.,							;
			nDirect := Form_1.Radio_1.Value,					;
			SetComboItems(),							;
			SeekValues(Form_1.Combo_1.DisplayValue) )				;
		HORIZONTAL

	@ 12, 10 LABEL Label_1 VALUE "Show by:" ;
		WIDTH 48 HEIGHT 14

	@ 60, 10 LABEL Label_2 VALUE "Name:" ;
		WIDTH 48 HEIGHT 14

	@ 80, 10 LABEL Label_3 VALUE "Number:" ;
		WIDTH 48 HEIGHT 14

	@ 100, 10 LABEL Label_4 VALUE "Group:" ;
		WIDTH 48 HEIGHT 14

	@ 118, 10 LABEL Label_5 VALUE "Animal origin:" ;
		WIDTH 76 HEIGHT 14

	@ 138, 10 LABEL Label_6 VALUE "Warning:" ;
		WIDTH 64 HEIGHT 14

	@ 168, 10 LABEL Label_7 VALUE "Description:" ;
		WIDTH 76 HEIGHT 14

	@ 60, 80 LABEL Label_21 VALUE "" ;
		WIDTH 312 HEIGHT 14

	@ 80, 80 LABEL Label_31 VALUE "" ;
		WIDTH 160 HEIGHT 14

	@ 100, 80 LABEL Label_41 VALUE "" ;
		WIDTH 160 HEIGHT 14

	@ 118, 80 LABEL Label_51 VALUE "" ;
		WIDTH 80 HEIGHT 14

	@ 138, 80 LABEL Label_61 VALUE "" ;
		WIDTH 320 HEIGHT 42

	@ 186, 10 EDITBOX Edit_1 WIDTH Form_1.Width - 26 HEIGHT 204 VALUE "" READONLY NOVSCROLL NOHSCROLL

        @ Form_1.Height - IF(IsThemed(), 62, 58), Form_1.Width - 180 BUTTON Button_1 ;
            CAPTION 'About' ; 
            ACTION MsgAbout() ;
            WIDTH 74 ;
            HEIGHT 23 ;
            TOOLTIP "About this program"

        @ Form_1.Height - IF(IsThemed(), 62, 58), Form_1.Width - 90 BUTTON Button_2 ;
            CAPTION 'E&xit' ;
            ACTION ReleaseAllWindows() ;
            WIDTH 74 ;
            HEIGHT 23 ;
            TOOLTIP "Exit from program"

	ON KEY ESCAPE ACTION Form_1.Release

	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return

*--------------------------------------------------------*
Static Procedure SearchItem( cSearch )
*--------------------------------------------------------*

	IF lSearch
		cSearch := Upper(cSearch)

		IF nDirect==1
			IF Left(cSearch, 1) # 'E'
				cSearch := "E" + cSearch
			ENDIF
		ENDIF

		SET SOFTSEEK ON
		BASE->( dbseek( cSearch ) )
		SET SOFTSEEK OFF

		IF !EOF()
			Form_1.Combo_1.Value := aScan( aItems, {|e| BASE->( RecNo() ) == e[2]} )
			SeekValues( aItems[Form_1.Combo_1.Value][1] )
		ELSE
			PlayBeep()
		ENDIF

		lSearch := .F.
		Form_1.Combo_1.Setfocus
	ENDIF

Return

*--------------------------------------------------------*
Static Procedure RefreshValues()
*--------------------------------------------------------*

	Form_1.Label_21.Value := BASE->Name
	Form_1.Label_31.Value := BASE->Number
	Form_1.Label_41.Value := GRP->Name
	Form_1.Label_51.Value := IF(BASE->Animal, "Yes", "No")
	Form_1.Label_61.Value := BASE->Warning
	Form_1.Edit_1.Value := BASE->Descript

Return

*--------------------------------------------------------*
Static Procedure SeekValues( cItem )
*--------------------------------------------------------*
LOCAL n

	IF nDirect==1
		IF ( n := At(" - ", cItem) ) > 0
			cItem := Substr(cItem, 1, n)
		ENDIF
	ELSE
		IF ( n := At(" (", cItem) ) > 0
			cItem := Substr(cItem, 1, n)
		ENDIF
	ENDIF

	BASE->( dbseek( Upper(cItem) ) )
	RefreshValues()

Return

*--------------------------------------------------------*
Static Procedure SetComboItems()
*--------------------------------------------------------*

	aItems := {}
	Form_1.Combo_1.DeleteAllItems

	Set Order To nDirect

	IF nDirect == 1
		BASE->( DBeval( {|| aAdd(aItems, {Rtrim(BASE->Number) + " - " + Rtrim(BASE->Name), BASE->(RecNo())})}, {|| !Empty(BASE->Number)} ) )
	ELSE
		BASE->( DBeval( {|| aAdd(aItems, {Rtrim(BASE->Name) + IF(Empty(BASE->Number), "", " (" + Rtrim(BASE->Number) + ")"), BASE->(RecNo())})}, {|| !Empty(BASE->Name)} ) )
	ENDIF

	Aeval( aItems, {|e| Form_1.Combo_1.AddItem(e[1])} )

	Form_1.Combo_1.Value := 1
	BASE->( dbgotop() )

Return

*--------------------------------------------------------*
Static Function MsgAbout()
*--------------------------------------------------------*

Return MsgInfo( padc(PROGRAM + VERSION, 38) + CRLF + ;
	padc("Copyright " + Chr(169) + COPYRIGHT, 38) + CRLF + CRLF + ;
	hb_compiler() + CRLF + ;
	version() + CRLF + ;
	SubStr(MiniGuiVersion(), 1, 28) + CRLF + CRLF + ;
	padc("This program is Freeware!", 38) + CRLF + ;
	padc("Copying is allowed!", 40), "About", IDI_MAIN, .F. )

*--------------------------------------------------------*
Procedure FileDelete( cMask )
*--------------------------------------------------------*
	AEval( Directory( cMask ), { |file| Ferase( file[1] ) } )
Return

*--------------------------------------------------------*
Procedure OpenTables()
*--------------------------------------------------------*

	IF !FILE(cGroupName)
		CreateTable()
	ENDIF
	
	Use (cGroupName) Alias GRP NEW
	Index On Field->Code To Group
	Go Top

	Use (cFileName) Alias BASE NEW
	Set Relation To Field->Code Into GRP
	Index On Upper(Substr(Field->Name, 1, 40)) To Base2
	Index On Upper(Field->Number) To Base1
	Set Index To Base1, Base2

	SetComboItems()
	SeekValues(Form_1.Combo_1.DisplayValue)

Return

*--------------------------------------------------------*
Procedure CloseTables()
*--------------------------------------------------------*

	BASE->( dbclosearea() )
	GRP->( dbclosearea() )
	FileDelete( "*.ntx" )

Return

*--------------------------------------------------------*
Procedure CreateTable
*--------------------------------------------------------*
LOCAL aDbf[2][4], i, aName := ;
	{ "Colors", "Preservatives", "Acids, Antioxidants, Mineral salts", ;
	"Emulsifiers - Stabilisers", "Mineral salts - Anti-caking agents", ;
	"Flavour enhancers", "Miscellaneous" }

        aDbf[1][ DBS_NAME ] := "Code"
        aDbf[1][ DBS_TYPE ] := "Numeric"
        aDbf[1][ DBS_LEN ]  := 1
        aDbf[1][ DBS_DEC ]  := 0
        //
        aDbf[2][ DBS_NAME ] := "Name"
        aDbf[2][ DBS_TYPE ] := "Character"
        aDbf[2][ DBS_LEN ]  := 80
        aDbf[2][ DBS_DEC ]  := 0

        DBCREATE(cGroupName, aDbf)

	Use (cGroupName)

	For i:= 1 To Len(aName)
		append blank
		Replace CODE with i 
		Replace NAME With aName[i]
	Next i

	Use

Return
/*
*--------------------------------------------------------*
Procedure CreateBase
*--------------------------------------------------------*
LOCAL aDbf[6][4]

        aDbf[1][ DBS_NAME ] := "Name"
        aDbf[1][ DBS_TYPE ] := "Character"
        aDbf[1][ DBS_LEN ]  := 90
        aDbf[1][ DBS_DEC ]  := 0
        //
        aDbf[2][ DBS_NAME ] := "Number"
        aDbf[2][ DBS_TYPE ] := "Character"
        aDbf[2][ DBS_LEN ]  := 7
        aDbf[2][ DBS_DEC ]  := 0
        //
        aDbf[3][ DBS_NAME ] := "Code"
        aDbf[3][ DBS_TYPE ] := "Numeric"
        aDbf[3][ DBS_LEN ]  := 1
        aDbf[3][ DBS_DEC ]  := 0

        aDbf[4][ DBS_NAME ] := "Animal"
        aDbf[4][ DBS_TYPE ] := "Logical"
        aDbf[4][ DBS_LEN ]  := 1
        aDbf[4][ DBS_DEC ]  := 0
        //
        aDbf[5][ DBS_NAME ] := "Warning"
        aDbf[5][ DBS_TYPE ] := "Character"
        aDbf[5][ DBS_LEN ]  := 190
        aDbf[5][ DBS_DEC ]  := 0
        //
        aDbf[6][ DBS_NAME ] := "Descript"
        aDbf[6][ DBS_TYPE ] := "Memo"
        aDbf[6][ DBS_LEN ]  := 10
        aDbf[6][ DBS_DEC ]  := 0

        DBCREATE(cFileName, aDbf)

	Use

Return
*/

#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC ( C_CENTER ) 
{
	RECT rect;
	int w, h, x, y;
	GetWindowRect((HWND) hb_parnl (1), &rect);
	w  = rect.right  - rect.left;
	h = rect.bottom - rect.top;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );
	x = rect.right - rect.left;
	y = rect.bottom - rect.top;
	SetWindowPos( (HWND) hb_parnl (1), HWND_TOP, (x - w) / 2, (y - h) / 2 + 1, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE );
}

HB_FUNC ( INITIMAGE )
{
	HWND  h;
	HBITMAP hBitmap;
	HWND hwnd;

	hwnd = (HWND) hb_parnl(1);

	h = CreateWindowEx(0,"static",NULL, WS_CHILD | WS_VISIBLE | SS_BITMAP | SS_NOTIFY,
		hb_parni(3), hb_parni(4), 0, 0, hwnd, (HMENU)hb_parni(2), GetModuleHandle(NULL), NULL );

	hBitmap = (HBITMAP) LoadImage(0,hb_parc(5),IMAGE_BITMAP,hb_parni(6),hb_parni(7),LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap==NULL)
	{
		hBitmap = (HBITMAP) LoadImage(GetModuleHandle(NULL), hb_parc(5), IMAGE_BITMAP, hb_parni(6), hb_parni(7), LR_CREATEDIBSECTION);
	}


	SendMessage( h, (UINT)STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)hBitmap );

	hb_retnl( (LONG) h );
}

HB_FUNC (C_SETPICTURE)
{
	HBITMAP hBitmap;

	hBitmap = (HBITMAP) LoadImage(0,hb_parc(2),IMAGE_BITMAP,hb_parni(3),hb_parni(4),LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap==NULL)
	{
		hBitmap = (HBITMAP) LoadImage(GetModuleHandle(NULL),hb_parc(2),IMAGE_BITMAP,hb_parni(3),hb_parni(4),LR_CREATEDIBSECTION);
	}

	SendMessage((HWND) hb_parnl (1),(UINT)STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBitmap);

	hb_retnl ( (LONG) hBitmap );
}

#pragma ENDDUMP