/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-06 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Copyright (c) 2004-06 Grigory Filatov <gfilatov@freemail.ru>
*/
ANNOUNCE RDDSYS

#include "minigui.ch"

#define PROGRAM 'ForceSaver'
#define COPYRIGHT ' Grigory Filatov, 2004'
#define CRLF HB_OsNewLine()

#define RSP_NORMAL	0
#define RSP_SERVICE	1

#define SPI_SCREENSAVERRUNNING 97
#define WM_SYSCOMMAND 274     // &H112
#define SC_SCREENSAVE 61760   // &HF140

#xcommand DEFINE DEFAULT MENUITEM TO <item> [ OF <parent> ] ;
=>;
_DefineDefaultMenuItem( <item>, 'LAUNCH' , <"parent"> )

*--------------------------------------------------------*
Procedure Main( cCmdLine )
*--------------------------------------------------------*
	DEFAULT cCmdLine := ""

	SET MULTIPLE OFF WARNING

	IF !EMPTY( cCmdLine ) .AND. LOWER( SUBSTR( cCmdLine, 2) ) == 'service'

		ServiceProcess( RSP_SERVICE )

		DEFINE WINDOW Form_1 ;
			AT 0,0 ;
			WIDTH 0 HEIGHT 0 ;
			TITLE PROGRAM ;
			MAIN NOSHOW
	ELSE
		DEFINE WINDOW Form_1 ;
			AT 0,0 ;
			WIDTH 0 HEIGHT 0 ;
			TITLE PROGRAM ;
			MAIN NOSHOW ;
			NOTIFYICON "MAIN" ;
			NOTIFYTOOLTIP PROGRAM + ": Right Click for Menu" ;
			ON NOTIFYCLICK RunSSaver()

		DEFINE NOTIFY MENU 
			ITEM '&Launch Screen Saver'	ACTION RunSSaver()	NAME LAUNCH
			SEPARATOR
			ITEM '&Mail to author...' ;
				ACTION ShellExecute(0, "open", "rundll32.exe", ;
					"url.dll,FileProtocolHandler " + ;
					"mailto:gfilatov@freemail.ru?cc=&bcc=" + ;
					"&subject=Force%20Saver%20Feedback:" + ;
					"&body=How%20are%20you%2C%20Grigory%3F", , 1)
			ITEM '&About...'	ACTION ShellAbout( "", PROGRAM + ' version 1.0' + CRLF + ;
					"Copyright " + Chr(169) + COPYRIGHT, LoadMainIcon(GetInstance(), "MAIN") )
			SEPARATOR
			ITEM 'E&xit'	ACTION Form_1.Release
		END MENU

		DEFINE DEFAULT MENUITEM TO 1

	ENDIF

	END WINDOW

	DEFINE TIMER Timer_1 OF Form_1 ;
		INTERVAL 1000 ;
		ACTION CheckTopLeftCorner()

	ACTIVATE WINDOW Form_1

Return

*--------------------------------------------------------*
Function CheckTopLeftCorner()
*--------------------------------------------------------*
   Local aPos := GetCursorPos()

   IF aPos[1] = 0 .AND. aPos[2] = 0
	SetCursorPos(1, 1)
	DO EVENTS
	RunSSaver()
   ENDIF

Return NIL

*--------------------------------------------------------*
Function RunSSaver()
*--------------------------------------------------------*
Return SendMessage( GetFormHandle("Form_1"), WM_SYSCOMMAND, SC_SCREENSAVE )

*--------------------------------------------------------*
Procedure _DefineDefaultMenuItem( ItemNumber, ItemName, FormName )
*--------------------------------------------------------*
	Local i , h

	if valtype(FormName) == 'U'
		FormName := _HMG_ActiveFormName
	Endif

	i := GetControlIndex( ItemName, FormName )

	h := _HMG_aControlpageMap[ i ]

	SetMenuDefaultItem( h, ItemNumber )

Return

*--------------------------------------------------------*
Procedure ServiceProcess( mode )
*--------------------------------------------------------*
	Local nProcessId := 0

	DEFAULT mode := RSP_NORMAL

	nProcessId := GCP()

	If Abs( nProcessId ) > 0

		RSProcess( nProcessId, mode )

	Endif

Return

*--------------------------------------------------------*
DECLARE DLL_TYPE_LONG RegisterServiceProcess( DLL_TYPE_LONG nProcessID, DLL_TYPE_LONG nMode ) ;
	IN KERNEL32.DLL ;
	ALIAS RSProcess

*--------------------------------------------------------*
DECLARE DLL_TYPE_LONG GetCurrentProcessId() ;
	IN KERNEL32.DLL ;
	ALIAS GCP


#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400
#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC ( SETMENUDEFAULTITEM )
{
	SetMenuDefaultItem( (HMENU) hb_parnl( 1 ), hb_parni( 2 ) - 1, TRUE );
}

HB_FUNC (LOADTRAYICON)
{
	HICON himage;
	HINSTANCE hInstance  = (HINSTANCE) hb_parnl(1);  // handle to application instance
	LPCTSTR   lpIconName = (LPCTSTR)   hb_parc(2);   // name string or resource identifier

	himage = (HICON) LoadImage( hInstance ,  lpIconName , IMAGE_ICON, 16, 16, LR_SHARED ) ;

	if (himage==NULL)
	{
		himage = (HICON) LoadImage( hInstance ,  lpIconName , IMAGE_ICON, 0, 0, LR_LOADFROMFILE + LR_DEFAULTSIZE ) ;
	}

	hb_retnl ( (LONG) himage );
}

HB_FUNC (LOADMAINICON)
{
	HICON himage;
	HINSTANCE hInstance  = (HINSTANCE) hb_parnl(1);  // handle to application instance
	LPCTSTR   lpIconName = (LPCTSTR)   hb_parc(2);   // name string or resource identifier

	himage = (HICON) LoadImage( hInstance ,  lpIconName , IMAGE_ICON, 0, 0, LR_DEFAULTSIZE ) ;

	if (himage==NULL)
	{
		himage = (HICON) LoadImage( hInstance ,  lpIconName , IMAGE_ICON, 0, 0, LR_LOADFROMFILE + LR_DEFAULTSIZE ) ;
	}

	hb_retnl ( (LONG) himage );
}

HB_FUNC( INITIMAGE )
{
	HWND  h;
	HBITMAP hBitmap;
	HWND hwnd;
	int Style;

	hwnd = (HWND) hb_parnl(1);

	Style = WS_CHILD | SS_BITMAP | SS_NOTIFY ;

	if ( ! hb_parl (8) )
	{
		Style = Style | WS_VISIBLE ;
	}

	h = CreateWindowEx( 0, "static", NULL, Style,
		hb_parni(3), hb_parni(4), 0, 0,
		hwnd, (HMENU) hb_parni(2), GetModuleHandle(NULL), NULL ) ;

	hBitmap = (HBITMAP) LoadImage(0,hb_parc(5),IMAGE_BITMAP,hb_parni(6),hb_parni(7),LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap==NULL)
	{
		hBitmap = (HBITMAP) LoadImage(GetModuleHandle(NULL),hb_parc(5),IMAGE_BITMAP,hb_parni(6),hb_parni(7),LR_CREATEDIBSECTION);
	}

	SendMessage( h, (UINT) STM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) hBitmap );

	hb_retnl( (LONG) h );
}

HB_FUNC( C_SETPICTURE )
{
	HBITMAP hBitmap;

	hBitmap = (HBITMAP) LoadImage(0,hb_parc(2),IMAGE_BITMAP,hb_parni(3),hb_parni(4),LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if (hBitmap==NULL)
	{
		hBitmap = (HBITMAP) LoadImage(GetModuleHandle(NULL),hb_parc(2),IMAGE_BITMAP,hb_parni(3),hb_parni(4),LR_CREATEDIBSECTION);
	}

	SendMessage( (HWND) hb_parnl (1), (UINT) STM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) hBitmap );

	hb_retnl( (LONG) hBitmap );
}

#pragma ENDDUMP
