ANNOUNCE RDDSYS
EXTERNAL Pi

#include 'minigui.ch'
#include "rtfc.ch"

SET PROCEDURE TO USERFUNC

#define MsgInfo( c, t ) MsgInfo( c, t, , .f. )
#define MsgStop( c, t ) MsgStop( c, t, , .f. )

Memvar cNameApp
Memvar aPointG
Memvar nFun
Memvar WinCLR
Memvar cMess
Memvar PathGraph
Memvar cExpTran1
Memvar cExpTran2
Memvar cExpF1
Memvar cExpF2
*--------------------------------------------------------*
PROCEDURE MAIN
*--------------------------------------------------------*
Local cVer := 'v2.3'
Local cWWW := "http://slmini.narod.ru"
Local PathApp := GetStartupFolder()
Local FileUserF := PathApp+'\userfun.txt'
Local aFun := {'Sin(x)','Cos(x)','Tg(x)','ArcS(x)','ArcC(x)','ArcT(x)',;
      'RD(x)','DR(x)','Ln(x)','Lg(x)','Sqr(x)','Abs(x)'}
Local aConst := {'Pi','Pi/2','Pi/3','Pi/4','2*Pi/3','2*Pi'}
Local hand, aUserF := {}, cStr, nTok
Local nColbut := 150, i, cBut

SET CENTURY ON
SET DATE GERMAN

SET LOGERROR OFF
SET TOOLTIP BALLOON ON
SET NAVIGATION EXTENDED

PUBLIC cNameApp := 'MiniGraph'
PUBLIC aPointG:={}
PUBLIC nFun:=1
PUBLIC WinCLR:={200,220,220}
PUBLIC cMess

PUBLIC PathGraph := PathApp+'\GRAPH\'
IF DIRCHANGE( PathGraph ) > 0
   MakeDir(PathGraph)
ENDIF
DirChange(PathApp)

IF File(FileUserF)=.F.
    hand:=FCreate(FileUserF)
    fwrite(hand,'Abs(Abs(x^2-2x)-3)'+CRLF)
    fwrite(hand,'x^3-3x^2+4'+CRLF)
    fwrite(hand,'Sin(2x)+Ln(x+1)'+CRLF)
    fclose(hand)
ENDIF
cStr := MemoRead(FileUserF)
nTok := NumToken(cStr, CRLF)
FOR i=1 TO nTok
    AADD(aUserF, Token(cStr, CRLF, i) )
NEXT

DEFINE WINDOW WinMain ;
	AT 0,0 WIDTH 490 HEIGHT 530 ;
	TITLE cNameApp +' '+cVer ;
	ICON 'MAIN' ;
	MAIN NOSIZE NOMAXIMIZE ;
	FONT 'Courier' SIZE 12 ; 
	BACKCOLOR WinCLR

BoxIn2('WinMain',10,10,150,470,3)
@ 17,30 LABEL lblV HEIGHT 20 WIDTH 150 VALUE 'Select' ;
         FONT 'Times' SIZE 11 BOLD TRANSPARENT
@ 42,30 LABEL lbUFu WIDTH 120 HEIGHT 40 VALUE 'User functions';
         FONT 'Arial' SIZE 10 TRANSPARENT
@ 40,150  COMBOBOX cboFun1 WIDTH 300 HEIGHT 160 ITEMS aUserF  VALUE 1 FONT 'Arial' SIZE 10;  
         ON CHANGE InsertStr(This.Item(This.Value),1 );
         TOOLTIP 'Select user function'
@ 75,30 LABEL lblFu WIDTH 120 HEIGHT 40 VALUE 'Standard functions' ;
         FONT 'Arial' SIZE 10 TRANSPARENT

FOR i=1 TO 6
   cBut:='butF_'+AllTrim(Str(i))
   @ 70,nColBut BUTTONEX &cBut CAPTION aFun[i] WIDTH 50 HEIGHT 20 ;
         ACTION InsertStr(This.Caption,1);
         FONT 'Arial' SIZE 9 BACKCOLOR WHITE NOXPSTYLE FLAT
   nColbut+=50
NEXT

nColbut:=150
FOR i=7 TO 12
   cBut:='butF_'+AllTrim(Str(i))
   @ 90,nColBut BUTTONEX &cBut CAPTION aFun[i] WIDTH 50 HEIGHT 20 ;
         ACTION InsertStr(This.Caption,1);
         FONT 'Arial' SIZE 9 BACKCOLOR WHITE NOXPSTYLE FLAT 
   nColbut+=50
NEXT
@ 115,30 LABEL lblCo WIDTH 120 HEIGHT 20 VALUE 'Constants' ;
         FONT 'Arial' SIZE 10 TRANSPARENT

nColBut:=150
FOR i=1 TO 6
   cBut:='butC_'+AllTrim(Str(i))
   @ 115,nColBut BUTTONEX &cBut CAPTION aConst[i] WIDTH 50 HEIGHT 20 ;
         ACTION InsertStr(This.Caption,1);
         FONT 'Arial' SIZE 9 BACKCOLOR WHITE NOXPSTYLE FLAT
   nColbut+=50
NEXT

BoxIn2('WinMain',160,10,310,470,3)
@ 165,30 LABEL lblF HEIGHT 20 WIDTH 150 VALUE 'Functions' ;
         FONT 'Times' SIZE 11 BOLD TRANSPARENT

@ 190,30 LABEL L_Y1 WIDTH  40  VALUE 'Y1=' FONT 'Courier' SIZE 12 BOLD FONTCOLOR RED TRANSPARENT
@ 190,70 TEXTBOX  txtCalc1 WIDTH 380  VALUE ''FONT 'Courier' SIZE 11 ;
         ON GOTFOCUS nFun:=SetnFun(This.Name) ;
         TOOLTIP 'Function expression 1'
@ 220,30 LABEL L_Y2 WIDTH  40  VALUE 'Y2=' FONT 'Courier' SIZE 12 BOLD  FONTCOLOR BLUE TRANSPARENT
@ 220,70 TEXTBOX  txtCalc2 WIDTH 380  VALUE ''FONT 'Courier' SIZE 11 ;
         ON GOTFOCUS nFun:=SetnFun(This.Name) ;
         TOOLTIP 'Function expression 2' 
@ 250,30 LABEL lblA HEIGHT 20 WIDTH 150 VALUE 'Argument' ;
         FONT 'Times' SIZE 11 BOLD TRANSPARENT

DEFINE TEXTBOX txtDia1
   ROW 270
   COL 70
   WIDTH 100
   VALUE 0
   NUMERIC .T.
   INPUTMASK '99999.99'  
   TOOLTIP 'Bottom border of argument'
   ON GOTFOCUS This.CARETPOS:= 0
END TEXTBOX

@ 272,175 LABEL Label_7 WIDTH 55 VALUE '< X <' FONT 'Courier' SIZE 12 BOLD TRANSPARENT
DEFINE TEXTBOX txtDia2
   ROW 270
   COL 230
   WIDTH 100
   VALUE 0
   NUMERIC .T.
   INPUTMASK '99999.99'  
   TOOLTIP 'Top border of argument'
   ON GOTFOCUS This.CARETPOS:= 0
END TEXTBOX

@ 272,348 LABEL Label_8 WIDTH 30 VALUE 'Step' FONT 'Arial' SIZE 10 TRANSPARENT
DEFINE TEXTBOX txtStep
   ROW 270
   COL 380
   WIDTH 70
   VALUE 0
   NUMERIC .T.
   INPUTMASK '999.99'  
   TOOLTIP 'Step of argument changing' 
   ON GOTFOCUS This.CARETPOS:= 0
END TEXTBOX

BoxIn2('WinMain',320,10,430,470,3)
@ 325,30 LABEL lblU HEIGHT 20 WIDTH 150 VALUE 'Settings' ;
	FONT 'Times' SIZE 11 BOLD TRANSPARENT

@ 345,30 RADIOGROUP rgUg ;
	OPTIONS { 'Angles in degree', 'Angles in radians'} ;
	VALUE 2 WIDTH 120 SPACING 25 FONT 'Arial' SIZE 10 TRANSPARENT;
        TOOLTIP 'For trigonometric functions' 
@ 395,30 SPINNER txtnPen RANGE 1,5 WIDTH 35 HEIGHT 22 FONT 'Courier' SIZE 11 ;
	TOOLTIP 'Thickness from 1 to 5 points'
@ 400,70 LABEL Label_9 WIDTH 150 VALUE 'Thickness of line' FONT 'Arial' SIZE 10 TRANSPARENT
@ 345,215 CHECKBOX Chk1 CAPTION 'Show vertical grid line'     VALUE .T. HEIGHT 25 WIDTH 250 FONT 'Arial' SIZE 10 BACKCOLOR WinClr
@ 370,215 CHECKBOX Chk2 CAPTION 'Show horizontal grid line'   VALUE .T. HEIGHT 25 WIDTH 250 FONT 'Arial' SIZE 10 BACKCOLOR WinClr
@ 395,215 CHECKBOX Chk3 CAPTION 'Show mark of value on graph' VALUE .T. HEIGHT 25 WIDTH 250 FONT 'Arial' SIZE 10 BACKCOLOR WinClr

@ 440,140 BUTTONEX But_3 CAPTION 'To build the graph' WIDTH 200 HEIGHT 30 BACKCOLOR WinClr NOXPSTYLE;
         FONT 'Times' SIZE 12 BOLD;
         ACTION CreateGra() TOOLTIP 'Draw graph of functions' 

@ 475,0 LABEL  lblLine WIDTH 490  HEIGHT 1 VALUE ' ' BACKCOLOR BLACK
@ 480,10 LABEL  Label_10 WIDTH 470  HEIGHT 15 VALUE cWWW;
        FONT 'Times New Roman' SIZE 10  CENTERALIGN FONTCOLOR {0,0,128} TRANSPARENT

ON KEY ESCAPE ACTION ThisWindow.Release
END WINDOW

WinMain.txtCalc1.SetFocus
WinMain.Center

ACTIVATE WINDOW WinMain

RETURN

*--------------------------------------------------------*
FUNCTION SetnFun(txtName)
*--------------------------------------------------------*
LOCAL nFun:=Val(Right(txtName,1))
IF nFun=1
   SetProperty('WinMain','txtCalc2','BackColor',WinClr)
   SetProperty('WinMain','txtCalc1','BackColor',WHITE)
ELSEIF nFun=2
   SetProperty('WinMain','txtCalc2','BackColor',WHITE)
   SetProperty('WinMain','txtCalc1','BackColor',WinClr)
ENDIF
RETURN nFun

*--------------------------------------------------------*
FUNCTION InsertStr(Str2,nMod)
*--------------------------------------------------------*
LOCAL cText:=IIF(nFun=1,AllTrim(WinMain.txtcalc1.Value), AllTrim(WinMain.txtcalc2.Value))
LOCAL nLen:= Len(cText), cNewText, nPos, cLeft, cRight
IF nMod=0
   cNewText:=cText+Str2
ELSEIF nMod=1
   nPos:=IIF(nFun=1,WinMain.txtcalc1.CaretPos,WinMain.txtcalc2.CaretPos)
   cLeft:=Left(cText,nPos)
   cRight:=Right(cText,nLen-nPos)
   cNewText:=cLeft+Str2+cRight
ENDIF
IF nFun=1
   WinMain.txtcalc1.Value:=cNewText
   WinMain.txtcalc1.SetFocus
ELSEIF nFun=2
   WinMain.txtcalc2.Value:=cNewText
   WinMain.txtcalc2.SetFocus
ENDIF
RETURN NIL

*--------------------------------------------------------*
PROCEDURE CreateGra()
*--------------------------------------------------------*
LOCAL nDia1:= WinMain.txtDia1.Value
LOCAL nDia2:= WinMain.txtDia2.Value
LOCAL nStep:= WinMain.txtStep.Value
LOCAL nArg
PRIVATE cExpTran1:=''
PRIVATE cExpTran2:=''
PRIVATE cExpF1:=WinMain.txtcalc1.Value
PRIVATE cExpF2:=WinMain.txtcalc2.Value
IF Empty(cExpF1).AND.Empty(cExpF2)
   MsgStop( "Function is absent",cNameApp )
   RETURN
ENDIF
IF Empty(cExpF1)=.F.
   cExpTran1:=TransFun(cExpF1,1)
   IF Empty(cExpTran1)
      RETURN
   ENDIF
ENDIF
IF Empty(cExpF2)=.F.
   cExpTran2:=TransFun(cExpF2,2)
   IF Empty(cExpTran2)
      RETURN
   ENDIF
ENDIF
IF nStep<=0.OR.nStep>=nDia2
   MsgStop( "Invalid step select",cNameApp )
   RETURN
ENDIF
IF nDia2<=nDia1
   MsgStop( "Invalid range select",cNameApp )
   RETURN
ENDIF
nArg:=Abs((nDia2-nDia1)/nStep)
IF nArg>999
   MsgStop( "Overranging argument amount",cNameApp )
   RETURN
ENDIF

DEFINE WINDOW WinGraph ;
	AT 0,0 WIDTH 800 HEIGHT 530+ IF(IsXPThemeActive(), 8, 0) ;
	TITLE cNameApp ;
	ICON 'MAIN' ;
	MODAL NOSIZE BACKCOLOR WinClr ;
	ON INIT DrawGra('WinGraph',.F.)

BoxIn2( 'WinGraph', 10, 10, 490, 600 ,2)
@ 15,680 LABEL LblPoint1 HEIGHT 4 WIDTH 4 VALUE '' BACKCOLOR RED INVISIBLE
@ 15,670 LABEL LblPoint2 HEIGHT 4 WIDTH 4 VALUE '' BACKCOLOR BLUE INVISIBLE
@ 5,630 LABEL Label_5 HEIGHT 20 WIDTH 130 VALUE 'Tables of values' FONT 'Arial' SIZE 10 BOLD TRANSPARENT
@ 470,610 BUTTONEX But1 CAPTION 'Word' PICTURE 'WORD' WIDTH 85 HEIGHT 22 BOLD ;
         ACTION Form2File('RTF') BACKCOLOR WHITE NOXPSTYLE;
         TOOLTIP 'Save graph and table on hard disk'
@ 470,705 BUTTONEX But2 CAPTION 'Excel' PICTURE 'EXCEL' WIDTH 85 HEIGHT 22 BOLD ;
         ACTION Form2File('XLS') BACKCOLOR WHITE NOXPSTYLE;
         TOOLTIP 'Save graph and table on hard disk'

ON KEY ESCAPE ACTION ThisWindow.Release
END WINDOW

WinGraph.Center
ACTIVATE WINDOW WinGraph

RETURN

*--------------------------------------------------------*
FUNCTION TransFun(cExp,nExp)
*--------------------------------------------------------*
LOCAL cExpErr:='Function -'+Str(nExp,1)+'   '
LOCAL cExpTran:=StrTran(cExp,',','.'), cExpC, i, cLX
cExpTran:=StrTran(cExpTran,'x','X')
cExpTran:=StrTran(cExpTran,'','X')
cExpTran:=StrTran(cExpTran,'','X')
IF At('X',cExpTran)=0
      MsgStop(cExpErr+ "Function's argument is absent ",cNameApp )
      RETURN ''
ENDIF
cExpTran:=Upper(cExpTran)                    &&  
FOR i=1 TO Len(cExpTran)
   IF SubStr(cExpTran,i,1)='X'
      cLX:= SubStr(cExpTran,i-1,1)
      IF cLX<>'0'
         IF Val(cLX)<>0.OR.cLX=')'.OR.cLX='I'
           cExpTran=StrTran(cExpTran,cLX+'X',cLX+'*X')
         ENDIF
      ELSE
         cExpTran=StrTran(cExpTran,cLX+'X',cLX+'*X')
      ENDIF
      i=i+1
   ENDIF
NEXT
cExpTran:=StrTran(cExpTran,'SIN','SINF')
cExpTran:=StrTran(cExpTran,'COS','COSF')
cExpTran:=StrTran(cExpTran,'X','(X)')
cExpC:=StrTran(cExpTran,'X',AllTrim(Str(1)))
IF TYPE( cExpC ) $ "UE"
      MsgStop( cExpErr+"Invalid expression ",cNameApp )
      RETURN ''
ENDIF
RETURN cExpTran

*--------------------------------------------------------*
PROCEDURE DrawGra(cWinGraph)
*--------------------------------------------------------*
LOCAL nDia1:= WinMain.txtDia1.Value
LOCAL nDia2:= WinMain.txtDia2.Value
LOCAL nStep:= WinMain.txtStep.Value
LOCAL nPen := WinMain.txtNPen.Value

LOCAL aYVal:={}
LOCAL aXVal:={}
LOCAL aSer:={}
LOCAL aSer0:={}                            && straight line
LOCAL aSer1:={}                            && 1st graph
LOCAL aGrid1:={}
LOCAL aSer2:={}                            && 2nd graph
LOCAL aGrid2:={}
LOCAL lxGrid:=GetProperty ('WinMain','Chk2','VALUE')
LOCAL lyGrid:=GetProperty ('WinMain','Chk1','VALUE')

LOCAL aClr:= {WinClr,RED,BLUE}
LOCAL aSerName:={"","",""}
LOCAL nDc:=0, cRight2, XV, nInt, nLen, cExpr, Rez
LOCAL nMax,nMin,lAdd,cTit:='',nGra, i

cMess:=''
cRight2:=Right(AllTrim(Str(nStep)),2)
IF cRight2<>'00'
    nDc=IIF(Right(cRight2,1)='0', 1, 2 )
ENDIF
XV:=nDia1

DO WHILE XV <= nDia2                 && 1st graph
    nInt:=Len(Alltrim(Str(Int(XV))))+1
    IF XV<0
       nInt++
    ENDIF
    nLen:=IIF(nDc=0,nInt,nInt+1+nDc)
    AAdd(aYVal,Alltrim(Str(XV,nLen,nDc)))
    IF Empty(cExpTran1)=.f.
       cExpr:=StrTran(cExpTran1,'X',AllTrim(Str(XV)))
       Rez := &( cExpr)
       AAdd(aSer1,Rez)
    ENDIF
    IF Empty(cExpTran2)=.f.
       cExpr:=StrTran(cExpTran2,'X',AllTrim(Str(XV)))
       Rez := &( cExpr)
       AAdd(aSer2,Rez)
    ENDIF
    XV+=nStep
ENDDO
nMax:=0
nMin:=0
lAdd:=.F.
FOR i=1 TO Len(aSer1)
       nMax:=Max(nMax,aSer1[i])
       nMin:=Min(nMin,aSer1[i])
NEXT
FOR i=1 TO Len(aSer2)
       nMax:=Max(nMax,aSer2[i])
       nMin:=Min(nMin,aSer2[i])
NEXT
IF nMin<0
   IF nMax<=Abs(nMin)
      lAdd:=.t.
   ENDIF
ENDIF
FOR i=1 TO Len(aYVal)                && straight line
    IF lAdd=.t.
       AAdd(aSer0,Round(Abs(nMin),nDc))
    ELSE
       AAdd(aSer0,0)
    ENDIF

    IF Empty(cExpTran1)=.F.
       AADD( aGrid1, { Str(i,3), aYVal[i], Alltrim(Str(aSer1[i])) } )
    ENDIF
    IF Empty(cExpTran2)=.F.
       AADD( aGrid2, { Str(i,3), aYVal[i], Alltrim(Str(aSer2[i])) } )
    ENDIF
NEXT
AAdd(aSer,aSer0)
IF Len(aSer1)=0
   AAdd(aSer,aSer2)
   AAdd(aSer,aSer2)
ELSEIF Len(aSer2)=0
   AAdd(aSer,aSer1)
   AAdd(aSer,aSer1)
ELSE 
   AAdd(aSer,aSer1)
   AAdd(aSer,aSer2)
ENDIF
IF Empty(cMess)=.F.
   MsgInfo(cMess,cNameApp)
ENDIF

IF Empty(cExpF1)=.f.
   cTit:=cTit+"Y1="+cExpF1+'  '
   nGra:=1
ENDIF
IF Empty(cExpF2)=.f.
   cTit:=cTit+"Y2="+cExpF2
   nGra:=2
ENDIF
IF Empty(cExpF1)=.f. .AND. Empty(cExpF2)=.f.
   nGra:=0
ENDIF

nPen:=Min(Max(nPen,1),5)
aPointG:=GraShow( cWinGraph,5,0,480,620,aSer,cTit,aYVal,5,15,15,lxGrid,lyGrid,aSerName,aClr,nGra,nPen )
@ 25,610 GRID Grid1 OF WinGraph WIDTH 175 HEIGHT 220 ;
            HEADERS {' #','X   ','Y1   '} WIDTHS {30,55,65} ITEMS aGrid1 VALUE 1 ;
            JUSTIFY {1,1,1} FONT 'Arial' SIZE 8 FONTCOLOR RED;
            ON CHANGE MovePoint(This.Name)
@ 245,610 GRID Grid2 OF WinGraph WIDTH 175 HEIGHT 220 ;
            HEADERS {' #','X   ','Y2   '} WIDTHS {30,55,65} ITEMS aGrid2 VALUE 1 ;
            JUSTIFY {1,1,1} FONT 'Arial' SIZE 8 FONTCOLOR BLUE;
            ON CHANGE MovePoint(This.Name)
IF GetProperty ('WinMain','Chk3','VALUE')=.F.
   SetProperty('WinGraph','LblPoint1','Visible', .F.)
   SetProperty('WinGraph','LblPoint2','Visible', .F.)
ELSE
   SetProperty('WinGraph','LblPoint1','Visible', !Empty(cExpF1))
   SetProperty('WinGraph','LblPoint2','Visible', !Empty(cExpF2))
ENDIF
SetProperty('WinGraph','LblPoint1','Width' , GetProperty('WinGraph','LblPoint1','Width')+nPen)
SetProperty('WinGraph','LblPoint1','Height', GetProperty('WinGraph','LblPoint1','Height')+nPen)
SetProperty('WinGraph','LblPoint2','Width' , GetProperty('WinGraph','LblPoint2','Width')+nPen)
SetProperty('WinGraph','LblPoint2','Height', GetProperty('WinGraph','LblPoint2','Height')+nPen)
RETURN

*--------------------------------------------------------*
PROCEDURE MovePoint(NameGrid)
*--------------------------------------------------------*
LOCAL nRow:=GetProperty ('WinGraph',NameGrid,'VALUE')
IF GetProperty ('WinMain','Chk3','VALUE')=.T.
   IF NameGrid='Grid1'
      SetProperty ('WinGraph','LblPoint1','ROW',aPointG[2,nRow,1]-3)
      SetProperty ('WinGraph','LblPoint1','COL',aPointG[2,nRow,2]-3)
   ELSEIF NameGrid='Grid2'
      SetProperty ('WinGraph','LblPoint2','ROW',aPointG[3,nRow,1]-3)
      SetProperty ('WinGraph','LblPoint2','COL',aPointG[3,nRow,2]-3)
   ENDIF
   RedrawWindow( GetControlHandle('LblPoint1', 'WinGraph' ) )
   RedrawWindow( GetControlHandle('LblPoint2', 'WinGraph' ) )
ENDIF
RETURN

*--------------------------------------------------------*
PROCEDURE Form2File(cType)
*--------------------------------------------------------*
LOCAL nCount:=GetProperty ('WinGraph','Grid1','ITEMCOUNT')
LOCAL i, cFileG, cFileT, cTit1, cTit2

FOR i=1 TO 999
    cFileG:=PathGraph+'graph_'+Alltrim(Str(i))+'.bmp'
    IF !File(cFileG)
       EXIT
    ENDIF
NEXT
cTit1:=IIF(Empty(cExpF1)=.T.,'',"Y1="+cExpF1)
cTit2:=IIF(Empty(cExpF2)=.T.,'',"Y2="+cExpF2)
IF cType='RTF'
   cFileT:=PathGraph+'graph_'+Alltrim(Str(i))+'.rtf'
   Gra2RTF(cFileT,cTit1,cTit2)
ELSEIF cType='XLS'
   cFileT:=PathGraph+'graph_'+Alltrim(Str(i))+'.xls'
   Gra2XLS(cFileT,cTit1,cTit2)
ENDIF
WinGraph.width:=615
DO EVENTS
WndCopy( GetFormHandle('WinGraph'), .f., cFileG )
WinGraph.width:=800
MsgInfo('Look for graph in the file '+cFileG+CRLF+;
	'Look for table in the file '+cFileT, cNameApp)
RETURN

*--------------------------------------------------------*
PROCEDURE Gra2XLS(FileT,cTit1,cTit2)
*--------------------------------------------------------*
LOCAL oExcel, oSheet, oRange, cCell, cText, i
LOCAL nCount1:=GetProperty ('WinGraph','Grid1','ITEMCOUNT')
LOCAL nCount2:=GetProperty ('WinGraph','Grid2','ITEMCOUNT')
LOCAL nCount:=Max(nCount1,nCount2), aItem1, aItem2, cEndT

oExcel := TOleAuto():New("Excel.Application")
IF oExcel=NIL
   RETURN
ENDIF
oExcel:WorkBooks:Add()
oSheet:= oExcel:Get( "ActiveSheet" )
cText := '#'+ Chr( 9 )+'  Value X  '+ Chr( 9 )+'  Value Y1  '+ Chr( 9 )+'  Value Y2 '+ Chr( 13 )
FOR i=1 TO nCount
    aItem1:=GetProperty ('WinGraph','Grid1','ITEM',i)
    aItem2:=GetProperty ('WinGraph','Grid2','ITEM',i)
    IF nCount1=0
       cText=cText+aItem2[1] + Chr( 9 )+StrTran(aItem2[2], '.' , ',') + Chr( 9 )+'  '+ Chr( 9 )+StrTran(aItem2[3], '.' , ',') + Chr( 13 )
    ELSEIF nCount2=0
       cText=cText+aItem1[1] + Chr( 9 )+StrTran(aItem1[2], '.' , ',') + Chr( 9 )+StrTran(aItem1[3], '.' , ',') + Chr( 9 )+'  ' + Chr( 13 )
    ELSE
       cText=cText+aItem1[1] + Chr( 9 )+StrTran(aItem1[2], '.' , ',') + Chr( 9 )+StrTran(aItem1[3], '.' , ',') + Chr( 9 )+StrTran(aItem2[3], '.' , ',') + Chr( 13 )
    ENDIF
NEXT
CopyToClipboard( cText )
cCell := "A5"
oRange := oSheet:Range( cCell )
oRange:Select()
oSheet:Paste()

oRange := oSheet:Range("A5:D5")
oRange:Set( "HorizontalAlignment", 7 )
oRange:Font:Bold := .T.
oRange:Font:Size := 10
cEndT=AllTrim( Str(nCount+5) )
* table framing overshadow
oRange := oSheet:Range("A5:D"+cEndT)
oRange:Borders():LineStyle := 1
oRange:Set( "HorizontalAlignment", 7 )
oRange:Columns:AutoFit()

oSheet:Cells(1,1):Value:='Table of functions values'
oSheet:Cells(2,1):Value:=cTit1+' '+cTit2
oSheet:Cells(3,1):Value:='Date:  '+dtoc(date())

oRange := oSheet:Range("A1:A2")
oRange :FONT:Size:=10
oRange :Font:Bold := .T.
oSheet:Range( "A1" ):Select()
oSheet:SaveAS(FileT) 
oExcel:Quit()

RETURN

*--------------------------------------------------------*
PROCEDURE Gra2RTF(cFileT,cTit1,cTit2)
*--------------------------------------------------------*
LOCAL nCount := GetProperty ('WinGraph','Grid1','ITEMCOUNT')
LOCAL HandDoc, i, aItem1, aItem2
LOCAL aZag:={ {' #',1000}, {'Value X',3000}, {'Value Y1',5000}, {'Value Y2',7000} }

HandDoc:=fCreate(cFileT)
FWrite(HandDoc,HEADRTF+CLRTBL) 
FWrite(HandDoc,FTIMES+FBOLD+FS12+'       Table of functions values'+ENDP)
FWrite(HandDoc,FTIMES+FBOLD+FS12+'       '+cTit1+ENDP)
FWrite(HandDoc,FTIMES+FBOLD+FS12+'       '+cTit2+ENDP)
CreateTableRTF(HandDoc,aZag)
FWrite(HandDoc,FCOURIER+FS10+FBOLD_)
FOR i=1 TO nCount
    aItem1:=GetProperty ('WinGraph','Grid1','ITEM',i)
    aItem2:=GetProperty ('WinGraph','Grid2','ITEM',i)
    FWrite(HandDoc,"\intbl"+PadL(AllTrim(aItem1[1]),4)+ENDC+PadL(aItem1[2],10)+ENDC+PadL(aItem1[3],10)+ENDC+PadL(aItem2[3],10)+ENDC+ENDR+CRLF) 
NEXT
FWrite(HandDoc,"\pard\nowidctlpar\fi-108\li108  \par}") && END ALL
fClose(HandDoc)
RETURN

*--------------------------------------------------------*
PROCEDURE CreateTableRTF(Hand,aZag,trl)
*--------------------------------------------------------*
* trl - indention from edge in twips
LOCAL nLenA:=Len(aZag)
LOCAL i
IF trl=NIL
   trl:='0'
ENDIF
* Header
FWrite(Hand,"\trowd\trgaph108\trleft"+trl)
FWrite(Hand,TBL+CRLF)
FOR i=1 TO nLenA
   FWrite(Hand,INITCELL+AllTrim(STR(aZag[i,2]))+INTBL+aZag[i,1]+ENDC)
NEXT
FWrite(Hand,+ENDR+CRLF)
* Separator
FWrite(Hand,"\fs2\trowd\trgaph108\trleft"+trl)
FWrite(Hand,TBL+CRLF)
FWrite(Hand,INITCELL+AllTrim(STR(aZag[nLenA,2]))+"\intbl\cell\row"+CRLF)
* Main table
FWrite(Hand,"\trowd\trgaph108\trleft"+trl)
FWrite(Hand,TBL+CRLF)
FOR i=1 TO Len(aZag)
   FWrite(Hand,INITCELL+AllTrim(STR(aZag[i,2]))+CRLF)
NEXT
RETURN

*--------------------------------------------------------*
FUNCTION SinF(x)
*--------------------------------------------------------*
RETURN IIF(WinMain.rgUg.Value=1,Sin(DTOR(x)),Sin(x))

*--------------------------------------------------------*
FUNCTION CosF(x)
*--------------------------------------------------------*
RETURN IIF(WinMain.rgUg.Value=1,Cos(DTOR(x)),Cos(x))

*--------------------------------------------------------*
FUNCTION Tg(x)
*--------------------------------------------------------*
IF WinMain.rgUg.Value=2
   x:=RToD(x)
ENDIF
IF Mod(x,90)<4
   x:=x-4
ENDIF
RETURN Tan(DTOR(x))

*--------------------------------------------------------*
FUNCTION ArcSinF(x)
*--------------------------------------------------------*
IF x>1
   IF AT('ArcSin',cMess)=0
      cMess+='ArcSin - Invalid argument'+CRLF 
   ENDIF
   X:=1
ENDIF
RETURN IIF(WinMain.rgUg.Value=1,RToD(ASin(x)),ASin(x))

*--------------------------------------------------------*
FUNCTION ArcCosF(x)
*--------------------------------------------------------*
IF x>1
   IF AT('ArcCos',cMess)=0
      cMess+='ArcCos - Invalid argument'+CRLF 
   ENDIF
   X:=1
ENDIF
RETURN IIF(WinMain.rgUg.Value=1,RToD(ACos(x)),ACos(x))

*--------------------------------------------------------*
FUNCTION ArcTg(x)
*--------------------------------------------------------*
RETURN IIF(WinMain.rgUg.Value=1,RToD(ATan(x)),ATan(x))

*--------------------------------------------------------*
FUNCTION RD(x)
*--------------------------------------------------------*
RETURN RToD(x)

*--------------------------------------------------------*
FUNCTION DR(x)
*--------------------------------------------------------*
RETURN DToR(x)

*--------------------------------------------------------*
FUNCTION Lg(x)
*--------------------------------------------------------*
IF x<=0
   IF AT('Lg',cMess)=0
      cMess+='Lg - Invalid argument'+CRLF 
   ENDIF
   RETURN 0
ENDIF
RETURN Log10(x)

*--------------------------------------------------------*
FUNCTION Ln(x)
*--------------------------------------------------------*
IF x<=0
   IF AT('Ln',cMess)=0
      cMess+='Ln - Invalid argument'+CRLF 
   ENDIF
   RETURN 0
ENDIF
RETURN Log(x)

*--------------------------------------------------------*
FUNCTION Sqr(x)
*--------------------------------------------------------*
IF x<0
   cMess+='Sqr - Invalid argument'+CRLF 
   RETURN 0
ENDIF
RETURN SQRT(x)

*--------------------------------------------------------*
FUNCTION BoxIn2(cWin,r1,c1,r2,c2,nD)
*--------------------------------------------------------*
LOCAL ib
FOR ib=1 to nD
        BoxIn(cWin,r1+ib,c1+ib,r2-ib,c2-ib)
NEXT
RETURN NIL

*--------------------------------------------------------*
Function BoxIn(window,row,col,rowr,colr)
*--------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i] 
   Local hDC := GetDC( FormHandle )

   WndBoxIn( hDC, row, col, rowr, colr )
   ReleaseDC( FormHandle, hDC )
   Aadd( _HMG_aFormGraphTasks [i] , { || WndBoxIn( hDC := GetDC( FormHandle ), row, col, rowr, colr ), ReleaseDC( FormHandle, hDC ) } )
RETURN NIL
