#define __SYSDATA__
#include 'minigui.ch'             

*--------------------------------------------------------*
FUNCTION GraShow(parent,nTop,nLeft,nBottom,nRight,aData,;
	cTitle,aYVals,nBarD,nWideB,nXRanges,;
	lxGrid,lyGrid,aSeries,aColors,nGra,nPen)
*--------------------------------------------------------*

LOCAL nI, nJ, nPos, nMax, nMin, nMaxBar 
LOCAL nRange, nResH, nResV,  nWide, aPoint, cName
LOCAL nXMax, nXMin, nHigh, nRel, nZero, nRPos, nRNeg
LOCAL MaxYLen:=1, lZero, i, nStep, nPic, nYVal, nKrat
If ( Len (aSeries) != Len (aData) ) .or. ( Len (aSeries) != Len (aColors) ) 
   MsgStop("DRAW GRAPH: 'Series' / 'SerieNames' / 'Colors' arrays size mismatch.",cNameApp)
   RETURN {}
EndIf

nBottom -=  42
nRight  -=  32
nTop    += 1 + IF(Empty(cTitle), 30, 44)	// Top gap
nLeft   += 1 + 80 + nBarD			// Left
nMaxBar := nBottom - nTop - 5
nResH   := nResV := 1
nWide   := ( nRight - nLeft )*nResH / ( nMax(aData) + 1 ) * nResH
// Graph info
//
@ nTop-30*nResV, nLeft LABEL Graph_Title OF &parent ;
	VALUE cTitle WIDTH nRight - nLeft HEIGHT 18 ;
	FONT "Times" SIZE 11 BOLD CENTERALIGN BACKCOLOR WinClr
	RedrawWindow( GetControlHandle( 'Graph_Title', parent ) )

// Max, Min values
nMax := 0
FOR nJ := 1 TO Len(aSeries)
    FOR nI :=1 TO Len(aData[nJ])
         nMax := Max( aData[nJ][nI], nMax )
    NEXT nI
NEXT nJ
nMin := 0
FOR nJ := 1 TO Len(aSeries)
    FOR nI :=1 TO Len(aData[nJ])
         nMin := Min( aData[nJ][nI], nMin )
    NEXT nI
NEXT nJ

nXMax := IF( nMax > 0, DetMaxVal( nMax ), 0 )
nXMin := IF( nMin < 0, DetMaxVal( nMin ), 0 )
nHigh := nXMax + nXMin
nMax  := Max( nXMax, nXMin )
nRel  := ( nMaxBar / nHigh )
nMaxBar := nMax * nRel
nZero := nTop + (nMax*nRel) +  5    // Zero pos
aPoint := Array( Len( aSeries ), Len( aData[1] ), 2 )
nRange := nMax / nXRanges

// xLabels
nRPos := nRNeg := nZero
IF lxGrid         &&    
   FOR nI := 0 TO nXRanges
     IF nRange*nI <= nXMax
        cName := "xPVal_Name_"+Ltrim(Str(nI))
        @ nRPos-5, nLeft-70 LABEL &cName OF &parent ;
		VALUE Transform(nRange*nI, '9999999.99') ;
		WIDTH 60 HEIGHT 14 ;
		FONTCOLOR BLACK  FONT "Arial" SIZE 8  RIGHTALIGN BACKCOLOR WinCLR
        RedrawWindow( GetControlHandle( cName, parent ) )
     ENDIF
     IF nRange*(-nI) >= nXMin*(-1)
        cName := "xNVal_Name_"+Ltrim(Str(nI))
        @ nRNeg-5, nLeft-70 LABEL &cName OF &parent ;
		VALUE Transform(nRange*-nI, '9999999.99') ;
		WIDTH 60 HEIGHT 14 ;
		FONTCOLOR BLACK FONT "Arial" SIZE 8 RIGHTALIGN BACKCOLOR WinCLR
 	RedrawWindow( GetControlHandle( cName, parent ) )
     ENDIF
     IF nRange*nI <= nXMax
        DrawLine( parent, nRPos, nLeft, nRPos, nRight, {160,160,160} )
     ENDIF
     IF nRange*-nI >= nXMin*-1
        DrawLine( parent, nRNeg, nLeft, nRNeg, nRight, {160,160,160} )
     ENDIF
     nRPos -= ( nMaxBar / nXRanges )
     nRNeg += ( nMaxBar / nXRanges )
   NEXT nI
Else
   DrawLine( parent, nZero-1, nLeft-2, nZero-1, nRight, BLACK,1 ) && horizontal thickness
ENDIF

nPos:= nTop-5 
IF  Len(aYVals) > 0                // Show yLabels
      lZero:=IIF(Val(aYVals[1])<=0,.T.,.F.)
      FOR i=1 TO Len(aYVals)          && detect Max length
          MaxYLen:=Max(MaxYLen,Len(aYVals[i]))
      NEXT
      nStep:= Abs(Val(aYVals[2])-Val(aYVals[1]))
      nWideB  := ( nRight - nLeft ) / ( nMax(aData) + 1 )
      nI := nLeft + nWideB
      nPic := nWideB/nStep
      FOR nJ := 1 TO nMax(aData)
         nYVal:=VAL(aYVals[nJ])
         nKrat:=Int((Len(aYVals)*MaxYLen)/80)+1     && vertical lines and inscriptions count
         IF Mod(nJ,nKrat)=0 
            IF lYGrid=.t.        && vertical lines
               Drawline( parent, nBottom, nI, nPos, nI, {160,160,160} )
               cName := "yVal_Name_"+Ltrim(Str(nJ))
               @ nBottom + 8, nI -  8 LABEL &cName OF &parent ;
  		       VALUE aYVals[nJ] HEIGHT 20 AUTOSIZE ;
		       FONTCOLOR BLACK 	FONT "Arial" SIZE 8  TRANSPARENT
            ELSE
              IF lZero=.T.
                 DrawLine( parent, nTop, ni-nYVal*nPic, nBottom-2, ni-nYVal*nPic, BLACK,1 )
                 lZero=.F.
              ENDIF
            ENDIF
         ENDIF
         nI += nWideB
      NEXT
ENDIF

nMin := nMax / nMaxBar
nPos := nLeft + ( ( nWide) / 2 )            // first point graph
nRange := ( ( nWide ) * Len(aSeries) ) / 2

// Lines
//
nWideB  := ( nRight - nLeft ) / ( nMax(aData) + 1 )
nPos := nLeft + nWideB
FOR nI := 1 TO Len(aData[1])
    FOR nJ=1 TO Len(aSeries)
            aPoint[nJ,nI,2] := nPos
            aPoint[nJ,nI,1] := nZero - ( aData[nJ,nI] / nMin)
    NEXT nJ
    nPos += nWideB
NEXT nI
FOR nI := 1 TO Len(aData[1])-1
    FOR nJ := 2 TO Len(aSeries)           && without first value
        IF nGra=0
           DrawLine(parent,aPoint[nJ,nI,1],aPoint[nJ,nI,2],aPoint[nJ,nI+1,1],aPoint[nJ,nI+1,2],aColors[nJ],nPen)
        ELSEIF nGra=1
           DrawLine(parent,aPoint[nJ,nI,1],aPoint[nJ,nI,2],aPoint[nJ,nI+1,1],aPoint[nJ,nI+1,2],RED,nPen)
        ELSEIF nGra=2
           DrawLine(parent,aPoint[nJ,nI,1],aPoint[nJ,nI,2],aPoint[nJ,nI+1,1],aPoint[nJ,nI+1,2],BLUE,nPen)
        ENDIF
    NEXT nI
NEXT nI
RETURN aPoint

*--------------------------------------------------------*
STATIC FUNCTION nMax(aData)
*--------------------------------------------------------*
   LOCAL nI, nMax := 0

   FOR nI :=1 TO Len( aData )
      nMax := Max( Len(aData[nI]), nMax )
   NEXT nI

RETURN( nMax )

*--------------------------------------------------------*
STATIC FUNCTION DetMaxVal(nNum)
*--------------------------------------------------------*
   LOCAL nE, nMax, nMan, nVal, nOffset

   nE:=9
   nVal:=0
   nNum:=Abs(nNum)

   DO WHILE .T.

      nMax := 10**nE

      IF Int(nNum/nMax)>0

         nMan:=(nNum/nMax)-Int(nNum/nMax)
         nOffset:=1
         nOffset:=IF(nMan<=.75,.75,nOffset)
         nOffset:=IF(nMan<=.50,.50,nOffset)
         nOffset:=IF(nMan<=.25,.25,nOffset)
         nOffset:=IF(nMan<=.00,.00,nOffset)
         nVal := (Int(nNum/nMax)+nOffset)*nMax
         EXIT

      ENDIF

      nE--

   ENDDO

RETURN (nVal)

*--------------------------------------------------------*
function drawline(window,row,col,row1,col1,penrgb,penwidth)
*--------------------------------------------------------*
Local i := GetFormIndex ( Window )
Local FormHandle := _HMG_aFormHandles [i]

	if formhandle > 0

		if valtype(penrgb) == "U"
			penrgb = {0,0,0}
		endif
	
		if valtype(penwidth) == "U"
			penwidth = 1
		endif

		linedraw( formhandle,row,col,row1,col1,penrgb,penwidth)

		aadd ( _HMG_aFormGraphTasks [i] , { || linedraw( formhandle,row,col,row1,col1,penrgb,penwidth) } )

	endif

return nil
