/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-06 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
 *
 * Copyright 2006 Grigory Filatov <gfilatov@freemail.ru>
*/
ANNOUNCE RDDSYS

#include "minigui.ch"
#include "fileio.ch"

#define PROGRAM 'QuickSplit'
#define VERSION " v.1.1"
#define COPYRIGHT ' 2006, Grigory Filatov'

#define IDI_MAIN	1001
#define NTRIM( n )	LTrim( Str( n ) )
#define MsgInfo( c, t ) MsgInfo( c, t, IDI_MAIN, .f. )
#define MsgStop( c, t ) MsgStop( c, t, , .f. )

Static lexit := .F., nUnits := 0
Memvar cFileIni
/*
*/
PROCEDURE Main
LOCAL nDestSize := 1.44, nSizeType := 3, lCreateBatFile := .T., ;
	cFile := "", cFolder := "", aEscBlock := {|| NIL}

	PUBLIC cFileIni := GetStartUpFolder() + "\" + PROGRAM + '.ini'

	IF FILE(cFileIni + '.ini')
		BEGIN INI FILE cFileIni
			GET nDestSize SECTION "Settings" ENTRY "DestSize"
			GET nSizeType SECTION "Settings" ENTRY "SizeType"
			GET lCreateBatFile SECTION "Settings" ENTRY "CreateBatFile"
		END INI
	ELSE
		BEGIN INI FILE cFileIni
			SET SECTION "Settings" ENTRY "DestSize" TO nDestSize
			SET SECTION "Settings" ENTRY "SizeType" TO nSizeType
			SET SECTION "Settings" ENTRY "CreateBatFile" TO lCreateBatFile
		END INI
	ENDIF

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 422 HEIGHT IF(IsXPThemeActive(), 148, 142) ;
		TITLE PROGRAM ;
		ICON IDI_MAIN ;
		MAIN ;
		NOMAXIMIZE NOSIZE ;
		FONT "MS Sans Serif" SIZE 8 ;
		ON RELEASE IF(Empty(cFile), , SaveSettings())

		@ 10,2 LABEL Label_1 VALUE "Source file:" WIDTH 56 RIGHTALIGN
		@ 7,62 BTNTEXTBOX Text_1 WIDTH 345 HEIGHT 22 ;
			VALUE '' ;
			ACTION {|| cFile := GetFile( NIL, NIL, ;
				IF( Empty(cFile), GetMyDocumentsFolder(), cFilePath(cFile) ), .F., .F. ), ;
				IF( Empty(cFile), , ( Form_1.Text_1.Value := cFile, ;
				Form_1.Text_2.Value := cFilePath(cFile) + "\", lExistFile(cFile), Form_1.Text_1.SetFocus ) ) } ;
			PICTURE "OPEN" ;
			BUTTONWIDTH 19

		@ 38,2 LABEL Label_2 VALUE "Split to:" WIDTH 56 RIGHTALIGN
		@ 35,62 BTNTEXTBOX Text_2 WIDTH 345 HEIGHT 22 ;
			VALUE '' ;
			ACTION {|| cFolder := GetFolder(), ;
			IF( Empty(cFolder), , ( Form_1.Text_2.Value := cFolder, Form_1.Text_2.SetFocus ) ) } ;
			PICTURE "OPEN" ;
			BUTTONWIDTH 19

		@ 66,2 LABEL Label_3 VALUE "Split size:" WIDTH 56 RIGHTALIGN
		@ 63,62 GETBOX Text_3 WIDTH 44 HEIGHT 22 ;
			VALUE nDestSize ;
			PICTURE "9999.99" ;
			ON CHANGE IF(lExistFile(cFile), nDestSize := Form_1.Text_3.Value, )

		@ 63,108 COMBOBOX ComboBox_1 ;
			ITEMS {"Bytes", "KBytes", "MBytes"} ;
			VALUE nSizeType WIDTH 60 ;
			ON CHANGE IF(lExistFile(cFile), nSizeType := Form_1.ComboBox_1.Value, ) ;
			ON LISTDISPLAY ( aEscBlock := EscapeOff() ) ;
			ON LISTCLOSE ( EscapeOn(aEscBlock) )

		@ 64,175 CHECKBOX CheckBox_1 CAPTION 'Create BAT file' VALUE lCreateBatFile ;
			WIDTH 90 HEIGHT 22

		@ 62,305 BUTTON Button_1 ;
		CAPTION '? ' ;
		ACTION MsgAbout() ;
		WIDTH 26 HEIGHT 24

		@ 62,348 BUTTON Button_2 ;
		CAPTION '&Split' ;
		ACTION {|| Form_1.Button_2.Visible := .F., Form_1.Button_3.Visible := .T., Form_1.Button_3.SetFocus, ;
			SplitFile( Form_1.Text_1.Value, Form_1.Text_2.Value, Form_1.Text_3.Value, ;
			Form_1.ComboBox_1.Value, Form_1.CheckBox_1.Value ), lexit := .F., Form_1.ProgressBar_1.Value := 0, ;
			Form_1.Button_3.Visible := .F., Form_1.Button_2.Visible := .T., Form_1.Button_2.SetFocus } ;
		WIDTH 59 HEIGHT 24

		@ 62,348 BUTTON Button_3 ;
		CAPTION '&Cancel' ;
		ACTION lexit := .T. ;
		WIDTH 59 HEIGHT 24

		DRAW BOX IN WINDOW Form_1 AT 91,6 TO 109,299

		@ 93,7 LABEL Label_4 VALUE "None" WIDTH 290 HEIGHT 15

		@ 91,305 PROGRESSBAR ProgressBar_1 RANGE 0, 100 ;
			WIDTH 102 HEIGHT 19 SMOOTH

		ON KEY ESCAPE ACTION ( cFile := "", ThisWindow.Release )

	END WINDOW

	Form_1.Button_3.Visible := .F.

	CENTER WINDOW Form_1
	ACTIVATE WINDOW Form_1

RETURN
/*
*/
Static Function lExistFile( cSource )
local hsource       := 0          // file handle for source file
local nfilesize     := 0          // file size to be split
local nbyte                       // size of each split file
local nkoef
local nSizeType := Form_1.ComboBox_1.Value, nDestSize := Form_1.Text_3.Value

	if empty(cSource) .OR. !file(cSource)
		Form_1.Label_4.Value := "File doesn't exist!"
		return .F.
	endif

	nkoef := if( nSizeType == 1, 1, if( nSizeType == 2, 1024, 1024 * 1024 ) )
	nDestSize := if( nSizeType == 1, Int(nDestSize), nDestSize )
	// size of each split file
	nbyte := nDestSize * nkoef

	// open the source file
	if ( hsource := fopen( csource,FO_READ+FO_SHARED) ) <> -1
		// is file size smaller than chunk size ?
		if ( nfilesize := fseek( hsource, 0 , FS_END ) ) <= nbyte
			Form_1.Label_4.Value := "File size is smaller than unit size!"
		else
			nUnits := Round(nfilesize / nbyte + .5, 0)
			Form_1.Label_4.Value := Form_1.Label_1.Value + " " + NTRIM( Round(nfilesize / nkoef, 1) ) + " " + ;
				Form_1.ComboBox_1.Item(nSizeType) + ", Split: " + NTRIM( nUnits ) + " files"
		endif
		fclose( hsource )
	else
		return .F.
	endif

Return .T.
/*
*/
FUNCTION SplitFile(cSource, cTarget, nDestSize, nSizeType, lCreateBatFile)
local i                           // general counter
local ccommand      := ""         // dos command for joining files
local nbufsize      := 16         // 16k for buffer Read/Write
local hsource       := 0          // file handle for source file
local hdestination  := 0          // file handle for destination file
local cbuffer       := ""         // buffer for read/write
local nblock        := 0          // bytes read
local ncurrent      := 0          // total bytes copied
local nsplit        := 1          // destination file name extension
local cbat                        // for joining split files
local ctmp          := "@echo off" + CRLF // 1st line in .bat
local cdestination                // destination filename
local hbat                        // file handle for .bat
local afile         := {}         // for information upon completion
local nfilesize     := 0          // file size to be split
local hfile         := 0          // split file sizes
local lsplit        := .f.        // return value
local csplit                      // destination name
local nbyte                       // size of each split file
local nkoef

if lExistFile( cSource )

	csplit := cFileNoExt( cSource ) + "."    // destination name
	cbat   := cTarget + csplit + "bat"       // batch name

	nkoef := if( nSizeType == 1, 1, if( nSizeType == 2, 1024, 1024 * 1024 ) )
	nDestSize := if( nSizeType == 1, Int(nDestSize), nDestSize )
	// size of each split file
	nbyte := nDestSize * nkoef

	// open the source file
	if ( hsource := fopen( csource,FO_READ+FO_SHARED) ) <> -1
		nfilesize := fseek( hsource, 0 , FS_END )
		fseek( hsource, 0, FS_SET )                           // go to top of file
		cdestination := cTarget + csplit + NTRIM(nsplit)      // destination file name

		if lCreateBatFile
			hbat         := fcreate( cbat )               // .bat
			ctmp         += "rem source file " + cFileName(cSource) + " size " + NTRIM(nfilesize) + CRLF
			ctmp         += "rem split on " + dtoc(date()) + " "+ time() + CRLF
			ccommand     := "copy /b "                    // line in join.bat
			ccommand     += cFileName(cdestination) + "+" // line in join.bat
		endif

		hdestination := fcreate(cdestination)                 // create 1st split file
		if nSizeType == 2
			nbufsize     := 1024                            // buffer size
		elseif nSizeType == 3
			nbufsize     *= 1024                            // buffer size
		endif
		cbuffer      := space( nbufsize )                     // buffer read/write

		if lCreateBatFile
			aadd( afile, cbat )
			aadd( afile, cdestination )
		endif

		while !lsplit .and. !lexit
			lsplit := ( ( ( nblock := fread( hsource, @cbuffer, nbufsize ) ) == 0 ) .or. ;
				( fwrite ( hdestination, cbuffer, nblock ) < nblock ) )
			ncurrent += nblock
			Form_1.ProgressBar_1.Value := nsplit * 100 / nUnits
			if ncurrent >= nbyte                                        // files size already exceed ?
				fclose( hdestination )                              // close file
				ncurrent      := 0                                  // reset counter
				cdestination  := cTarget + csplit + NTRIM(++nsplit) // next file name
				if lCreateBatFile
					ccommand += cFileName(cdestination) + "+"   // line in join.bat
				endif
				hdestination  := fcreate(cdestination)              // create next file
				if lCreateBatFile
					aadd( afile, cdestination )
				endif
			endif
			do events
		enddo

		fclose( hsource )         // close source file
		fclose( hdestination )    // close split file

		inkey(.2)
		do events

		if lCreateBatFile
			ccommand := left( ccommand, Rat("+",ccommand ) - 1 ) + " "  // line in .bat
			ccommand += cFileName(cSource) + CRLF                       // line in .bat
			ctmp += "rem the following files should be placed in a directory"+CRLF
			for i := 2 to len( afile )
				hfile     := fopen( afile[i], FO_READ+FO_SHARED )
				nfilesize := fseek( hfile, 0 , FS_END )
				fclose( hfile )
				ctmp += "rem " + cFileName(afile[i]) + " - " + NTRIM(nfilesize) + CRLF
			next
			for i := 2 to len( afile )                                  // error checker
				ctmp += "if not exist " + cFileName(afile[i]) + " goto error" + NTRIM(i - 1) + CRLF
			next
			ctmp += ccommand
			ctmp += "goto end" + CRLF
			for i := 2 to Len( afile )
				ctmp += ":error" + NTRIM(i - 1) + CRLF
				ctmp += "echo missing file " + cFileName(afile[i]) + CRLF
				ctmp += "goto end" + CRLF
			next
			ctmp += ":end" + CRLF
			fwrite( hbat, ctmp )                                        // write .bat
			fclose( hbat )                                              // close handle
		endif
	endif
endif

RETURN lsplit
/*
*/
Static Function MsgAbout()
return MsgInfo( padc(PROGRAM + VERSION, 42) + CRLF + ;
	"Copyright " + Chr(169) + COPYRIGHT + CRLF + CRLF + ;
	hb_compiler() + CRLF + version() + CRLF + ;
	Left(MiniGuiVersion(), 28) + CRLF + CRLF + ;
	padc("This program is Freeware!", 38), "About" )
/*
*/
Static Function SaveSettings()
LOCAL nDestSize := Form_1.Text_3.Value, nSizeType := Form_1.ComboBox_1.Value, ;
	lCreateBatFile := Form_1.CheckBox_1.Value

	BEGIN INI FILE cFileIni
		SET SECTION "Settings" ENTRY "DestSize" TO nDestSize
		SET SECTION "Settings" ENTRY "SizeType" TO nSizeType
		SET SECTION "Settings" ENTRY "CreateBatFile" TO lCreateBatFile
	END INI

RETURN NIL
/*
*/
STATIC FUNCTION EscapeOff
LOCAL bKeyBlock, abRetVal := {}

STORE KEY ESCAPE OF Form_1 TO bKeyBlock
AADD( abRetVal, bKeyBlock )
RELEASE KEY ESCAPE OF Form_1

RETURN( abRetVal )
/*
*/
STATIC PROCEDURE EscapeOn( aKeyBlock )

_DefineHotKey( "Form_1", 0, 27, aKeyBlock[1] )

RETURN
/*
*/
Function cFileName( cPathMask )
return cFileNoPath( cPathMask )
/*
*/
Function cFilePath( cPathMask )
LOCAL n := RAt( "\", cPathMask )
return If( n > 0, Left( cPathMask, n - 1), Left( cPathMask, 2 ) )


#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC ( C_CENTER ) 
{
	RECT rect;
	int w, h, x, y;
	GetWindowRect((HWND) hb_parnl (1), &rect);
	w  = rect.right  - rect.left;
	h = rect.bottom - rect.top;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );
	x = rect.right - rect.left;
	y = rect.bottom - rect.top;
	SetWindowPos( (HWND) hb_parnl (1), HWND_TOP, (x - w) / 2, (y - h) / 2, 0, 0, SWP_NOSIZE | SWP_NOACTIVATE );
}

#pragma ENDDUMP