/* 
 * MINIGUI - Harbour Win32 GUI library Demo 
 * 
 * Copyright 2002-06 Roberto Lopez <harbourminigui@gmail.com> 
 * http://harbourminigui.googlepages.com/ 
 * 
 * Copyright 2005-06 Grigory Filatov <gfilatov@freemail.ru> 
 * Revised at 2007 By Pierpaolo Martinello <pier at bmm.it> 
 * 
*/ 

ANNOUNCE RDDSYS 

#include "minigui.ch" 
#include "fileio.ch" 

#define PROGRAM "Harbour Mailer 1.2" 

#define IDI_MAIN 1001 

#define MsgInfo( c, t ) MsgInfo( c, t, , .f. ) 
#define MsgStop( c, t ) MsgStop( c, t, , .f. ) 

DECLARE WINDOW Form_2 

Static aGet 
*-----------------------------------------------------------------------------* 
* SYNTAX: SENDMAIL [silent clog compress ] 
* With silent, it doesn't open any window 
* 
* With compress the compressed filename declares him that will contain the attached ones 
* 
* Ie. SendMail Y N Test 
* It will send an e-mail without windows and the attached file it is "Test.zip" 
* 
* Ie Sendmail Y 
* It will send an e-mail without windows. 
* The possible File attached is drawn by the file Ini 
* 
* In both the cases will be written the "Sendmail.log" file 
* 
* for silent and clog are valid Y N or 1 0 or .T. .F. or any char (=.F.) 
* Compress arg require silent arg 
* 
*-----------------------------------------------------------------------------* 

Memvar cCfgFile, cLogFile
Memvar aEntry, cCryptKey
*-----------------------------------------------------------------------------* 
PROCEDURE Main( Silent, cLog, Compress) 
*-----------------------------------------------------------------------------* 
LOCAL cPath := GetStartUpFolder() + "\", cFileName := cFileNoExt( GetExeFileName() ) 
LOCAL extraTitle := '' , i

   PRIVATE cCfgFile := cPath + Lower(cFileName) + ".ini" 
   PRIVATE cLogFile := cPath + Lower(cFileName) + ".log" 
   PRIVATE aEntry := {}, cCryptKey := REPL( "#$@%&", 2 ) 

   DEFAULT Silent to .F., Compress to '', Clog to .F. 

   If valtype(clog) == "C" .and. !empty(clog) 
      clog := Lower(clog) 
      clog := IF(clog=".t." .or. clog="clog" .or. clog="y" .or. val(clog)>0, .T., .F.) 
   Endif 

   If File( cLogFile ) 
      if clog .or. FileSize( cLogFile ) > 1000000 
         Ferase( cLogFile ) 
      endif 
   Endif 

   aAdd( aEntry, "SMTP" ) 
   aAdd( aEntry, "From" ) 
   aAdd( aEntry, "To" ) 
   aAdd( aEntry, "CC" ) 
   aAdd( aEntry, "BCC" ) 
   aAdd( aEntry, "Subject" ) 
   aAdd( aEntry, "Attachment" ) 
   aAdd( aEntry, "Message" ) 
   aAdd( aEntry, "Login" ) 
   aAdd( aEntry, "LoginMD5" ) 
   aAdd( aEntry, "User" ) 
   aAdd( aEntry, "PassWord" ) 
   aAdd( aEntry, "HTML" ) 
   aAdd( aEntry, "Silent" ) 
   aAdd( aEntry, "Compress") 

   aGet := ARRAY(15) 

   DEFAULT aget[1] TO "smtp.domain.com" 
   DEFAULT aget[2] TO "Sender <sender@domain.com>" 
   DEFAULT aget[3] TO "Recipient <recipient@domain.com>" 
   DEFAULT aget[4] TO SPACE(30) 
   DEFAULT aget[5] TO SPACE(30) 
   DEFAULT aget[6] TO "This is a Test" 
   DEFAULT aget[7] TO {} 
   DEFAULT aget[8] TO "This is a Test" 
   aGet[ 9] := .F. 
   aGet[10] := .F. 
   DEFAULT aget[11] TO "" 
   DEFAULT aget[12] TO "" 
   aGet[13] := 1 
   DEFAULT aget[14] TO Silent 

   If Pcount() = 3 
      Compress := Lower(Compress) 
      Compress := STRTRAN(Compress, ".zip", "") 
   EndIf 

   DEFAULT aget[15] TO Compress 

   IF File( cCfgFile ) 

      BEGIN INI FILE cCfgFile 

         For i := 1 To Len(aEntry) 
             GET aGet[i] SECTION "Data" ENTRY aEntry[i] 
         Next i 
         aGet[8] := STRTRAN( aGet[8], Chr(250), CRLF ) 
         aGet[12] := CHARXOR( aGet[12], cCryptKey ) 

      END INI 

   ENDIF 

   If Empty(Compress) 
      compress := aget[15] 
   Else 
      aget[15] := Compress 
   Endif 

   If valtype(Silent) == "C" .and. !empty(Silent) 
      silent := Lower(Silent) 
      if "?" $ silent 
          MsgInfo( [Syntax: ] + "Sendmail [Silent] [clear log] [Zipname] "+CRLF+CRLF+; 
                  [ ] + "where Silent are Y [.T. or 1 or silent] or N [.F. or 0]" +CRLF+; 
                  [ ] + "where clearlog are Y [.T. or 1 or clog] or N [.F. or 0] "+CRLF+; 
                  [ ] + "Zipname no need name extension '.zip'"+CRLF+CRLF+; 
                  "Ie: SendMail 0 .T. (or SendMail N 1)"+CRLF+; 
                  " Will take action clear log and open main window."+CRLF+CRLF+; 
                  "Ie: SendMail Y .T. (or SendMail clog silent)"+CRLF+; 
                  " Will take action clear log and send mail without GUI.", "Syntax Help" ) 
          return 
      endif 
      silent := IF(Silent=".t." .or. Silent="silent" .or. silent="y" .or. val(silent)>0, .T., .F.) 
       
   Endif 

   aget[14] := Silent 

   SET CENTURY ON 
   SET DATE GERMAN 

   If Silent
      M_Send(.F.) 
      RETURN 
   Endif 

   extratitle := " [ I send the file(s) attached as "+Compress+".Zip ]" 

   DEFINE WINDOW Form_1 ; 
          AT 131,220 ; 
          WIDTH 643 ; 
          HEIGHT 490 + IF(IsXPThemeActive(), 6, 0) ; 
          TITLE PROGRAM ; 
          ICON IDI_MAIN ; 
          MAIN ; 
          NOMINIMIZE NOMAXIMIZE NOSIZE ; 
          ON RELEASE SaveData() ; 
          FONT "MS Sans Serif" SIZE 10 

          DEFINE STATUSBAR 
                STATUSITEM "" 
                DATE 
                CLOCK 
          END STATUSBAR 

          @ 9,7 FRAME Frame_1 WIDTH 620 HEIGHT 40 

          @ 17,20 BUTTON PicButton_1 PICTURE "SEND" ACTION m_send(.T.) WIDTH 24 HEIGHT 24 TOOLTIP "Send Mail (Alt+S)"
          @ 17,48 BUTTON PicButton_2 PICTURE "CONFIG" ACTION m_config() WIDTH 24 HEIGHT 24 TOOLTIP "Config (Alt+C)"
          @ 17,76 BUTTON PicButton_3 PICTURE "TRASH" ACTION File_Attached(.T.) WIDTH 24 HEIGHT 24 TOOLTIP "Clear the Attachment List (Alt+T)"
          @ 17,104 BUTTON PicButton_4 PICTURE "INFO" ACTION m_about() WIDTH 24 HEIGHT 24 TOOLTIP "About (Alt+A)"
          @ 17,132 BUTTON PicButton_5 PICTURE "EXIT" ACTION Form_1.Release WIDTH 24 HEIGHT 24 TOOLTIP "Exit (Alt+X)"

          @ 21,220 LABEL Label_0 VALUE "Message Priority:" WIDTH 120 HEIGHT 20 
          @ 17,350 RADIOGROUP Radio_0 OPTIONS { "Normal", "Highest", "Low" } VALUE 1 ; 
                   WIDTH 66 SPACING 14 TOOLTIP "Select a Message Priority" HORIZONTAL

          @ 62,7 FRAME Frame_2 WIDTH 620 HEIGHT 370 
          @ 205,15 FRAME Frame_3 WIDTH 115 HEIGHT 55 

          @ 84,24 LABEL Label_1 VALUE "SMTP Server" WIDTH 100 HEIGHT 20 
          @ 108,24 LABEL Label_2 VALUE "From" WIDTH 100 HEIGHT 20 
          @ 131,24 LABEL Label_3 VALUE "To" WIDTH 100 HEIGHT 20 
          @ 158,24 LABEL Label_4 VALUE "Cc" WIDTH 100 HEIGHT 20 
          @ 158,357 LABEL Label_5 VALUE "Bcc" WIDTH 58 HEIGHT 20 
          @ 185,24 LABEL Label_6 VALUE "Subject" WIDTH 100 HEIGHT 20 
          @ 210,24 LABEL Label_7 VALUE "Attachment" WIDTH 100 HEIGHT 20 
          @ 262,24 LABEL Label_8 VALUE "Message" WIDTH 100 HEIGHT 20 

          @ 78,135 TEXTBOX Text_1 HEIGHT 23 WIDTH 480 ON CHANGE aget[1] := Form_1.Text_1.Value 
          Form_1.Text_1.Value := aget[1] 

          @ 104,135 TEXTBOX Text_2 HEIGHT 22 WIDTH 480 ON CHANGE aget[2] := Form_1.Text_2.Value 
          Form_1.Text_2.Value := aget[2] 

          @ 129,135 TEXTBOX Text_3 HEIGHT 22 WIDTH 480 ON CHANGE aget[3] := Form_1.Text_3.Value 
          Form_1.Text_3.Value := aget[3] 

          @ 155,135 TEXTBOX Text_4 HEIGHT 22 WIDTH 200 ON CHANGE aget[4] := Form_1.Text_4.Value 
          Form_1.Text_4.Value := aget[4] 

          @ 155,415 TEXTBOX Text_5 HEIGHT 22 WIDTH 200 ON CHANGE aget[5] := Form_1.Text_5.Value 
          Form_1.Text_5.Value := aget[5] 

          @ 180,135 TEXTBOX Text_6 HEIGHT 22 WIDTH 480 ON CHANGE aget[6] := Form_1.Text_6.Value 
          Form_1.Text_6.Value := aget[6] 

          @ 205,135 COMBOBOX Combo_7 ITEMS aget[7] HEIGHT 200 WIDTH 450 Tooltip "Attached File List"; 
                    ON GOTFOCUS MCONTEXT() ON CHANGE SetFcompress() 
          Form_1.Combo_7.Value := IF(Len(aget[7]) == 0, 0, 1) 

          @ 205,590 BUTTON PicButton_6 PICTURE "OPEN" ACTION File_Attached() ; 
                    WIDTH 24 HEIGHT 24 TOOLTIP "Select a File(s) To Attach" 

          @ 234,24 CHECKBOX Check_1 CAPTION "Compress" WIDTH 100 HEIGHT 20 ; 
                   VALUE ( !Empty(Form_1.Combo_7.DisplayValue) .and. !Empty(Compress) ) ; 
                   ON CHANGE SetFcompress() 

          @ 286,24 RADIOGROUP Radio_1 OPTIONS { "Text", "HTML" } VALUE aget[13] ; 
                   WIDTH 64 TOOLTIP "Select a Message Format" ; 
                   ON CHANGE aget[13] := Form_1.Radio_1.Value 

          @ 232,135 EDITBOX Edit_1 WIDTH 480 HEIGHT 190 ON CHANGE aget[8] := Form_1.Edit_1.Value NOHSCROLL 
          Form_1.Edit_1.Value := aget[8] 

          DEFINE CONTEXT MENU CONTROL Combo_7
                MENUITEM "Add a File(s) To Attach" ACTION File_Attached(.F.,.F.,.T.) NAME ADDFILE 
                MENUITEM "Remove from list" ACTION File_Attached(.T.,.T.,.T.) NAME DELFILE DISABLED 
          END MENU 

          ON KEY ALT+S ACTION m_send(.T.) 
          ON KEY ALT+C ACTION m_config() 
          ON KEY ALT+T ACTION File_Attached(.T.) 
          ON KEY ALT+A ACTION m_about() 
          ON KEY ALT+X ACTION ReleaseAllWindows() 

   END WINDOW 

   Form_1.Title := PROGRAM + IF(Form_1.Check_1.Value == .T., extratitle, "") 

   Displaystatus() 

   CENTER WINDOW Form_1 

   ACTIVATE WINDOW Form_1 

RETURN 

*-----------------------------------------------------------------------------* 
STATIC PROCEDURE MCONTEXT(ACT) 
*-----------------------------------------------------------------------------* 
DEFAULT ACT TO .T. 

IF ACT 
   DO EVENTS 
   IF EMPTY(FORM_1.COMBO_7.DISPLAYVALUE) 
       DISABLE MENUITEM DELFILE OF FORM_1 
   ELSE 
       ENABLE MENUITEM DELFILE OF FORM_1 
   ENDIF 
ENDIF 

RETURN 

*-----------------------------------------------------------------------------* 
STATIC PROCEDURE DisplayStatus() 
*-----------------------------------------------------------------------------* 

if Empty(Form_1.Combo_7.DisplayValue) 
   _setitem("statusbar","Form_1",1,"") 
   _setTooltip("combo_7","Form_1","Attached File(s) List") 
else 
   _setitem("statusbar","Form_1",1,"File: "+cfilenopath(Form_1.combo_7.displayvalue)) 
   _setTooltip("combo_7","Form_1","Attached File: "+cfilenopath(Form_1.combo_7.displayvalue)) 
endif 

RETURN 

*-----------------------------------------------------------------------------* 
STATIC PROCEDURE SetFcompress() 
*-----------------------------------------------------------------------------* 
Local Compress := Lower( aGet[15] ), new := Lower( cFileNoExt( Form_1.Combo_7.DisplayValue ) ) 

If Form_1.Check_1.Value == .T. .and. !Empty(new) 
   If !Empty(compress) .and. compress <> new 
      PlayExclamation() 
      If msgYesNo("Do you want to replace the file "+compress+".Zip" + CRLF + ; 
                  "with the new "+new+".Zip ?", "Confirm", , IDI_MAIN, .f.) 
         aGet[15] := new 
      EndIf 
   Else 
      aGet[15] := new 
   EndIf 
Else 
   aGet[15] := '' 
EndIf 

If Empty(new) 
   Form_1.Check_1.Value := .F. 
   Form_1.Title := PROGRAM 
Else 
   Form_1.Title := PROGRAM + IF(Empty(aGet[15]), "", " [ I send the file(s) attached as "+aGet[15]+".Zip ]") 
EndIf 

DisplayStatus() 
MCONTEXT() 

RETURN 

*-----------------------------------------------------------------------------* 
STATIC PROCEDURE m_send(gui) 
*-----------------------------------------------------------------------------* 
   LOCAL i, oSocket, cSMTP, cFrom, cTo, cCC, cBCC, cSubject, cMsgBody, aAttachment 
   LOCAL lLogin, lLoginMD5, cUserID, cPassWord, lHTML, cUser := "" 
   LOCAL Silent, Fcompress := "", nCompress := 9, nPriority := 3, nPort := 25 
   LOCAL cPrgPath := GetStartUpFolder()+"\" 
   default gui to .T. 

      cSMTP	:= aget[ 1] 
      cFrom	:= aget[ 2] 
      cTo	:= aget[ 3] 
      cCC	:= aget[ 4] 
      cBCC	:= aget[ 5] 
      cSubject	:= aget[ 6] 
      aAttachment := aget[ 7] 
      cMsgBody	:= aget[ 8] 
      lLogin	:= aGet[ 9] 
      lLoginMD5 := aGet[10] 
      cUserID	:= aGet[11] 
      cPassWord := aGet[12] 
      lHTML	:= ( aget[13] == 2 ) 
      Silent	:= aGet[14] 
      Fcompress := aGet[15] 
   if Gui 
      nPriority	:= if(Form_1.Radio_0.Value == 2, 1, if(Form_1.Radio_0.Value == 3, 5, nPriority))
      Silent	:= .F. 
   endif 

   If !Empty(Fcompress) 
      HB_ZIPFILE( cPrgPath+Fcompress+".Zip", aAttachment, nCompress , , .T. , , .T. ) 
      aAttachment := { cPrgPath+Fcompress+".Zip" } 
   EndIf 

   oSocket := TSMTP():New() 

   IF oSocket:Connect( cSMTP, nPort ) 

      i := At("<", cFrom) 
      IF i > 0 
         cUser := Chr(34) + Alltrim(Left(cFrom, i-1)) + Chr(34) 
         cFrom := Substr(cFrom, i+1, Len(cFrom)-i-1) 
      ENDIF 

      i := At("<", cTo) 
      IF i > 0 
         cTo := Substr(cTo, i+1, Len(cTo)-i-1) 
      ENDIF 

      i := At("<", cCC) 
      IF i > 0 
         cCC := Substr(cCC, i+1, Len(cCC)-i-1) 
      ENDIF 
      i := At("<", cBCC) 
      IF i > 0 
         cBCC := Substr(cBCC, i+1, Len(cBCC)-i-1) 
      ENDIF 

      oSocket:ClearData() 
      oSocket:SetPriority( nPriority )

      oSocket:SetFrom( cUser, "<"+ cFrom +">") 

      oSocket:AddTo( cUser, "<"+ cTo +">" ) 

      IF ! Empty( cCC ) 
         oSocket:AddCc( cUser,"<"+ cCC +">") 
      ENDIF 
      IF ! Empty( cBCC ) 
         oSocket:AddBcc( cUser, "<"+ cBCC +">" ) 
      ENDIF 

      oSocket:SetSubject( cSubject ) 

      IF Len( aAttachment ) > 0 
         aeval( aAttachment, { |x| oSocket:AddAttach(x) } ) 
      ENDIF 

      oSocket:SetData( cMsgBody, lHTML ) 
    
      IF lLogin 
         IF lLoginMD5 
            IF ! oSocket:LoginMD5( cUserID, cPassWord ) 
               If Silent 
                  LogFile( cLogFile, {oSocket:GetLastError()+" While trying to login got an error messages from server"} ) 
               Else 
                  MsgStop( oSocket:GetLastError(), "While trying to login got an error messages from server" ) 
               EndIf 
               oSocket:Close() 
               RETURN 
            ENDIF 
         ELSEIF ! oSocket:Login( cUserID, cPassWord ) 
            If Silent 
               LogFile( cLogFile, {oSocket:GetLastError()+" While trying to login got an error messages from server"} ) 
            Else 
               MsgStop( oSocket:GetLastError(), "While trying to login got an error messages from server" ) 
            EndIf 
            oSocket:Close() 
            RETURN 
         ENDIF 
      ENDIF 

      IF ! oSocket:Send(.T.) 
         If Silent 
            LogFile( cLogFile, {oSocket:GetLastError()+" While trying to send data got an error messages from server"} ) 
         Else 
            MsgStop( oSocket:GetLastError(), "While trying to send data got an error messages from server" ) 
         EndIf 
         oSocket:Close() 
         RETURN 
      ENDIF 

      oSocket:Close() 

      If Silent 
         LogFile( cLogFile, {"Mail sent to " + cTo + " successfully"} ) 
      Else 
         MsgInfo( "Mail sent to " + cTo + " successfully!", PROGRAM ) 
      EndIf 

   ELSE 

      If Silent 
         LogFile( cLogFile, {"Can't connect to SMTP server: " + cSMTP} ) 
      Else 
         MsgStop( "Can't connect to SMTP server: " + cSMTP, "Error while trying to connect to SMTP server" ) 
      EndIf 

   ENDIF 

RETURN 

*-----------------------------------------------------------------------------* 
STATIC PROCEDURE m_config() 
*-----------------------------------------------------------------------------* 
   DEFINE WINDOW Form_2 ; 
      AT 199,144 WIDTH 374 HEIGHT 221 ; 
      TITLE Left(PROGRAM, Len(PROGRAM)-3)+"Config" ; 
      ICON IDI_MAIN ; 
      MODAL NOSIZE ; 
      ON INIT Form_2.Button_1.Setfocus ; 
      FONT "MS Sans Serif" SIZE 10 

      @ 8,8 FRAME Frame_1 WIDTH 350 HEIGHT 138 

      @ 22,25 CHECKBOX CheckBox_1 CAPTION "My server requires authentication" ; 
              WIDTH 240 HEIGHT 22 ON CHANGE aget[9] := Form_2.CheckBox_1.Value 
      Form_2.CheckBox_1.Value := aget[9] 

      @ 46,45 CHECKBOX CheckBox_2 CAPTION "MD5 Password Authentication" ; 
              WIDTH 200 HEIGHT 22 ON CHANGE aget[10] := Form_2.CheckBox_2.Value 
      Form_2.CheckBox_2.Value := aget[10] 

      @ 81,25 LABEL Label_1 VALUE "User Name" WIDTH 90 HEIGHT 22 
      @ 107,25 LABEL Label_2 VALUE "Password" WIDTH 92 HEIGHT 22 

      @ 76,125 TEXTBOX Text_1 HEIGHT 22 WIDTH 222 ON CHANGE aget[11] := Form_2.Text_1.Value 
      Form_2.Text_1.Value := aget[11] 

      @ 103,125 TEXTBOX Text_2 HEIGHT 22 WIDTH 222 PASSWORD ON CHANGE aget[12] := Form_2.Text_2.Value 
      Form_2.Text_2.Value := aget[12] 

      @ 156,140 BUTTON Button_1 CAPTION "OK" ACTION Form_2.Release WIDTH 80 HEIGHT 26 DEFAULT 

      ON KEY ESCAPE ACTION Form_2.Button_1.OnClick 

   END WINDOW 

   CENTER WINDOW Form_2 

   ACTIVATE WINDOW Form_2 

RETURN 

*-----------------------------------------------------------------------------* 
STATIC FUNCTION m_about() 
*-----------------------------------------------------------------------------* 
RETURN MsgInfo(padc(PROGRAM + " - Freeware", 40) + CRLF + ; 
   "Copyright (c) 2005-2006 Grigory Filatov" + CRLF + CRLF + ; 
   padc("Email: gfilatov@rambler.ru", 36) + CRLF + CRLF + ; 
   "Revision by Pierpaolo Martinello 2007"+ CRLF + CRLF + ; 
   hb_compiler() + CRLF + ; 
   version() + CRLF + ; 
   substr(MiniGuiVersion(), 1, 39), "About", IDI_MAIN, .f.) 

*-----------------------------------------------------------------------------* 
STATIC PROCEDURE File_Attached( lClear, lcOne, oAdd ) 
*-----------------------------------------------------------------------------* 
   LOCAL i,ync, cNewAtt, c := .F., v := aget[7], cv := Form_1.Combo_7.Value 

   Default lClear to .F., lcOne to .F., oAdd to .F. 
    
   if len(v) > 0 .and. !lClear .and. Form_1.Combo_7.ItemCount > 0 
      if !oadd 
         PlayExclamation() 
         ync := msgYesNoCancel("Add a new file or make a new selection?", "Choice", IDI_MAIN, .f.) 
         if ync = -1 
            return 
         else 
            c := ( ync == 0 ) 
         endif 
      endif 
   endif 
    
   if !lClear 
      cNewAtt := GetFile( { {"All Files", "*.*"}, ; 
         {"ZIP Archives", "*.zip"}, {"RAR Archives", "*.rar"} }, ; 
         "Select a File(s) To Attach", , .T. ) 
   endif 

   if !empty( cNewAtt ) 

      If C 
         aGet[7] := {} 
         Form_1.Combo_7.DeleteAllItems 
         v := {} 
      Endif 

      if valtype(cNewAtt) == 'C' 

         If ascan(v,cNewAtt) < 1 
            Form_1.Combo_7.AddItem(cNewAtt) 
            aAdd(aGet[7], cNewAtt) 
         Endif 

      elseif valtype(cNewAtt) == 'A' 

         for i := 1 to len(cNewAtt) 

             if ascan(v,cNewAtt) < 1 
                Form_1.Combo_7.AddItem(cNewAtt[i]) 
                aAdd(aGet[7], cNewAtt[i]) 
             Endif 

         next i 

      endif 

      Form_1.Combo_7.Value := 1 

   elseif lClear 

      if LcOne 
         Form_1.Combo_7.DeleteItem( cv ) 
         aGet[7] := GetComboArray( "Combo_7", "Form_1" ) 
         Form_1.Combo_7.Value := if( cv >= 1, cv - 1, 1 ) 
      else 
         aGet[7] := {} 
         Form_1.Combo_7.DeleteAllItems 
         Form_1.Check_1.Value := .F. 
         aGet[15] := '' 
      Endif 

   endif 
    
   DO EVENTS 

   If EMPTY(FORM_1.COMBO_7.DISPLAYVALUE) 
       DISABLE MENUITEM DELFILE OF FORM_1 
   Else 
       ENABLE MENUITEM DELFILE OF FORM_1 
   Endif 

   SetFCompress() 

RETURN 

*-----------------------------------------------------------------------------* 
STATIC PROCEDURE SaveData() 
*-----------------------------------------------------------------------------* 
   LOCAL i, s := aget[14], q := .T. 

   SET DECIMALS TO 

   if !s 
      PlayExclamation() 
      q := msgYesno("Do you want to save these parameters?", "Exit from Application", q, IDI_MAIN, .f.) 
   endif 

   if q 
      BEGIN INI FILE cCfgFile 
       
            SET SECTION Left(PROGRAM, Len(PROGRAM)-4) ENTRY "Release" to Right(PROGRAM, 3) 
             
            For i := 1 To Len(aEntry) 
                IF i == 8 
                   aGet[i] := STRTRAN( aGet[i], CRLF, Chr(250) ) 
                ELSEIF i == 12 
                   aGet[i] := CHARXOR( aGet[i], cCryptKey ) 
                ENDIF 
                SET SECTION "Data" ENTRY aEntry[i] TO aGet[i] 
            Next i 

      END INI 
   endif 
    
RETURN 

*-----------------------------------------------------------------------------* 
STATIC PROCEDURE LogFile( cFileName, acInfo ) 
*-----------------------------------------------------------------------------* 
   LOCAL hFile, cLine := DToC( Date() ) + " " + Time() + " : ", n 

   For n = 1 to Len( acInfo ) 
      cLine += acInfo[ n ] + Chr( 9 ) 
   Next 
   cLine += CRLF 

   if ! File( cFileName ) 
      FClose( FCreate( cFileName ) ) 
   endif 

   if( ( hFile := FOpen( cFileName, FO_WRITE + FO_SHARED ) ) != -1 ) 
      FSeek( hFile, 0, FS_END ) 
      FWrite( hFile, cLine, Len( cLine ) ) 
      FClose( hFile ) 
   endif 

Return 

*-----------------------------------------------------------------------------* 
STATIC Function GetComboArray( ControlName, ParentWindow ) 
*-----------------------------------------------------------------------------* 
Local n, cnt := GetProperty( ParentWindow, ControlName, "ITEMCOUNT" ), aret := {} 

for n = 1 to cnt 
    aadd( aret, GetProperty( ParentWindow, ControlName, "ITEM", n ) ) 
next 

Return aret 
