/*
 * MINIGUI - Harbour Win32 GUI library
 *
 * Copyright 2002-2007 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com
 *
 * Copyright 2005-2007 Grigory Filatov <gfilatov@freemail.ru>
*/

ANNOUNCE RDDSYS

#include "minigui.ch"

#define PROGRAM 'XMas Lights'
#define VERSION ' version 1.0'
#define COPYRIGHT ' 2005-2007 Grigory Filatov'

#define NTRIM( n )	LTrim( Str( n ) )
#define BMP_SIZE	32

Static aHandles := {}, aLights := {}
Static nSwitch := 1, lBusy := .F.

*--------------------------------------------------------*
Procedure Main()
*--------------------------------------------------------*

	// Left Height
	aAdd(aLights, {"B121", "B115"})
	aAdd(aLights, {"B120", "B114"})
	aAdd(aLights, {"B122", "B116"})
	aAdd(aLights, {"B115", "B121"})
	aAdd(aLights, {"B114", "B120"})
	aAdd(aLights, {"B116", "B122"})
	aAdd(aLights, {"B122", "B116"})
	aAdd(aLights, {"B115", "B121"})

	// Top Width
	aAdd(aLights, {"B109", "B107"})
	aAdd(aLights, {"B105", "B106"})
	aAdd(aLights, {"B110", "B108"})
	aAdd(aLights, {"B107", "B109"})
	aAdd(aLights, {"B106", "B105"})
	aAdd(aLights, {"B108", "B110"})
	aAdd(aLights, {"B106", "B105"})
	aAdd(aLights, {"B108", "B110"})
	aAdd(aLights, {"B109", "B107"})
	aAdd(aLights, {"B107", "B109"})
	aAdd(aLights, {"B106", "B105"})
	aAdd(aLights, {"B108", "B110"})

	// Right Height
	aAdd(aLights, {"B112", "B118"})
	aAdd(aLights, {"B117", "B111"})
	aAdd(aLights, {"B113", "B119"})
	aAdd(aLights, {"B118", "B112"})
	aAdd(aLights, {"B111", "B117"})
	aAdd(aLights, {"B119", "B113"})
	aAdd(aLights, {"B111", "B117"})
	aAdd(aLights, {"B119", "B113"})

	SET MULTIPLE OFF

	DEFINE WINDOW Form_0 ;
		AT 0,0 ;
		WIDTH 0 HEIGHT 0 ;
		TITLE PROGRAM ;
		ICON 'MAIN' ;
		MAIN NOSHOW ;
		ON INIT CreateForms() ;
		ON RELEASE Aeval(aHandles, {|e| DeleteObject( e )}) ;
		NOTIFYICON 'MAIN' ;
		NOTIFYTOOLTIP PROGRAM ;
		ON NOTIFYCLICK HideShow()

		DEFINE TIMER Timer_0 INTERVAL 250 ACTION SetRegions()

	END WINDOW

	ACTIVATE WINDOW Form_0

Return

*--------------------------------------------------------*
Static Procedure SetRegions()
*--------------------------------------------------------*
Local i, cForm, cResName, RegionHandle

IF !lBusy

   lBusy := .T.

   for i = 1 To Len(aLights)

	cForm := "Form_" + NTRIM(i)
	cResName := aLights[i][1]

	DoMethod(cForm, "Show")

	SET REGION OF &cForm BITMAP &cResName TRANSPARENT COLOR FUCHSIA TO RegionHandle
	aAdd(aHandles, RegionHandle)

   next

   r_menu()

   Form_0.Timer_0.Release

ENDIF

Return

*--------------------------------------------------------*
Static Procedure CreateForms()
*--------------------------------------------------------*
Local nTop := 0, nLeft := 0, cForm := "", i, cImage
Local aDesk := GetDesktopArea()
Local nDeskWidth := aDesk[3], nDeskHeight := aDesk[4]
Local n := Int(nDeskHeight / 9), n1 := Int(nDeskWidth / 13)

   CLEAN MEMORY

   // Left Height
   for i = 1 To 8

	cForm := "Form_"+str(i, 1)
	cImage := "Image_"+str(i, 1)
	nTop := nTop + n

	DEFINE WINDOW &cForm ;
		AT nTop, nLeft ;
		WIDTH BMP_SIZE HEIGHT BMP_SIZE ;
		CHILD ;
		TOPMOST ;
		NOSHOW ;
		NOCAPTION ;
		NOMINIMIZE NOMAXIMIZE NOSIZE

		@ 0,0 IMAGE &cImage ;
			PICTURE aLights[i][1] ;
			WIDTH BMP_SIZE HEIGHT BMP_SIZE

	END WINDOW

   next

   // Top Width
   nTop := 0
   nLeft := 0
   for i = 9 To 20

	cForm := "Form_" + NTRIM(i)
	cImage := "Image_" + NTRIM(i)
	nLeft := nLeft + n1

	DEFINE WINDOW &cForm ;
		AT nTop, nLeft ;
		WIDTH BMP_SIZE HEIGHT BMP_SIZE ;
		CHILD ;
		TOPMOST ;
		NOSHOW ;
		NOCAPTION ;
		NOMINIMIZE NOMAXIMIZE NOSIZE

		@ 0,0 IMAGE &cImage ;
			PICTURE aLights[i][1] ;
			WIDTH BMP_SIZE HEIGHT BMP_SIZE

	END WINDOW

   next

   // Right Height
   nTop := 0
   nLeft := nDeskWidth - BMP_SIZE
   for i = 21 To 28

	cForm := "Form_" + str(i, 2)
	cImage := "Image_" + str(i, 2)
	nTop := nTop + n

	DEFINE WINDOW &cForm ;
		AT nTop, nLeft ;
		WIDTH BMP_SIZE HEIGHT BMP_SIZE ;
		CHILD ;
		TOPMOST ;
		NOSHOW ;
		NOCAPTION ;
		NOMINIMIZE NOMAXIMIZE NOSIZE

		@ 0,0 IMAGE &cImage ;
			PICTURE aLights[i][1] ;
			WIDTH BMP_SIZE HEIGHT BMP_SIZE

	END WINDOW

   next

   DEFINE TIMER Timer_1 OF Form_1 INTERVAL 500 ACTION SwitchLights()

   ACTIVATE WINDOW Form_1, Form_2, Form_3, Form_4, Form_5, Form_6, Form_7, Form_8, ;
	Form_9, Form_10, Form_11, Form_12, Form_13, Form_14, Form_15, Form_16, ;
	Form_17, Form_18, Form_19, Form_20, Form_21, Form_22, Form_23, Form_24, ;
	Form_25, Form_26, Form_27, Form_28

Return

*--------------------------------------------------------*
Static Procedure SwitchLights()
*--------------------------------------------------------*
Local i

   nSwitch := IF(nSwitch == 1, 2, 1)

   IF lBusy

	for i = 1 To Len(aLights)
		SetProperty( "Form_" + NTRIM(i), "Image_" + NTRIM(i), 'Picture', aLights[i][nSwitch] )
	next

   ENDIF

Return

*--------------------------------------------------------*
Static Procedure HideShow()
*--------------------------------------------------------*
Local i

   IF IsWindowVisible( GetFormHandle( "Form_1" ) )
	lBusy := .F.

	for i = 1 To Len(aLights)
		DoMethod( "Form_" + NTRIM(i), "Hide" )
	next

   ELSE
	lBusy := .T.

	for i = 1 To Len(aLights)
		DoMethod( "Form_" + NTRIM(i), "Show" )
	next

   ENDIF

   r_menu()

Return

*--------------------------------------------------------*
Static Procedure r_menu()
*--------------------------------------------------------*

	DEFINE NOTIFY MENU OF Form_0
		ITEM IF( IsWindowVisible( GetFormHandle( "Form_1" ) ), '&Hide', '&Show' ) ;
			ACTION HideShow() NAME Show_Hide
		ITEM '&About...'	ACTION ShellAbout( "About " + PROGRAM + "#", PROGRAM + VERSION + CRLF + ;
			"Copyright " + Chr(169) + COPYRIGHT, LoadTrayIcon(GetInstance(), "MAIN") )
		SEPARATOR	
		ITEM '&Exit'		ACTION Form_0.Release
	END MENU

	_DefaultMenuItem( 1, "Show_Hide", "Form_0" )

Return

*--------------------------------------------------------*
Function _DefaultMenuItem(ItemNumber, ItemName, FormName)
*--------------------------------------------------------*
Local i , h

	i := GetControlIndex( ItemName, FormName )

	h := _HMG_aControlpageMap[ i ]

	SetMenuDefaultItem( h, ItemNumber )

Return Nil


#pragma BEGINDUMP

#include <shlobj.h>
#include <windows.h>
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"
#include <commctrl.h>

HB_FUNC ( SETMENUDEFAULTITEM )
{
	SetMenuDefaultItem( (HMENU) hb_parnl( 1 ), hb_parni( 2 ) - 1, TRUE );
}

HB_FUNC ( GETDESKTOPAREA ) 
{
	RECT rect;
	SystemParametersInfo( SPI_GETWORKAREA, 1, &rect, 0 );

	hb_reta(4);
	hb_storni((INT) rect.top, -1, 1);
	hb_storni((INT) rect.left, -1, 2);
	hb_storni((INT) rect.right - rect.left, -1, 3);
	hb_storni((INT) rect.bottom - rect.top, -1, 4);
}

HB_FUNC( INITIMAGE )
{
	HWND  h;
	HBITMAP hBitmap;
	HWND hwnd;
	int Style;

	hwnd = (HWND) hb_parnl(1);

	Style = WS_CHILD | SS_BITMAP | SS_NOTIFY ;

	if ( ! hb_parl (8) )
	{
		Style = Style | WS_VISIBLE ;
	}

	h = CreateWindowEx( 0, "static", NULL, Style,
		hb_parni(3), hb_parni(4), 0, 0,
		hwnd, (HMENU) hb_parni(2), GetModuleHandle(NULL), NULL ) ;

	hb_retnl( (LONG) h );
}

HB_FUNC( C_SETPICTURE )
{
	HBITMAP hBitmap;

	hBitmap = (HBITMAP) LoadImage( GetModuleHandle(NULL), hb_parc(2), IMAGE_BITMAP, hb_parni(3), hb_parni(4), LR_CREATEDIBSECTION );

	SendMessage( (HWND) hb_parnl(1), (UINT) STM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) hBitmap );

	hb_retnl( (LONG) hBitmap );
}

#pragma ENDDUMP
