/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2003, http://www.harbour-project.org/
---------------------------------------------------------------------------*/
#include "minigui.ch"

#define SB_CTL	2
#define LVS_REPORT              0x0001
#define LVS_SINGLESEL           0x0004
#define LVS_SHOWSELALWAYS       0x0008
#define LVS_EX_HEADERDRAGDROP   0x00000010
#define LVS_EX_FULLROWSELECT    0x00000020 // applies to report mode only
#define LVM_FIRST               0x1000      // ListView messages
#define LVM_SETEXTENDEDLISTVIEWSTYLE (LVM_FIRST + 54)   // optional wParam == mask



#define WS_CHILD    0x40000000
#define WS_TABSTOP    0x10000
#define WS_VISIBLE    0x10000000
#define WS_BORDER    0x800000

*-----------------------------------------------------------------------------*
Function _DefineBrowse ( ControlName, ParentFormName, x, y, w, h, aHeaders, aWidths, aFields ,value,fontname,fontsize , tooltip , change , dblclick , aHeadClick , gotfocus , lostfocus , WorkArea , Delete, nogrid, aImage, aJust , HelpId , bold , italic , underline , strikeout , break , backcolor , fontcolor , lock , inplace , novscroll , appendable , readonly , valid , validmessages , edit , dynamicforecolor , dynamicbackcolor , aWhenFields , nId )
*-----------------------------------------------------------------------------*
Local i , ParentFormHandle, blInit , mVar , wBitmap , DeltaWidth , k := 0, Style := 0
Local ControlHandle, FontHandle, aFont, hsum := 0

Static CellValue

/*
appendable	1
readonly	2
valid		3
validmessages	4
*/
    if ( FontHandle := GetFontHandle( FontName ) ) != 0
        aFont := GetFontParam(FontHandle)
        FontName      := aFont[1]
        FontSize      := aFont[2]
        bold          := aFont[3]
        italic        := aFont[4]
        underline     := aFont[5]
        strikeout     := aFont[6]
    endif

	if _HMG_BeginWindowActive = TRUE .or. _HMG_BeginDialogActive = TRUE
		ParentFormName := if(_HMG_BeginDialogActive,_HMG_ActiveDialogName,_HMG_ActiveFormName)
		if .Not. Empty (_HMG_ActiveFontName) .And. ValType(FontName) == "U"
			FontName := _HMG_ActiveFontName
		EndIf
		if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(FontSize) == "U"
			FontSize := _HMG_ActiveFontSize
		EndIf
	endif
	if _HMG_FrameLevel > 0
		x 	:= x + _HMG_ActiveFrameCol [_HMG_FrameLevel]
		y 	:= y + _HMG_ActiveFrameRow [_HMG_FrameLevel] 
		ParentFormName := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
	EndIf

	If .Not. _IsWindowDefined (ParentFormName) .and. .Not. _HMG_DialogInMemory
		MsgMiniGuiError("Window: "+ ParentFormName + " is not defined. Program terminated" )
	Endif

	If _IsControlDefined (ControlName,ParentFormName) .and. .Not. _HMG_DialogInMemory
		MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentFormName + " Already defined. Program Terminated" )
	endif

	if valtype(value) == "U"
		value := 0
	endif
	if valtype(aFields) == "U"
		aFields := {}
	endif
	if valtype(aJust) == "U"		// Browse+
		aJust := Array( len( aFields ) )
		aFill( aJust, 0 )
	else
		aSize( aJust, len( aFields) )
		aEval( aJust, { |x| x := iif( x == NIL, 0, x ) } )
	endif
	if valtype(aImage) == "U"
		aImage := {}
	endif

	if novscroll == .F.
		DeltaWidth := GETVSCROLLBARWIDTH() 
	Else
		DeltaWidth := 0
	EndIf

	if valtype(change) == "U"
		change := ""
	endif

	if valtype(dblclick) == "U"
		dblclick := ""
	endif

	if valtype(aHeadClick) == "U"
		aHeadClick := {}
	endif

    mVar := '_' + ParentFormName + '_' + ControlName
    k := _GetControlFree()

    if _HMG_BeginDialogActive = TRUE

        ParentFormHandle = _HMG_ActiveDialogHandle

        style := LVS_SINGLESEL + LVS_SHOWSELALWAYS + WS_BORDER + WS_CHILD + WS_TABSTOP + WS_VISIBLE + LVS_REPORT 


        if _HMG_DialogInMemory         //Dialog Template

            blInit:= {|x,y,z| InitDialogBrowse(x,y,z) }
            aadd(_HMG_aDialogItems,{nId,k,"SysListView32",style,0,x,y,w - DeltaWidth,h,"",HelpId,tooltip,FontName,FontSize,bold,italic,underline,strikeout,blInit,_HMG_BeginTabActive,.f.,_HMG_ActiveTabPage })
            if _HMG_aDialogTemplate[3]   // Modal
                Return Nil
            endif
        else

            ControlHandle := GetDialogItemHandle( ParentFormHandle, nId )
            SetWindowStyle ( ControlHandle, style)

            x := GetWindowCol ( Controlhandle )
            y := GetWindowRow ( Controlhandle )
            w := GetWindowWidth  ( Controlhandle )
            h := GetWindowHeight ( Controlhandle )
        endif

    else

    	ParentFormHandle = GetFormHandle (ParentFormName)

    	if valtype(w) == "U"
	    	w := 240
	    endif
	    if valtype(h) == "U"
		    h := 120
	    endif


    	if valtype(x) == "U" .or. valtype(y) == "U" 

		// If splitboxed force no vertical scrollbar
		novscroll := .T.

	    	If _HMG_SplitLastControl == 'TOOLBAR'
		    	Break := .T.
		    EndIf

		    _HMG_SplitLastControl	:= 'GRID'

    		i := GetFormIndex ( ParentFormName )

	    	if i > 0 

    			ControlHandle := InitBrowse ( ParentFormHandle, 0, x, y, w - DeltaWidth , h , '', 0, iif( nogrid, 0, 1 ) ) // Browse+	

    			x := GetWindowCol ( Controlhandle )
	    		y := GetWindowRow ( Controlhandle )

			If FontHandle != 0
				_SetFontHandle(ControlHandle,FontHandle)
			Else
    				if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
	    				FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
			    	Else
				    	FontHandle := _SetFont (ControlHandle,_HMG_DefaultFontName,_HMG_DefaultFontSize,bold,italic,underline,strikeout)
    				endif
			EndIf

	    		AddSplitBoxItem ( Controlhandle, _HMG_aFormReBarHandle [i] , w , break , , , , _HMG_ActiveSplitBoxInverted )
		    EndIf

    	Else

    		ControlHandle := InitBrowse ( ParentFormHandle, 0, x, y, w - DeltaWidth , h , '', 0, iif( nogrid, 0, 1 ) ) // Browse+	

		If FontHandle != 0
			_SetFontHandle(ControlHandle,FontHandle)
		Else
		    	if valtype(fontname) != "U" .and. valtype(fontsize) != "U"
			    	FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
    			Else
	    			FontHandle := _SetFont (ControlHandle,_HMG_DefaultFontName,_HMG_DefaultFontSize,bold,italic,underline,strikeout)		
			endif
		EndIf

    	endif
    Endif

    if .Not. _HMG_DialogInMemory

    	If ValType (backcolor) != 'U'
	    	ListView_SetBkColor ( ControlHandle , backcolor[1] , backcolor[2] , backcolor[3] )
		ListView_SetTextBkColor ( ControlHandle , backcolor[1] , backcolor[2] , backcolor[3]  )
    	EndIf

	    If ValType (fontcolor) != 'U'
		ListView_SetTextColor ( ControlHandle , fontcolor[1] , fontcolor[2] , fontcolor[3]  )
    	EndIf

    	wBitmap := iif( len( aImage ) > 0, AddListViewBitmap( ControlHandle, aImage ), 0 ) //Add Bitmap Column
    	aWidths[1] := max ( aWidths[1], wBitmap + 2 ) // Set Column 1 witth to Bitmap width

    	if valtype(tooltip) != "U"
	        SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (ParentFormName) )
    	endif
    endif

	Public &mVar. := k
	CellValue:=nil
	_HMG_aControlType [k] := "BROWSE" 
	_HMG_aControlNames [k] :=   ControlName 
	_HMG_aControlHandles [k] :=   ControlHandle 
	_HMG_aControlParenthandles [k] :=   ParentFormHandle 
	_HMG_aControlIds  [k] :=  nId
	_HMG_aControlProcedures  [k] :=  aWidths 
	_HMG_aControlPageMap   [k] := aHeaders
	_HMG_aControlValue   [k] := Value 
	_HMG_aControlInputMask   [k] := Lock 
	_HMG_aControllostFocusProcedure  [k] :=  lostfocus 
	_HMG_aControlGotFocusProcedure  [k] :=  gotfocus 
	_HMG_aControlChangeProcedure  [k] :=  change 
	_HMG_aControlDeleted   [k] := .F. 	
	_HMG_aControlBkColor  [k] :=  aImage // Browse+
	_HMG_aControlFontColor   [k] := inplace 
	_HMG_aControlDblClick   [k] := dblclick 
	_HMG_aControlHeadClick   [k] := aHeadClick 
	_HMG_aControlRow   [k] := y 
	_HMG_aControlCol   [k] := x 
	_HMG_aControlWidth   [k] := w 
	_HMG_aControlHeight   [k] := h 
	_HMG_aControlSpacing   [k] := WorkArea 
	_HMG_aControlContainerRow   [k] := iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 ) 
	_HMG_aControlContainerCol   [k] := iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 ) 
	_HMG_aControlPicture   [k] := Delete 
	_HMG_aControlContainerHandle   [k] := 0 
	_HMG_aControlFontName   [k] := fontname 
	_HMG_aControlFontSize   [k] := fontsize 
	_HMG_aControlFontAttributes   [k] := {bold,italic,underline,strikeout} 
	_HMG_aControlToolTip    [k] := tooltip  
	_HMG_aControlRangeMin   [k] := aFields  
	_HMG_aControlRangeMax   [k] := aJust  // {}  
	_HMG_aControlCaption  [k] :=   aHeaders  
	_HMG_aControlVisible  [k] :=   .t. 
	_HMG_aControlHelpId  [k] :=   HelpId 
	_HMG_aControlFontHandle   [k] :=  FontHandle 
	_HMG_aControlBrushHandle  [k] :=  0 
	_HMG_aControlEnabled   [k] :=  .T. 
	_HMG_aControlMiscData1 [k] := { 0 , appendable , readonly , valid , validmessages , edit , nogrid, novscroll, dynamicforecolor , dynamicbackcolor , aWhenFields}

    if .Not. _HMG_DialogInMemory  
        InitDialogBrowse(ParentFormName, ControlHandle, k)
    endif

Return Nil

*-----------------------------------------------------------------------------*
Function InitDialogBrowse(ParentName, ControlHandle, k)
*-----------------------------------------------------------------------------*
Local i , x , w , y ,h , ParentFormHandle , z , ScrollBarHandle , wBitmap
Local hsum := 0, dynamicforecolor , dynamicbackcolor , aWhenFields
Local ScrollBarButtonHandle,nogrid

    x := _HMG_aControlCol   [k] 
    w := _HMG_aControlWidth   [k]
    y := _HMG_aControlRow   [k] 
    h := _HMG_aControlHeight   [k] 

    ParentFormHandle := _HMG_aControlParenthandles [k]
    nogrid := _HMG_aControlMiscData1 [k,7]
    dynamicforecolor := _HMG_aControlMiscData1 [k,9]
    dynamicbackcolor := _HMG_aControlMiscData1 [k,10]
    aWhenFields      := _HMG_aControlMiscData1 [k,11]
    SendMessage(ControlHandle,LVM_SETEXTENDEDLISTVIEWSTYLE, 0, iif( nogrid, 0, 1 ) + LVS_EX_FULLROWSELECT + LVS_EX_HEADERDRAGDROP );

    wBitmap := iif( len( _HMG_aControlBkColor  [k] ) > 0, AddListViewBitmap( ControlHandle, _HMG_aControlBkColor  [k] ), 0 ) //Add Bitmap Column
    _HMG_aControlProcedures[k,1] := max ( _HMG_aControlProcedures[k,1], wBitmap + 2 ) // Set Column 1 witth to Bitmap width


    InitListViewColumns ( ControlHandle , _HMG_aControlCaption[k] , _HMG_aControlProcedures[k], _HMG_aControlRangeMax[k]  ) // Browse+

    // Add to browselist array to update on window activation

    i := k
    aAdd ( _HMG_aFormBrowseList    [ GetFormIndex ( ParentName ) ] , k )

    For z := 1 To Len ( _HMG_aControlProcedures [i] )
        hsum := hsum + ListView_GetColumnWidth ( _HMG_aControlHandles [i] , z - 1 )
        _HMG_aControlProcedures [i] [z] := ListView_GetColumnWidth ( _HMG_aControlHandles [i] , z - 1 )
    Next z

    // Add Vertical scrollbar

    if _HMG_aControlMiscData1 [k,8] == .F.

        if hsum > w - GETVSCROLLBARWIDTH() - 4
            ScrollBarHandle := InitVScrollBar (  ParentFormHandle , x + w - GETVSCROLLBARWIDTH() , y , GETVSCROLLBARWIDTH() , h - GETHSCROLLBARHEIGHT() )
            ScrollBarButtonHandle := InitVScrollBarButton (  ParentFormHandle , x + w - GETVSCROLLBARWIDTH() , y + h - GETHSCROLLBARHEIGHT() , GETVSCROLLBARWIDTH() , GETHSCROLLBARHEIGHT() )
        Else
            ScrollBarHandle := InitVScrollBar (  ParentFormHandle , x + w - GETVSCROLLBARWIDTH() , y , GETVSCROLLBARWIDTH() , h )
            ScrollBarButtonHandle := InitVScrollBarButton (  ParentFormHandle , x + w - GETVSCROLLBARWIDTH() , y + h - GETHSCROLLBARHEIGHT() , 0 , 0 )
        EndIf

        If _HMG_BeginTabActive = .T.
            aAdd ( _HMG_ActiveTabCurrentPageMap , { ControlHandle , ScrollBarHandle , ScrollBarButtonHandle } )
        EndIf

    Else

        ScrollBarHandle := 0

        If _HMG_BeginTabActive = .T.
            aAdd ( _HMG_ActiveTabCurrentPageMap , ControlHandle )
        EndIf

    EndIf

    _HMG_aControlIds [i] := ScrollBarHandle
    _HMG_aControlMiscData1 [i] [1] := ScrollBarButtonHandle
 	_HMG_aControlIds [i] := ScrollBarHandle
	_HMG_aControlMiscData1 [i] [1] := ScrollBarButtonHandle

	__MVPUBLIC ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICFORECOLOR' )
	__MVPUT ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICFORECOLOR' , dynamicforecolor )

	__MVPUBLIC ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICBACKCOLOR' )
	__MVPUT ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICBACKCOLOR' , dynamicbackcolor )

	__MVPUBLIC ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_WHEN' )
	__MVPUT ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_WHEN' , aWhenFields )
   _BrowseRefresh('','',i)

Return Nil

*-----------------------------------------------------------------------------*
Procedure _BrowseUpdate( ControlName,ParentName , z )
*-----------------------------------------------------------------------------*
Local PageLength , aTemp := {} , cTemp , Fields , _BrowseRecMap := {} , i , x , j , First , Image , _Rec
local dBc , dFc , processdbc , processdfc , ColorMap , ColorRow , fcolormap , fcolorrow

	If pcount() == 2
		i := GetControlIndex(ControlName,ParentName)
	Else
		i := z
	EndIf

	If Select() == 0
		Return
	EndIf

	dbc := 	__MVGET	( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICBACKCOLOR' )
	processdbc := if ( valtype (dbc) = 'A' , .t. , .f. )

	dfc := 	__MVGET	( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICFORECOLOR' )
	processdFc := if ( valtype (dFc) = 'A' , .t. , .f. )

	_HMG_aControlContainerHandle [i] := 0

	First   := iif( len( _HMG_aControlBkColor[i] ) == 0, 1, 2 ) // Browse+ ( 2= bitmap definido, se cargan campos a partir de 2 )

	Fields := _HMG_aControlRangeMin [i]

	PageLength := ListViewGetCountPerPage ( _HMG_aControlhandles[i] )
	ListViewReset ( _HMG_aControlhandles[i] )

	if processdfc == .t.
		fcolormap := {}
		fcolorrow := {}
	endif

	if processdbc == .t.
		colormap := {}
		colorrow := {}
	endif
	if PageLength < 1
		PageLength := 1
	end
	if first < 1
		first:= 1
	end
	for x := 1 to PageLength 

		aTemp := {}

		If First == 2						// Browse+
			cTemp := Fields [1]
		
			if Type (cTemp) == 'N'				// ..
				image := &cTemp
			
			elseif Type (cTemp) == 'L'			// ..
				image := iif( &cTemp, 1, 0 )
		
			else						// ..
				image := 0
	
			endif						// ..
			aadd ( aTemp , NIL )

			if processdbc == .t.
				if valtype ( dbc ) = 'A' .and. len ( dbc ) = Len ( Fields )
					aadd ( colorrow , -1 )
				endif
			endif

			if processdfc == .t.
				if valtype ( dfc ) = 'A' .and. len ( dfc ) = Len ( Fields )
					aadd ( fcolorrow , -1 )
				endif
			endif

		EndIf							// Browse+

		For j := First To Len (Fields)
			cTemp := Fields [j]

			If Type (cTemp) == 'N'

				aadd ( aTemp , lTrim ( Str (&cTemp) ) )

			ElseIf Type (cTemp) == 'D'

				aadd ( aTemp , Dtoc(&cTemp) )

			ElseIf Type (cTemp) == 'L'

				aadd ( aTemp , IIF ( &cTemp == .T. , '.T.' , '.F.' ) )

			ElseIf Type (cTemp) == 'C'

				aadd ( aTemp , rTrim ( &cTemp ) )

			ElseIf Type (cTemp) == 'M'

				aadd ( aTemp , '<Memo>' )

			ElseIf ValType (cTemp) == 'N'

				aadd ( aTemp , lTrim ( Str(&cTemp) ) )

			ElseIf ValType (cTemp) == 'D'

				aadd ( aTemp , Dtoc(&cTemp) )

			ElseIf ValType (cTemp) == 'L'

				aadd ( aTemp , IIF ( &cTemp == .T. , '.T.' , '.F.' ) )

			ElseIf ValType (cTemp) == 'C'

				aadd ( aTemp , rTrim ( &cTemp ) )

			ElseIf ValType (cTemp) == 'M'

				aadd ( aTemp , '<Memo>' )

			Else
				aadd ( aTemp , 'Nil' )				

			EndIf

			if processdfc == .t.

				if valtype ( dfc ) = 'A' .and. len ( dfc ) = Len ( Fields )

					aadd ( fcolorrow , if( valtype ( dfc [j] ) = 'B', eval ( dfc [j] ) , -1 ) )

				endif

			endif

			if processdbc == .t.

				if valtype ( dbc ) = 'A' .and. len ( dbc ) = Len ( Fields )

					aadd ( colorrow , if( valtype ( dbc [j] ) = 'B', eval ( dbc [j] ) , -1 ) )

				endif

			endif

		Next j

		AddListViewItems ( _HMG_aControlhandles[i] , aTemp , Image )

		_Rec := RecNo()

		aadd ( _BrowseRecMap , _Rec )

		if processdfc == .t.
			aadd ( fcolormap , fcolorrow )
			fcolorrow := {}
		endif

		if processdbc == .t.
			aadd ( colormap , colorrow )
			colorrow := {}
		endif

		*Skip

		If Eof()
			_HMG_aControlContainerHandle [i] := 1
			Go Bottom
			Exit
		EndIf
		Skip

	Next x

	__MVPUBLIC	( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DBC' )
	__MVPUBLIC	( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DFC' )

	if processdbc == .t.
		__MVPUT		( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DBC' , colormap )
	else
		__MVPUT		( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DBC' , Nil )
	endif

	if processdfc == .t.
		__MVPUT		( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DFC' , fcolormap )
	else
		__MVPUT		( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DFC' , Nil )
	endif

	_HMG_aControlRangeMax [i] := _BrowseRecMap

Return

*-----------------------------------------------------------------------------*
Procedure _BrowseNext ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , PageLength , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil } , s 

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	_DeltaScroll := ListView_GetSubItemRect ( _HMG_aControlhandles[i] , 0 , 0 ) 

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	PageLength := LISTVIEWGETCOUNTPERPAGE ( _HMG_aControlhandles[i] )

	s := LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] )

	If  s == PageLength 

		if _HMG_aControlContainerHandle [i] != 0
			Return
		EndIf

		_Alias := Alias()
		_BrowseArea := _HMG_aControlSpacing [i]
		If Select (_BrowseArea) == 0
			Return
		EndIf
		Select &_BrowseArea
		_RecNo := RecNo()

		Go _BrowseRecMap [PageLength] 
		_BrowseUpdate( ControlName , ParentForm , i )
		_BrowseVscrollUpdate( i )
		ListView_Scroll( _HMG_aControlHandles[i] , _DeltaScroll[2] * (-1) , 0 )
		ListView_SetCursel ( _HMG_aControlHandles [i] , Len(_HMG_aControlRangeMax [i] ) )
		Go _RecNo
		if Select( _Alias ) != 0
			Select &_Alias
		Else
			Select 0
		Endif

	Else

		ListView_SetCursel ( _HMG_aControlHandles [i] , Len(_BrowseRecMap) )
		_BrowseVscrollFastUpdate ( i , PageLength - s )

	EndIf

	_BrowseOnChange (i)

Return

*-----------------------------------------------------------------------------*
Procedure _BrowsePrior ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	_DeltaScroll := ListView_GetSubItemRect ( _HMG_aControlhandles[i] , 0 , 0 ) 

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	If LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) == 1
		_Alias := Alias()
		_BrowseArea := _HMG_aControlSpacing [i]
		If Select (_BrowseArea) == 0
			Return
		EndIf
		Select &_BrowseArea
		_RecNo := RecNo()
		Go _BrowseRecMap [1]
		Skip - LISTVIEWGETCOUNTPERPAGE ( _HMG_aControlhandles[i] ) + 1
		_BrowseVscrollUpdate( i )
		_BrowseUpdate(ControlName , ParentForm , i )
		ListView_Scroll( _HMG_aControlHandles[i] , _DeltaScroll[2] * (-1) , 0 )
		Go _RecNo
		if Select( _Alias ) != 0
			Select &_Alias
		Else
			Select 0
		Endif

	Else

		_BrowseVscrollFastUpdate ( i , 1 - LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) )

	EndIf

	ListView_SetCursel ( _HMG_aControlHandles [i] , 1 )		

	_BrowseOnChange (i)

Return

*-----------------------------------------------------------------------------*
Procedure _BrowseHome ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	_DeltaScroll := ListView_GetSubItemRect ( _HMG_aControlhandles[i] , 0 , 0 ) 

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	_Alias := Alias()
	_BrowseArea := _HMG_aControlSpacing [i]
	If Select (_BrowseArea) == 0
		Return
	EndIf
	Select &_BrowseArea
	_RecNo := RecNo()
	Go Top
	_BrowseVscrollUpdate( i )
	_BrowseUpdate( ControlName , ParentForm , i )
	ListView_Scroll( _HMG_aControlHandles[i] , _DeltaScroll[2] * (-1) , 0 )
	Go _RecNo
	if Select( _Alias ) != 0
		Select &_Alias
	Else
		Select 0
	Endif

	ListView_SetCursel ( _HMG_aControlHandles [i] , 1 )		

	_BrowseOnChange (i)

Return

*-----------------------------------------------------------------------------*
Procedure _BrowseEnd ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , _Alias , _RecNo , _BrowseArea , _BrowseRecMap   , _DeltaScroll := { Nil , Nil , Nil , Nil } , _BottomRec

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	_DeltaScroll := ListView_GetSubItemRect ( _HMG_aControlhandles[i] , 0 , 0 ) 

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	_Alias := Alias()
	_BrowseArea := _HMG_aControlSpacing [i]
	If Select (_BrowseArea) == 0
		Return
	EndIf
	Select &_BrowseArea
	_RecNo := RecNo()
	Go Bottom
	_BottomRec := RecNo()

	_BrowseVscrollUpdate( i )
	Skip - LISTVIEWGETCOUNTPERPAGE ( _HMG_aControlhandles[i] ) + 1
	_BrowseUpdate(ControlName , ParentForm , i )
	ListView_Scroll( _HMG_aControlHandles[i] , _DeltaScroll[2] * (-1) , 0 )
	Go _RecNo
	if Select( _Alias ) != 0
		Select &_Alias
	Else
		Select 0
	Endif

	ListView_SetCursel ( _HMG_aControlHandles [i] , ascan ( _HMG_aControlRangeMax [i] , _BottomRec ) )

	_BrowseOnChange (i)

Return

*-----------------------------------------------------------------------------*
Procedure _BrowseUp ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , s  , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	_DeltaScroll := ListView_GetSubItemRect ( _HMG_aControlhandles[i] , 0 , 0 ) 

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	s := LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) 

	If s == 1
		_Alias := Alias()
		_BrowseArea := _HMG_aControlSpacing [i]
		If Select (_BrowseArea) == 0
			Return
		EndIf
		Select &_BrowseArea
		_RecNo := RecNo()
		Go _BrowseRecMap [1]
		Skip - 1
		_BrowseVscrollUpdate( i )
		_BrowseUpdate(ControlName , ParentForm , i )
		ListView_Scroll( _HMG_aControlHandles[i] , _DeltaScroll[2] * (-1) , 0 )
		Go _RecNo
		if Select( _Alias ) != 0
			Select &_Alias
		Else
			Select 0
		Endif
		ListView_SetCursel ( _HMG_aControlHandles [i] , 1 )		

	Else
		ListView_SetCursel ( _HMG_aControlHandles [i] , s - 1 )		
		_BrowseVscrollFastUpdate ( i , -1 )
	EndIf

	_BrowseOnChange (i)

Return

*-----------------------------------------------------------------------------*
Procedure _BrowseDown ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , PageLength , s , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	_DeltaScroll := ListView_GetSubItemRect ( _HMG_aControlhandles[i] , 0 , 0 ) 

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	s := LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) 

	PageLength := LISTVIEWGETCOUNTPERPAGE ( _HMG_aControlhandles[i] )

	If s == PageLength

		if _HMG_aControlContainerHandle [i] != 0
			Return
		EndIf

		_Alias := Alias()
		_BrowseArea := _HMG_aControlSpacing [i]
		If Select (_BrowseArea) == 0
			Return
		EndIf
		Select &_BrowseArea
		_RecNo := RecNo()

		Go _BrowseRecMap [1] 
		Skip
		_BrowseUpdate( ControlName , ParentForm , i )
		_BrowseVscrollUpdate( i )
		ListView_Scroll( _HMG_aControlHandles[i] , _DeltaScroll[2] * (-1) , 0 )
		Go _RecNo
		if Select( _Alias ) != 0
			Select &_Alias
		Else
			Select 0
		Endif

		ListView_SetCursel ( _HMG_aControlHandles [i] , Len(_HMG_aControlRangeMax [i]) )		

	Else

		ListView_SetCursel ( _HMG_aControlHandles [i] , s+1 )		
		_BrowseVscrollFastUpdate ( i , 1 )

	EndIf

	_BrowseOnChange (i)

Return

*-----------------------------------------------------------------------------*
Procedure _BrowseRefresh ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , s , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , _DeltaScroll := { Nil , Nil , Nil , Nil }
Local v
Memvar cMacroVar
Private cMacroVar

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	v := _BrowseGetValue ( '','' , i )

	_DeltaScroll := ListView_GetSubItemRect ( _HMG_aControlhandles[i] , 0 , 0 ) 

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	s := LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) 

	_Alias := Alias()
	_BrowseArea := _HMG_aControlSpacing [i]

	If Select (_BrowseArea) == 0
		*-msginfo('entro aqui porque esta con filtro?')
		ListViewReset ( _HMG_aControlhandles[i] )
		Return
	EndIf

	Select &_BrowseArea
	_RecNo := RecNo()
		if v <= 0
			v := _RecNo
		EndIf

		Go v

		if s == 1 .or. s == 0
			cMacroVar := dbfilter()
			If Len (cMacroVar) > 0
				If ! &cMacroVar
					Skip
				EndIf
			EndIf
		EndIf		
	
		if s == 0
			if INDEXORD() != 0
				if ORDKEYVAL() == Nil
					Go Top
				endif
			EndIf
		endif

		if s == 0
			if Set ( _SET_DELETED ) == .T.
				if Deleted() == .T.
					Go Top
				endif
			EndIf
		endif
	/*	
	If Eof()

		*ListViewReset ( _HMG_aControlhandles[i] )

		*Go _RecNo 

		if Select( _Alias ) != 0
			Select &_Alias
		Else
			Select 0
		Endif

		*Return

	EndIf
	*/
	_BrowseVscrollUpdate( i )

	if s != 0
		Skip -s+1
	EndIf

	_BrowseUpdate( '' , '' , i )

	ListView_Scroll( _HMG_aControlHandles[i] , _DeltaScroll[2] * (-1) , 0 )
	ListView_SetCursel ( _HMG_aControlHandles [i] , ascan ( _HMG_aControlRangeMax [i] , v ) )		

	Go _RecNo
	if Select( _Alias ) != 0
		Select &_Alias
	Else
		Select 0
	Endif

Return

*-----------------------------------------------------------------------------*
Procedure _BrowseSetValue ( ControlName , ParentForm , Value , z , mp )
*-----------------------------------------------------------------------------*
Local i  , _Alias , _RecNo , _BrowseArea , _BrowseRecMap , NewPos := 50  , _DeltaScroll := { Nil , Nil , Nil , Nil } , m
Memvar cMacroVar
Private cMacroVar

	If Value <= 0 
		Return
	EndIf

	If valtype ( z ) == 'U'
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	If _HMG_ThisEventType == 'BROWSE_ONCHANGE'
		If i == _HMG_THISINDEX
			MsgMiniGuiError ("BROWSE: Value property can't be changed inside ONCHANGE event. Program Terminated" )
		EndIf
	EndIf

	_Alias := Alias()
	_BrowseArea := _HMG_aControlSpacing [i]

	If Select (_BrowseArea) == 0
		Return
	EndIf

	If Value == (_BrowseArea)->(RecCount()) + 1
		_HMG_aControlValue [i] := Value
		ListViewReset ( _HMG_aControlhandles[i] )
		_BrowseOnChange (i)
		Return
	EndIf

	If Value > (_BrowseArea)->(RecCount()) + 1
		Return
	EndIf

	If Select (_BrowseArea) == 0
		Return
	EndIf

	If valtype ( mp ) == 'U'
		m := int ( ListViewGetCountPerPage ( _HMG_aControlhandles[i] ) / 2 )
	else
		m := mp
	endif

	_DeltaScroll := ListView_GetSubItemRect ( _HMG_aControlhandles[i] , 0 , 0 ) 
	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	Select &_BrowseArea
	
	_RecNo := RecNo()

	Go Value

	cMacroVar := dbfilter()

	If Len (cMacroVar) > 0

		If ! &cMacroVar

			Go _RecNo
			if Select( _Alias ) != 0
				Select &_Alias
			Else
				Select 0
			Endif

			Return
			
		EndIf

	EndIf

	If Eof()
		Go _RecNo
		if Select( _Alias ) != 0
			Select &_Alias
		Else
			Select 0
		Endif
		Return
	Else
		if pcount() < 5
			_BrowseVscrollUpdate( i )
		EndIf
		Skip -m + 1
	EndIf

	_HMG_aControlValue [i] := Value
	_BrowseUpdate( '' , '' , i )
	Go _RecNo
	if Select( _Alias ) != 0
		Select &_Alias
	Else
		Select 0
	Endif

	ListView_Scroll( _HMG_aControlHandles[i] , _DeltaScroll[2] * (-1) , 0 )
	ListView_SetCursel ( _HMG_aControlHandles [i] , ascan ( _HMG_aControlRangeMax [i] , Value ) )		

	_HMG_ThisEventType := 'BROWSE_ONCHANGE'
	_BrowseOnChange (i)
	_HMG_ThisEventType := ''

Return

*-----------------------------------------------------------------------------*
Function _BrowseGetValue ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , RetVal , _BrowseRecMap , _Alias , _BrowseArea

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	_Alias := Alias()
	_BrowseArea := _HMG_aControlSpacing [i]

	If Select (_BrowseArea) == 0
		Return 0
	EndIf

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	If LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) != 0
#ifdef __XHARBOUR__
		RetVal := _BrowseRecMap [ LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) ]
#else
		RetVal := _BrowseRecMap [ LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA[137] [i] ) ]
#endif
	Else
		if( eof(), Retval:=1, RetVal := 0 )
	EndIf

Return ( RetVal )

*-----------------------------------------------------------------------------*
Function  _BrowseDelete (  ControlName , ParentForm , z  )
*-----------------------------------------------------------------------------*
Local i , _BrowseRecMap , Value , _Alias , _RecNo , _BrowseArea 

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	If LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) == 0
		Return Nil
	EndIf

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

#ifdef __XHARBOUR__
	Value := _BrowseRecMap [ LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) ]
#else
	Value := _BrowseRecMap [ LISTVIEW_GETFIRSTITEM ( _HMG_SYSDATA[137] [i] ) ]
#endif

	If Value == 0
		Return Nil
	EndIf

	_Alias := Alias()
	_BrowseArea := _HMG_aControlSpacing [i]
	If Select (_BrowseArea) == 0
		Return Nil
	EndIf
	Select &_BrowseArea
	_RecNo := RecNo()

	Go Value

	If _HMG_aControlInputMask [i] == .t.
		If Rlock()
			Delete
			Skip
			if eof()
				Go Bottom
			EndIf

			If Set ( _SET_DELETED ) == .T.
				_BrowseSetValue( '' , '' , RecNo() , i , LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) )
			EndIf

		Else

			MsgStop('Record is being editied by another user. Retry later','Delete Record')

		EndIf

	Else

		Delete
		Skip
		if eof()
			Go Bottom
		EndIf
		If Set ( _SET_DELETED ) == .T.
			_BrowseSetValue( '' , '' , RecNo() , i  , LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) )
		EndIf

	EndIf

	Go _RecNo
	if Select( _Alias ) != 0
		Select &_Alias
	Else
		Select 0
	Endif

Return Nil

*------------------------------------------------------------------------------*
Function _BrowseEdit ( GridHandle , aValid , aValidMessages , aReadOnly , lock , append , inplace )
*------------------------------------------------------------------------------*
Local a,l,g,actpos:={0,0,0,0},h,GRow,GCol,GWidth,Col,IRow, i , ControlName , j , FormName , item
Local Title , aLabels , aInitValues := {} , aFormats := {} , aResults , z , tvar , BackRec , aStru , y , svar , q , BackArea , BrowseArea , TmpNames := {} , NewRec := 0 , MixedFields := .f.
memvar aWhen , aWhenVarNames
Private aWhen , aWhenVarNames

	If LISTVIEW_GETFIRSTITEM (GridHandle) == 0 
		If Valtype (append) != 'U'
			If append == .f.
				Return Nil
			EndIf
		EndIf			
	EndIf

	If InPlace 
		_BrowseInPlaceEdit ( GridHandle , aValid , aValidMessages , aReadOnly , lock , append )		
		Return Nil
	EndIf

	BackArea := Alias()

	_HMG_ActiveFormNameBak := _HMG_ActiveFormName

	i := ascan (_HMG_aControlHandles , GridHandle )

	aWhen := __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_WHEN' )

	a := _HMG_aControlPageMap [i]
	ControlName := _HMG_aControlNames [i]

	j := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles [ i ] )

	FormName := _HMG_aFormNames [ j ]

	item := _GetValue ( ControlName , FormName )

	l := Len(a)

	g := _GetItem ( ControlName , FormName , Item )

	h := GridHandle

	IRow := ListViewGetItemRow (h, LISTVIEW_GETFIRSTITEM ( h ) )

	GetWindowRect(h,actpos)

	GRow 	:= actpos [2]
	GCol 	:= actpos [1] 
	GWidth 	:= actpos [3] - actpos [1]

	Col := GCol + ( ( GWidth - 310 ) / 2 )

	If Valtype (append) != 'U'
		If append == .t.
			Title := _HMG_BRWLangButton[1]
		Else
			Title := _HMG_BRWLangButton[2]
		EndIf
	ELse
		Title := _HMG_BRWLangButton[2]
	EndIf

	aLabels 	:= _HMG_aControlCaption [i]

	BrowseArea := _HMG_aControlSpacing [i]
	Select &BrowseArea

	BackRec := RecNo()

	If Valtype (append) != 'U'
		If append == .t.
			Go Bottom
			Skip
		Else
			Go item 
		EndIf
	ELse
		Go item 
	EndIf

	For z := 1 To Len ( _HMG_aControlRangeMin [i] )

		tvar := _HMG_aControlRangeMin [i] [z]

		if valtype (&tvar) == 'C'

			Aadd ( aInitValues , Alltrim(&tvar) ) 

		Else			

			Aadd ( aInitValues , &tvar ) 

		EndIf

	Next z	

	For z := 1 To Len ( _HMG_aControlRangeMin [i] )
		
		tvar := Upper ( _HMG_aControlrangeMin [i] [z] )

		q := at ( '>' , tvar )
		
		if q == 0
	
		        Select &BrowseArea
			aStru := DbStruct () 

			aAdd ( TmpNames , 'MemVar' + BrowseArea + tvar )

		Else
	
			svar := Left ( tvar , q-2 )
		        Select &svar
			aStru := DbStruct() 

			tvar := Right ( tvar , Len (tvar) - q ) 

			aAdd ( TmpNames , 'MemVar' + svar + tvar )

			If Upper(svar) != Upper(BrowseArea)
				MixedFields := .t.				
			EndIf

		EndIf

		If Valtype (append) != 'U'
			If append == .t.
				If MixedFields == .t.
					MsgMiniGuiError(_HMG_BRWLangError[8],_HMG_BRWLangError[3])
				EndIf
			EndIf
		EndIf
		
		For y := 1 To Len (aStru)

			If Upper (aStru [y] [1]) == tvar

				If aStru [y] [2] == 'N' .And. aStru [y] [4] == 0
					Aadd ( aFormats , Replicate('9', aStru [y] [3] ) )
				ElseIf aStru [y] [2] == 'N' .And. aStru [y] [4] > 0
					Aadd ( aFormats , Replicate('9', (aStru [y] [3] - aStru [y] [4] - 1) ) +'.'+Replicate('9', aStru [y] [4]) )
				ElseIf aStru [y] [2] == 'C'
					Aadd ( aFormats , aStru [y] [3] )			
				ElseIf aStru [y] [2] == 'D'
					Aadd ( aFormats , Nil )			
				ElseIf aStru [y] [2] == 'L'
					Aadd ( aFormats , Nil )							
				EndIf
			EndIf
			
		Next y
											// Browse+
	Next z

	aWhenVarNames := tmpnames

	Select &BrowseArea

	If lock == .t.

		If Rlock() == .F.
			MsgExclamation(_HMG_BRWLangError[9],_HMG_BRWLangError[10])
			Go BackRec
			If Select (BackArea) != 0
				Select &BackArea
			Else
				Select 0
			EndIf
			_HMG_ActiveFormName := _HMG_ActiveFormNameBak
			_SetFocus( ControlName , FormName )
			Return Nil
		EndIf

	EndIf

	aResults := _EditRecord ( Title , aLabels , aInitValues , aFormats , GRow , Col , aValid , TmpNames , aValidMessages , aReadOnly , actpos [4] - actpos [2] )
	tvar := aResults [1]
	If ValType ( tvar ) != 'U'

		If Valtype (append) != 'U'
			If append == .t.
				APPEND BLANK
				NewRec := RecNo()
			EndIf
		EndIf

		For z := 1 To Len ( aResults )

			tvar := _HMG_aControlRangeMin [i] [z]
			
			If ValType (aReadOnly) == 'U' 

				Replace &tvar With aResults [z]

			Else

				If aReadOnly [z] == .F.
	
					Replace &tvar With aResults [z]
	
				EndIf

			EndIf

		Next z	

		_BrowseRefresh ( '' , '' , i )

	EndIf

	If lock == .t.
		Unlock
	EndIf

	Go BackRec

	If Select (BackArea) != 0
		Select &BackArea
	Else
		Select 0
	EndIf

	_HMG_ActiveFormName := _HMG_ActiveFormNameBak

	_SetFocus( ControlName , FormName )

	If Valtype (append) != 'U'
		If append == .t.
			If NewRec != 0
				_SetValue ( ControlName , FormName , NewRec )
			EndIf
		EndIf
	EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _EditRecord ( Title , aLabels , aValues , aFormats , row , col , aValid , TmpNames , aValidMessages , aReadOnly , h )
*-----------------------------------------------------------------------------*
Local i , ControlRow , e := 0 , LN , CN , th 

	memvar aresult , l

	Private l := Len ( aLabels )
	Private aResult [l]
	
	For i := 1 to l

		if ValType ( aValues[i] ) == 'C'

			if ValType ( aFormats[i] ) == 'N'

				If aFormats[i] > 32
					e++
				Endif

			EndIf

		EndIf

		if ValType ( aValues[i] ) == 'M'  
			e++
		EndIf

	Next i

	th := (l*30) + (e*60) + 30
	
	IF TH < H
		TH := H + 1
	ENDIF

	DEFINE WINDOW _EditRecord ;
		AT row,col ;
		WIDTH 310 ;
		HEIGHT h - 19 + GetTitleHeight() ;
		TITLE Title ; 
		MODAL NOSIZE ;
		ON INIT ( _SetFocus ('Control_1','_Split_1'), ThisWindow.Setfocus )

		ON KEY ALT+O ACTION _EditRecordOk ( aValid , TmpNames , aValidMessages )
		ON KEY ALT+C ACTION _EditRecordCancel()

		DEFINE SPLITBOX

			DEFINE WINDOW _Split_1 ; 
				WIDTH 310 ;
				HEIGHT H - 90 ;
				VIRTUAL HEIGHT TH ;
				SPLITCHILD NOCAPTION FONT 'Arial' SIZE 10 BREAK FOCUSED

				ON KEY ALT+O ACTION _EditRecordOk ( aValid , TmpNames , aValidMessages )
				ON KEY ALT+C ACTION _EditRecordCancel()

				ControlRow :=  10

				For i := 1 to l

					LN := 'Label_' + Alltrim(Str(i,0))
					CN := 'Control_' + Alltrim(Str(i,0))

					@ ControlRow , 10 LABEL &LN OF _Split_1 VALUE aLabels [i] WIDTH 90

					do case
					case ValType ( aValues [i] ) == 'L'

						@ ControlRow , 120 CHECKBOX &CN OF _Split_1 CAPTION '' VALUE aValues[i] ON LOSTFOCUS _WHENEVAL()
						ControlRow := ControlRow + 30

					case ValType ( aValues [i] ) == 'D'

						@ ControlRow , 120 DATEPICKER &CN  OF _Split_1 VALUE aValues[i] WIDTH 140 ON LOSTFOCUS _WHENEVAL()
						ControlRow := ControlRow + 30

					case ValType ( aValues [i] ) == 'N'

						If ValType ( aFormats [i] ) == 'A'
							@ ControlRow , 120 COMBOBOX &CN  OF _Split_1 ITEMS aFormats[i] VALUE aValues[i] WIDTH 140  FONT 'Arial' SIZE 10 ON LOSTFOCUS _WHENEVAL()
							ControlRow := ControlRow + 30

						ElseIf  ValType ( aFormats [i] ) == 'C'

							If AT ( '.' , aFormats [i] ) > 0
								@ ControlRow , 120 TEXTBOX &CN  OF _Split_1 VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 NUMERIC INPUTMASK aFormats [i] ON LOSTFOCUS _WHENEVAL() 
							Else
								@ ControlRow , 120 TEXTBOX &CN  OF _Split_1 VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 MAXLENGTH Len(aFormats [i]) NUMERIC ON LOSTFOCUS _WHENEVAL()
							EndIf

							ControlRow := ControlRow + 30
						Endif

					case ValType ( aValues [i] ) == 'C'

						If ValType ( aFormats [i] ) == 'N'
							If  aFormats [i] <= 32
								@ ControlRow , 120 TEXTBOX &CN  OF _Split_1 VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 MAXLENGTH aFormats [i] ON LOSTFOCUS _WHENEVAL()
								ControlRow := ControlRow + 30
							Else
								@ ControlRow , 120 EDITBOX &CN  OF _Split_1 WIDTH 140 HEIGHT 90 VALUE aValues[i] FONT 'Arial' SIZE 10 MAXLENGTH aFormats[i] ON LOSTFOCUS _WHENEVAL()
								ControlRow := ControlRow + 94
							EndIf
						EndIf

					case ValType ( aValues [i] ) == 'M'

						@ ControlRow , 120 EDITBOX &CN  OF _Split_1 WIDTH 140 HEIGHT 90 VALUE aValues[i] FONT 'Arial' SIZE 10 ON LOSTFOCUS _WHENEVAL()
						ControlRow := ControlRow + 94

					endcase

					If ValType ( aReadOnly ) != 'U'

						If aReadOnly [i] == .T.

						     _DisableControl ( CN ,'_Split_1' )

						EndIf

					EndIf

				Next i

			END WINDOW

			DEFINE WINDOW _Split_2 ; 
				WIDTH 300 ;
				HEIGHT 50 ;
				SPLITCHILD NOCAPTION FONT 'Arial' SIZE 10 BREAK

				@ 10 , 40 BUTTON BUTTON_1 ;
				OF _Split_2 ;
				CAPTION _HMG_BRWLangButton[4] ;
				ACTION _EditRecordOk ( aValid , TmpNames , aValidMessages )

				@ 10 , 150 BUTTON BUTTON_2 ;
				OF _Split_2 ;
				CAPTION _HMG_BRWLangButton[3] ;
				ACTION _EditRecordCancel()

			END WINDOW

		END SPLITBOX 		

	END WINDOW

	ACTIVATE WINDOW _EditRecord

Return ( aResult )

PROCEDURE _WHENEVAL ()
Local i, x, CN, E
Local Result, mVar
Local ControlName
memvar aWhen , l , aWhenVarNames

	IF VALTYPE ( aWhen ) = 'A'

		IF LEN (aWhen) >= l

			For x := 1 to l
				ControlName := 'Control_' + Alltrim ( Str ( x , 0 ) )
				Result := _GetValue ( ControlName , '_Split_1' )
				mVar := aWhenVarNames [x]
				&mVar := Result 
			Next x


			FOR i := 1 TO l

				IF VALTYPE ( aWhen [i] ) = 'B'

					CN := 'Control_' + Alltrim ( Str ( i , 0 ) )
		
					E := EVAL ( aWhen [i] )
					IF E == .F.				
					     _DisableControl ( CN ,'_Split_1' )
					ELSE
					     _EnableControl ( CN ,'_Split_1' )
					ENDIF
				
				ENDIF

			NEXT i

		ENDIF

	ENDIF

RETURN

*-----------------------------------------------------------------------------*
Function _EditRecordOk ( aValid , TmpNames , aValidMessages )
*-----------------------------------------------------------------------------*
Local i , ControlName , l , b , mVar
Memvar aresult

	l := len (aResult)

	For i := 1 to l

		ControlName := 'Control_' + Alltrim ( Str ( i , 0 ) )
		aResult [i] := _GetValue ( ControlName , '_Split_1' )

		If ValType (aValid) != 'U'

			mVar := TmpNames [i]
			&mVar := aResult [i]

		EndIf

	Next i

	If ValType (aValid) == 'A'

		For i := 1 to l

			If ValType ( aValid [i] ) == 'B'

				b := Eval ( aValid [i] )
			
				If b == .f.

				        If ValType ( aValidMessages ) == 'A'

						If ValType ( aValidMessages [i] ) != 'U'

							MsgExclamation ( aValidMessages[i] )

						Else

							MsgExclamation (_HMG_BRWLangError[11])

						EndIf

					Else

						MsgExclamation (_HMG_BRWLangError[11])

					EndIf


					_SetFocus ( 'Control_' + Alltrim( Str( i , 0 ) ) , '_Split_1' )

					Return Nil

				EndIf

			EndIf

		Next i

	EndIf

	RELEASE WINDOW _EditRecord

Return Nil

*-----------------------------------------------------------------------------*
Function _EditRecordCancel
*-----------------------------------------------------------------------------*
Local i , l
Memvar aresult

	l := len (aResult)

	For i := 1 to l

		aResult [i] := Nil

	Next i

	RELEASE WINDOW _EditRecord

Return Nil

*------------------------------------------------------------------------------*
Function _BrowseInPlaceEdit ( GridHandle , aValid , aValidMessages , aReadOnly , lock , append )
*------------------------------------------------------------------------------*
Local GridCol , GridRow , i , nrec , _GridWorkArea , BackArea , BackRec , _GridFields , FieldName , CellData  := '' , CellColIndex , x
Local aFieldNames
Local aTypes	
Local aWidths		
Local aDecimals	
Local Type		
Local Width		
Local Decimals	
Local sFieldname
Local r
Local ControlType
Local Ldelta := 0
Local aTemp
Local E, abKeyBlocks := {}

	If append

		I := ascan ( _HMG_aControlhandles , GridHandle )

		_BrowseInPlaceAppend ( '' , '' , i )

		Return Nil

	EndIf

	If This.CellRowIndex != LISTVIEW_GETFIRSTITEM ( GridHandle )
		Return Nil
	EndIf

	I := ascan ( _HMG_aControlhandles , GridHandle ) 

	_GridWorkArea := _HMG_aControlSpacing [i]

	_GridFields := _HMG_aControlRangeMin [i]

	CellColIndex := This.CellColIndex

	If CellColIndex < 1 .or. CellColIndex > Len (_GridFields)
		Return Nil
	EndIf

	if Len ( _HMG_aControlBkColor [i] ) > 0 .And. CellColIndex == 1 
		PlayHand()
		Return Nil
	EndIf

	If ValType ( aReadOnly ) == 'A'
		If Len ( aReadOnly ) >= CellColIndex
			If aReadOnly [ CellColIndex ] != Nil
				If aReadOnly [ CellColIndex ] == .T.
					_HMG_IPE_CANCELLED := .F.
					Return Nil
				EndIf
			EndIf
		EndIf
	EndIf

	FieldName := _GridFields [  CellColIndex ]

	// It the specified area does not exists, set recorcount to 0 and
	// return 

	If Select (_GridWorkArea) == 0
		Return Nil
	EndIf

	// Save Original WorkArea
	BackArea := Alias()

	// Save Original Record Pointer
	BackRec := RecNo()

	// Selects Grid's WorkArea

	Select &_GridWorkArea

	nRec := _GetValue ( '','',i )
	Go nRec

	// If LOCK clause is present, try to lock.

	If lock == .T.
		If Rlock() == .F.
			MsgExclamation(_HMG_BRWLangError[9],_HMG_BRWLangError[10])
			// Restore Original Record Pointer
			Go BackRec
			// Restore Original WorkArea
			If Select (BackArea) != 0
				Select &BackArea
			Else
				Select 0
			EndIf
			Return Nil
		EndIf
	EndIf

	aTemp := __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_WHEN' )

	IF VALTYPE ( aTemp ) == 'A'
		IF LEN (aTemp) >= LEN (_GridFields)
			IF VALTYPE ( aTemp [CellColIndex] ) = 'B'
				E := EVAL ( aTemp [CellColIndex] )
				IF E == .F.				
					PlayHand()
					// Restore Original Record Pointer
					Go BackRec
					// Restore Original WorkArea
					If Select (BackArea) != 0
						Select &BackArea
					Else
						Select 0
					EndIf
					_HMG_IPE_CANCELLED := .F.
					Return Nil
				ENDIF
			ENDIF
		ENDIF
	ENDIF

	CellData := &FieldName

        aFieldNames	:= ARRAY(FCOUNT())
        aTypes		:= ARRAY(FCOUNT())
        aWidths		:= ARRAY(FCOUNT())
        aDecimals	:= ARRAY(FCOUNT())

        AFIELDS(aFieldNames, aTypes, aWidths, aDecimals)

	r := at ('>',FieldName) 

	if r != 0 
		sFieldName := Right ( FieldName, Len(Fieldname) - r ) 
	Else
		sFieldName := FieldName
	EndIf

	x := FieldPos ( sFieldName )

	If x > 0
        	Type		:= aTypes [x]
	        Width		:= aWidths [x]
        	Decimals	:= aDecimals [x]
	EndIf

	GridRow := GetWIndowRow (GridHandle)
	GridCol := GetWIndowCol (GridHandle)

	If Type (FieldName) == 'C'
		ControlType := 'C'
	ElseIf Type (FieldName) == 'D'
		ControlType := 'D'
	ElseIf Type (FieldName) == 'L'
		ControlType := 'L'
		Ldelta := 1
	ElseIf Type (FieldName) == 'M'
		ControlType := 'M'
	ElseIf Type (FieldName) == 'N'
		If Decimals == 0
			ControlType := 'I'
		Else
			ControlType := 'F'
		EndIf
	EndIf

	If ControlType == 'M'

		r := InputBox ( '' , 'Edit Memo' , STRTRAN(CellData,chr(141),' ') , , , .T. )

		If _HMG_DialogCancelled == .F.
			Replace &FieldName With r
			_HMG_IPE_CANCELLED := .F.
		Else
			_HMG_IPE_CANCELLED := .T.
		EndIf

		dbrunlock()
		setfocus ( GridHandle )

	Else

		DEFINE WINDOW _InPlaceEdit ;
			AT This.CellRow + GridRow - _HMG_aControlRow [i] - 1 , This.CellCol + GridCol - _HMG_aControlCol [i] + 2 ;
			WIDTH This.CellWidth ;
			HEIGHT This.CellHeight + 6 + Ldelta ;
			MODAL ;
			NOCAPTION ;
			NOSIZE

		ON KEY RETURN ACTION IF(_IsWindowActive('_InPlaceEdit'), _InPlaceEditOk ( i , Fieldname , _InPlaceEdit.Control_1.Value , ControlType , aValid , CellColIndex , sFieldName , _GridWorkArea , aValidMessages , lock ), NIL)
		ON KEY ESCAPE ACTION ( _HMG_IPE_CANCELLED := .T. , dbrunlock() , IF(_IsWindowActive('_InPlaceEdit'), _InPlaceEdit.Release, NIL) , setfocus ( GridHandle ) )

			If ControlType == 'C'
				CellData := rtrim ( CellData )

				DEFINE TEXTBOX Control_1
					ROW 0
					COL 0
					WIDTH This.CellWidth 
					HEIGHT This.CellHeight + 6
					VALUE CellData
					MAXLENGTH Width 
					FONTNAME _hmg_aControlFontName [i]
					FONTSIZE _hmg_aControlFontSize [i]
				END TEXTBOX

			ElseIf ControlType == 'D'

				DEFINE DATEPICKER Control_1
					ROW 0
					COL 0
					HEIGHT This.CellHeight + 6
					WIDTH This.CellWidth 
					VALUE CellData
					UPDOWN .T.
					FONTNAME _hmg_aControlFontName [i]
					FONTSIZE _hmg_aControlFontSize [i]
				END DATEPICKER

			ElseIf ControlType == 'L'

				DEFINE COMBOBOX Control_1
					ROW 0
					COL 0
					ITEMS { '.T.','.F.' }
					WIDTH This.CellWidth 
					VALUE If ( CellData , 1 , 2 )
					FONTNAME _hmg_aControlFontName [i]
					FONTSIZE _hmg_aControlFontSize [i]
					ON LISTDISPLAY ( AADD(abKeyBlocks, _GetHotKey ( '_InPlaceEdit', 0, 27 )), ;
						_ReleaseHotKey ('_InPlaceEdit',0,27 ), ;
						AADD(abKeyBlocks, _GetHotKey ('_InPlaceEdit', 0, 13 )), ;
						_ReleaseHotKey ('_InPlaceEdit',0,13 ) )
					ON LISTCLOSE ( _DefineHotKey('_InPlaceEdit', 0, 27, abKeyBlocks[1]), ;
						_DefineHotKey('_InPlaceEdit', 0, 13, abKeyBlocks[2]), ;
						abKeyBlocks := {} )
				END COMBOBOX

			ElseIf ControlType == 'I'

				DEFINE TEXTBOX Control_1
					ROW 0
					COL 0
					NUMERIC	.T.
					WIDTH This.CellWidth 
					HEIGHT This.CellHeight + 6
					VALUE CellData
					MAXLENGTH Width
					FONTNAME _hmg_aControlFontName [i]
					FONTSIZE _hmg_aControlFontSize [i]
				END TEXTBOX

			ElseIf ControlType == 'F'

				DEFINE TEXTBOX Control_1
					ROW 0
					COL 0
					NUMERIC	.T.
					INPUTMASK Replicate ( '9', Width - Decimals - 1 ) + '.' + Replicate ( '9', Decimals ) 
					WIDTH This.CellWidth 
					HEIGHT This.CellHeight + 6
					VALUE CellData
					FONTNAME _hmg_aControlFontName [i]
					FONTSIZE _hmg_aControlFontSize [i]
				END TEXTBOX

			EndIf

		END WINDOW

		ACTIVATE WINDOW _InPlaceEdit

	EndIf

	// Restore Original Record Pointer
	Go BackRec

	// Restore Original WorkArea
	If Select (BackArea) != 0
		Select &BackArea
	Else
		Select 0
	EndIf

Return Nil
///////////////////////////////////////////////////////////////////////////////
Procedure _InPlaceEditOk ( i , Fieldname , r , ControlType , aValid , CellColIndex , sfieldName , AreaName , aValidMessages )//, lock )
///////////////////////////////////////////////////////////////////////////////
Local b , Result , mVar , TmpName 
	M->CellValue := r
	If ValType ( aValid ) == 'A'
		If Len ( aValid ) >= CellColIndex
			If aValid [ CellColIndex ] != Nil

				Result := _GetValue ( 'Control_1' , '_InPlaceEdit' )

				If ControlType == 'L'
					Result := if ( Result == 0 .or. Result == 2 , .F. , .T. )
				EndIf

				TmpName := 'MemVar' + AreaName + sFieldname

				mVar := TmpName
				&mVar := Result
				*-----AGREGUE ESTA VARIABLE PUBLICA PARA PODER OBTENERLA DESDE EL PROGRAMA.
				M->CellValue := Result

				b := Eval ( aValid [ CellColIndex ] )
				If b == .f.

					If ValType ( aValidMessages ) == 'A'

						If Len ( aValidMessages ) >= CellColIndex

							If aValidMessages [CellColIndex] != Nil

								MsgExclamation ( aValidMessages [CellColIndex] )
							Else

								MsgExclamation (_HMG_BRWLangError[11])
							
							EndIf
							_SetValue( 'Control_1','_InplaceEdit', M->CellValue )

						Else

							MsgExclamation (_HMG_BRWLangError[11])
							_SetValue( 'Control_1','_InplaceEdit', M->CellValue )
						EndIf

					Else

						MsgExclamation (_HMG_BRWLangError[11])
						_SetValue( 'Control_1','_InplaceEdit', M->CellValue )

					EndIf

				Else
					Select( AreaName )
					If ControlType == 'L'
						r := if ( r == 0 .or. r == 2 , .F. , .T. )
					Else
						r := M->CellValue
					EndIf
					
					WHILE ! RLOCK(); END
					IF EOF()
						DBAPPEND()
					END
					Replace &FieldName With r
					DBUNLOCK()
					
					_BrowseRefresh ( '' , '' , i )

					_InPlaceEdit.Release

				EndIf

			Else
				Select( AreaName )

				If ControlType == 'L'
					r := if ( r == 0 .or. r == 2 , .F. , .T. )
				else
					r := M->CellValue
				EndIf
				WHILE !RLOCK(); END
				IF EOF()
					DBAPPEND()
				END
				Replace &FieldName With r
				DBUNLOCK()

				_BrowseRefresh ( '' , '' , i )

				_InPlaceEdit.Release

			EndIf

		EndIf

	Else
		Select( AreaName )

		If ControlType == 'L'
			r := if ( r == 0 .or. r == 2 , .F. , .T. )
		else
			r := M->CellValue
		EndIf
		WHILE !RLOCK();END
		IF EOF()
			DBAPPEND()
		END
		Replace &FieldName With r
		DBUNLOCK()

		_BrowseRefresh ( '' , '' , i )

		_InPlaceEdit.Release

	EndIf

	_HMG_IPE_CANCELLED := .F.

	setfocus ( _hmg_acontrolhandles [i] )

Return
*------------------------------------------------------------------------------*
Procedure ProcessInPlaceKbdEdit(i)
*------------------------------------------------------------------------------*
Local r, IPE_MAXCOL, TmpRow, hcMDI, xs, xd

	If _HMG_aControlFontColor [ i ] == .F.
		Return
	EndIf

	if LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) == 0
		Return
	EndIf

	IPE_MAXCOL := Len ( _HMG_aControlRangeMin [i] )

	Do While .T.

		TmpRow := LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] )

		If TmpRow != _HMG_IPE_ROW 

			_HMG_IPE_ROW := TmpRow

			if Len ( _HMG_aControlBkColor [i] ) > 0 
				_HMG_IPE_COL := 2
			Else
				_HMG_IPE_COL := 1
			EndIf

		EndIf

		_HMG_ThisItemRowIndex := _HMG_IPE_ROW
		_HMG_ThisItemColIndex := _HMG_IPE_COL

		If _HMG_IPE_COL == 1
			r := LISTVIEW_GETITEMRECT ( _HMG_aControlHandles [i]  , _HMG_IPE_ROW - 1 )
		Else
			r := LISTVIEW_GETSUBITEMRECT ( _HMG_aControlHandles [i]  , _HMG_IPE_ROW - 1 , _HMG_IPE_COL - 1 )
		EndIf

		xs :=	( ( _HMG_aControlCol [i] + r [2] ) +( r[3] ))  -  ( _HMG_aControlCol [i] + _HMG_aControlWidth [i] )

		xd := 20

		If xs > -xd 
			ListView_Scroll( _HMG_aControlHandles [i] ,	xs + xd , 0 ) 
		Else

        		If r [2] < 0
                	     ListView_Scroll( _HMG_aControlHandles [i] , r[2]	, 0 )
	                EndIf

		endIf

		If _HMG_IPE_COL == 1
			r := LISTVIEW_GETITEMRECT ( _HMG_aControlHandles [i]  , _HMG_IPE_ROW - 1 )
		Else
			r := LISTVIEW_GETSUBITEMRECT ( _HMG_aControlHandles [i]  , _HMG_IPE_ROW - 1 , _HMG_IPE_COL - 1 )
		EndIf

		_HMG_ThisItemCellRow := _HMG_aControlRow [i] + r [1]
		_HMG_ThisItemCellCol := _HMG_aControlCol [i] + r [2]
		_HMG_ThisItemCellWidth := r[3]
		_HMG_ThisItemCellHeight := r[4]

		hcMDI := GetActiveMdiHandle()	//JP12a

		_BrowseEdit ( _hmg_acontrolhandles[i] , _HMG_acontrolmiscdata1 [i] [4] , _HMG_acontrolmiscdata1 [i] [5] , _HMG_acontrolmiscdata1 [i] [3] , _HMG_aControlInputMask [i] , .f. , _HMG_aControlFontColor [i] )

		_MdiWindowsActivate(hcMDI)	//JP12a

		_HMG_ThisIndex := 0
		_HMG_ThisType := ''

		_HMG_ThisItemRowIndex := 0
		_HMG_ThisItemColIndex := 0
		_HMG_ThisItemCellRow := 0
		_HMG_ThisItemCellCol := 0
		_HMG_ThisItemCellWidth := 0
		_HMG_ThisItemCellHeight := 0

		If _HMG_IPE_CANCELLED == .T.

			If _HMG_IPE_COL == IPE_MAXCOL

				if Len ( _HMG_aControlBkColor [i] ) > 0 
					_HMG_IPE_COL := 2
				Else
					_HMG_IPE_COL := 1
				EndIf

				ListView_Scroll( _HMG_aControlHandles [i] ,	-10000  , 0 ) 
			EndIf

			Exit

		Else

			_HMG_IPE_COL++

			If _HMG_IPE_COL > IPE_MAXCOL

				if Len ( _HMG_aControlBkColor [i] ) > 0 
					_HMG_IPE_COL := 2
				Else
					_HMG_IPE_COL := 1
				EndIf

				ListView_Scroll( _HMG_aControlHandles [i] ,	-10000  , 0 ) 
				Exit
			EndIf

		EndIf		

	EndDo

Return
*------------------------------------------------------------------------------*
Procedure _BrowseSync (i)
*------------------------------------------------------------------------------*
Local _Alias
Local _BrowseArea
Local _RecNo
Local _CurrentValue

	If _HMG_BrowseSyncStatus == .T.

		_Alias := Alias()
		_BrowseArea := _HMG_aControlSpacing [i]
		If Select (_BrowseArea) == 0
			Return
		EndIf
		Select &_BrowseArea
		_RecNo := RecNo()

		_CurrentValue := _BrowseGetValue ( '' , '' , i )

		If _RecNo != _CurrentValue
			Go _CurrentValue
		EndIf

		if Select( _Alias ) != 0
			Select &_Alias
		Else
			Select 0
		Endif

	EndIf

Return
*------------------------------------------------------------------------------*
Procedure _BrowseOnChange (i)
*------------------------------------------------------------------------------*

	_BrowseSync (i)
	_DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i )

Return

*-----------------------------------------------------------------------------*
Procedure _BrowseInPlaceAppend ( ControlName , ParentForm , z )
*-----------------------------------------------------------------------------*
Local i , _Alias , _RecNo , _BrowseArea , _BrowseRecMap   , _DeltaScroll := { Nil , Nil , Nil , Nil } , _NewRec , aTemp 

	If pcount() == 2
		i := GetControlIndex ( ControlName , ParentForm )
	Else
		i := z
	EndIf

	_BrowseRecMap := _HMG_aControlRangeMax [i] 

	_Alias := Alias()
	_BrowseArea := _HMG_aControlSpacing [i]
	If Select (_BrowseArea) == 0
		Return
	EndIf
	Select &_BrowseArea
	_RecNo := RecNo()
	Go Bottom

	_NewRec := RecCount() + 1

	if LISTVIEWGETITEMCOUNT(_HMG_aControlhandles[i] ) != 0
		_BrowseVscrollUpdate( i )
		Skip - LISTVIEWGETCOUNTPERPAGE ( _HMG_aControlhandles[i] ) + 2
		_BrowseUpdate(ControlName , ParentForm , i )
	endif

	append blank

	Go _RecNo
	if Select( _Alias ) != 0
		Select &_Alias
	Else
		Select 0
	Endif

	aTemp := array ( Len (_HMG_aControlRangeMin [i]) )
	afill ( aTemp , '' )
	aadd ( _HMG_aControlRangeMax [i] , _NewRec )

	AddListViewItems ( _HMG_aControlhandles[i] , aTemp , 0 )

	ListView_SetCursel ( _HMG_aControlHandles [i] , Len ( _HMG_aControlRangeMax [i] ) )

	_BrowseOnChange (i)

	_HMG_IPE_ROW := 1
	_HMG_IPE_COL := 1

Return

*------------------------------------------------------------------------------*
Procedure _BrowseVscrollUpdate (i)
*------------------------------------------------------------------------------*
Local ActualRecord , RecordCount , KeyCount 

	// If vertical scrollbar is used it must be updated
	If _HMG_aControlIds [i] != 0

		KeyCount := OrdKeyCount()
		If KeyCount > 0
			ActualRecord := OrdKeyNo()
			RecordCount := KeyCount
		Else
			ActualRecord := RecNo()
			RecordCount := 1 //RecCount()
		EndIf

		_HMG_aControlBrushHandle [i] := RecordCount

		If RecordCount < 100
			SetScrollRange (_HMG_aControlIds [i] , 2 , 1 , RecordCount , .t. )
			SetScrollPos ( _HMG_aControlIds [i] , 2 , ActualRecord , 1 )
		Else
			SetScrollRange (_HMG_aControlIds [i] , 2 , 1 , 100 , .t. )
			SetScrollPos ( _HMG_aControlIds [i] , 2 , Int ( ActualRecord * 100 / RecordCount ) , 1 )
		EndIf

	EndIf

Return

*------------------------------------------------------------------------------*
Procedure _BrowseVscrollFastUpdate ( i , d )
*------------------------------------------------------------------------------*
Local ActualRecord , RecordCount 

	// If vertical scrollbar is used it must be updated
	If _HMG_aControlIds [i] != 0

		RecordCount := _HMG_aControlBrushHandle [i]  

		If RecordCount == 0 
			Return
		EndIf

		If RecordCount < 100
			ActualRecord := GetScrollPos( _HMG_aControlIds [i], 2 )
			ActualRecord := ActualRecord + d
			SetScrollRange (_HMG_aControlIds [i] , 2 , 1 , RecordCount , .t. )
			SetScrollPos ( _HMG_aControlIds [i] , 2 , ActualRecord , 1 )
		EndIf

	EndIf

Return

*------------------------------------------------------------------------------*
Function _SetBrowseAllowEdit ( cControlName , cWindowName , lValue )	
*------------------------------------------------------------------------------*
Local i

	If ValType ( lValue ) <> 'L'
		MsgMiniGuiError("Wrong Parameter Type (Logical Required). Program terminated" )
	Endif
	
	i := GetControlIndex ( cControlName , cWindowName )

	_hmg_aControlMiscData1 [i] [6] := lValue

Return Nil

*------------------------------------------------------------------------------*
Function _SetBrowseAllowAppend ( cControlName , cWindowName , lValue )	
*------------------------------------------------------------------------------*
Local i

	If ValType ( lValue ) <> 'L'
		MsgMiniGuiError("Wrong Parameter Type (Logical Required). Program terminated" )
	Endif
	
	i := GetControlIndex ( cControlName , cWindowName )

	_hmg_aControlMiscData1 [i] [2] := lValue

Return Nil

*------------------------------------------------------------------------------*
Function _SetBrowseAllowDelete ( cControlName , cWindowName , lValue )	
*------------------------------------------------------------------------------*
Local i

	If ValType ( lValue ) <> 'L'
		MsgMiniGuiError("Wrong Parameter Type (Logical Required). Program terminated" )
	Endif
	
	i := GetControlIndex ( cControlName , cWindowName )

	_HMG_aControlPicture [i] := lValue

Return Nil

*------------------------------------------------------------------------------*
Function _GetBrowseAllowEdit ( cControlName , cWindowName )	
*------------------------------------------------------------------------------*
Local i := GetControlIndex ( cControlName , cWindowName )

Return _hmg_aControlMiscData1 [i] [6] 

*------------------------------------------------------------------------------*
Function _GetBrowseAllowAppend ( cControlName , cWindowName )	
*------------------------------------------------------------------------------*
Local i := GetControlIndex ( cControlName , cWindowName )

Return _hmg_aControlMiscData1 [i] [2] 

*------------------------------------------------------------------------------*
Function _GetBrowseAllowDelete ( cControlName , cWindowName )	
*------------------------------------------------------------------------------*
Local i := GetControlIndex ( cControlName , cWindowName )

Return _HMG_aControlPicture [i]
