//===========================================================================//
// Programa......: Calculadora
// Programador...: Marcos Antonio Gambeta
// Criado em.....: 13/01/2004 11:00:00
// Atualizado em : 14/01/2004 00:10:47
//===========================================================================//
// Este programa  uma adaptao de um exemplo que acompanha o
// Visual Basic 5. O programa original pode ser encontrado (para quem tem o
// VB5), na pasta: C:\Arquivos de programas\DevStudio\VB\samples\PGuide\calc.
// Se voc melhorar ou ampliar os recursos desta calculadora, no deixe de
// enviar uma cpia para o autor da adaptao original. No caso, eu. :-)
//===========================================================================//

#include "minigui.ch"

#define PROGRAM "Calculadora"
//===========================================================================//
// VARIVEIS ESTTICAS
//===========================================================================//

Static nOp1,nOp2         // armazenam os valores entrados
Static lDecimalFlag      // indica se j h um ponto-decimal no valor
Static nNumOps           // nmero de valores entrados
Static cLastInput        // armazena a ltima tecla pressionada
Static cOpFlag           // indica a operao pendente
Static cTempReadout

//===========================================================================//
// JANELA PRINCIPAL
//===========================================================================//

Function Main()

   DEFINE WINDOW Form1 ;
      AT 0,0 WIDTH 218 HEIGHT 228 ;
      TITLE PROGRAM ;
      ICON "CALC.ICO" ;
      MAIN NOSIZE NOMAXIMIZE ;
      FONT "Arial" SIZE 10 ON INIT Form_Load()
      // visor
      @ 007,008 TEXTBOX ReadOut VALUE "0." WIDTH 200 HEIGHT 25 FONTCOLOR BLACK BACKCOLOR WHITE RIGHTALIGN NOTABSTOP
      // 7 8 9 C CE
      @ 040,008 BUTTONEX btnN7  CAPTION "7"  ACTION Number_Click(7)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 040,048 BUTTONEX btnN8  CAPTION "8"  ACTION Number_Click(8)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 040,088 BUTTONEX btnN9  CAPTION "9"  ACTION Number_Click(9)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 040,136 BUTTONEX btnC   CAPTION "C"  ACTION Cancel_Click()      WIDTH 32 HEIGHT 32 FONTCOLOR RED
      @ 040,176 BUTTONEX btnCE  CAPTION "CE" ACTION CancelEntry_Click() WIDTH 32 HEIGHT 32 FONTCOLOR RED
      // 4 5 6 + -
      @ 080,008 BUTTONEX btnN4  CAPTION "4"  ACTION Number_Click(4)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 080,048 BUTTONEX btnN5  CAPTION "5"  ACTION Number_Click(5)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 080,088 BUTTONEX btnN6  CAPTION "6"  ACTION Number_Click(6)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 080,136 BUTTONEX btnOA  CAPTION "+"  ACTION Operator_Click("+") WIDTH 32 HEIGHT 32 FONTCOLOR RED
      @ 080,176 BUTTONEX btnOS  CAPTION "-"  ACTION Operator_Click("-") WIDTH 32 HEIGHT 32 FONTCOLOR RED
      // 1 2 3 X /
      @ 120,008 BUTTONEX btnN1  CAPTION "1"  ACTION Number_Click(1)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 120,048 BUTTONEX btnN2  CAPTION "2"  ACTION Number_Click(2)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 120,088 BUTTONEX btnN3  CAPTION "3"  ACTION Number_Click(3)     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 120,136 BUTTONEX btnOM  CAPTION "X"  ACTION Operator_Click("X") WIDTH 32 HEIGHT 32 FONTCOLOR RED
      @ 120,176 BUTTONEX btnOD  CAPTION "/"  ACTION Operator_Click("/") WIDTH 32 HEIGHT 32 FONTCOLOR RED
      // 0 . = %
      @ 160,008 BUTTONEX btnN0  CAPTION "0"  ACTION Number_Click(0)     WIDTH 72 HEIGHT 32 FONTCOLOR BLUE
      @ 160,088 BUTTONEX btnDot CAPTION "."  ACTION Decimal_Click()     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
      @ 160,136 BUTTONEX btnOI  CAPTION "="  ACTION Operator_Click("=") WIDTH 32 HEIGHT 32 FONTCOLOR RED
      @ 160,176 BUTTONEX btnOP  CAPTION "%"  ACTION Percent_Click()     WIDTH 32 HEIGHT 32 FONTCOLOR BLUE
	END WINDOW
   DoMethod("Form1","Center")
   DoMethod("Form1","Activate")
   Return Nil

//---------------------------------------------------------------------------//
// Rotina de inicializao do formulrio.
// Define os valores iniciais das variveis.
//---------------------------------------------------------------------------//

Static Function Form_Load()

    lDecimalFlag := .f.
    nNumOps := 0
    cLastInput := "NONE"
    cOpFlag := " "
    Form1.Readout.Value := "0."
    nOp1 := 0
    nOp2 := 0

   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD7 , {|| Form1.btnN7.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD8 , {|| Form1.btnN8.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD9 , {|| Form1.btnN9.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD4 , {|| Form1.btnN4.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD5 , {|| Form1.btnN5.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD6 , {|| Form1.btnN6.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD1 , {|| Form1.btnN1.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD2 , {|| Form1.btnN2.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD3 , {|| Form1.btnN3.OnClick} )

   _DefineHotKey ( "Form1" , 0 , VK_C , {|| Form1.btnC.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_E , {|| Form1.btnCE.OnClick} )

   _DefineHotKey ( "Form1" , 0 , VK_ADD , {|| Form1.btnOA.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_SUBTRACT , {|| Form1.btnOS.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_MULTIPLY , {|| Form1.btnOM.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_DIVIDE , {|| Form1.btnOD.OnClick} )

   _DefineHotKey ( "Form1" , 0 , VK_NUMPAD0 , {|| Form1.btnN0.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_DECIMAL , {|| Form1.btnDot.OnClick} )
   _DefineHotKey ( "Form1" , 0 , VK_RETURN , {|| Form1.btnOI.OnClick} )
   _DefineHotKey ( "Form1" , MOD_SHIFT , VK_5 , {|| Form1.btnOP.OnClick} )

   _DefineHotKey ( "Form1" , 0 , VK_ESCAPE , {|| Form1.Release} )
   _ExtDisableControl ( "ReadOut", "Form1" )

    Return Nil

//---------------------------------------------------------------------------//
// Evento 'click' do boto "C" (CANCEL)
// Reseta o visor e inicializa as variveis.
//---------------------------------------------------------------------------//

Static Function Cancel_Click()

   Form1.Readout.Value := "0."
   nOp1 := 0
   nOp2 := 0
   Form_Load()
   Return Nil

//---------------------------------------------------------------------------//
// Evento 'click' do boto "CE" (CANCEL ENTRY)
// Cancela o valor no visor.
//---------------------------------------------------------------------------//

Static Function CancelEntry_Click()

    Form1.Readout.Value := "0."
    lDecimalFlag := .f.
    cLastInput := "CE"
    Return Nil

//---------------------------------------------------------------------------//
// Evento 'click' do boto "." (DECIMAL POINT)
// Se o ltimo boto pressionado foi um operador, inicializa
// o visor com "0.". Caso contrrio, adiciona um ponto decimal
// no visor.
//---------------------------------------------------------------------------//

Static Function Decimal_Click()

    If cLastInput = "NEG"
        Form1.Readout.Value := "-0."
    ElseIf cLastInput <> "NUMS"
        Form1.Readout.Value := "0."
    EndIf
    lDecimalFlag := .t.
    cLastInput := "NUMS"
    Return Nil

//---------------------------------------------------------------------------//
// Evento 'click' para os botes de 0-9 (NUMBERS KEYS)
// Adiciona o novo nmero ao nmero do visor.
//---------------------------------------------------------------------------//

Static Function Number_Click( nIndex )

    If cLastInput <> "NUMS"
       Form1.Readout.Value := "."
       lDecimalFlag := .f.
    EndIf
    If lDecimalFlag
       Form1.Readout.Value := Form1.Readout.Value + Str(nIndex,1)
    Else
       Form1.Readout.Value := Left(Form1.Readout.Value,At(".",Form1.Readout.Value)-1)+Str(nIndex,1)+"."
    EndIf
    If cLastInput = "NEG"
       Form1.Readout.Value := "-" + Form1.Readout.Value
    endif
    cLastInput = "NUMS"
    Return Nil

//---------------------------------------------------------------------------//
// Evento 'click' para o boto "%" (PERCENT KEY)
// Calcula e exibe a porcentagem do primeiro valor.
//---------------------------------------------------------------------------//

Static Function Percent_Click()

   Form1.Readout.Value := AllTrim(Str(Val(Form1.Readout.Value)/100))
   cLastInput := "Ops"
   cOpFlag := "%"
   nNumOps := nNumOps + 1
   lDecimalFlag := .t.
   Return Nil

//---------------------------------------------------------------------------//
// Evento 'click' para as teclas "+-x/=" (OPERATOR KEYS)
// Se o ltimo boto pressionado foi parte de um nmero,
// incrementa nNumOps. Se um operando est presente, define nOp1.
// Se dois esto presentes, define nOp1 igual ao resultado da
// operao entre nOp1 e o valor corrente e exibe o resultado.
//---------------------------------------------------------------------------//

Static Function Operator_Click( cIndex )

    cTempReadout := Form1.Readout.Value
    If cLastInput = "NUMS"
        nNumOps := nNumOps + 1
    EndIf
    Do Case
    Case nNumOps = 0
        If cIndex = "-" .And. cLastInput <> "NEG"
            Form1.Readout.Value := "-" + Form1.Readout.Value
            cLastInput := "NEG"
        EndIf
    Case nNumOps = 1
        nOp1 := Val( Form1.Readout.Value )
        If cIndex = "-" .And. cLastInput <> "NUMS" .And. cOpFlag <> "="
            Form1.Readout.Value := "-"
            cLastInput := "NEG"
        EndIf
    Case nNumOps = 2
        nOp2 := Val(cTempReadout)
        Do Case
        Case cOpFlag = "+"
           nOp1 := nOp1 + nOp2
        Case cOpFlag = "-"
           nOp1 := nOp1 - nOp2
        Case cOpFlag = "X"
           nOp1 := nOp1 * nOp2
        Case cOpFlag = "/"
           If nOp2 = 0
              MsgInfo("No pode dividir por 0 (zero).",PROGRAM)
           Else
              nOp1 := nOp1 / nOp2
           EndIf
        Case cOpFlag = "="
           nOp1 := nOp2
        Case cOpFlag = "%"
           nOp1 := nOp1 * nOp2
        Endcase
        Form1.Readout.Value := AllTrim(Str(nOp1))
        nNumOps := 1
    Endcase
    If cLastInput <> "NEG"
        cLastInput := "OPS"
        cOpFlag := cIndex
    EndIf
    Return Nil

//===========================================================================//
