/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2008 Grigory Filatov <gfilatov@freemail.ru>
*/

#include "minigui.ch"

Static aSer1, aSer2, aSer3
Static aSerName1, aSerName2, aSerName3
Static aSerVal1, aSerVal3
Static aClrs, nGraphType

Procedure Main

	aClrs := { RED,;
		{ 0 , 128 , 0 },;
		YELLOW,;
		BLUE,;
		WHITE,;
		GRAY,;
		FUCHSIA,;
		{ 0 , 128 , 128 },;
		{ 0 , 0 , 128 },;
		{ 128 , 0 , 0 },;
		GREEN,;
		{ 128 , 128 , 0 },;
		PURPLE,;
		{ 192 , 192 , 192 },;
		{ 0 , 255 , 255 },;
		BLACK,;
		RED,;
		{ 0 , 128 , 0 },;
		YELLOW,;
		BLUE	}

	DEFINE WINDOW GraphTest ;
		AT 0,0 ;
		WIDTH 640 ;
		HEIGHT 580 ;
		TITLE "Charts ADO Demo by Grigory Filatov" ;
		MAIN ;
		ICON "Chart.ico" ;
		NOMAXIMIZE NOSIZE ;
		FONT "Tahoma" SIZE 9 ;
		ON INIT OpenTable()

		Define Button Button_1
			Row	510
			Col	30
			Caption	'Chart &1'
			Action  drawchart_1( aser1 )
		End Button

		Define Button Button_2
			Row	510
			Col	150
			Caption	'Chart &2'
			Action  drawchart_2( aser2 )
		End Button

		Define Button Button_3
			Row	510
			Col	270
			Caption	'Chart &3'
			Action  drawchart_3( aser3 )
		End Button

		Define Button Button_4
			Row	510
			Col	390
			Caption	'&Print'
			Action  PrintGraph( nGraphType )
		End Button

		Define Button Button_5
			Row	510
			Col	510
			Caption	'E&xit'
			Action  GraphTest.Release
		End Button

	END WINDOW

	GraphTest.Center

	ACTIVATE WINDOW GraphTest

Return

Procedure DrawChart_1 ( aSer )

	nGraphType := 1

	EraseBarGraph('GraphTest')
	ErasePieGraph('GraphTest')
	ERASE WINDOW GraphTest

	DRAW GRAPH							;
		IN WINDOW GraphTest					;
		AT 20,20						;
		TO 500,610						;
		TITLE "Population (top 10 values)"			;
		TYPE BARS						;
		SERIES aSer						;
		YVALUES aSerVal1					;
		DEPTH 12						;
		BARWIDTH 12						;
		HVALUES 10						;
		SERIENAMES aSerName1					;
		COLORS aClrs						;
		3DVIEW    						;
		SHOWXGRID                        			;
		SHOWXVALUES                     			;
		SHOWLEGENDS LEGENDSWIDTH 70 DATAMASK "9,999,999"

	GraphTest.Button_1.SetFocus

Return

Procedure DrawChart_2 ( aSer )

	nGraphType := 2

	EraseBarGraph('GraphTest')
	ERASE WINDOW GraphTest

	DRAW GRAPH							;
		IN WINDOW GraphTest					;
		AT 10,130						;
		TO 500,500						;
		TITLE "Area size (top 10 values)"			;
		TYPE PIE						;
		SERIES aSer						;
		DEPTH 15						;
		SERIENAMES aSerName2					;
		COLORS aClrs						;
		3DVIEW    						;
		SHOWXVALUES                     			;
		SHOWLEGENDS

	GraphTest.Button_2.SetFocus

Return

Procedure DrawChart_3 ( aSer )

	nGraphType := 3

	EraseBarGraph('GraphTest')
	ErasePieGraph('GraphTest')
	ERASE WINDOW GraphTest

	DRAW GRAPH							;
		IN WINDOW GraphTest					;
		AT 20,0							;
		TO 500,590						;
		TITLE "Population density (top 20 values)"		;
		TYPE BARS						;
		SERIES aSer						;
		YVALUES aSerVal3					;
		DEPTH 4							;
		BARWIDTH 8						;
		HVALUES 5						;
		SERIENAMES aSerName3					;
		COLORS aClrs						;
		3DVIEW    						;
		SHOWXGRID                        			;
		SHOWXVALUES                     			;
		SHOWLEGENDS LEGENDSWIDTH 105 DATAMASK "9 999"

	GraphTest.Button_3.SetFocus

Return

Procedure PrintGraph()

   GraphTest.Button_4.SetFocus

   switch nGraphType
      case 1
	PRINT GRAPH							;
		IN WINDOW GraphTest					;
		AT 20,20						;
		TO 500,610						;
		TITLE "Population (top 10 values)"			;
		TYPE BARS						;
		SERIES aSer1						;
		YVALUES aSerVal1					;
		DEPTH 12						;
		BARWIDTH 12						;
		HVALUES 10						;
		SERIENAMES aSerName1					;
		COLORS aClrs						;
		3DVIEW    						;
		SHOWXGRID                        			;
		SHOWXVALUES                     			;
		SHOWLEGENDS LEGENDSWIDTH 70 DATAMASK "9,999,999"	;
		LIBRARY HBPRINT
	exit
      case 2
	PRINT GRAPH							;
		IN WINDOW GraphTest					;
		AT 10,130						;
		TO 500,500						;
		TITLE "Area size (top 10 values)"			;
		TYPE PIE						;
		SERIES aSer2						;
		DEPTH 15						;
		SERIENAMES aSerName2					;
		COLORS aClrs						;
		3DVIEW    						;
		SHOWXVALUES                     			;
		SHOWLEGENDS						;
		LIBRARY HBPRINT
	exit
      case 3
	PRINT GRAPH							;
		IN WINDOW GraphTest					;
		AT 20,0							;
		TO 500,590						;
		TITLE "Population density (top 20 values)"		;
		TYPE BARS						;
		SERIES aSer3						;
		YVALUES aSerVal3					;
		DEPTH 4							;
		BARWIDTH 8						;
		HVALUES 5						;
		SERIENAMES aSerName3					;
		COLORS aClrs						;
		3DVIEW    						;
		SHOWXGRID                        			;
		SHOWXVALUES                     			;
		SHOWLEGENDS LEGENDSWIDTH 105 DATAMASK "9 999"		;
		LIBRARY HBPRINT
   end

return

Procedure OpenTable
Local n
Local Sql
Local cn := CreateObject("ADODB.Connection")
Local rs := CreateObject("ADODB.Recordset")

   cn:Open("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=demo.mdb")

   // Request data for Chart 1
   //
   sql := "SELECT TOP 10 * FROM Country ORDER BY Population DESC"

   rs:Open(sql, cn, 2, 3)  // top 10 values

   // One serie data
   aSer1 := Array(10, 1)
   aSerVal1 := Array(10)
   aSerName1 := Array(10)

   n := 0
   rs:MoveFirst()
   Do While !rs:EoF()
	n++
	aSer1[n, 1] := Rs:Fields["Population"]:Value() / 1000
	aSerVal1[n] := Rs:Fields["Name"]:Value()
	aSerName1[n]:= aSerVal1[n]
	rs:MoveNext()
   EndDo
   rs:Close()

   // Request data for Chart 2
   //
   sql := "SELECT TOP 10 * FROM Country ORDER BY Area DESC"

   rs:Open(sql, cn, 2, 3)  // top 10 values

   // One serie data
   aSer2 := Array(10)
   aSerName2 := Array(10)

   n := 0
   rs:MoveFirst()
   Do While !rs:EoF()
	n++
	aSer2[n] := Rs:Fields["Area"]:Value() / 1000
	aSerName2[n]:= Rs:Fields["Name"]:Value()
	rs:MoveNext()
   EndDo
   rs:Close()

   // Request data for Chart 3
   //
   sql := "SELECT TOP 20 Name, Population/Area as off FROM Country ORDER BY Population/Area DESC"

   rs:Open(sql, cn, 2, 3)  // top 20 values

   // One serie data
   aSer3 := Array(20, 1)
   aSerVal3 := Array(20)
   aSerName3 := Array(20)

   n := 0
   rs:MoveFirst()
   Do While !rs:EoF()
	n++
	aSer3[n, 1] := Rs:Fields["Off"]:Value()
	aSerVal3[n] := Rs:Fields["Name"]:Value()
	aSerName3[n]:= Transform( aSer3[n, 1], "9 999.999" ) + ' ' + aSerVal3[n]
  	rs:MoveNext()
   EndDo
   rs:Close()

   cn:Close()

   // First chart drawing
   DrawChart_1( aser1 )

Return

Procedure ErasePieGraph ( windowname )
Local i

   if _iscontroldefined("title_of_pie",windowname)
      _releasecontrol("title_of_pie",windowname)
   endif
   for i := 1 to 10
      if _iscontroldefined("pielegend_"+alltrim(str(i,3,0)),windowname)
         _releasecontrol("pielegend_"+alltrim(str(i,3,0)),windowname)
      endif
   next i

Return

Procedure EraseBarGraph ( Parent )
Local i, cName

	If _IsControlDefined ( 'Graph_Title', Parent )
		_ReleaseControl ( 'Graph_Title', Parent )
	EndIf

	For i := 1 To 20
		cName := "Ser_Name_"+ltrim(str(i))
		If _IsControlDefined ( cName, Parent )
			_ReleaseControl ( cName , Parent )
		EndIf
	Next

	For i := 0 To 20
		cName := "xPVal_Name_"+ltrim(str(i))
		If _IsControlDefined ( cName, Parent )
			_ReleaseControl ( cName , Parent )
		EndIf
	Next

	For i := 0 To 20
		cName := "xNVal_Name_"+ltrim(str(i))
		If _IsControlDefined ( cName, Parent )
			_ReleaseControl ( cName , Parent )
		EndIf
	Next

	For i := 1 To 20
		cName := "yVal_Name_"+ltrim(str(i))
		If _IsControlDefined ( cName, Parent )
			_ReleaseControl ( cName , Parent )
		EndIf
	Next

Return
