/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002-05 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
*/

#include "minigui.ch"

Static Rot :=-10, lRot := .f.

Function Main

	DEFINE FONT font_0 FONTNAME 'Times New Roman' SIZE 10 DEFAULT
	DEFINE FONT font_1 FONTNAME 'Arial' SIZE 24 ITALIC
	DEFINE FONT font_2 FONTNAME 'Verdana' SIZE 10 BOLD ANGLE Rot 
	DEFINE FONT font_3 FONTNAME 'Courier New' SIZE 12 BOLD

	DEFINE WINDOW Form_Main ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 480 ;
		TITLE 'New definitions of Fonts - by Janusz Pora' ;
		MAIN ;
		ON PAINT IF(lRot,RotationText(GetControlHandle('Label_1', 'Form_Main')),)

		@ 200,250 LABEL Label_1 ;
		WIDTH 150 HEIGHT 150 ;
		VALUE 'Click Me !' ;
		ACTION fRotFont() ;
		FONT "font_1"  ;
	        BACKCOLOR BLUE CENTERALIGN

		@ 10,10 LABEL Label_2 ;
		WIDTH 350 HEIGHT 150 ;
		VALUE "" ;
		ACTION MsgInfo('Click!');
        	BACKCOLOR YELLOW;
		FONT "font_2" CENTERALIGN

		@ 10,400 LABEL Label_3 ;
		WIDTH 150 HEIGHT 24 ;
		VALUE 'Default font' ;

		@ 40,400 LABEL Label_4 ;
		WIDTH 150 HEIGHT 44 ;
		VALUE 'Font 1' ;
        	FONT "font_1"

		@ 90,400 LABEL Label_5 ;
		WIDTH 150 HEIGHT 24 ;
		VALUE 'Font 3' ;
	        FONT "font_3"

		@ 400,450 BUTTON Btn_1 ;
		CAPTION 'Exit' ;
        	ON CLICK thiswindow.release ;
	        FONT "font_3"

	END WINDOW

	Form_Main.Label_2.Value := space(350) + 'This Is An Rotate Label!!!'

//    _SetFontRotate ( 'Label_1', 'Form_Main' , 45 )

	CENTER WINDOW Form_Main

	ACTIVATE WINDOW Form_Main

Return Nil

#define WM_PAINT	15

Function fRotFont()

    Form_Main.Label_1.Value := 'Click Me !'

    lRot := IF( lRot, .f., .t. )
    if lRot
	SendMessage( _HMG_MainHandle, WM_PAINT, 0, 0 )
    endif

    Rot -= 10
    _SetFontRotate ( 'Label_2', 'Form_Main', rot )

Return Nil

*-----------------------------------------------------------------------------*
Function _SetFontRotate ( ControlName, ParentForm , Value )
*-----------------------------------------------------------------------------*
Local i , h , s, ab , ai , au , as , aa , x ,n

	i := GetControlIndex ( ControlName, ParentForm )
	DeleteObject ( _HMG_aControlFontHandle [i] )
	h := _HMG_aControlhandles [i]
	n := _HMG_aControlFontName [i]
	s := _HMG_aControlFontSize [i]
	ab := _HMG_aControlFontAttributes [i] [1]
	ai := _HMG_aControlFontAttributes [i] [2]
	au := _HMG_aControlFontAttributes [i] [3]
	as := _HMG_aControlFontAttributes [i] [4]
	
	do case
	case _HMG_aControlType [i] == "SPINNER"
		_HMG_aControlFontHandle [i] := SetFontNameSize ( h [1] , n , s , ab , ai , au , as , Value*10 )

	case _HMG_aControlType [i] == "RADIOGROUP"

		For x := 1 To Len (h)
			_HMG_aControlFontHandle [i] := SetFontNameSize ( h [x] , n , s , ab , ai , au , as, value*10 )
		Next x

	otherwise
	   _HMG_aControlFontHandle [i] := SetFontNameSize ( h , n , s , ab , ai , au , as , value*10 )
	Endcase

Return Nil


#pragma BEGINDUMP

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC ( ROTATIONTEXT )
{

	RECT rc;
	int angle;
	HFONT hfnt, hfntPrev;
	LPSTR lpszRotate = "The string to be rotated";
	HRESULT hr;
	size_t  pcch;
	HWND hwnd;
	HDC  hdc;

	// Allocate memory for a LOGFONT structure. 
	PLOGFONT plf = (PLOGFONT) LocalAlloc(LPTR, sizeof(LOGFONT)); 
 
	hdc = GetDC ( (HWND) hb_parnl(1) ) ;
 
	// Specify a font typeface name and weight. 
	strncpy(plf->lfFaceName, "Arial",6);
	plf->lfWeight = FW_NORMAL; 
 
	// Retrieve the client-rectangle dimensions. 
	GetClientRect((HWND) hb_parnl(1), &rc); 
 
	// Set the background mode to transparent for the 
	// text-output operation. 
	SetBkMode(hdc, TRANSPARENT); 
 
	// Draw the string 36 times, rotating 10 degrees 
	// counter-clockwise each time. 

	for (angle = 0; angle < 3600; angle += 100) 
	{
		plf->lfEscapement = angle; 
		hfnt = CreateFontIndirect(plf); 
		hfntPrev = SelectObject(hdc, hfnt);
	
	//
	// The StringCchLength call is fitted to the lpszRotate string
	//
		pcch = strlen(lpszRotate);

		TextOut(hdc, rc.right / 2, rc.bottom / 2, 
			lpszRotate, pcch); 
		SelectObject(hdc, hfntPrev); 
		DeleteObject(hfnt); 
	}
 
	// Reset the background mode to its default. 
 	SetBkMode(hdc, OPAQUE); 
 
	// Free the memory allocated for the LOGFONT structure. 
	LocalFree((LOCALHANDLE) plf); 

}

#pragma ENDDUMP