/*
* MiniGUI ON KEY Demo
*/

/*

Available Keys 

	F1
	F2
	F3
	F4
	F5
	F6
	F7
	F8
	F9
	F10
	F11 
	F12 
	BACK 
	TAB 
	RETURN 
	ESCAPE 
	END 
	HOME 
	LEFT 
	UP 
	RIGHT 
	DOWN 
	INSERT 
	DELETE 
	PRIOR 
	NEXT 
	ALT+A 
	ALT+B 
	ALT+C 
	ALT+D 
	ALT+E 
	ALT+F 
	ALT+G 
	ALT+H 
	ALT+I 
	ALT+J 
	ALT+K 
	ALT+L 
	ALT+M 
	ALT+N 
	ALT+O 
	ALT+P 
	ALT+Q 
	ALT+R 
	ALT+S 
	ALT+T 
	ALT+U 
	ALT+V 
	ALT+W 
	ALT+X 
	ALT+Y 
	ALT+Z 
	ALT+0 
	ALT+1 
	ALT+2 
	ALT+3 
	ALT+4 
	ALT+5 
	ALT+6 
	ALT+7 
	ALT+8 
	ALT+9 
	ALT+F1
	ALT+F2 
	ALT+F3 
	ALT+F4 
	ALT+F5 
	ALT+F6 
	ALT+F7 
	ALT+F8 
	ALT+F9 
	ALT+F10
	ALT+F11
	ALT+F12 
	ALT+BACK
	ALT+TAB 
	ALT+RETURN 
	ALT+ESCAPE 
	ALT+END 
	ALT+HOME 
	ALT+LEFT 
	ALT+UP 
	ALT+RIGHT 
	ALT+DOWN 
	ALT+INSERT 
	ALT+DELETE 
	ALT+PRIOR 
	ALT+NEXT 
	SHIFT+A 
	SHIFT+B 
	SHIFT+C 
	SHIFT+D 
	SHIFT+E 
	SHIFT+F 
	SHIFT+G 
	SHIFT+H 
	SHIFT+I 
	SHIFT+J 
	SHIFT+K 
	SHIFT+L 
	SHIFT+M 
	SHIFT+N 
	SHIFT+O 
	SHIFT+P 
	SHIFT+Q 
	SHIFT+R 
	SHIFT+S 
	SHIFT+T 
	SHIFT+U 
	SHIFT+V 
	SHIFT+W 
	SHIFT+X 
	SHIFT+Y 
	SHIFT+Z 
	SHIFT+0 
	SHIFT+1 
	SHIFT+2 
	SHIFT+3 
	SHIFT+4 
	SHIFT+5 
	SHIFT+6 
	SHIFT+7 
	SHIFT+8 
	SHIFT+9 
	SHIFT+F1 
	SHIFT+F2 
	SHIFT+F3 
	SHIFT+F4 
	SHIFT+F5 
	SHIFT+F6 
	SHIFT+F7 
	SHIFT+F8 
	SHIFT+F9 
	SHIFT+F10
	SHIFT+F11 
	SHIFT+F12 
	SHIFT+BACK 
	SHIFT+TAB 
	SHIFT+RETURN 
	SHIFT+ESCAPE 
	SHIFT+END 
	SHIFT+HOME 
	SHIFT+LEFT 
	SHIFT+UP 
	SHIFT+RIGHT 
	SHIFT+DOWN 
	SHIFT+INSERT 
	SHIFT+DELETE 
	SHIFT+PRIOR 
	SHIFT+NEXT 
	CONTROL+A 
	CONTROL+B 
	CONTROL+C 
	CONTROL+D 
	CONTROL+E 
	CONTROL+F 
	CONTROL+G 
	CONTROL+H 
	CONTROL+I 
	CONTROL+J 
	CONTROL+K 
	CONTROL+L 
	CONTROL+M 
	CONTROL+N 
	CONTROL+O 
	CONTROL+P 
	CONTROL+Q 
	CONTROL+R 
	CONTROL+S 
	CONTROL+T 
	CONTROL+U 
	CONTROL+V 
	CONTROL+W 
	CONTROL+X 
	CONTROL+Y 
	CONTROL+Z 
	CONTROL+0 
	CONTROL+1 
	CONTROL+2 
	CONTROL+3 
	CONTROL+4 
	CONTROL+5 
	CONTROL+6 
	CONTROL+7 
	CONTROL+8 
	CONTROL+9 
	CONTROL+F1 
	CONTROL+F2 
	CONTROL+F3 
	CONTROL+F4 
	CONTROL+F5 
	CONTROL+F6 
	CONTROL+F7 
	CONTROL+F8 
	CONTROL+F9 
	CONTROL+F10 
	CONTROL+F11 
	CONTROL+F12 
	CONTROL+BACK
	CONTROL+TAB 
	CONTROL+RETURN 
	CONTROL+ESCAPE 
	CONTROL+END 
	CONTROL+HOME 
	CONTROL+LEFT 
	CONTROL+UP 
	CONTROL+RIGHT 
	CONTROL+DOWN 
	CONTROL+INSERT 
	CONTROL+DELETE
	CONTROL+PRIOR 
	CONTROL+NEXT 

*/

#include "minigui.ch"

#define MsgInfo( c ) MsgInfo( c, , , .f. )

Procedure Main
  
Local abActiveBlocks := {}

	DEFINE WINDOW Win_1 ;
		AT 0,0 ;
		WIDTH 400 ;
		HEIGHT 400 ;
		TITLE 'Hello World!' ;
		MAIN  

		ON KEY SHIFT+A ACTION MsgInfo ('Shift+A')
		ON KEY TAB ACTION MsgInfo ('TAB')
		ON KEY RETURN ACTION MsgInfo ('RETURN')
		ON KEY CONTROL+END ACTION MsgInfo ('CONTROL+END')
		ON KEY ESCAPE ACTION MsgInfo ('ESCAPE')
		ON KEY ALT+C ACTION MsgInfo ('ALT+C')

		DEFINE BUTTON Button_1
			ROW 10
			COL 10
			CAPTION 'Activate F11'
			ACTION EnableF11()
		END BUTTON

		DEFINE BUTTON Button_2
			ROW 40
			COL 10
			CAPTION 'Release F11'
			ACTION DisableF11()
		END BUTTON

		DEFINE BUTTON Button_3
			ROW 70
			COL 10
			CAPTION 'Store Key Test'
			ACTION StoreTest()
		END BUTTON

		DEFINE BUTTON Button_4
			ROW 10
			COL 150
			WIDTH 120
			CAPTION 'Save All Fkeys'
			ACTION abActiveBlocks := SAVEONKEY('Win_1')
		END BUTTON

		DEFINE BUTTON Button_5
			ROW 40
			COL 150
			WIDTH 120
			CAPTION 'Clear All Fkeys'
			ACTION CLEARONKEY('Win_1')
		END BUTTON

		DEFINE BUTTON Button_6
			ROW 70
			COL 150
			WIDTH 120
			CAPTION 'Restore All Fkeys'
			ACTION RESTONKEY('Win_1', abActiveBlocks)
		END BUTTON

	END WINDOW

	CENTER WINDOW Win_1

	ACTIVATE WINDOW Win_1

Return

Procedure EnableF11()
	ON KEY F11 OF Win_1 ACTION MsgInfo ('F11 is pressed')
Return

Procedure DisableF11()
	RELEASE KEY F11 OF Win_1
Return

Procedure StoreTest()
Local bBlock

	STORE KEY RETURN OF Win_1 TO bBlock

	RELEASE KEY RETURN OF Win_1

	ON KEY RETURN OF Win_1 ACTION Eval ( bBlock )

Return

/*
  Function SaveOnKey() - MiniGUI DEMO
  (C)2006 Mel Smith <syntel@shaw.ca>
*/
FUNCTION SAVEONKEY(cForm)
LOCAL I,bKeyBlock, abSaveKeys := {}
LOCAL nKey

FOR I = 1 TO 12
   
   nKey := I - 1 + VK_F1      // Gets the Starting Key -- F1
   
   bKeyBlock := _GetHotKey(cForm,0,nKey)
   AADD(abSaveKeys,bKeyBlock)       // Store 'Regular' Function Keys

   bKeyBlock := _GetHotKey(cForm,MOD_SHIFT,nKey)
   AADD(abSaveKeys,bKeyBlock)       // Store 'Shift' Function Keys

   bKeyBlock := _GetHotKey(cForm,MOD_ALT,nKey)
   AADD(abSaveKeys,bKeyBlock)       // Store 'Alt' Function Keys

   bKeyBlock := _GetHotKey(cForm,MOD_CONTROL,nKey)
   AADD(abSaveKeys,bKeyBlock)       // Store 'Control' Function Keys

NEXT 
// Lastly Store the <Esc> Key
bKeyBlock := _GETHOTKEY(cForm,0,VK_ESCAPE)
AADD(abSaveKeys,bKeyBlock)       // Store the <Esc> Key

RETURN abSaveKeys

/*
  Function ClearOnKey() - MiniGUI DEMO
  (C)2006 Mel Smith <syntel@shaw.ca>
*/
FUNCTION CLEARONKEY(cForm)
LOCAL I,nKey
 
FOR I = 1 to 12
   
   nKey := I - 1 + VK_F1      // Gets the Starting Key -- F1
   
   _ReleaseHotKey(cForm,0,nKey)           // Clear 'Regular' Function Keys
   _ReleaseHotKey(cForm,MOD_SHIFT,nKey)   // Clear 'Shift'   Function Keys
   _ReleaseHotKey(cForm,MOD_ALT,nKey)     // Clear 'Alt'     Function Keys
   _ReleaseHotKey(cForm,MOD_CONTROL,nKey) // Clear 'Control' Function Keys
NEXT 

// Lastly Clear the <Esc> Key
_ReleaseHotKey(cForm,0,VK_ESCAPE)

RETURN NIL

/*
  Function RestOnKey() - MiniGUI DEMO
  (C)2006 Mel Smith <syntel@shaw.ca>
*/
FUNCTION RESTONKEY(cForm,abSaveKeys)
LOCAL I,J,nKey, nEscIndex := LEN(abSaveKeys)

IF nEscIndex <> 49      // (i.e., 4 * 12 + 1) Then *big trouble* 
   MsgInfo("Fault in Restoring Hot-Keys." + CRLF + "Run for Cover !")
   RETURN .F.
ENDIF

J := 0

FOR I = 1 to 48 STEP 4                          // 4 * 12 Function Keys
    nKey := VK_F1 + J
    J++ 
   _DEFINEHOTKEY(cForm, 0 ,nKey,abSaveKeys[I])             //Restore 'Regular'
   _DEFINEHOTKEY(cForm, MOD_SHIFT ,nKey,abSaveKeys[I+1])   //Restore 'Shift'
   _DEFINEHOTKEY(cForm, MOD_ALT ,nKey,abSaveKeys[I+2])     //Restore 'Alt'
   _DEFINEHOTKEY(cForm, MOD_CONTROL ,nKey,abSaveKeys[I+3])  //Restore 'Control'
NEXT
// Now Restore the <Esc> Key for the Window
nKey := VK_ESCAPE
_DEFINEHOTKEY(cForm, 0 , VK_ESCAPE,abSaveKeys[nEscIndex])

RETURN .T.