/*
 * MINIGUI - Harbour Win32 GUI library Demo
 *
 * Copyright 2002 Roberto Lopez <harbourminigui@gmail.com>
 * http://harbourminigui.googlepages.com/
*/

#include "minigui.ch"

Function Main

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 600 HEIGHT 400 ;
		TITLE 'MiniGUI StatusBar Demo (Based Upon a Contribution Of Janusz Pora)' ;
		MAIN ;
		FONT 'Arial' SIZE 10 

		DEFINE MAIN MENU 
			POPUP '&StatusBar Test'
				ITEM 'Set StatusBar Item 1'	ACTION Form_1.StatusBar.Item(1) := "New value 1"
				ITEM 'Set StatusBar Item 2'	ACTION Form_1.StatusBar.Item(2) := "New value 2"
				ITEM 'Set StatusBar Item Icon' ;
					ACTION ( Form_1.StatusBar.Icon (3) := 'New.iCO', Form_1.StatusBar.Item(3) := "A Smile!" )
				ITEM 'Open Other Window...'	ACTION Modal_Click()
                        END POPUP
			POPUP '&Help'
				ITEM '&About'		ACTION MsgInfo ("MiniGUI StatusBar Demo") 
			END POPUP
		END MENU

		DEFINE STATUSBAR FONT 'MS Sans Serif' SIZE 8
			STATUSITEM "Item 1" 	ACTION MsgInfo('Click! 1')
			STATUSITEM "Item 2" 	WIDTH 100 ACTION MsgInfo('Click! 2') 
			STATUSITEM 'A Car!'	WIDTH 100 ICON 'Car.Ico'
			CLOCK 
			DATE 
		END STATUSBAR

	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return Nil

*-----------------------------------------------------------------------------*
Procedure Modal_CLick
*-----------------------------------------------------------------------------*

	DEFINE WINDOW Form_2 ;
		AT 0,0 ;
		WIDTH 400 HEIGHT 300 ;
		TITLE 'StatusBar Test'  ;
		MODAL NOSIZE

		DEFINE STATUSBAR 

			STATUSITEM "Modal 1" 	WIDTH 100 ACTION MsgInfo('Click! 1') 
			STATUSITEM "Modal 2" 	WIDTH 100 ACTION MsgInfo('Click! 2')

		END STATUSBAR

	END WINDOW

	Form_2.Center

	Form_2.Activate

Return

*-----------------------------------------------------------------------------*
Function _CenterWindow ( FormName )
*-----------------------------------------------------------------------------*
Local FormHandle := GetFormHandle ( FormName )
Local nPos, nColMain, nRowMain, nWidthMain, nHeightMain, lCentered := .F.

If FormHandle # _HMG_MainHandle

   If ( ( nPos := aScan ( _HMG_aFormHandles, _HMG_MainHandle ) ) > 0 )

      nColMain	  := GetProperty ( _HMG_aFormNames[ nPos ] , 'Col' )
      nRowMain	  := GetProperty ( _HMG_aFormNames[ nPos ] , 'Row' )
      nWidthMain  := GetProperty ( _HMG_aFormNames[ nPos ] , 'Width' )
      nHeightMain := GetProperty ( _HMG_aFormNames[ nPos ] , 'Height' )

      SetProperty ( FormName, 'Col', nColMain + Int ( ( nWidthMain  - GetProperty ( FormName , 'Width' )  ) / 2 ) )
      SetProperty ( FormName, 'Row', nRowMain + Int ( ( nHeightMain - GetProperty ( FormName , 'Height' ) ) / 2 ) )
      
      If GetProperty ( FormName, 'Col' ) >= 0 .and. GetProperty ( FormName, 'Row' ) >= 0
	      lCentered := .T.
      Endif

   Endif
    
Endif

If !lCentered
   C_Center( FormHandle )
Endif
	
Return Nil