/*
  Get file from Internet via HTTP - MiniGUI DEMO
  (C)2005 Jacek Kubica <kubica@wssk.wroc.pl>
*/

#include "minigui.ch"
#include "fileio.ch"

*
Function MAIN()
*
   
DEFINE WINDOW Form_1 AT 0, 0 ;
   WIDTH 400 HEIGHT 210  MAIN ;
   TITLE "Get file via HTTP";
   BACKCOLOR { 212, 208, 200 } ;
   NOSIZE NOMAXIMIZE TOPMOST

@ 19+25,110 TEXTBOX ServerURL VALUE "www.wssk.wroc.pl" ;
            WIDTH 175 HEIGHT 20  FONT "MS Sans serif" SIZE 9
@ 44+25,110 TEXTBOX FileURL VALUE "/images/szpital_pr9.jpg" ;
            WIDTH 175 HEIGHT 20  FONT "MS Sans serif" SIZE 9
@ 69+25,110 TEXTBOX LocalName  VALUE "MyPicture.jpg" ;
           WIDTH 120 HEIGHT 20  FONT "MS Sans serif" SIZE 9
@ 22+25,17 LABEL Label_3 VALUE  "ServerURL" HEIGHT 17 ;
           AUTOSIZE FONT "MS Sans serif" SIZE 9 BOLD TRANSPARENT
@ 47+25,17 LABEL Label_2 VALUE  "FileURL" HEIGHT 17 ;
           AUTOSIZE FONT "MS Sans serif" SIZE 9 BOLD TRANSPARENT
@ 72+25,17 LABEL Label_4 VALUE  "LocalFile" HEIGHT 16 ;
           AUTOSIZE FONT "MS Sans serif" SIZE 9 BOLD TRANSPARENT

@ 80-10+25,245   BUTTON Button_1  CAPTION "Get It"  WIDTH 40 HEIGHT 40 FLAT ;
ACTION GetFileFromInet( Form_1.ServerURL.Value, Form_1.FileURL.Value, Form_1.LocalName.Value )

DEFINE STATUSBAR FONT "Arial" SIZE 8
	STATUSITEM "Author: J.Kubica <kubica@wssk.wroc.pl>" WIDTH 80
	DATE  WIDTH 80
	CLOCK WIDTH 80
END STATUSBAR

END WINDOW

Form_1.Center
Form_1.Activate

Return NIL

*
FUNCTION GetFileFromInet( cServer, cFile, cOutName )
*
local oSock, nHandle,cPic
local nPort    := 80  

// make new socket   
oSock := THttp():New()
Form_1.StatusBar.Item(1) := "Connect to " +cServer +":" +alltrim(str( nPort ))

// connect to server
if oSock:Connect( cServer, nPort )
   Form_1.StatusBar.Item(1) := "Connected"
   Form_1.StatusBar.Item(1) := "Retriving data ... wait pls .."

   // retrive data from server
   cPic := oSock:Get( cFile ) 

   // extract header data
   cPic:=SUBSTR(cPic,AT(CRLF+CRLF,cPic)+4)

   // save extracted data do local file
   IF FILE(cOutName)
      FERASE(cOutName)
   endif

   nHandle := FCREATE(cOutName, FC_NORMAL)
   IF nHandle  < 0
      MsgStop("Local file cannot be created:"+ Str(FERROR()))
      RETURN ""
   ELSE
      FWRITE(nHandle, cPic)
      FCLOSE(nHandle)
   ENDIF 

   Form_1.StatusBar.Item(1) := "Close connection"
   if oSock:Close()
	Form_1.StatusBar.Item(1) := "Close successfull"
   else
	Form_1.StatusBar.Item(1) := "Error on close connection"
   endif
else
   Form_1.StatusBar.Item(1) := "Connection Refused"
endif

RETURN NIL
