/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

 Parts of this module are based upon:

	"HBPRINT" 
	Copyright 2002 Richard Rylko <rrylko@poczta.onet.pl>
	http://rrylko.republika.pl

	"HBPRINTER"
	Copyright 2002 Richard Rylko <rrylko@poczta.onet.pl>
	http://rrylko.republika.pl

---------------------------------------------------------------------------*/

///////////////////////////////////////////////////////////////////////////////
// HARBOUR LEVEL PRINT ROUTINES
///////////////////////////////////////////////////////////////////////////////

#include "minigui.ch"
#include "miniprint.ch"
#include "hp_images.ch"

#define WM_CLOSE	0x0010
#define SB_HORZ		0
#define SB_VERT		1

#define WM_VSCROLL	0x0115

DECLARE WINDOW _HMG_PRINTER_PPNAV

memvar _hmg_printer_timestamp
memvar _hmg_printer_hdc_bak
memvar _hmg_printer_pagecount
memvar _hmg_printer_copies
memvar _hmg_printer_collate
memvar _hmg_printer_hdc
memvar _hmg_printer_JobName
memvar _HMG_PRINTER_DELTA_ZOOM
memvar _hmg_printer_BasePageName
memvar _hmg_printer_CurrentPageNumber
memvar _hmg_printer_SizeFactor
memvar _hmg_printer_Dx
memvar _hmg_printer_Dy
memvar _hmg_printer_Dz
memvar _hmg_printer_scrollstep
memvar _hmg_printer_zoomclick_xoffset
memvar _hmg_printer_thumbupdate
memvar _hmg_printer_thumbscroll 
memvar _hmg_printer_PrevPageNumber
memvar _hmg_printer_usermessages

memvar a
Static IsVistaThemed
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_SHOWPREVIEW
*------------------------------------------------------------------------------*
Local ModalHandle := 0
Local Tmp
Local i
Local tWidth
Local tHeight
Local tFactor
Local tvHeight
Local icb := 0
Local ppnavtitle 

IsVistaThemed := ( ISVISTA() .And. IsAppXPThemed() )

Public _hmg_printer_BasePageName := GetTempFolder() + "\" + _hmg_printer_timestamp + "_hmg_print_preview_"
Public _hmg_printer_CurrentPageNumber := 1
Public _hmg_printer_SizeFactor
Public _hmg_printer_Dx := 0
Public _hmg_printer_Dy := 0
Public _hmg_printer_Dz := 0
Public _hmg_printer_scrollstep := 10
Public _hmg_printer_zoomclick_xoffset := 0
Public _hmg_printer_thumbupdate := .T.
Public _hmg_printer_thumbscroll 
Public _hmg_printer_PrevPageNumber := 0
Public _hmg_PRINTER_DELTA_ZOOM

	if _HMG_IsModalActive == .T.

		ModalHandle := _hmg_activemodalhandle

		_HMG_IsModalActive := .F.
		_hmg_activemodalhandle := 0

		DisableWindow ( ModalHandle )

	Else

		ModalHandle := 0

	EndIf

	if _hmg_printer_hdc_bak == 0
		Return
	EndIf

	if _IsWindowDefined ( "_HMG_PRINTER_SHOWPREVIEW" )
		Return
	endif

	icb := _HMG_InteractiveClose

	set interactiveclose on

	_hmg_printer_SizeFactor := GetDesktopHeight() / _HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) * 0.63

	IF _HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak ) > 370
		_HMG_PRINTER_DELTA_ZOOM := - 250
	ELSE
		_HMG_PRINTER_DELTA_ZOOM := 0
	ENDIF

	define window _HMG_PRINTER_Wait at 0,0 width 310 height 85 title '' child noshow nocaption 
		define label label_1
			row 30
			col 5
			width 300
			height 30
			value _hmg_printer_usermessages [29] 
			centeralign .t.
		end label
	end window

	_HMG_PRINTER_Wait.Center

	ppnavtitle := _hmg_printer_usermessages [01] + ' [' + alltrim(str(_hmg_printer_CurrentPageNumber)) + '/'+alltrim(str(_hmg_printer_PageCount)) + ']'

	DEFINE WINDOW _HMG_PRINTER_SHOWPREVIEW ;
			AT 0,0 ;
			WIDTH GetDesktopWidth() - 103 - IF ( IsVistaThemed == .T. , 25 , 0);
			HEIGHT GetDesktopHeight() - 103  - IF ( IsVistaThemed == .T. , 25 , 0);
			VIRTUAL WIDTH ( GetDesktopWidth() - 103 ) * 2 ;
			VIRTUAL HEIGHT ( GetDesktopHeight() - 103 ) * 2 ;
			TITLE ppnavtitle ;
			CHILD ;
			NOSIZE ;
			NOMINIMIZE ;
			NOMAXIMIZE ;
			NOSYSMENU ;
			CURSOR IMG_CURSOR ;
			ON PAINT _HMG_PRINTER_PREVIEWRefresh() ;
			BACKCOLOR GRAY ;
			ON MOUSECLICK	( _HMG_PRINTER_PPNAV.b5.value := ! _HMG_PRINTER_PPNAV.b5.value , _HMG_PRINTER_MouseZoom() ) ;
			ON SCROLLUP	_HMG_PRINTER_ScrolluP() ;
			ON SCROLLDOWN	_HMG_PRINTER_ScrollDown() ;
			ON SCROLLLEFT	_HMG_PRINTER_ScrollLeft() ;
			ON SCROLLRIGHT	_HMG_PRINTER_ScrollRight() ;
			ON HSCROLLBOX	_HMG_PRINTER_hScrollBoxProcess() ;
			ON VSCROLLBOX	_HMG_PRINTER_vScrollBoxProcess() 

			ON KEY HOME		ACTION ( _hmg_printer_CurrentPageNumber:=1 , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY PRIOR		ACTION ( _hmg_printer_CurrentPageNumber-- , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY NEXT		ACTION ( _hmg_printer_CurrentPageNumber++ , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY END		ACTION ( _hmg_printer_CurrentPageNumber:= _hmg_printer_PageCount, _HMG_PRINTER_PREVIEWRefresh() )
			ON KEY CONTROL+P	ACTION _HMG_PRINTER_PrintPages()
			ON KEY CONTROL+G	ACTION _HMG_PRINTER_GO_TO_PAGE()
			ON KEY ESCAPE		ACTION _HMG_PRINTER_PreviewClose()
			ON KEY MULTIPLY 	ACTION ( _HMG_PRINTER_PPNAV.b5.value := ! _HMG_PRINTER_PPNAV.b5.value , _HMG_PRINTER_MouseZoom() )
			ON KEY CONTROL+C	ACTION _HMG_PRINTER_PreviewClose()
			ON KEY ALT+F4		ACTION _HMG_PRINTER_PreviewClose()
			ON KEY CONTROL+S	ACTION _hmg_printer_savepages()
			ON KEY CONTROL+T	ACTION _hmg_printer_ThumbnailToggle()

	END WINDOW

	Define Window _HMG_PRINTER_PRINTPAGES		;
		At 0,0					;
		Width 420				;
		Height 168 + GetTitleHeight()		;
		Title _hmg_printer_usermessages [9]	;
		CHILD NOSHOW 				;
		NOSIZE NOSYSMENU

		ON KEY ESCAPE	ACTION ( HideWindow ( GetFormHandle ( "_HMG_PRINTER_PRINTPAGES" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus )
		ON KEY RETURN	ACTION _HMG_PRINTER_PrintPagesDo()

		Define Frame Frame_1
			Row 5
			Col 10
			Width 275
			Height 147
			FontName 'Arial'
			FontSize 9
			Caption _hmg_printer_usermessages [15]
		End Frame

		Define RadioGroup Radio_1
			Row 25
			Col 20
			FontName 'Arial'
			FontSize 9
			Value 1
			Options { _hmg_printer_usermessages [16] , _hmg_printer_usermessages [17] }
			OnChange if ( This.value == 1 , ( _HMG_PRINTER_PRINTPAGES.Label_1.Enabled := .F. , _HMG_PRINTER_PRINTPAGES.Label_2.Enabled := .F. , _HMG_PRINTER_PRINTPAGES.Spinner_1.Enabled := .F. , _HMG_PRINTER_PRINTPAGES.Spinner_2.Enabled := .F. , _HMG_PRINTER_PRINTPAGES.Combo_1.Enabled := .F.  , _HMG_PRINTER_PRINTPAGES.Label_4.Enabled := .F. ) , ( _HMG_PRINTER_PRINTPAGES.Label_1.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Label_2.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Spinner_1.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Spinner_2.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Combo_1.Enabled := .T.  , _HMG_PRINTER_PRINTPAGES.Label_4.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Spinner_1.SetFocus ) ) 
		End RadioGroup

		Define Label Label_1
			Row 84
			Col 55
			Width 50
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _hmg_printer_usermessages [18] + ':'
		End Label

		Define Spinner Spinner_1
			Row 81
			Col 110
			Width 50
			FontName 'Arial'
			FontSize 9
			Value 1
			RangeMin 1
			RangeMax _hmg_printer_PageCount
		End Spinner

		Define Label Label_2
			Row 84
			Col 165
			Width 35
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _hmg_printer_usermessages [19] + ':'
		End Label

		Define Spinner Spinner_2
			Row 81
			Col 205
			Width 50
			FontName 'Arial'
			FontSize 9
			Value _hmg_printer_PageCount
			RangeMin 1
			RangeMax _hmg_printer_PageCount
		End Spinner

		Define Label Label_4
			Row 115
			Col 55
			Width 50
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _hmg_printer_usermessages [09] + ':'
		End Label

		Define ComboBox Combo_1
			Row 113
			Col 110
			Width 145
			FontName 'Arial'
			FontSize 9
			Value 1
			Items {_hmg_printer_usermessages [21] , _hmg_printer_usermessages [22] , _hmg_printer_usermessages [23] }
		End ComboBox

		Define Button Ok
			Row 10
			Col 300
			Width 105
			Height 25
			FontName 'Arial'
			FontSize 9
			Caption _hmg_printer_usermessages [11]
			Action _HMG_PRINTER_PrintPagesDo()
		End Button

		Define Button Cancel
			Row 40
			Col 300
			Width 105
			Height 25
			FontName 'Arial'
			FontSize 9
			Caption _hmg_printer_usermessages [12]
			Action ( EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , HideWindow ( GetFormHandle ( "_HMG_PRINTER_PRINTPAGES" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus )
		End Button

		Define Label Label_3
			Row 103
			Col 300
			Width 45
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _hmg_printer_usermessages [20] + ':'
		End Label

		Define Spinner Spinner_3
			Row 100
			Col 355
			Width 50
			FontName 'Arial'
			FontSize 9
			Value _hmg_printer_copies
			RangeMin 1
			RangeMax 999
			OnChange ( if ( IsControlDefined (CheckBox_1,_HMG_PRINTER_PRINTPAGES) , If ( This.Value > 1 , SetProperty( '_HMG_PRINTER_PRINTPAGES' , 'CheckBox_1','Enabled',.T.) , SetProperty( '_HMG_PRINTER_PRINTPAGES','CheckBox_1','Enabled', .F. ) ) , Nil ) )
		End Spinner

		Define CheckBox CheckBox_1
			Row 132
			Col 300
			Width 110
			FontName 'Arial'
			FontSize 9
			Value if ( _hmg_printer_collate == 1 , .T. , .F. )
			Caption _hmg_printer_usermessages [14]
		End CheckBox

	End Window

	Center Window _HMG_PRINTER_PRINTPAGES

	Define Window _HMG_PRINTER_GO_TO_PAGE		;
		At 0,0					;
		Width 195				;
		Height 90 + GetTitleHeight()		;
		Title _hmg_printer_usermessages [07] 	;
		CHILD NOSHOW				;
		NOSIZE NOSYSMENU

		ON KEY ESCAPE	ACTION ( HideWindow( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )  , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus  )
		ON KEY RETURN	ACTION ( _hmg_printer_CurrentPageNumber := _HMG_PRINTER_GO_TO_PAGE.Spinner_1.Value , HideWindow( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus  )

		Define Label Label_1
			Row 13
			Col 10
			Width 94
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _hmg_printer_usermessages [10] + ':'
		End Label

		Define Spinner Spinner_1
			Row 10
			Col 105
			Width 75
			FontName 'Arial'
			FontSize 9
			Value _hmg_printer_CurrentPageNumber
			RangeMin 1
			RangeMax _hmg_printer_PageCount
		End Spinner

		Define Button Ok
			Row 48
			Col 10
			Width 80
			Height 25
			FontName 'Arial'
			FontSize 9
			Caption _hmg_printer_usermessages [11]
			Action ( _hmg_printer_CurrentPageNumber := _HMG_PRINTER_GO_TO_PAGE.Spinner_1.Value , HideWindow( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus  )
		End Button

		Define Button Cancel
			Row 48
			Col 100
			Width 80
			Height 25
			FontName 'Arial'
			FontSize 9
			Caption _hmg_printer_usermessages [12]
			Action ( HideWindow( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )  , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus  )
		End Button

	End Window

	Center Window _HMG_PRINTER_GO_TO_PAGE

	if _HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) > _HMG_PRINTER_GETPAGEWIDTH(_hmg_printer_hdc_bak)
		tFactor := 0.44
	else
		tFactor := 0.26
	endif

	tWidth	:=_HMG_PRINTER_GETPAGEWIDTH(_hmg_printer_hdc_bak) * tFactor
	tHeight :=_HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) * tFactor

	tHeight := Int (tHeight)	

	tvHeight := ( _hmg_printer_PageCount * (tHeight + 10) ) + GetHScrollbarHeight() + GetTitleHeight() + ( GetBorderHeight() * 2 ) + 7 

	if tvHeight <= GetDesktopHeight() - 103
		_hmg_printer_thumbscroll := .f.
		tvHeight := GetDesktopHeight() - 102
	else
		_hmg_printer_thumbscroll := .t.
	EndIf

	DEFINE WINDOW _HMG_PRINTER_SHOWTHUMBNAILS ;
		AT 0,5 ;
		WIDTH 130 ;
		HEIGHT GetDesktopHeight() - 103 - IF ( IsVistaThemed == .T. , 25 , 0) ;
		VIRTUAL WIDTH 131 ;
		VIRTUAL HEIGHT tvHeight ;
		TITLE _hmg_printer_usermessages [28] ;
		CHILD ;
		NOSIZE ;
		NOMINIMIZE ;
		NOMAXIMIZE ;
		NOSYSMENU ;
		NOSHOW ;
		BACKCOLOR GRAY 

		ON KEY HOME		ACTION ( _hmg_printer_CurrentPageNumber:=1 , _HMG_PRINTER_PREVIEWRefresh()  )
		ON KEY PRIOR		ACTION ( _hmg_printer_CurrentPageNumber-- , _HMG_PRINTER_PREVIEWRefresh()  )
		ON KEY NEXT		ACTION ( _hmg_printer_CurrentPageNumber++ , _HMG_PRINTER_PREVIEWRefresh()  )
		ON KEY END		ACTION ( _hmg_printer_CurrentPageNumber:= _hmg_printer_PageCount, _HMG_PRINTER_PREVIEWRefresh() )
		ON KEY CONTROL+P	ACTION _HMG_PRINTER_PrintPages()
		ON KEY CONTROL+G	ACTION _HMG_PRINTER_GO_TO_PAGE()
		ON KEY ESCAPE		ACTION _HMG_PRINTER_PreviewClose()
		ON KEY MULTIPLY 	ACTION ( _HMG_PRINTER_PPNAV.b5.value := ! _HMG_PRINTER_PPNAV.b5.value , _HMG_PRINTER_MouseZoom() )
		ON KEY CONTROL+C	ACTION _HMG_PRINTER_PreviewClose()
		ON KEY ALT+F4		ACTION _HMG_PRINTER_PreviewClose()
		ON KEY CONTROL+S	ACTION _hmg_printer_savepages()
		ON KEY CONTROL+T	ACTION _hmg_printer_ThumbnailToggle()

	END WINDOW

	if _hmg_printer_thumbscroll == .f.
		_HMG_PRINTER_PREVIEW_DISABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWTHUMBNAILS'))
	endif

	DEFINE WINDOW _HMG_PRINTER_PPNAV ;
			AT 1 + IF( IsVistaThemed == .T. , 3 , 0 ) , GetDesktopWidth() - 320 - IF ( IsVistaThemed == .T. , 5 , 0) ;
			WIDTH 312 + GetBorderWidth() ;
			HEIGHT 35 + GetTitleHeight() + GetBorderHeight() - IF ( IsVistaThemed == .T. , 3 , 0);
			TITLE _hmg_printer_usermessages [02] ;
			CHILD  ;
			NOMAXIMIZE ;
			NOMINIMIZE ;
			NOSIZE ;
			NOSYSMENU

			DEFINE BUTTON b1
				ROW 2
				COL 2
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_TOP
				TOOLTIP _hmg_printer_usermessages [03] 
				ACTION ( _hmg_printer_CurrentPageNumber:=1 , _HMG_PRINTER_PREVIEWRefresh()  )
			END BUTTON

			DEFINE BUTTON b2
				ROW 2
				COL 32
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_BACK
				TOOLTIP _hmg_printer_usermessages [04]
				ACTION ( _hmg_printer_CurrentPageNumber-- , _HMG_PRINTER_PREVIEWRefresh()  )
			END BUTTON

			DEFINE BUTTON b3
				ROW 2
				COL 62
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_NEXT
				TOOLTIP _hmg_printer_usermessages [05]
				ACTION ( _hmg_printer_CurrentPageNumber++ , _HMG_PRINTER_PREVIEWRefresh()  )
			END BUTTON

			DEFINE BUTTON b4
				ROW 2
				COL 92
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_END
				TOOLTIP _hmg_printer_usermessages [06]
				ACTION ( _hmg_printer_CurrentPageNumber:= _hmg_printer_PageCount, _HMG_PRINTER_PREVIEWRefresh()  )
			END BUTTON

			DEFINE CHECKBUTTON thumbswitch
				ROW 2
				COL 126
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_THUMBNAIL
				TOOLTIP _hmg_printer_usermessages [28] + ' [Ctrl+T]'
				OnChange _HMG_PRINTER_ProcessTHUMBNAILS()
			END CHECKBUTTON

			DEFINE BUTTON GoToPage
				ROW 2
				COL 156
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_GOPAGE
				TOOLTIP _hmg_printer_usermessages [07] + ' [Ctrl+G]'
				ACTION _HMG_PRINTER_GO_TO_PAGE()
			END BUTTON

			DEFINE CHECKBUTTON b5
				ROW 2
				COL 186
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_ZOOM
				TOOLTIP _hmg_printer_usermessages [08] + ' [*]'
				ON CHANGE _HMG_PRINTER_Zoom()
			END CHECKBUTTON

			DEFINE BUTTON b12
				ROW 2
				COL 216
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_PRINT
				TOOLTIP _hmg_printer_usermessages [09] + ' [Ctrl+P]'
				ACTION _HMG_PRINTER_PrintPages()
			END BUTTON

			DEFINE BUTTON b7
				ROW 2
				COL 246
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_SAVE
				TOOLTIP _hmg_printer_usermessages [27] + ' [Ctrl+S]'
				ACTION _hmg_printer_savepages()
			END BUTTON

			DEFINE BUTTON b6
				ROW 2
				COL 280
				WIDTH 30
				HEIGHT 30
				PICTURE IMG_CLOSE
				TOOLTIP _hmg_printer_usermessages [26] + ' [Ctrl+C]'
				ACTION _HMG_PRINTER_PreviewClose()
			END BUTTON

			ON KEY HOME		ACTION ( _hmg_printer_CurrentPageNumber:=1 , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY PRIOR		ACTION ( _hmg_printer_CurrentPageNumber-- , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY NEXT		ACTION ( _hmg_printer_CurrentPageNumber++ , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY END		ACTION ( _hmg_printer_CurrentPageNumber:= _hmg_printer_PageCount, _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY CONTROL+P	ACTION _HMG_PRINTER_Printpages()
			ON KEY CONTROL+G	ACTION _HMG_PRINTER_GO_TO_PAGE()
			ON KEY ESCAPE		ACTION _HMG_PRINTER_PreviewClose()
			ON KEY MULTIPLY 	ACTION ( _HMG_PRINTER_PPNAV.b5.value := ! _HMG_PRINTER_PPNAV.b5.value , _HMG_PRINTER_MouseZoom() )
			ON KEY CONTROL+C	ACTION _HMG_PRINTER_PreviewClose()
			ON KEY ALT+F4		ACTION _HMG_PRINTER_PreviewClose()
			ON KEY CONTROL+S	ACTION _hmg_printer_savepages()
			ON KEY CONTROL+T	ACTION _hmg_printer_ThumbnailToggle()

	END WINDOW

	SetScrollRange ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 0 , 100 , 1 )
	SetScrollRange ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 0 , 100 , 1 )

	SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 50 , 1 )
	SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 50 , 1 )

	_HMG_PRINTER_PREVIEW_DISABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	_HMG_PRINTER_PREVIEW_DISABLEHSCROLLBAR (GetFormHandle('_HMG_PRINTER_SHOWTHUMBNAILS'))

	CENTER WINDOW _HMG_PRINTER_SHOWPREVIEW

	Tmp := _HMG_PRINTER_SHOWPREVIEW.ROW  

	Tmp := Tmp + GetTitleHeight() - 10

	_HMG_PRINTER_SHOWPREVIEW.ROW := Tmp

	_HMG_PRINTER_SHOWTHUMBNAILS.ROW := Tmp

	ACTIVATE WINDOW _HMG_PRINTER_PRINTPAGES , _HMG_PRINTER_GO_TO_PAGE , _HMG_PRINTER_SHOWTHUMBNAILS , _HMG_PRINTER_SHOWPREVIEW , _HMG_PRINTER_Wait , _HMG_PRINTER_PPNAV 

	_hmg_printer_hdc := _hmg_printer_hdc_bak 

	If ModalHandle != 0

		For i := 1 To Len ( _HMG_aFormHandles )
			If _HMG_aFormDeleted [i] == .F.
				If _HMG_aFormType [i] != 'X'
					If _HMG_aFormHandles [i] != ModalHandle
						DisableWindow (_HMG_aFormHandles [i] )
					EndIf
				EndIf
			EndIf
		Next i

		EnableWIndow ( ModalHandle )
		SetFocus ( ModalHandle )

		_HMG_IsModalActive := .T.
		_hmg_activemodalhandle := ModalHandle

	Endif

	_HMG_InteractiveClose := icb

Return
*------------------------------------------------------------------------------*
Procedure CreateThumbNails
*------------------------------------------------------------------------------*
Local tFactor
Local tWidth
Local tHeight
Local ttHandle
Local i
Local cMacroTemp
Local cAction

	If _IsControlDefined ( 'Image1' , '_HMG_PRINTER_SHOWTHUMBNAILS' )
		Return
	EndIf

	ShowWindow ( GetFormHandle ( "_HMG_PRINTER_Wait" ) )

	if _HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) > _HMG_PRINTER_GETPAGEWIDTH(_hmg_printer_hdc_bak)
		tFactor := 0.44
	else
		tFactor := 0.26
	endif

	tWidth	:=_HMG_PRINTER_GETPAGEWIDTH(_hmg_printer_hdc_bak) * tFactor
	tHeight :=_HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) * tFactor

	tHeight := Int (tHeight)	

	ttHandle := GetFormToolTipHandle ('_HMG_PRINTER_SHOWTHUMBNAILS')

	For i := 1 To _hmg_printer_PageCount

		cMacroTemp := 'Image' + alltrim(str(i))

		cAction := "( _hmg_printer_CurrentPageNumber:="+ alltrim(str(i)) +", _HMG_PRINTER_THUMBUPDATE := .F. , _HMG_PRINTER_PREVIEWRefresh() , _HMG_PRINTER_THUMBUPDATE := .T. )"

		_DefineImage(;
			cMacroTemp,;
			'_HMG_PRINTER_SHOWTHUMBNAILS',;
			10,;
			( i * (tHeight + 10) ) - tHeight,;
			_hmg_printer_BasePageName + strzero(i,4) + ".emf",;
			tWidth,;
			tHeight,;
			{ || &cAction },;
			Nil,;
			.F.,;
			.F.,;
			.T.;
			)

		SetToolTip ( GetControlHandle ( cMacroTemp ,'_HMG_PRINTER_SHOWTHUMBNAILS'), _hmg_printer_usermessages [01] + ' ' + AllTrim(Str(i)) + ' [Click]' , ttHandle )
			
	Next i

	HideWindow ( GetFormHandle ( "_HMG_PRINTER_Wait" ) )

Return
*------------------------------------------------------------------------------*
Function _hmg_printer_ThumbnailToggle()
*------------------------------------------------------------------------------*

	if _HMG_PRINTER_PPNAV.thumbswitch.Value == .t. 

		_HMG_PRINTER_PPNAV.thumbswitch.Value := .f. 

	Else

		_HMG_PRINTER_PPNAV.thumbswitch.Value := .t. 
	
	EndIf

	_HMG_PRINTER_ProcessTHUMBNAILS() 

Return .F.
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ProcessTHUMBNAILS()
*------------------------------------------------------------------------------*

	If _HMG_PRINTER_PPNAV.thumbswitch.Value == .T.

		CreateThumbNails()

		_hmg_printer_zoomclick_xoffset := 90

		_hmg_printer_SizeFactor := GetDesktopHeight() / _HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) * 0.58

		_HMG_PRINTER_SHOWPREVIEW.Width := GetDesktopWidth() - 148 - IF ( IsVistaThemed == .T. , 30 , 0 )

		_HMG_PRINTER_SHOWPREVIEW.Col := 138 + IF ( IsVistaThemed == .T. , 20 , 0 )

		ShowWindow ( GetFormHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) 

	else

		_hmg_printer_zoomclick_xoffset := 0

		_hmg_printer_SizeFactor := GetDesktopHeight() / _HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) * 0.63

		_HMG_PRINTER_SHOWPREVIEW.Width := GetDesktopWidth() - 103
		_HMG_PRINTER_SHOWPREVIEW.Col := 51

		HideWindow ( GetFormHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) )

		_HMG_PRINTER_PPNAV.SetFocus

	EndIf

Return
*------------------------------------------------------------------------------*
Procedure _hmg_printer_savepages
*------------------------------------------------------------------------------*
Local c , i , f , t , d , x

	x := Putfile ( { {'Images','*.emf'} }, , GetCurrentFolder(), .t. )

	if empty(x)
		return
	endif

	x := cFileNoExt( x )

	t := gettempfolder() + '\'

	c := adir ( t + _hmg_printer_timestamp  + "_hmg_print_preview_*.Emf")

	declare a[c]

	adir ( t + _hmg_printer_timestamp  + "_hmg_print_preview_*.Emf" , a )

	For i := 1 To c
		f := t + a [i]
		d := x + '_' + StrZero ( i , 4 ) + '.emf'
		COPY FILE (F) TO (D)
	Next i

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_GO_TO_PAGE
*------------------------------------------------------------------------------*

	DisableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) 

	DisableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) )

	DisableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )

	ShowWindow ( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_hScrollBoxProcess()
*------------------------------------------------------------------------------*
Local Sp

	Sp := GetScrollPos (  GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ )

	_hmg_printer_Dx	:= - ( Sp - 50 ) * 10

	_HMG_PRINTER_PREVIEWRefresh()

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_vScrollBoxProcess()
*------------------------------------------------------------------------------*
Local Sp

	Sp := GetScrollPos (  GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT )

	_hmg_printer_Dy	:= - ( Sp - 50 ) * 10

	_HMG_PRINTER_PREVIEWRefresh()

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_PreviewClose()
*------------------------------------------------------------------------------*

	_HMG_PRINTER_CleanPreview()

	_HMG_PRINTER_WAIT.Release
	_HMG_PRINTER_SHOWTHUMBNAILS.Release
	_HMG_PRINTER_SHOWPREVIEW.Release
	_HMG_PRINTER_GO_TO_PAGE.Release
	_HMG_PRINTER_PRINTPAGES.Release
	_HMG_PRINTER_PPNAV.Release

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_CleanPreview
*------------------------------------------------------------------------------*

	AEval( Directory( GetTempFolder() + "\" + _hmg_printer_timestamp + "_hmg_print_preview_*.Emf" ), ;
		{ |file| Ferase( GetTempFolder() + "\" + file[1] ) } )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_PREVIEWRefresh 
*------------------------------------------------------------------------------*
Local hwnd
Local nRow
Local nScrollMax

	If _IsControlDefined ( 'Image' + AllTrim(Str(_hmg_printer_CurrentPageNumber)) , '_HMG_PRINTER_SHOWTHUMBNAILS' ) .and. _HMG_PRINTER_THUMBUPDATE == .T. .and. _hmg_printer_thumbscroll == .T.

		if _hmg_printer_PrevPageNumber != _hmg_printer_CurrentPageNumber

			_hmg_printer_PrevPageNumber := _hmg_printer_CurrentPageNumber
			hwnd := GetFormHandle('_HMG_PRINTER_SHOWTHUMBNAILS')
			nRow := GetProperty ( '_HMG_PRINTER_SHOWTHUMBNAILS' , 'Image' + AllTrim(Str(_hmg_printer_CurrentPageNumber)) , 'Row' )
			nScrollMax := GetScrollRangeMax ( hwnd , SB_VERT )

		if _hmg_printer_PageCount == _hmg_printer_CurrentPageNumber

			if GetScrollPos(hwnd,SB_VERT) != nScrollMax
				_HMG_PRINTER_SETVSCROLLVALUE ( hwnd , nScrollMax )
			EndIf

		ElseIf _hmg_printer_CurrentPageNumber == 1 

			if GetScrollPos(hwnd,SB_VERT) != 0
				_HMG_PRINTER_SETVSCROLLVALUE ( hwnd , 0 )
			EndIf

		Else

			if ( nRow - 9 ) < nScrollMax 
				_HMG_PRINTER_SETVSCROLLVALUE ( hwnd , nRow - 9 )
			Else
				if GetScrollPos(hwnd,SB_VERT) != nScrollMax
					_HMG_PRINTER_SETVSCROLLVALUE ( hwnd , nScrollMax )
				EndIf
			EndIf

		EndIf

		EndIf

	EndIf

	if _hmg_printer_CurrentPageNumber < 1 
		_hmg_printer_CurrentPageNumber := 1
		PlayBeep()
		Return
	EndIf

	if _hmg_printer_CurrentPageNumber > _hmg_printer_PageCount
		_hmg_printer_CurrentPageNumber := _hmg_printer_PageCount
		PlayBeep()
		Return
	EndIf

	_HMG_PRINTER_SHOWPAGE ( _hmg_printer_BasePageName + strzero(_hmg_printer_CurrentPageNumber,4) + ".emf" , GetFormhandle ('_HMG_PRINTER_SHOWPREVIEW') , _hmg_printer_hdc_bak , _hmg_printer_SizeFactor * 10000 , _hmg_printer_Dz , _hmg_printer_Dx , _hmg_printer_Dy ) 

	_HMG_PRINTER_SHOWPREVIEW.TITLE := _hmg_printer_usermessages [01] + ' [' + alltrim(str(_hmg_printer_CurrentPageNumber)) + '/'+alltrim(str(_hmg_printer_PageCount)) + ']'

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_PrintPages
*------------------------------------------------------------------------------*

	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) 
	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) )
	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )

	_HMG_PRINTER_PRINTPAGES.Radio_1.Value := 1

	_HMG_PRINTER_PRINTPAGES.Label_1.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Label_2.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Label_4.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Spinner_1.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Spinner_2.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Combo_1.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.CheckBox_1.Enabled := .F.

	if	_hmg_printer_copies > 1 ;
		.or. ;
		_hmg_printer_collate == 1

		_HMG_PRINTER_PRINTPAGES.Spinner_3.Enabled := .F.

	endif

	ShowWindow ( GetFormHandle ( "_HMG_PRINTER_PRINTPAGES" ) )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_PrintPagesDo
*------------------------------------------------------------------------------*
Local i
Local PageFrom
Local PageTo
Local p
Local OddOnly := .F.
Local EvenOnly := .F.

	If _HMG_PRINTER_PrintPages.Radio_1.Value == 1

		PageFrom := 1 
		PageTo	 := _hmg_printer_PageCount

	ElseIf _HMG_PRINTER_PrintPages.Radio_1.Value == 2

		PageFrom := _HMG_PRINTER_PrintPages.Spinner_1.Value
		PageTo	 := _HMG_PRINTER_PrintPages.Spinner_2.Value

		If _HMG_PRINTER_PrintPages.Combo_1.Value == 2
			OddOnly := .T. 
		ElseIf _HMG_PRINTER_PrintPages.Combo_1.Value == 3
			EvenOnly := .T. 
		EndIf

	EndIf

	_HMG_PRINTER_StartDoc ( _hmg_printer_hdc_bak, _hmg_printer_JobName )

	If	_hmg_printer_copies > 1 ;
		.or. ;
		_hmg_printer_collate == 1

		For i := PageFrom To PageTo

			If OddOnly == .T.
				If i / 2 != int (i / 2)
					_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
				EndIf
			ElseIf EvenOnly == .T.
				If i / 2 == int (i / 2)
					_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
				EndIf
			Else
				_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
			EndIf

		Next i

	Else

		If _HMG_PRINTER_PrintPages.Spinner_3.Value == 1 // Copies 

			For i := PageFrom To PageTo

				If OddOnly == .T.
					If i / 2 != int (i / 2)
						_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
					EndIf
				ElseIf EvenOnly == .T.
					If i / 2 == int (i / 2)
						_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
					EndIf
				Else
					_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
				EndIf

			Next i

		Else

			If _HMG_PRINTER_PrintPages.CheckBox_1.Value == .F.

				For p := 1 To _HMG_PRINTER_PrintPages.Spinner_3.Value
					For i := PageFrom To PageTo

						If OddOnly == .T.
							If i / 2 != int (i / 2)
								_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
							EndIf
						ElseIf EvenOnly == .T.
							If i / 2 == int (i / 2)
								_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
							EndIf
						Else
							_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
						EndIf

					Next i

				Next p

			Else

				For i := PageFrom To PageTo

					For p := 1 To _HMG_PRINTER_PrintPages.Spinner_3.Value

						If OddOnly == .T.
							If i / 2 != int (i / 2)
								_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
							EndIf
						ElseIf EvenOnly == .T.
							If i / 2 == int (i / 2)
								_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
							EndIf
						Else
							_HMG_PRINTER_PRINTPAGE ( _hmg_printer_hdc_bak , _hmg_printer_BasePageName + strzero(i,4) + ".emf" )
						EndIf

					Next p

				Next i

			EndIf

		EndIf

	EndIf

	_HMG_PRINTER_ENDDOC ( _hmg_printer_hdc_bak )

	EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )
	EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) 
	EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) 

	HideWindow ( GetFormHandle ( "_HMG_PRINTER_PRINTPAGES" ) ) 

	_HMG_PRINTER_SHOWPREVIEW.setfocus 

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ScrollLeft
*------------------------------------------------------------------------------*
	_hmg_printer_Dx := _hmg_printer_Dx + _hmg_printer_scrollstep
	if _hmg_printer_Dx >= 500
		_hmg_printer_Dx := 500
		PlayBeep()
	EndIf
	_HMG_PRINTER_PREVIEWRefresh()
Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ScrollRight
*------------------------------------------------------------------------------*
	_hmg_printer_Dx := _hmg_printer_Dx - _hmg_printer_scrollstep
	if _hmg_printer_Dx <= -500
		_hmg_printer_Dx := -500
		PlayBeep()
	EndIf
	_HMG_PRINTER_PREVIEWRefresh()
Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ScrollUp
*------------------------------------------------------------------------------*
	_hmg_printer_Dy := _hmg_printer_Dy + _hmg_printer_scrollstep
	if _hmg_printer_Dy >= 500
		_hmg_printer_Dy := 500
		PlayBeep()
	EndIf
	_HMG_PRINTER_PREVIEWRefresh()
Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ScrollDown
*------------------------------------------------------------------------------*
	_hmg_printer_Dy := _hmg_printer_Dy - _hmg_printer_scrollstep
	if _hmg_printer_Dy <= -500
		_hmg_printer_Dy := -500
		PlayBeep()
	EndIf

	_HMG_PRINTER_PREVIEWRefresh()
Return
*------------------------------------------------------------------------------*
Function GetPrinter()
*------------------------------------------------------------------------------*
Local RetVal		:= ''
Local Printers		:= asort (aPrinters())
Local cDefaultPrinter	:= GetDefaultPrinter()
Local i
Local nInitPosition	:= 0

	For i := 1 to Len ( Printers )

		If Printers [i] == cDefaultPrinter
			nInitPosition := i
			Exit
		Endif

	Next i

	if Type ('_hmg_printer_usermessages') # "A"
		_hmg_printer_InitUserMessages()
	EndIf

	DEFINE WINDOW _HMG_PRINTER_GETPRINTER	;
		AT 0,0			; 
		WIDTH 345		;
		HEIGHT GetTitleHeight() + 100 ;
		TITLE _hmg_printer_usermessages [13] ;
		MODAL			;
		NOSIZE

		@ 15,10 COMBOBOX Combo_1 ITEMS Printers VALUE nInitPosition WIDTH 320

		@ 53 , 65  BUTTON Ok CAPTION _hmg_printer_usermessages [11] ACTION ( RetVal := Printers [ GetProperty ( '_HMG_PRINTER_GETPRINTER','Combo_1','Value') ] , DoMethod('_HMG_PRINTER_GETPRINTER','Release' ) )

		@ 53 , 175 BUTTON Cancel CAPTION _hmg_printer_usermessages [12] ACTION ( RetVal := '' , DoMethod('_HMG_PRINTER_GETPRINTER','Release' ) )

	END WINDOW

	CENTER WINDOW _HMG_PRINTER_GETPRINTER

	ACTIVATE WINDOW _HMG_PRINTER_GETPRINTER

Return (RetVal)

#define TA_CENTER	6
#define TA_LEFT		0
#define TA_RIGHT	2

*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_PRINT ( nHdc , nRow , nCol , cFontName , nFontSize , nColor1 , nColor2 , nColor3 , cText , lbold , litalic , lunderline , lstrikeout , lcolor , lfont , lsize , cAlign )
*------------------------------------------------------------------------------*
Local lAlignChanged := .F.

	if ValType (cText) == "N"
		cText := AllTrim(Str(cText))
	Elseif ValType (cText) == "D"
		cText := dtoc (cText)
	Elseif ValType (cText) == "L"
		cText := if ( cText == .T. , _hmg_printer_usermessages [24] , _hmg_printer_usermessages [25] )
	Elseif ValType (cText) == "A"
		Return
	Elseif ValType (cText) == "B"
		Return
	Elseif ValType (cText) == "O"
		Return
	Elseif ValType (cText) == "U"
		Return
	EndIf

	nRow := Int ( nRow * 10000 / 254 )
	nCol := Int ( nCol * 10000 / 254 )

	if valtype ( cAlign ) = 'C'
		if upper ( cAlign ) = 'CENTER'
			SetTextAlign ( nHdc , TA_CENTER )
			lAlignChanged := .T.
		elseif upper ( cAlign ) = 'RIGHT'
			SetTextAlign ( nHdc , TA_RIGHT )
			lAlignChanged := .T.
		endif			
	endif

	_HMG_PRINTER_C_PRINT ( nHdc , nRow , nCol , cFontName , nFontSize , nColor1 , nColor2 , nColor3 , cText , lbold , litalic , lunderline , lstrikeout , lcolor , lfont , lsize )

	if lAlignChanged
		SetTextAlign ( nHdc , TA_LEFT )
	endif

Return

*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_MULTILINE_PRINT ( nHdc , nRow , nCol , nToRow , nToCol , cFontName , nFontSize , nColor1 , nColor2 , nColor3 , cText , lbold , litalic , lunderline , lstrikeout , lcolor , lfont , lsize , cAlign )
*------------------------------------------------------------------------------*
Local nAlign := TA_LEFT

	if ValType (cText) == "N"
		cText := AllTrim(Str(cText))
	Elseif ValType (cText) == "D"
		cText := dtoc (cText)
	Elseif ValType (cText) == "L"
		cText := if ( cText == .T. , _hmg_printer_usermessages [24] , _hmg_printer_usermessages [25] )
	Elseif ValType (cText) == "A"
		Return
	Elseif ValType (cText) == "B"
		Return
	Elseif ValType (cText) == "O"
		Return
	Elseif ValType (cText) == "U"
		Return
	EndIf

	nRow := Int ( nRow * 10000 / 254 )
	nCol := Int ( nCol * 10000 / 254 )
	nToRow := Int ( nToRow * 10000 / 254 )
	nToCol := Int ( nToCol * 10000 / 254 )

	if valtype ( cAlign ) = 'C'
		if upper ( cAlign ) = 'CENTER'
			nAlign := TA_CENTER
		elseif upper ( cAlign ) = 'RIGHT'
			nAlign := TA_RIGHT
		endif			
	endif

	_HMG_PRINTER_C_MULTILINE_PRINT ( nHdc , nRow , nCol , cFontName , nFontSize , nColor1 , nColor2 , nColor3 , cText , lbold , litalic , lunderline , lstrikeout , lcolor , lfont , lsize , nToRow , nToCol , nAlign )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_IMAGE ( nHdc , cImage , nRow , nCol , nHeight , nWidth , lStretch )
*------------------------------------------------------------------------------*

	nRow	:= Int ( nRow * 10000 / 254 )
	nCol	:= Int ( nCol * 10000 / 254 )
	nWidth	:= Int ( nWidth * 10000 / 254 )
	nHeight	:= Int ( nHeight * 10000 / 254 )

	_HMG_PRINTER_C_IMAGE ( nHdc , cImage , nRow , nCol , nHeight , nWidth , lStretch )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_LINE ( nHdc , nRow , nCol , nToRow , nToCol , nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor )
*------------------------------------------------------------------------------*

	nRow	:= Int ( nRow * 10000 / 254 )
	nCol	:= Int ( nCol * 10000 / 254 )
	nToRow	:= Int ( nToRow * 10000 / 254 )
	nToCol	:= Int ( nToCol * 10000 / 254 )

	If ValType ( nWidth ) != 'U'
		nWidth	:= Int ( nWidth * 10000 / 254 )
	EndIf

	_HMG_PRINTER_C_LINE ( nHdc , nRow , nCol , nToRow , nToCol , nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_RECTANGLE ( nHdc , nRow , nCol , nToRow , nToCol ,nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor )
*------------------------------------------------------------------------------*

	nRow	:= Int ( nRow * 10000 / 254 )
	nCol	:= Int ( nCol * 10000 / 254 )
	nToRow	:= Int ( nToRow * 10000 / 254 )
	nToCol	:= Int ( nToCol * 10000 / 254 )

	If ValType ( nWidth ) != 'U'
		nWidth	:= Int ( nWidth * 10000 / 254 )
	EndIf

	_HMG_PRINTER_C_RECTANGLE ( nHdc , nRow , nCol , nToRow , nToCol , nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_ROUNDRECTANGLE ( nHdc , nRow , nCol , nToRow , nToCol ,nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor )
*------------------------------------------------------------------------------*

	nRow	:= Int ( nRow * 10000 / 254 )
	nCol	:= Int ( nCol * 10000 / 254 )
	nToRow	:= Int ( nToRow * 10000 / 254 )
	nToCol	:= Int ( nToCol * 10000 / 254 )

	If ValType ( nWidth ) != 'U'
		nWidth	:= Int ( nWidth * 10000 / 254 )
	EndIf

	_HMG_PRINTER_C_ROUNDRECTANGLE ( nHdc , nRow , nCol , nToRow , nToCol , nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor )

Return

*------------------------------------------------------------------------------*
Procedure _hmg_printer_InitUserMessages
*------------------------------------------------------------------------------*
Local cLang := Set ( _SET_LANGUAGE )   
Public	_hmg_printer_usermessages [29]

_hmg_printer_usermessages [01] := 'Page'
_hmg_printer_usermessages [02] := 'Print Preview'
_hmg_printer_usermessages [03] := 'First Page [HOME]'
_hmg_printer_usermessages [04] := 'Previous Page [PGUP]'
_hmg_printer_usermessages [05] := 'Next Page [PGDN]'
_hmg_printer_usermessages [06] := 'Last Page [END]'
_hmg_printer_usermessages [07] := 'Go To Page'
_hmg_printer_usermessages [08] := 'Zoom'
_hmg_printer_usermessages [09] := 'Print'
_hmg_printer_usermessages [10] := 'Page Number'
_hmg_printer_usermessages [11] := 'Ok'
_hmg_printer_usermessages [12] := 'Cancel'
_hmg_printer_usermessages [13] := 'Select Printer'
_hmg_printer_usermessages [14] := 'Collate Copies'
_hmg_printer_usermessages [15] := 'Print Range'
_hmg_printer_usermessages [16] := 'All'
_hmg_printer_usermessages [17] := 'Pages'
_hmg_printer_usermessages [18] := 'From'
_hmg_printer_usermessages [19] := 'To'
_hmg_printer_usermessages [20] := 'Copies'
_hmg_printer_usermessages [21] := 'All Range'
_hmg_printer_usermessages [22] := 'Odd Pages Only'
_hmg_printer_usermessages [23] := 'Even Pages Only'
_hmg_printer_usermessages [24] := 'Yes'
_hmg_printer_usermessages [25] := 'No'
_hmg_printer_usermessages [26] := 'Close'
_hmg_printer_usermessages [27] := 'Save'
_hmg_printer_usermessages [28] := 'Thumbnails'
_hmg_printer_usermessages [29] := 'Generating Thumbnails... Please Wait...'

#ifdef _MULTILINGUAL_

// LANGUAGE IS NOT SUPPORTED BY hb_langSelect() FUNCTION

IF _HMG_LANG_ID == 'FI'		// FINNISH
	cLang := 'FI'		
ENDIF

do case

case cLang == "CS" .OR. cLang == "CSWIN"
/////////////////////////////////////////////////////////////
// CZECH
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Strana'
	_hmg_printer_usermessages [02] := 'Nhled'
	_hmg_printer_usermessages [03] := 'Prvn strana [HOME]'
	_hmg_printer_usermessages [04] := 'Pedchoz strana [PGUP]'
	_hmg_printer_usermessages [05] := 'Dal strana [PGDN]'
	_hmg_printer_usermessages [06] := 'Posledn strana [END]'
	_hmg_printer_usermessages [07] := 'Jdi na stranu'
	_hmg_printer_usermessages [08] := 'Lupa'
	_hmg_printer_usermessages [09] := 'Tisk'
	_hmg_printer_usermessages [10] := 'slo strany'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Storno'
	_hmg_printer_usermessages [13] := 'Vyber tiskrnu'
	_hmg_printer_usermessages [14] := 'Tdn'
	_hmg_printer_usermessages [15] := 'Rozsah tisku'
	_hmg_printer_usermessages [16] := 've'
	_hmg_printer_usermessages [17] := 'strany'
	_hmg_printer_usermessages [18] := 'od'
	_hmg_printer_usermessages [19] := 'do'
	_hmg_printer_usermessages [20] := 'kopi'
	_hmg_printer_usermessages [21] := 'vechny strany'
	_hmg_printer_usermessages [22] := 'lich strany'
	_hmg_printer_usermessages [23] := 'sud strany'
	_hmg_printer_usermessages [24] := 'Ano'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Zavi'
	_hmg_printer_usermessages [27] := 'Ulo'
	_hmg_printer_usermessages [28] := 'Miniatury'
	_hmg_printer_usermessages [29] := 'Generuji miniatury... ekejte, prosm...'

case cLang == "HR852" // Croatian
/////////////////////////////////////////////////////////////
// CROATIAN
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Page'
	_hmg_printer_usermessages [02] := 'Print Preview'
	_hmg_printer_usermessages [03] := 'First Page [HOME]'
	_hmg_printer_usermessages [04] := 'Previous Page [PGUP]'
	_hmg_printer_usermessages [05] := 'Next Page [PGDN]'
	_hmg_printer_usermessages [06] := 'Last Page [END]'
	_hmg_printer_usermessages [07] := 'Go To Page'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Print'
	_hmg_printer_usermessages [10] := 'Page Number'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Cancel'
	_hmg_printer_usermessages [13] := 'Select Printer'
	_hmg_printer_usermessages [14] := 'Collate Copies'
	_hmg_printer_usermessages [15] := 'Print Range'
	_hmg_printer_usermessages [16] := 'All'
	_hmg_printer_usermessages [17] := 'Pages'
	_hmg_printer_usermessages [18] := 'From'
	_hmg_printer_usermessages [19] := 'To'
	_hmg_printer_usermessages [20] := 'Copies'
	_hmg_printer_usermessages [21] := 'All Range'
	_hmg_printer_usermessages [22] := 'Odd Pages Only'
	_hmg_printer_usermessages [23] := 'Even Pages Only'
	_hmg_printer_usermessages [24] := 'Yes'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Close'
	_hmg_printer_usermessages [27] := 'Save'
	_hmg_printer_usermessages [28] := 'Thumbnails'
	_hmg_printer_usermessages [29] := 'Generating Thumbnails... Please Wait...'

case cLang == "EU"        // Basque.
/////////////////////////////////////////////////////////////
// BASQUE
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Page'
	_hmg_printer_usermessages [02] := 'Print Preview'
	_hmg_printer_usermessages [03] := 'First Page [HOME]'
	_hmg_printer_usermessages [04] := 'Previous Page [PGUP]'
	_hmg_printer_usermessages [05] := 'Next Page [PGDN]'
	_hmg_printer_usermessages [06] := 'Last Page [END]'
	_hmg_printer_usermessages [07] := 'Go To Page'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Print'
	_hmg_printer_usermessages [10] := 'Page Number'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Cancel'
	_hmg_printer_usermessages [13] := 'Select Printer'
	_hmg_printer_usermessages [14] := 'Collate Copies'
	_hmg_printer_usermessages [15] := 'Print Range'
	_hmg_printer_usermessages [16] := 'All'
	_hmg_printer_usermessages [17] := 'Pages'
	_hmg_printer_usermessages [18] := 'From'
	_hmg_printer_usermessages [19] := 'To'
	_hmg_printer_usermessages [20] := 'Copies'
	_hmg_printer_usermessages [21] := 'All Range'
	_hmg_printer_usermessages [22] := 'Odd Pages Only'
	_hmg_printer_usermessages [23] := 'Even Pages Only'
	_hmg_printer_usermessages [24] := 'Yes'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Close'
	_hmg_printer_usermessages [27] := 'Save'
	_hmg_printer_usermessages [28] := 'Thumbnails'
	_hmg_printer_usermessages [29] := 'Generating Thumbnails... Please Wait...'

case cLang == "FR"        // French
/////////////////////////////////////////////////////////////
// FRENCH
////////////////////////////////////////////////////////////
                                          
	_hmg_printer_usermessages [01] := 'Page'
	_hmg_printer_usermessages [02] := "Aperu avant impression"
	_hmg_printer_usermessages [03] := 'Premire page [HOME]'
	_hmg_printer_usermessages [04] := 'Page prcdente [PGUP]'
	_hmg_printer_usermessages [05] := 'Page suivante [PGDN]'
	_hmg_printer_usermessages [06] := 'Dernire page [END]'
	_hmg_printer_usermessages [07] := 'Allez page'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Imprimer'
	_hmg_printer_usermessages [10] := 'Page'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Annulation'
	_hmg_printer_usermessages [13] := "Slection de l'imprimante"
	_hmg_printer_usermessages [14] := "Assemblez"
	_hmg_printer_usermessages [15] := "Paramtres d'impression"
	_hmg_printer_usermessages [16] := 'Tous'
	_hmg_printer_usermessages [17] := 'Pages'
	_hmg_printer_usermessages [18] := 'De'
	_hmg_printer_usermessages [19] := ''
	_hmg_printer_usermessages [20] := 'Copies'
	_hmg_printer_usermessages [21] := 'Toutes les pages'
	_hmg_printer_usermessages [22] := 'Pages Impaires'
	_hmg_printer_usermessages [23] := 'Pages Paires'
	_hmg_printer_usermessages [24] := 'Oui'
	_hmg_printer_usermessages [25] := 'Non'
	_hmg_printer_usermessages [26] := 'Fermer'
	_hmg_printer_usermessages [27] := 'Sauver'
	_hmg_printer_usermessages [28] := 'Affichettes'
	_hmg_printer_usermessages [29] := "Cration des affichettes... Merci d'attendre..."

case cLang == "DEWIN" .OR. cLang == "DE"       // German
/////////////////////////////////////////////////////////////
// GERMAN
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Seite'
	_hmg_printer_usermessages [02] := 'DruckcVorbetrachtung'
	_hmg_printer_usermessages [03] := 'Erste Seite [HOME]'
	_hmg_printer_usermessages [04] := 'Vorige Seite [PGUP]'
	_hmg_printer_usermessages [05] := 'Folgende Seite [PGDN]'
	_hmg_printer_usermessages [06] := 'Letzte Seite [END]'
	_hmg_printer_usermessages [07] := 'Gehen Sie Zu paginieren'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Druck'
	_hmg_printer_usermessages [10] := 'Seitenzahl'
	_hmg_printer_usermessages [11] := 'O.K.'
	_hmg_printer_usermessages [12] := 'Lschen'
	_hmg_printer_usermessages [13] := 'Whlen Sie Drucker Vor'
	_hmg_printer_usermessages [14] := 'Sortieren'
	_hmg_printer_usermessages [15] := 'DruckcStrecke'
	_hmg_printer_usermessages [16] := 'Alle'
	_hmg_printer_usermessages [17] := 'Seiten'
	_hmg_printer_usermessages [18] := 'Von'
	_hmg_printer_usermessages [19] := 'Zu'
	_hmg_printer_usermessages [20] := 'Kopien'
	_hmg_printer_usermessages [21] := 'Alle Strecke'
	_hmg_printer_usermessages [22] := 'Nur Ungerade Seiten'
	_hmg_printer_usermessages [23] := 'Nur Gleichmige Seiten'
	_hmg_printer_usermessages [24] := 'Ja'
	_hmg_printer_usermessages [25] := 'Nein'
	_hmg_printer_usermessages [26] := 'Fenster'
	_hmg_printer_usermessages [27] := 'Speichern'
	_hmg_printer_usermessages [28] := 'berblick'
	_hmg_printer_usermessages [29] := 'berblick Erzeugen...  Bitte Wartezeit...'

case cLang == "IT"        // Italian
/////////////////////////////////////////////////////////////
// ITALIAN
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Pagina'
	_hmg_printer_usermessages [02] := 'Anteprima di stampa'
	_hmg_printer_usermessages [03] := 'Prima Pagina [HOME]'
	_hmg_printer_usermessages [04] := 'Pagina Precedente [PGUP]'
	_hmg_printer_usermessages [05] := 'Pagina Seguente [PGDN]'
	_hmg_printer_usermessages [06] := 'Ultima Pagina [END]'
	_hmg_printer_usermessages [07] := 'Vai Alla Pagina'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Stampa'
	_hmg_printer_usermessages [10] := 'Pagina'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Annulla'
	_hmg_printer_usermessages [13] := 'Selezioni Lo Stampatore'
	_hmg_printer_usermessages [14] := 'Fascicoli'
	_hmg_printer_usermessages [15] := 'Intervallo di stampa'
	_hmg_printer_usermessages [16] := 'Tutti'
	_hmg_printer_usermessages [17] := 'Pagine'
	_hmg_printer_usermessages [18] := 'Da'
	_hmg_printer_usermessages [19] := 'A'
	_hmg_printer_usermessages [20] := 'Copie'
	_hmg_printer_usermessages [21] := 'Tutte le pagine'
	_hmg_printer_usermessages [22] := 'Le Pagine Pari'
	_hmg_printer_usermessages [23] := 'Le Pagine Dispari'
	_hmg_printer_usermessages [24] := 'Si'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Chiudi'
	_hmg_printer_usermessages [27] := 'Salva'
	_hmg_printer_usermessages [28] := 'Miniatura'
	_hmg_printer_usermessages [29] := 'Generando Miniatura...  Prego Attesa...'

case cLang == "PLWIN" .OR. cLang == "PL852" .OR. cLang == "PLISO" .OR. cLang == "" .OR. cLang == "PLMAZ"   // Polish 
/////////////////////////////////////////////////////////////
// POLISH
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Strona'
	_hmg_printer_usermessages [02] := 'Podgld wydruku'
	_hmg_printer_usermessages [03] := 'Pierwsza strona [HOME]'
	_hmg_printer_usermessages [04] := 'Poprzednia strona [PGUP]'
	_hmg_printer_usermessages [05] := 'Nastpna strona [PGDN]'
	_hmg_printer_usermessages [06] := 'Ostatnia strona [END]'
	_hmg_printer_usermessages [07] := 'Skocz do strony'
	_hmg_printer_usermessages [08] := 'Powiksz'
	_hmg_printer_usermessages [09] := 'Drukuj'
	_hmg_printer_usermessages [10] := 'Numer strony'
	_hmg_printer_usermessages [11] := 'Tak'
	_hmg_printer_usermessages [12] := 'Przerwij'
	_hmg_printer_usermessages [13] := 'Wybierz drukark'
	_hmg_printer_usermessages [14] := 'Sortuj kopie'
	_hmg_printer_usermessages [15] := 'Zakres wydruku'
	_hmg_printer_usermessages [16] := 'Wszystkie'
	_hmg_printer_usermessages [17] := 'Strony'
	_hmg_printer_usermessages [18] := 'Od'
	_hmg_printer_usermessages [19] := 'Do'
	_hmg_printer_usermessages [20] := 'Kopie'
	_hmg_printer_usermessages [21] := 'Wszystkie'
	_hmg_printer_usermessages [22] := 'Nieparzyste'
	_hmg_printer_usermessages [23] := 'Parzyste'
	_hmg_printer_usermessages [24] := 'Tak'
	_hmg_printer_usermessages [25] := 'Nie'
	_hmg_printer_usermessages [26] := 'Zamknij'
	_hmg_printer_usermessages [27] := 'Zapisz'
	_hmg_printer_usermessages [28] := 'Thumbnails'
	_hmg_printer_usermessages [29] := 'Generuj Thumbnails... Prosz czeka...'

case cLang == "PT"        // Portuguese
/////////////////////////////////////////////////////////////
// PORTUGUESE
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Pgina'
	_hmg_printer_usermessages [02] := 'Visualizao da Impresso'
	_hmg_printer_usermessages [03] := 'Primeira Pgina [HOME]'
	_hmg_printer_usermessages [04] := 'Pgina Anterior [PGUP]'
	_hmg_printer_usermessages [05] := 'Pgina Seguinte [PGDN]'
	_hmg_printer_usermessages [06] := 'ltima Pgina [END]'
	_hmg_printer_usermessages [07] := 'Ir Para a Pgina N'
	_hmg_printer_usermessages [08] := 'Ampliar'
	_hmg_printer_usermessages [09] := 'Imprimir'
	_hmg_printer_usermessages [10] := 'Pgina'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Cancelar'
	_hmg_printer_usermessages [13] := 'Selecione a Impressora'
	_hmg_printer_usermessages [14] := 'Ordenar Cpias'
	_hmg_printer_usermessages [15] := 'Intervalo de Impresso'
	_hmg_printer_usermessages [16] := 'Tudo'
	_hmg_printer_usermessages [17] := 'Pginas'
	_hmg_printer_usermessages [18] := 'De'
	_hmg_printer_usermessages [19] := 'At'
	_hmg_printer_usermessages [20] := 'N de Cpias'
	_hmg_printer_usermessages [21] := 'Todas as Pginas'
	_hmg_printer_usermessages [22] := ' Somente Pginas Impares'
	_hmg_printer_usermessages [23] := ' Somente Pginas Pares'
	_hmg_printer_usermessages [24] := 'Sim'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Fechar'
	_hmg_printer_usermessages [27] := 'Salvar'
	_hmg_printer_usermessages [28] := 'Miniaturas'
	_hmg_printer_usermessages [29] := 'Aguarde, Gerando Miniaturas...'

case cLang == "RUWIN" .OR. cLang == "RU866" .OR. cLang == "RUKOI8"	// Russian 
/////////////////////////////////////////////////////////////
// RUSSIAN
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := ''
	_hmg_printer_usermessages [02] := ' '
	_hmg_printer_usermessages [03] := ' [HOME]'
	_hmg_printer_usermessages [04] := ' [PGUP]'
	_hmg_printer_usermessages [05] := ' [PGDN]'
	_hmg_printer_usermessages [06] := ' [END]'
	_hmg_printer_usermessages [07] := ' '
	_hmg_printer_usermessages [08] := ''
	_hmg_printer_usermessages [09] := ''
	_hmg_printer_usermessages [10] := ' '
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := ''
	_hmg_printer_usermessages [13] := ' '
	_hmg_printer_usermessages [14] := ' '
	_hmg_printer_usermessages [15] := ' '
	_hmg_printer_usermessages [16] := ''
	_hmg_printer_usermessages [17] := ''
	_hmg_printer_usermessages [18] := ''
	_hmg_printer_usermessages [19] := ''
	_hmg_printer_usermessages [20] := ''
	_hmg_printer_usermessages [21] := ' '
	_hmg_printer_usermessages [22] := ' '
	_hmg_printer_usermessages [23] := ' '
	_hmg_printer_usermessages [24] := ''
	_hmg_printer_usermessages [25] := ''
	_hmg_printer_usermessages [26] := ''
	_hmg_printer_usermessages [27] := ''
	_hmg_printer_usermessages [28] := ''
	_hmg_printer_usermessages [29] := ',  ...'

case cLang == "UAWIN" .OR. cLang == "UA866" // Ukrainian 
/////////////////////////////////////////////////////////////
// UKRAINIAN
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := ''
	_hmg_printer_usermessages [02] := ' '
	_hmg_printer_usermessages [03] := ' [HOME]'
	_hmg_printer_usermessages [04] := ' [PGUP]'
	_hmg_printer_usermessages [05] := ' [PGDN]'
	_hmg_printer_usermessages [06] := ' [END]'
	_hmg_printer_usermessages [07] := ' '
	_hmg_printer_usermessages [08] := ''
	_hmg_printer_usermessages [09] := ''
	_hmg_printer_usermessages [10] := ' '
	_hmg_printer_usermessages [11] := ''
	_hmg_printer_usermessages [12] := '³'
	_hmg_printer_usermessages [13] := ' '
	_hmg_printer_usermessages [14] := ' '
	_hmg_printer_usermessages [15] := ' '
	_hmg_printer_usermessages [16] := ''
	_hmg_printer_usermessages [17] := ''
	_hmg_printer_usermessages [18] := ''
	_hmg_printer_usermessages [19] := ''
	_hmg_printer_usermessages [20] := ''
	_hmg_printer_usermessages [21] := ' '
	_hmg_printer_usermessages [22] := 'ҳ '
	_hmg_printer_usermessages [23] := 'ҳ '
	_hmg_printer_usermessages [24] := ''
	_hmg_printer_usermessages [25] := 'ͳ'
	_hmg_printer_usermessages [26] := ''
	_hmg_printer_usermessages [27] := ''
	_hmg_printer_usermessages [28] := '̳'
	_hmg_printer_usermessages [29] := ',  ...'

case cLang == "ES" .OR. cLang == "ESWIN"       // Spanish
/////////////////////////////////////////////////////////////
// SPANISH
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Pgina'
	_hmg_printer_usermessages [02] := 'Vista Previa'
	_hmg_printer_usermessages [03] := 'Inicio [INICIO]'
	_hmg_printer_usermessages [04] := 'Anterior [REPAG]'
	_hmg_printer_usermessages [05] := 'Siguiente [AVPAG]'
	_hmg_printer_usermessages [06] := 'Fin [FIN]'
	_hmg_printer_usermessages [07] := 'Ir a'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Imprimir'
	_hmg_printer_usermessages [10] := 'Pgina Nro.'
	_hmg_printer_usermessages [11] := 'Aceptar'
	_hmg_printer_usermessages [12] := 'Cancelar'
	_hmg_printer_usermessages [13] := 'Seleccionar Impresora'
	_hmg_printer_usermessages [14] := 'Ordenar Copias'
	_hmg_printer_usermessages [15] := 'Rango de Impresin'
	_hmg_printer_usermessages [16] := 'Todo'
	_hmg_printer_usermessages [17] := 'Pginas'
	_hmg_printer_usermessages [18] := 'Desde'
	_hmg_printer_usermessages [19] := 'Hasta'
	_hmg_printer_usermessages [20] := 'Copias'
	_hmg_printer_usermessages [21] := 'Todo El Rango'
	_hmg_printer_usermessages [22] := 'Solo Pginas Impares'
	_hmg_printer_usermessages [23] := 'Solo Pginas Pares'
	_hmg_printer_usermessages [24] := 'Si'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Cerrar'
	_hmg_printer_usermessages [27] := 'Guardar'
	_hmg_printer_usermessages [28] := 'Miniaturas'
	_hmg_printer_usermessages [29] := 'Generando Miniaturas... Espere Por Favor...'

case cLang == "FI"        // Finnish
///////////////////////////////////////////////////////////////////////
// FINNISH
///////////////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Page'
	_hmg_printer_usermessages [02] := 'Print Preview'
	_hmg_printer_usermessages [03] := 'First Page [HOME]'
	_hmg_printer_usermessages [04] := 'Previous Page [PGUP]'
	_hmg_printer_usermessages [05] := 'Next Page [PGDN]'
	_hmg_printer_usermessages [06] := 'Last Page [END]'
	_hmg_printer_usermessages [07] := 'Go To Page'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Print'
	_hmg_printer_usermessages [10] := 'Page Number'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Cancel'
	_hmg_printer_usermessages [13] := 'Select Printer'
	_hmg_printer_usermessages [14] := 'Collate Copies'
	_hmg_printer_usermessages [15] := 'Print Range'
	_hmg_printer_usermessages [16] := 'All'
	_hmg_printer_usermessages [17] := 'Pages'
	_hmg_printer_usermessages [18] := 'From'
	_hmg_printer_usermessages [19] := 'To'
	_hmg_printer_usermessages [20] := 'Copies'
	_hmg_printer_usermessages [21] := 'All Range'
	_hmg_printer_usermessages [22] := 'Odd Pages Only'
	_hmg_printer_usermessages [23] := 'Even Pages Only'
	_hmg_printer_usermessages [24] := 'Yes'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Close'
	_hmg_printer_usermessages [27] := 'Save'
	_hmg_printer_usermessages [28] := 'Thumbnails'
	_hmg_printer_usermessages [29] := 'Generating Thumbnails... Please Wait...'

case cLang == "NL"        // Dutch
/////////////////////////////////////////////////////////////
// DUTCH
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Page'
	_hmg_printer_usermessages [02] := 'Print Preview'
	_hmg_printer_usermessages [03] := 'First Page [HOME]'
	_hmg_printer_usermessages [04] := 'Previous Page [PGUP]'
	_hmg_printer_usermessages [05] := 'Next Page [PGDN]'
	_hmg_printer_usermessages [06] := 'Last Page [END]'
	_hmg_printer_usermessages [07] := 'Go To Page'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Print'
	_hmg_printer_usermessages [10] := 'Page Number'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Cancel'
	_hmg_printer_usermessages [13] := 'Select Printer'
	_hmg_printer_usermessages [14] := 'Collate Copies'
	_hmg_printer_usermessages [15] := 'Print Range'
	_hmg_printer_usermessages [16] := 'All'
	_hmg_printer_usermessages [17] := 'Pages'
	_hmg_printer_usermessages [18] := 'From'
	_hmg_printer_usermessages [19] := 'To'
	_hmg_printer_usermessages [20] := 'Copies'
	_hmg_printer_usermessages [21] := 'All Range'
	_hmg_printer_usermessages [22] := 'Odd Pages Only'
	_hmg_printer_usermessages [23] := 'Even Pages Only'
	_hmg_printer_usermessages [24] := 'Yes'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Close'
	_hmg_printer_usermessages [27] := 'Save'
	_hmg_printer_usermessages [28] := 'Thumbnails'
	_hmg_printer_usermessages [29] := 'Generating Thumbnails... Please Wait...'

case cLang == "SLWIN" .OR. cLang == "SLISO" .OR. cLang == "SL852" .OR. cLang == "" .OR. cLang == "SL437" // Slovenian
/////////////////////////////////////////////////////////////
// SLOVENIAN
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Page'
	_hmg_printer_usermessages [02] := 'Print Preview'
	_hmg_printer_usermessages [03] := 'First Page [HOME]'
	_hmg_printer_usermessages [04] := 'Previous Page [PGUP]'
	_hmg_printer_usermessages [05] := 'Next Page [PGDN]'
	_hmg_printer_usermessages [06] := 'Last Page [END]'
	_hmg_printer_usermessages [07] := 'Go To Page'
	_hmg_printer_usermessages [08] := 'Zoom'
	_hmg_printer_usermessages [09] := 'Print'
	_hmg_printer_usermessages [10] := 'Page Number'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Cancel'
	_hmg_printer_usermessages [13] := 'Select Printer'
	_hmg_printer_usermessages [14] := 'Collate Copies'
	_hmg_printer_usermessages [15] := 'Print Range'
	_hmg_printer_usermessages [16] := 'All'
	_hmg_printer_usermessages [17] := 'Pages'
	_hmg_printer_usermessages [18] := 'From'
	_hmg_printer_usermessages [19] := 'To'
	_hmg_printer_usermessages [20] := 'Copies'
	_hmg_printer_usermessages [21] := 'All Range'
	_hmg_printer_usermessages [22] := 'Odd Pages Only'
	_hmg_printer_usermessages [23] := 'Even Pages Only'
	_hmg_printer_usermessages [24] := 'Yes'
	_hmg_printer_usermessages [25] := 'No'
	_hmg_printer_usermessages [26] := 'Close'
	_hmg_printer_usermessages [27] := 'Save'
	_hmg_printer_usermessages [28] := 'Thumbnails'
	_hmg_printer_usermessages [29] := 'Generating Thumbnails... Please Wait...'

case cLang == "SK" .OR. cLang == "SKWIN"   // Slovak
/////////////////////////////////////////////////////////////
// SLOVAK
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Strana'
	_hmg_printer_usermessages [02] := 'Nhad'
	_hmg_printer_usermessages [03] := 'Prv strana [HOME]'
	_hmg_printer_usermessages [04] := 'Predchzajca strana [PGUP]'
	_hmg_printer_usermessages [05] := 'alia strana [PGDN]'
	_hmg_printer_usermessages [06] := 'Posledn strana [END]'
	_hmg_printer_usermessages [07] := 'Uka stranu'
	_hmg_printer_usermessages [08] := 'Lupa'
	_hmg_printer_usermessages [09] := 'Tla'
	_hmg_printer_usermessages [10] := 'slo strany'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Storno'
	_hmg_printer_usermessages [13] := 'Vyberte tlaire'
	_hmg_printer_usermessages [14] := 'Zoradenie'
	_hmg_printer_usermessages [15] := 'Rozsah tlae'
	_hmg_printer_usermessages [16] := 'vetko'
	_hmg_printer_usermessages [17] := 'strany'
	_hmg_printer_usermessages [18] := 'od'
	_hmg_printer_usermessages [19] := 'po'
	_hmg_printer_usermessages [20] := 'kpi'
	_hmg_printer_usermessages [21] := 'vetky strany'
	_hmg_printer_usermessages [22] := 'neprn strany'
	_hmg_printer_usermessages [23] := 'prn strany'
	_hmg_printer_usermessages [24] := 'no'
	_hmg_printer_usermessages [25] := 'Nie'
	_hmg_printer_usermessages [26] := 'Zatvor'
	_hmg_printer_usermessages [27] := 'Ulo'
	_hmg_printer_usermessages [28] := 'Miniatury'
	_hmg_printer_usermessages [29] := 'Generujem miniatury... akajte, prosm...'

case cLang == "HU" .OR. cLang == "HUWIN"   // Hungarian
/////////////////////////////////////////////////////////////
// HUNGARIAN
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := 'Oldal'
	_hmg_printer_usermessages [02] := 'Elnzet'
	_hmg_printer_usermessages [03] := 'Els oldal [HOME]'
	_hmg_printer_usermessages [04] := 'Elz oldal [PGUP]'
	_hmg_printer_usermessages [05] := 'Kvetkez oldal [PGDN]'
	_hmg_printer_usermessages [06] := 'Utols oldal [END]'
	_hmg_printer_usermessages [07] := 'Oldalt mutasd'
	_hmg_printer_usermessages [08] := 'Nagyt'
	_hmg_printer_usermessages [09] := 'Nyomtasd'
	_hmg_printer_usermessages [10] := 'Oldal szma'
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := 'Elvets'
	_hmg_printer_usermessages [13] := 'Vlasszon nyomtatt'
	_hmg_printer_usermessages [14] := 'Rendezve'
	_hmg_printer_usermessages [15] := 'Oldalak nyomtatsa'
	_hmg_printer_usermessages [16] := 'mindent'
	_hmg_printer_usermessages [17] := 'Oldalakat'
	_hmg_printer_usermessages [18] := 'ettl'
	_hmg_printer_usermessages [19] := 'eddig'
	_hmg_printer_usermessages [20] := 'msolat'
	_hmg_printer_usermessages [21] := 'Minden oldalt'
	_hmg_printer_usermessages [22] := 'pros oldalakat'
	_hmg_printer_usermessages [23] := 'pratlan oldalakat'
	_hmg_printer_usermessages [24] := 'Igen'
	_hmg_printer_usermessages [25] := 'Nem'
	_hmg_printer_usermessages [26] := 'Zrd be'
	_hmg_printer_usermessages [27] := 'Mentsd'
	_hmg_printer_usermessages [28] := 'Miniatrk'
	_hmg_printer_usermessages [29] := 'Miniatrk ltrehozsa... Krem, vrjon...'

case cLang == "BGWIN" .OR. cLang == "BG866" 	// Bulgarian 
/////////////////////////////////////////////////////////////
// BULGARIAN
////////////////////////////////////////////////////////////

	_hmg_printer_usermessages [01] := ''
	_hmg_printer_usermessages [02] := ' '
	_hmg_printer_usermessages [03] := ' [HOME]'
	_hmg_printer_usermessages [04] := ' [PGUP]'
	_hmg_printer_usermessages [05] := ' [PGDN]'
	_hmg_printer_usermessages [06] := ' [END]'
	_hmg_printer_usermessages [07] := ' '
	_hmg_printer_usermessages [08] := ''
	_hmg_printer_usermessages [09] := ''
	_hmg_printer_usermessages [10] := ' '
	_hmg_printer_usermessages [11] := 'Ok'
	_hmg_printer_usermessages [12] := ''
	_hmg_printer_usermessages [13] := '  '
	_hmg_printer_usermessages [14] := '  '
	_hmg_printer_usermessages [15] := '  '
	_hmg_printer_usermessages [16] := ''
	_hmg_printer_usermessages [17] := ''
	_hmg_printer_usermessages [18] := ''
	_hmg_printer_usermessages [19] := ''
	_hmg_printer_usermessages [20] := ''
	_hmg_printer_usermessages [21] := ' '
	_hmg_printer_usermessages [22] := ' '
	_hmg_printer_usermessages [23] := ' '
	_hmg_printer_usermessages [24] := ''
	_hmg_printer_usermessages [25] := ''
	_hmg_printer_usermessages [26] := ''
	_hmg_printer_usermessages [27] := ''
	_hmg_printer_usermessages [28] := ''
	_hmg_printer_usermessages [29] := ',  ...'

endcase

#endif

Return

*------------------------------------------------------------------------------*
FUNCTION GETPRINTABLEAREAWIDTH()
*------------------------------------------------------------------------------*

	IF ! __MVEXIST ( '_hmg_printer_hdc' )
		RETURN 0
	ENDIF

RETURN _HMG_PRINTER_GETPRINTERWIDTH ( _hmg_printer_hdc )

*------------------------------------------------------------------------------*
FUNCTION GETPRINTABLEAREAHEIGHT()
*------------------------------------------------------------------------------*

	IF ! __MVEXIST ( '_hmg_printer_hdc' )
		RETURN 0
	ENDIF

RETURN _HMG_PRINTER_GETPRINTERHEIGHT ( _hmg_printer_hdc )

*------------------------------------------------------------------------------*
FUNCTION GETPRINTABLEAREAHORIZONTALOFFSET()
*------------------------------------------------------------------------------*

	IF ! __MVEXIST ( '_hmg_printer_hdc' )
		RETURN 0
	ENDIF

RETURN ( _HMG_PRINTER_GETPRINTABLEAREAPHYSICALOFFSETX ( _hmg_printer_hdc ) / _HMG_PRINTER_GETPRINTABLEAREALOGPIXELSX ( _hmg_printer_hdc ) * 25.4 )

*------------------------------------------------------------------------------*
FUNCTION GETPRINTABLEAREAVERTICALOFFSET()
*------------------------------------------------------------------------------*

	IF ! __MVEXIST ( '_hmg_printer_hdc' )
		RETURN 0
	ENDIF

RETURN ( _HMG_PRINTER_GETPRINTABLEAREAPHYSICALOFFSETY ( _hmg_printer_hdc ) / _HMG_PRINTER_GETPRINTABLEAREALOGPIXELSY ( _hmg_printer_hdc ) * 25.4 )

*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_MouseZoom
*------------------------------------------------------------------------------*
Local Width := GetDesktopWidth()
Local Height := GetDesktopHeight()
Local Q := 0
Local DeltaHeight := 35 + GetTitleHeight() + GetBorderHeight() + 10

	If _hmg_printer_Dz == 1000 + _HMG_PRINTER_DELTA_ZOOM

		_hmg_printer_Dz := 0
		_hmg_printer_Dx := 0
		_hmg_printer_Dy := 0

		SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 50 , 1 )
		SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 50 , 1 )

		_HMG_PRINTER_PREVIEW_DISABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	Else

		* Calculate Quadrant

		if	_HMG_MouseCol <= ( Width / 2 ) - _hmg_printer_zoomclick_xoffset ;
			.And. ;
			_HMG_MouseRow <= ( Height / 2 )	- DeltaHeight
		
			Q := 1

		Elseif	_HMG_MouseCol > ( Width / 2 ) - _hmg_printer_zoomclick_xoffset ;
			.And. ;
			_HMG_MouseRow <= ( Height / 2 )	- DeltaHeight
	
			Q := 2

		Elseif	_HMG_MouseCol <= ( Width / 2 ) - _hmg_printer_zoomclick_xoffset ;
			.And. ;
			_HMG_MouseRow > ( Height / 2 ) - DeltaHeight		
	
			Q := 3

		Elseif	_HMG_MouseCol > ( Width / 2 ) - _hmg_printer_zoomclick_xoffset ;
			.And. ;
			_HMG_MouseRow > ( Height / 2 ) - DeltaHeight		
	
			Q := 4

		EndIf

		if	_HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) ;
			> ;
			_HMG_PRINTER_GETPAGEWIDTH(_hmg_printer_hdc_bak) 

			* Portrait

			If Q == 1 
				_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
				_hmg_printer_Dx := 100
				_hmg_printer_Dy := 400
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 10 , 1 )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 40 , 1 )
			ElseIf Q == 2
				_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
				_hmg_printer_Dx := -100
				_hmg_printer_Dy := 400
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 10 , 1 )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 60 , 1 )
			ElseIf Q == 3
				_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
				_hmg_printer_Dx := 100
				_hmg_printer_Dy := -400
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 90 , 1 )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 40 , 1 )
			ElseIf Q == 4
				_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
				_hmg_printer_Dx := -100
				_hmg_printer_Dy := -400
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 90 , 1 )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 60 , 1 )
			EndIf				

		Else

			* Landscape

			If Q == 1 
				_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
				_hmg_printer_Dx := 500
				_hmg_printer_Dy := 300
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 20 , 1 )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 1 , 1 )
			ElseIf Q == 2
				_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
				_hmg_printer_Dx := -500
				_hmg_printer_Dy := 300
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 20 , 1 )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 99 , 1 )
			ElseIf Q == 3
				_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
				_hmg_printer_Dx := 500
				_hmg_printer_Dy := -300
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 80 , 1 )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 1 , 1 )
			ElseIf Q == 4
				_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
				_hmg_printer_Dx := -500
				_hmg_printer_Dy := -300
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 80 , 1 )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 99 , 1 )
			EndIf				

		EndIf

		_HMG_PRINTER_PREVIEW_ENABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	EndIf

	_HMG_PRINTER_PREVIEWRefresh()

Return

*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_Zoom
*------------------------------------------------------------------------------*

	If _hmg_printer_Dz == 1000 + _HMG_PRINTER_DELTA_ZOOM

		_hmg_printer_Dz := 0
		_hmg_printer_Dx := 0
		_hmg_printer_Dy := 0

		SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 50 , 1 )
		SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 50 , 1 )

		_HMG_PRINTER_PREVIEW_DISABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	Else

		if	_HMG_PRINTER_GETPAGEHEIGHT(_hmg_printer_hdc_bak) ;
			> ;
			_HMG_PRINTER_GETPAGEWIDTH(_hmg_printer_hdc_bak) 

			_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
			_hmg_printer_Dx := 100
			_hmg_printer_Dy := 400
			SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 10 , 1 )
			SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 40 , 1 )

		Else

			_hmg_printer_Dz := 1000 + _HMG_PRINTER_DELTA_ZOOM
			_hmg_printer_Dx := 500
			_hmg_printer_Dy := 300
			SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 20 , 1 )
			SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 1 , 1 )

		EndIf

		_HMG_PRINTER_PREVIEW_ENABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	EndIf

	_HMG_PRINTER_PREVIEWRefresh()

Return

*------------------------------------------------------------------------------*
Function _hmg_printer_setjobname( cName )
*------------------------------------------------------------------------------*
return( if( valtype ( cName ) = 'U', 'Harbour MiniGUI Print System', cName ) )
