

#define _WIN32_IE 0x0500
#define HB_OS_WIN_32_USED
#define _WIN32_WINNT 0x0400
#include <shlobj.h>

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"
#include "winreg.h"
#include "tchar.h"

#include "hbapifs.h"
#include "hbstack.h"
#include "item.api"

BOOL Array2Rect( PHB_ITEM aRect, RECT * rc );
PHB_ITEM HB_EXPORT   Rect2Array( RECT *rc );

/*
BOOL Array2Rect(PHB_ITEM aRect, RECT *rc )
{
   if (HB_IS_ARRAY(aRect) && hb_arrayLen(aRect) == 4) {
      rc->left   = hb_arrayGetNL(aRect,1);
      rc->top    = hb_arrayGetNL(aRect,2);
      rc->right  = hb_arrayGetNL(aRect,3);
      rc->bottom = hb_arrayGetNL(aRect,4);
      return TRUE ;
   }
   return FALSE;
}

PHB_ITEM Rect2Array( RECT *rc  )
{
   PHB_ITEM aRect = hb_itemArrayNew(4);
   PHB_ITEM element = hb_itemNew(NULL);

   hb_arraySet(aRect, 1, hb_itemPutNL(element, rc->left));
   hb_arraySet(aRect, 2, hb_itemPutNL(element, rc->top));
   hb_arraySet(aRect, 3, hb_itemPutNL(element, rc->right));
   hb_arraySet(aRect, 4, hb_itemPutNL(element, rc->bottom));
   hb_itemRelease(element);
   return aRect;
}

PHB_ITEM Point2Array( POINT *pt  )
{
   PHB_ITEM aPoint = hb_itemArrayNew(2);
   PHB_ITEM element = hb_itemNew(NULL);

   hb_arraySet(aPoint, 1, hb_itemPutNL(element, pt->x));
   hb_arraySet(aPoint, 2, hb_itemPutNL(element, pt->y));
   hb_itemRelease(element);
   return aPoint;
}
*/

HB_FUNC( SYSREFRESH )
{
   MSG   Msg;

   while( PeekMessage((LPMSG) & Msg, 0, 0, 0, PM_REMOVE) )
   {
      TranslateMessage( &Msg );
      DispatchMessage( &Msg );
   }
}

HB_FUNC( NMAKELONG )
{
   hb_retnl( MAKELONG(hb_parni(1), hb_parni(2)) );
}

HB_FUNC( LAND )
{
   hb_retl( hb_parni(1) & hb_parni(2) );
}

HB_FUNC( NOR )
{
   int   p = hb_pcount();
   int   n, ret = 0;

   for( n = 1; n <= p; n++ )
   {
      ret = ret | hb_parni( n );
   }

   hb_retni( ret );
}

HB_FUNC( CREATEPEN )
{
   HPEN     hpen;
   int      fnPenStyle = hb_parni( 1 );   // pen style
   int      nWidth = hb_parni( 2 );       // pen width
   COLORREF crColor = hb_parni( 3 );      // pen color
   hpen = CreatePen( fnPenStyle, nWidth, crColor );

   hb_retnl( (LONG) hpen );
}

HB_FUNC( MOVETO ) //MoveTo( HDC hDC, int ix, int iy )
{
   POINT pt;

   MoveToEx( (HDC) hb_parnl(1), (INT) hb_parni(2), (INT) hb_parni(3), &pt );
}

HB_FUNC( LINETO ) //LineTo( HDC hDC, int ix, int iy )
{
   LineTo( (HDC) hb_parnl(1), (INT) hb_parni(2), (INT) hb_parni(3) );
}

HB_FUNC( DRAWICON )
{
   hb_retl( DrawIcon((HDC) hb_parnl(1), hb_parni(2), hb_parni(3), (HICON) hb_parnl(4)) );
}
/*
HB_FUNC( CURSORWAIT )
{
   hb_retnl( ( long ) SetCursor(LoadCursor(0, IDC_WAIT)) );
}

HB_FUNC( CURSORHAND )
{
   hb_retnl( ( long ) SetCursor(LoadCursor(0, IDC_HAND)) );
}
*/
HB_FUNC( CURSORWE )
{
   hb_retnl( ( long ) SetCursor(LoadCursor(0, IDC_SIZEWE)) );
}

HB_FUNC( CURSORSIZE )
{
   hb_retnl( ( long ) SetCursor(LoadCursor(0, IDC_SIZEALL)) );
}

HB_FUNC( RELEASECAPTURE )
{
   hb_retl( ReleaseCapture() );
}

HB_FUNC( INVERTRECT )
{
   RECT  rc;

   if( ISARRAY(2) )
   {
      Array2Rect( hb_param(2, HB_IT_ARRAY), &rc );
      InvertRect( (HDC) hb_parnl(1), &rc );
   }
}

HB_FUNC( BEGINPAINT )
{
   PAINTSTRUCT pps;
   hb_retnl( (LONG) BeginPaint((HWND) hb_parnl(1), &pps) );
   hb_storclen( ( char * ) &pps, sizeof(PAINTSTRUCT), 2 );
}

HB_FUNC( ENDPAINT )
{
   hb_retl( EndPaint((HWND) hb_parnl(1), ( PAINTSTRUCT * ) hb_parc(2)) );
}

HB_FUNC( GETSCROLLRANGE )
{
   LPINT lpMinPos = 0;
   LPINT lpMaxPos = 0;

   if( GetScrollRange((HWND) hb_parnl(1), hb_parni(2), lpMinPos, lpMaxPos) )
   {
      if( ISBYREF(3) && ISBYREF(4) )
      {
         hb_storni( 3, *lpMinPos );
         hb_storni( 4, *lpMaxPos );
         hb_retl( 1 );
      }
      else
      {
         hb_retl( 0 );
      }
   }
   else
   {
      hb_retl( 0 );
   }
}

HB_FUNC( GETCLASSINFO )
{
   WNDCLASS WndClass;

   if( GetClassInfo(ISNIL(1) ? NULL : (HINSTANCE) hb_parnl(1), (LPCSTR) hb_parc(2), &WndClass) )
   {
      hb_retclen( ( char * ) &WndClass, sizeof(WNDCLASS) );
   }
}

HB_FUNC( _GETCLIENTRECT )
{
   RECT     rc;

   PHB_ITEM aMetr;
   GetClientRect( (HWND) hb_parnl(1), &rc );

   aMetr = Rect2Array( &rc );

   _itemReturn( aMetr );
   _itemRelease( aMetr );
}

HB_FUNC( ISICONIC )
{
   hb_retl( IsIconic((HWND) hb_parnl(1)) );
}

HB_FUNC( SETCAPTURE )
{
   hb_retnl( (LONG) SetCapture((HWND) hb_parnl(1)) );
}

HB_FUNC( GETWINDOWLONG )
{
   hb_retnl( GetWindowLong((HWND) hb_parnl(1), hb_parni(2)) );
}

HB_FUNC( SETWINDOWLONG )
{
   hb_retnl( SetWindowLong((HWND) hb_parnl(1), hb_parni(2), hb_parnl(3)) );
}

HB_FUNC( GETTEXTCOLOR )
{
   hb_retnl( (ULONG) GetTextColor((HDC) hb_parnl(1)) );
}

HB_FUNC( GETBKCOLOR )
{
   hb_retnl( (ULONG) GetBkColor((HDC) hb_parnl(1)) );
}

HB_FUNC( LOADIMAGE )
{
   HWND  himage;

   himage = ( HWND ) LoadImage( GetModuleHandle(0), hb_parc(1), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_LOADMAP3DCOLORS );

   if( himage == NULL )
   {
      himage = ( HWND ) LoadImage( GetModuleHandle(NULL), hb_parc(1), IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS );
   }

   hb_retnl( (LONG) himage );
}

HB_FUNC( GETSYSMETRICS )
{
   int   nVal;
   int   nIndex = hb_parni( 1 );

   switch( nIndex )
   {
      case 0:  nVal = GetSystemMetrics( SM_CXSCREEN ); break;
      case 1:  nVal = GetSystemMetrics( SM_CYSCREEN ); break;
   }

   hb_retni( nVal );
}

HB_FUNC( MOVEFILE )
{
   hb_retl( (BOOL) MoveFile(hb_parc(1), hb_parc(2)) );
}

HB_FUNC( GETACP )
{
   hb_retni( ( int ) GetACP() );
}
