/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

 Parts of this code is contributed and used here under permission of his author:
       Copyright 2005 (C) Jacek Kubica <kubica@wssk.wroc.pl>
---------------------------------------------------------------------------*/

#define _WIN32_IE 0x0500
#define HB_OS_WIN_32_USED
#define _WIN32_WINNT 0x0400
#include <shlobj.h>

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"
#include "item.api"
#include "winuser.h"
#include "Wingdi.h"

LRESULT CALLBACK  OwnButtonProc( HWND hbutton, UINT msg, WPARAM wParam, LPARAM lParam );

HB_FUNC( INITBUTTON )
{
   HWND  hwnd;
   HWND  hbutton;
   int   Style;

   hwnd = ( HWND ) hb_parnl( 1 );

   Style = BS_NOTIFY | WS_CHILD;

   if( hb_parl(10) )
   {
      Style = Style | BS_FLAT;
   }

   if( !hb_parl(11) )
   {
      Style = Style | WS_TABSTOP;
   }

   if( !hb_parl(12) )
   {
      Style = Style | WS_VISIBLE;
   }

   if ( hb_parl (13) )
   {
      Style = Style | BS_MULTILINE ;
   }

   //JK

   if( !hb_parl(14) )
   {
      Style = Style | BS_PUSHBUTTON;
   }
   else
   {
      Style = Style | BS_DEFPUSHBUTTON;
   }

   hbutton = CreateWindow
      (
         "button",
         hb_parc(2),
         Style,
         hb_parni(4),
         hb_parni(5),
         hb_parni(6),
         hb_parni(7),
         hwnd,
         (HMENU) hb_parni(3),
         GetModuleHandle(NULL),
         NULL
      );

   hb_retnl( (LONG) hbutton );
}

HB_FUNC( INITIMAGEBUTTON )
{
   HWND  hwnd;
   HWND  hbutton;
   HWND  himage;
   HICON hIcon;
   int   Style;
   int   ImgStyle;

   hwnd = ( HWND ) hb_parnl( 1 );

   Style = BS_NOTIFY | WS_CHILD;

   //JK

   if( hb_parc(14) == NULL )
   {
      Style = Style | BS_BITMAP;
   }
   else
   {
      Style = Style | BS_ICON;
   }

   if( hb_parl(9) )
   {
      Style = Style | BS_FLAT;
   }

   if( !hb_parl(11) )
   {
      Style = Style | WS_VISIBLE;
   }

   if( !hb_parl(12) )
   {
      Style = Style | WS_TABSTOP;
   }

   //JK

   if( !hb_parl(13) )
   {
      Style = Style | BS_PUSHBUTTON;
   }
   else
   {
      Style = Style | BS_DEFPUSHBUTTON;
   }

   hbutton = CreateWindow
      (
         "button",
         hb_parc(2),
         Style,
         hb_parni(4),
         hb_parni(5),
         hb_parni(6),
         hb_parni(7),
         hwnd,
         (HMENU) hb_parni(3),
         GetModuleHandle(NULL),
         NULL
      );

   if( hb_parl(10) )
   {
      ImgStyle = 0;
   }
   else
   {
      ImgStyle = LR_LOADTRANSPARENT;
   }

   if( hb_parc(14) == NULL )
   {
      himage = ( HWND ) LoadImage( GetModuleHandle(0), hb_parc(8), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_LOADMAP3DCOLORS | ImgStyle );

      if( himage == NULL )
      {
         himage = ( HWND ) LoadImage( GetModuleHandle(NULL), hb_parc(8), IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS | ImgStyle );
      }

      SendMessage( hbutton, (UINT) BM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) himage );

      hb_reta( 2 );
      hb_stornl( (LONG) hbutton, -1, 1 );
      hb_stornl( (LONG) himage, -1, 2 );
   }
   else
   {
      hIcon = ( HICON ) LoadImage( GetModuleHandle(0), hb_parc(14), IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTCOLOR );

      if( hIcon == NULL )
      {
         hIcon = ( HICON ) LoadImage( GetModuleHandle(NULL), hb_parc(14), IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR );
      }

      SendMessage( hbutton, (UINT) BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) hIcon );

      hb_reta( 2 );
      hb_stornl( (LONG) hbutton, -1, 1 );
      hb_stornl( (LONG) hIcon, -1, 2 );
   }
}

HB_FUNC( INITOWNERBUTTON )
{
   HWND  hwnd;
   HWND  hbutton;
   HWND  himage;
   HICON hIcon;
   int   Style;
   int   ImgStyle;

   hwnd = ( HWND ) hb_parnl( 1 );

   Style = BS_NOTIFY | WS_CHILD | BS_OWNERDRAW;
   if( hb_parc(14) == NULL )
   {
      Style = Style | BS_BITMAP;
   }
   else
   {
      Style = Style | BS_ICON;
   }

   if( hb_parl(9) )
   {
      Style = Style | BS_FLAT;
   }

   if( !hb_parl(11) )
   {
      Style = Style | WS_VISIBLE;
   }

   if( !hb_parl(12) )
   {
      Style = Style | WS_TABSTOP;
   }

   if( !hb_parl(13) )
   {
      Style = Style | BS_PUSHBUTTON;
   }
   else
   {
      Style = Style | BS_DEFPUSHBUTTON;
   }

   hbutton = CreateWindow
      (
         "button",
         hb_parc(2),
         Style,
         hb_parni(4),
         hb_parni(5),
         hb_parni(6),
         hb_parni(7),
         hwnd,
         (HMENU) hb_parni(3),
         GetModuleHandle(NULL),
         NULL
      );

   SetProp( (HWND) hbutton, "oldbtnproc", (HWND) GetWindowLong((HWND) hbutton, GWL_WNDPROC) );
   SetWindowLong( hbutton, GWL_WNDPROC, (LONG) (WNDPROC) OwnButtonProc );

   if( hb_parl(10) )
   {
      ImgStyle = 0;
   }
   else
   {
      ImgStyle = LR_LOADTRANSPARENT;
   }

   if( hb_parc(14) == NULL )
   {
      himage = ( HWND ) LoadImage( GetModuleHandle(0), hb_parc(8), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_LOADMAP3DCOLORS | ImgStyle );

      if( himage == NULL )
      {
         himage = ( HWND ) LoadImage( GetModuleHandle(NULL), hb_parc(8), IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS | ImgStyle );
      }

      hb_reta( 2 );
      hb_stornl( (LONG) hbutton, -1, 1 );
      hb_stornl( (LONG) himage, -1, 2 );
   }
   else
   {
      hIcon = ( HICON ) LoadImage( GetModuleHandle(0), hb_parc(14), IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTCOLOR );

      if( hIcon == NULL )
      {
         hIcon = ( HICON ) LoadImage( GetModuleHandle(NULL), hb_parc(14), IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR );
      }

      hb_reta( 2 );
      hb_stornl( (LONG) hbutton, -1, 1 );
      hb_stornl( (LONG) hIcon, -1, 2 );
   }
}

HB_FUNC( _SETBTNPICTURE )
{
   HWND  hwnd;
   HWND  himage;

   hwnd = ( HWND ) hb_parnl( 1 );

   himage = ( HWND ) LoadImage( 0, hb_parc(2), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );

   if( himage == NULL )
   {
      himage = ( HWND ) LoadImage( GetModuleHandle(NULL), hb_parc(2), IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );
   }

   SendMessage( hwnd, (UINT) BM_SETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) himage );

   hb_retnl( (LONG) himage );
}

HB_FUNC( _GETBTNPICTUREHANDLE )
{
   HWND  hwnd;
   HWND  himage = 0;

   hwnd = ( HWND ) hb_parnl( 1 );

   himage = ( HWND ) SendMessage( hwnd, (UINT) BM_GETIMAGE, (WPARAM) IMAGE_BITMAP, (LPARAM) himage );

   hb_retnl( (LONG) himage );
}

// HMG 1.0 Experimental Build 8e

HB_FUNC( _SETBTNICON )
{
   HWND  hwnd;
   HICON hIcon;

   hwnd = ( HWND ) hb_parnl( 1 );

   hIcon = ( HICON ) LoadImage( GetModuleHandle(NULL), hb_parc(2), IMAGE_ICON, 0, 0, LR_LOADFROMFILE | LR_DEFAULTCOLOR );

   if( hIcon == NULL )
   {
      hIcon = ( HICON ) LoadImage( GetModuleHandle(NULL), hb_parc(2), IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR );
   }

   SendMessage( hwnd, (UINT) BM_SETIMAGE, (WPARAM) IMAGE_ICON, (LPARAM) hIcon );

   hb_retnl( (LONG) hIcon );
}

HB_FUNC( DRAWBUTTON )
{
   RECT           rc;
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 4 );
   HDC            hDC;
   HPEN           OldPen;
   HBRUSH         OldBrush;

   UINT           iFocus = hb_parni( 2 );
   UINT           iState = hb_parni( 3 );
   UINT           iMouseOver = hb_parni( 5 );
   UINT           iFlat = hb_parni( 6 );

   rc = pps->rcItem;
   hDC = pps->hDC;

   if( iFocus == 1 || iMouseOver == 1 )
   {
      // deflate rectangle

      rc.left = rc.left + 1;
      rc.top = rc.top + 1;
      rc.right = rc.right - 1;
      rc.bottom = rc.bottom - 1;
   }

   if( !iFlat )
   {
      DrawFrameControl( hDC, &rc, DFC_BUTTON, iState );
   }
   else
   {
      FillRect( hDC, &rc, (HBRUSH) (COLOR_3DDKSHADOW + 1) );
      rc.left++;
      rc.top++;
      rc.right--;
      rc.bottom--;
      FillRect( hDC, &rc, (HBRUSH) (COLOR_3DHILIGHT + 1) );
      rc.left++;
      rc.top++;
      rc.right--;
      rc.bottom--;
      FillRect( hDC, &rc, (HBRUSH) (COLOR_3DFACE + 1) );
      rc.left--;
      rc.top--;
      rc.right++;
      rc.bottom++;
      rc.left--;
      rc.top--;
      rc.right++;
      rc.bottom++;
   }

   if( iFocus == 1 )
   {
      // inflate rectangle

      rc.left = rc.left - 1;
      rc.top = rc.top - 1;
      rc.right = rc.right + 1;
      rc.bottom = rc.bottom + 1;

      OldBrush = SelectObject( hDC, GetStockObject(NULL_BRUSH) );
      OldPen = SelectObject( hDC, GetStockObject(BLACK_PEN) );
      Rectangle( hDC, rc.left, rc.top, rc.right, rc.bottom );
      SelectObject( hDC, OldBrush );
      SelectObject( hDC, OldPen );
   }

   if( iFocus == 1 || iMouseOver == 1 )
   {
      rc.left = rc.left + 1;
      rc.top = rc.top + 1;
      rc.right = rc.right - 1;
      rc.bottom = rc.bottom - 1;
   }
}

HB_FUNC( DRAWFOCUSRECT )
{
   RECT           rc;
   HDC            hDC;
   HPEN           OldPen;
   HBRUSH         OldBrush;
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 1 );
   rc = pps->rcItem;
   hDC = pps->hDC;
   rc.left = rc.left + 3;
   rc.top = rc.top + 3;
   rc.right = rc.right - 3;
   rc.bottom = rc.bottom - 3;
   OldBrush = SelectObject( hDC, GetStockObject(NULL_BRUSH) );
   OldPen = SelectObject( hDC, GetStockObject(BLACK_PEN) );
   DrawFocusRect( hDC, &rc );
   rc.left = rc.left - 3;
   rc.top = rc.top - 3;
   rc.right = rc.right + 3;
   rc.bottom = rc.bottom + 3;
   pps->rcItem = rc;
   SelectObject( hDC, OldBrush );
   SelectObject( hDC, OldPen );
}

/*
Function GETOWNBTNHANDLE return value of hwndItem DRAWITEMSTRUCT member
*/

HB_FUNC( GETOWNBTNHANDLE )
{
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 1 );
   if( pps )
   {
      hb_retnl( (LONG) pps->hwndItem );
   }
}

/*
Function GETOWNBTNSTATE return value of itemState DRAWITEMSTRUCT member
*/

HB_FUNC( GETOWNBTNSTATE )
{
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 1 );
   if( pps )
   {
      hb_retnl( (LONG) pps->itemState );
   }
}

/*
Function GETOWNBTNDC return value of hDC DRAWITEMSTRUCT member
*/

HB_FUNC( GETOWNBTNDC )
{
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 1 );
   if( pps )
   {
      hb_retnl( (LONG) pps->hDC );
   }
}

HB_FUNC( GETOWNBTNITEMID )
{
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 1 );
   if( pps )
   {
      hb_retnl( (LONG) pps->itemID );
   }
}

/*
Function GETOWNBTNITEMACTION return value of itemAction DRAWITEMSTRUCT member
*/

HB_FUNC( GETOWNBTNITEMACTION )
{
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 1 );
   if( pps )
   {
      hb_retnl( (LONG) pps->itemAction );
   }
}

/*
Function GETOWNBTNCTLTYPE return value of CtlType DRAWITEMSTRUCT member
*/

HB_FUNC( GETOWNBTNCTLTYPE )
{
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 1 );
   if( pps )
   {
      hb_retni( (UINT) pps->CtlType );
   }
}

/*
Function GETOWNBTNRECT (pDis) return array with button rectangle coords
*/

HB_FUNC( GETOWNBTNRECT )
{
   RECT           rc;
   PHB_ITEM       aMetr = _itemArrayNew( 4 );
   PHB_ITEM       temp;
   DRAWITEMSTRUCT *pps = ( DRAWITEMSTRUCT * ) hb_parnl( 1 );
   rc = pps->rcItem;

   temp = _itemPutNL( NULL, rc.left );
   _itemArrayPut( aMetr, 1, temp );
   _itemRelease( temp );

   temp = _itemPutNL( NULL, rc.top );
   _itemArrayPut( aMetr, 2, temp );
   _itemRelease( temp );

   temp = _itemPutNL( NULL, rc.right );
   _itemArrayPut( aMetr, 3, temp );
   _itemRelease( temp );

   temp = _itemPutNL( NULL, rc.bottom );
   _itemArrayPut( aMetr, 4, temp );
   _itemRelease( temp );

   _itemReturn( aMetr );
   _itemRelease( aMetr );
}

LRESULT CALLBACK OwnButtonProc( HWND hButton, UINT Msg, WPARAM wParam, LPARAM lParam )
{
   static PHB_SYMB   pSymbol = NULL;
   long int          r;
   TRACKMOUSEEVENT   tme;
   WNDPROC           OldWndProc;

   OldWndProc = ( WNDPROC ) GetProp( hButton, "oldbtnproc" );

   switch( Msg )
   {
      case WM_LBUTTONDBLCLK:
         {
            SendMessage( hButton, WM_LBUTTONDOWN, wParam, lParam );
            break;
         }

      case WM_MOUSEMOVE:
         {
            tme.cbSize = sizeof( TRACKMOUSEEVENT );
            tme.dwFlags = TME_LEAVE;
            tme.hwndTrack = hButton;
            tme.dwHoverTime = 0;
            _TrackMouseEvent( &tme );

            if( !pSymbol )
            {
               pSymbol = hb_dynsymSymbol( hb_dynsymGet("OBTNEVENTS") );
            }

            if( pSymbol )
            {
               hb_vmPushSymbol( pSymbol );
               hb_vmPushNil();
               hb_vmPushLong( (LONG) hButton );
               hb_vmPushLong( Msg );
               hb_vmPushLong( wParam );
               hb_vmPushLong( lParam );
               hb_vmDo( 4 );
            }

            r = hb_parnl( -1 );

            if( r != 0 )
            {
               return r;
            }
            else
            {
               return( DefWindowProc(hButton, Msg, wParam, lParam) );
            }
         }

      case WM_MOUSELEAVE:
         {
            if( !pSymbol )
            {
               pSymbol = hb_dynsymSymbol( hb_dynsymGet("OBTNEVENTS") );
            }

            if( pSymbol )
            {
               hb_vmPushSymbol( pSymbol );
               hb_vmPushNil();
               hb_vmPushLong( (LONG) hButton );
               hb_vmPushLong( Msg );
               hb_vmPushLong( wParam );
               hb_vmPushLong( lParam );
               hb_vmDo( 4 );
            }

            r = hb_parnl( -1 );

            if( r != 0 )
            {
               return r;
            }
            else
            {
               return( DefWindowProc(hButton, Msg, wParam, lParam) );
            }
         }
   }

   return( CallWindowProc(OldWndProc, hButton, Msg, wParam, lParam) );
}
