/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#define _WIN32_IE 0x0500
#define HB_OS_WIN_32_USED
#define _WIN32_WINNT 0x0400
#include <shlobj.h>

#if !defined( __POCC__ )
#if defined( __MINGW32__ )
#define UDM_GETPOS32 0x0472
#define UDM_SETPOS32 0x0471
#endif
#if defined( _MSC_VER )
#define UDM_SETPOS32 ( WM_USER + 113 )
#define UDM_GETPOS32 ( WM_USER + 114 )
#endif
#endif
#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"

#ifdef MAKELONG
#undef MAKELONG
#endif
#define MAKELONG( a, b )   ( (LONG) (((WORD) ((DWORD_PTR) (a) & 0xffff)) | (((DWORD) ((WORD) ((DWORD_PTR) (b) & 0xffff))) << 16)) )

HB_FUNC( DELETEOBJECT )
{
   hb_retl( DeleteObject((HGDIOBJ) hb_parnl(1)) );
}

HB_FUNC( CSHOWCONTROL )
{
   ShowWindow( (HWND) hb_parnl(1), SW_SHOW );
}

/*
31/10/2005

*/

HB_FUNC( INITTOOLTIP )
{
   if( hb_parl(3) )
   {
      HWND  htooltip;
      int   Style = TTS_ALWAYSTIP;

      if( hb_parl(2) )
      {
         Style = Style | TTS_BALLOON;
      }

      InitCommonControls();

      htooltip = CreateWindowEx( 0, "tooltips_class32", "", Style, 0, 0, 0, 0, (HWND) hb_parnl(1), (HMENU) 0, GetModuleHandle(NULL), NULL );

      hb_retnl( (LONG) htooltip );
   }
}

HB_FUNC( SETTOOLTIP )
{
   static TOOLINFO   ti;

   HWND              hWnd;
   char              *Text;
   HWND              hWnd_ToolTip;

   hWnd = ( HWND ) hb_parnl( 1 );
   Text = hb_parc( 2 );
   hWnd_ToolTip = ( HWND ) hb_parnl( 3 );

   memset( &ti, 0, sizeof(ti) );

   ti.cbSize = sizeof( ti );
   ti.uFlags = TTF_SUBCLASS | TTF_IDISHWND;
   ti.hwnd = GetParent( hWnd );
   ti.uId = ( UINT ) hWnd;

   if( SendMessage(hWnd_ToolTip, (UINT) TTM_GETTOOLINFO, (WPARAM) 0, (LPARAM) & ti) )
   {
      SendMessage( hWnd_ToolTip, (UINT) TTM_DELTOOL, (WPARAM) 0, (LPARAM) & ti );
   }

   ti.cbSize = sizeof( ti );
   ti.uFlags = TTF_SUBCLASS | TTF_IDISHWND;
   ti.hwnd = GetParent( hWnd );
   ti.uId = ( UINT ) hWnd;
   ti.lpszText = Text;
   SendMessage( hWnd_ToolTip, (UINT) TTM_ADDTOOL, (WPARAM) 0, (LPARAM) & ti );

   hb_retni( 0 );
}

HB_FUNC( HIDEWINDOW )
{
   ShowWindow( (HWND) hb_parnl(1), SW_HIDE );
}

HB_FUNC( CHECKDLGBUTTON )
{
   CheckDlgButton( (HWND) hb_parnl(2), hb_parni(1), BST_CHECKED );
}

HB_FUNC( UNCHECKDLGBUTTON )
{
   CheckDlgButton( (HWND) hb_parnl(2), hb_parni(1), BST_UNCHECKED );
}

HB_FUNC( SETDLGITEMTEXT )
{
   SetDlgItemText( (HWND) hb_parnl(3), hb_parni(1), (LPCTSTR) hb_parc(2) );
}

HB_FUNC( SETFOCUS )
{
   hb_retnl( (LONG) SetFocus((HWND) hb_parnl(1)) );
}

/*
HB_FUNC ( GETDLGITEMTEXT )
{
   USHORT iLen = 32768;
   char *cText = (char*) hb_xgrab( iLen+1 );

   GetDlgItemText(
   (HWND) hb_parnl (2),   // handle of dialog box
   hb_parni(1),      // identifier of control
   (LPTSTR) cText,          // address of buffer for text
   iLen                      // maximum size of string
   );

   hb_retc( cText );
   hb_xfree( cText );
}

HB_FUNC ( ISDLGBUTTONCHECKED )
{
   UINT r ;

   r = IsDlgButtonChecked( (HWND) hb_parnl (2), hb_parni( 1 ) );

   if ( r == BST_CHECKED )
   {
      hb_retl( TRUE );
   }
   else
   {
      hb_retl( FALSE );
   }
}
*/

HB_FUNC( SETSPINNERVALUE )
{
   SendMessage( (HWND) hb_parnl(1), (UINT) UDM_SETPOS32, (WPARAM) 0, (LPARAM) (INT) hb_parni(2) );
}

HB_FUNC( GETSPINNERVALUE )
{
   hb_retnl( SendMessage((HWND) hb_parnl(1), (UINT) UDM_GETPOS32, (WPARAM) 0, (LPARAM) 0) );
}

HB_FUNC( INSERTTAB )
{
   keybd_event
   (
      VK_TAB,           // virtual-key code
      0,                // hardware scan code
      0,                // flags specifying various function options
      0                 // additional data associated with keystroke
   );
}

HB_FUNC( INSERTSHIFTTAB )
{
   keybd_event
   (
      VK_SHIFT,         // virtual-key code
      0,                // hardware scan code
      0,                // flags specifying various function options
      0                 // additional data associated with keystroke
   );

   keybd_event
   (
      VK_TAB,           // virtual-key code
      0,                // hardware scan code
      0,                // flags specifying various function options
      0                 // additional data associated with keystroke
   );

   keybd_event
   (
      VK_SHIFT,         // virtual-key code
      0,                // hardware scan code
      KEYEVENTF_KEYUP,  // flags specifying various function options
      0                 // additional data associated with keystroke
   );
}

HB_FUNC( RELEASECONTROL )
{
   SendMessage( (HWND) hb_parnl(1), WM_SYSCOMMAND, SC_CLOSE, 0 );
}

HB_FUNC( INSERTBACKSPACE )
{
   keybd_event
   (
      VK_BACK,          // virtual-key code
      0,                // hardware scan code
      0,                // flags specifying various function options
      0                 // additional data associated with keystroke
   );
}

HB_FUNC( INSERTPOINT )
{
   keybd_event
   (
      VK_DECIMAL,       // virtual-key code
      0,                // hardware scan code
      0,                // flags specifying various function options
      0                 // additional data associated with keystroke
   );
}

HB_FUNC( SETCURSORPOS )
{
   SetCursorPos( hb_parni(1), hb_parni(2) );
}

HB_FUNC( SHOWCURSOR )
{
   hb_retni( ShowCursor(hb_parl(1)) );
}

HB_FUNC( SYSTEMPARAMETERSINFO )
{
   if( SystemParametersInfoA((UINT) hb_parni(1), (UINT) hb_parni(2), ( VOID * ) hb_parc(3), (UINT) hb_parni(4)) )
   {
      hb_retl( TRUE );
   }
   else
   {
      hb_retl( FALSE );
   }
}

HB_FUNC( GETTEXTWIDTH ) // returns the width of a string in pixels
{
   HDC   hDC = ( HDC ) hb_parnl( 1 );
   HWND  hWnd;
   DWORD dwSize;
   BOOL  bDestroyDC = FALSE;
   HFONT hFont = ( HFONT ) hb_parnl( 3 );
   HFONT hOldFont;
   SIZE  sz;

   if( !hDC )
   {
      bDestroyDC = TRUE;
      hWnd = GetActiveWindow();
      hDC = GetDC( hWnd );
   }

   if( hFont )
   {
      hOldFont = ( HFONT ) SelectObject( hDC, hFont );
   }

   GetTextExtentPoint32( hDC, hb_parc(2), hb_parclen(2), &sz );
   dwSize = sz.cx;

   if( hFont )
   {
      SelectObject( hDC, hOldFont );
   }

   if( bDestroyDC )
   {
      ReleaseDC( hWnd, hDC );
   }

   hb_retni( LOWORD(dwSize) );
}

HB_FUNC( KEYBD_EVENT )
{
   keybd_event
   (
      (BYTE) hb_parni(1),                    // virtual-key code
      (BYTE) MapVirtualKey(hb_parni(1), 0),  // hardware scan code
      hb_parl(2) ? KEYEVENTF_KEYUP : 0,      // flags specifying various function options
      0           // additional data associated with keystroke
   );
}

HB_FUNC( INSERTRETURN )
{
   keybd_event
   (
      VK_RETURN,  // virtual-key code
      0,          // hardware scan code
      0,          // flags specifying various function options
      0           // additional data associated with keystroke
   );
}

HB_FUNC( GETEXEFILENAME )
{
   unsigned char  pBuf[250];

   GetModuleFileName( GetModuleHandle(NULL), (LPTSTR) pBuf, 249 );

   hb_retc( ( char * ) pBuf );
}

HB_FUNC( _HMG_SETVSCROLLVALUE )
{
   SendMessage( (HWND) hb_parnl(1), WM_VSCROLL, MAKEWPARAM(SB_THUMBPOSITION, hb_parni(2)), 0 );
}

HB_FUNC( _HMG_SETHSCROLLVALUE )
{
   SendMessage( (HWND) hb_parnl(1), WM_HSCROLL, MAKEWPARAM(SB_THUMBPOSITION, hb_parni(2)), 0 );
}

HB_FUNC( SHOWCARET )
{
   hb_retl( ShowCaret((HWND) hb_parnl(1)) );
}

HB_FUNC( HIDECARET )
{
   hb_retl( HideCaret((HWND) hb_parnl(1)) );
}

HB_FUNC( DESTROYCARET )
{
   hb_retl( DestroyCaret() );
}

HB_FUNC( CREATECARET )
{
   hb_retl( CreateCaret((HWND) hb_parnl(1), (HBITMAP) hb_parnl(2), ( int ) hb_parni(3), ( int ) hb_parni(4)) );
}

/*
CHANGESTYLE (hWnd,dwAdd,dwRemove,bEx)
Action: Modifies the basic styles of a window
Parameters: hWnd - handle to window
            dwAdd - window styles to add
            dwRemove - window styles to remove
            bEx - TRUE for Extended style otherwise FALSE
HMG 1.1 Expermental Build 12a
(C)Jacek Kubica <kubica@wssk.wroc.pl>
*/

HB_FUNC( CHANGESTYLE )
{
   HWND  hWnd = ( HWND ) hb_parnl( 1 );
   DWORD dwAdd = hb_parnl( 2 );
   DWORD dwRemove = hb_parnl( 3 );
   BOOL  bEx = hb_parl( 4 );
   DWORD dwStyle, dwNewStyle;

   dwStyle = GetWindowLong( hWnd, (bEx ? GWL_EXSTYLE : GWL_STYLE) );
   dwNewStyle = ( dwStyle & (~dwRemove) ) | dwAdd;

   hb_retnl( SetWindowLongPtr(hWnd, (bEx ? GWL_EXSTYLE : GWL_STYLE), dwNewStyle) );
   SetWindowPos( (HWND) hb_parnl(1), NULL, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOZORDER );
}
