/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#define _WIN32_IE 0x0500
#define HB_OS_WIN_32_USED
#define _WIN32_WINNT 0x0400
#include <shlobj.h>

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"
#include "hbvm.h"
#include "hbstack.h"
#include "hbapiitm.h"

#ifdef MAKELONG
#undef MAKELONG
#endif
#define MAKELONG( a, b )   ( (LONG) (((WORD) ((DWORD_PTR) (a) & 0xffff)) | (((DWORD) ((WORD) ((DWORD_PTR) (b) & 0xffff))) << 16)) )

HB_FUNC( INITLISTVIEW )
{
   HWND                 hwnd;
   HWND                 hbutton;
   int                  style;

   INITCOMMONCONTROLSEX i;

   i.dwSize = sizeof( INITCOMMONCONTROLSEX );
   i.dwICC = ICC_DATE_CLASSES;
   InitCommonControlsEx( &i );

   hwnd = ( HWND ) hb_parnl( 1 );

   if( hb_parl(12) )
   {
      style = LVS_SHOWSELALWAYS | WS_CHILD | WS_VISIBLE | LVS_REPORT;
   }
   else
   {
      style = LVS_SHOWSELALWAYS | WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_SINGLESEL;
   }

   if( !hb_parl(14) )
   {
      style = style | WS_TABSTOP;
   }

   if( !hb_parl(13) )
   {
      style = style | LVS_NOCOLUMNHEADER;
   }

   if( hb_parl(10) )
   {
      style = style | LVS_OWNERDATA;
   }

   hbutton = CreateWindowEx
      (
         WS_EX_CLIENTEDGE,
         "SysListView32",
         "",
         style,
         hb_parni(3),
         hb_parni(4),
         hb_parni(5),
         hb_parni(6),
         hwnd,
         (HMENU) hb_parni(2),
         GetModuleHandle(NULL),
         NULL
      );

   SendMessage( hbutton, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, hb_parni(9) | LVS_EX_FULLROWSELECT | LVS_EX_HEADERDRAGDROP );

   if( hb_parl(10) )
   {
      ListView_SetItemCount( hbutton, hb_parni(11) );
   }

   hb_retnl( (LONG) hbutton );
}

HB_FUNC( LISTVIEW_SETITEMCOUNT )
{
   ListView_SetItemCount( (HWND) hb_parnl(1), hb_parni(2) );
}

HB_FUNC( ADDLISTVIEWBITMAP )        // Grid+
{
   HWND        hbutton;
   HIMAGELIST  himl;
   HBITMAP     hbmp;
   PHB_ITEM    hArray;
   char        *caption;
   int         l9;
   int         s;
   int         cx;
   int         cy;

   hbutton = ( HWND ) hb_parnl( 1 );
   l9 = hb_parinfa( 2, 0 ) - 1;
   hArray = hb_param( 2, HB_IT_ARRAY );

   cx = 0;
   if( l9 != 0 )
   {
      caption = hb_arrayGetCPtr( hArray, 1 );

      himl = ImageList_LoadImage( GetModuleHandle(NULL), caption, 0, l9, CLR_NONE, IMAGE_BITMAP, LR_LOADTRANSPARENT );

      if( himl == NULL )
      {
         himl = ImageList_LoadImage( GetModuleHandle(NULL), caption, 0, l9, CLR_NONE, IMAGE_BITMAP, LR_LOADTRANSPARENT | LR_LOADFROMFILE );
      }

      ImageList_GetIconSize( himl, &cx, &cy );

      for( s = 1; s <= l9; s = s + 1 )
      {
         caption = hb_arrayGetCPtr( hArray, s + 1 );

         hbmp = ( HBITMAP ) LoadImage( GetModuleHandle(NULL), caption, IMAGE_BITMAP, cx, cy, LR_LOADTRANSPARENT );
         if( hbmp == NULL )
         {
            hbmp = ( HBITMAP ) LoadImage( GetModuleHandle(NULL), caption, IMAGE_BITMAP, cx, cy, LR_LOADTRANSPARENT | LR_LOADFROMFILE );
         }

         ImageList_Add( himl, hbmp, NULL );
         DeleteObject( hbmp );
      }

      if( himl != NULL )
      {
         SendMessage( hbutton, LVM_SETIMAGELIST, (WPARAM) LVSIL_SMALL, (LPARAM) himl );
      }
   }

   hb_retni( (INT) cx );
}

HB_FUNC( ADDLISTVIEWBITMAPHEADER )  // Grid+
{
   HWND        hheader;
   HIMAGELIST  himl;
   HBITMAP     hbmp;
   PHB_ITEM    hArray;
   char        *caption;
   int         l9;
   int         s;
   int         cx;
   int         cy;

   hheader = ListView_GetHeader( (HWND) hb_parnl(1) );

   if( hheader )
   {
      l9 = hb_parinfa( 2, 0 ) - 1;
      hArray = hb_param( 2, HB_IT_ARRAY );

      if( l9 != 0 )
      {
         caption = hb_arrayGetCPtr( hArray, 1 );

         // Determine Image Size Based Upon First Image

         himl = ImageList_LoadImage
            (
               GetModuleHandle(NULL),
               caption,
               0,
               l9,
               CLR_DEFAULT,
               IMAGE_BITMAP,
               LR_LOADTRANSPARENT | LR_DEFAULTCOLOR | LR_LOADMAP3DCOLORS
            );

         if( himl == NULL )
         {
            himl = ImageList_LoadImage
               (
                  GetModuleHandle(NULL),
                  caption,
                  0,
                  l9,
                  CLR_DEFAULT,
                  IMAGE_BITMAP,
                  LR_LOADTRANSPARENT | LR_LOADFROMFILE | LR_DEFAULTCOLOR | LR_LOADMAP3DCOLORS
               );
         }

         ImageList_GetIconSize( himl, &cx, &cy );

         ImageList_Destroy( himl );

         himl = ImageList_Create( cx, cy, ILC_COLOR8 | ILC_MASK, l9 + 1, l9 + 1 );

         for( s = 0; s <= l9; s++ )
         {
            caption = hb_arrayGetCPtr( hArray, s + 1 );

            hbmp = ( HBITMAP ) LoadImage
               (
                  GetModuleHandle(NULL),
                  caption,
                  IMAGE_BITMAP,
                  cx,
                  cy,
                  LR_LOADTRANSPARENT | LR_DEFAULTCOLOR | LR_LOADMAP3DCOLORS
               );
            if( hbmp == NULL )
            {
               hbmp = ( HBITMAP ) LoadImage
                  (
                     GetModuleHandle(NULL),
                     caption,
                     IMAGE_BITMAP,
                     cx,
                     cy,
                     LR_LOADTRANSPARENT | LR_LOADFROMFILE | LR_DEFAULTCOLOR | LR_LOADMAP3DCOLORS
                  );
            }

            ImageList_AddMasked( himl, hbmp, CLR_DEFAULT );
            DeleteObject( hbmp );
         }

         if( himl != NULL )
         {
            SendMessage( hheader, HDM_SETIMAGELIST, 0, (LPARAM) himl );
         }
      }
   }

   hb_retnl( (LONG) himl );
}

HB_FUNC( LISTVIEW_GETFIRSTITEM )
{
   hb_retni( ListView_GetNextItem((HWND) hb_parnl(1), -1, LVNI_ALL | LVNI_SELECTED) + 1 );
}
/* code INITLISTVIEWCOLUMNS function  borrowed from ooHG */
HB_FUNC( INITLISTVIEWCOLUMNS )
{
   PHB_ITEM wArray;
   PHB_ITEM hArray;
   PHB_ITEM jArray;

   HWND hc;
   LV_COLUMN COL;
   int iLen;
   int s;
   int iColumn = 0;

   hc = ( HWND ) hb_parnl( 1 );

   iLen = hb_parinfa( 2, 0 ) - 1;
   hArray = hb_param( 2, HB_IT_ARRAY );
   wArray = hb_param( 3, HB_IT_ARRAY );
   jArray = hb_param( 4, HB_IT_ARRAY );

   COL.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

   for( s = 0; s <= iLen; s++ )
   {
      COL.fmt = hb_arrayGetNI( jArray, s + 1 );
      COL.cx = hb_arrayGetNI( wArray, s + 1 );
      COL.pszText = hb_arrayGetCPtr( hArray, s + 1 );
      COL.iSubItem = iColumn;
      ListView_InsertColumn( hc, iColumn, &COL );
      if( iColumn == 0 && COL.fmt != LVCFMT_LEFT )
      {
         iColumn++;
         COL.iSubItem = iColumn;
         ListView_InsertColumn( hc, iColumn, &COL );
      }
      iColumn++;
   }

   if( iColumn != s )
   {
      ListView_DeleteColumn( hc, 0 );
   }
}

HB_FUNC( ADDLISTVIEWITEMS )
{
   PHB_ITEM hArray;
   char     *caption;
   LV_ITEM  LI;
   HWND     h;
   int      l;
   int      s;
   int      c;

   h = ( HWND ) hb_parnl( 1 );
   l = hb_parinfa( 2, 0 ) - 1;
   hArray = hb_param( 2, HB_IT_ARRAY );
   c = ListView_GetItemCount( h );

   caption = hb_arrayGetCPtr( hArray, 1 );

   LI.mask = LVIF_TEXT | LVIF_IMAGE;            // Browse+
   LI.state = 0;
   LI.stateMask = 0;
   LI.iImage = hb_parni( 3 );                   // Browse+
   LI.iSubItem = 0;
   LI.iItem = c;
   LI.pszText = caption;
   ListView_InsertItem( h, &LI );

   for( s = 1; s <= l; s = s + 1 )
   {
      caption = hb_arrayGetCPtr( hArray, s + 1 );
      ListView_SetItemText( h, c, s, caption );
   }
}

HB_FUNC( LISTVIEW_SETCURSEL )
{
   ListView_SetItemState( (HWND) hb_parnl(1), (WPARAM) hb_parni(2) - 1, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
}

HB_FUNC( LISTVIEWDELETESTRING )
{
   SendMessage( (HWND) hb_parnl(1), LVM_DELETEITEM, (WPARAM) hb_parni(2) - 1, 0 );
}

HB_FUNC( LISTVIEWRESET )
{
   SendMessage( (HWND) hb_parnl(1), LVM_DELETEALLITEMS, 0, 0 );
}

HB_FUNC( LISTVIEWGETMULTISEL )
{
   HWND  hwnd = ( HWND ) hb_parnl( 1 );
   int   i;
   int   n;
   int   j;

   n = SendMessage( hwnd, LVM_GETSELECTEDCOUNT, 0, 0 );

   hb_reta( n );

   i = -1;
   j = 0;

   while( 1 )
   {
      i = ListView_GetNextItem( (HWND) hb_parnl(1), i, LVNI_ALL | LVNI_SELECTED );

      if( i == -1 )
      {
         break;
      }
      else
      {
         j++;
      }

      hb_storni( i + 1, -1, j );
   }
}

HB_FUNC( LISTVIEWSETMULTISEL )
{
   PHB_ITEM wArray;

   HWND     hwnd = ( HWND ) hb_parnl( 1 );

   int      i;
   int      l;
   int      n;

   wArray = hb_param( 2, HB_IT_ARRAY );

   l = hb_parinfa( 2, 0 ) - 1;

   n = SendMessage( hwnd, LVM_GETITEMCOUNT, 0, 0 );

   // CLEAR CURRENT SELECTIONS

   for( i = 0; i < n; i++ )
   {
      ListView_SetItemState( (HWND) hb_parnl(1), (WPARAM) i, 0, LVIS_FOCUSED | LVIS_SELECTED );
   }

   // SET NEW SELECTIONS

   for( i = 0; i <= l; i++ )
   {
      ListView_SetItemState( (HWND) hb_parnl(1), hb_arrayGetNI(wArray, i + 1) - 1, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED );
   }
}

HB_FUNC( LISTVIEWSETITEM )
{
   PHB_ITEM hArray;
   char     *caption;
   HWND     h;
   int      l;
   int      s;
   int      c;

   h = ( HWND ) hb_parnl( 1 );
   l = hb_parinfa( 2, 0 ) - 1;
   hArray = hb_param( 2, HB_IT_ARRAY );
   c = hb_parni( 3 ) - 1;

   for( s = 0; s <= l; s = s + 1 )
   {
      caption = hb_arrayGetCPtr( hArray, s + 1 );
      ListView_SetItemText( h, c, s, caption );
   }
}

HB_FUNC( LISTVIEWGETITEM )
{
   char  string[1024] = "";
   HWND  h;
   int   s;
   int   c;
   int   l;

   h = ( HWND ) hb_parnl( 1 );

   c = hb_parni( 2 ) - 1;

   l = hb_parni( 3 );

   hb_reta( l );

   for( s = 0; s <= l - 1; s++ )
   {
      ListView_GetItemText( h, c, s, string, 1024 );
      hb_storc( string, -1, s + 1 );
   }
}

HB_FUNC( LISTVIEWGETITEMROW )
{
   POINT point;

   ListView_GetItemPosition( (HWND) hb_parnl(1), hb_parni(2), &point );

   hb_retnl( point.y );
}

HB_FUNC( LISTVIEWGETITEMCOUNT )
{
   hb_retnl( ListView_GetItemCount((HWND) hb_parnl(1)) );
}

HB_FUNC( SETGRIDCOLUMNHEADER )
{
   LV_COLUMN   COL;

   COL.mask = LVCF_FMT | LVCF_TEXT;
   COL.pszText = hb_parc( 3 );
   COL.fmt = hb_parni( 4 );

   ListView_SetColumn( (HWND) hb_parnl(1), hb_parni(2) - 1, &COL );
}

HB_FUNC( SETGRIDCOLUMNHEADERIMAGE )
{
   LV_COLUMN   COL;

   COL.mask = LVCF_FMT | LVCF_IMAGE;

   if( hb_parl(4) )
   {
      COL.fmt = LVCFMT_IMAGE | LVCFMT_COL_HAS_IMAGES | LVCFMT_BITMAP_ON_RIGHT;
   }
   else
   {
      COL.fmt = LVCFMT_IMAGE | LVCFMT_COL_HAS_IMAGES;
   }

   COL.iImage = hb_parni( 3 ) - 1;

   ListView_SetColumn( (HWND) hb_parnl(1), hb_parni(2) - 1, &COL );
}

HB_FUNC( LISTVIEWGETCOUNTPERPAGE )
{
   hb_retnl( ListView_GetCountPerPage((HWND) hb_parnl(1)) );
}

HB_FUNC( LISTVIEW_ENSUREVISIBLE )
{
   ListView_EnsureVisible( (HWND) hb_parnl(1), hb_parni(2) - 1, 1 );
}

HB_FUNC( SETIMAGELISTVIEWITEMS )
{
   LV_ITEM  LI;
   HWND     h;

   h = ( HWND ) hb_parnl( 1 );

   LI.mask = LVIF_IMAGE;      // Browse+
   LI.state = 0;
   LI.stateMask = 0;
   LI.iImage = hb_parni( 3 ); // Browse+
   LI.iSubItem = 0;
   LI.iItem = hb_parni( 2 ) - 1;

   ListView_SetItem( h, &LI );
}

HB_FUNC( GETIMAGELISTVIEWITEMS )
{
   LV_ITEM  LI;
   HWND     h;
   int      i;

   h = ( HWND ) hb_parnl( 1 );

   LI.mask = LVIF_IMAGE;      // Browse+
   LI.state = 0;
   LI.stateMask = 0;
   LI.iSubItem = 0;
   LI.iItem = hb_parni( 2 ) - 1;

   ListView_GetItem( h, &LI );
   i = LI.iImage;

   hb_retni( i );
}

HB_FUNC( LISTVIEW_GETTOPINDEX )
{
   hb_retnl( ListView_GetTopIndex((HWND) hb_parnl(1)) );
}

HB_FUNC( LISTVIEW_REDRAWITEMS )
{
   hb_retnl( ListView_RedrawItems((HWND) hb_parnl(1), hb_parni(2), hb_parni(3)) );
}

HB_FUNC( LISTVIEW_HITTEST )
{
   POINT          point;
   LVHITTESTINFO  lvhti;

   point.y = hb_parni( 2 );
   point.x = hb_parni( 3 );

   lvhti.pt = point;

   ListView_SubItemHitTest( (HWND) hb_parnl(1), &lvhti );

   if( lvhti.flags & LVHT_ONITEM )
   {
      hb_reta( 2 );
      hb_storni( lvhti.iItem + 1, -1, 1 );
      hb_storni( lvhti.iSubItem + 1, -1, 2 );
   }
   else
   {
      hb_reta( 2 );
      hb_storni( 0, -1, 1 );
      hb_storni( 0, -1, 2 );
   }
}

HB_FUNC( LISTVIEW_GETSUBITEMRECT )
{
   RECT  Rect;

   ListView_GetSubItemRect( (HWND) hb_parnl(1), hb_parni(2), hb_parni(3), LVIR_BOUNDS, &Rect );

   hb_reta( 4 );
   hb_storni( Rect.top, -1, 1 );
   hb_storni( Rect.left, -1, 2 );
   hb_storni( Rect.right - Rect.left, -1, 3 );
   hb_storni( Rect.bottom - Rect.top, -1, 4 );
}

HB_FUNC( LISTVIEW_GETITEMRECT )
{
   RECT  Rect;

   ListView_GetItemRect( (HWND) hb_parnl(1), hb_parni(2), &Rect, LVIR_LABEL );

   hb_reta( 4 );
   hb_storni( Rect.top, -1, 1 );
   hb_storni( Rect.left, -1, 2 );
   hb_storni( Rect.right - Rect.left, -1, 3 );
   hb_storni( Rect.bottom - Rect.top, -1, 4 );
}

HB_FUNC( LISTVIEW_UPDATE )
{
   ListView_Update( (HWND) hb_parnl(1), hb_parni(2) - 1 );
}

HB_FUNC( LISTVIEW_SCROLL )
{
   ListView_Scroll( (HWND) hb_parnl(1), hb_parni(2), hb_parni(3) );
}

HB_FUNC( LISTVIEW_SETBKCOLOR )
{
   ListView_SetBkColor( (HWND) hb_parnl(1), (COLORREF) RGB(hb_parni(2), hb_parni(3), hb_parni(4)) );
}

HB_FUNC( LISTVIEW_SETTEXTBKCOLOR )
{
   ListView_SetTextBkColor( (HWND) hb_parnl(1), (COLORREF) RGB(hb_parni(2), hb_parni(3), hb_parni(4)) );
}

HB_FUNC( LISTVIEW_SETTEXTCOLOR )
{
   ListView_SetTextColor( (HWND) hb_parnl(1), (COLORREF) RGB(hb_parni(2), hb_parni(3), hb_parni(4)) );
}

HB_FUNC( LISTVIEW_GETTEXTCOLOR )
{
   hb_retnl( ListView_GetTextColor((HWND) hb_parnl(1)) );
}

HB_FUNC( LISTVIEW_GETBKCOLOR )
{
   hb_retnl( ListView_GetBkColor((HWND) hb_parnl(1)) );
}

HB_FUNC( LISTVIEW_GETCOLUMNWIDTH )
{
   hb_retni( ListView_GetColumnWidth((HWND) hb_parnl(1), hb_parni(2)) );
}

HB_FUNC( LISTVIEW_ADDCOLUMN )
{
   LV_COLUMN   COL;

   PHB_ITEM    pValue = hb_itemNew( NULL );
   hb_itemCopy( pValue, hb_param(4, HB_IT_STRING) );

   COL.mask = LVCF_WIDTH | LVCF_TEXT | LVCF_FMT | LVCF_SUBITEM;
   COL.cx = hb_parni( 3 );
   COL.pszText = hb_itemGetCPtr( pValue );
   COL.iSubItem = hb_parni( 2 ) - 1;
   COL.fmt = hb_parni( 5 );

   ListView_InsertColumn( (HWND) hb_parnl(1), hb_parni(2) - 1, &COL );

   SendMessage( (HWND) hb_parnl(1), LVM_DELETEALLITEMS, 0, 0 );

   RedrawWindow( (HWND) hb_parnl(1), NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_ALLCHILDREN | RDW_ERASENOW | RDW_UPDATENOW );
}

HB_FUNC( LISTVIEW_DELETECOLUMN )
{
   ListView_DeleteColumn( (HWND) hb_parnl(1), hb_parni(2) - 1 );
   SendMessage( (HWND) hb_parnl(1), LVM_DELETEALLITEMS, 0, 0 );
   RedrawWindow( (HWND) hb_parnl(1), NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_ALLCHILDREN | RDW_ERASENOW | RDW_UPDATENOW );
}

// (JK) HMG Experimental Build 6

HB_FUNC( LISTVIEW_SETCOLUMNWIDTH )
{
   hb_retl( ListView_SetColumnWidth((HWND) hb_parnl(1), hb_parni(2), hb_parni(3)) );
}

HB_FUNC( LISTVIEW_SETCOLUMNWIDTHAUTO )
{
   hb_retl( ListView_SetColumnWidth((HWND) hb_parnl(1), hb_parni(2), LVSCW_AUTOSIZE) );
}

HB_FUNC( LISTVIEW_SETCOLUMNWIDTHAUTOH )
{
   hb_retl( ListView_SetColumnWidth((HWND) hb_parnl(1), hb_parni(2), LVSCW_AUTOSIZE_USEHEADER) );
}
