/*----------------------------------------------------------------------------
 MINIGUI - Harbour Win32 GUI library source code

 Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
 http://harbourminigui.googlepages.com/

 IMAGELIST control source code
 (C)2005 Janusz Pora <januszpora@onet.eu>

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text 
 contained in this release of Harbour Minigui.

 The exception is that, if you link the Harbour Minigui library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 Harbour-Minigui library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net> 

	"HWGUI"
  	Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#define _WIN32_IE 0x0500
#define HB_OS_WIN_32_USED
#define _WIN32_WINNT 0x0400
#include <shlobj.h>

#include <windows.h>
#include <commctrl.h>
#include "hbapi.h"

WINCOMMCTRLAPI void WINAPI ImageList_EndDrag( void );

HB_FUNC( INITIMAGELIST )   //InitImageList ( cx , cy, mask , nCount )
{
   HIMAGELIST  himlIcons;
   UINT        Styl = ILC_COLOR8;

   if( hb_parl(3) )
   {
      Styl = Styl | ILC_MASK;
   }

   InitCommonControls();

   himlIcons = ImageList_Create( (INT) hb_parni(1), (INT) hb_parni(2), Styl, (INT) hb_parni(4), 0 );

   hb_retnl( (LONG) himlIcons );
}

HB_FUNC( IL_ADD )          //IL_Add( hwnd , image ,maskimage ,ix , iy , imagecount)
{
   BITMAP   bm;
   HBITMAP  himage1; // handle to image
   HBITMAP  himage2; // handle to maskimage
   LRESULT  lResult = -1;
   int      ic = 1;

   if( hb_parni(6) )
   {
      ic = hb_parni( 6 );
   }

   himage1 = ( HBITMAP ) LoadImage( 0, hb_parc(2), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );
   if( himage1 == NULL )
   {
      himage1 = ( HBITMAP ) LoadImage( GetModuleHandle(NULL), hb_parc(2), IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );
   }

   himage2 = 0;
   if( strlen(hb_parc(3)) )
   {
      himage2 = ( HBITMAP ) LoadImage( 0, hb_parc(3), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );
      if( himage2 == NULL )
      {
         himage2 = ( HBITMAP ) LoadImage( GetModuleHandle(NULL), hb_parc(3), IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );
      }
   }

   if( GetObject(himage1, sizeof(BITMAP), &bm) != 0 )
   {
      if( (hb_parni(4) * ic == bm.bmWidth) & (hb_parni(5) == bm.bmHeight) )
      {
         lResult = ImageList_Add( (HIMAGELIST) hb_parnl(1), himage1, himage2 );
      }
   }

   hb_retni( lResult );
}

HB_FUNC( IL_ADDMASKED ) //IL_AddMasked( hwnd , image ,color ,ix , iy , imagecount)
{
   BITMAP   bm;
   HBITMAP  himage1; // handle to image
   COLORREF clrBk = CLR_NONE;
   LRESULT  lResult = -1;
   int      ic = 1;

   if( hb_parnl(3) )
   {
      clrBk = ( COLORREF ) hb_parnl( 3 );
   }

   if( hb_parni(6) )
   {
      ic = hb_parni( 6 );
   }

   himage1 = ( HBITMAP ) LoadImage( 0, hb_parc(2), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );
   if( himage1 == NULL )
   {
      himage1 = ( HBITMAP ) LoadImage( GetModuleHandle(NULL), hb_parc(2), IMAGE_BITMAP, 0, 0, LR_LOADMAP3DCOLORS | LR_LOADTRANSPARENT );
   }

   if( GetObject(himage1, sizeof(BITMAP), &bm) != 0 )
   {
      if( (hb_parni(4) * ic == bm.bmWidth) & (hb_parni(5) == bm.bmHeight) )
      {
         lResult = ImageList_AddMasked( (HIMAGELIST) hb_parnl(1), himage1, clrBk );
      }
   }

   hb_retni( lResult );
}

HB_FUNC( IL_DRAW )            //BOOL IL_Draw(HWND hwnd, HIMAGELIST himl, int imageindex, cx , cy)
{
   HDC   hdc;
   HWND  hwnd = ( HWND ) hb_parnl( 1 );

   if( (hdc = GetDC(hwnd)) == NULL )
   {
      hb_retl( FALSE );
   }

   if( !ImageList_Draw((HIMAGELIST) hb_parnl(2), (INT) hb_parni(3), hdc, hb_parni(4), hb_parni(5), ILD_TRANSPARENT) )
   {
      hb_retl( FALSE );
   }

   ReleaseDC( hwnd, hdc );

   hb_retl( TRUE );
}

HB_FUNC( IL_REMOVE )          //IL_Remove( hwnd , imageindex  )
{
   HIMAGELIST  himlIcons;
   LRESULT     lResult;

   himlIcons = ( HIMAGELIST ) hb_parnl( 1 );

   lResult = ImageList_Remove( himlIcons, (INT) hb_parni(2) );
   if( lResult )
   {
      hb_retl( TRUE );
   }
   else
   {
      hb_retl( FALSE );
   }
}

HB_FUNC( IL_DESTROY )         //IL_Destroy( hwnd )
{
   HIMAGELIST  himlIcons;
   LRESULT     lResult;

   himlIcons = ( HIMAGELIST ) hb_parnl( 1 );

   lResult = ImageList_Destroy( himlIcons );
   if( lResult )
   {
      hb_retl( TRUE );
   }
   else
   {
      hb_retl( FALSE );
   }
}

HB_FUNC( IL_SETBKCOLOR )      //IL_SetBkColor( hwnd , color)
{
   COLORREF clrBk = CLR_NONE;

   if( hb_parnl(2) )
   {
      clrBk = hb_parnl( 2 );
   }

   hb_retnl( (COLORREF) ImageList_SetBkColor((HIMAGELIST) hb_parnl(1), clrBk) );
}

HB_FUNC( IL_ERASEIMAGE )      //IL_EraseImage( hwnd , ix, iy ,dx, dy)
{
   RECT  rcImage;

   SetRect( &rcImage, hb_parni(2), hb_parni(3), hb_parni(4) + hb_parni(2), hb_parni(5) + hb_parni(3) );

   InvalidateRect( (HWND) hb_parnl(1), &rcImage, TRUE );
   UpdateWindow( (HWND) hb_parnl(1) );
}

HB_FUNC( IL_BEGINDRAG )       //IL_BeginDrag( hwnd ,himl, ImageInx, ix, iy )
{
   LRESULT  lResult;
   INT      cx;
   INT      cy;
   RECT     rcImage;

   if( ImageList_GetIconSize((HIMAGELIST) hb_parnl(2), &cx, &cy) )
   {
      SetRect( &rcImage, hb_parni(4) - 2, hb_parni(5) - 2, hb_parni(4) + cx + 2, hb_parni(5) + cy + 2 );
      InvalidateRect( (HWND) hb_parnl(1), &rcImage, TRUE );
      UpdateWindow( (HWND) hb_parnl(1) );
   }

   lResult = ImageList_BeginDrag( (HIMAGELIST) hb_parnl(2), (INT) hb_parni(3), (INT) 0, (INT) 0 );
   if( lResult )
   {
      hb_retl( TRUE );
   }
   else
   {
      hb_retl( FALSE );
   }
}

HB_FUNC( IL_DRAGMOVE )        //IL_DragMove( ix, iy )
{
   LRESULT  lResult;

   lResult = ImageList_DragMove( (INT) hb_parni(1), (INT) hb_parni(2) );
   if( lResult )
   {
      hb_retl( TRUE );
   }
   else
   {
      hb_retl( FALSE );
   }
}

HB_FUNC( IL_DRAGENTER )       //IL_DragEnter( hvnd, ix, iy )
{
   LRESULT  lResult;

   lResult = ImageList_DragEnter( (HWND) hb_parnl(1), (INT) hb_parni(2), (INT) hb_parni(3) );

   if( lResult )
   {
      hb_retl( TRUE );
   }
   else
   {
      hb_retl( FALSE );
   }
}

HB_FUNC( IL_ENDDRAG )         //IL_EndDrag(hwnd )
{
   ImageList_EndDrag();
   ImageList_DragLeave( (HWND) hb_parnl(1) );
}

HB_FUNC( IL_GETIMAGECOUNT )   //IL_GetImageCount(himl )
{
   hb_retni( ImageList_GetImageCount((HIMAGELIST) hb_parnl(1)) );
}

HB_FUNC( IL_ADDINDIRECT )     //IL_AddIndirect( hwnd , himage ,maskimage ,ix , iy , imagecount)
{
   BITMAP   bm;
   HBITMAP  himage1 = ( HBITMAP ) hb_parnl( 2 );   // handle to image
   HBITMAP  himage2 = ( HBITMAP ) hb_parnl( 3 );   // handle to maskimage
   LRESULT  lResult = -1;
   int      ic = 1;

   if( hb_parni(6) )
   {
      ic = hb_parni( 6 );
   }

   if( GetObject(himage1, sizeof(BITMAP), &bm) != 0 )
   {
      if( (hb_parni(4) * ic == bm.bmWidth) & (hb_parni(5) == bm.bmHeight) )
      {
         lResult = ImageList_Add( (HIMAGELIST) hb_parnl(1), himage1, himage2 );
      }
   }

   hb_retni( lResult );
}

HB_FUNC( IL_ADDMASKEDINDIRECT )  //IL_AddMaskedIndirect( hwnd , himage ,color ,ix , iy , imagecount)
{
   BITMAP   bm;
   COLORREF clrBk = CLR_NONE;
   LRESULT  lResult = -1;
   int      ic = 1;

   if( hb_parnl(3) )
   {
      clrBk = ( COLORREF ) hb_parnl( 3 );
   }

   if( hb_parni(6) )
   {
      ic = hb_parni( 6 );
   }

   if( GetObject((HBITMAP) hb_parnl(2), sizeof(BITMAP), &bm) != 0 )
   {
      if( (hb_parni(4) * ic == bm.bmWidth) & (hb_parni(5) == bm.bmHeight) )
      {
         lResult = ImageList_AddMasked( (HIMAGELIST) hb_parnl(1), (HBITMAP) hb_parnl(2), clrBk );
      }
   }

   hb_retni( lResult );
}
