/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include 'minigui.ch'

#define PBM_GETPOS 1032
#define BM_GETCHECK   240
#define BM_SETCHECK   241
#define BST_UNCHECKED   0
#define BST_CHECKED      1
#define BST_INDETERMINATE   2
#define EM_GETSEL   176
#define EM_SETSEL   177
#define TBM_SETPOS 1029
#define TBM_GETPOS 1024
#define PBM_SETPOS 1026
#define EM_SETBKGNDCOLOR   1091
#define WM_SETREDRAW 0x0b
#define COLOR_WINDOW      5
#define COLOR_WINDOWTEXT  8
#define COLOR_3DFACE     15
#define WS_DISABLED   134217728

#ifdef _TSBROWSE_
   MEMVAR _TSB_aControlhWnd
#endif

Memvar aResult
*-----------------------------------------------------------------------------*
Function _GetValue ( ControlName, ParentForm , Index )
*-----------------------------------------------------------------------------*
   Local retval /*, h*/ , t , x , c , d , bd , ix , oGet, auxval , WorkArea , BackRec , rcount , Tmp , Ts

   retval := 0

   If Pcount() == 2

      If Upper (ControlName) == 'VSCROLLBAR'

         Return GetScrollPos ( GetFormHandle ( ParentForm )  , 1 )

      EndIf

      If Upper (ControlName) == 'HSCROLLBAR'

         Return GetScrollPos ( GetFormHandle ( ParentForm )  , 0 )

      EndIf

      T := GetControlType (ControlName,ParentForm)
//      h := GetControlParentHandle (ControlName,ParentForm)
      c := GetControlHandle (ControlName,ParentForm)
      ix := GetControlIndex ( ControlName, ParentForm )

   Else

      T := _HMG_aControlType [ Index ]
//      h := _HMG_aControlParentHandles [ Index ]
      c := _HMG_aControlHandles [ Index ]
      ix := Index

   EndIf

   do case

   case T == "BROWSE"

      retval := _BrowseGetValue ( '' , '' , ix )

   case T == "PROGRESSBAR"

      retval := SendMessage( c, PBM_GETPOS, 0, 0)

   case T == "IPADDRESS"

      retval := GetIPAddress ( c )

   case T == "MONTHCAL"

      bd = Set (_SET_DATEFORMAT )

      SET DATE TO ANSI
      d = Alltrim( Str ( GetMOnthCalYear ( c ) ) ) + "." + Alltrim ( Str (GetMonthCalMonth ( c ) ) ) + "." + Alltrim (Str ( GetMonthCalDay( c ) ) )
      retval := ctod (d)
      Set (_SET_DATEFORMAT ,bd)

   case T == "TREE"

      if _HMG_aControlInputMask [ix] == .F.
         retval :=  aScan ( _HMG_aControlPageMap [ ix ] , TreeView_GetSelection ( c ) )
      Else
         retval :=  TreeView_GetSelectionId ( c )
      EndIf

   case T == "MASKEDTEXT"

      IF "E" $ _HMG_aControlPageMap [ix]

         Ts := GetWindowText ( c )

         If "." $ _HMG_aControlPageMap [ix]
            Do Case
            Case At ( '.' , Ts ) >  At ( ',' , Ts )
               retval :=  GetNumFromText ( GetWindowText ( c )  , ix )
            Case At ( ',' , Ts ) > At ( '.' , Ts )
               retval :=  GetNumFromTextSp ( GetWindowText ( c )  , ix )
            EndCase
         Else
            Do Case
            Case At ( '.' , Ts ) !=  0
               retval :=  GetNumFromTextSp ( GetWindowText ( c )  , ix )
            Case At ( ',' , Ts )  != 0
               retval :=  GetNumFromText ( GetWindowText ( c )  , ix )
            OtherWise
               retval :=  GetNumFromText ( GetWindowText ( c )  , ix )
            EndCase
         EndIf
      ELSE
         retval :=  GetNumFromText ( GetWindowText ( c )  , ix )
      ENDIF

   case T == "TEXT" .or. T == "BTNTEXT" .or. T == "EDIT" .or. T == "LABEL"  .or. T == "CHARMASKTEXT" .or. T == "HYPERLINK" .or. T == "RICHEDIT"

      if t == "CHARMASKTEXT"
         if valtype ( _HMG_aControlHeadCLick [ix] ) == 'L'
            if _HMG_aControlHeadCLick [ix] == .T.
               retval := CTOD ( alltrim ( GetWindowText ( c ) ) )
            Else
               retval := GetWindowText ( c )
            endif
         Else
            retval := GetWindowText ( c )
         endif
      Else
         retval := GetWindowText ( c )
      endif

   case "NUMTEXT" $ T

      retval := Int ( Val( GetWindowText( c ) ) )

   case T == "SPINNER"

      retval := GetSpinnerValue ( c [2] )

   case T == "CHECKBOX"

      auxval := SendMessage( c , BM_GETCHECK , 0 , 0 )

      if auxval == BST_CHECKED
         retval   := .t.
      ElseIf auxval == BST_UNCHECKED
         retval := .f.
      ElseIf auxval == BST_INDETERMINATE
         retval := Nil
      EndIf

   case T == "RADIOGROUP"

      for x = 1 to len (c)

         auxval := SendMessage( c[x] , BM_GETCHECK , 0 , 0 )

         if auxval == BST_CHECKED
            retval   := x
            exit
         EndIf

      next x

   case T == "COMBO"

      If ValType ( _HMG_aControlSpacing [ix] ) == 'C'

         auxval := ComboGetCursel ( c )
         rcount := 0

         WorkArea := _HMG_aControlSpacing [ix]

         BackRec := (WorkArea)->(RecNo())
         (WorkArea)->(DBGoTop())

         Do While ! (WorkArea)->(Eof())
            rcount++
            if rcount == auxval
               If Empty ( _HMG_aControlCaption [ix] )
                  RetVal := (WorkArea)->(RecNo())
               Else
                  Tmp := _HMG_aControlCaption [ix]
                  RetVal := &Tmp
               EndIf
            EndIf
            (WorkArea)->(DBSkip())
         EndDo

         (WorkArea)->(DBGoTo(BackRec))

      Else
         retval := ComboGetCursel ( c )
      EndIf

   case T == "LIST"
      retval := ListBoxGetCursel ( c )

   case T == "GRID"

      retval := LISTVIEW_GETFIRSTITEM ( c )

   case T == "TAB"
      retval := TABCTRL_GETCURSEL ( c )

   case T == "DATEPICK"

      bd = Set (_SET_DATEFORMAT )

      SET DATE TO ANSI
      d = Str ( GetDatePickYear ( c ), 4 ) + "." + StrZero ( GetDatePickMonth ( c ), 2 ) + "." + StrZero ( GetDatePickDay ( c ), 2 )
      retval := ctod (d)

      Set ( _SET_DATEFORMAT , bd )

   case T == "TIMEPICK"

      if  GetDatePickHour ( c ) >= 0
         d := StrZero(GetDatePickHour ( c ), 2 ) + ":" + StrZero ( GetDatePickMinute ( c ), 2 ) + ":" + StrZero ( GetDatePickSecond ( c ), 2 )
      else
         d := ""
      endif
      retval := d

   case T == "SLIDER"

      retval := SendMessage( c, TBM_GETPOS, 0, 0)

   case T == "MULTILIST"

      retval := ListBoxGetMultiSel (c)

   case T == "MULTIGRID"

      retval := ListViewGetMultiSel (c)

   case T == "TOOLBUTTON"

      retval := IsButtonBarChecked( _HMG_aControlContainerHandle [ ix ]  , _HMG_aControlValue [ix] - 1 )

   case T == "GETBOX"

      oGet := _HMG_aControlHeadClick [ix]
      retval := oGet:VarGet()

   case T == "HOTKEYBOX"

      retval := C_GetHotKey (c)

   endcase

Return (retval)

*-----------------------------------------------------------------------------*
Function _SetValue ( ControlName, ParentForm, Value , index )
*-----------------------------------------------------------------------------*
   Local t , h , c , x , controlcount , backrec , workarea , rcount , aPos
   Local TreeItemHandle , ix

   if pcount() == 3

      ix := GetControlIndex (ControlName,ParentForm)

      t := _HMG_aControlType [ix]
      h := _HMG_aControlParentHandles [ix]
      c := _HMG_aControlHandles [ix]

   Else

      t := _HMG_aControlType [index]
      h := _HMG_aControlParentHandles [index]
      c := _HMG_aControlHandles [index]
      ix := index

   EndIf

   do case

   case T == "BROWSE"

      _BrowseSetValue ( '' , '' , value , ix )

   case T == "IPADDRESS"

      Value := IFEMPTY(Value, {}, Value)

      If Len( Value ) == 0
         ClearIpAddress( c )
      Else
         SetIPAddress( c , Value[1] , Value[2] , Value[3] , Value[4] )
      EndIf

   case T == "MONTHCAL"

      Value := IFEMPTY(Value, CTOD(''), Value)
      SetMonthCal( c, year(value), month(value), day(value) )

   case T == "TREE"

      if Empty( Value )
         Return Nil
      endif

      if _HMG_aControlInputMask [ix] == .F.
         If Value > TreeView_GetCount ( c )
            Return Nil
         EndIf
      EndIf

      if _HMG_aControlInputMask [ix] == .F.
         TreeItemHandle :=  _HMG_aControlPageMap [ ix ] [ Value ]
      Else
         aPos := ascan ( _HMG_aControlPicture [ix] , Value )
         If aPos == 0
            MsgMiniGuiError ("Value Property: Invalid TreeItem Reference. Program Terminated")
         EndIf
         TreeItemHandle :=  _HMG_aControlPageMap [ ix ] [ aPos ]
      EndIf

      TreeView_SelectItem ( c , TreeItemHandle )

   case T == "MASKEDTEXT"

      Value := IFEMPTY(Value, 0, Value)

      If GetFocus() == c
         SetWindowText ( _HMG_aControlhandles [ix] , Transform ( Value , _HMG_aControlInputMask [ix] ) )
      Else
         SetWindowText ( _HMG_aControlhandles [ix] , Transform ( value , _HMG_aControlPageMap[ix]) )
      EndIf

   CASE T == "TIMER"
      controlcount := len (_HMG_aControlIds)

      KillTimer ( _HMG_aControlParentHandles [ix] , _HMG_aControlIds [ix] )

      for x := 1 to ControlCount
         if _HMG_aControlIds [x] == _HMG_aControlIds [ix]
            InitTimer ( GetFormHandle(ParentForm) , _HMG_aControlIds [ix] , Value )
            exit
         endif
      next x

   case T == "LABEL" .or. T == "HYPERLINK"

      if Empty( Value )
         value := IIF(T == "LABEL", "", "@")
      endif

      if _HMG_aControlSpacing [ix] == 1
         _SetControlWidth ( ControlName , ParentForm , GetTextWidth( NIL, Value, _HMG_aControlFontHandle [ix] ) +;
            IF( _HMG_aControlFontAttributes [ix] [1] == .T. .And. IsXPThemeActive() == .T., GetTextWidth( NIL, " ", _HMG_aControlFontHandle [ix] ), 0 ) ) // Fixed for problem with display bold label at themed WinXP
         _SetControlHeight ( ControlName , ParentForm , _HMG_aControlFontSize [ix] + 16 )
      EndIf

      SetWindowText ( c , value )

      If ISLOGICAL ( _HMG_aControlInputMask [ix] )
         If _HMG_aControlInputMask [ix] == .T.
            RedrawWindowControlRect( h , _HMG_aControlRow[ix] , _HMG_aControlCol[ix] , _HMG_aControlRow[ix] + _HMG_aControlHeight[ix] , _HMG_aControlCol[ix] + _HMG_aControlWidth [ix] )
         EndIf
      EndIf

   case T == "TEXT" .or. T == "BTNTEXT" .or. T == "EDIT" .or. T == "CHARMASKTEXT" .or. T == "RICHEDIT"

      Value := IFEMPTY(Value, '', Value)

      If T == "CHARMASKTEXT"
         If ISLOGICAL ( _HMG_aControlHeadCLick [ix] )
            If _HMG_aControlHeadCLick [ix] == .T.
               Value := IFCHARACTER(Value, CTOD(''), Value)
               SetWindowText ( c , rtrim(dtoc(value)) )
            Else
               SetWindowText ( c , rtrim(value) )
            Endif
         Else
            SetWindowText ( c , rtrim(value) )
         Endif
      ElseIf T == "EDIT"
         SetWindowText ( c , value )
      Else
         SetWindowText ( c , rtrim(value) )
      Endif

   case "NUMTEXT" $ T

      Value := IFEMPTY(Value, 0, Value)
      SetWindowText ( c , Alltrim(Str(Int(value))) )

   case T == "SPINNER"

      Value := IFEMPTY(Value, 0, Value)
      SetSpinnerValue ( c [2] , Value )

   case T == "CHECKBOX"

      Value := IIF( ISLOGICAL(Value) == .F., NIL, Value )

      if value == .T.
         SendMessage( c , BM_SETCHECK  , BST_CHECKED , 0 )
      elseif value == .F.
         SendMessage( c , BM_SETCHECK  , BST_UNCHECKED , 0 )
      else
         SendMessage( c , BM_SETCHECK  , BST_INDETERMINATE , 0 )
      endif

      if _HMG_ProgrammaticChange .And. Empty( _HMG_aControlMiscData1 [ix] )
         _DoControlEventProcedure ( _HMG_aControlChangeProcedure [ix] , ix , 'CONTROL_ONCHANGE' )
      endif

   case T == "RADIOGROUP"

      for x = 1 to len (c)
         SendMessage( c[x] , BM_SETCHECK  , BST_UNCHECKED , 0 )
      next x

      if !Empty( Value ) .And. ISNUMERIC( Value )

         SendMessage( c[value] , BM_SETCHECK  , BST_CHECKED , 0 )

         if _HMG_aControlPicture [ix] == .F. .and. IsTabStop( c[value] )
            SetTabStop( c[value] , .f. )
         endif

      endif

   case T == "COMBO"

      Value := IFNUMERIC(Value, Value, 0)

      If ValType ( _HMG_aControlSpacing [ix] ) == 'C'
         _HMG_aControlValue [ix] := value
         WorkArea := _HMG_aControlSpacing [ix]
         rcount := 0
         BackRec := (WorkArea)->( RecNo() )
         (WorkArea)->( DBGoTop() )
         Do While ! (WorkArea)->( Eof() )
            rcount++
            if value == ( WorkArea)->( RecNo() )
               Exit
            EndIf
            (WorkArea)->( DBSkip() )
         EndDo
         (WorkArea)->( DBGoTo(BackRec) )
         ComboSetCurSel ( c , rcount )
      Else
         ComboSetCursel ( c , value )
      EndIf

   case T == "LIST"

      ListBoxSetCursel ( c , value )

   case T == "GRID"

      ListView_SetCursel ( c, value )
      ListView_EnsureVisible( c , value )

   case T == "TAB"

      TABCTRL_SETCURSEL ( c , value )

      If ValType ( Value ) != 'N'
         MsgMiniGuiError('TAB: Value property wrong type (only numeric allowed). Program terminated')
      ElseIf Value < 1
         MsgMiniGuiError('TAB: Wrong Value (only value > 0 allowed). Program terminated')
      Else
         If Len (_HMG_aControlPageMap [ix]) > 0
            UpdateTab (ix)
         EndIf
         If _HMG_ProgrammaticChange
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [ix] , ix , 'CONTROL_ONCHANGE' )
         EndIf
      EndIf

   case T == "DATEPICK"

      If Empty( Value )
         SetDatePickNull( c )
      Else
         SetDatePick( c, year(value), month(value), day(value) )
      EndIf

   case T == "TIMEPICK"

      If Empty( Value )
         SetDatePickNull( c )
      ElseIf ISCHARACTER( Value )
         SetTimePick( c, Val(Left(value,2)), Val(Substr(value,4,2)), Val(Substr(value,7,2)) )
      EndIf

   case T == "PROGRESSBAR"

      Value := IFEMPTY(Value, 0, Value)
      SendMessage( c, PBM_SETPOS , value , 0 )

   case T == "SLIDER"

      Value := IFEMPTY(Value, 0, Value)
      SendMessage( c , TBM_SETPOS , 1 , value )

   case T == "MULTILIST"

      LISTBOXSETMULTISEL ( c , value )

   case T == "MULTIGRID"

      LISTVIEWSETMULTISEL ( c , value )

      If Len (value) > 0
         ListView_EnsureVisible( c , value [1] )
      EndIf

   case T == "TOOLBUTTON"

      CheckButtonBar( _HMG_aControlContainerHandle [ ix ] , _HMG_aControlValue [ix] - 1 , value )

   case T == "GETBOX"

      _SetGetBoxValue( ix , c , Value )

   case T == "HOTKEYBOX"

      SetHotKeyValue ( c , value )

   endcase

Return Nil

*-----------------------------------------------------------------------------*
Function _AddItem ( ControlName, ParentForm, Value , Parent, aImage , Id )
*-----------------------------------------------------------------------------*
   Local t , c , NewHandle , TempHandle , i , ix , aPos
   Local ChildHandle , BackHandle , ParentHandle
   Local TreeItemHandle , ImgDef , iUnSel , iSel
#ifdef _TSBROWSE_
   Local oGet
#endif

   ix := GetControlIndex (ControlName , ParentForm )

   T := _HMG_aControltype [ix]

   c := _HMG_aControlhandles [ix]

   If ValType ( Id ) == 'U'
      Id := 0
   EndIf

   If ValType ( aImage ) == 'N'
      Id := aImage
   EndIf

   do case

   case T == "TREE"

      If _HMG_aControlInputmask [ix] == .F.

         If Parent > TreeView_GetCount ( c ) .or. Parent < 0
            MsgMiniGuiError ( "Additem Method: Invalid Parent Value. Program Terminated" )
         EndIf

      EndIf

      ImgDef := iif( valtype( aImage ) == "A" , len( aImage ), 0 )  //Tree+

      If Parent != 0

         If _HMG_aControlInputmask [ix] == .F.
            TreeItemHandle := _HMG_aControlPageMap [ ix ] [ Parent ]
         Else
            aPos := ascan ( _HMG_aControlPicture [ix] , Parent )

            If aPos == 0
               MsgMiniGuiError ( "Additem Method: Invalid Parent Value. Program Terminated" )
            EndIf

            TreeItemHandle := _HMG_aControlPageMap [ ix ] [ aPos ]

         EndIf

         if ImgDef == 0

            iUnsel := 2   // Pointer to defalut Node Bitmaps, no Bitmap loaded
            iSel   := 3
         else
            iUnSel := AddTreeViewBitmap( c, aImage[1] ) -1
            iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( c, aImage[2] ) -1 )
            // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
         endif

         NewHandle := AddTreeItem ( c , TreeItemHandle , Value, iUnsel, iSel , Id )

         * Determine Position of New Item

         TempHandle := TreeView_GetChild ( c , TreeItemHandle )

         i := 0

         Do While .t.

            i++

            If TempHandle == NewHandle
               Exit
            EndIf

            ChildHandle := TreeView_GetChild ( c , TempHandle )

            If ChildHandle == 0
               BackHandle := TempHandle
               TempHandle := TreeView_GetNextSibling ( c , TempHandle )
            Else
               i++
               BackHandle := Childhandle
               TempHandle := TreeView_GetNextSibling ( c , ChildHandle )
            EndIf

            Do While TempHandle == 0

               ParentHandle := TreeView_GetParent ( c , BackHandle )

               TempHandle := TreeView_GetNextSibling ( c , ParentHandle )

               If TempHandle == 0
                  BackHandle := ParentHandle
               EndIf

            EndDo

         EndDo

         * Resize Array

         aSize ( _HMG_aControlPageMap [ ix ] , TreeView_GetCount ( c ) )
         aSize ( _HMG_aControlPicture [ ix ] , TreeView_GetCount ( c ) )

         * Insert New Element

         if _HMG_aControlInputmask [ix] == .F.
            aIns ( _HMG_aControlPageMap [ ix ] , Parent + i  )
            aIns ( _HMG_aControlPicture [ ix ] , Parent + i  )
         Else
            aIns ( _HMG_aControlPageMap [ ix ] , aPos + i )
            aIns ( _HMG_aControlPicture [ ix ] , aPos + i )
         EndIf

         * Assign Handle

         if _HMG_aControlInputmask [ix] == .F.
            _HMG_aControlPageMap [ ix ] [ Parent + i ] := NewHandle
            _HMG_aControlPicture [ ix ] [ Parent + i ] := Id
         Else

            If ascan ( _HMG_aControlPicture [ ix ] , Id ) != 0
               MsgMiniGuiError ( "Additem Method: Item Id "+alltrim(str(Id))+" Already In Use. Program Terminated" )
            EndIf

            _HMG_aControlPageMap [ ix ] [ aPos + i ] := NewHandle
            _HMG_aControlPicture [ ix ] [ aPos + i ] := Id

         EndIf

      Else

         If ImgDef == 0

            iUnsel := 0   // Pointer to defalut Node Bitmaps, no Bitmap loaded
            iSel   := 1
         Else
            iUnSel := AddTreeViewBitmap( c, aImage[1] ) -1
            iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( c, aImage[2] ) -1 )
            // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
         EndIf

         NewHandle := AddTreeItem ( c , 0 , Value, iUnsel, iSel , Id )

         aadd ( _HMG_aControlPageMap [ ix ] , NewHandle )

         If _HMG_aControlInputmask [ix] == .T.

            If ascan ( _HMG_aControlPicture [ ix ] , Id ) != 0
               MsgMiniGuiError ( "Additem Method: Item Id Already In Use. Program Terminated" )
            EndIf

         EndIf

         aadd ( _HMG_aControlPicture [ ix ] , Id )

      EndIf

   case T == "COMBO"
      // (JK) HMG 1.0 Experimental Build 8

      if _HMG_aControlMiscData1 [ix][1] == 0       // standard combo
         ComboAddString ( c , value )
      elseif _HMG_aControlMiscData1 [ix][1] == 1   // extend combo - "parent" is a picture Id. ;-)
         ComboAddStringEx ( c , value , Parent )
      endif

   case T == "LIST" .or. T == "MULTILIST"
      ListBoxAddstring ( c , value )

   case T == "GRID" .or. T == "MULTIGRID"
      _AddGridRow ( ControlName, ParentForm, value )
      _UpdateGridColors ( ix )

#ifdef _TSBROWSE_
   case T == "TBROWSE"

      if Type('_TSB_aControlhWnd') == 'A' .and. Len(_TSB_aControlhWnd) > 0
         oGet := GetObjectByHandle( c )
         if ValType(oGet) == 'O'
            oGet:AddItem( value )
         endif
      endif
#endif

   endcase

Return Nil

*-----------------------------------------------------------------------------*
Function _DeleteItem ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*
   Local t , c , BeforeCount , AfterCount , DeletedCount , i , ix , aPos
   Local TreeItemHandle
#ifdef _TSBROWSE_
   Local oGet
#endif

   ix := GetControlIndex (ControlName,ParentForm)

   T := _HMG_aControlType [ix]
   c := _HMG_aControlHandles [ix]

   do case

   case T == "TREE"

      BeforeCount := TreeView_GetCount ( c )

      if _HMG_aControlInputmask [ix] == .F.

         If Value > BeforeCount .or. Value < 1
            MsgMiniGuiError ( "DeleteItem Method: Invalid Item Specified. Program Terminated" )
         EndIf

         TreeItemHandle := _HMG_aControlPageMap [ ix ] [ Value ]
         TreeView_DeleteItem ( c , TreeItemHandle )

      Else

         aPos := ascan ( _HMG_aControlPicture [ix] , Value )

         If aPos == 0
            MsgMiniGuiError ( "DeleteItem Method: Invalid Item Id. Program Terminated" )
         EndIf

         TreeItemHandle := _HMG_aControlPageMap [ ix ] [ aPos ]
         TreeView_DeleteItem ( c , TreeItemHandle )

      EndIf

      AfterCount := TreeView_GetCount ( c )

      DeletedCount := BeforeCount - AfterCount

      if _HMG_aControlInputmask [ix] == .F.

         If DeletedCount == 1

            Adel ( _HMG_aControlPageMap [ ix ] , Value )

         Else

            For i := 1 To DeletedCount
               Adel ( _HMG_aControlPageMap [ ix ] , Value )
            Next i

         EndIf

      Else

         If DeletedCount == 1

            Adel ( _HMG_aControlPageMap [ ix ] , aPos )
            Adel ( _HMG_aControlPicture [ ix ] , aPos )

         Else

            For i := 1 To DeletedCount
               Adel ( _HMG_aControlPageMap [ ix ] , aPos )
               Adel ( _HMG_aControlPicture [ ix ] , aPos )
            Next i

         EndIf

      EndIf

      aSize ( _HMG_aControlPageMap [ ix ] , AfterCount )
      aSize ( _HMG_aControlPicture [ ix ] , AfterCount )

   case T == "LIST" .OR. T == "MULTILIST"

      ListBoxDeleteString ( c , value )

   case T == "COMBO"

      ComboBoxDeleteString ( c , value )
      ComboSetCursel ( c , value )

   case T == "GRID" .OR. T == "MULTIGRID"

      ListViewDeleteString ( c , value )
      _UpdateGridColors ( ix )

#ifdef _TSBROWSE_
   case T == "TBROWSE"

      if Type('_TSB_aControlhWnd') == 'A' .and. Len(_TSB_aControlhWnd) > 0
         oGet := GetObjectByHandle( c )
         if ValType(oGet) == 'O'
            oGet:DeleteRow()
         endif
      endif
#endif

   endcase

Return Nil

*-----------------------------------------------------------------------------*
Function _DeleteAllItems ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local t , c , i
#ifdef _TSBROWSE_
   Local oGet
#endif

   i = GetControlIndex (ControlName,ParentForm)

   t = _HMG_aControlType [i]
   c = _HMG_aControlhandles [i]

   do case

   case t == "TREE"
      TreeView_DeleteAllItems ( c )
      aSize ( _HMG_aControlPageMap [ i ] , 0 )
      aSize ( _HMG_aControlPicture [ i ] , 0 )

   case t == "LIST" .OR. t == "MULTILIST"
      ListBoxReset ( c )

   case t == "COMBO"
      ComboBoxReset ( c )

   case t == "GRID" .OR. t == "MULTIGRID"
      ListViewReset ( c )

#ifdef _TSBROWSE_
   case t == "TBROWSE"

      if Type('_TSB_aControlhWnd') == 'A' .and. Len(_TSB_aControlhWnd) > 0
         oGet := GetObjectByHandle( c )
         if ValType(oGet) == 'O' .and. oGet:lIsArr
            oGet:DeleteRow(.t.)
         endif
      endif
#endif

   endcase

Return Nil

*-----------------------------------------------------------------------------*
Function GetControlIndex (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar
   mVar := '_' + ParentForm + '_' + ControlName
Return ( &mVar )
*-----------------------------------------------------------------------------*
Function GetControlName (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName
   i := &mVar
   if i == 0
      Return ''
   EndIf

Return ( _HMG_aControlNames [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlHandle (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return 0
   EndIf

Return ( _HMG_aControlHandles [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlContainerHandle (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return 0
   EndIf

Return ( _HMG_aControlContainerHandle [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlParentHandle (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return 0
   EndIf

Return ( _HMG_aControlParentHandles [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlId (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return 0
   EndIf

Return ( _HMG_aControlIds [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlType (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return ''
   EndIf

Return ( _HMG_aControlType [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlValue (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return Nil
   EndIf

Return ( _HMG_aControlValue [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlPageMap (ControlName, ParentForm)
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return {}
   EndIf

Return ( _HMG_aControlPageMap [ &mVar ] )
*-----------------------------------------------------------------------------*
Function _IsControlDefined ( ControlName, FormName )
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + FormName + '_' + ControlName

   If Type ( mVar ) <> 'U'
      If Type ( mVar ) == 'N'
         i := &mVar
         If i == 0
            Return .F.
         EndIf
         Return ( .Not. ( _HMG_aControlDeleted [ i ] ) )
      EndIf
   EndIf

Return .F.

// (JK) HMG 1.0 Experimental Build 8
*-----------------------------------------------------------------------------*
Function _IsComboExtend ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i, lRet := .f.

   If !_IsControlDefined ( ControlName, ParentForm )
      MsgMiniGuiError("Control "+ ControlName + " of " +ParentForm + " is not defined" )

   ElseIf GetControlType ( ControlName, ParentForm ) <> "COMBO"
      MsgMiniGuiError("Control "+ ControlName + " of " +ParentForm + " is not COMBO control" )

   Else
      i := GetControlIndex ( ControlName, ParentForm )
      If _HMG_aControlMiscData1 [i][1] == 1
         lRet := .t.
      EndIf

   EndIf

Return lRet

*-----------------------------------------------------------------------------*
Function _SetFocus ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local H , T , MaskStart , x , i

   H := GetControlHandle( ControlName , ParentForm )

   T := GetControlType (ControlName,ParentForm)

   i := GetControlIndex ( ControlName,ParentForm )

   DO CASE

   CASE T == 'TEXT' .Or. T == 'NUMTEXT' .Or. T == 'MASKEDTEXT' .Or. T == 'BTNTEXT' .Or. T == 'BTNNUMTEXT'
      setfocus( H )
      SendMessage ( H , EM_SETSEL , 0 , -1 )

   CASE T == "CHARMASKTEXT"

      setfocus( H )

      For x := 1 To Len (_HMG_aControlInputMask [i])
         If IsDigit(SubStr ( _HMG_aControlInputMask [i] , x , 1 )) .Or. IsAlpha(SubStr ( _HMG_aControlInputMask [i] , x , 1 )) .Or. SubStr ( _HMG_aControlInputMask [i] , x , 1 ) == '!'
            MaskStart := x
            Exit
         EndIf
      Next x

      If MaskStart == 1
         SendMessage( H , EM_SETSEL , 0 , -1 )
      Else
         SendMessage( H , EM_SETSEL , MaskStart - 1 , -1 )
      EndIf

   CASE T == 'BUTTON'
      setfocus( H )
      SendMessage ( H , 244 , LOWORD ( 1 ) , 1 )

   CASE T == 'SPINNER'
      setfocus( H [1] )

   CASE T == 'RADIOGROUP'
      setfocus( H [1] )

   OTHERWISE
      setfocus( H )

   ENDCASE

   _HMG_SetFocusExecuted := .T.

Return Nil
*-----------------------------------------------------------------------------*
Function _DisableControl ( ControlName , ParentForm , nPosition )
*-----------------------------------------------------------------------------*
   Local H , T , i , c , y , s , z , w

   default nPosition to 0

   T := GetControlType (ControlName, ParentForm)
   i := GetControlId (ControlName, ParentForm)
   h := GetControlParentHandle (ControlName, ParentForm)
   c := GetControlHandle (ControlName, ParentForm)
   y := GetControlIndex (ControlName, ParentForm)

   _HMG_aControlEnabled [y] := .F.

   DO CASE

   // HMG 1.0 Experimental build 9 (JK)

   CASE T == "BUTTON" .and. !EMPTY(_HMG_aControlBrushHandle [y]) .and. VALTYPE(_HMG_aControlPicture [y])=="A" .and. _HMG_aControlMiscData1 [y]==0
      _DestroyBtnPicture(c, y)
      _SetBtnPicture(c, _HMG_aControlPicture [y][2])
      DisableWindow( c )

   CASE T == "BUTTON" .and. !EMPTY(_HMG_aControlBrushHandle [y]) .and. VALTYPE(_HMG_aControlPicture [y])=="C" .and. _HMG_aControlMiscData1 [y]==0
      _SetBtnPictureMask(c, y)
      _DestroyBtnPicture(c, y)
      DisableWindow( c )

   CASE T == "CHECKBOX" .and. !EMPTY(_HMG_aControlBrushHandle [y]) .and. VALTYPE(_HMG_aControlPicture [y])=="C" .and. _HMG_aControlMiscData1 [y]==1
      _SetBtnPictureMask(c, y)
      _DestroyBtnPicture(c, y)
      DisableWindow( c )

   CASE T == "BROWSE"
      DisableWindow ( c )
      If _HMG_aControlIds[y] != 0
         DisableWindow ( _HMG_aControlIds[y] )
      EndIf

   CASE T == "TOOLBUTTON"
      _DisableToolBarButton ( ControlName, ParentForm )

   CASE T == "MENU" .OR. T == "POPUP"
      _DisableMenuItem ( ControlName, ParentForm )

   CASE T == "TIMER"
      KillTimer ( h , i )

   CASE T == "SPINNER"
      DisableWindow ( c [1] )
      DisableWindow ( c [2] )

   CASE T == "RADIOGROUP"
      IF PCOUNT() == 3 // Position defined, which Radiobutton to disable
         DisableWindow ( c [nPosition] )
         _HMG_aControlPageMap [y] [nPosition] := .T.
      ELSE
         For i := 1 To Len ( c )
            DisableWindow ( c [i] )
         Next i
      ENDIF

   CASE T == "TAB"
      DisableWindow ( c )

      s := TabCtrl_GetCurSel (_HMG_aControlHandles [y] )
      for w := 1 to len (_HMG_aControlPageMap [y] [s])
         if valtype (_HMG_aControlPageMap [y] [s] [w]) <> "A"
            DisableWindow ( _HMG_aControlPageMap [y] [s] [w] )
         else
            for z := 1 to len ( _HMG_aControlPageMap [y] [s] [w] )
               DisableWindow ( _HMG_aControlPageMap [y] [s] [w] [z] )
            next z
         endif
      Next w

   OTHERWISE
      DisableWindow ( c )

   ENDCASE

Return Nil
*-----------------------------------------------------------------------------*
Function _EnableControl ( ControlName , ParentForm , nPosition )
*-----------------------------------------------------------------------------*
   Local /*h ,*/ t , i , c , x , controlcount , y , s , z , w

   default nPosition to 0

   T := GetControlType (ControlName, ParentForm)
   i := GetControlId (ControlName, ParentForm)
//   h := GetControlParentHandle (ControlName, ParentForm)
   c := GetControlHandle (ControlName, ParentForm)
   y := GetControlIndex (ControlName, ParentForm)

   _HMG_aControlEnabled [y] := .T.

   DO CASE
   // HMG 1.0 Experimental build 9 (JK)

   CASE T == "BUTTON" .and. !EMPTY(_HMG_aControlBrushHandle [y]) .and. VALTYPE(_HMG_aControlPicture [y])=="A"
      _DestroyBtnPicture(c,y)
      _HMG_aControlBrushHandle[y] := _SetBtnPicture(c,_HMG_aControlPicture [y][1])
      EnableWindow( c )

   CASE T == "BUTTON" .and. !EMPTY(_HMG_aControlBrushHandle [y]) .and. VALTYPE(_HMG_aControlPicture [y])=="C" .and. _HMG_aControlMiscData1 [y]==0
      _DestroyBtnPictureMask(c,y)
      _HMG_aControlBrushHandle[y] := _SetBtnPicture(c,_HMG_aControlPicture [y])
      EnableWindow( c )

   CASE T == "CHECKBOX" .and. !EMPTY(_HMG_aControlBrushHandle [y]) .and. VALTYPE(_HMG_aControlPicture [y])=="C" .and. _HMG_aControlMiscData1 [y]==1
      _DestroyBtnPictureMask(c,y)
      _HMG_aControlBrushHandle[y] := _SetBtnPicture(c,_HMG_aControlPicture [y])
      EnableWindow( c )

   CASE T == "BROWSE"
      EnableWindow ( c )
      If _HMG_aControlIds[y] != 0
         EnableWindow ( _HMG_aControlIds[y] )
      EndIf

   CASE T == "TOOLBUTTON"
      _EnableToolBarButton ( ControlName , ParentForm )

   CASE T == "MENU" .OR. T == "POPUP"
      _EnableMenuItem ( ControlName , ParentForm )

   CASE T == "TIMER"
      controlcount := len (_HMG_aControlNames)

      for x := 1 to controlcount
         if valtype ( _HMG_aControlIds [x] ) == 'N' .and. _HMG_aControlIds [x] == i
            InitTimer ( GetFormHandle(ParentForm) , _HMG_aControlIds [x] , _HMG_aControlValue [x] )
            exit
         endif
      next x

   CASE T == "SPINNER"
      EnableWindow ( c [1] )
      If _HMG_aControlMiscData1 [ y, 2 ] == .F.
         EnableWindow ( c [2] )
      EndIf

   CASE T == "RADIOGROUP"

      IF PCOUNT() == 3  // Position defined, which Radiobutton to enable
         EnableWindow ( c [nPosition] )
         _HMG_aControlPageMap [y] [nPosition] := .F.
      ELSE
         For i := 1 To Len (c)
            EnableWindow ( c [i] )
         Next i
      ENDIF

   CASE T == "TAB"
      EnableWindow ( c )

      s := TabCtrl_GetCurSel (_HMG_aControlHandles [y] )
      for w = 1 to len (_HMG_aControlPageMap [y] [s])
         if valtype (_HMG_aControlPageMap [y] [s] [w]) <> "A"
            EnableWindow ( _HMG_aControlPageMap [y] [s] [w] )
         else
            for z = 1 to len ( _HMG_aControlPageMap [y] [s] [w] )
               EnableWindow ( _HMG_aControlPageMap [y] [s] [w] [z] )
            next z
         endif
      Next w

   OTHERWISE
      EnableWindow ( c )

   ENDCASE

Return Nil
*-----------------------------------------------------------------------------*
Function _ShowControl ( ControlName,ParentForm )
*-----------------------------------------------------------------------------*
   Local t, i, c, w, s, y, z, r
   Local TabHide := .f.

   T := GetControlType (ControlName,ParentForm)

   c := GetControlHandle (ControlName,ParentForm)

   y := GetControlIndex (ControlName,ParentForm)

   if _HMG_aControlVisible [y] == .t.
      Return Nil
   EndIf

   // If the control is inside a TAB and the page is not visible,
   // the control must not be showed

   For i := 1 To Len ( _HMG_aControlPageMap )

      if _HMG_aControlType [i] == "TAB"

         s = TabCtrl_GetCurSel (_HMG_aControlHandles [i] )

         for r = 1 to len ( _HMG_aControlPageMap [i] )

            for w = 1 to len (_HMG_aControlPageMap [i] [r])

               If t == 'RADIOGROUP'

                  If ValType (_HMG_aControlPageMap [i] [r] [w]) == 'A'

                     if _HMG_aControlPageMap [i] [r] [w] [1] == _HMG_aControlHandles [y] [1]

                        If r != s
                           TabHide := .T.
                        EndIf

                        Exit

                     EndIf

                  EndIf

               Elseif t == 'SPINNER'

                  If ValType (_HMG_aControlPageMap [i] [r] [w]) == 'A'

                     If _HMG_aControlPageMap [i] [r] [w] [1] == _HMG_aControlHandles [y] [1]

                        If r != s
                           TabHide := .T.
                        EndIf

                        Exit

                     EndIf

                  EndIf

               Elseif t == 'BROWSE'

                  If ValType (_HMG_aControlPageMap [i] [r] [w]) == 'A'

                     If _HMG_aControlPageMap [i] [r] [w] [1] == _HMG_aControlHandles [y]

                        If r != s
                           TabHide := .T.
                        EndIf

                        Exit

                     EndIf

                  Elseif ValType (_HMG_aControlPageMap [i] [r] [w]) == 'N'

                     If _HMG_aControlPageMap [i] [r] [w] == _HMG_aControlHandles [y]

                        If r != s
                           TabHide := .T.
                        EndIf

                        Exit

                     EndIf

                  EndIf

               Else

                  If ValType (_HMG_aControlPageMap [i] [r] [w]) == 'N'

                     If _HMG_aControlPageMap [i] [r] [w] == _HMG_aControlHandles [y]

                        If r != s
                           TabHide := .T.
                        EndIf

                        Exit

                     EndIf

                  EndIf

               EndIf

            Next w

         next r

      EndIf

   Next i

   if TabHide == .T.
      _HMG_aControlVisible [y] := .t.
      Return Nil
   EndIf

   if T == "SPINNER"

      CShowControl ( c [2] )
      CShowControl ( c [1] )

   ElseIf T == "BROWSE"

      CShowControl ( c )

      If _HMG_aControlIds [y] != 0
         CShowControl ( _HMG_aControlIds [y] )
      EndIf
      If _HMG_aControlMiscData1 [y] [1] != 0
         CShowControl ( _HMG_aControlMiscData1 [y] [1] )
      EndIf

   Elseif T == "TAB"

      CShowControl ( c )

      s := TabCtrl_GetCurSel (_HMG_aControlHandles [y] )
      for w = 1 to len (_HMG_aControlPageMap [y] [s])
         if valtype (_HMG_aControlPageMap [y] [s] [w]) <> "A"
            CShowControl ( _HMG_aControlPageMap [y] [s] [w] )
         else
            for z = 1 to len ( _HMG_aControlPageMap [y] [s] [w] )
               CShowControl ( _HMG_aControlPageMap [y] [s] [w] [z] )
            next z
         endif
      Next w

   Elseif T == "RADIOGROUP"

      For i:= 1 To Len ( c )
         CShowControl ( c [i] )
      Next i

   Else

      CShowControl ( c )

   EndIf

   _HMG_aControlVisible [y] := .t.
   ProcessMessages()

Return Nil
*-----------------------------------------------------------------------------*
Function _HideControl ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local t, c, y, r, w, z

   T := GetControlType (ControlName,ParentForm)
   c := GetControlHandle (ControlName,ParentForm)
   y := GetControlIndex (ControlName,ParentForm)

   If T == "SPINNER"

      HideWindow ( c [1] )
      HideWindow ( c [2] )

   ElseIf T == "BROWSE"

      HideWindow ( c )

      If _HMG_aControlIds [y] != 0
         HideWindow ( _HMG_aControlIds [y] )
      EndIf
      If _HMG_aControlMiscData1 [y] [1] != 0
         HideWindow ( _HMG_aControlMiscData1 [y] [1] )
      EndIf

   ElseIf T == "TAB"

      HideWindow ( c )

      for r = 1 to len ( _HMG_aControlPageMap [y] )
         for w = 1 to len (_HMG_aControlPageMap [y] [r])
            if valtype ( _HMG_aControlPageMap [y] [r] [w] ) <> "A"
               HideWindow ( _HMG_aControlPageMap [y] [r] [w] )
            else
               for z = 1 to len ( _HMG_aControlPageMap [y] [r] [w] )
                  HideWindow ( _HMG_aControlPageMap [y] [r] [w] [z] )
               Next z
            endif
         Next w
      Next r

   ElseIf T == "RADIOGROUP"

      For r = 1 To Len ( c )
         HideWindow ( c [r] )
      Next r

   ElseIf T == "COMBO"

      SendMessage ( c , 335 , 0 , 0 )   // close DropDown list
      HideWindow ( c )

   Else

      HideWindow ( c )

   EndIf

   _HMG_aControlVisible [y] := .f.

Return Nil

*-----------------------------------------------------------------------------*
Function _SetItem ( ControlName, ParentForm, Item , Value, index )
*-----------------------------------------------------------------------------*
   Local t , c , i , aPos
   Local TreeHandle, ItemHandle

   LOCAL AEDITCONTROLS
   LOCAL CI, bd
   LOCAL XRES
   LOCAL ATEMP
   LOCAL AEC
   LOCAL CTYPE
   LOCAL CINPUTMASK
   LOCAL CFORMAT
   LOCAL AITEMS
//   LOCAL ARANGE
//   LOCAL DTYPE
   LOCAL ALABELS

   if pcount() == 5
      i = index
   else
      i := GetControlIndex (ControlName,ParentForm)
   endif

   t := _HMG_aControlType [i]
   c := _HMG_aControlhandles [i]

   do case
   case t == 'TREE'

      if _HMG_aControlInputmask [i] == .F.
         If Item > TreeView_GetCount ( c ) .or. Item < 1
            MsgMiniGuiError ("Item Property: Invalid Item Reference. Program Terminated" )
         EndIf
      EndIf

      TreeHandle := c

      if _HMG_aControlInputmask [i] == .F.
         ItemHandle := _HMG_aControlPageMap [ i ] [ Item ]
      Else

         aPos := ascan ( _HMG_aControlPicture [i] , Item )

         If aPos == 0
            MsgMiniGuiError ("Item Property: Invalid Item Id. Program Terminated" )
         EndIf

         ItemHandle := _HMG_aControlPageMap [ i ] [ aPos ]

      EndIf

      TreeView_SetItem ( TreeHandle , ItemHandle , Value )

   case T == "LIST"
      ListBoxDeleteString ( c , Item )
      ListBoxInsertString ( c , value , Item )
      ListBoxSetCurSel ( c , Item )

   case T == "MULTILIST"
      aTemp := ListBoxGetMultiSel ( c )
      ListBoxDeleteString ( c , Item )
      ListBoxInsertString ( c , value , Item )
      ListBoxSetMultiSel ( c , aTemp )

   case T == "COMBO"
      if _HMG_aControlMiscData1 [i][1] == 0       // standard combo
         ComboBoxDeleteString ( c , Item )
         ComboInsertString ( c , value , Item )
      elseif _HMG_aControlMiscData1 [i][1] == 1   // extend combo - value is array (1-image index, 2-string)
         ComboBoxDeleteItemEx ( c , Item )
         ComboInsertStringEx ( c , value[2] , value[1] , Item )
      endif

   case T == "GRID" .OR. T == "MULTIGRID"

      AEDITCONTROLS := __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[ I ] )) + '_EDITCONTROLS' )

      IF VALTYPE ( AEDITCONTROLS ) != 'A'

         ListViewSetItem ( c , value , Item )

      ELSE

         ATEMP := ARRAY ( LEN ( VALUE ) )

         FOR CI := 1 TO LEN ( VALUE )

            XRES := _ParseGridControls ( AEDITCONTROLS , CI )

            AEC      := XRES [1]
            CTYPE      := XRES [2]
            CINPUTMASK   := XRES [3]
            CFORMAT      := XRES [4]
            AITEMS      := XRES [5]
//            ARANGE      := XRES [6]
//            DTYPE      := XRES [7]
            ALABELS      := XRES [8]

            IF   AEC == 'TEXTBOX'
               IF CTYPE == 'CHARACTER'
                  IF EMPTY ( CINPUTMASK )
                     aTemp [ci] := VALUE [CI]
                  ELSE
                     aTemp [ci] := TRANSFORM ( VALUE [CI] , CINPUTMASK )
                  ENDIF
               ELSEIF CTYPE == 'NUMERIC'
                  IF EMPTY ( CINPUTMASK )
                     aTemp [ci] := STR ( VALUE [CI] )
                  ELSE
                     IF EMPTY ( CFORMAT )
                        aTemp [ci] := TRANSFORM ( VALUE [CI] , CINPUTMASK )
                     ELSE
                        aTemp [ci] := TRANSFORM ( VALUE [CI], '@' + CFORMAT + ' ' + CINPUTMASK )
                     ENDIF
                  ENDIF
               ELSEIF CTYPE == 'DATE'
                  aTemp [ci] := DTOC ( VALUE [CI] )
               ENDIF
            ELSEIF   AEC == 'DATEPICKER'
               bd := Set (_SET_DATEFORMAT )
               SET CENTURY ON
               aTemp [ci] := dtoc ( VALUE [CI] )
               Set ( _SET_DATEFORMAT , bd )
            ELSEIF   AEC == 'COMBOBOX'
               IF VALUE [CI] == 0
                  aTemp [ci] := ''
               ELSE
                  aTemp [ci] := AITEMS [ VALUE [CI] ]
               ENDIF
            ELSEIF   AEC == 'SPINNER'
               aTemp [ci] := str ( VALUE [CI] )
            ELSEIF   AEC == 'CHECKBOX'
               IF VALUE [CI] == .T.
                  aTemp [ci] := ALABELS [1]
               ELSE
                  aTemp [ci] := ALABELS [2]
               ENDIF
            ENDIF

         NEXT CI

         ListViewSetItem ( c , aTemp , Item )

      ENDIF

      if Len ( _HMG_aControlBkColor [i] ) > 0
         SetImageListViewItems( c, item , value [1] )
      EndIf

      _UpdateGridColors ( i )

   case T == "MESSAGEBAR" //JP

      SetItemBar ( c , value , Item-1 )

   endcase

Return Nil

*-----------------------------------------------------------------------------*
Function _GetItem ( ControlName, ParentForm, Item, idx )
*-----------------------------------------------------------------------------*
   Local t , c , RetVal , TreeHandle , ItemHandle , i , aPos

   LOCAL AEDITCONTROLS
   LOCAL CI
   LOCAL XRES
   LOCAL ATEMP
   LOCAL AEC
   LOCAL CTYPE
//   LOCAL CINPUTMASK
   LOCAL CFORMAT
   LOCAL AITEMS
//   LOCAL ARANGE
//   LOCAL DTYPE
   LOCAL ALABELS
   LOCAL V, Z, X

   if pcount() == 4

      i := idx

   else

      i := GetControlIndex ( ControlName, ParentForm )

   endif

   t := _HMG_aControlType [i]

   c := _HMG_aControlHandles [i]

   do case
   case t == 'TREE'

      If _HMG_aControlInputmask [i] == .F.
         If Item > TreeView_GetCount ( c ) .or. Item < 1
            MsgMiniGuiError ("Item Property: Invalid Item Reference. Program Terminated" )
         EndIf
      EndIf

      TreeHandle := c

      If _HMG_aControlInputmask [i] == .F.
         ItemHandle := _HMG_aControlPageMap [ i ] [ Item ]
      Else

         aPos := ascan ( _HMG_aControlPicture [i] , Item )

         If aPos == 0
            MsgMiniGuiError ("Item Property: Invalid Item Id. Program Terminated" )
         EndIf

         ItemHandle := _HMG_aControlPageMap [ i ] [ aPos ]

      EndIf

      RetVal := TreeView_GetItem ( TreeHandle , ItemHandle )

   case T == "LIST" .Or. T == "MULTILIST"
      RetVal := ListBoxGetString ( c , Item )

   case T == "COMBO"
      RetVal := ComboGetString ( c , Item )

   case T == "GRID" .OR. T == "MULTIGRID"

      AEDITCONTROLS := __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[ i ] )) + '_' + 'EDITCONTROLS' )

      IF VALTYPE ( AEDITCONTROLS ) != 'A'

         RetVal := ListViewGetItem ( c , Item , Len ( _hmg_aControlPageMap [i] ) )

      ELSE

         V := ListViewGetItem ( c , Item , Len( _hmg_acontrolpagemap [i] ) )

         ATEMP := ARRAY ( Len( _hmg_acontrolpagemap [i] ) )

         FOR CI := 1 TO Len( _hmg_acontrolpagemap [i] )

            XRES := _ParseGridControls ( AEDITCONTROLS , CI )

            AEC        := XRES [1]
            CTYPE      := XRES [2]
//            CINPUTMASK := XRES [3]
            CFORMAT    := XRES [4]
            AITEMS     := XRES [5]
//            ARANGE     := XRES [6]
//            DTYPE      := XRES [7]
            ALABELS    := XRES [8]

            IF AEC == 'TEXTBOX'
               IF CTYPE == 'NUMERIC'
                  IF CFORMAT = 'E'
                     ATEMP [CI] := GetNumFromCellTextSp ( v [CI] )
                  ELSE
                     ATEMP [CI] := GetNumFromCellText ( v [CI] )
                  ENDIF
               ELSEIF CTYPE == 'DATE'
                  ATEMP [CI] := CTOD ( v [CI] )
               ELSEIF CTYPE == 'CHARACTER'
                  ATEMP [CI] := v [CI]
               ENDIF

            ELSEIF AEC == 'DATEPICKER'
               ATEMP [CI] := CTOD (V [CI] )

            ELSEIF AEC == 'COMBOBOX'
               Z := 0
               FOR X := 1 TO LEN ( AITEMS )
                  IF UPPER ( ALLTRIM( V [CI] ) ) == UPPER ( ALLTRIM ( AITEMS [X] ) )
                     Z := X
                     EXIT
                  ENDIF
               NEXT X
               ATEMP [CI] :=    Z

            ELSEIF AEC == 'SPINNER'
               ATEMP [CI] := VAL (V [CI] )

            ELSEIF AEC == 'CHECKBOX'
               IF ALLTRIM(UPPER(V[CI])) == ALLTRIM(UPPER(ALABELS [1]))
                  ATEMP [CI] :=  .T.
               ELSEIF ALLTRIM(UPPER(V[CI])) == ALLTRIM(UPPER(ALABELS [2]))
                  ATEMP [CI] := .F.
               ENDIF
            ENDIF

         NEXT CI

         RetVal := ATEMP

      ENDIF

      If Len ( _HMG_aControlBkColor [i] ) > 0
         If Len (RetVal) >= 1
            RetVal [1] := GetImageListViewItems( c , Item )
         EndIf
      EndIf
      //JK
   case T == "MESSAGEBAR"

      RetVal := GetItemBar ( c , Item )

   endcase

Return (RetVal)

*-----------------------------------------------------------------------------*
Function _SetControlSizePos ( ControlName, ParentForm, row, col, width, height )
*-----------------------------------------------------------------------------*
   Local t, i, c, x , NewCol , NewRow , r , w , z , p , xx , b , hws
   Local DelTaRow, DelTaCol, SpinW
   Local tCol, tRow, tWidth, tHeight

   T := GetControlType (ControlName,ParentForm)

   c := GetControlHandle (ControlName,ParentForm)

   x := GetControlIndex (ControlName,ParentForm)

   do case

   Case T == "TAB"

      DelTaRow := Row - _HMG_aControlRow    [ x ]
      DelTaCol := Col - _HMG_aControlCol    [ x ]

      _HMG_aControlRow    [ x ] := Row
      _HMG_aControlCol    [ x ] := Col
      _HMG_aControlWidth  [ x ] := Width
      _HMG_aControlHeight [ x ] := Height

      MoveWindow ( c , col , Row , Width , Height , .t. )

      for r = 1 to len ( _HMG_aControlPageMap [x] )
         for w = 1 to len (_HMG_aControlPageMap [x] [r])
            if valtype ( _HMG_aControlPageMap [x] [r] [w] ) <> "A"

               p := aScan (_HMG_aControlhandles , _HMG_aControlPageMap [x] [r] [w] )

               tCol    := _HMG_aControlCol    [p]
               tRow    := _HMG_aControlRow    [p]
               tWidth   := _HMG_aControlWidth    [p]
               tHeight   := _HMG_aControlHeight    [p]

               MoveWindow ( _HMG_aControlPageMap [x] [r] [w] ,  tCol + DeltaCol , tRow + DeltaRow , tWidth , tHeight , .t. )

               _HMG_aControlRow [ p ] :=  tRow + DeltaRow
               _HMG_aControlCol [ p ] :=  tCol + DeltaCol

               _HMG_aControlContainerRow [ p ] :=  Row
               _HMG_aControlContainerCol [ p ] :=  Col

            else

               p := ascan ( _HMG_aControlhandles , _HMG_aControlPageMap [x] [r] [w] [1] )

               if p > 0 .and. _hmg_acontroltype [p] == 'BROWSE'

                  tCol    := _HMG_aControlCol     [p]
                  tRow    := _HMG_aControlRow     [p]
                  tWidth  := _HMG_aControlWidth   [p]
                  tHeight := _HMG_aControlHeight  [p]

                  If _HMG_aControlIds[p] != 0

                     MoveWindow ( _HMG_aControlPageMap [x] [r] [w] [1] , tCol + DeltaCol , tRow + DeltaRow , tWidth - GETVSCROLLBARWIDTH() , tHeight , .t. )

                     hws := 0
                     For b := 1 To Len ( _HMG_aControlProcedures [p] )
                        hws := hws + ListView_GetColumnWidth ( _HMG_aControlHandles [p] , b - 1 )
                     Next b

                     if hws > _HMG_aControlWidth[p] - GETVSCROLLBARWIDTH() - 4

                        MoveWindow ( _HMG_aControlIds[p] , tCol + DeltaCol + tWidth - GETVSCROLLBARWIDTH() , tRow + DeltaRow , GETVSCROLLBARWIDTH() , tHeight - GetHScrollBarHeight() , .t. )
                        MoveWindow ( _HMG_aControlMiscData1[p] [1], tCol + DeltaCol + tWidth - GETVSCROLLBARWIDTH() , tRow + DeltaRow + tHeight - GetHScrollBarHeight() ,;
                           GetWindowWidth(_HMG_aControlMiscData1[p] [1]) , GetWindowHeight(_HMG_aControlMiscData1[p][1]) , .t. )

                     Else

                        MoveWindow ( _HMG_aControlIds[p] , tCol + DeltaCol + tWidth - GETVSCROLLBARWIDTH() , tRow + DeltaRow , GETVSCROLLBARWIDTH()   , tHeight , .t. )
                        MoveWindow ( _HMG_aControlMiscData1[p] [1], tCol + DeltaCol + tWidth - GETVSCROLLBARWIDTH() , tRow + DeltaRow + tHeight - GetHScrollBarHeight() , 0  , 0 , .t. )

                     EndIf

                     _BrowseRefresh ( '' , '' , p )

                     ReDrawWindow ( _HMG_aControlIds[p] )

                     ReDrawWindow ( _HMG_aControlMiscData1[p] [1])

                  Else

                     MoveWindow ( _HMG_aControlPageMap [x] [r] [w] [1] ,  tCol + DeltaCol , tRow + DeltaRow , tWidth , tHeight , .t. )

                  endif

                  _HMG_aControlRow [ p ] := tRow + DeltaRow
                  _HMG_aControlCol [ p ] := tCol + DeltaCol

                  _HMG_aControlContainerRow [ p ] := Row
                  _HMG_aControlContainerCol [ p ] := Col

               else

                  for z = 1 to len ( _HMG_aControlPageMap [x] [r] [w] )

                     for xx = 1 to len ( _HMG_aControlType )

                        if valtype ( _HMG_aControlhandles [xx] ) == 'A'

                           if _HMG_aControlPageMap [x] [r] [w] == _HMG_aControlhandles [xx]

                              if _HMG_aControlType [xx] == 'RADIOGROUP'
                                 if _HMG_aControlMiscData1 [ xx ] == .t.
                                    MoveWIndow ( _HMG_aControlhandles [xx] [z] , _HMG_aControlCol [xx] + DeltaCol + ( _HMG_aControlWidth [xx] + _HMG_aControlSpacing [xx] ) * (z-1) , _HMG_aControlRow [xx] + DeltaRow,;
                                       _HMG_aControlWidth [xx] , _HMG_aControlHeight [xx] , .t. )
                                 Else
                                    MoveWIndow ( _HMG_aControlhandles [xx] [z] , _HMG_aControlCol [xx] + DeltaCol , _HMG_aControlRow [xx] + DeltaRow + _HMG_aControlSpacing [xx] * (z-1) , _HMG_aControlWidth [xx] , 28 , .t. )
                                 EndIf
                              endif

                              if _HMG_aControlType [xx] == 'RADIOGROUP' .and. z == len ( _HMG_aControlPageMap [x] [r] [w] )
                                 _HMG_aControlRow [ xx ] := _HMG_aControlRow [ xx ] + DeltaRow
                                 _HMG_aControlCol [ xx ] := _HMG_aControlCol [ xx ] + DeltaCol
                                 _HMG_aControlContainerRow [ xx ] := Row
                                 _HMG_aControlContainerCol [ xx ] := Col
                              EndIf

                              if _HMG_aControlType [xx] == 'SPINNER' .and. z == 1

                                // JD 07/22/2007
                                 SpinW := GetWindowWidth( _HMG_aControlhandles [xx] [2] )
                                 MoveWIndow ( _HMG_aControlhandles [xx] [1] , _HMG_aControlCol [xx] + DeltaCol , _HMG_aControlRow [xx] + DeltaRow , _HMG_aControlWidth [xx] - SpinW + Get3DEdgeWidth() , _HMG_aControlHeight [xx] , .t. )
                              endif

                              if _HMG_aControlType [xx] == 'SPINNER' .and. z == 2

                                // JD 07/22/2007
                                 SpinW := GetWindowWidth( _HMG_aControlhandles [xx] [2] )
                                 MoveWIndow ( _HMG_aControlhandles [xx] [2] , _HMG_aControlCol [xx] + DeltaCol + _HMG_aControlWidth [xx] - SpinW , _HMG_aControlRow [xx] + DeltaRow , SpinW , _HMG_aControlHeight [xx] , .t. )
                                 _HMG_aControlRow [ xx ] := _HMG_aControlRow [ xx ] + DeltaRow
                                 _HMG_aControlCol [ xx ] := _HMG_aControlCol [ xx ] + DeltaCol
                                 _HMG_aControlContainerRow [ xx ] := Row
                                 _HMG_aControlContainerCol [ xx ] := Col
                              endif

                           EndIf

                        EnDif

                     next xx

                  Next z
               endif
            endif
         Next w
      Next r

   Case T == "SPINNER"

      // JD 07/22/2007
      SpinW := GetWindowWidth( c [2] )

      if _HMG_aControlContainerRow [x] == -1

         _HMG_aControlRow    [ x ] := Row
         _HMG_aControlCol    [ x ] := Col
         _HMG_aControlWidth  [ x ] := Width
         _HMG_aControlHeight [ x ] := Height

         // JD 07/22/2007
         MoveWindow ( c [1] , Col , Row , Width - SpinW + Get3DEdgeWidth(), Height , .t. )
         MoveWindow ( c [2] , Col + Width - SpinW , Row , SpinW , Height , .t. )

      Else

         _HMG_aControlRow    [ x ] := Row + _HMG_aControlContainerRow [x]
         _HMG_aControlCol    [ x ] := Col + _HMG_aControlContainerCol [x]
         _HMG_aControlWidth  [ x ] := Width
         _HMG_aControlHeight [ x ] := Height

         // JD 07/22/2007
         MoveWindow ( c [1] , Col + _HMG_aControlContainerCol [x] , Row + _HMG_aControlContainerRow [x] , Width - SpinW + Get3DEdgeWidth() , Height , .t. )
         MoveWindow ( c [2] , Col + _HMG_aControlContainerCol [x] + Width - SpinW , Row + _HMG_aControlContainerRow [x] , SpinW , Height , .t. )

      EndIf

   Case T == "BROWSE"

      if _HMG_aControlContainerRow [x] == -1

         _HMG_aControlRow    [ x ] := Row
         _HMG_aControlCol    [ x ] := Col
         _HMG_aControlWidth  [ x ] := Width
         _HMG_aControlHeight [ x ] := Height

         If _HMG_aControlIds[x] != 0

            MoveWindow ( c , col , Row , Width - GETVSCROLLBARWIDTH() , Height , .t. )

            hws := 0
            For b := 1 To Len ( _HMG_aControlProcedures [x] )
               hws := hws + ListView_GetColumnWidth ( _HMG_aControlHandles [x] , b - 1 )
            Next b

            if hws > _HMG_aControlWidth[x] - GETVSCROLLBARWIDTH() - 4

               MoveWindow ( _HMG_aControlIds [x] , Col + Width - GETVSCROLLBARWIDTH() , Row , GETVSCROLLBARWIDTH() , Height - GetHScrollBarHeight() , .t. )
               MoveWindow ( _HMG_aControlMiscData1 [x] [1], Col + Width - GETVSCROLLBARWIDTH() , Row + Height - GetHScrollBarHeight() , GetWindowWidth(_HMG_aControlMiscData1 [x] [1]) , GetWindowHeight( _HMG_aControlMiscData1 [x] [1] ) , .t. )

            else

               MoveWindow ( _HMG_aControlIds[x] , col + Width - GETVSCROLLBARWIDTH() , Row , GETVSCROLLBARWIDTH() , Height , .t. )
               MoveWindow ( _HMG_aControlMiscData1[x] [1], col + Width - GETVSCROLLBARWIDTH() , Row + Height - GetHScrollBarHeight() , 0 , 0 , .t. )

            endif

            _BrowseRefresh ( '' , '' , x )
            ReDrawWindow ( _HMG_aControlIds[x] )
            ReDrawWindow ( _HMG_aControlMiscData1[x] [1])
         Else
            MoveWindow ( c , col , Row , Width , Height , .t. )
         EndIf

      Else

         _HMG_aControlRow    [ x ] := Row + _HMG_aControlContainerRow [x]
         _HMG_aControlCol    [ x ] := Col + _HMG_aControlContainerCol [x]
         _HMG_aControlWidth  [ x ] := Width
         _HMG_aControlHeight [ x ] := Height

         If _HMG_aControlIds[x] != 0

            MoveWindow ( c , col + _HMG_aControlContainerCol [x], Row + _HMG_aControlContainerRow [x] , Width - GETVSCROLLBARWIDTH() , Height , .t. )

            hws := 0
            For b := 1 To Len ( _HMG_aControlProcedures [x] )
               hws := hws + ListView_GetColumnWidth ( _HMG_aControlHandles [x] , b - 1 )
            Next b

            if hws > _HMG_aControlWidth[x] - GETVSCROLLBARWIDTH() - 4

               MoveWindow ( _HMG_aControlIds[x] , col + _HMG_aControlContainerCol [x]+ Width - GETVSCROLLBARWIDTH() , Row + _HMG_aControlContainerRow [x], GETVSCROLLBARWIDTH()   , Height - GetHScrollBarHeight() , .t. )
               MoveWindow ( _HMG_aControlMiscData1[x] [1], col + _HMG_aControlContainerCol [x]+ Width - GETVSCROLLBARWIDTH() , Row + _HMG_aControlContainerRow [x]+ Height - GetHScrollBarHeight() ,;
                  GetWindowWidth(_HMG_aControlMiscData1[x] [1]) , GetWindowHeight(_HMG_aControlMiscData1[x][1]) , .t. )

            else

               MoveWindow ( _HMG_aControlIds [x] , col + _HMG_aControlContainerCol [x] + Width - GETVSCROLLBARWIDTH() , Row + _HMG_aControlContainerRow [x], GETVSCROLLBARWIDTH() , Height , .t. )
               MoveWindow ( _HMG_aControlMiscData1 [x] [1] , col + _HMG_aControlContainerCol [x] + Width - GETVSCROLLBARWIDTH() , Row + _HMG_aControlContainerRow [x] + Height - GetHScrollBarHeight() , 0 , 0 , .t. )

            endif

            _BrowseRefresh ( '' , '' , x )

            ReDrawWindow ( _HMG_aControlIds[x] )

            ReDrawWindow ( _HMG_aControlMiscData1[x] [1])

         Else
            MoveWindow ( c , col + _HMG_aControlContainerCol [x] , Row + _HMG_aControlContainerRow [x] , Width , Height , .t. )
         EndIf

      EndIf

      ReDrawWindow ( c )

   Case T == "RADIOGROUP"

      if _HMG_aControlContainerRow [x] == -1

         _HMG_aControlRow    [ x ] := Row
         _HMG_aControlCol    [ x ] := Col
         _HMG_aControlWidth  [ x ] := Width

         For i := 1 To Len ( c )

            if _HMG_aControlMiscData1 [ x ] == .t.
               NewCol := Col + ( i - 1 ) * ( Width + _HMG_aControlSpacing [ x ] )
               MoveWindow ( c [i] , NewCol , Row , Width , height , .t. )
            Else
               NewRow := Row + ( i - 1 ) * _HMG_aControlSpacing [ x ]
               MoveWindow ( c [i] , col , NewRow , Width , 28 , .t. )
            EndIf

         Next i

      Else

         _HMG_aControlRow    [ x ] := Row + _HMG_aControlContainerRow [x]
         _HMG_aControlCol    [ x ] := Col + _HMG_aControlContainerCol [x]
         _HMG_aControlWidth  [ x ] := Width

         For i := 1 To Len ( c )

            if _HMG_aControlMiscData1 [ x ] == .t.
               NewCol := Col + _HMG_aControlContainerCol [x] + ( i - 1 ) * ( Width + _HMG_aControlSpacing [ x ] )
            // JD 07/20/2007 Added _HMG_aControlContainerRow [x]
               MoveWindow ( c [i] , NewCol , Row + _HMG_aControlContainerRow [x] , Width , height , .t. )
            Else
               NewRow := Row + _HMG_aControlContainerRow [x] + ( i - 1 ) * _HMG_aControlSpacing [ x ]
               MoveWindow ( c [i] , Col + _HMG_aControlContainerCol [x] , NewRow , Width , 28 , .t. )
            EndIf

         Next i

      EndIf

   OtherWise

      if _HMG_aControlContainerRow [x] == -1

         _HMG_aControlRow    [ x ] := Row
         _HMG_aControlCol    [ x ] := Col
         _HMG_aControlWidth  [ x ] := Width
         _HMG_aControlHeight [ x ] := Height
         MoveWindow ( c , col , row , width , height , .t. )

      Else

         _HMG_aControlRow    [ x ] := Row + _HMG_aControlContainerRow [x]
         _HMG_aControlCol    [ x ] := Col + _HMG_aControlContainerCol [x]
         _HMG_aControlWidth  [ x ] := Width
         _HMG_aControlHeight [ x ] := Height
         MoveWindow ( c , col + _HMG_aControlContainerCol [x] , row + _HMG_aControlContainerRow [x] , width , height , .t. )

      EndIf

   EndCase

Return Nil

*-----------------------------------------------------------------------------*
Function _GetItemCount ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local t , c , RetVal

   t := GetControlType (ControlName,ParentForm)

   c := GetControlHandle (ControlName,ParentForm)

   do case

   case t == "TREE"
      RetVal := TreeView_GetCount ( c )

   case t == "LIST" .Or. t == "MULTILIST"
      RetVal := ListBoxGetItemCount ( c )

   case t == "COMBO"
      RetVal := ComboBoxGetItemCount ( c )

   case t == "GRID" .Or. t == "MULTIGRID"
      RetVal := ListViewGetItemCount ( c )

   case t == "TAB"
      c := GetControlIndex (ControlName,ParentForm)
      RetVal := Len ( _HMG_aControlPageMap [c] )

   endcase

Return (RetVal)

*-----------------------------------------------------------------------------*
Function _GetControlRow ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local mVar , i , nRet

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0 .Or. ( ValType ( _HMG_aControlRow [i] ) == 'U' .And. ValType ( _HMG_aControlCol [i] ) == 'U' )
      Return 0
   EndIf

   If _HMG_aControlContainerRow [ i ] == - 1
      nRet := _HMG_aControlRow [ i ]
   Else
      nRet := _HMG_aControlRow [ i ] - _HMG_aControlContainerRow [ i ]
   EndIf

Return nRet

*-----------------------------------------------------------------------------*
Function _GetControlCol ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local mVar , i , nRet

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0 .Or. ( ValType ( _HMG_aControlRow [i] ) == 'U' .And. ValType ( _HMG_aControlCol [i] ) == 'U' )
      Return 0
   EndIf

   If _HMG_aControlContainerCol [ i ] == - 1
      nRet := _HMG_aControlCol [ i ]
   Else
      nRet := _HMG_aControlCol [ i ] - _HMG_aControlContainerCol [ i ]
   EndIf

Return nRet

*-----------------------------------------------------------------------------*
Function _GetControlWidth ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return 0
   EndIf

Return ( _HMG_aControlWidth [ &mVar ] )
*-----------------------------------------------------------------------------*
Function _GetControlHeight ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local mVar , i

   mVar := '_' + ParentForm + '_' + ControlName

   i := &mVar
   if i == 0
      Return 0
   EndIf

Return ( _HMG_aControlHeight [ &mVar ] )

*-----------------------------------------------------------------------------*
Function _SetControlCaption ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*
   Local i

   i := GetControlIndex ( ControlName, ParentForm )

   _HMG_aControlCaption [i] := Value

   IF _HMG_aControlType [i] == 'TOOLBUTTON'

      SetToolButtonCaption ( _HMG_aControlContainerHandle [i] , _HMG_aControlIds [i] , Value )

   Else

      SetWindowText ( GetControlHandle( ControlName , ParentForm ) , Value )

   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _SetControlCol ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*

   _SetControlSizePos ( ControlName, ParentForm , _GetControlRow ( ControlName,ParentForm) , Value , _GetControlWidth ( ControlName,ParentForm) , _GetControlHeight ( ControlName,ParentForm) )

Return Nil
*-----------------------------------------------------------------------------*
Function _SetControlRow ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*

   _SetControlSizePos ( ControlName, ParentForm , Value , _GetControlCol ( ControlName,ParentForm) , _GetControlWidth ( ControlName,ParentForm) , _GetControlHeight ( ControlName,ParentForm) )

Return Nil
*-----------------------------------------------------------------------------*
Function _SetControlWidth ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*

   _SetControlSizePos ( ControlName, ParentForm , _GetControlRow ( ControlName,ParentForm) , _GetControlCol ( ControlName,ParentForm) , Value , _GetControlHeight ( ControlName,ParentForm) )

Return Nil
*-----------------------------------------------------------------------------*
Function _SetControlHeight ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*

   _SetControlSizePos ( ControlName, ParentForm , _GetControlRow ( ControlName,ParentForm) , _GetControlCol ( ControlName,ParentForm) , _GetControlWidth ( ControlName,ParentForm) , Value )

Return Nil

*-----------------------------------------------------------------------------*
Function _SetPicture ( ControlName, ParentForm, FileName )
*-----------------------------------------------------------------------------*
   Local w, h, t, i, n, cImage, oGet

   i := GetControlIndex ( ControlName, ParentForm )
   t := GetControlType ( ControlName, ParentForm )

   if t == 'IMAGE'

      w := _GetControlWidth ( ControlName, ParentForm )
      h := _GetControlHeight ( ControlName, ParentForm )

      DeleteObject ( _hmg_aControlBrushHandle [i] )

      _HMG_aControlPicture [i] := FileName
      _hmg_aControlBrushHandle [i] := C_SetPicture ( GetControlHandle (ControlName, ParentForm) , FileName , w , h , _HMG_aControlValue [i] , _HMG_aControlInputMask [i] )

   elseif t == 'GETBOX'

      oGet := _HMG_aControlHeadClick [i]
      oGet:SetFocus()
      oGet:Picture := Filename
      _HMG_aControlInputMask [i] := _GetPictureData( oGet, Filename )

      _SetValue( ControlName, ParentForm, oGet:VarGet(), i )

   else   // picture for buttons

      if !EMPTY(_hmg_aControlBrushhandle [i])
         DeleteObject ( _hmg_aControlBrushhandle [i] )
      endif

      if VALTYPE(Filename)=="A"   // bitmap + mask
         cImage := Filename[1]
      else
         cImage := Filename
      endif

      if _HMG_aControlMiscData1 [i] == 0             // bitmap
         n := _SetBtnPicture ( _hmg_aControlHandles [i] , cImage )
      else                                           // icon
         n := _SetBtnIcon ( _hmg_aControlHandles [i] , cImage )
      endif

      _HMG_aControlPicture [i] := FileName
      _hmg_aControlBrushHandle [i] := n

   Endif

Return Nil
*-----------------------------------------------------------------------------*
Function _GetPicture ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm ), cPicture

   if i == 0
      Return ''
   EndIf

   if valtype( _HMG_aControlPicture [i]) == "A"
      cPicture := _HMG_aControlPicture [i][1]
   else
      cPicture := _HMG_aControlPicture [i]
   endif

Return ( cPicture )
*-----------------------------------------------------------------------------*
Function GetData()
*-----------------------------------------------------------------------------*
   Local PacketNames [ aDir ( _HMG_CommPath + _HMG_StationName + '.*' ) ]
   Local i , Rows , Cols , RetVal := Nil , aItem , aTemp := {} , r , c
   Local DataValue, DataType, DataLength, Packet
   Local bd := Set ( _SET_DATEFORMAT )

   SET DATE TO ANSI

   aDir ( _HMG_CommPath + _HMG_StationName + '.*' , PacketNames )

   If Len ( PacketNames ) > 0

      Packet := MemoRead ( _HMG_CommPath + PacketNames [1] )

      Rows := Val ( SubStr ( Memoline ( Packet , , 1 ) , 11 , 99 ) )
      Cols := Val ( SubStr ( Memoline ( Packet , , 2 ) , 11 , 99 )   )

      Do Case

         // Single Data

      Case Rows == 0 .And. Cols == 0

         DataType := SubStr ( Memoline ( Packet ,  , 3 ) , 12 , 1 )
         DataLength := Val ( SubStr ( Memoline ( Packet , , 3 ) , 14 , 99 ) )

         DataValue := Memoline ( Packet , 254 , 4 )

         Do Case
         Case DataType == 'C'
            RetVal := Left ( DataValue , DataLength )
         Case DataType == 'N'
            RetVal := Val ( DataValue )
         Case DataType == 'D'
            RetVal := CTOD ( DataValue )
         Case DataType == 'L'
            RetVal := iif ( Alltrim(DataValue) == 'T' , .t. , .f. )
            End Case

         // One Dimension Array Data

         Case Rows != 0 .And. Cols == 0

            i := 3

            Do While i < MlCount ( Packet )

               DataType   := SubStr ( Memoline ( Packet , , i ) , 12 , 1 )
               DataLength := Val ( SubStr ( Memoline ( Packet , , i ) , 14 , 99 ) )

               i++

               DataValue  := Memoline ( Packet , 254 , i )

               Do Case
               Case DataType == 'C'
                  aItem := Left ( DataValue , DataLength )
               Case DataType == 'N'
                  aItem := Val ( DataValue )
               Case DataType == 'D'
                  aItem := CTOD ( DataValue )
               Case DataType == 'L'
                  aItem := iif ( Alltrim(DataValue) == 'T' , .t. , .f. )
                  End Case

                  aAdd ( aTemp , aItem )

                  i++

               EndDo

               RetVal := aTemp

         // Two Dimension Array Data

            Case Rows != 0 .And. Cols != 0

               i := 3

               aTemp := Array ( Rows , Cols )

               r := 1
               c := 1

               Do While i < MlCount ( Packet )

                  DataType   := SubStr ( Memoline ( Packet , , i ) , 12 , 1 )
                  DataLength := Val ( SubStr ( Memoline ( Packet , , i ) , 14 , 99 ) )

                  i++

                  DataValue  := Memoline ( Packet , 254 , i )

                  Do Case
                  Case DataType == 'C'
                     aItem := Left ( DataValue , DataLength )
                  Case DataType == 'N'
                     aItem := Val ( DataValue )
                  Case DataType == 'D'
                     aItem := CTOD ( DataValue )
                  Case DataType == 'L'
                     aItem := iif ( Alltrim(DataValue) == 'T' , .t. , .f. )
                     End Case

                     aTemp [r] [c] := aItem

                     c++
                     if c > Cols
                        r++
                        c := 1
                     EndIf

                     i++

                  EndDo

                  RetVal := aTemp

                  End Case

               Else
                  Set ( _SET_DATEFORMAT , bd )
                  Return Nil
               EndIf

               Delete File ( _HMG_CommPath + PacketNames [1] )

               Set ( _SET_DATEFORMAT , bd )

Return ( RetVal )
*-----------------------------------------------------------------------------*
Function SendData ( cDest , Data )
*-----------------------------------------------------------------------------*
   Local cData, i, j
   LOCAL pData, cLen, cType, FileName, Rows, Cols

   _HMG_SendDataCount++

   FileName := _HMG_CommPath + cDest + '.' + _HMG_StationName + '.' + Alltrim ( Str ( _HMG_SendDataCount ) )

   If ValType ( Data ) == 'A'

      If ValType ( Data [1] ) != 'A'

         cData := '#DataRows=' +   Alltrim(Str(Len(Data)))   + chr(13) + chr(10)
         cData := cData + '#DataCols=0'   + chr(13) + chr(10)

         For i := 1 To Len ( Data )

            cType := ValType ( Data [i] )

            If cType == 'D'
               pData := alltrim(str(year(data[i]))) + '.' + alltrim(str(month(data[i]))) + '.' + alltrim(str(day(data[i])))
               cLen := Alltrim(Str(Len(pData)))
            ElseIf cType == 'L'
               If Data [i] == .t.
                  pData := 'T'
               Else
                  pData := 'F'
               EndIf
               cLen := Alltrim(Str(Len(pData)))
            ElseIf cType == 'N'
               pData := str ( Data [i] )
               cLen := Alltrim(Str(Len(pData)))
            ElseIf cType == 'C'
               pData := Data [i]
               cLen := Alltrim(Str(Len(pData)))
            Else
               MsgMiniGuiError('SendData: Type Not Suported. Program terminated')
            EndIf

            cData := cData + '#DataBlock='   + cType   + ',' + cLen + chr(13) + chr(10)
            cData := cData + pData      + chr(13) + chr(10)

         Next i

         MemoWrit ( FileName , cData )

      Else

         Rows := Len ( Data )
         Cols := Len ( Data [1] )

         cData := '#DataRows=' +   Alltrim(Str(Rows))   + chr(13) + chr(10)
         cData := cData + '#DataCols=' +   Alltrim(Str(Cols)) + chr(13) + chr(10)

         For i := 1 To Rows

            For j := 1 To Cols

               cType := ValType ( Data [i] [j] )

               If cType == 'D'
                  pData := alltrim(str(year(data[i][j]))) + '.' + alltrim(str(month(data[i][j]))) + '.' + alltrim(str(day(data[i][j])))
                  cLen := Alltrim(Str(Len(pData)))
               ElseIf cType == 'L'
                  If Data [i] [j] == .t.
                     pData := 'T'
                  Else
                     pData := 'F'
                  EndIf
                  cLen := Alltrim(Str(Len(pData)))
               ElseIf cType == 'N'
                  pData := str ( Data [i] [j] )
                  cLen := Alltrim(Str(Len(pData)))
               ElseIf cType == 'C'
                  pData := Data [i] [j]
                  cLen := Alltrim(Str(Len(pData)))
               Else
                  MsgMiniGuiError('SendData: Type Not Suported. Program terminated')
               EndIf

               cData := cData + '#DataBlock='   + cType   + ',' + cLen+ chr(13) + chr(10)
               cData := cData + pData      + chr(13) + chr(10)

            Next j
         Next i

         MemoWrit ( FileName , cData )

      EndIf

   Else

      cType := ValType ( Data )

      If cType == 'D'
         pData := alltrim(str(year(data))) + '.' + alltrim(str(month(data))) + '.' + alltrim(str(day(data)))
         cLen := Alltrim(Str(Len(pData)))
      ElseIf cType == 'L'
         If Data == .t.
            pData := 'T'
         Else
            pData := 'F'
         EndIf
         cLen := Alltrim(Str(Len(pData)))
      ElseIf cType == 'N'
         pData := str ( Data )
         cLen := Alltrim(Str(Len(pData)))
      ElseIf cType == 'C'
         pData := Data
         cLen := Alltrim(Str(Len(pData)))
      Else
         MsgMiniGuiError('SendData: Type Not Suported. Program terminated')
      EndIf

      cData := '#DataRows=0'      + chr(13) + chr(10)
      cData := cData + '#DataCols=0'   + chr(13) + chr(10)

      cData := cData + '#DataBlock='   + cType + ',' + cLen+ chr(13) + chr(10)
      cData := cData + pData      + chr(13) + chr(10)

      MemoWrit ( FileName , cData )

   EndIf

Return Nil
*-----------------------------------------------------------------------------*
Function _EnableToolbarButton ( ButtonName , FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local cCaption
   Local c
   Local bAction

   i := GetControlIndex ( ButtonName, FormName )

   if i > 0

      cEnableToolbarButton( _HMG_aControlContainerHandle [i] , GetControlId( ButtonName, FormName ) )

      bAction := _HMG_aControlProcedures [i]

      cCaption := _HMG_aControlCaption [i]

      If ValType ( cCaption ) != 'U'

         cCaption := Upper ( cCaption )

         i := At ( '&' , cCaption )

         If i > 0
            c := Asc ( SubStr ( cCaption , i + 1 , 1 ) )

            If c >= 48 .And. c <= 90
               _DefineHotKey ( FormName , MOD_ALT , c , bAction )
            EndIf
         EndIf

      EndIf

   EndIf

Return Nil
*-----------------------------------------------------------------------------*
Function _DisableToolbarButton ( ButtonName, FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local cCaption
   Local c

   i := GetControlIndex ( ButtonName, FormName )

   if i > 0

      cDisableToolbarButton( _HMG_aControlContainerHandle [i] , GetControlId( ButtonName, FormName ) )

      cCaption := _HMG_aControlCaption [i]

      If ValType ( cCaption ) != 'U'

         cCaption := Upper ( cCaption )

         i := At ( '&' , cCaption )

         If i > 0

            c := Asc ( SubStr ( cCaption , i + 1 , 1 ) )

            If c >= 48 .And. c <= 90
               _ReleaseHotKey ( FormName , MOD_ALT , c )
            EndIf

         EndIf

      EndIf

   EndIf

Return NIL

*-----------------------------------------------------------------------------*
Function _DefineLetterOrDigitHotKey ( Caption, i, FormName, bAction )
*-----------------------------------------------------------------------------*
   Local c := Asc ( SubStr ( Caption , i + 1 , 1 ) )

   If c >= 48 .And. c <= 90
      _DefineHotKey ( FormName , MOD_ALT , c , bAction )
   EndIf

Return NIL

// (JK) HMG 1.0 Experimental Build 8
*-----------------------------------------------------------------------------*
Function _GetComboItemValue( ControlName, ParentForm, nItemIndex)
*-----------------------------------------------------------------------------*
   if GetControlIndex ( ControlName, ParentForm ) == 0
      Return NIL
   EndIf

Return ( ComboGetString ( GetControlHandle ( ControlName, ParentForm ), nItemIndex ) )

*-----------------------------------------------------------------------------*
Function _GetControlAction( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )

   if i == 0
      Return ''
   EndIf

Return ( _HMG_aControlProcedures [i] )
*-----------------------------------------------------------------------------*
Function _SetControlAction( ControlName, ParentForm , Value )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )

   if i == 0
      Return Nil
   EndIf

   _HMG_aControlProcedures [i] := Value

Return Nil
*-----------------------------------------------------------------------------*
Function _GetToolTip ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )

   if i == 0
      Return ''
   EndIf

Return ( _HMG_aControlToolTip [i] )
*-----------------------------------------------------------------------------*
Function _SetToolTip ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , t

   i := GetControlIndex ( ControlName, ParentForm )

   if i == 0
      Return Nil
   EndIf

   _HMG_aControlToolTip [i] := Value

   h := GetFormToolTipHandle ( ParentForm )

   SetToolTip ( _HMG_aControlHandles [i] , Value , h )

   // tooltips for editable or/and extend combo
   // HMG 1.0 Experimental Build 8

   t := GetControlType ( ControlName, ParentForm )

   if t == 'COMBO'
      IF !empty( _hmg_acontrolrangemin [i] )
         SetToolTip ( _hmg_acontrolrangemin [i] , Value , h )
      ENDIF
      IF !empty( _hmg_acontrolrangemax [i] )
         SetToolTip ( _hmg_acontrolrangemax [i] , Value , h )
      ENDIF
   endif

Return Nil

*-----------------------------------------------------------------------------*
Function _SetRangeMin ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , t , m

   i := GetControlIndex ( ControlName, ParentForm )
   h := _HMG_aControlhandles [i]
   t := GetControlType ( ControlName, ParentForm )
   m := _HMG_aControlRangeMax [i]

   DO CASE

   CASE T == 'SLIDER'

      SetSliderRange ( h , Value , m )

   CASE T == 'SPINNER'

      SetSpinnerRange ( h[2] , Value , m )

   CASE T == 'PROGRESSBAR'

      SetProgressBarRange ( h , Value , m )

   END CASE

   _HMG_aControlRangeMin [i] := Value

Return Nil
*-----------------------------------------------------------------------------*
Function _SetRangeMax ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , t , m

   i := GetControlIndex ( ControlName, ParentForm )
   h := _HMG_aControlhandles [i]
   t := GetControlType ( ControlName, ParentForm )
   m := _HMG_aControlRangeMin [i]

   DO CASE

   CASE T == 'SLIDER'

      SetSliderRange ( h , m, Value  )

   CASE T == 'SPINNER'

      SetSpinnerRange ( h[2] , m , Value )

   CASE T == 'PROGRESSBAR'

      SetProgressBarRange ( h , m , Value )

   END CASE

   _HMG_aControlRangeMax [i] := Value

Return Nil

*-----------------------------------------------------------------------------*
Function _GetRangeMin ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )

   if i == 0
      Return 0
   EndIf

Return ( _HMG_aControlRangeMin [i] )

*-----------------------------------------------------------------------------*
Function _GetRangeMax ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )

   if i == 0
      Return 0
   EndIf

Return ( _HMG_aControlRangeMax [i] )

*-----------------------------------------------------------------------------*
Function _SetMultiCaption ( ControlName, ParentForm , Column , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , t

   i := GetControlIndex ( ControlName, ParentForm )

    // JD 11/30/2006
   if i > 0

      h := _HMG_aControlhandles [i]

      t := GetControlType ( ControlName, ParentForm )

      _HMG_aControlCaption [i] [Column] := Value

      Do Case

      Case t == 'GRID' .Or. t == 'MULTIGRID'

         SETGRIDCOLUMNHEADER ( h , Column , Value , _HMG_aControlMiscData1 [i,3] [Column] )

      Case t == 'BROWSE'

         SETGRIDCOLUMNHEADER ( h , Column , Value , _HMG_aControlRangeMax [i] [Column] )

      Case t == 'RADIOGROUP'

         SetWindowText ( h [Column] , Value )

      Case t == 'TAB'

         SETTABCAPTION ( h , Column , Value )

      EndCase

   endif

Return Nil

*-----------------------------------------------------------------------------*
Function _GetMultiCaption ( ControlName, ParentForm , Item )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )

   if i == 0
      Return ''
   EndIf

Return ( _HMG_aControlCaption [i] [Item] )

*-----------------------------------------------------------------------------*
Function _SetMultiImage ( ControlName, ParentForm, Column, Value, lLeftAlign )
*-----------------------------------------------------------------------------*
   Local i , h , t

   default lLeftAlign to .F.

   i := GetControlIndex ( ControlName, ParentForm )

   if i > 0

      h := _HMG_aControlhandles [i]

      t := GetControlType ( ControlName, ParentForm )

      Do Case

      Case t == 'GRID' .Or. t == 'MULTIGRID' .Or. t == 'BROWSE' // EF 01/09/2008
         SetGridColumnHeaderImage ( h , Column , Value, lLeftAlign )

      Case t == 'TAB' // JD 11/30/2006
         if Column > 0 .And. Column <= Len( _HMG_aControlPicture [i] )
            _HMG_aControlPicture [i] [Column] := Value
         endif

         if !EMPTY( _HMG_aControlInputMask [i] )
            IMAGELIST_DESTROY ( _HMG_aControlInputMask [i] )
         endif

         _HMG_aControlInputMask [i] := AddTabBitMap ( h, _HMG_aControlPicture [i] )

      EndCase

   endif

Return Nil

*-----------------------------------------------------------------------------*
Function _GetMultiImage ( ControlName, ParentForm, Item ) // JD 11/30/2006
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )

   if i == 0
      Return ''
   EndIf

Return ( _HMG_aControlPicture [i] [Item] )

*-----------------------------------------------------------------------------*
Function InputWindow ( cTitle , aLabels , aValues , aFormats , nRow , nCol, lCenterWindow, aButOKCancelCaptions )
*-----------------------------------------------------------------------------*
   Local i , l , ControlRow , e := 0 , LN , CN , r , c , wHeight , diff

   lCenterWindow := IF( nRow=NIL .and. nCol=NIL, .t., .f. )
   default nRow to 0
   default nCol to 0
   default aButOKCancelCaptions to {}

   if Len( aButOKCancelCaptions ) = 0

      if Set ( _SET_LANGUAGE ) == 'ES'
         aadd(aButOKCancelCaptions,'Aceptar')
         aadd(aButOKCancelCaptions,'Cancelar')
      else
         aadd(aButOKCancelCaptions,'OK')
         aadd(aButOKCancelCaptions,'Cancel')
      endif

   endif

   l := Len ( aLabels )

   Private aResult [l]

   For i := 1 to l

      if ValType ( aValues[i] ) == 'C'

         if ValType ( aFormats[i] ) == 'N'

            If aFormats[i] > 32
               e++
            Endif

         EndIf

      EndIf

      if ValType ( aValues[i] ) == 'M'
         e++
      EndIf

   Next i

   if pcount() == 4
      r := 0
      c := 0
   Else
      r := nRow
      c := nCol
      wHeight := (l*30) + 90 + (e*60)

      if r + wHeight > GetDeskTopHeight()

         diff := r + wHeight - GetDeskTopHeight()
         r := r - diff

      EndIf

   EndIf

   DEFINE WINDOW _InputWindow;
      AT r,c;
      WIDTH 280;
      HEIGHT (l*30) + 90 + (e*60);
      TITLE cTitle;
      MODAL;
      NOSIZE

      ControlRow :=  10

      For i := 1 to l

         LN := 'Label_' + Alltrim(Str(i,2,0))
         CN := 'Control_' + Alltrim(Str(i,2,0))

         @ ControlRow , 10 LABEL &LN OF _InputWindow VALUE aLabels [i] WIDTH 90

         do case
         case ValType ( aValues [i] ) == 'L'

            @ ControlRow , 120 CHECKBOX &CN OF _InputWindow CAPTION '' VALUE aValues[i]
            ControlRow := ControlRow + 30

         case ValType ( aValues [i] ) == 'D'

            @ ControlRow , 120 DATEPICKER &CN  OF _InputWindow VALUE aValues[i] WIDTH 140
            ControlRow := ControlRow + 30

         case ValType ( aValues [i] ) == 'N'

            If ValType ( aFormats [i] ) == 'A'

               @ ControlRow , 120 COMBOBOX &CN  OF _InputWindow ITEMS aFormats[i] VALUE aValues[i] WIDTH 140  FONT 'Arial' SIZE 10
               ControlRow := ControlRow + 30

            ElseIf  ValType ( aFormats [i] ) == 'C'

               If AT ( '.' , aFormats [i] ) > 0
                  @ ControlRow , 120 TEXTBOX &CN  OF _InputWindow VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 NUMERIC INPUTMASK aFormats [i]
               Else
                  @ ControlRow , 120 TEXTBOX &CN  OF _InputWindow VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 MAXLENGTH Len(aFormats [i]) NUMERIC
               EndIf

               ControlRow := ControlRow + 30
            Endif

         case ValType ( aValues [i] ) == 'C'

            If ValType ( aFormats [i] ) == 'N'
               If  aFormats [i] <= 32
                  @ ControlRow , 120 TEXTBOX &CN  OF _InputWindow VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 MAXLENGTH aFormats [i]
                  ControlRow := ControlRow + 30
               Else
                  @ ControlRow , 120 EDITBOX &CN  OF _InputWindow WIDTH 140 HEIGHT 90 VALUE aValues[i] FONT 'Arial' SIZE 10 MAXLENGTH aFormats[i]
                  ControlRow := ControlRow + 94
               EndIf
            EndIf

         case ValType ( aValues [i] ) == 'M'

            @ ControlRow , 120 EDITBOX &CN  OF _InputWindow WIDTH 140 HEIGHT 90 VALUE aValues[i] FONT 'Arial' SIZE 10
            ControlRow := ControlRow + 94

         endcase

      Next i

      @ ControlRow + 10 , 30 BUTTON BUTTON_1;
         OF _InputWindow;
         CAPTION aButOKCancelCaptions[1];
         ACTION _InputWindowOk()

      @ ControlRow + 10 , 140 BUTTON BUTTON_2;
         OF _InputWindow;
         CAPTION aButOKCancelCaptions[2];
         ACTION _InputWindowCancel()

      _SetFocus ('Control_1','_InputWindow')

   END WINDOW

   if lCenterWindow
      CENTER WINDOW _InputWindow
   EndIf

   ACTIVATE WINDOW _InputWindow

Return ( aResult )
*-----------------------------------------------------------------------------*
Function _InputWindowOk
*-----------------------------------------------------------------------------*
   Local i , ControlName

   For i := 1 to len (aResult)

      ControlName := 'Control_' + Alltrim ( Str ( i , 0 ) )
      aResult [i] := _GetValue ( ControlName , '_InputWindow' )

   Next i

   RELEASE WINDOW _InputWindow

Return Nil
*-----------------------------------------------------------------------------*
Function _InputWindowCancel
*-----------------------------------------------------------------------------*
   Local i

   For i := 1 to len (aResult)

      aResult [i] := Nil

   Next i

   RELEASE WINDOW _InputWindow

Return Nil

*-----------------------------------------------------------------------------*
Function _ReleaseControl ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i , t , r , w , z , x , y , k

   i := GetControlIndex ( ControlName, ParentForm )
   t := GetControlType ( ControlName, ParentForm )
   k := GetFormIndex (ParentForm)

   Do Case

   Case t == "ANIMATEBOX"
      _DestroyAnimateBox ( ControlName , ParentForm )

   Case t == "PLAYER"
      _DestroyPlayer ( ControlName , ParentForm )

   Case t == "SPINNER"
      ReleaseControl ( _HMG_aControlHandles [i] [1] )
      ReleaseControl ( _HMG_aControlHandles [i] [2] )

   Case t == "MESSAGEBAR"

      if _IsControlDefined ( 'StatusTimer' , ParentForm )
         ReleaseControl ( _HMG_aControlHandles [ GetControlIndex ( 'StatusTimer' , ParentForm) ] )
         _EraseControl ( GetControlIndex ( 'StatusTimer' , ParentForm ) , k )
      endif

      if _IsControlDefined ( 'StatusKeyBrd' , ParentForm )
         ReleaseControl ( _HMG_aControlHandles [ GetControlIndex ( 'StatusKeyBrd' , ParentForm ) ] )
         _EraseControl ( GetControlIndex ( 'StatusKeyBrd' , ParentForm ) , k )
      endif

      ReleaseControl ( _HMG_aControlHandles [i] )

   Case t == "BROWSE"

      ReleaseControl ( _HMG_aControlHandles [i] )

      if _HMG_aControlIds [i] != 0

         ReleaseControl ( _HMG_aControlIds [i] )
         ReleaseControl ( _HMG_aControlMiscData1 [i] [1])

      endif

   Case t == "RADIOGROUP"

      For x:= 1 To Len( _HMG_aControlHandles [i] )
         ReleaseControl ( _HMG_aControlHandles [i] [x] )
      Next x

   Case t == "TAB"

      for r = 1 to len ( _HMG_aControlPageMap [i] )
         for w = 1 to len (_HMG_aControlPageMap [i] [r])
            if valtype ( _HMG_aControlPageMap [i] [r] [w] ) <> "A"
               ReleaseControl ( _HMG_aControlPageMap [i] [r] [w] )
               x := ascan ( _HMG_aControlhandles , _HMG_aControlPageMap [i] [r] [w] )
               if x > 0
                  _EraseControl(x,k)
               EndIf
            else
               for z = 1 to len ( _HMG_aControlPageMap [i] [r] [w] )
                  ReleaseControl ( _HMG_aControlPageMap [i] [r] [w] [z] )
               Next z

               For x := 1 To Len (_HMG_aControlhandles)
                  If ValType( _HMG_aControlhandles [x] ) == 'A'
                     If _HMG_aControlhandles [x] [1] == _HMG_aControlPageMap [i] [r] [w] [1]
                        _EraseControl(x,k)
                        Exit
                     EndIf
                  EndIf
               Next x

            endif
         Next w
      Next r

      ReleaseControl ( _HMG_aControlHandles [i] )

   OtherWise
      ReleaseControl ( _HMG_aControlHandles [i] )

   EndCase

   // If the control is inside a TAB, PageMap must be updated

   For y := 1 To Len ( _HMG_aControlPageMap )

      if _HMG_aControlType [y] == "TAB"

         for r = 1 to len ( _HMG_aControlPageMap [y] )

            for w = 1 to len (_HMG_aControlPageMap [y] [r])

               if t == 'RADIOGROUP'

                  if ValType (_HMG_aControlPageMap [y] [r] [w]) == 'A'

                     if _HMG_aControlPageMap [y] [r] [w] [1] == _HMG_aControlHandles [i] [1]

                        adel ( _HMG_aControlPageMap [y] [r] , w )
                        asize ( _HMG_aControlPageMap [y] [r] , Len(_HMG_aControlPageMap [y] [r])-1 )
                        Exit

                     EndIf

                  EndIf

               Elseif t == 'SPINNER'

                  if ValType (_HMG_aControlPageMap [y] [r] [w]) == 'A'

                     if _HMG_aControlPageMap [y] [r] [w] [1] == _HMG_aControlHandles [i] [1]

                        adel ( _HMG_aControlPageMap [y] [r] , w )
                        asize ( _HMG_aControlPageMap [y] [r] , Len(_HMG_aControlPageMap [y] [r])-1 )
                        Exit

                     EndIf

                  EndIf

               Elseif t == 'BROWSE'

                  if ValType (_HMG_aControlPageMap [y] [r] [w]) == 'A'

                     if _HMG_aControlPageMap [y] [r] [w] [1] == _HMG_aControlHandles [i]

                        adel ( _HMG_aControlPageMap [y] [r] , w )
                        asize ( _HMG_aControlPageMap [y] [r] , Len(_HMG_aControlPageMap [y] [r])-1 )
                        Exit

                     EndIf

                  Elseif ValType (_HMG_aControlPageMap [y] [r] [w]) == 'N'

                     if _HMG_aControlPageMap [y] [r] [w] == _HMG_aControlHandles [i]

                        adel ( _HMG_aControlPageMap [y] [r] , w )
                        asize ( _HMG_aControlPageMap [y] [r] , Len(_HMG_aControlPageMap [y] [r])-1 )
                        Exit

                     EndIf


                  EndIf

               Else

                  if ValType (_HMG_aControlPageMap [y] [r] [w]) == 'N'

                     if _HMG_aControlPageMap [y] [r] [w] == _HMG_aControlHandles [i]

                        adel ( _HMG_aControlPageMap [y] [r] , w )
                        asize ( _HMG_aControlPageMap [y] [r] , Len(_HMG_aControlPageMap [y] [r])-1 )
                        Exit

                     EndIf

                  EndIf

               EndIf

            Next w

         next r

      EndIf

   Next y

   _EraseControl(i,k)

Return Nil
*-----------------------------------------------------------------------------*
Function _EraseControl (i,p)
*-----------------------------------------------------------------------------*
   Local mVar, t

   DeleteObject ( _HMG_aControlFontHandle [i] )
   DeleteObject ( _HMG_aControlBrushHandle [i] )

   t := _HMG_aControlType [i]

   Do Case

   Case t == 'HOTKEY'
      ReleaseHotKey ( _HMG_aControlParentHandles [i] , _HMG_aControlIds [i] )

   Case t == 'LABEL'
      If _HMG_aControlMiscData1 [i] [2] == .t.
         _ReleaseControl ( 'BlinkTimer' + Ltrim( Str(i) ), _HMG_aFormNames [p] )
      EndIf

   Case t == 'TAB'
      If !EMPTY( _HMG_aControlInputMask [i] )
         IMAGELIST_DESTROY ( _HMG_aControlInputMask [i] )
      EndIf

   Case t == 'BROWSE'
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICBACKCOLOR' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICFORECOLOR' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_WHEN' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DBC' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DFC' )

      If !EMPTY( _HMG_aControlMiscData1 [i] [15] )
         IMAGELIST_DESTROY ( _HMG_aControlMiscData1 [i] [15] )
      EndIf

   Case 'GRID' $ t
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_INPLACE' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_EDITCONTROLS' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICBACKCOLOR' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICFORECOLOR' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DBC' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DFC' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_COLUMNVALID' )
      __MVXRELEASE ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_COLUMNWHEN' )

      If !EMPTY( _HMG_aControlContainerHandle [i] )
         IMAGELIST_DESTROY ( _HMG_aControlContainerHandle [i] )
      EndIf

   EndCase

   mVar := '_' + _HMG_aFormNames [p] + '_' + _HMG_aControlNames [i]
   if type ( mVar ) != 'U'
#ifdef _ZEROPUBLIC_
      __MVPUT ( mVar , 0 )
      #else
      __MVXRELEASE( mVar )
#endif
   EndIf

   _HMG_aControlDeleted         [i] := .T.
   _HMG_aControlType            [i] := ""
   _HMG_aControlNames           [i] := ""
   _HMG_aControlHandles         [i] := 0
   _HMG_aControlParentHandles       [i] := 0
   _HMG_aControlIds         [i] := 0
   _HMG_aControlProcedures      [i] := ""
   _HMG_aControlPageMap         [i] := {}
   _HMG_aControlValue           [i] := Nil
   _HMG_aControlInputMask       [i] := ""
   _HMG_aControllostFocusProcedure  [i] := ""
   _HMG_aControlGotFocusProcedure   [i] := ""
   _HMG_aControlChangeProcedure     [i] := ""
   _HMG_aControlBkColor         [i] := Nil
   _HMG_aControlFontColor       [i] := Nil
   _HMG_aControlDblClick        [i] := ""
   _HMG_aControlHeadClick       [i] := {}
   _HMG_aControlRow         [i] := 0
   _HMG_aControlCol         [i] := 0
   _HMG_aControlWidth           [i] := 0
   _HMG_aControlHeight          [i] := 0
   _HMG_aControlSpacing         [i] := 0
   _HMG_aControlContainerRow        [i] := 0
   _HMG_aControlContainerCol        [i] := 0
   _HMG_aControlPicture         [i] := ''
   _HMG_aControlContainerHandle     [i] := 0
   _HMG_aControlFontName        [i] := ''
   _HMG_aControlFontSize        [i] := 0
   _HMG_aControlToolTip         [i] := ''
   _HMG_aControlRangeMin        [i] := 0
   _HMG_aControlRangeMax        [i] := 0
   _HMG_aControlCaption         [i] := ''
   _HMG_aControlVisible         [i] := .F.
   _HMG_aControlHelpId          [i] := 0
   _HMG_aControlFontHandle      [i] := 0
   _HMG_aControlFontAttributes      [i] := {}
   _HMG_aControlBrushHandle     [i] := 0
   _HMG_aControlEnabled         [i] := .F.
   _HMG_aControlMiscData1       [i] := 0

Return Nil
*-----------------------------------------------------------------------------*
Function _IsControlVisibleFromHandle (Handle)
*-----------------------------------------------------------------------------*
   Local x, lVisible := .f.

   For x := 1 To Len ( _HMG_aControlHandles )

      If ValType ( _HMG_aControlHandles [x] ) == 'N'

         If _HMG_aControlHandles [x] == Handle
            lVisible := _HMG_aControlVisible [x]
            Exit
         EndIf

      ElseIf ValType ( _HMG_aControlHandles [x] ) == 'A'

         If _HMG_aControlHandles [x] [1] == Handle
            lVisible := _HMG_aControlVisible [x]
            Exit
         EndIf

      EndIf

   Next x

Return lVisible
*-----------------------------------------------------------------------------*
Function _IsControlVisible ( ControlName , FormName )
*-----------------------------------------------------------------------------*
   Local ix, lVisible := .f.

   ix := GetControlIndex ( ControlName, FormName )

   if ix > 0
      lVisible := _HMG_aControlVisible [ix]
   endif

Return lVisible

*-----------------------------------------------------------------------------*
Function _SetCaretPos ( ControlName , FormName , Pos )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, FormName )

   if i == 0
      Return Nil
   EndIf

   SendMessage( _HMG_aControlhandles [i] , EM_SETSEL , Pos , Pos )

Return Nil
*-----------------------------------------------------------------------------*
Function _GetCaretPos ( ControlName , FormName )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, FormName )

   If i == 0
      Return 0
   EndIf

Return ( HiWord ( SendMessage( _HMG_aControlhandles [i] , EM_GETSEL , 0 , 0 ) ) )

*-----------------------------------------------------------------------------*
Function _GetId( nMax )
*-----------------------------------------------------------------------------*
   Local RetVal , i

   default nMax to 65000

   REPEAT
   RetVal := Random ( nMax )
   i := ascan ( _HMG_aControlIds , RetVal )
   UNTIL i != 0

Return RetVal

*-----------------------------------------------------------------------------*
Function Random( nLimit )
*-----------------------------------------------------------------------------*
Return HB_RandomInt( 1, IFNUMERIC(nLimit, nLimit, 65535) )

*-----------------------------------------------------------------------------*
Function SetProperty ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )
*-----------------------------------------------------------------------------*
   Local i
#ifdef _USERINIT_
   Local cMacro
#endif

   If Pcount() == 3 // Window

      If .Not. _IsWindowDefined ( Arg1 )
         MsgMiniGuiError("Window: "+ Arg1 + " is not defined. Program terminated" )
      Endif

      Arg2 := Upper (Arg2)

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomPropertyProcedure )

         If Arg2 == _HMG_aCustomPropertyProcedure [i] [1]
            cMacro := _HMG_aCustomPropertyProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 , Arg3 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif
      If     Arg2 == 'TITLE'

         SetWindowText ( GetFormHandle( Arg1 ) , Arg3 )

      ELseIf Arg2 == 'HEIGHT'

         _SetWindowSizePos ( Arg1 , , , , Arg3 )

      ElseIf Arg2 == 'WIDTH'

         _SetWindowSizePos ( Arg1 , , , Arg3 , )

      ElseIf Arg2 == 'COL'

         _SetWindowSizePos ( Arg1 , , Arg3 , , )

      ElseIf Arg2 == 'ROW'

         _SetWindowSizePos ( Arg1 , Arg3 , , , )

      ElseIf Arg2 == 'NOTIFYICON'

         _SetNotifyIconName ( Arg1 , Arg3 )

      ElseIf Arg2 == 'NOTIFYTOOLTIP'

         _SetNotifyIconTooltip ( Arg1 , Arg3 )

      ElseIf Arg2 == 'CURSOR'

         SetWindowCursor ( GetFormHandle( Arg1 ) , Arg3 )

      ElseIf Arg2 == 'BACKCOLOR'

         _SetWindowBackColor ( GetFormHandle( Arg1 ) , Arg3 )

      ElseIf Arg2 == 'MINWIDTH' // Grigory Filatov HMG 1.4 Ext Build 43

         i := GetFormIndex ( Arg1 )

         if i >= 0 .and. i <= Len ( _hmg_aFormHandles )

            _HMG_aFormMinMaxInfo [i] [5] := Arg3

         EndIf

      ElseIf Arg2 == 'MINHEIGHT'

         i := GetFormIndex ( Arg1 )

         if i >= 0 .and. i <= Len ( _hmg_aFormHandles )

            _HMG_aFormMinMaxInfo [i] [6] := Arg3

         EndIf

      ElseIf Arg2 == 'MAXWIDTH'

         i := GetFormIndex ( Arg1 )

         if i >= 0 .and. i <= Len ( _hmg_aFormHandles )

            _HMG_aFormMinMaxInfo [i] [7] := Arg3

         EndIf

      ElseIf Arg2 == 'MAXHEIGHT'

         i := GetFormIndex ( Arg1 )

         if i >= 0 .and. i <= Len ( _hmg_aFormHandles )

            _HMG_aFormMinMaxInfo [i] [8] := Arg3

         EndIf

      EndIf

   ElseIf Pcount() == 4 // CONTROL

      Arg3 := Upper (Arg3)

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomPropertyProcedure )

         If Arg3 == _HMG_aCustomPropertyProcedure [i] [1]
            cMacro := _HMG_aCustomPropertyProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 , Arg3 , Arg4 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif
      If .Not. _IsControlDefined ( Arg2 , Arg1 )
         MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
      endif

      If     Arg3 == 'VALUE'

         _SetValue ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FORMATSTRING'

         _SetDatePickerDateFormat ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'ALLOWEDIT'

         _SetBrowseAllowEdit ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'ALLOWAPPEND'

         _SetBrowseAllowAppend ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'ALLOWDELETE'

         _SetBrowseAllowDelete ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'PICTURE' .or. Arg3 == 'ICON'

         _SetPicture ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'TOOLTIP'

         _SetTooltip ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FONTNAME'

         _SetFontName ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FONTSIZE'

         _SetFontSize ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FONTBOLD'

         _SetFontBold ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FONTITALIC'

         _SetFontItalic ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FONTUNDERLINE'

         _SetFontUnderline ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FONTSTRIKEOUT'

         _SetFontStrikeout ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'CAPTION'

         _SetControlCaption( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'ACTION' // GF 10/22/2008

         _SetControlAction ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'DISPLAYVALUE'

         SetWindowText ( GetControlHandle( Arg2 , Arg1 ) , Arg4 )

      ElseIf Arg3 == 'ROW'

         _SetControlRow ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'COL'

         _SetControlCol ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'LISTWIDTH'

         _SetDropDownWidth(Arg2 , Arg1 , Arg4)

      ElseIf Arg3 == 'WIDTH'

         _SetControlWidth ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'HEIGHT'

         _SetControlHeight ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'VISIBLE'

         iif ( Arg4 == .t. , _ShowControl ( Arg2 , Arg1 ) , _HideControl ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'ENABLED'

         iif ( Arg4 == .t. , _EnableControl ( Arg2 , Arg1 ) , _DisableControl ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'CHECKED'

         iif ( Arg4 == .t. , _CheckMenuItem ( Arg2 , Arg1 ) , _UnCheckMenuItem ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'RANGEMIN'

         _SetRangeMin ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'RANGEMAX'

         _SetRangeMax ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'REPEAT'

         If Arg4 == .t.
            _SetPlayerRepeatOn ( Arg2 , Arg1 )
         Else
            _SetPlayerRepeatOff ( Arg2 , Arg1 )
         EndIf

      ElseIf Arg3 == 'SPEED'

         _SetPlayerSpeed ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'VOLUME'

         _SetPlayerVolume ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'ZOOM'

         _SetPlayerZoom ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'POSITION'

         If Arg4 == 0
            _SetPlayerPositionHome ( Arg2 , Arg1 )
         ElseIf Arg4 == 1
            _SetPlayerPositionEnd ( Arg2 , Arg1 )
         EndIf

      ElseIf Arg3 == 'CARETPOS'

         _SetCaretPos ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'BACKCOLOR'

         _SetBackColor ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FONTCOLOR'

         _SetFontColor ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'FORECOLOR'

         _SetFontColor ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'ADDRESS'

         _SetAddress ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'INPUTITEMS'

         _SetBrowseInputItems ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'DISPLAYITEMS'

         _SetBrowseDisplayItems ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'READONLY'

         If GetControlType ( Arg2 , Arg1 ) == 'RADIOGROUP'
            _SetRadioGroupReadOnly ( Arg2 , Arg1 , Arg4 )
         Else
            _SetTextEditReadOnly ( Arg2 , Arg1 , Arg4 )
         EndIf

      ElseIf Arg3 == 'ITEMCOUNT'

         ListView_SetItemCount ( GetControlHandle ( Arg2 , Arg1 ) , Arg4 )

      ElseIf Arg3 == 'INDENT'

         TreeView_SetIndent( GetControlHandle ( Arg2 , Arg1 ), Arg4 )

      ElseIf Arg3 == 'LINECOLOR'

         TreeView_SetLineColor( GetControlHandle ( Arg2 , Arg1 ), Arg4 )

      ElseIf Arg3 == 'ITEMHEIGHT'

         TreeView_SetItemHeight( GetControlHandle ( Arg2 , Arg1 ), Arg4 )

      ElseIf Arg3 == 'RICHVALUE' // Kevin Carmody <i@kevincarmody.com> 2007.04.23

         _SetGetRichValue ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'AUTOFONT' // Kevin Carmody <i@kevincarmody.com> 2007.04.23

         _SetGetAutoFont ( Arg2 , Arg1 , Arg4 )

      EndIf

   ElseIf Pcount() == 5 // CONTROL WITH ARGUMENT OR TOOLBAR BUTTON OR
			// SPLITBOX CHILD CONTROL WITHOUT ARGUMENT

      If Upper(Arg2) <> 'SPLITBOX' .And. GetControlType ( Arg2 , Arg1 ) != 'TOOLBAR'

         If .Not. _IsControlDefined ( Arg2 , Arg1 )
            MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
         endif

      EndIf

      Arg3 := Upper (Arg3)

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomPropertyProcedure )

         If Arg3 == _HMG_aCustomPropertyProcedure [i] [1]
            cMacro := _HMG_aCustomPropertyProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif

      If     Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )

            SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 )

         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      Else
         If     Arg3 == 'CAPTION'

            _SetMultiCaption ( Arg2 , Arg1 , Arg4 , Arg5 )

         ElseIf Arg3 == 'HEADER'

            _SetMultiCaption ( Arg2 , Arg1 , Arg4 , Arg5 )

         ElseIf Arg3 == 'IMAGE' .or. Arg3 == 'HEADERIMAGE'

            _SetMultiImage ( Arg2 , Arg1 , Arg4 , Arg5 )

         ElseIf Arg3 == 'ITEM'

            _SetItem ( Arg2 , Arg1 , Arg4 , Arg5 )

         ElseIf Arg3 == 'ICON'

            _SetStatusIcon ( Arg2 , Arg1 , Arg4 , Arg5 )

         ElseIf Arg3 == 'WIDTH'

            _SetStatusWidth ( Arg1 , Arg4 , Arg5 )

         ElseIf Arg3 == 'COLUMNWIDTH'  //(JK) HMG 1.0 Experimental Build 6

            _SetColumnWidth( Arg2 , Arg1 , Arg4 , Arg5 )

         ElseIf Arg3 == 'ENABLED' // To ENABLE / DISABLE Radiobuttons

            iif ( Arg5 == .t. , _EnableControl ( Arg2 , Arg1, Arg4 ) , _DisableControl ( Arg2 , Arg1, Arg4 ) )

         ElseIf Arg3 == 'RICHVALUE' // Kevin Carmody <i@kevincarmody.com> 2007.04.23

            _SetGetRichValue ( Arg2 , Arg1 , Arg5 , Arg4 )

         Else
			// If Property Not Matched Look For ToolBar Button

            If GetControlType ( Arg2 , Arg1 ) == 'TOOLBAR'

               If GetControlHandle ( Arg2 , Arg1 ) != GetControlContainerHandle ( Arg3 , Arg1 )
                  MsgMiniGuiError( 'Control Does Not Belong To Container' )
               EndIf

               SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 )

            EndIf
         EndIf
      EndIf

   ElseIf Pcount() == 6 // TAB CHILD CONTROL
			// SPLITBOX CHILD WITH ARGUMENT
			// OR SPLITCHILD TOOLBAR BUTTON

      If Upper (Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )

            SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 )

         Else
            If _IsControlDefined ( Arg4 , Arg1 )

               If _IsControlSplitBoxed ( Arg4 , Arg1 )

                  SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 )

               Else
                  MsgMiniGuiError( 'Control Does Not Belong To Container' )
               EndIf

            Else
               MsgMiniGuiError( 'Control Does Not Belong To Container' )
            EndIf

         EndIf

      Else

         If ValType (Arg3) != 'N'

            Arg3 := Upper (Arg3)

            If Arg3 == 'CELL'

               If .Not. _IsControlDefined ( Arg2 , Arg1 )
                  MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
               EndIf

               _SetGridCellValue ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 )

            ElseIf Arg3 == 'HEADERIMAGE'    // Grid & Browse

               _SetMultiImage ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 )

            EndIf

         Else

            If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
               MsgMiniGuiError( 'Control Does Not Belong To Container' )
            EndIf

            SetProperty ( Arg1 , Arg4 , Arg5 , Arg6 )

         EndIf

      EndIf

   ElseIf Pcount() == 7 // TAB CHILD CONTROL WITH ARGUMENT
			// OR SPLITBOX CHILD WITH 2 ARGUMENTS

      If     Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      Else

         If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

         SetProperty ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

      EndIf

   ElseIf Pcount() == 8 // TAB CHILD CONTROL WITH 2 ARGUMENTS
			// OR SPLITBOX CHILD WITH 3 ARGUMENT

      If     Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      Else

         If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

         SetProperty ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )

      EndIf

   EndIf

Return Nil
*-----------------------------------------------------------------------------*
Function GetProperty ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )
*-----------------------------------------------------------------------------*
   Local RetVal, ix
#ifdef _USERINIT_
   Local i, cMacro
#endif

   if Pcount() == 2 // WINDOW

      If .Not. _IsWindowDefined ( Arg1 )
         MsgMiniGuiError("Window: "+ Arg1 + " is not defined. Program terminated" )
      Endif

      Arg2 := Upper ( Arg2 )

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomPropertyProcedure )

         If Arg2 == _HMG_aCustomPropertyProcedure [i] [1]
            cMacro := _HMG_aCustomPropertyProcedure [i] [3]
            RetVal := &cMacro ( Arg1 , Arg2 )

            If _HMG_UserComponentProcess == .T.
               Return RetVal
            EndIf				

         Endif

      Next i
#endif
      if     Arg2 == 'TITLE'

         RetVal := GetWindowText ( GetFormHandle( Arg1 ) )

      ELseIf Arg2 == 'FOCUSEDCONTROL'

         RetVal := _GetFocusedControl ( Arg1 )

      ELseIf Arg2 == 'NAME'

         RetVal := GetFormName ( Arg1 )

      ELseIf Arg2 == 'HEIGHT'

         RetVal := GetWindowHeight ( GetFormHandle ( Arg1 ) )

      ElseIf Arg2 == 'WIDTH'

         RetVal := GetWindowWidth ( GetFormHandle ( Arg1 ) )

      ElseIf Arg2 == 'COL'

         RetVal := GetWindowCol ( GetFormHandle ( Arg1 ) )

      ElseIf Arg2 == 'ROW'

         RetVal := GetWindowRow ( GetFormHandle ( Arg1 ) )

      ElseIf Arg2 == 'NOTIFYICON'

         RetVal := _GetNotifyIconName ( Arg1 )

      ElseIf Arg2 == 'NOTIFYTOOLTIP'

         RetVal := _GetNotifyIconTooltip ( Arg1 )

      ElseIf Arg2 == 'BACKCOLOR'

         RetVal := _HMG_aFormBkColor[ GetFormIndex ( Arg1 ) ]

      ElseIf Arg2 == 'MINWIDTH' // Grigory Filatov HMG 1.4 Ext Build 43

         ix := GetFormIndex ( Arg1 )

         if ix >= 0 .and. ix <= Len ( _hmg_aFormHandles )

            RetVal := _HMG_aFormMinMaxInfo [ix] [5]

         EndIf

      ElseIf Arg2 == 'MINHEIGHT'

         ix := GetFormIndex ( Arg1 )

         if ix >= 0 .and. ix <= Len ( _hmg_aFormHandles )

            RetVal := _HMG_aFormMinMaxInfo [ix] [6]

         EndIf

      ElseIf Arg2 == 'MAXWIDTH'

         ix := GetFormIndex ( Arg1 )

         if ix >= 0 .and. ix <= Len ( _hmg_aFormHandles )

            RetVal := _HMG_aFormMinMaxInfo [ix] [7]

         EndIf

      ElseIf Arg2 == 'MAXHEIGHT'

         ix := GetFormIndex ( Arg1 )

         if ix >= 0 .and. ix <= Len ( _hmg_aFormHandles )

            RetVal := _HMG_aFormMinMaxInfo [ix] [8]

         EndIf

      EndIf

   ElseIf Pcount() == 3 // CONTROL

      Arg3 := Upper ( Arg3 )

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomPropertyProcedure )

         If Arg3 == _HMG_aCustomPropertyProcedure [i] [1]
            cMacro := _HMG_aCustomPropertyProcedure [i] [3]
            RetVal := &cMacro ( Arg1 , Arg2 , Arg3 )

            If _HMG_UserComponentProcess == .T.
               Return RetVal
            EndIf				

         Endif

      Next i
#endif
      If ( Upper(Arg2) == 'VSCROLLBAR' .Or. Upper(Arg2) == 'HSCROLLBAR' )

         If .Not. _IsWindowDefined ( Arg1 )
            MsgMiniGuiError("Window: "+ Arg1 + " is not defined. Program terminated" )
         Endif

      Else

         If .Not. _IsControlDefined ( Arg2 , Arg1 )
            MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
         endif

      EndIf

      If     Arg3 == 'VALUE'

         RetVal := _GetValue ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FORMATSTRING'

         RetVal := _GetDatePickerDateFormat ( Arg2 , Arg1 )

      ElseIf Arg3 == 'NAME'

         RetVal := GetControlName ( Arg2 , Arg1 )

      ElseIf Arg3 == 'ALLOWEDIT'

         RetVal := _GetBrowseAllowEdit ( Arg2 , Arg1 )

      ElseIf Arg3 == 'ALLOWAPPEND'

         RetVal := _GetBrowseAllowAppend ( Arg2 , Arg1 )

      ElseIf Arg3 == 'ALLOWDELETE'

         RetVal := _GetBrowseAllowDelete ( Arg2 , Arg1 )

      ElseIf Arg3 == 'INPUTITEMS'

         RetVal := _GetBrowseInputItems ( Arg2 , Arg1 )

      ElseIf Arg3 == 'DISPLAYITEMS'

         RetVal := _GetBrowseDisplayItems ( Arg2 , Arg1 )

      ElseIf Arg3 == 'PICTURE' .or. Arg3 == 'ICON'

         RetVal := _GetPicture ( Arg2 , Arg1 )

      ElseIf Arg3 == 'TOOLTIP'

         RetVal := _GetTooltip ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FONTNAME'

         RetVal := _GetFontName ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FONTSIZE'

         RetVal := _GetFontSize ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FONTBOLD'

         RetVal := _GetFontBold ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FONTITALIC'

         RetVal := _GetFontItalic ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FONTUNDERLINE'

         RetVal := _GetFontUnderline ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FONTSTRIKEOUT'

         RetVal := _GetFontStrikeout ( Arg2 , Arg1 )

      ElseIf Arg3 == 'CAPTION'

         RetVal := _GetCaption ( Arg2 , Arg1 )

      ElseIf Arg3 == 'ACTION' // GF 10/22/2008

         RetVal := _GetControlAction ( Arg2 , Arg1 )

      ElseIf Arg3 == 'DISPLAYVALUE'

         //(JK) HMG 1.0 Experimental Build 14
         ix := GetControlIndex ( Arg2 , Arg1 )

         If _HMG_aControltype [ix] == "GETBOX"

            RetVal := GetWindowText ( GetControlHandle ( Arg2 , Arg1 ) )

         ElseIf _HMG_aControltype [ix] == "COMBO" .and. _HMG_aControlMiscData1 [ix][1] == 1

            If EMPTY ( _hmg_acontrolrangemin[ ix] )
               RetVal := _GetComboItemValue ( Arg2 , Arg1, ComboGetCursel ( _HMG_aControlHandles[ ix ] ) )
            Else
               RetVal := GetWindowText ( GetControlHandle ( Arg2 , Arg1 ) )
            Endif

         Else

            If EMPTY ( _hmg_acontrolrangemin[ ix] )
               RetVal := GetWindowText ( GetControlHandle ( Arg2 , Arg1 ) )
            Else
               RetVal := GetWindowText ( _hmg_acontrolrangemin[ ix] )
            Endif

         Endif

      ElseIf Arg3 == 'ROW'

         RetVal := _GetControlRow ( Arg2 , Arg1 )

      ElseIf Arg3 == 'COL'

         RetVal := _GetControlCol ( Arg2 , Arg1 )

      ElseIf Arg3 == 'WIDTH'

         RetVal := _GetControlWidth ( Arg2 , Arg1 )

      ElseIf Arg3 == 'LISTWIDTH'

         RetVal := _GetDropDownWidth( Arg2 , Arg1 )

      ElseIf Arg3 == 'HEIGHT'

         RetVal := _GetControlHeight ( Arg2 , Arg1 )

      ElseIf Arg3 == 'VISIBLE'

         RetVal := _IsControlVisible ( Arg2 , Arg1 )

      ElseIf Arg3 == 'ENABLED'

         RetVal := _IsControlEnabled ( Arg2 , Arg1 )

      ElseIf Arg3 == 'CHECKED'

         RetVal := _IsMenuItemChecked ( Arg2 , Arg1 )

      ElseIf Arg3 == 'ITEMCOUNT'

         RetVal := _GetItemCount ( Arg2 , Arg1 )

      ElseIf Arg3 == 'RANGEMIN'

         RetVal := _GetRangeMin ( Arg2 , Arg1 )

      ElseIf Arg3 == 'RANGEMAX'

         RetVal := _GetRangeMax ( Arg2 , Arg1 )

      ElseIf Arg3 == 'LENGTH'

         RetVal := _GetPlayerLength ( Arg2 , Arg1 )

      ElseIf Arg3 == 'POSITION'

         RetVal := _GetPlayerPosition ( Arg2 , Arg1 )

      ElseIf Arg3 == 'CARETPOS'

         RetVal := _GetCaretPos ( Arg2 , Arg1 )

      ElseIf Arg3 == 'BACKCOLOR'

         RetVal := _GetBackColor ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FONTCOLOR'

         RetVal := _GetFontColor ( Arg2 , Arg1 )

      ElseIf Arg3 == 'FORECOLOR'

         RetVal := _GetFontColor ( Arg2 , Arg1 )

      ElseIf Arg3 == 'ADDRESS'

         RetVal := _GetAddress ( Arg2 , Arg1 )

      ElseIf Arg3 == 'READONLY'

         ix := GetControlType ( Arg2 , Arg1 )

         If ix == "TEXT" .or. ix == "GETBOX" .or. ix == "NUMTEXT" .or. ix == "MASKEDTEXT" .or. ix == "CHARMASKTEXT" .or. ix == "SPINNER"
            RetVal := _HMG_aControlMiscData1 [ GetControlIndex ( Arg2 , Arg1 ), 2 ]
         ElseIf ix == "EDIT"
            RetVal := _HMG_aControlMiscData1 [ GetControlIndex ( Arg2 , Arg1 ), 3 ]
         ElseIf ix == 'RADIOGROUP'
            RetVal := _GetRadioGroupReadOnly ( Arg2 , Arg1 )
         EndIf

      ElseIf Arg3 == 'INDENT'

         RetVal := TreeView_GetIndent( GetControlHandle ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'LINECOLOR'

         RetVal := TreeView_GetLineColor( GetControlHandle ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'ITEMHEIGHT'

         RetVal :=  TreeView_GetItemHeight( GetControlHandle ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'RICHVALUE' // Kevin Carmody <i@kevincarmody.com> 2007.04.10

         RetVal := _SetGetRichValue ( Arg2 , Arg1 )

      ElseIf Arg3 == 'AUTOFONT' // Kevin Carmody <i@kevincarmody.com> 2007.04.23

         RetVal := _SetGetAutoFont ( Arg2 , Arg1 )

      EndIf

   ElseIf Pcount() == 4 // CONTROL WITH ARGUMENT OR TOOLBAR BUTTON OR (JK) HMG 1.0 Experimental Buid 6 GRID/BROWSE COLUMN - ColumnWidth
			// OR SPLITBOX CHILD WITHOUT ARGUMENT

      If Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            RetVal := GetProperty ( Arg1 , Arg3 , Arg4 )
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      Else

         If GetControlType ( Arg2 , Arg1 ) != 'TOOLBAR'

            If .Not. _IsControlDefined ( Arg2 , Arg1 )
               MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
            EndIf

         EndIf

         Arg3 := Upper ( Arg3 )

         If     Arg3 == 'ITEM'

            RetVal := _GetItem (  Arg2 , Arg1 , Arg4 )

         ElseIf Arg3 == 'WIDTH' // GF 01/05/2007

            RetVal := _GetStatusItemWidth( GetFormHandle ( Arg1 ) , Arg4 )

         ElseIf Arg3 == 'CAPTION'

            RetVal := _GetMultiCaption ( Arg2 , Arg1 , Arg4 )

         ElseIf Arg3 == 'HEADER'

            RetVal := _GetMultiCaption ( Arg2 , Arg1 , Arg4 )

         ElseIf Arg3 == 'IMAGE' .or. Arg3 == 'HEADERIMAGE'

            RetVal := _GetMultiImage ( Arg2 , Arg1 , Arg4 )

         ElseIf Arg3 == 'COLUMNWIDTH' //(JK) HMG 1.0 Experimental Build 6

            If Empty ( Arg4 ) .Or. Arg4 < 1
               MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + ". Unproper or empty index param. Program Terminated" )
            EndIf

            RetVal := _GetColumnWidth( Arg2 , Arg1 , Arg4 )

         ElseIf Arg3 == 'ENABLED'

            RetVal := _IsControlEnabled ( Arg2 , Arg1 , Arg4 )

         ElseIf Arg3 == 'RICHVALUE' // Kevin Carmody <i@kevincarmody.com> 2007.04.23

            RetVal := _SetGetRichValue ( Arg2 , Arg1 , , Arg4 )

         Else

           // If Property Not Matched Look For Contained Control
           // With No Arguments (ToolBar Button)

            If GetControlType ( Arg2 , Arg1 ) == 'TOOLBAR'

               If GetControlHandle ( Arg2 , Arg1 ) != GetControlContainerHandle ( Arg3 , Arg1 )
                  MsgMiniGuiError( 'Control Does Not Belong To Container' )
               EndIf

               RetVal := GetProperty ( Arg1 , Arg3 , Arg4 )

            EndIf

         EndIf

      EndIf

   ElseIf Pcount() == 5	// TAB CHILD CONTROL (WITHOUT ARGUMENT)
			// OR SPLITBOX CHILD WITH ARGUMENT

      If Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            RetVal := GetProperty ( Arg1 , Arg3 , Arg4 , Arg5 )
         Else
            If _IsControlDefined ( Arg4 , Arg1 )

               If _IsControlSplitBoxed ( Arg4 , Arg1 )

                  RetVal := GetProperty ( Arg1 , Arg3 , Arg4 , Arg5 )

               Else

                  MsgMiniGuiError( 'Control Does Not Belong To Container' )

               EndIf

            Else

               MsgMiniGuiError( 'Control Does Not Belong To Container' )

            EndIf

         EndIf

      Else

         If ValType (Arg3) != 'N'

            Arg3 := Upper ( Arg3 )

            If Arg3 == 'CELL'
               RetVal := _GetGridCellValue ( Arg2 , Arg1 , Arg4 , Arg5 )
            EndIf

         Else

            If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
               MsgMiniGuiError( 'Control Does Not Belong To Container' )
            EndIf

            RetVal := GetProperty ( Arg1 , Arg4 , Arg5 )
         EndIf

      EndIf

   ElseIf Pcount() == 6	// TAB CHILD CONTROL WITH 1 ARGUMENT
			// OR SPLITBOX CHILD WITH 2 ARGUMENT

      If Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            RetVal := GetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 )
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      Else

         If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

         RetVal := GetProperty ( Arg1 , Arg4 , Arg5 , Arg6 )

      EndIf

   ElseIf Pcount() == 7	// TAB CHILD CONTROL WITH 2 ARGUMENT
			// OR SPLITBOX CHILD WITH 3 ARGUMENT

      If Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            RetVal := GetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      Else

         If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

         RetVal := GetProperty ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

      EndIf

   EndIf

Return RetVal
*-----------------------------------------------------------------------------*
Function DoMethod ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 , Arg9 )
*-----------------------------------------------------------------------------*
   Local i
#ifdef _USERINIT_
   Local cMacro
#endif

   if Pcount() == 2 // Window

      If ValType ( Arg1 ) == 'C'
         If .Not. _IsWindowDefined ( Arg1 )
            MsgMiniGuiError("Window: "+ Arg1 + " is not defined. Program terminated" )
         Endif
      EndIf

      Arg2 := Upper ( Arg2 )

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomMethodProcedure )

         If Arg2 == _HMG_aCustomMethodProcedure [i] [1]
            cMacro := _HMG_aCustomMethodProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif
      if     Arg2 == 'ACTIVATE'

         if ValType ( Arg1 ) == 'A'
            _ActivateWindow ( Arg1 )
         Else
            _ActivateWindow ( { Arg1 } )
         EndIf

      ELseIf Arg2 == 'CENTER'

         _CenterWindow ( Arg1 )

      ElseIf Arg2 == 'RELEASE'

         _ReleaseWindow ( Arg1 )

      ElseIf Arg2 == 'MAXIMIZE'

         _MaximizeWindow ( Arg1 )

      ElseIf Arg2 == 'MINIMIZE'

         _MinimizeWindow ( Arg1 )

      ElseIf Arg2 == 'RESTORE'

         _RestoreWindow ( Arg1 )

      ElseIf Arg2 == 'SHOW'

         _ShowWindow ( Arg1 )

      ElseIf Arg2 == 'HIDE'

         _HideWindow ( Arg1 )

      ElseIf Arg2 == 'SETFOCUS'

         i := GetFormIndex ( Arg1 )

         if i >= 1  .and. i <= Len (_hmg_aFormHandles )

            If _hmg_aformActive [i] == .T.
               setfocus ( _hmg_aformhandles [i] )
            EndIf

         EndIf

      EndIf

   ElseIf Pcount() == 3 // CONTROL

      Arg3 := Upper ( Arg3 )

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomMethodProcedure )

         If Arg3 == _HMG_aCustomMethodProcedure [i] [1]
            cMacro := _HMG_aCustomMethodProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 , Arg3 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif
      If .Not. _IsControlDefined ( Arg2 , Arg1 )
         MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
      endif

      //(JK) HMG 1.0 Experimental Build 6 (2 new method for GRID/BROWSE control COLUMNSAUTOFIT,COLUMNSAUTOFITH)

      If     Arg3 == 'COLUMNSAUTOFIT'

         _SetColumnsWidthAuto( Arg2 , Arg1 )

      ElseIf Arg3 == 'COLUMNSAUTOFITH'

         _SetColumnsWidthAutoH( Arg2 , Arg1 )

      ElseIf Arg3 == 'ENABLEUPDATE'

         _EnableListViewUpdate(Arg2 , Arg1 , .t. )

      ElseIf Arg3 == 'DISABLEUPDATE'

         _EnableListViewUpdate(Arg2 , Arg1 , .f. )

      ElseIf Arg3 == 'REFRESH'

         _Refresh ( GetControlIndex ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'SAVE'

         _SaveData (Arg2 , Arg1)

      ElseIf Arg3 == 'SETFOCUS'

         _SetFocus ( Arg2 , Arg1 )

      ElseIf Arg3 == 'ACTION'

         Eval ( _GetControlAction ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'ONCLICK'

         Eval ( _GetControlAction ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'DELETEALLITEMS'

         _DeleteAllItems ( Arg2 , Arg1 )

      ElseIf Arg3 == 'RELEASE'

         _ReleaseControl ( Arg2 , Arg1 )

      ElseIf Arg3 == 'SHOW'

         _ShowControl ( Arg2 , Arg1 )

      ElseIf Arg3 == 'HIDE'

         _HideControl ( Arg2 , Arg1 )

      ElseIf Arg3 == 'PLAY'

         iif ( GetControlType ( Arg2 , Arg1 ) == "ANIMATEBOX" ,  _PlayAnimateBox ( Arg2 , Arg1 )  , _PlayPlayer ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'STOP'

         iif ( GetControlType ( Arg2 , Arg1 ) == "ANIMATEBOX" ,  _StopAnimateBox ( Arg2 , Arg1 )  , _StopPlayer ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'CLOSE'

         iif ( GetControlType ( Arg2 , Arg1 ) == "ANIMATEBOX" ,  _CloseAnimateBox ( Arg2 , Arg1 )  , _ClosePlayer ( Arg2 , Arg1 ) )

      ElseIf Arg3 == 'PLAYREVERSE'

         _PlayPlayerReverse ( Arg2 , Arg1 )

      ElseIf Arg3 == 'PAUSE'

         _PausePlayer ( Arg2 , Arg1 )

      ElseIf Arg3 == 'EJECT'

         _EjectPlayer ( Arg2 , Arg1 )

      ElseIf Arg3 == 'OPENDIALOG'

         _OpenPlayerDialog ( Arg2 , Arg1 )

      ElseIf Arg3 == 'RESUME'

         _ResumePlayer ( Arg2 , Arg1 )

      EndIf

   ElseIf Pcount() == 4	// CONTROL WITH 1 ARGUMENT OR SPLITBOX CHILD WITHOUT ARGUMENT

      Arg3 := Upper ( Arg3 )

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomMethodProcedure )

         If Arg3 == _HMG_aCustomMethodProcedure [i] [1]
            cMacro := _HMG_aCustomMethodProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 , Arg3 , Arg4 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif
      If Upper(Arg2) == 'SPLITBOX'
         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            DoMethod( Arg1 , Arg3 , Arg4 )
            Return Nil
         Else
            MsgMiniGuiError('Control Does Not Belong To Container')
         EndIf
      EndIf

      If .Not. _IsControlDefined ( Arg2 , Arg1 )
         MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
      endif

      //(JK) HMG 1.0 Experimental Build 6 (2 new method for GRID/BROWSE control COLUMNAUTOFIT(n),COLUMNAUTOFITH(n))

      If     Arg3 == 'COLUMNAUTOFIT'

         _SetColumnWidthAuto( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'COLUMNAUTOFITH'

         _SetColumnWidthAutoH( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'DELETEITEM'

         _DeleteItem ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'DELETEPAGE'

         _DeleteTabPage ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'OPEN'

         iif ( GetControlType ( Arg2 , Arg1 ) == "ANIMATEBOX" , _OpenAnimateBox ( Arg2 , Arg1 , Arg4 ) , _OpenPlayer ( Arg2 , Arg1 , Arg4 ) )

      ElseIf Arg3 == 'SEEK'

         _SeekAnimateBox ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'ADDITEM'

         _AddItem ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'EXPAND'

         _Expand ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'COLLAPSE'

         _Collapse ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'DELETECOLUMN'

         _DeleteGridColumn ( Arg2 , Arg1 , Arg4 )

      ElseIf Arg3 == 'DELETEIMAGE' //JP ImageList

         _RemoveImageFromImageList ( Arg2 , Arg1 , Arg4-1 )

      EndIf

   ElseIf Pcount() == 5 .And. ValType (Arg3) == 'C'
		 // CONTROL WITH 2 ARGUMENTS OR SPLITBOX CHILD WITH 1 ARGUMENT
      Arg3 := Upper ( Arg3 )

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomMethodProcedure )

         If Arg3 == _HMG_aCustomMethodProcedure [i] [1]
            cMacro := _HMG_aCustomMethodProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif
      If Upper(Arg2) == 'SPLITBOX'
         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            DoMethod( Arg1 , Arg3 , Arg4 , Arg5 )
            Return Nil
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf
      EndIf

      If .Not. _IsControlDefined ( Arg2 , Arg1 )
         MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
      endif

      If     Arg3 == 'ADDITEM'

         _AddItem ( Arg2 , Arg1 , Arg4 , Arg5 )

      ElseIf Arg3 == 'ADDPAGE'

         _AddTabPage ( Arg2 , Arg1 , Arg4 , Arg5 )

      ElseIf Arg3 == 'ADDIMAGE' //JP ImageList

         _AddImageToImageList ( Arg2 , Arg1 , Arg4 , Arg5 )

      ElseIf Arg3 == 'ADDIMAGEMASK' //JP ImageList

         _AddImageMaskedToImageList ( Arg2 , Arg1 , Arg4 , Arg5 )

      EndIf

   ElseIf Pcount() == 5  .And. ValType (Arg3) == 'N'
		// TAB CHILD WITHOUT ARGUMENTS

      If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
         MsgMiniGuiError( 'Control Does Not Belong To Container' )
      EndIf

      DoMethod ( Arg1 , Arg4 , Arg5 )

   ElseIf Pcount() == 6 .And. ValType (Arg3) == 'C'
		// CONTROL WITH 3 ARGUMENTS OR SPLITBOX CHILD WITH 2 ARGUMENTS
      Arg3 := Upper ( Arg3 )

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomMethodProcedure )

         If Arg3 == _HMG_aCustomMethodProcedure [i] [1]
            cMacro := _HMG_aCustomMethodProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif
      If Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            DoMethod( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 )
            Return Nil
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      EndIf

      If .Not. _IsControlDefined ( Arg2 , Arg1 )
         MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
      endif

      If     Arg3 == 'ADDITEM'

         _AddItem ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 )

      ElseIf Arg3 == 'ADDPAGE'

         _AddTabPage ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 )

      EndIf

   ElseIf Pcount() == 6 .And. ValType (Arg3) == 'N'
		// TAB CHILD WITH 1 ARGUMENT

      If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
         MsgMiniGuiError( 'Control Does Not Belong To Container' )
      EndIf

      DoMethod ( Arg1 , Arg4 , Arg5 , Arg6 )

   ElseIf Pcount() == 7 .And. ValType (Arg3) == 'C'
		// CONTROL WITH 4 ARGUMENTS OR SPLITBOX CHILD WITH 3 ARGUMENTS
      Arg3 := Upper ( Arg3 )

#ifdef _USERINIT_
      For i := 1 To Len ( _HMG_aCustomMethodProcedure )

         If Arg3 == _HMG_aCustomMethodProcedure [i] [1]
            cMacro := _HMG_aCustomMethodProcedure [i] [2]
            &cMacro ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )

            If _HMG_UserComponentProcess == .T.
               Return NIL
            EndIf				

         Endif

      Next i
#endif
      If Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            DoMethod( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )
            Return Nil
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      EndIf

      If .Not. _IsControlDefined ( Arg2 , Arg1 )
         MsgMiniGuiError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
      endif

      If     Arg3 == 'ADDCONTROL'

         _AddTabControl ( Arg2 , Arg4 , Arg1 , Arg5 , Arg6 , Arg7 )

      ElseIf Arg3 == 'ADDCOLUMN'

         _AddGridColumn ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

      ElseIf Arg3 == 'ADDITEM'

         _AddItem ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

      EndIf

   ElseIf Pcount() == 7 .And. ValType (Arg3) == 'N'
		// TAB CHILD WITH 2 ARGUMENTS

      If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
         MsgMiniGuiError( 'Control Does Not Belong To Container' )
      EndIf

      DoMethod ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

   ElseIf Pcount() == 8
		// TAB CHILD WITH 3 ARGUMENTS
		// OR SPLITBOX CHILD WITH 4 ARGUMENTS

      If Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            DoMethod( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )
            Return Nil
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      EndIf

      If ValType (Arg3) == 'N'

         If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

         DoMethod ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )

      EndIf

   ElseIf Pcount() == 9
		// TAB CHILD WITH 4 ARGUMENTS
		// OR SPLITBOX CHILD WITH 5 ARGUMENTS

      If Upper(Arg2) == 'SPLITBOX'

         If _IsControlSplitBoxed ( Arg3 , Arg1 )
            DoMethod( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 , Arg9 )
            Return Nil
         Else
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

      EndIf

      If ValType (Arg3) == 'N'

         If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
            MsgMiniGuiError( 'Control Does Not Belong To Container' )
         EndIf

         DoMethod ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 , Arg9 )

      EndIf

   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function GetControlTabPage ( cControlName , cTabName , cParentWindowName )
*-----------------------------------------------------------------------------*
   Local r , c , j , z , nRetVal := 0
   Local niTab		:= GetControlIndex ( cTabName , cParentWindowName )
   Local niControl		:= GetControlIndex ( cControlName , cParentWindowName )
   Local xControlHandle	:= _HMG_aControlHandles [ niControl ]
   Local aPageMap		:= _HMG_aControlPageMap [ niTab ]

   For r = 1 to len ( aPageMap )

      For c = 1 To Len ( aPageMap [r] )

         If	ValType ( aPageMap [r] [c] ) == 'N';
            .And.;
            ValType ( xControlHandle ) == 'N'

         If aPageMap [r] [c] == xControlHandle

            nRetVal := r
            Exit

         EndIf

      ElseIf	ValType ( aPageMap [r] [c] ) == "A";
         .And.;
         ValType ( xControlHandle ) == "A"

         For j := 1 To Len ( xControlHandle )

            z := aScan ( aPageMap [r] [c] , xControlHandle [j] )

            If z <> 0					
               nRetVal := r
               Exit
            EndIf

         Next j

         If nRetVal <> 0
            Exit
         EndIf

      ElseIf	ValType ( aPageMap [r] [c] ) == "A";
         .And.;
         ValType ( xControlHandle ) == "N"

         z := aScan ( aPageMap [r] [c] , xControlHandle )

         If z <> 0					
            nRetVal := r
            Exit
         EndIf

      EndIf

   Next c

   If nRetVal <> 0
      Exit
   EndIf

Next r

Return nRetVal

*-----------------------------------------------------------------------------*
Function _IsControlSplitBoxed ( cControlName , cWindowName )
*-----------------------------------------------------------------------------*
   Local lSplitBoxed := .F.
   Local i := GetControlIndex ( cControlName, cWindowName )

   If i > 0

      If ValType ( _HMG_aControlRow [i] ) == 'U' .And. ValType ( _HMG_aControlCol [i] ) == 'U'
         lSplitBoxed := .T.
      EndIf

   EndIf

Return lSplitBoxed

Function _dummy()
return nil

*-----------------------------------------------------------------------------*
Function cFilePath( cPathMask )
*-----------------------------------------------------------------------------*
   LOCAL n := RAt( "\", cPathMask )

return If( n > 0, Upper( Left( cPathMask, n - 1) ), Left( cPathMask, 2 ) )

*-----------------------------------------------------------------------------*
Function cFileNoPath( cPathMask )
*-----------------------------------------------------------------------------*
   LOCAL n := Max( rAt( "\", cPathMask ), rAt( "/", cPathMask ) )

Return If( n > 0 .And. n < Len( cPathMask ),;
      Right( cPathMask, Len( cPathMask ) - n ),;
      If( ( n := At( ":", cPathMask ) ) > 0,;
      Right( cPathMask, Len( cPathMask ) - n ), cPathMask ) )

*-----------------------------------------------------------------------------*
Function cFileNoExt( cPathMask )
*-----------------------------------------------------------------------------*
   LOCAL cName := AllTrim( cFileNoPath( cPathMask ) )
   LOCAL n     := At( ".", cName )

Return AllTrim( If( n > 0, Left( cName, n - 1 ), cName ) )

*-----------------------------------------------------------------------------*
Function NoArray( OldArray )
*-----------------------------------------------------------------------------*
   Local NewArray := {}
   Local i

   If ValType ( OldArray ) == 'U'
      Return Nil
   ELse
      Asize ( NewArray , Len (OldArray) )
   EndIf

   For i := 1 To Len ( OldArray )

      If OldArray [i] == .t.
         NewArray [i] := .f.
      Else
         NewArray [i] := .t.
      EndIf

   Next i

Return NewArray

*-----------------------------------------------------------------------------*
Procedure _Refresh( i )
*-----------------------------------------------------------------------------*
   Local T := _HMG_aControlType [i]

   If T == 'TEXT' .or. T == 'NUMTEXT' .or. T == "CHARMASKTEXT" .or. T == "MASKEDTEXT"
      _DataTextBoxRefresh ( i )

   ElseIf T == 'COMBO'
      _DataComboRefresh ( i )

   ElseIf T == 'DATEPICK' .or. T == 'TIMEPICK'
      _DataDatePickerRefresh ( i )

   ElseIf T == 'EDIT'
      _DataEditBoxRefresh ( i )

   ElseIf T == 'RICHEDIT'   // JP Exp. build 8
      _DataRichEditBoxRefresh ( i )

   ElseIf T == 'CHECKBOX'
      _DataCheckBoxRefresh ( i )

   ElseIf T == 'GETBOX'
      _DataGetBoxRefresh ( i )

   ElseIf T == 'BROWSE'
      _BrowseRefresh ( '', '', i )

   ElseIf T == 'GRID' .or. T == 'MULTIGRID'
      _UpdateGridColors ( i )

   Else
      RedrawWindowControlRect ( _HMG_aControlParentHandles [i] , _HMG_aControlRow [i] , _HMG_aControlCol [i] ,;
         _HMG_aControlRow [i] + _HMG_aControlHeight [i] , _HMG_aControlCol [i] + _HMG_aControlWidth [i] )

   EndIf

return

*-----------------------------------------------------------------------------*
Procedure _SaveData ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )
   Local T := _HMG_aControlType [i]

   If T == 'TEXT' .or. T == 'NUMTEXT' .or. T == "CHARMASKTEXT" .or. T == "MASKEDTEXT"
      _DataTextBoxSave ( ControlName , ParentForm )

   ElseIf T == 'DATEPICK' .or. T == 'TIMEPICK'
      _DataDatePickerSave ( ControlName , ParentForm )

   ElseIf T == 'EDIT'
      _DataEditBoxSave ( ControlName , ParentForm )

   ElseIf T == 'RICHEDIT'   // JP Exp. build 8
      _DataBaseRichEditBoxSave ( ControlName , ParentForm )

   ElseIf T == 'CHECKBOX'
      _DataCheckBoxSave ( ControlName , ParentForm )

   ElseIf T == 'GETBOX'
      _DataGetBoxSave ( ControlName , ParentForm )

   EndIf

Return

*-----------------------------------------------------------------------------*
Function _SetWindowBackColor ( FormHandle , aColor )
*-----------------------------------------------------------------------------*
   local i, hbrush

   i := Ascan( _HMG_aFormhandles, FormHandle )

   DeleteObject( _HMG_aFormBrushHandle[ i ] )

   hbrush := PaintBkGnd( FormHandle, aColor )

   SetWindowBackground( FormHandle, hbrush )

   _HMG_aFormBkColor[ i ] := aColor
   _HMG_aFormBrushHandle[ i ] := hbrush

Return Nil

*-----------------------------------------------------------------------------*
Function _GetFocusedControl ( cFormName )
*-----------------------------------------------------------------------------*
   Local nFormHandle , i , nFocusedControlHandle , nControlCount , cRetVal , x

   nFormHandle           := GetFormHandle ( cFormName )
   nFocusedControlHandle := GetFocus()
   nControlCount         := Len ( _HMG_aControlHandles )

   If nFocusedControlHandle != 0

      For i := 1 To nControlCount

         If _HMG_aControlParentHandles [i] ==  nFormHandle
            If ValType ( _HMG_aControlHandles [i] ) == 'N'
               If _HMG_aControlHandles [i] == nFocusedControlHandle
                  cRetVal := _HMG_aControlNames [i]
               EndIf
            ElseIf ValType ( _HMG_aControlHandles [i] ) == 'A'
               For x := 1 To Len ( _HMG_aControlHandles [i] )
                  If _HMG_aControlHandles [i] [x] == nFocusedControlHandle
                     cRetVal := _HMG_aControlNames [i]
                     Exit
                  EndIf
               Next x
            EndIf
         EndIf

         If ! Empty ( cRetVal )
            Exit
         EndIf

      Next i

   Else

      cRetVal := ''

   EndIf

Return ( cRetVal )

*-----------------------------------------------------------------------------*
Function _SetFontColor ( ControlName, ParentForm , Value )
*-----------------------------------------------------------------------------*
   Local i, default := GetSysColor ( COLOR_WINDOWTEXT )

   If value == Nil
      Return Nil
   EndIf

   If valtype(value) == "A"
      If len(value) == 3 .and. ( value[1] == Nil .or. value[2] == Nil .or. value[3] == Nil )
         Return Nil
      EndIf
   EndIf

   i := GetControlIndex ( ControlName, ParentForm )

   If  _HMG_aControlType [i] == 'GRID' .or. _HMG_aControlType [i] == 'MULTIGRID' .or. _HMG_aControlType [i] == 'BROWSE'
      ListView_SetTextColor ( _HMG_aControlhandles [i], value[1] , value[2] , value[3] )
      RedrawWindow ( _HMG_aControlHandles [i] )

   ElseIf  _HMG_aControlType [i] == 'DATEPICK'
      _HMG_aControlFontColor [i] := Value
      SetDatePickFontColor( _HMG_aControlHandles [i], value[1], value[2], value[3] )

   ElseIf  _HMG_aControlType [i] == 'MONTHCAL'
      _HMG_aControlFontColor [i] := Value
      SetMonthCalFontColor( _HMG_aControlHandles [i], value[1], value[2], value[3] )

   ElseIf _HMG_aControlType [i] == 'PROGRESSBAR'
      _HMG_aControlFontColor [i] := Value
      SetProgressBarBarColor( _HMG_aControlHandles [i], value[1], value[2], value[3] )

   ElseIf _HMG_aControlType [i] == 'TREE'
      _HMG_aControlFontColor [i] := Value
      TreeView_SetTextColor( _HMG_aControlHandles [i], value )

   ElseIf _HMG_aControlType [i] == "NUMTEXT" .or. _HMG_aControlType [i] == "TEXT" .or. _HMG_aControlType [i] == "MASKEDTEXT" .or. _HMG_aControlType [i] == "CHARMASKTEXT" .or. _HMG_aControlType [i] == "EDIT"
      if valtype(value) == "A"
         _HMG_aControlFontColor [i] := Value
         RedrawWindow ( _HMG_aControlHandles [i] )
      else
         _HMG_aControlFontColor [i] := { GetRed ( default ) , GetGreen ( default ) , GetBlue ( default ) }
         RedrawWindow ( _HMG_aControlHandles [i] )
      endif

   Else
      _HMG_aControlFontColor [i] := Value
      RedrawWindow ( _HMG_aControlHandles [i] )

   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _SetBackColor ( ControlName, ParentForm , Value )
*-----------------------------------------------------------------------------*
   Local i , f := GetSysColor ( COLOR_3DFACE ), d := GetSysColor ( COLOR_WINDOW )

   If value == Nil
      Return Nil
   EndIf

   If valtype(value) == "A"
      If len(value) == 3 .and. ( value[1] == Nil .or. value[2] == Nil .or. value[3] == Nil )
         Return Nil
      EndIf
   EndIf

   i := GetControlIndex ( ControlName, ParentForm )

   If _HMG_aControlType [i] == 'SLIDER'
      _HMG_aControlBkColor [i] := Value
      RedrawWindow ( _HMG_aControlHandles [i] )
      f := GetFocus()
      setfocus( _HMG_aControlhandles[i] )
      setfocus(f)

   ElseIf  _HMG_aControlType [i] == 'GRID' .or. _HMG_aControlType [i] == 'MULTIGRID' .or. _HMG_aControlType [i] == 'BROWSE'
      ListView_SetBkColor ( _HMG_aControlhandles [i], value[1], value[2], value[3] )
      ListView_SetTextBkColor ( _HMG_aControlhandles [i], value[1], value[2], value[3] )
      RedrawWindow ( _HMG_aControlHandles [i] )

   ElseIf  _HMG_aControlType [i] == 'RICHEDIT'
      SendMessage ( _HMG_aControlhandles [i], EM_SETBKGNDCOLOR, 0, RGB ( value[1], value[2], value[3] ) )
      RedrawWindow ( _HMG_aControlHandles [i] )

   ElseIf  _HMG_aControlType [i] == 'DATEPICK'
      _HMG_aControlBkColor [i] := Value
      SetDatePickBkColor( _HMG_aControlHandles [i], value[1], value[2], value[3] )

   ElseIf  _HMG_aControlType [i] == 'MONTHCAL'
      _HMG_aControlBkColor [i] := Value
      SetMonthCalMonthBkColor( _HMG_aControlHandles [i], value[1], value[2], value[3] )

   ElseIf _HMG_aControlType [i] == 'PROGRESSBAR'
      _HMG_aControlBkColor [i] := Value
      SetProgressBarBkColor(_HMG_aControlHandles [i],value[1],value[2],value[3])

   ElseIf _HMG_aControlType [i] == 'TREE'
      _HMG_aControlFontColor [i] := Value
      TreeView_SetBkColor( _HMG_aControlHandles [i], value )

   ElseIf _HMG_aControlType [i] == "NUMTEXT" .or. _HMG_aControlType [i] == "TEXT" .or. _HMG_aControlType [i] == "MASKEDTEXT" .or. _HMG_aControlType [i] == "CHARMASKTEXT" .or. _HMG_aControlType [i] == "EDIT" .or. _HMG_aControlType [i] == "GETBOX"
      if valtype(value) == "A"
         _HMG_aControlBkColor [i] := Value
         RedrawWindow ( _HMG_aControlHandles [i] )
      else
         _HMG_aControlBkColor [i] :=  { { GetRed ( d ) , GetGreen ( d ) , GetBlue ( d ) }, { GetRed ( f ) , GetGreen ( f ) , GetBlue ( f ) } }
         RedrawWindow ( _HMG_aControlHandles [i] )
      endif

   Else
      _HMG_aControlBkColor [i] := Value
      RedrawWindow ( _HMG_aControlHandles [i] )

   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _GetFontColor ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i , RetVal := { Nil , Nil , Nil } , Tmp

   i := GetControlIndex ( ControlName, ParentForm )

   If  _HMG_aControlType [i] == 'GRID' .or. _HMG_aControlType [i] == 'MULTIGRID' .or. _HMG_aControlType [i] == 'BROWSE'
      Tmp := ListView_GetTextColor ( _HMG_aControlHandles [i] )
      RetVal [1] := GetRed (Tmp)
      RetVal [2] := GetGreen (Tmp)
      RetVal [3] := GetBlue (Tmp)

   ElseIf _HMG_aControlType [i] == 'TREE'
      RetVal := TreeView_GetTextColor ( _HMG_aControlHandles [i] )

   Else
      RetVal := _HMG_aControlFontColor [i]

   EndIf

Return RetVal

*-----------------------------------------------------------------------------*
Function _GetBackColor ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i , RetVal := { Nil , Nil , Nil } , Tmp

   i := GetControlIndex ( ControlName, ParentForm )

   If  _HMG_aControlType [i] == 'GRID' .or. _HMG_aControlType [i] == 'MULTIGRID' .or. _HMG_aControlType [i] == 'BROWSE'
      Tmp := ListView_GetBkColor ( _HMG_aControlHandles [i] )
      RetVal [1] := GetRed (Tmp)
      RetVal [2] := GetGreen (Tmp)
      RetVal [3] := GetBlue (Tmp)

   Else
      RetVal := _HMG_aControlBkColor [i]

   EndIf

Return RetVal

*-----------------------------------------------------------------------------*
Function _IsControlEnabled ( ControlName, ParentForm, nPosition )
*-----------------------------------------------------------------------------*
   Local i , t , c , RetVal

   default nPosition to 0

   i := GetControlIndex  ( ControlName, ParentForm )
   t := GetControlType   ( ControlName, ParentForm )
   c := GetControlHandle ( ControlName, ParentForm )

   If t == 'MENU'
      RetVal := _IsMenuItemEnabled ( ControlName, ParentForm )

   ElseIf t == 'RADIOGROUP'
      RetVal := IsWindowEnabled( c [nPosition] )

   Else
      RetVal := _HMG_aControlEnabled [i]

   EndIf

Return RetVal

*-----------------------------------------------------------------------------*
Procedure _SetTextEditReadOnly ( ControlName , ParentForm, lValue )
*-----------------------------------------------------------------------------*
   Local i, t, c

   i := GetControlIndex  ( ControlName, ParentForm )
   t := GetControlType   ( ControlName, ParentForm )
   c := GetControlHandle ( ControlName, ParentForm )

   if Valtype( lValue ) <> "L"
      MsgMiniGUIError( "Readonly property must by a logical value type.Program terminated" )
   endif

   SetTextEditReadOnly ( c , lValue )

   If t == "TEXT" .or. t == "NUMTEXT" .or. t == "MASKEDTEXT" .or. t == "CHARMASKTEXT"
      _HMG_aControlMiscData1 [ i, 2 ] := lValue

   ElseIf t == "GETBOX"
      _HMG_aControlMiscData1 [ i, 2 ] := lValue
      _HMG_aControlProcedures [i] := IIf( lValue, NIL, _HMG_aControlMiscData1 [ i, 4 ] )
      _HMG_aControlDblClick [i] := IIf( lValue, NIL, _HMG_aControlMiscData1 [ i, 5 ] )

   ElseIf t == "EDIT"
      _HMG_aControlMiscData1 [ i, 3 ] := lValue

   EndIf

Return

*-----------------------------------------------------------------------------*
Procedure _SetStatusIcon( ControlName , ParentForm , Item , Icon )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName , ParentForm )

   SetStatusItemIcon( _HMG_aControlHandles[i] , Item , Icon )

Return

*-----------------------------------------------------------------------------*
Procedure _SetStatusWidth( ParentForm , Item , Size )
*-----------------------------------------------------------------------------*
   Local h := GetFormHandle ( ParentForm )
   Local aWidths := _GetStatusItemWidth( h )

   _SetStatusItemWidth( Item, Size, h )

   aWidths[Item] := Size
   SetStatusBarSize( _HMG_ActiveStatusHandle, aWidths )

   RefreshItemBar( _HMG_ActiveStatusHandle, _GetStatusItemWidth( h, 1 ) )

Return

*-----------------------------------------------------------------------------*
Function _GetCaption( ControlName , ParentForm )
*-----------------------------------------------------------------------------*
   Local cRetVal
   Local i := GetControlIndex ( ControlName , ParentForm )

   If _HMG_aControlType [i] == 'TOOLBUTTON'
      cRetVal := _HMG_aControlCaption [i]
   Else
      cRetVal := GetWindowText ( _HMG_aControlHandles [i] )
   EndIf

Return cRetVal

*-----------------------------------------------------------------------------*
Function _GetControlFree()
*-----------------------------------------------------------------------------*
   Local k := ascan ( _HMG_aControlDeleted , .T. )

   if k == 0

      k := Len(_HMG_aControlNames) + 1

      aAdd ( _HMG_aControlType      , Nil )
      aAdd ( _HMG_aControlNames      , Nil )
      aAdd ( _HMG_aControlHandles      , Nil )
      aAdd ( _HMG_aControlParenthandles   , Nil )
      aAdd ( _HMG_aControlIds         , Nil )
      aAdd ( _HMG_aControlProcedures      , Nil )
      aAdd ( _HMG_aControlPageMap      , Nil )
      aAdd ( _HMG_aControlValue      , Nil )
      aAdd ( _HMG_aControlInputMask      , Nil )
      aAdd ( _HMG_aControllostFocusProcedure   , Nil )
      aAdd ( _HMG_aControlGotFocusProcedure   , Nil )
      aAdd ( _HMG_aControlChangeProcedure   , Nil )
      aAdd ( _HMG_aControlDeleted      , Nil )
      aAdd ( _HMG_aControlBkColor      , Nil )
      aAdd ( _HMG_aControlFontColor      , Nil )
      aAdd ( _HMG_aControlDblClick      , Nil )
      aAdd ( _HMG_aControlHeadClick      , Nil )
      aAdd ( _HMG_aControlRow         , Nil )
      aAdd ( _HMG_aControlCol         , Nil )
      aAdd ( _HMG_aControlWidth      , Nil )
      aAdd ( _HMG_aControlHeight      , Nil )
      aAdd ( _HMG_aControlSpacing      , Nil )
      aAdd ( _HMG_aControlContainerRow   , Nil )
      aAdd ( _HMG_aControlContainerCol   , Nil )
      aAdd ( _HMG_aControlPicture      , Nil )
      aAdd ( _HMG_aControlContainerHandle   , Nil )
      aAdd ( _HMG_aControlFontName      , Nil )
      aAdd ( _HMG_aControlFontSize      , Nil )
      aAdd ( _HMG_aControlFontAttributes   , Nil )
      aAdd ( _HMG_aControlToolTip      , Nil )
      aAdd ( _HMG_aControlRangeMin      , Nil )
      aAdd ( _HMG_aControlRangeMax      , Nil )
      aAdd ( _HMG_aControlCaption      , Nil )
      aAdd ( _HMG_aControlVisible      , Nil )
      aAdd ( _HMG_aControlHelpId      , Nil )
      aAdd ( _HMG_aControlFontHandle      , Nil )
      aAdd ( _HMG_aControlBrushHandle      , Nil )
      aAdd ( _HMG_aControlEnabled      , Nil )
      aAdd ( _HMG_aControlMiscData1      , Nil )

   EndIf

Return k

// Jacek Kubica <kubica@wssk.wroc.pl> HMG 1.1 Experimental Build 10b
// enable/disable screen update for controls from ListView family
*-----------------------------------------------------------------------------*
Function _EnableListViewUpdate( ControlName, ParentForm, lEnable )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName, ParentForm )
   Local t := _HMG_aControlType [i]

   IF t == "MULTIGRID" .or. t == "GRID" .or. t == "COMBO" .or. t == "BROWSE" .or. t == "TREE"
      SendMessage (_HMG_aControlHandles [i], WM_SETREDRAW, iif(lEnable, 1, 0), 0)
   ELSE
      MsgMiniGuiError ("Method "+iif(lEnable, "EnableUpdate", "DisableUpdate")+" is available for ListView controls family only")
   ENDIF

Return NIL

// Jacek Kubica <kubica@wssk.wroc.pl> HMG 1.1 Experimental Build 11a
// cFile - string to be compacted (may be for example fullpath, path or file name)
// nMax  - required string size (characters count)
// Example:
//    _GetCompactPath("C:\Program Files\Adobe",20) return "C:\Program...\Adobe"
*-----------------------------------------------------------------------------*
Function _GetCompactPath( cFile, nMax )
*-----------------------------------------------------------------------------*
   Local cShort := SPACE( IFNUMERIC(nMax, nMax + 1, 64) )
Return IIF( GetCompactPath( @cShort, cFile, IFNUMERIC(nMax, nMax, 63), NIL ) > 0, cShort, cFile )

// Jacek Kubica <kubica@wssk.wroc.pl> HMG 1.1 Experimental Build 11a
// Example:
//    _GetShortPathName("C:\Program Files\Adobe") return "C:\Program~1\Adobe"
*-----------------------------------------------------------------------------*
Function _GetShortPathName( cPath )
*-----------------------------------------------------------------------------*
   Local cShortPathName
Return IIF( GetShortPathName( cPath, @cShortPathName ) > 0, cShortPathName, cPath )

// Jacek Kubica <kubica@wssk.wroc.pl> HMG 1.1 Experimental Build 12a
// Extend disable/enable control without change any control properties
*-----------------------------------------------------------------------------*
Function _ExtDisableControl ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local icp, icpe, hWnd := GetControlHandle ( ControlName, ParentForm )

   if IsWindowEnabled( hWnd )
      icp  := HiWord ( SendMessage( hWnd , EM_GETSEL , 0 , 0 ) )
      icpe := LoWord ( SendMessage( hWnd , EM_GETSEL , 0 , 0 ) )
      ChangeStyle( hWnd , WS_DISABLED  , , .f. )
      if icp <> icpe
         SendMessage( hWnd , EM_SETSEL , icpe , icpe )
      endif
      HideCaret( hWnd )
   endif

Return NIL

*-----------------------------------------------------------------------------*
Function _ExtEnableControl ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local hWnd := GetControlHandle ( ControlName, ParentForm )

   if ! IsWindowEnabled( hWnd )
      ChangeStyle( hWnd, , WS_DISABLED , .f. )
      ShowCaret( hWnd )
   endif

Return NIL

// Kevin Carmody <i@kevincarmody.com> 2007.04.23
// Set/Get RTF value of rich edit box.
*-----------------------------------------------------------------------------*
Function _SetGetRichValue ( ControlName, ParentForm, cValue, nType )
*-----------------------------------------------------------------------------*
   Local RetVal := "", i := GetControlIndex ( ControlName, ParentForm )

   If _HMG_aControlType [i] == 'RICHEDIT'
      If Valtype( cValue ) == 'C'
         _DataRichEditBoxSetValue ( ControlName, ParentForm, cValue, nType )
      Else
         RetVal := _DataRichEditBoxGetValue ( ControlName, ParentForm, nType )
      EndIf
   EndIf

Return RetVal

// Kevin Carmody <i@kevincarmody.com> 2007.04.23
// Set/Get AutoFont mode of rich edit box.
*-----------------------------------------------------------------------------*
Function _SetGetAutoFont ( ControlName, ParentForm, lAuto )
*-----------------------------------------------------------------------------*
   Local RetVal := .t., i := GetControlIndex ( ControlName, ParentForm )

   If _HMG_aControlType [i] == 'RICHEDIT'
      If Valtype( lAuto ) == 'L'
         _DataRichEditBoxSetAutoFont ( ControlName, ParentForm, lAuto )
      Else
         RetVal := _DataRichEditBoxGetAutoFont ( ControlName, ParentForm )
      EndIf
   EndIf

Return RetVal