/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

DIALOG form source code
(C)2005-2008 Janusz Pora <januszpora@onet.eu>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

#define WM_CLOSE            16
#define WM_COMMAND          273
#define WM_DESTROY          2
#define WM_NOTIFY           78
#define BN_CLICKED          0
#define WM_INITDIALOG       272

#define IDOK                1
#define IDCANCEL            2
#define IDABORT             3
#define IDRETRY             4
#define IDIGNORE            5
#define IDYES               6
#define IDNO                7
#define IDCLOSE             8
#define IDHELP              9
#define IDTRYAGAIN          10
#define IDCONTINUE          11

#define EM_LIMITTEXT        197
#define ES_UPPERCASE        8
#define ES_LOWERCASE        16
#define ES_PASSWORD         32
#define ES_READONLY         2048
#define ES_WANTRETURN       4096
#define ES_NUMBER           8192

#define DS_SETFONT          64   /* User specified font for Dlg controls */
#define WS_POPUP            2147483648
#define WS_CAPTION          12582912   // 0x00C00000L
#define WS_VISIBLE          268435456  // 0x10000000L
#define WS_SYSMENU          524288     // 0x00080000L
#define WS_THICKFRAME       262144     // 0x00040000L
#define WS_GROUP            131072     // 0x00020000L
#define WS_TABSTOP          65536      // 0x00010000L
#define WS_MINIMIZEBOX      131072     // 0x00020000L
#define WS_MAXIMIZEBOX      65536      // 0x00010000L

*-----------------------------------------------------------------------------*
Function _DefineDialog ( FormName, ParentForm, Id_resource , x , y , w , h , caption , fontname , fontsize , DialogProcedure , InitProcedure , ReleaseProcedure, modal , bold, italic )
*-----------------------------------------------------------------------------*
   Local i , htooltip , mVar , k
   Local FormHandle, ParentHandle, style

   DEFAULT x         TO 0
   DEFAULT y         TO 0
   DEFAULT w         TO 0
   DEFAULT h         TO 0

   _HMG_aDialogTemplate := {}
   _HMG_DialogInMemory  := .f.

   if valtype(FormName) == "U"
      FormName := _HMG_TempWindowName
   endif

   FormName := Alltrim(FormName)

   i := ascan ( _HMG_aFormType , 'A' )
   if i <= 0
      MsgMiniGuiError("Main Window Not Defined. Program Terminated" )
   Endif

   If _IsWindowDefined (FormName)
      MsgMiniGuiError("Dialog: "+ FormName + " already defined. Program Terminated" )
   endif

   mVar := '_' + FormName

   ParentHandle = GetFormHandle (ParentForm)

   _HMG_ModalDialogProcedure := {|| Nil }

   if EMPTY(Id_resource)
      style:= DS_SETFONT +WS_POPUP +WS_CAPTION +WS_VISIBLE +WS_SYSMENU +WS_THICKFRAME +WS_MAXIMIZEBOX +WS_MINIMIZEBOX
   //     style:= WS_POPUP +WS_CAPTION +WS_VISIBLE +WS_SYSMENU +WS_THICKFRAME +WS_MAXIMIZEBOX +WS_MINIMIZEBOX
      _HMG_DialogInMemory          := .T.
      _HMG_aDialogTemplate := {0,ParentHandle,modal,style,0,x,y,w,h,caption,fontname,fontsize,bold,Italic}
      _HMG_aDialogItems    := {}

      if modal
         _HMG_ActiveDialogHandle       := 0
         _HMG_ActiveDialogName       := FormName
         _HMG_BeginDialogActive       := .T.
         if valtype(InitProcedure) == "B"
            _HMG_InitDialogProcedure := InitProcedure
         endif
         if valtype(DialogProcedure) == "B"
            _HMG_ModalDialogProcedure := DialogProcedure
         endif
         Return Nil
      else
         if valtype(InitProcedure) == "B"
            _HMG_InitDialogProcedure := InitProcedure
         endif
         if valtype(DialogProcedure) == "B"
            _HMG_DialogProcedure := DialogProcedure
         endif
      endif
   else
      if modal
         if valtype(InitProcedure) == "B"
            _HMG_InitDialogProcedure := InitProcedure
         endif
         if valtype(DialogProcedure) == "B"
            _HMG_ModalDialogProcedure := DialogProcedure
         endif
         _HMG_ModalDialogReturn := InitModalDialog ( ParentHandle,  Id_resource )
         _HMG_InitDialogProcedure := ""
         _HMG_ModalDialogProcedure := ""
         Return Nil
      else
         if valtype(InitProcedure) == "B"
            _HMG_InitDialogProcedure := InitProcedure
         endif
         if valtype(DialogProcedure) == "B"
            _HMG_DialogProcedure := DialogProcedure
         endif
         Formhandle := InitDialog ( ParentHandle,  Id_resource )
         if FormHandle <=0
            MsgMiniGuiError("Error by create Dialog from resource. Program Terminated" )
         endif

      endif
   endif

   if valtype(FontName) == "U"
      _HMG_ActiveFontName := ""
   Else
      _HMG_ActiveFontName := FontName
   Endif

   if valtype(FontSize) == "U"
      _HMG_ActiveFontSize := 0
   Else
      _HMG_ActiveFontSize := FontSize
   Endif

   _HMG_ActiveDialogHandle       := Formhandle
   _HMG_ActiveDialogName       := FormName
   _HMG_BeginDialogActive       := .T.

   if valtype(caption) != "U"
      SetWindowText( FormHandle, caption )
   endif

   htooltip := InitToolTip(FormHandle)

   k := ascan ( _HMG_aFormDeleted , .T. )

   if k > 0

      Public &mVar. := k

      _HMG_aFormNames [k] := FormName
      _HMG_aFormHandles  [k] :=  FormHandle
      _HMG_aFormActive  [k] :=  .t.
      _HMG_aFormType  [k] := IF( _HMG_DialogInMemory ,'L', 'D')     // Windows type Dialog
      _HMG_aFormParentHandle  [k] :=  ParentHandle
      _HMG_aFormReleaseProcedure  [k] :=  ReleaseProcedure
      _HMG_aFormInitProcedure  [k] :=  InitProcedure
      _HMG_aFormToolTipHandle  [k] :=  htooltip
      _HMG_aFormContextMenuHandle  [k] :=  0
      _HMG_aFormMouseDragProcedure  [k] :=  ""
      _HMG_aFormSizeProcedure  [k] :=  ""
      _HMG_aFormClickProcedure  [k] :=  DialogProcedure
      _HMG_aFormMouseMoveProcedure  [k] :=  ""
      _HMG_aFormMoveProcedure  [k] :=  ""
      _HMG_aFormDropProcedure  [k] :=  ""
      _HMG_aFormDeleted  [k] := .f.
      _HMG_aFormBkColor  [k] := { -1 , -1 , -1 }
      _HMG_aFormPaintProcedure [k] :=   ""
      _HMG_aFormNoShow  [k] :=  .f.
      _HMG_aFormNotifyIconName  [k] :=  ""
      _HMG_aFormNotifyIconToolTip [k] := ""
      _HMG_aFormNotifyIconLeftClick   [k] := ""
      _HMG_aFormNotifyIconDblClick    [k] := ""
      _HMG_aFormGotFocusProcedure  [k] := ""
      _HMG_aFormLostFocusProcedure [k] := ""
      _HMG_aFormReBarHandle    [k] :=  0
      _HMG_aFormNotifyMenuHandle  [k] := 0
      _HMG_aFormBrowseList    [k] :=  {}
      _HMG_aFormSplitChildList  [k] := {}
      _HMG_aFormVirtualHeight    [k] :=  0
      _HMG_aFormVirtualWidth    [k] :=  0
      _HMG_aFormFocused    [k] :=  .f.
      _HMG_aFormScrollUp    [k] :=  ""
      _HMG_aFormScrollDown    [k] :=  ""
      _HMG_aFormScrollLeft    [k] :=  ""
      _HMG_aFormScrollRight    [k] :=  ""
      _HMG_aFormHScrollBox     [k] := ""
      _HMG_aFormVScrollBox     [k] := ""
      _HMG_aFormBrushHandle     [k] := 0
      _HMG_aFormFocusedControl  [k] := 0
      _HMG_aFormGraphTasks     [k] := {}
      _HMG_aFormMaximizeProcedure [k] :=  Nil
      _HMG_aFormMinimizeProcedure [k] :=  Nil
      _HMG_aFormRestoreProcedure [k] :=  Nil
      _HMG_aFormAutoRelease [k] :=  .F.
      _HMG_aFormInteractiveCloseProcedure [k] :=  ""
      _HMG_aFormMinMaxInfo [k] := {}
      _HMG_aFormActivateId [k] := 0

   Else

      Public &mVar. := Len(_HMG_aFormNames) + 1

      aAdd ( _HMG_aFormNames , FormName )
      aAdd ( _HMG_aFormHandles , FormHandle )
      aAdd ( _HMG_aFormActive , .t. )
      aAdd ( _HMG_aFormType , IF( _HMG_DialogInMemory ,'L', 'D')  )    // Windows type Dialog
      aAdd ( _HMG_aFormParentHandle , ParentHandle )
      aAdd ( _HMG_aFormReleaseProcedure , ReleaseProcedure )
      aAdd ( _HMG_aFormInitProcedure , InitProcedure )
      aAdd ( _HMG_aFormToolTipHandle , htooltip )
      aAdd ( _HMG_aFormContextMenuHandle , 0 )
      aAdd ( _HMG_aFormMouseDragProcedure , "" )
      aAdd ( _HMG_aFormSizeProcedure , "" )
      aAdd ( _HMG_aFormClickProcedure , DialogProcedure )
      aAdd ( _HMG_aFormMouseMoveProcedure , "" )
      aAdd ( _HMG_aFormMoveProcedure , "" )
      aAdd ( _HMG_aFormDropProcedure , "" )
      aAdd ( _HMG_aFormDeleted, .f. )
      aAdd ( _HMG_aFormBkColor, { -1 , -1 , -1 } )
      aAdd ( _HMG_aFormPaintProcedure , "" )
      aAdd ( _HMG_aFormNoShow , .f. )
      aAdd ( _HMG_aFormNotifyIconName       , ""    )
      aAdd ( _HMG_aFormNotifyIconToolTip      , ""    )
      aAdd ( _HMG_aFormNotifyIconLeftClick   , ""    )
      aAdd ( _HMG_aFormNotifyIconDblClick   , ""    )
      aAdd ( _HMG_aFormGotFocusProcedure      , "" )
      aAdd ( _HMG_aFormLostFocusProcedure      , "" )
      aAdd ( _HMG_aFormReBarHandle      , 0 )
      aAdd ( _HMG_aFormNotifyMenuHandle      , 0 )
      aAdd ( _HMG_aFormBrowseList         , {} )
      aAdd ( _HMG_aFormSplitChildList      , {} )
      aAdd ( _HMG_aFormVirtualHeight      , 0 )
      aAdd ( _HMG_aFormVirtualWidth      , 0 )
      aAdd ( _HMG_aFormFocused         , .f. )
      aAdd ( _HMG_aFormScrollUp         , "" )
      aAdd ( _HMG_aFormScrollDown         , "" )
      aAdd ( _HMG_aFormScrollLeft         , "" )
      aAdd ( _HMG_aFormScrollRight      , "" )
      aAdd ( _HMG_aFormHScrollBox         , "" )
      aAdd ( _HMG_aFormVScrollBox         , "" )
      aAdd ( _HMG_aFormBrushHandle      , 0 )
      aAdd ( _HMG_aFormFocusedControl      , 0 )
      aAdd ( _HMG_aFormGraphTasks         , {} )
      aAdd ( _HMG_aFormMaximizeProcedure      , "" )
      aAdd ( _HMG_aFormMinimizeProcedure      , "" )
      aAdd ( _HMG_aFormRestoreProcedure      , Nil )
      aAdd ( _HMG_aFormAutoRelease      , .F. )
      aAdd ( _HMG_aFormInteractiveCloseProcedure , "" )
      aAdd ( _HMG_aFormMinMaxInfo , {} )
      aAdd ( _HMG_aFormActivateId          , 0 )

   EndIf
   if len(_HMG_aDialogTemplate) > 0
      _HMG_aDialogTemplate[1] := &mVar.
   endif

Return (FormHandle)

*-----------------------------------------------------------------------------*
Function _BeginDialog( name, parent, Id_resource, x, y, w, h, caption, fontname, fontsize, dialogproc, initproc, releaseproc, modal, bold, italic, underline, strikeout )
*-----------------------------------------------------------------------------*
   Local aFont, FontHandle

   If _HMG_BeginDialogActive = .T.
      MsgMiniGuiError("DEFINE DIALOG Structures can't be nested. Program terminated")
   EndIf

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
      underline     := aFont[5]
      strikeout     := aFont[6]
   endif

   if _HMG_BeginWindowActive = .T.
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(fontname) == "U"
         fontname := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(fontsize) == "U"
         fontsize := _HMG_ActiveFontSize
      EndIf
   endif

   if valtype (parent) == 'U'
      parent := _HMG_ActiveFormName
   EndIf
   if valtype (Id_resource) == 'U'
      Id_resource := 0
   EndIf

   _DefineDialog ( name, parent, Id_resource, x, y, w, h, caption, fontname, fontsize, dialogproc, initproc, releaseproc, modal, bold, italic, underline, strikeout )

Return Nil

*-----------------------------------------------------------------------------*
Function _EndDialog()
*-----------------------------------------------------------------------------*
   Local FormHandle, ParentForm, nId, n, k, k_old, ControlHandle, blInit, FontHandle

   if  _HMG_DialogInMemory .and. len(_HMG_aDialogTemplate) > 0
      if _HMG_aDialogTemplate[3]  // Modal
         _HMG_ModalDialogReturn := CreateDlgTemplate ( _HMG_aDialogTemplate[2], _HMG_aDialogTemplate, _HMG_aDialogItems )
         _HMG_InitDialogProcedure := ""
         _HMG_ModalDialogProcedure := ""
         _HMG_aDialogTemplate := {}
         _HMG_aDialogItems    := {}
      else
//                                              10             12
//   {'ID',k/hwnd,class,Style,ExStyle,x,y,w,h,caption,HelpId,tooltip,font,size,bold,italic,underline,strikeout}  --->_HMG_aDialogItems

         Formhandle := CreateDlgTemplate (_HMG_aDialogTemplate[2], _HMG_aDialogTemplate,  _HMG_aDialogItems )
         if _HMG_aDialogTemplate[1] > 0
            _HMG_aFormHandles  [_HMG_aDialogTemplate[1]] :=  FormHandle
         endif
         ParentForm = FormHandle
         k_old := 0
         for n :=1 to len(_HMG_aDialogItems)
            nId     := _HMG_aDialogItems[n,1]
            k       := _HMG_aDialogItems[n,2]
            blInit  := _HMG_aDialogItems[n,19]

            ControlHandle := GetDialogItemHandle( ParentForm, nId )
            FontHandle    := GetFontHandle( _HMG_aDialogItems[n,13] )

            if FontHandle != 0
               _SetFontHandle (ControlHandle, FontHandle)
            else
               if valtype(_HMG_aDialogItems[n,13]) != "U" .and. valtype(_HMG_aDialogItems[n,14]) != "U"
                  FontHandle := _SetFont (ControlHandle,_HMG_aDialogItems[n,13],_HMG_aDialogItems[n,14],_HMG_aDialogItems[n,15],_HMG_aDialogItems[n,16],_HMG_aDialogItems[n,17],_HMG_aDialogItems[n,18])
               Else
                  FontHandle := _SetFont (ControlHandle,_HMG_DefaultFontName,_HMG_DefaultFontSize,_HMG_aDialogItems[n,15],_HMG_aDialogItems[n,16],_HMG_aDialogItems[n,17],_HMG_aDialogItems[n,18])
               Endif
            endif
            If _HMG_aDialogItems[n,20] == TRUE  //_HMG_BeginTabActive
               aAdd ( _HMG_ActiveTabCurrentPageMap , Controlhandle )
               if _HMG_aDialogItems[n,21]
                  while len(_HMG_ActiveTabFullPageMap)+1 < _HMG_aDialogItems[n,22]
                     aAdd ( _HMG_ActiveTabFullPageMap , {} )
                  enddo
                  aAdd ( _HMG_ActiveTabFullPageMap , _HMG_ActiveTabCurrentPageMap )
                  _HMG_ActiveTabCurrentPageMap := {}
               endif
            EndIf

            if valtype(_HMG_aDialogItems[n,12]) != "U"
               SetToolTip ( ControlHandle , _HMG_aDialogItems[n,12] , GetFormToolTipHandle (_HMG_ActiveDialogName) )
            endif
            if k > 0
               if k_old != k
                  if valtype(_HMG_aControlHandles  [ k ]) != "A"
                     _HMG_aControlHandles  [ k ] :=  ControlHandle
                  else
                     _HMG_aControlHandles  [ k ] :=  {}
                  endif
               else
                  aadd (_HMG_aControlHandles  [ k ] , ControlHandle )
               endif
               _HMG_aControlParentHandles  [ k ] :=  FormHandle
               _HMG_aControlFontHandle  [k] :=  FontHandle
               k_old := k
            endif
            if valtype(blInit) == "B"
               Eval( blInit, _HMG_ActiveDialogName, ControlHandle, k )
            endif
         next
      endif
      _HMG_DialogInMemory   := .f.
   endif
   _HMG_ActiveDialogName    := ""
   _HMG_BeginDialogActive   := .F.
   _HMG_InitDialogProcedure := ""
   _HMG_aDialogTemplate     := {}

Return Nil

*-----------------------------------------------------------------------------*
Function DialogProc(hwndDlg, nMsg, wParam, lParam)
*-----------------------------------------------------------------------------*
   Local ret := FALSE, i, ControlHandle
   _HMG_ActiveDlgProcHandle    := hwndDlg
   _HMG_ActiveDlgProcMsg       := nMsg
   _HMG_ActiveDlgProcId        := wParam
   _HMG_ActiveDlgProcNotify    := lParam
   _HMG_ActiveDlgProcModal     := .f.

   do case
   case nMsg == WM_INITDIALOG
      if valtype(_HMG_InitDialogProcedure) == 'B'
         Eval( _HMG_InitDialogProcedure, hwndDlg )
         ret := TRUE
      endif
   case nMsg == WM_DESTROY
      EraseDialog(hwndDlg)
      ret := TRUE
   case nMsg == WM_CLOSE
      i := ascan ( _HMG_aFormhandles, hwndDlg )
      if i > 0
         if valtype(_HMG_aFormReleaseProcedure [i]) == 'B'
            Eval( _HMG_aFormReleaseProcedure [i] )
         endif
      endif
      EraseDialog(hwndDlg)
      ret := TRUE
   case nMsg == WM_COMMAND
      i := ascan ( _HMG_aFormhandles, hwndDlg )  // find DialogProcedure
      if i > 0
         if valtype(_HMG_aFormClickProcedure [i]) == 'B' .and. _HMG_aFormType [i] == 'D'
            ret := Eval( _HMG_aFormClickProcedure [i], nMsg, LOWORD(wParam), HIWORD(wParam) )
            if valtype(ret) == "N"
               ret := if(ret=0, FALSE, TRUE)
            else
               ret := FALSE
            endif
         else                                                                   //JP 55
            ControlHandle := GetDialogITemHandle(hwndDlg,LOWORD(wParam))
            Events( hwndDlg, nMsg, wParam, ControlHandle )
            ret := TRUE                                                         //end
         endif
      endif
      if ret == FALSE
         ControlHandle := GetDialogITemHandle(hwndDlg,LOWORD(wParam))           //JP 55
         Events( hwndDlg, nMsg, wParam, ControlHandle )
         ret := TRUE
      endif
   otherwise
      Events( hwndDlg, nMsg, wParam, lParam )
      ret := FALSE
   endcase
   _HMG_ActiveDlgProcHandle    := 0
   _HMG_ActiveDlgProcMsg       := 0
   _HMG_ActiveDlgProcId        := 0
   _HMG_ActiveDlgProcNotify    := 0

Return ret

*-----------------------------------------------------------------------------*
Function ModalDialogProc(hwndDlg, nMsg, wParam, lParam)
*-----------------------------------------------------------------------------*
   Local ret

   HB_SYMBOL_UNUSED( lParam )

   _HMG_ActiveDlgProcHandle    := hwndDlg
   _HMG_ActiveDlgProcMsg       := nMsg
   _HMG_ActiveDlgProcId        := LOWORD(wParam)
   _HMG_ActiveDlgProcNotify    := HIWORD(wParam)
   _HMG_ActiveDlgProcModal     := .t.
   do case
   case nMsg == WM_INITDIALOG
      if valtype(_HMG_InitDialogProcedure )=='B'
         Eval( _HMG_InitDialogProcedure)
      endif
      ret := TRUE
   case nMsg == WM_CLOSE
      EndDialog(hwndDlg,0)
      ret := TRUE
   case nMsg == WM_COMMAND
      do case
      case LOWORD(wParam)== IDOK .and. HIWORD(wParam)== BN_CLICKED
         EndDialog(hwndDlg,IDOK)
         ret := TRUE
      case LOWORD(wParam)== IDCANCEL .and. HIWORD(wParam)== BN_CLICKED
         EndDialog(hwndDlg,IDCANCEL)
         ret := TRUE
      case LOWORD(wParam)== IDIGNORE .and. HIWORD(wParam)== BN_CLICKED
         ret := TRUE
      otherwise
         if valtype(_HMG_ModalDialogProcedure )=='B'
            Eval( _HMG_ModalDialogProcedure, hwndDlg, nMsg, LOWORD(wParam), HIWORD(wParam))
         endif
         ret := TRUE
      endcase
   otherwise
      ret := FALSE
   endcase
   _HMG_ActiveDlgProcHandle    := 0
   _HMG_ActiveDlgProcMsg       := 0
   _HMG_ActiveDlgProcId        := 0
   _HMG_ActiveDlgProcNotify    := 0

Return ret

*-----------------------------------------------------------------------------*
Function DisableDialogItem (hDlg, Id)
*-----------------------------------------------------------------------------*
   Local ControlHandle := GetDialogITemHandle(hDlg, Id)
   if ControlHandle > 0
      DisableWindow( ControlHandle )
   endif
Return Nil

*-----------------------------------------------------------------------------*
Function EnableDialogItem (hDlg, Id)
*-----------------------------------------------------------------------------*
   Local ControlHandle := GetDialogITemHandle(hDlg, Id)
   if ControlHandle > 0
      EnableWindow( ControlHandle )
   endif
Return Nil

*-----------------------------------------------------------------------------*
Function EraseDialog(hwndDlg)
*-----------------------------------------------------------------------------*
   Local i, x, ControlCount, mVar

   i := ascan ( _HMG_aFormhandles, hwndDlg)
   if i > 0
      ControlCount := Len (_HMG_aControlHandles)
      For x:=1 To ControlCount
         if _HMG_aControlParentHandles [x] == hwndDlg
            mVar := '_' + _HMG_aFormNames [i] + '_' + _HMG_aControlNames [x]
            if type ( mVar ) != 'U'
               __MVPUT ( mVar , 0 )
            EndIf
            _EraseControl(x,i)
         EndIf
      Next x
      mVar := '_' + _HMG_aFormNames [i]
      if type ( mVar ) != 'U'
         __MVPUT ( mVar , 0 )
      EndIf
      _HMG_aFormDeleted      [i]   := .T.
      _HMG_aFormhandles      [i]   := 0
      _HMG_aFormNames         [i]   := ""
      _HMG_aFormActive      [i]   := .f.
      _HMG_aFormType         [i]   := ""
      _HMG_aFormParenthandle      [i]   := 0
      _HMG_aFormInitProcedure      [i]   := ""
      _HMG_aFormReleaseProcedure   [i]   := ""
      _HMG_aFormToolTipHandle      [i]   := 0
      _HMG_aFormContextMenuHandle   [i]   := 0
      _HMG_aFormMouseDragProcedure   [i]   := ""
      _HMG_aFormSizeProcedure    [i]   := ""
      _HMG_aFormClickProcedure     [i]   := ""
      _HMG_aFormMouseMoveProcedure   [i]   := ""
      _HMG_aFormMoveProcedure      [i]   := ""
      _HMG_aFormDropProcedure      [i]   := ""
      _HMG_aFormBkColor      [i]   := Nil
      _HMG_aFormPaintProcedure   [i]   := ""
      _HMG_aFormNoShow      [i]   := .F.
      _HMG_aFormNotifyIconName   [i]   := ''
      _HMG_aFormNotifyIconToolTip   [i]   := ''
      _HMG_aFormNotifyIconLeftClick   [i]   := ''
      _HMG_aFormNotifyIconDblClick   [i]   := ''
      _HMG_aFormReBarHandle      [i]   := 0
      _HMG_aFormNotifyMenuHandle   [i]   := 0
      _HMG_aFormBrowseList      [i]   := {}
      _HMG_aFormSplitChildList   [i]   := {}
      _HMG_aFormVirtualHeight      [i]   := 0
      _HMG_aFormGotFocusProcedure   [i]   := ""
      _HMG_aFormLostFocusProcedure   [i]   := ""
      _HMG_aFormVirtualWidth      [i]   := 0
      _HMG_aFormFocused      [i]   := .f.
      _HMG_aFormScrollUp      [i]   := ""
      _HMG_aFormScrollDown      [i]   := ""
      _HMG_aFormScrollLeft      [i]   := ""
      _HMG_aFormScrollRight      [i]   := ""
      _HMG_aFormHScrollBox      [i]   := ""
      _HMG_aFormVScrollBox      [i]   := ""
      _HMG_aFormBrushHandle      [i]   := 0
      _HMG_aFormFocusedControl   [i]   := 0
      _HMG_aFormGraphTasks      [i]   := {}
      _HMG_aFormMaximizeProcedure   [i]   := Nil
      _HMG_aFormMinimizeProcedure   [i]   := Nil
      _HMG_aFormRestoreProcedure   [i]   := Nil
      _HMG_aFormAutoRelease      [i]   := .F.
      _HMG_aFormInteractiveCloseProcedure [i] := ""
      _HMG_aFormMinMaxInfo      [i]   := {}
      _HMG_aFormActivateId      [i]   := 0

      DestroyWindow(hwndDlg)
   endif

Return Nil

*-----------------------------------------------------------------------------*
Function _ReleaseDialog(hwndDlg)
*-----------------------------------------------------------------------------*
   Default  hwndDlg to _HMG_ActiveDlgProcHandle
   If hwndDlg != 0
      if _HMG_ActiveDlgProcModal
         EndDialog(hwndDlg, 0)
      else
         EraseDialog(hwndDlg)
      endif
   endif
Return Nil
