/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#define __SYSDATA__
#include 'minigui.ch'

*-----------------------------------------------------------------------------*
Function GetColor( aInitColor )
*-----------------------------------------------------------------------------*
   Local aRetVal [3] , nColor , nInitColor

   if valtype ( aInitColor ) != 'U'
      nInitColor := RGB ( aInitColor [1] , aInitColor [2] , aInitColor [3] )
   EndIf

   nColor := ChooseColor( NIL, nInitColor )

   If nColor == -1
      aRetVal [1] := Nil
      aRetVal [2] := Nil
      aRetVal [3] := Nil
   Else
      aRetVal [1] := GetRed (nColor)
      aRetVal [2] := GetGreen (nColor)
      aRetVal [3] := GetBlue (nColor)
   EndIf

Return aRetVal
// JK HMG 1.0 Experimental Build 8
*-----------------------------------------------------------------------------*
Function GetFolder( cTitle, cInitPath )
*-----------------------------------------------------------------------------*
Return C_BrowseForFolder( NIL, cTitle, NIL, NIL, cInitPath )

*-----------------------------------------------------------------------------*
Function BrowseForFolder( nfolder, nflag ) // Contributed By Ryszard Rylko
*-----------------------------------------------------------------------------*
Return C_BrowseForFolder( NIL, NIL, nflag, nfolder, NIL )

*-----------------------------------------------------------------------------*
Function GetFile( aFilter, title, cIniFolder, multiselect, nochangecurdir )
*-----------------------------------------------------------------------------*
   local c := '' , n
   local files , fileslist := {}

   Default aFilter := {}, multiselect := .f.

   FOR n := 1 TO Len( aFilter )
      c += aFilter[n][1] + Chr(0) + aFilter[n][2] + Chr(0)
   NEXT

   files := C_GetFile ( c , title, cIniFolder, multiselect, nochangecurdir )

   if multiselect
      if Len( files ) > 0
         if Valtype( files ) == "A"
            FOR n := 1 TO Len( files )
               if At( "\\", files[n] ) > 0
                  files[n] := StrTran( files[n] , "\\", "\" )
               endif
            NEXT
            fileslist := aClone( files )
         else
            aAdd( fileslist, files )
         endif
      endif
   else
      fileslist := files
   endif

Return ( fileslist )

*-----------------------------------------------------------------------------*
Function Putfile ( aFilter, title, cIniFolder, nochangecurdir, cFileName )
*-----------------------------------------------------------------------------*
   local c := '' , n

   Default aFilter := {}, cFileName := ""

   FOR n := 1 TO Len( aFilter )
      c += aFilter[n][1] + Chr(0) + aFilter[n][2] + Chr(0)
   NEXT

Return C_PutFile ( c, title, cIniFolder, nochangecurdir, cFileName )

*-----------------------------------------------------------------------------*
Function GetFont( cInitFontName , nInitFontSize , lBold , lItalic , anInitColor , lUnderLine , lStrikeOut , nCharset )
*-----------------------------------------------------------------------------*
   Local RetArray /*[8]*/ , rgbcolor

   If ValType ( cInitFontName ) == 'U'
      cInitFontName := ""
   EndIf	

   If ValType ( nInitFontSize ) == 'U'
      nInitFontSize := 0
   EndIf	

   If ValType ( lBold ) == 'U'
      lBold := .F.
   EndIf	

   If ValType ( lItalic ) == 'U'
      lItalic := .F.
   EndIf	

   If ValType ( anInitColor ) == 'U'
      rgbcolor := 0	
   Else
      rgbcolor := RGB( anInitColor[1] , anInitColor[2] , anInitColor[3] )
   EndIf

   If ValType ( lUnderLine ) == 'U'
      lUnderLine := .F.
   EndIf	

   If ValType ( lStrikeOut ) == 'U'
      lStrikeOut := .F.
   EndIf	

   If ValType ( nCharSet ) == 'U'
      nCharSet := 0
   EndIf	

   RetArray := ChooseFont( cInitFontName , nInitFontSize , lBold , lItalic , rgbcolor , lUnderLine , lStrikeOut , nCharSet )

   If ! Empty ( RetArray [1] )
      rgbcolor := RetArray [5]
      RetArray [5] := { GetRed(rgbcolor) , GetGreen(rgbcolor) , GetBlue(rgbcolor) }
   Else
      RetArray [5] := { Nil , Nil , Nil }
   EndIf

Return RetArray