/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

*-----------------------------------------------------------------------------*
Function drawtextout(window,row,col,string,fontcolor,backcolor,fontname,fontsize,bold,italic,underline,strikeout,transparent)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex( Window )
   Local FormHandle := _HMG_aFormHandles[i]
   local torow := 0
   local tocol := 0

   IF formhandle > 0

      if valtype(fontname) == "U"
         fontname := _HMG_DefaultFontName
      endif
      if valtype(fontsize) == "U"
         fontsize := _HMG_DefaultFontSize
      endif
      if valtype(backcolor) == "U"
         backcolor := {255,255,255}
      endif
      if valtype(fontcolor) == "U"
         fontcolor := {0,0,0}
      endif

      torow := row + if(transparent, 0, fontsize + 4)
      tocol := col + (len(string) - 1) * fontsize

      textdraw( formhandle,row,col,string,torow,tocol,fontcolor,backcolor,fontname,fontsize,bold,italic,underline,strikeout,transparent )
      aadd ( _HMG_aFormGraphTasks[i], { || textdraw( formhandle,row,col,string,torow,tocol,fontcolor,backcolor,fontname,fontsize,bold,italic,underline,strikeout,transparent) } )
   ENDIF

return nil

*-----------------------------------------------------------------------------*
Function drawline(window,row,col,row1,col1,penrgb,penwidth)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i]

   if formhandle > 0

      if valtype(penrgb) == "U"
         penrgb = {0,0,0}
      endif

      if valtype(penwidth) == "U"
         penwidth = 1
      endif

      linedraw( formhandle,row,col,row1,col1,penrgb,penwidth)

      aadd ( _HMG_aFormGraphTasks [i] , { || linedraw( formhandle,row,col,row1,col1,penrgb,penwidth) } )

   endif

return nil

*-----------------------------------------------------------------------------*
Function drawrect(window,row,col,row1,col1,penrgb,penwidth,fillrgb)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i] , fill

   if formhandle > 0

      if valtype(penrgb) == "U"
         penrgb = {0,0,0}
      endif

      if valtype(penwidth) == "U"
         penwidth = 1
      endif

      if valtype(fillrgb) == "U"
         fillrgb := {255,255,255}
         fill := .f.
      else
         fill := .t.
      endif

      rectdraw( FormHandle,row,col,row1,col1,penrgb,penwidth,fillrgb,fill)

      aadd ( _HMG_aFormGraphTasks [i] , { || rectdraw( FormHandle,row,col,row1,col1,penrgb,penwidth,fillrgb,fill) } )

   endif
return nil

*-----------------------------------------------------------------------------*
Function drawroundrect(window,row,col,row1,col1,width,height,penrgb,penwidth,fillrgb)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i] , fill

   if formhandle > 0
      if valtype(penrgb) == "U"
         penrgb = {0,0,0}
      endif
      if valtype(penwidth) == "U"
         penwidth = 1
      endif
      if valtype(fillrgb) == "U"
         fillrgb := {255,255,255}
         fill := .f.
      else
         fill := .t.
      endif
      roundrectdraw( FormHandle,row,col,row1,col1,width,height,penrgb,penwidth,fillrgb,fill)

      aadd ( _HMG_aFormGraphTasks [i] , { || roundrectdraw( FormHandle,row,col,row1,col1,width,height,penrgb,penwidth,fillrgb,fill) } )

   endif
return nil

*-----------------------------------------------------------------------------*
Function drawellipse(window,row,col,row1,col1,penrgb,penwidth,fillrgb)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i] , fill

   if formhandle > 0
      if valtype(penrgb) == "U"
         penrgb = {0,0,0}
      endif
      if valtype(penwidth) == "U"
         penwidth = 1
      endif
      if valtype(fillrgb) == "U"
         fillrgb := {255,255,255}
         fill := .f.
      else
         fill := .t.
      endif
      ellipsedraw( FormHandle ,row,col,row1,col1,penrgb,penwidth,fillrgb,fill)

      aadd ( _HMG_aFormGraphTasks [i] , { || ellipsedraw( FormHandle ,row,col,row1,col1,penrgb,penwidth,fillrgb,fill) } )

   endif
return nil

*-----------------------------------------------------------------------------*
Function drawarc(window,row,col,row1,col1,rowr,colr,rowr1,colr1,penrgb,penwidth)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i]

   if formhandle > 0
      if valtype(penrgb) == "U"
         penrgb = {0,0,0}
      endif
      if valtype(penwidth) == "U"
         penwidth = 1
      endif
      arcdraw( FormHandle ,row,col,row1,col1,rowr,colr,rowr1,colr1,penrgb,penwidth)
      aadd ( _HMG_aFormGraphTasks [i] , { || arcdraw( FormHandle ,row,col,row1,col1,rowr,colr,rowr1,colr1,penrgb,penwidth) } )

   endif

return nil

*-----------------------------------------------------------------------------*
Function drawpie(window,row,col,row1,col1,rowr,colr,rowr1,colr1,penrgb,penwidth,fillrgb)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i] , fill

   if formhandle > 0
      if valtype(penrgb) == "U"
         penrgb = {0,0,0}
      endif
      if valtype(penwidth) == "U"
         penwidth = 1
      endif
      if valtype(fillrgb) == "U"
         fillrgb := {255,255,255}
         fill := .f.
      else
         fill := .t.
      endif
      piedraw( FormHandle,row,col,row1,col1,rowr,colr,rowr1,colr1,penrgb,penwidth,fillrgb,fill)

      aadd ( _HMG_aFormGraphTasks [i] , { || piedraw( FormHandle,row,col,row1,col1,rowr,colr,rowr1,colr1,penrgb,penwidth,fillrgb,fill) } )

   endif
return nil

*-----------------------------------------------------------------------------*
Function drawpolygon(window,apoints,penrgb,penwidth,fillrgb)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i] , fill
   local xarr := {}
   local yarr := {}
   local x

   if formhandle > 0
      if valtype(penrgb) == "U"
         penrgb = {0,0,0}
      endif
      if valtype(penwidth) == "U"
         penwidth = 1
      endif
      if valtype(fillrgb) == "U"
         fillrgb := {255,255,255}
         fill := .f.
      else
         fill := .t.
      endif
      for x := 1 to len(apoints)
         aadd(xarr,apoints[x,2])
         aadd(yarr,apoints[x,1])
      next x
      polygondraw(FormHandle,xarr,yarr,penrgb,penwidth,fillrgb,fill)
      aadd( _HMG_aFormGraphTasks[i] , {||polygondraw(FormHandle,xarr,yarr,penrgb,penwidth,fillrgb,fill)})
   endif
return nil

*-----------------------------------------------------------------------------*
Function drawpolybezier(window,apoints,penrgb,penwidth)
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i]
   local xarr := {}
   local yarr := {}
   local x

   if formhandle > 0
      if valtype(penrgb) == "U"
         penrgb = {0,0,0}
      endif
      if valtype(penwidth) == "U"
         penwidth = 1
      endif
      for x := 1 to len(apoints)
         aadd(xarr,apoints[x,2])
         aadd(yarr,apoints[x,1])
      next x
      polybezierdraw(FormHandle,xarr,yarr,penrgb,penwidth)
      aadd( _HMG_aFormGraphTasks[i] , {||polybezierdraw(FormHandle,xarr,yarr,penrgb,penwidth)})
   endif
return nil

*-----------------------------------------------------------------------------*
Function EraseWindow( window )
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i]

   if FormHandle > 0

      if _HMG_aFormDeleted [i] == .F.

         If ValType ( _HMG_aFormGraphTasks [i] ) == 'A'

            asize( _HMG_aFormGraphTasks [i], 0 )
            RedrawWindow( FormHandle )

         endif

      endif

   endif

return nil

*-----------------------------------------------------------------------------*
Function DrawWindowBoxIn( window, row, col, rowr, colr )
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i]
   Local hDC := GetDC( FormHandle )

   WndBoxIn( hDC, row, col, rowr, colr )
   ReleaseDC( FormHandle, hDC )
   Aadd( _HMG_aFormGraphTasks [i] , { || WndBoxIn( hDC := GetDC( FormHandle ), row, col, rowr, colr ), ReleaseDC( FormHandle, hDC ) } )

return nil

*-----------------------------------------------------------------------------*
Function DrawWindowBoxRaised( window, row, col, rowr, colr )
*-----------------------------------------------------------------------------*
   Local i := GetFormIndex ( Window )
   Local FormHandle := _HMG_aFormHandles [i]
   Local hDC := GetDC( FormHandle )

   WndBoxRaised( hDC, row, col, rowr, colr )
   ReleaseDC( FormHandle, hDC )
   Aadd( _HMG_aFormGraphTasks [i] , { || WndBoxRaised( hDC := GetDC( FormHandle ), row, col, rowr, colr ), ReleaseDC( FormHandle, hDC ) } )

return nil

*-----------------------------------------------------------------------------*
Function BmpSize( Bitmap )
*-----------------------------------------------------------------------------*
Return IFSTRING( Bitmap, IFNUMERIC( Bitmap, GetBitmapSize( Bitmap ), BitmapSize( Bitmap ) ), {0,0,4} )