/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

*-----------------------------------------------------------------------------*
*-Module: h_error.prg
*-Target: Collect MiniGui Errors
*-Date Created: 01-01-2003
*-Author: Antonio Novo <novoantonio@hotmail.com>
*-----------------------------------------------------------------------------*
#define CRLF	HB_OsNewLine()
*-----------------------------------------------------------------------------*
*-Procedure: MsgMiniGuiError
*-Recieve: Message (String)
*-----------------------------------------------------------------------------*
Procedure MsgMiniGuiError( Message )
   Local n := 1, cText := "", HtmArch, HtmText

   HtmArch := Html_ErrorLog()
   Html_LineText( HtmArch, "Date:" + Dtoc(Date()) + "  " + "Time: " + Time() )
   cText += MiniGuiVersion() + CRLF + Message + CRLF + CRLF
   Html_LineText( HtmArch, "Error: " + MiniGuiVersion() )
   Html_LineText( HtmArch, Message )
   WHILE ! Empty( ProcName( n ) )
      HtmText := "Called from " + ProcName( n ) + "(" + AllTrim( Str( ProcLine( n++ ), 0 ) ) + ")" + CRLF
      cText += HtmText
      Html_LineText( HtmArch, HtmText )
   ENDDO
   Html_Line( HtmArch )
   Html_End( HtmArch )
   ShowError( cText )
Return
*-----------------------------------------------------------------------------*
*-Version of MiniGUI
*-----------------------------------------------------------------------------*
Function MiniGuiVersion
Return( "Harbour MiniGUI 1.6 Extended Edition (Build 62) - 2009.01.22" )