/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"
#include "i_winuser.ch"
#include "error.ch"

#ifdef _TSBROWSE_
   Memvar _TSB_aControlhWnd, _TSB_aControlObjects
#endif
*-----------------------------------------------------------------------------*
Function Events ( hWnd, nMsg, wParam, lParam )
*-----------------------------------------------------------------------------*
   Local i, z, x, FormCount, lvc, k, aPos , maskstart , xs , xd , ts , nr
   Local ControlCount , RecordCount , SkipCount , BackRec , BackArea , BrowseArea , NextControlHandle , NewPos , NewHPos , NewVPos , _ThisQueryTemp , r
   Local hwm , hws , mVar, DeltaSelect , TmpStr, Tmp , xRetVal , aCellData
   Local aTemp , aTemp2 , a , dBc , dFc , oGet
#ifdef _USERINIT_
   Local cProc
#endif

   Static lOpaque := .f., _IsXPThemed := NIL, _ActiveMenu := .F.

#ifdef _TSBROWSE_
   IF Type('_TSB_aControlhWnd') == 'A' .and. Len(_TSB_aControlhWnd) > 0
      oGet := GetObjectByHandle(hWnd)
      IF ValType(oGet) == 'O'
         r := oGet:HandleEvent ( nMsg, wParam, lParam )
         if ValType(r) == 'N'
            IF r != 0
               RETURN r
            ENDIF
         endif
      ENDIF
   ENDIF
#endif

#ifdef _USERINIT_
   For i := 1 To Len ( _HMG_aCustomEventProcedure )

      cProc := _HMG_aCustomEventProcedure [ i ]

      r := &cProc ( hWnd , nMsg , wParam , lParam )

      If ValType ( r ) <> 'U'
         Return r
      Endif

   Next i
#endif

   switch nMsg
***********************************************************************
case WM_MEASUREITEM
***********************************************************************

   IF wParam == 0
      _OnMeasureMenuItem( hWnd, nMsg, wParam, lParam )
   ENDIF
   exit
***********************************************************************
case WM_DRAWITEM
***********************************************************************

   IF GETOWNBTNCTLTYPE( lParam ) == ODT_MENU
      _OnDrawMenuItem( lParam )
      RETURN 0
   ELSEIF GETOWNBTNCTLTYPE( lParam ) == ODT_BUTTON
      RETURN ( OwnButtonPaint( lParam ) )
   ELSEIF  GETOWNBTNCTLTYPE( lParam ) == ODT_TAB
      RETURN ( OwnTabPaint( lParam ) )
   ENDIF

***********************************************************************
case WM_CTLCOLORSTATIC
***********************************************************************

   i := ascan ( _HMG_aControlHandles , lParam )

   if i > 0

      TmpStr := _HMG_aControlType [i]

      If TmpStr $ "GETBOX,LABEL,HYPERLINK,CHECKBOX,FRAME,SLIDER,NUMTEXT,MASKEDTEXT,CHARMASKTEXT,BTNTEXT,BTNNUMTEXT,EDIT"

         If TmpStr $ "GETBOX,NUMTEXT,MASKEDTEXT,CHARMASKTEXT,BTNTEXT,BTNNUMTEXT,EDIT"

            if IsWindowEnabled( _HMG_aControlHandles[ i ] )

               If _HMG_aControlFontColor [ i ] != Nil
                  If valtype(_HMG_aControlFontColor [ i , 2]) == "A" .and. len(_HMG_aControlFontColor [ i , 2]) == 3
                     SetTextColor( wParam, _HMG_aControlFontColor [ i , 2 , 1 ], _HMG_aControlFontColor [ i , 2 , 2 ], _HMG_aControlFontColor [ i , 2 , 3 ] )
                  ElseIf valtype(_HMG_aControlFontColor [ i , 2 ]) == "N" .and. len(_HMG_aControlFontColor [ i ]) == 3
                     SetTextColor( wParam, _HMG_aControlFontColor [ i , 1 ], _HMG_aControlFontColor [ i , 2 ], _HMG_aControlFontColor [ i , 3 ] )
                  EndIf
               EndIf

               If _HMG_aControlBkColor [ i ] != Nil

                  If valtype( _HMG_aControlBkColor [ i , 2 ] ) == "A" .and. len( _HMG_aControlBkColor [ i , 2 ] ) == 3
                     SetBkColor( wParam , _HMG_aControlBkColor [ i , 2 , 1 ] , _HMG_aControlBkColor [ i , 2 , 2 ] , _HMG_aControlBkColor [ i , 2 , 3 ] )
                     DeleteObject ( _HMG_aControlBrushHandle [ i ] )
                     _HMG_aControlBrushHandle [ i ] := CreateSolidBrush( _HMG_aControlBkColor [ i , 2 , 1 ] , _HMG_aControlBkColor [ i , 2 , 2 ] , _HMG_aControlBkColor [ i , 2 , 3 ] )
                     Return ( _HMG_aControlBrushHandle [ i ] )
                  Else
                     If valtype( _HMG_aControlBkColor [ i , 2] ) == "N" .and. len( _HMG_aControlBkColor [ i ] ) == 3
                        SetBkColor( wParam , _HMG_aControlBkColor [ i , 1 ] , _HMG_aControlBkColor [ i , 2 ] , _HMG_aControlBkColor [ i , 3 ] )
                        DeleteObject ( _HMG_aControlBrushHandle [ i ] )
                        _HMG_aControlBrushHandle [ i ] := CreateSolidBrush( _HMG_aControlBkColor [ i  , 1 ] , _HMG_aControlBkColor [ i  , 2 ] , _HMG_aControlBkColor [ i , 3 ] )
                        Return ( _HMG_aControlBrushHandle [ i ] )
                     EndIf
                  EndIf

               Else
                  SetBkColor( wParam , GetRed ( GetSysColor ( COLOR_3DFACE ) ) , GetGreen ( GetSysColor ( COLOR_3DFACE ) ) , GetBlue ( GetSysColor ( COLOR_3DFACE ) ) )
                  DeleteObject ( _HMG_aControlBrushHandle [ i ] )
                  _HMG_aControlBrushHandle [ i ] := CreateSolidBrush( GetRed ( GetSysColor ( COLOR_3DFACE ) ) , GetGreen ( GetSysColor ( COLOR_3DFACE ) ) , GetBlue ( GetSysColor (COLOR_3DFACE ) ) )
                  Return ( _HMG_aControlBrushHandle [ i ] )

               EndIf

            EndIf

         Else

            If _IsXPThemed == Nil
               _IsXPThemed := IsThemed()
            endif

            Tmp := _HMG_aControlContainerRow [i] <> -1 .AND. _HMG_aControlContainerCol [i] <> -1 .AND. _HMG_aControlBkColor [i] == Nil

            if _IsXPThemed .AND. TmpStr == "SLIDER" .AND. Tmp
               if _HMG_aControlDblClick [i] == .f. .and. !lOpaque
                  nr := GetControlIndex( _HMG_aControlFontHandle [i], _HMG_aControlMiscData1 [i] )
                  DeleteObject ( _HMG_aControlBrushHandle [ nr ] )
                  hws := GetControlHandle( _HMG_aControlFontHandle [i], _HMG_aControlMiscData1 [i] )
                  _HMG_aControlBrushHandle [ nr ] := GetTabBrush( hws )
                  Return GetTabbedControlBrush ( wParam , lParam , hws , _HMG_aControlBrushHandle [ nr ] )
               endif
            endif

            if _IsXPThemed .AND. TmpStr == "FRAME" .AND. Tmp
               if _HMG_aControlDblClick [i] == .f.
                  nr := GetControlIndex( _HMG_aControlRangeMin [i], _HMG_aControlRangeMax [i] )
                  DeleteObject ( _HMG_aControlBrushHandle [ nr ] )
                  hws := GetControlHandle( _HMG_aControlRangeMin [i], _HMG_aControlRangeMax [i] )
                  _HMG_aControlBrushHandle [ nr ] := GetTabBrush( hws )
                  Return GetTabbedControlBrush ( wParam , lParam , hws , _HMG_aControlBrushHandle [ nr ] )
               else
                  lOpaque := .t.
               endif
            endif

            if _IsXPThemed .AND. TmpStr == "CHECKBOX" .AND. Tmp
               if _HMG_aControlDblClick [i] == .f. .and. !lOpaque
                  nr := GetControlIndex( _HMG_aControlRangeMin [i], _HMG_aControlRangeMax [i] )
                  DeleteObject ( _HMG_aControlBrushHandle [ nr ] )
                  hws := GetControlHandle( _HMG_aControlRangeMin [i], _HMG_aControlRangeMax [i] )
                  _HMG_aControlBrushHandle [ nr ] := GetTabBrush( hws )
                  Return GetTabbedControlBrush ( wParam , lParam , hws , _HMG_aControlBrushHandle [ nr ] )
               endif
            endif

            If _HMG_aControlFontColor [i] != Nil
               SetTextColor( wParam , _HMG_aControlFontColor [i] [1] , _HMG_aControlFontColor [i] [2] , _HMG_aControlFontColor [i] [3] )
            EndIf

            If ValType ( _HMG_aControlInputMask [i] ) == 'L'
               If _HMG_aControlInputMask [i] == .T.
                  SetBkMode( wParam , TRANSPARENT )
                  Return(GetStockObject( NULL_BRUSH ) )
               EndIf
            EndIf

            If _HMG_aControlBkColor [i] != Nil

               SetBkColor( wParam , _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
               DeleteObject ( _HMG_aControlBrushHandle [i] )
               _HMG_aControlBrushHandle [i] := CreateSolidBrush( _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
               Return ( _HMG_aControlBrushHandle [i] )

            Else

               DeleteObject ( _HMG_aControlBrushHandle [i] )
               _HMG_aControlBrushHandle [i] := CreateSolidBrush( GetRed ( GetSysColor ( COLOR_3DFACE) ) , GetGreen ( GetSysColor ( COLOR_3DFACE) ) , GetBlue ( GetSysColor ( COLOR_3DFACE) ) )
               SetBkColor( wParam , GetRed ( GetSysColor ( COLOR_3DFACE) ) , GetGreen ( GetSysColor ( COLOR_3DFACE) ) , GetBlue ( GetSysColor ( COLOR_3DFACE) ) )
               Return ( _HMG_aControlBrushHandle [i] )

            EndIf

         EndIf

      EndIf

   Else

      For i := 1 To Len ( _HMG_aControlhandles )

         If ValType ( _HMG_aControlHandles [i] ) == 'A'

            If _HMG_aControlType [i] == 'RADIOGROUP'

               For x := 1 To Len ( _HMG_aControlHandles [i] )

                  If _HMG_aControlHandles [i] [x] == lParam

                     If _HMG_aControlFontColor [i] != Nil
                        SetTextColor( wParam , _HMG_aControlFontColor [i] [1] , _HMG_aControlFontColor [i] [2] , _HMG_aControlFontColor [i] [3] )
                     EndIf

                     If _IsXPThemed == Nil
                        _IsXPThemed := IsThemed()
                     endif

                     if _IsXPThemed .AND. _HMG_aControlContainerRow [i] <> -1 .AND. _HMG_aControlContainerCol [i] <> -1
                        if _HMG_aControlDblClick [i] == .f. .and. !lOpaque
                           nr := GetControlIndex( _HMG_aControlRangeMin [i], _HMG_aControlRangeMax [i] )
                           DeleteObject ( _HMG_aControlBrushHandle [ nr ] )
                           hws := GetControlHandle( _HMG_aControlRangeMin [i], _HMG_aControlRangeMax [i] )
                           _HMG_aControlBrushHandle [ nr ] := GetTabBrush( hws )
                           Return GetTabbedControlBrush ( wParam , lParam , hws , _HMG_aControlBrushHandle [ nr ] )
                        endif
                     endif

                     If ValType ( _HMG_aControlInputMask [i] ) == 'L'
                        If _HMG_aControlInputMask [i] == .T.
                           SetBkMode( wParam , TRANSPARENT )
                           Return ( GetStockObject( NULL_BRUSH ) )
                        EndIf
                     EndIf

                     If _HMG_aControlBkColor [i] != Nil
                        SetBkColor( wParam , _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
                        if x == 1
                           DeleteObject ( _HMG_aControlBrushHandle [i] )
                           _HMG_aControlBrushHandle [i] := CreateSolidBrush( _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
                        EndIf
                        return ( _HMG_aControlBrushHandle [i] )
                     Else
                        if x == 1
                           DeleteObject ( _HMG_aControlBrushHandle [i] )
                           _HMG_aControlBrushHandle [i] := CreateSolidBrush( GetRed ( GetSysColor ( COLOR_3DFACE) ) , GetGreen ( GetSysColor ( COLOR_3DFACE) ) , GetBlue ( GetSysColor ( COLOR_3DFACE) ) )
                        EndIf
                        SetBkColor( wParam , GetRed ( GetSysColor ( COLOR_3DFACE) ) , GetGreen ( GetSysColor ( COLOR_3DFACE) ) , GetBlue ( GetSysColor ( COLOR_3DFACE) ) )
                        return ( _HMG_aControlBrushHandle [i] )

                     EndIf

                  EndIf

               Next x

            EndIf

         EndIf

      Next i

   EndIf
   exit
***********************************************************************
case WM_CTLCOLOREDIT
case WM_CTLCOLORLISTBOX
***********************************************************************

   i := ascan ( _HMG_aControlHandles , lParam )

   if i > 0

      TmpStr := _HMG_aControlType [i]

      If TmpStr $  "GETBOX,NUMTEXT,MASKEDTEXT,CHARMASKTEXT,EDIT,BTNTEXT,BTNNUMTEXT,MULTILIST,COMBO"

         If _HMG_aControlFontColor [i] != Nil
            If valtype(_HMG_aControlFontColor [i,1]) == "N"
               SetTextColor( wParam,_HMG_aControlFontColor [i] [1], _HMG_aControlFontColor [i] [2] , _HMG_aControlFontColor [i] [3] )
            ElseIf valtype(_HMG_aControlFontColor [i,1]) == "A"

               if len(_HMG_aControlFontColor[i]) > 2 .and. GetFocus() == _HMG_aControlHandles [i]
                  SetTextColor( wParam,_HMG_aControlFontColor [i,3,1], _HMG_aControlFontColor [i,3,2] , _HMG_aControlFontColor [i,3,3] )
               else
                  SetTextColor( wParam,_HMG_aControlFontColor [i,1,1], _HMG_aControlFontColor [i,1,2] , _HMG_aControlFontColor [i,1,3] )
               endif
            EndIf
         EndIf

         If _HMG_aControlBkColor [i] != Nil

            If valtype(_HMG_aControlBkColor [i,1]) == "N"
               SetBkColor( wParam, _HMG_aControlBkColor [i] [1], _HMG_aControlBkColor [i] [2], _HMG_aControlBkColor [i] [3] )
               DeleteObject ( _HMG_aControlBrushHandle [i] )
               _HMG_aControlBrushHandle [i] := CreateSolidBrush( _HMG_aControlBkColor [i] [1], _HMG_aControlBkColor [i] [2], _HMG_aControlBkColor [i] [3] )
               return ( _HMG_aControlBrushHandle [i] )
            Else
               If valtype(_HMG_aControlBkColor [i,1]) == "A"
                  if len(_HMG_aControlBkColor[i]) == 3 .and. GetFocus() == _HMG_aControlHandles [i]
                     SetBkColor( wParam, _HMG_aControlBkColor [i,3,1], _HMG_aControlBkColor [i,3,2], _HMG_aControlBkColor [i,3,3] )
                     DeleteObject ( _HMG_aControlBrushHandle [i] )
                     _HMG_aControlBrushHandle [i] := CreateSolidBrush( _HMG_aControlBkColor [i,3,1], _HMG_aControlBkColor [i,3,2], _HMG_aControlBkColor [i,3,3] )
                     return ( _HMG_aControlBrushHandle [i] )
                  else
                     SetBkColor( wParam, _HMG_aControlBkColor [i,1,1], _HMG_aControlBkColor [i,1,2], _HMG_aControlBkColor [i,1,3] )
                     DeleteObject ( _HMG_aControlBrushHandle [i] )
                     _HMG_aControlBrushHandle [i] := CreateSolidBrush( _HMG_aControlBkColor [i,1,1], _HMG_aControlBkColor [i,1,2], _HMG_aControlBkColor [i,1,3] )
                     return ( _HMG_aControlBrushHandle [i] )
                  endif
               EndIf
            EndIf

         Else

            DeleteObject ( _HMG_aControlBrushHandle [i] )
            _HMG_aControlBrushHandle [i] := CreateSolidBrush( GetRed ( GetSysColor ( COLOR_WINDOW) ) , GetGreen ( GetSysColor ( COLOR_WINDOW) ) , GetBlue ( GetSysColor ( COLOR_WINDOW) ) )
            SetBkColor( wParam, GetRed ( GetSysColor ( COLOR_WINDOW) ) , GetGreen ( GetSysColor ( COLOR_WINDOW) ) , GetBlue ( GetSysColor ( COLOR_WINDOW) ) )
            return ( _HMG_aControlBrushHandle [i] )

         EndIf

      EndIf

   Else

      For i := 1 To Len ( _HMG_aControlhandles )

         If ValType ( _HMG_aControlHandles [i] ) == 'A'

            If _HMG_aControlType [i] == 'SPINNER'

               If _HMG_aControlHandles [i] [1] == lParam

                  If _HMG_aControlFontColor [i] != Nil
                     SetTextColor( wParam , _HMG_aControlFontColor [i] [1] , _HMG_aControlFontColor [i] [2] , _HMG_aControlFontColor [i] [3] )
                  EndIf

                  If _HMG_aControlBkColor [i] != Nil
                     SetBkColor( wParam , _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
                     DeleteObject ( _HMG_aControlBrushHandle [i] )
                     _HMG_aControlBrushHandle [i] := CreateSolidBrush( _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
                     return ( _HMG_aControlBrushHandle [i] )
                  Else
                     DeleteObject ( _HMG_aControlBrushHandle [i] )
                     _HMG_aControlBrushHandle [i] := CreateSolidBrush( GetRed ( GetSysColor ( COLOR_WINDOW) ) , GetGreen ( GetSysColor ( COLOR_WINDOW) ) , GetBlue ( GetSysColor ( COLOR_WINDOW) ) )
                     SetBkColor( wParam , GetRed ( GetSysColor ( COLOR_WINDOW) ) , GetGreen ( GetSysColor ( COLOR_WINDOW) ) , GetBlue ( GetSysColor ( COLOR_WINDOW) ) )
                     return ( _HMG_aControlBrushHandle [i] )
                  EndIf

               EndIf

            EndIf

         EndIf

         If _HMG_aControlType [i] == "COMBO"

            If Empty( _HMG_aControlRangeMax [i] )
               _HMG_aControlRangeMax [i] := wParam
            EndIf

            If GetFocus() == _HMG_aControlHandles [i] .Or. GetFocus() == _HMG_aControlRangeMax [i]

               If _HMG_aControlFontColor [i] != Nil
                  SetTextColor( wParam , _HMG_aControlFontColor [i] [1] , _HMG_aControlFontColor [i] [2] , _HMG_aControlFontColor [i] [3] )
               EndIf

               If _HMG_aControlBkColor [i] != Nil
                  If _HMG_aControlRangeMin [i] == lParam
                     SetBkColor( lParam , _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
                  EndIf
                  SetBkColor( wParam , _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
                  DeleteObject ( _HMG_aControlBrushHandle [i] )
                  _HMG_aControlBrushHandle [i] := CreateSolidBrush( _HMG_aControlBkColor [i] [1] , _HMG_aControlBkColor [i] [2] , _HMG_aControlBkColor [i] [3] )
                  return ( _HMG_aControlBrushHandle [i] )
               EndIf

            EndIf

         EndIf

      Next i

   EndIf
   exit
***********************************************************************
case WM_MENUSELECT
***********************************************************************

   if AND( HIWORD(wParam), MF_HILITE ) <> 0

      i := Ascan ( _HMG_aControlIds , LOWORD(wParam) ) // LOWORD(wParam) = menu id

      if i > 0

         if ( x := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles [i] ) ) > 0
            _ActiveMenu := .T.
            if _IsControlDefined ( "StatusBar" , _HMG_aFormNames [x] )
               if _HMG_aControlValue [i] # NIL
                  SetProperty( _HMG_aFormNames [x], "StatusBar", "Item", 1, _HMG_aControlValue [i] )
               elseif valtype ( _HMG_DefaultStatusBarMessage ) == "C"
                  SetProperty( _HMG_aFormNames [x], "StatusBar", "Item", 1, _HMG_DefaultStatusBarMessage )
               endif
            endif
         endif

      endif

   EndIf
   exit
***********************************************************************
case WM_HOTKEY
***********************************************************************

      * Process HotKeys

   i := Ascan ( _HMG_aControlIds , wParam )

   If i > 0
      //JP MDI HotKey
      If _HMG_aControlType [i] = "HOTKEY"
         if _HMG_BeginWindowMDIActive
            if _HMG_aControlParentHandles[i] == GetActiveMdiHandle() .Or. _HMG_InplaceParentHandle <> 0
               If _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
                  Return 0
               EndIf
            elseif _HMG_aControlParentHandles[i] == GetActiveWindow()
               If _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
                  Return 0
               EndIf
            endif
         elseif _HMG_aControlParentHandles[i] == GetActiveWindow() .And. _ActiveMenu == .F.
            If _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
               Return 0
            EndIf
         else
            PlayHand()
         endif
      EndIf
      //End JP
   EndIf
   exit
***********************************************************************
case WM_MOUSEWHEEL
***********************************************************************

   hwnd := 0

   i := ascan ( _HMG_aFormHandles , GetFocus() )

   if i > 0 .and. ! _HMG_AutoAdjust

      If _HMG_aFormVirtualHeight [i] > 0
         hwnd := _HMG_aFormHandles [i]
      EndIf

   Else

      i := ascan ( _HMG_aControlhandles , GetFocus() )
      If i > 0 .and. ! _HMG_AutoAdjust

         x := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles [i] )

         if x > 0
            If _HMG_aFormVirtualHeight [x] > 0
               hwnd := _HMG_aFormHandles [x]
            EndIf
         EndIf
      Else
         ControlCount := Len ( _HMG_aControlHandles )
         For i := 1 To ControlCount
            if _HMG_aControlType [i] == 'RADIOGROUP'
               x := ascan ( _HMG_aControlHandles [i] , GetFocus() )
               If x > 0
                  z := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles [i] )
                  if z > 0
                     If _HMG_aFormVirtualHeight [z] > 0
                        hwnd := _HMG_aFormHandles [z]
                        Exit
                     EndIf
                  EndIf
               EndIf
            Endif
         Next i
      EndIf

   EndIf

   If hwnd != 0

      If HIWORD(wParam) == 120
         if GetScrollPos(hwnd,SB_VERT) < 25
            SendMessage ( hwnd , WM_VSCROLL , SB_TOP , 0 )
         Else
            SendMessage ( hwnd , WM_VSCROLL , SB_PAGEUP , 0 )
         endif
      Else
         if GetScrollPos(hwnd,SB_VERT) >= GetScrollRangeMax ( hwnd , SB_VERT ) - 10
            SendMessage ( hwnd , WM_VSCROLL , SB_BOTTOM , 0 )
         else
            SendMessage ( hwnd , WM_VSCROLL , SB_PAGEDOWN , 0 )
         endif
      EndIf

   EndIf
   exit
***********************************************************************
case WM_CREATE
***********************************************************************

   if  _HMG_BeginWindowMDIActive .and. _HMG_MainClientMDIHandle == 0

      _HMG_MainClientMDIHandle := InitMDIClientWindow(hWnd)

   endif
   exit
***********************************************************************
case WM_ACTIVATE
***********************************************************************

   If LoWord(wparam) == 0

      i := Ascan ( _HMG_aFormhandles , hWnd )

      if i > 0

         ControlCount := Len ( _HMG_aControlHandles )

         For x := 1 To ControlCount
            If _HMG_aControlType [x] == 'HOTKEY'
               ReleaseHotKey ( _HMG_aControlParentHandles [x] , _HMG_aControlIds [x] )
            EndIf
         Next x

         _HMG_aFormFocusedControl [i] := GetFocus()

         _DoWindowEventProcedure ( _HMG_aFormLostFocusProcedure [i] , i , 'WINDOW_LOSTFOCUS' )

      Endif

   Else

      i := Ascan ( _HMG_aFormhandles , hWnd )
      if i > 0
         UpdateWindow ( hWnd )
      EndIf

   EndIf
   exit
***********************************************************************
case WM_SETFOCUS
***********************************************************************

   i := Ascan ( _HMG_aFormhandles , hWnd )

   if i > 0

      If _hmg_aFormActive [i] == .T. .and. _hmg_aFormType [i] != 'X'
         _hmg_UserWindowHandle := hWnd
      EndIf

      ControlCount := Len ( _HMG_aControlHandles )

      For x := 1 To ControlCount
         //JP MDI HotKey
         If _HMG_aControlType [x] == 'HOTKEY'
            If .Not. _HMG_BeginWindowMDIActive
               ReleaseHotKey ( _HMG_aControlParentHandles [x] , _HMG_aControlIds [x] )
            ElseIf _HMG_aControlParentHandles [x] != GetFormHandle(_HMG_MainClientMDIName) .Or. _HMG_InplaceParentHandle <> 0
               ReleaseHotKey ( _HMG_aControlParentHandles [x] , _HMG_aControlIds [x] )
            Endif
         EndIf
         //End
      Next x

      For x := 1 To ControlCount
         If _HMG_aControlType [x] == 'HOTKEY'
            If _HMG_aControlParentHandles[x] == hWnd .Or. ( _HMG_BeginWindowMDIActive .And. _HMG_InplaceParentHandle == GetActiveMdiHandle() )
               InitHotKey ( hWnd , _HMG_aControlPageMap [x] , _HMG_aControlValue [x] , _HMG_aControlIds [x] )
            EndIf
         EndIf
      Next x

      _DoWindowEventProcedure ( _HMG_aFormGotFocusProcedure [i] , i , 'WINDOW_GOTFOCUS' )

      if ( _HMG_aFormFocusedControl [i] != 0 , setfocus (_HMG_aFormFocusedControl [i]) , Nil )

   Endif
   exit
***********************************************************************
case WM_HELP
***********************************************************************

   i := ascan ( _HMG_aControlHandles , GetHelpData ( lParam ) )

   if i > 0
      WinHelp ( hWnd , _HMG_ActiveHelpFile , 2 , _HMG_aControlHelpId[i] )
   EndIf
   exit
***********************************************************************
case WM_GETMINMAXINFO
***********************************************************************

   RETURN _OnGetMinMaxInfo ( hWnd, lParam )
   ***********************************************************************
   case WM_VSCROLL
   ***********************************************************************

      i := aScan ( _HMG_aFormHandles , hWnd )

      if i > 0

         * Vertical ScrollBar Processing

         if _HMG_aFormVirtualHeight [i] > 0 .And. lParam == 0

            If _HMG_aFormRebarhandle [i] > 0
               MsgMiniGuiError("SplitBox's Parent Window cannot be a 'Virtual Dimensioned' window (use 'Virtual Dimensioned' SplitChild instead). Program terminated" )
            EndIf

            z := GetScrollRangeMax ( hwnd , SB_VERT ) / 20

            If LoWord(wParam) == SB_LINEDOWN

               NewPos := GetScrollPos(hwnd,SB_VERT) + z
               SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )

            ElseIf LoWord(wParam) == SB_LINEUP

               NewPos := GetScrollPos(hwnd,SB_VERT) - z
               SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )

            ElseIf LoWord(wParam) == SB_TOP

               NewPos := 0
               SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )

            ElseIf LoWord(wParam) == SB_BOTTOM

               NewPos := GetScrollRangeMax(hwnd,SB_VERT)
               SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )

            ElseIf LoWord(wParam) == SB_PAGEUP

               NewPos := GetScrollPos(hwnd,SB_VERT) - 20
               SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )

            ElseIf LoWord(wParam) == SB_PAGEDOWN

               NewPos := GetScrollPos(hwnd,SB_VERT) + 20
               SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )

            ElseIf LoWord(wParam) == SB_THUMBPOSITION

               NewPos := HIWORD(wParam)
               SetScrollPos ( hwnd , SB_VERT , NewPos , 1 )

            EndIf

            If _HMG_aFormVirtualWidth [i] > 0
               NewHPos := GetScrollPos ( hwnd , SB_HORZ )
            Else
               NewHPos := 0
            EndIf

            * Control Repositioning

            If LoWord(wParam) == SB_THUMBPOSITION .Or. LoWord(wParam) == SB_LINEDOWN .Or. LoWord(wParam) == SB_LINEUP .Or. LoWord(wParam) == SB_PAGEUP .Or. LoWord(wParam) == SB_PAGEDOWN .Or. LoWord(wParam) == SB_BOTTOM .Or. LoWord(wParam) == SB_TOP .And. ! _HMG_AutoAdjust

               For x := 1 To Len ( _HMG_aControlhandles )

                  If _HMG_aControlParentHandles [x] == hwnd

                     If _HMG_aControlType [x] == 'SPINNER'

                        MoveWindow ( _HMG_aControlhandles [x] [1] , _HMG_aControlCol [x] - NewHPos , _HMG_aControlRow [x] - NewPos , _HMG_aControlWidth [x] - GetWindowWidth(_HMG_aControlhandles [x] [2] )+1 , _HMG_aControlHeight [x] , .t. )
                        MoveWindow ( _HMG_aControlhandles [x] [2] , _HMG_aControlCol [x] + _HMG_aControlWidth [x] - GetWindowWidth(_HMG_aControlhandles [x] [2] ) - NewHPos , _HMG_aControlRow [x] - NewPos , GetWindowWidth(_HMG_aControlhandles [x] [2] ) , _HMG_aControlHeight [x] , .t. )

                     ElseIf _HMG_aControlType [x] == 'BROWSE'

                        MoveWindow ( _HMG_aControlhandles [x] , _HMG_aControlCol [x] - NewHPos , _HMG_aControlRow [x] - NewPos , _HMG_aControlWidth [x] - GETVSCROLLBARWIDTH() , _HMG_aControlHeight [x] , .t. )
                        MoveWindow ( _HMG_aControlIds [x] , _HMG_aControlCol [x] + _HMG_aControlWidth [x] - GETVSCROLLBARWIDTH() - NewHPos , _HMG_aControlRow [x] - NewPos , GETVSCROLLBARWIDTH() , GetWIndowHeight(_HMG_aControlIds [x]) , .t. )

                        MoveWindow ( _HMG_aControlMiscData1 [x] [1] , _HMG_aControlCol [x] + _HMG_aControlWidth [x] - GETVSCROLLBARWIDTH() - NewHPos , _HMG_aControlRow [x] +_HMG_aControlHeight [x] - GetHScrollBarHeight () - NewPos ,;
                           GetWindowWidth(_HMG_aControlMiscData1 [x][1]) , GetWindowHeight(_HMG_aControlMiscData1 [x][1]) , .t. )


                        ReDrawWindow ( _HMG_aControlhandles [x] )

                     ElseIf _HMG_aControlType [x] == 'RADIOGROUP'

                        For z := 1 To Len (_HMG_aControlhandles [x])
                           If _HMG_aControlMiscData1 [x] = .F.
                              MoveWindow ( _HMG_aControlhandles [x] [z] , _HMG_aControlCol [x] - NewHPos , _HMG_aControlRow [x] - NewPos + ( (z-1) * _HMG_aControlSpacing[x] ), _HMG_aControlWidth [x] , _HMG_aControlHeight [x] / Len (_HMG_aControlhandles [x]) , .t. )
                           Else && horizontal
                              MoveWindow ( _HMG_aControlhandles [x] [z] , _HMG_aControlCol [x] - NewHPos + (z-1) * ( _HMG_aControlWidth [x] + _HMG_aControlSpacing[x] ), _HMG_aControlRow [x] - NewPos , _HMG_aControlWidth [x] , _HMG_aControlHeight [x] , .t. )
                           EndIf
                        Next z

                     ElseIf _HMG_aControlType [x] == 'TOOLBAR'

                        MsgMiniGuiError("ToolBar's Parent Window cannot be a 'Virtual Dimensioned' window (use 'Virtual Dimensioned' SplitChild instead). Program terminated" )

                     Else

                        MoveWindow ( _HMG_aControlhandles [x] , _HMG_aControlCol [x] - NewHPos , _HMG_aControlRow [x] - NewPos , _HMG_aControlWidth [x] , _HMG_aControlHeight [x] , .t. )

                     EndIf

                  EndIf
               Next x

               ReDrawWindow ( hwnd )

            EndIf

         EndIf

         If LoWord(wParam) == SB_LINEDOWN
            _DoWindowEventProcedure ( _HMG_aFormScrollDown [i] , i )
         ElseIf LoWord(wParam) == SB_LINEUP
            _DoWindowEventProcedure ( _HMG_aFormScrollUp [i] , i )
         ElseIf LoWord(wParam) == SB_THUMBPOSITION .or. LoWord(wParam) == SB_PAGEUP .or. LoWord(wParam) == SB_PAGEDOWN .or. LoWord(wParam) == SB_TOP .or. LoWord(wParam) == SB_BOTTOM
            _DoWindowEventProcedure ( _HMG_aFormVScrollBox [i] , i )
         EndIf

      EndIf

      i := aScan ( _HMG_aControlIds , lParam )

      if i > 0

         if _HMG_aControlType [i] == 'BROWSE'

            If LoWord(wParam) == SB_LINEDOWN

               setfocus( _HMG_aControlHandles [i] )
               InsertDown()

            EndIf

            If LoWord(wParam) == SB_LINEUP

               setfocus( _HMG_aControlHandles [i] )
               InsertUp()

            EndIf

            If LoWord(wParam) == SB_PAGEUP
               setfocus( _HMG_aControlHandles [i] )
               InsertPrior()
            EndIf

            If LoWord(wParam) == SB_PAGEDOWN
               setfocus( _HMG_aControlHandles [i] )
               InsertNext()
            EndIf

            If LoWord(wParam) == SB_THUMBPOSITION

               BackArea := Alias()
               BrowseArea := _HMG_aControlSpacing [i]

               If Select (BrowseArea) != 0

                  Select &BrowseArea
                  BackRec := RecNo()

                  If OrdKeyCount() > 0
                     RecordCount := OrdKeyCount()
                  Else
                     RecordCount := RecCount()
                  EndIf

                  SkipCount := Int ( HIWORD(wParam) * RecordCount / GetScrollRangeMax ( _HMG_aControlIds [ i ] , 2 ) )

                  If SkipCount > ( RecordCount / 2 )
                     Go Bottom
                     Skip - ( RecordCount - SkipCount )
                  Else
                     Go Top
                     If SkipCount > 1
                        Skip SkipCount - RecCount()/100
                     EndIf
                  EndIf

                  If Eof()
                     Skip -1
                  EndIf

                  nr := RecNo()

                  SetScrollPos ( _HMG_aControlIds [i] , 2 , HIWORD(wParam) , 1 )

                  Go BackRec

                  If Select (BackArea) != 0
                     Select &BackArea
                  Else
                     Select 0
                  EndIf

                  _BrowseSetValue ( '' , '' , nr , i )

               EndIf

            EndIf

         EndIf

      EndIf

      i := Ascan ( _HMG_aControlhandles , lParam )
      if i > 0
         If _HMG_aControlType [i] == 'SLIDER'
            If LoWord (wParam) == TB_ENDTRACK
               _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i )
            ElseIf LoWord (wParam) == TB_THUMBTRACK .or. LoWord (wParam) == TB_LINEUP .or. LoWord (wParam) == TB_LINEDOWN
               _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
            EndIf
         EndIf
      EndIf
      exit
   ***********************************************************************
   case WM_TASKBAR
   ***********************************************************************

      If wParam == ID_TASKBAR .and. lParam # WM_MOUSEMOVE

         switch lParam

         case WM_LBUTTONDOWN

            i := Ascan ( _HMG_aFormhandles , hWnd )
            if i > 0
               _DoWindowEventProcedure ( _HMG_aFormNotifyIconLeftClick [i] , i )
            Endif
            exit

         case WM_LBUTTONDBLCLK

            i := Ascan ( _HMG_aFormhandles , hWnd )
            if i > 0
               _DoWindowEventProcedure ( _HMG_aFormNotifyIconDblClick [i] , i )
            Endif
            exit

         case WM_RBUTTONDOWN

            if _HMG_ShowContextMenus == .t.

               aPos := GetCursorPos()

               i := Ascan ( _HMG_aFormhandles , hWnd )
               if i > 0
                  if _HMG_aFormNotifyMenuHandle [i] != 0
                     TrackPopupMenu ( _HMG_aFormNotifyMenuHandle [i] , aPos[2] , aPos[1] , hWnd )
                  Endif
               Endif

            EndIf

         end

      EndIf
      exit
***********************************************************************
case WM_NEXTDLGCTL
***********************************************************************

   If Wparam == 0
      NextControlHandle := GetNextDlgTabITem ( GetActiveWindow() , GetFocus() , 0 )
   else
      NextControlHandle := GetNextDlgTabITem ( GetActiveWindow() , GetFocus() , 1 )
   endif

   setfocus( NextControlHandle )

   i := ascan ( _HMG_aControlHandles , NextControlHandle )

   if i > 0
      If _HMG_aControlType [i] == 'BUTTON'
         SendMessage ( NextControlHandle , BM_SETSTYLE , LOWORD ( BS_DEFPUSHBUTTON ) , 1 )
      ElseIf _HMG_aControlType [i] == 'EDIT' .Or. _HMG_aControlType [i] == 'TEXT'
         SendMessage( _HMG_aControlhandles [i] , EM_SETSEL , 0 , -1 )
      endif
   EndIf
   exit
***********************************************************************
case WM_HSCROLL
***********************************************************************

   i := aScan ( _HMG_aFormHandles , hWnd )

   if i > 0

      * Horizontal ScrollBar Processing

      if _HMG_aFormVirtualWidth [i] > 0 .And. lParam == 0

         If _HMG_aFormRebarhandle [i] > 0
            MsgMiniGuiError("SplitBox's Parent Window cannot be a 'Virtual Dimensioned' window (use 'Virtual Dimensioned' SplitChild instead). Program terminated" )
         EndIf

         z := GetScrollRangeMax ( hwnd , SB_HORZ ) / 20

         If LoWord(wParam) == SB_LINERIGHT

            NewHPos := GetScrollPos(hwnd,SB_HORZ) + z
            SetScrollPos ( hwnd , SB_HORZ , NewHPos , 1 )

         ElseIf LoWord(wParam) == SB_LINELEFT

            NewHPos := GetScrollPos(hwnd,SB_HORZ) - z
            SetScrollPos ( hwnd , SB_HORZ , NewHPos , 1 )

         ElseIf LoWord(wParam) == SB_PAGELEFT

            NewHPos := GetScrollPos(hwnd,SB_HORZ) - 20
            SetScrollPos ( hwnd , SB_HORZ , NewHPos , 1 )

         ElseIf LoWord(wParam) == SB_PAGERIGHT

            NewHPos := GetScrollPos(hwnd,SB_HORZ) + 20
            SetScrollPos ( hwnd , SB_HORZ , NewHPos , 1 )

         ElseIf LoWord(wParam) == SB_THUMBPOSITION

            NewHPos := HIWORD(wParam)
            SetScrollPos ( hwnd , SB_HORZ , NewHPos , 1 )

         EndIf

         If _HMG_aFormVirtualHeight [i] > 0
            NewVPos := GetScrollPos ( hwnd , SB_VERT )
         Else
            NewVPos := 0
         EndIf

         * Control Repositioning

         If LoWord(wParam) == SB_THUMBPOSITION .Or. LoWord(wParam) == SB_LINELEFT .Or. LoWord(wParam) == SB_LINERIGHT .Or. LoWord(wParam) == SB_PAGELEFT .Or. LoWord(wParam) == SB_PAGERIGHT .And. ! _HMG_AutoAdjust

            For x := 1 To Len ( _HMG_aControlhandles )

               If _HMG_aControlParentHandles [x] == hwnd

                  If _HMG_aControlType [x] == 'SPINNER'

                     MoveWindow ( _HMG_aControlhandles [x] [1] , _HMG_aControlCol [x] - NewHPos , _HMG_aControlRow [x] - NewVPos , _HMG_aControlWidth [x] - GetWindowWidth(_HMG_aControlhandles [x] [2] )+1 , _HMG_aControlHeight [x] , .t. )
                     MoveWindow ( _HMG_aControlhandles [x] [2] , _HMG_aControlCol [x] + _HMG_aControlWidth [x] - GetWindowWidth(_HMG_aControlhandles [x] [2] ) - NewHPos , _HMG_aControlRow [x] - NewVPos ,;
                        GetWindowWidth(_HMG_aControlhandles [x] [2] ) , _HMG_aControlHeight [x] , .t. )

                  ElseIf _HMG_aControlType [x] == 'BROWSE'

                     MoveWindow ( _HMG_aControlhandles [x] , _HMG_aControlCol [x] - NewHPos , _HMG_aControlRow [x] - NewVPos , _HMG_aControlWidth [x] - GETVSCROLLBARWIDTH() , _HMG_aControlHeight [x] , .t. )

                     MoveWindow ( _HMG_aControlIds [x] , _HMG_aControlCol [x] + _HMG_aControlWidth [x] - GETVSCROLLBARWIDTH() - NewHPos , _HMG_aControlRow [x] - NewVPos ,;
                        GetWindowWidth(_HMG_aControlIds [x]) , GetWindowHeight(_HMG_aControlIds [x]) , .t. )

                     MoveWindow ( _HMG_aControlMiscData1 [x] [1] , _HMG_aControlCol [x] + _HMG_aControlWidth [x] - GETVSCROLLBARWIDTH() - NewHPos , _HMG_aControlRow [x] +_HMG_aControlHeight[x] - GethScrollBarHeight() - NewVPos ,;
                        GetWindowWidth(_HMG_aControlMiscData1 [x] [1]) , GetWindowHeight (_HMG_aControlMiscData1 [x][1]) , .t. )


                     ReDrawWindow ( _HMG_aControlhandles [x] )

                  ElseIf _HMG_aControlType [x] == 'RADIOGROUP'

                     For z := 1 To Len (_HMG_aControlhandles [x])
                        If _HMG_aControlMiscData1 [x] = .F.
                           MoveWindow ( _HMG_aControlhandles [x] [z] , _HMG_aControlCol [x] - NewHPos , _HMG_aControlRow [x] - NewVPos + ( (z-1) * _HMG_aControlSpacing[x] ),;
                              _HMG_aControlWidth [x] , _HMG_aControlHeight [x] / Len (_HMG_aControlhandles [x]) , .t. )
                        Else  && horizontal
                           MoveWindow ( _HMG_aControlhandles [x] [z] , _HMG_aControlCol [x] - NewHPos + (z-1) * ( _HMG_aControlWidth [x] + _HMG_aControlSpacing[x] ) , _HMG_aControlRow [x] - NewVPos ,;
                              _HMG_aControlWidth [x] , _HMG_aControlHeight [x] , .t. )
                        EndIf
                     Next z

                  ElseIf _HMG_aControlType [x] == 'TOOLBAR'

                     MsgMiniGuiError("ToolBar's Parent Window cannot be a 'Virtual Dimensioned' window (use 'Virtual Dimensioned' SplitChild instead). Program terminated" )

                  Else

                     MoveWindow ( _HMG_aControlhandles [x] , _HMG_aControlCol [x] - NewHPos , _HMG_aControlRow [x] - NewVPos , _HMG_aControlWidth [x] , _HMG_aControlHeight [x] , .t. )

                  EndIf

               EndIf
            Next x

            RedrawWindow ( hwnd )

         EndIf

      EndIf

      If LoWord(wParam) == SB_LINERIGHT

         _DoWindowEventProcedure ( _HMG_aFormScrollRight [i] , i )

      ElseIf LoWord(wParam) == SB_LINELEFT

         _DoWindowEventProcedure ( _HMG_aFormScrollLeft [i] , i )

      ElseIf   LoWord(wParam) == SB_THUMBPOSITION;
         .or.;
         LoWord(wParam) == SB_PAGELEFT;
         .or.;
         LoWord(wParam) == SB_PAGERIGHT

         _DoWindowEventProcedure ( _HMG_aFormHScrollBox [i] , i )

      EndIf

   EndIf

   i := Ascan ( _HMG_aControlhandles , lParam )
   if i > 0
      If _HMG_aControlType [i] == 'SLIDER'
         If LoWord (wParam) == TB_ENDTRACK
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i )
         ElseIf LoWord (wParam) == TB_THUMBTRACK .Or. LoWord (wParam) == TB_LINEUP .Or. LoWord (wParam) == TB_LINEDOWN
            _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         EndIf
      EndIf
   EndIf
   exit
***********************************************************************
case WM_PAINT
***********************************************************************

   FormCount := Len ( _HMG_aFormhandles )

   For z := 1 To FormCount
      If _HMG_aFormDeleted [z] == .F.
         If _HMG_aFormType [z] == 'X'
            If ValType ( _HMG_aFormGraphTasks [z] ) == 'A'
               If Len ( _HMG_aFormGraphTasks [z] ) > 0
                  For x := 1 To Len ( _HMG_aFormGraphTasks [z] )
                     Eval ( _HMG_aFormGraphTasks [z] [x] )
                  Next x
               EndIf
            EndIf
         EndIf
      EndIf
   Next z

   i := Ascan ( _HMG_aFormhandles , hWnd )

   if i > 0

      For x := 1 To Len ( _HMG_aFormGraphTasks [i] )
         Eval ( _HMG_aFormGraphTasks [i] [x] )
      Next x

      DefWindowProc( hWnd, nMsg, wParam, lParam )

      _DoWindowEventProcedure ( _HMG_aFormPaintProcedure [i] , i )

      Return 1

   Endif
   exit
***********************************************************************
case WM_RBUTTONDOWN
***********************************************************************

   if _HMG_ShowContextMenus == .f.

      _HMG_MouseRow := HIWORD(lParam)
      _HMG_MouseCol := LOWORD(lParam)
      _HMG_MouseState := 2

      i := Ascan ( _HMG_aFormhandles , hWnd )

      if i > 0
         _DoWindowEventProcedure ( _HMG_aFormClickProcedure [i] , i )
      Endif

   EndIf
   exit
***********************************************************************
case WM_LBUTTONDOWN
***********************************************************************

   _HMG_MouseRow := HIWORD(lParam)
   _HMG_MouseCol := LOWORD(lParam)
   _HMG_MouseState := 1

   i := Ascan ( _HMG_aFormhandles , hWnd )

   if i > 0

      if _hmg_aformvirtualheight [i] > 0
         _HMG_MouseRow := _HMG_MouseRow + GetScrollPos(hwnd,SB_VERT)
      endif

      if _hmg_aformvirtualwidth [i] > 0
         _HMG_MouseCol := _HMG_MouseCol + GetScrollPos(hwnd,SB_HORZ)
      endif

      _DoWindowEventProcedure ( _HMG_aFormClickProcedure [i] , i )
   Endif
   exit
***********************************************************************
case WM_LBUTTONUP
***********************************************************************

   _HMG_MouseState := 0
   exit
***********************************************************************
case WM_MOUSEMOVE
***********************************************************************

   _ActiveMenu := .F.
   _HMG_MouseRow := HIWORD(lParam)
   _HMG_MouseCol := LOWORD(lParam)

   i := Ascan ( _HMG_aFormhandles , hWnd )
   if i > 0

      if _hmg_aformvirtualheight [i] > 0
         _HMG_MouseRow := _HMG_MouseRow + GetScrollPos(hwnd,SB_VERT)
      endif

      if _hmg_aformvirtualwidth [i] > 0
         _HMG_MouseCol := _HMG_MouseCol + GetScrollPos(hwnd,SB_HORZ)
      endif

      if wParam == MK_LBUTTON
         _DoWindowEventProcedure ( _HMG_aFormMouseDragProcedure [i] , i )
      Else
         _DoWindowEventProcedure ( _HMG_aFormMouseMoveProcedure [i] , i )
      Endif

   endif
   exit
***********************************************************************
case WM_DROPFILES
***********************************************************************

   i := Ascan ( _HMG_aFormhandles , hWnd )
   if i > 0
      SetForegroundWindow( hWnd )

      Eval( _HMG_aFormDropProcedure [i], DragQueryFiles( wParam ) )

      DragFinish( wParam )
   endif
   exit
***********************************************************************
case WM_CONTEXTMENU
***********************************************************************

   _ActiveMenu := .F.
   i := Ascan ( _HMG_aControlsContextMenu ,{ |x| x[1] == wParam } )

   If i > 0 .And. _HMG_aControlsContextMenu [i, 4] == .t.

      _HMG_MouseRow := HIWORD(lParam)
      _HMG_MouseCol := LOWORD(lParam)

      setfocus(wParam)

      _HMG_xControlsContextMenuID := _HMG_aControlsContextMenu [i, 3]
      TrackPopupMenu ( _HMG_aControlsContextMenu [i, 2] , LOWORD(lparam) , HIWORD(lparam) , hWnd )

   ElseIf _HMG_ShowContextMenus == .t.

      _HMG_MouseRow := HIWORD(lParam)
      _HMG_MouseCol := LOWORD(lParam)

      setfocus(wParam)

      i := Ascan ( _HMG_aFormhandles , hWnd )
      if i > 0
         if _HMG_aFormContextMenuHandle [i] != 0
            if _hmg_aformvirtualheight [i] > 0
               _HMG_MouseRow := _HMG_MouseRow + GetScrollPos(hwnd, SB_VERT)
            endif
            if _hmg_aformvirtualwidth [i] > 0
               _HMG_MouseCol := _HMG_MouseCol + GetScrollPos(hwnd, SB_HORZ)
            endif
            TrackPopupMenu ( _HMG_aFormContextMenuHandle [i] , LOWORD(lparam) , HIWORD(lparam) , hWnd )
         Endif
      EndIf

   EndIf
   exit
***********************************************************************
case WM_TIMER
***********************************************************************

   i := Ascan ( _HMG_aControlIds , wParam )

   if i > 0
      _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
   EndIf
   exit
***********************************************************************
case WM_MOVE
***********************************************************************

   _ActiveMenu := .F.
   _HMG_MouseRow := HIWORD(lParam)
   _HMG_MouseCol := LOWORD(lParam)

   i := Ascan ( _HMG_aFormhandles , hWnd )

   if i > 0
      If _HMG_MainActive == .T.
         _DoWindowEventProcedure ( _HMG_aFormMoveProcedure [i] , i )
      EndIf
   EndIf
   exit
***********************************************************************
case WM_SIZE
***********************************************************************

   _ActiveMenu := .F.
   ControlCount := Len (_HMG_aControlHandles)

   i := aScan ( _HMG_aFormHandles , hWnd )

   if i > 0

      hws := 0
      If _HMG_aFormReBarHandle [i] > 0
         SizeRebar ( _HMG_aFormReBarHandle [i] )
         hws := RebarHeight ( _HMG_aFormReBarHandle [i] )
         RedrawWindow ( _HMG_aFormReBarHandle [i] )
      EndIf

      For x = 1 to ControlCount
         If _HMG_aControlParentHandles [x] == hWnd
            if _HMG_aControlType [x] == "MESSAGEBAR"
               MoveWindow( _HMG_aControlHandles [x] , 0 , 0 , 0 , 0 , .T. )
               RefreshItemBar ( _HMG_aControlHandles [x] , _GetStatusItemWidth( hWnd, 1 ) )
               Exit
            endif
         EndIf
      Next x

      If _HMG_MainClientMDIHandle != 0

         If wParam != SIZE_MINIMIZED

            SizeClientWindow( hWnd, _HMG_ActiveStatusHandle, _HMG_MainClientMDIHandle, hws )

         Endif

      Endif

      If _HMG_MainActive == .T.

         If wParam == SIZE_MAXIMIZED

            _DoWindowEventProcedure ( _HMG_aFormMaximizeProcedure [i], i )

            if _HMG_AutoAdjust .and. _HMG_MainClientMDIHandle == 0
               _Autoadjust( hWnd )
            endif

         ElseIf wParam == SIZE_MINIMIZED

            _DoWindowEventProcedure ( _HMG_aFormMinimizeProcedure [i], i )

         ElseIf wParam == SIZE_RESTORED .AND. !IsWindowSized( hWnd )

            _DoWindowEventProcedure ( _HMG_aFormRestoreProcedure [i], i )

         Else

            _DoWindowEventProcedure ( _HMG_aFormSizeProcedure [i], i )

            if _HMG_AutoAdjust .and. _HMG_MainClientMDIHandle == 0
               _Autoadjust( hWnd )
            endif

            If Empty( _HMG_ActiveSplitChildIndex ) .And. _HMG_SplitLastControl <> 'TOOLBAR' .And.;
               Empty( Len ( _HMG_aFormGraphTasks [i] ) )   // GF 09/16/2008

               InvalidateRect( hWnd, 1 )

            EndIf

         EndIf

      EndIf

   EndIf

   For i = 1 to ControlCount
      if _HMG_aControlParentHandles [i] == hWnd
         if _HMG_aControlType [i] == "TOOLBAR"
            SendMessage( _HMG_aControlHandles [i], TB_AUTOSIZE, 0, 0 )
         EndIf
      EndIf
   Next i

   If _HMG_MainClientMDIHandle != 0
      return (1)
   Else
      exit
   EndIf
***********************************************************************
case WM_COMMAND
***********************************************************************

   _ActiveMenu := .F.
   ControlCount := Len (_HMG_aControlHandles)

      *...............................................
      * Search Control From Received Id LoWord(wParam)
      *...............................................

   i := Ascan ( _HMG_aControlIds , LoWord(wParam) )

   If i > 0

         * Process Menus .......................................

      IF HiWord(wParam) == 0 .And. _HMG_aControlType [i] = "MENU"
         _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         Return 0
      EndIf

         * Process ToolBar Buttons ............................

      If _HMG_aControlType [i] = "TOOLBUTTON"
         _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         Return 0
      EndIf

   EndIf

      *..............................................
      * Search Control From Received Handle (lparam)
      *..............................................

#ifdef _TSBROWSE_

   IF Type('_TSB_aControlhWnd') == 'A' .and. Len(_TSB_aControlhWnd) > 0
      oGet := GetObjectByHandle(lParam)
      IF ValType(oGet) == 'O'
         r := oGet:HandleEvent ( nMsg, wParam, lParam )
         if ValType(r) == 'N'
            IF r != 0
               RETURN r
            ENDIF
         endif
      ENDIF
   ENDIF
#endif

   i := Ascan ( _HMG_aControlhandles , lParam )

      * If Handle Not Found, Look For Spinner

   if i == 0
      For x := 1 To ControlCount
         If ValType (_HMG_aControlHandles[x]) == 'A'
            If _HMG_aControlHandles [x] [1] == lParam .and. _HMG_aControlType[x] == 'SPINNER'
               i := x
               Exit
            EndIf
         EndIf
      Next x
   EndIf

      *................................
      * Process Command (Handle based)
      *................................

   if ( i > 0 )

         * Button Click ........................................

      If HIWORD(wParam) == BN_CLICKED .And. _HMG_aControlType [i] $ "OBUTTON"
         _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         Return 0
      EndIf

         * BtnText Click .......................................

      If HIWORD(wParam) == BN_CLICKED .And. ( _HMG_aControlType [i] = "BTNTEXT" .Or. _HMG_aControlType [i] = "BTNNUMTEXT" )
         If LoWord(wParam) == 0
            _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         ElseIf LoWord(wParam) == 1
            _DoControlEventProcedure ( _HMG_aControlHeadClick [i] , i )
         EndIf
         Return 0
      EndIf

         * GetBox Click .......................................

      If HIWORD(wParam) == BN_CLICKED .And. _HMG_aControlType [i] = "GETBOX"
         If LoWord(wParam) == 0
            _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         ElseIf LoWord(wParam) == 1
            _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
         EndIf
         Return 0
      EndIf

         * CheckBox Click ......................................

      If HIWORD(wParam) == BN_CLICKED .And. _HMG_aControlType [i] = "CHECKBOX"
         _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
         Return 0
      EndIf

         * Label / HyperLink / Image Click .....................

      If HiWord ( wParam ) == STN_CLICKED .And. ( _HMG_aControlType [i] = "LABEL" .Or. _HMG_aControlType [i] = "HYPERLINK" .Or. _HMG_aControlType [i] = "IMAGE" )
         _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         Return 0
      EndIf

         * Process Richedit Area Change ........................

      If HIWORD(wParam) == EN_VSCROLL .And. ( _HMG_aControlType [i] = "RICHEDIT" )
         _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         Return 0
      EndIf

         * TextBox and GetBox Change ...........................

      if HiWord ( wParam ) == EN_CHANGE

         If _HMG_DateTextBoxActive == .T.
            _HMG_DateTextBoxActive := .F.
         Else

            if Len (_HMG_aControlInputMask [i] ) > 0

               If _HMG_aControlType [i] == 'GETBOX'

                  if GetFocus(i) ==  _HMG_aControlHandles [i]
                     oGet :=_HMG_aControlHeadClick  [i]
                     if oGet:Changed
                        _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
                     endif
                  endif

               elseif _HMG_aControlType [i] == 'MASKEDTEXT'

                  If _HMG_aControlSpacing [i] == .T.
                     ProcessCharmask ( i, .t. )
                  EndIf

                  _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )

               ElseIf _HMG_aControlType [i] == 'CHARMASKTEXT'

                  ProcessCharMask ( i )

                  _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )

               EndIf

            else

               If 'NUMTEXT' $ _HMG_aControlType[i]
                  ProcessNumText ( i )
               EndIf

               If _HMG_aControlType [i] <> 'GETBOX'
                  _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
               endif

            endif

         EndIf

         Return 0

      EndIf

         * TextBox LostFocus ...................................

      If  HiWord(wParam) == EN_KILLFOCUS

         If _HMG_aControlType [i] == 'MASKEDTEXT'

            _HMG_aControlSpacing [i] := .F.

            IF "E" $ _HMG_aControlPageMap [i]

               Ts := GetWindowText ( _HMG_aControlHandles[i] )

               If "." $ _HMG_aControlPageMap [i]
                  Do Case
                  Case At ( '.' , Ts ) >  At ( ',' , Ts )
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromText ( GetWindowText ( _HMG_aControlHandles[i] ) , i ) , _HMG_aControlPageMap[i] ) )
                  Case At ( ',' , Ts ) > At ( '.' , Ts )
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromTextSp ( GetWindowText ( _HMG_aControlHandles[i] ) , i ) , _HMG_aControlPageMap[i] ) )
                  EndCase
               Else
                  Do Case
                  Case At ( '.' , Ts ) !=  0
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromTextSp ( GetWindowText ( _HMG_aControlHandles[i] ) , i ) , _HMG_aControlPageMap[i] ) )
                  Case At ( ',' , Ts )  != 0
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromText ( GetWindowText ( _HMG_aControlHandles[i] ) , i ) , _HMG_aControlPageMap[i] ) )
                  OtherWise
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromText ( GetWindowText ( _HMG_aControlHandles[i] ) , i ) , _HMG_aControlPageMap[i] ) )
                  EndCase
               EndIf

            ELSE

               SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromText ( GetWindowText ( _HMG_aControlhandles [i] ) , i ) , _HMG_aControlPageMap[i] ) )

            ENDIF

         Endif

         If _HMG_aControlType [i] == 'CHARMASKTEXT'
            If valtype ( _HMG_aControlHeadCLick [i] ) == 'L'
               If _HMG_aControlHeadCLick [i] == .T.
                  _HMG_DateTextBoxActive := .T.
                  SetWindowText ( _HMG_aControlHandles[i] , dtoc ( ctod ( GetWindowText ( _HMG_aControlhandles [i] ) ) ) )
               EndIf
            EndIf
         EndIf

         If _HMG_InteractiveCloseStarted != .T.
            _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i], i )
         EndIf

         Return 0

      EndIf

         * TextBox GotFocus ....................................

      If  HIWORD(wParam) == EN_SETFOCUS

         VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] , _HMG_aControlParentHandles [i] )

         If _HMG_aControlType [i] == 'MASKEDTEXT'

            IF "E" $ _HMG_aControlPageMap [i]

               Ts := GetWindowText ( _HMG_aControlHandles[i] )

               If "." $ _HMG_aControlPageMap [i]
                  Do Case
                  Case At ( '.' , Ts ) >  At ( ',' , Ts )
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromText ( GetWindowText ( _HMG_aControlhandles [i] ) , i ) , _HMG_aControlInputMask [i] ) )
                  Case At ( ',' , Ts ) > At ( '.' , Ts )
                     TmpStr := Transform ( GetNumFromTextSP ( GetWindowText ( _HMG_aControlhandles [i] ) , i )  , _HMG_aControlInputMask [i] )
                     If Val ( TmpStr ) == 0
                        TmpStr := StrTran ( TmpStr , '0.' , ' .' )
                     EndIf
                     SetWindowText ( _HMG_aControlhandles [i] , TmpStr )
                  EndCase
               Else
                  Do Case
                  Case At ( '.' , Ts ) !=  0
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromTextSP ( GetWindowText ( _HMG_aControlhandles [i] ) , i ) , _HMG_aControlInputMask [i] ) )
                  Case At ( ',' , Ts )  != 0
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromText ( GetWindowText ( _HMG_aControlhandles [i] ) , i ) , _HMG_aControlInputMask [i] ) )
                  OtherWise
                     SetWindowText ( _HMG_aControlhandles [i] , Transform ( GetNumFromText ( GetWindowText ( _HMG_aControlhandles [i] ) , i ) , _HMG_aControlInputMask [i] ) )
                  EndCase
               EndIf

            ELSE

               TmpStr := Transform ( GetNumFromText ( GetWindowText ( _HMG_aControlhandles [i] ) , i ) , _HMG_aControlInputMask [i] )

               If Val ( TmpStr ) == 0
                  TmpStr := StrTran ( TmpStr , '0.' , ' .' )
               EndIf

               SetWindowText ( _HMG_aControlhandles [i] , TmpStr )

            ENDIF

            SendMessage( _HMG_aControlhandles [i] , EM_SETSEL , 0 , -1 )

            _HMG_aControlSpacing [i] := .T.

         EndIf

         If _HMG_aControlType [i] == 'CHARMASKTEXT'

            MaskStart := 1

            For x := 1 To Len (_HMG_aControlInputMask [i])
               z := SubStr ( _HMG_aControlInputMask [i] , x , 1 )
               If IsDigit( z ) .Or. IsAlpha( z ) .Or. z == '!'
                  MaskStart := x
                  Exit
               EndIf
            Next x

            SendMessage( _HMG_aControlhandles [i] , EM_SETSEL , MaskStart - 1 , -1 )

         EndIf

         _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )

         Return 0

      EndIf

         * ListBox Processing ..................................

      If _HMG_aControlType[i] == 'LIST' .Or. _HMG_aControlType[i] == 'MULTILIST'

            * ListBox OnChange ....................................

         If  HIWORD(wParam) == LBN_SELCHANGE
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
            Return 0
         EndIf

            * ListBox LostFocus ...................................

         If HIWORD(wParam) == LBN_KILLFOCUS
            _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
            Return 0
         EndIf

            * ListBox GotFocus ....................................

         If HIWORD(wParam) == LBN_SETFOCUS
            VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] , _HMG_aControlParentHandles [i] )
            _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
            Return 0
         EndIf

            * ListBox Double Click ................................

         If  HIWORD(wParam) == LBN_DBLCLK
            _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
            Return 0
         EndIf

      EndIf

         * ComboBox Processing .................................

      If _HMG_aControlType[i] == 'COMBO'

            * ComboBox Change .....................................

         If  HIWORD(wParam) == CBN_SELCHANGE
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
            Return 0
         EndIf

            * ComboBox DropDownList visible .......................

         If  HIWORD(wParam) == CBN_DROPDOWN
            _DoControlEventProcedure ( _HMG_aControlInputMask [i] , i )
            Return 0
         EndIf

            * ComboBox DropDownList closed ........................

         If  HIWORD(wParam) == CBN_CLOSEUP
            _DoControlEventProcedure ( _HMG_aControlPicture [i] , i )
            Return 0
         EndIf

            * ComboBox LostFocus ..................................

         If HIWORD(wParam) == CBN_KILLFOCUS
            _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
            Return 0
         EndIf

            * ComboBox GotFocus ...................................

         If HIWORD(wParam) == CBN_SETFOCUS
            VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] , _HMG_aControlParentHandles [i] )
            _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
            Return 0
         EndIf

            * Process Combo Display Area Change ...................

         If HIWORD(wParam) == CBN_EDITCHANGE
            _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
            Return 0
         EndIf

      EndIf

         * Button LostFocus ....................................

      If HIWORD(wParam) == BN_KILLFOCUS .And. _HMG_aControlType[i] != 'COMBO'
         _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
         Return 0
      EndIf

         * Button GotFocus .....................................

      If HIWORD(wParam) == BN_SETFOCUS
         VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] , _HMG_aControlParentHandles [i] )
         _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
         Return 0
      EndIf

   Else

        * Process RadioGrop ...................................

      If HIWORD(wParam) == BN_CLICKED

         For i := 1 to ControlCount
            if ValType (_HMG_aControlHandles [i] ) == "A" .And. _HMG_aControlParentHandles [i] == hWnd
               For x := 1 To Len ( _HMG_aControlHandles [i] )
                  If _HMG_aControlHandles [i] [x] == lParam
                     _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
                     If _HMG_aControlPicture [i] == .F. // No TabStop
                        if IsTabStop(_HMG_aControlHandles [i] [x])
                           SetTabStop(_HMG_aControlHandles [i] [x], .f.)
                        endif
                     EndIf
                     Return 0
                  EndIf
               Next x
            Endif
         Next i

      ElseIf HIWORD(wParam) == BN_SETFOCUS

         For i := 1 to ControlCount
            if ValType (_HMG_aControlHandles [i] ) == "A" .And. _HMG_aControlParentHandles [i] == hWnd
               For x := 1 To Len ( _HMG_aControlHandles [i] )
                  If _HMG_aControlHandles [i] [x] == lParam
                     VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] [x] , _HMG_aControlParentHandles [i] )
                     If _HMG_aControlPicture [i] == .F. // No TabStop
                        if IsTabStop(_HMG_aControlHandles [i] [x])
                           SetTabStop(_HMG_aControlHandles [i] [x], .f.)
                        endif
                     EndIf
                     Return 0
                  EndIf
               Next x
            Endif
         Next i

      EndIf

   EndIf

      *...................
      * Process Enter Key
      *...................

#ifdef _TSBROWSE_

   IF Type('_TSB_aControlhWnd') == 'A' .and. Len(_TSB_aControlhWnd) > 0
      oGet := GetObjectByHandle(GetFocus())
      IF ValType(oGet) == 'O'
         r := oGet:HandleEvent ( nMsg, wParam, lParam )
         if ValType(r) == 'N'
            IF r != 0
               RETURN r
            ENDIF
         endif
      ENDIF
   ENDIF
#endif

   i := Ascan ( _HMG_aControlhandles , GetFocus() )

   if  i > 0

         * CheckBox or CheckButton Enter ......................................

      if _HMG_aControlType [i] = "CHECKBOX" .And. HiWord(wParam) == 0 .And. LoWord(wParam) == 1
         If _HMG_ExtendedNavigation == .T.
            _SetNextFocus()
         EndIf
         Return 0
      EndIf

         * ButtonEx Enter ......................................

      if _HMG_aControlType [i] = "OBUTTON" .And. HiWord(wParam) == 0 .And. LoWord(wParam) == 1
         _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         Return 0
      EndIf

         * DatePicker or TimePicker Enter ......................

      if (_HMG_aControlType [i] == "DATEPICK" .or. _HMG_aControlType [i] == "TIMEPICK") .and. ( HiWord(wParam) == 0 .And. LoWord(wParam) == 1 )
         _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
         If _HMG_ExtendedNavigation == .T.
            _SetNextFocus()
         EndIf
         Return 0
      EndIf

         * Browse Escape .......................................

      if _HMG_aControlType [i] = "BROWSE" .and. lparam == 0 .and. wparam == 2
         Return 1
      EndIf

         * Browse Enter ........................................

      if _HMG_aControlType [i] = "BROWSE" .and. lparam == 0 .and. wparam == 1

         if _hmg_acontrolmiscdata1 [i] [6] == .T.
            if _HMG_aControlFontColor [i] == .T.
               ProcessInPlaceKbdEdit(i)
            Else
               _BrowseEdit ( _hmg_acontrolhandles[i] , _HMG_acontrolmiscdata1 [i] [4] , _HMG_acontrolmiscdata1 [i] [5] , _HMG_acontrolmiscdata1 [i] [3] , _HMG_aControlInputMask [i] , .f. , _HMG_aControlFontColor [i] )
            EndIf
         Else
            _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
         Endif
         Return 1 // JP12
      EndIf

         * Grid Enter ..........................................

      if ( _HMG_aControlType [i] = "GRID" .or. _HMG_aControlType [i] = "MULTIGRID") .and. lparam == 0 .and. wparam == 1
         if _hmg_acontrolspacing [i] == .T.
            if __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_INPLACE' ) == .T.
               _GridInplaceKBDEdit ( i )
            Else
               _EditItem ( _hmg_acontrolhandles [i] )
            EndIf
         Else
            _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
         EndIf
         Return 0
      EndIf

         * ComboBox Enter ......................................

      if _HMG_aControlType [i] = "COMBO" .and. ( HiWord(wParam) == 0  .And. LoWord(wParam) == 1 )
         _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
         If _HMG_ExtendedNavigation == .T.
            _SetNextFocus()
         EndIf
         Return 0
      EndIf

         * ListBox Enter .......................................

      if ( _HMG_aControlType [i] = "LIST" .or. _HMG_aControlType [i] = "MULTILIST") .And. ( HiWord(wParam) == 0  .And. LoWord(wParam) == 1 )
         _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
         Return 0
      EndIf

         * TextBox Enter .......................................

      if ( _HMG_aControlType [i] == "TEXT" .Or. _HMG_aControlType [i] == "MASKEDTEXT" .Or. _HMG_aControlType [i] == "CHARMASKTEXT" .Or.;
         _HMG_aControlType [i] == "NUMTEXT" .Or. _HMG_aControlType [i] = "BTNTEXT" .Or. _HMG_aControlType [i] = "BTNNUMTEXT" ) .And. HiWord(wParam) == 0  .And. LoWord(wParam) == 1
         _HMG_SetFocusExecuted := .F.
         _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
         If _HMG_SetFocusExecuted == .F.
            If _HMG_ExtendedNavigation == .T.
               _SetNextFocus()
            EndIf
         Else
            _HMG_SetFocusExecuted := .F.
         EndIf
         Return 0
      EndIf

         * Tree Enter ..........................................

      if _HMG_aControlType [i] == "TREE" .And. HiWord(wParam) == 0 .And. LoWord(wParam) == 1
         _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
         Return 0
      EndIf

   Else

         * ComboBox (DisplayEdit) ..............................

      For i := 1 To ControlCount
         if _HMG_aControlType [i] == "COMBO" .And. HiWord(wParam) == 0 .And. LoWord(wParam) == 1
            if _hmg_acontrolrangemin [i] == GetFocus() .or. _hmg_acontrolrangemax [i] == GetFocus()
               _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
               If _HMG_ExtendedNavigation == .T.
                  _SetNextFocus()
               EndIf
               Exit
            EndIf
         EndIf
      Next i

   EndIf
   exit
***********************************************************************
case WM_NOTIFY
***********************************************************************

      * Process ToolBar ToolTip .....................................

   If GetNotifyCode ( lParam ) == TTN_NEEDTEXT   // for tooltip TOOLBUTTON
      x := Ascan ( _HMG_aControlIds , GetNotifyId( lParam ) )
      if x > 0 .And. _HMG_aControlType [x] == "TOOLBUTTON"
         SetButtonTip ( lParam , _HMG_aControlToolTip [x] )
      endif
   endif

   If GetNotifyCode ( lParam ) == RBN_CHEVRONPUSHED    // Notify for chevron button
      _CreatePopUpChevron ( hWnd, wParam, lParam )
   endif

#ifdef _TSBROWSE_

      * Process TSBrowse .....................................

   IF Type('_TSB_aControlhWnd') == 'A' .and. Len(_TSB_aControlhWnd) > 0
      oGet := GetObjectByHandle( GetHwndFrom (lParam) )
      IF ValType(oGet) == 'O'
         r := oGet:HandleEvent ( nMsg, wParam, lParam )
         if ValType(r) == 'N'
            IF r != 0
               RETURN r
            ENDIF
         endif
      ENDIF
   ENDIF
#endif

   i := Ascan ( _HMG_aControlHandles , GetHwndFrom (lParam) )

   if i > 0

         * Process Browse .....................................

      if _HMG_aControlType [i] = "BROWSE"

             * Browse Refresh On Column Size ..............

         If   GetNotifyCode ( lParam ) == NM_CUSTOMDRAW

            hws := 0
            hwm := .F.
            For x := 1 To Len ( _HMG_aControlProcedures [i] )
               hws := hws + ListView_GetColumnWidth ( _HMG_aControlHandles [i] , x - 1 )
               If _HMG_aControlProcedures [i] [x] != ListView_GetColumnWidth ( _HMG_aControlHandles [i] , x - 1 )
                  hwm := .T.
                  _HMG_aControlProcedures [i] [x] := ListView_GetColumnWidth ( _HMG_aControlHandles [i] , x - 1 )
                  _BrowseRefresh( '', '', i )
               EndIf
            Next x

               * Browse ReDraw Vertical ScrollBar If Needed ...

            If _HMG_aControlIds [i] != 0 .and. hwm == .T.
               if hws > _HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() - 4
                  MoveWindow ( _HMG_aControlIds [i] , _HMG_aControlCol[i]+_HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() , _HMG_aControlRow[i] , GETVSCROLLBARWIDTH() ,;
                     _HMG_aControlHeight[i] - GETHSCROLLBARHEIGHT() , .t. )
                  MoveWindow ( _HMG_aControlMiscData1 [i] [1], _HMG_aControlCol[i]+_HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() , _HMG_aControlRow[i] + _HMG_aControlHeight[i] - GETHSCROLLBARHEIGHT() ,;
                     GETVSCROLLBARWIDTH() , GETHSCROLLBARHEIGHT() , .t. )
               Else
                  MoveWindow ( _HMG_aControlIds [i] , _HMG_aControlCol[i]+_HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() , _HMG_aControlRow[i] , GETVSCROLLBARWIDTH() , _HMG_aControlHeight[i] , .t. )
                  MoveWindow ( _HMG_aControlMiscData1 [i] [1], _HMG_aControlCol[i]+_HMG_aControlWidth[i] - GETVSCROLLBARWIDTH() , _HMG_aControlRow[i] + _HMG_aControlHeight[i] - GETHSCROLLBARHEIGHT() , 0 , 0 , .t. )
               EndIf
            EndIf

         EndIf

         dBc :=   __MVGET( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICBACKCOLOR' )
         dFc :=   __MVGET( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICFORECOLOR' )

         If GetNotifyCode ( lParam ) = NM_CUSTOMDRAW .and. ( valtype (dBc) == 'A' .or. valtype (dFc) == 'A' )
            if ( r := GetDs ( lParam ) ) <> -1
               Return r
            else
               a := GetRc (lParam)

               if a[1] >= 1 .and. a[1] <= Len ( _HMG_aControlRangeMax [i] ) .and. ;  // MaxBrowseRows
                  a[2] >= 1 .and. a[2] <= Len ( _HMG_aControlRangeMin [i] )      // MaxBrowseCols
                  aTemp := __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DBC' )
                  aTemp2 := __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DFC' )
                  if valtype ( aTemp ) == 'A' .and. valtype ( aTemp2 ) <> 'A'
                     if len ( aTemp ) >= a[1]
                        if aTemp [a[1]] [a[2]] <> -1
                           Return SetBcBc ( lParam , aTemp [a[1]] [a[2]] , RGB(0, 0, 0) )
                        else
                           Return SETBRCCD(lParam)
                        endif
                     endif
                  elseif valtype ( aTemp ) <> 'A' .and. valtype ( aTemp2 ) == 'A'
                     if len ( aTemp2 ) >= a[1]
                        if aTemp2 [a[1]] [a[2]] <> -1
                           Return SetBcBc ( lParam , RGB(255, 255, 255) , aTemp2 [a[1]] [a[2]] )
                        else
                           Return SETBRCCD(lParam)
                        endif
                     endif
                  elseif valtype ( aTemp ) == 'A' .and. valtype ( aTemp2 ) == 'A'
                     if len ( aTemp ) >= a[1] .and. len ( aTemp2 ) >= a[1]
                        if aTemp [a[1]] [a[2]] <> -1
                           Return SetBcBc ( lParam , aTemp [a[1]] [a[2]] , aTemp2 [a[1]] [a[2]] )
                        else
                           Return SETBRCCD(lParam)
                        endif
                     endif
                  endif
               else
                  Return SETBRCCD(lParam)
               endif

            endif

         EndIf

            * Browse Click ................................

         If GetNotifyCode ( lParam ) == NM_CLICK .or. GetNotifyCode ( lParam ) == LVN_BEGINDRAG .or.;
            GetNotifyCode ( lParam ) == NM_RCLICK

            If LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) > 0
               DeltaSelect := LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) - ascan ( _HMG_aControlRangeMax [i] , _HMG_aControlValue [i] )
               _HMG_aControlValue [i] :=  _HMG_aControlRangeMax [i] [ LISTVIEW_GETFIRSTITEM ( _HMG_aControlHandles [i] ) ]
               _BrowseVscrollFastUpdate ( i , DeltaSelect )
               _BrowseOnChange (i)
            EndIf

            Return 0

         EndIf

            * Browse Key Handling .........................

         If GetNotifyCode ( lParam ) = LVN_KEYDOWN

            Do Case

            Case GetGridvKey(lParam) == 65 // A

               if   GetAltState() == -127;
                  .or.;
                  GetAltState() == -128   // ALT

                  if _HMG_acontrolmiscdata1 [i] [2] == .T.
                     _BrowseEdit ( _hmg_acontrolhandles[i] , _HMG_acontrolmiscdata1 [i] [4] , _HMG_acontrolmiscdata1 [i] [5] , _HMG_acontrolmiscdata1 [i] [3] , _HMG_aControlInputMask [i] , .t. ,;
                        _HMG_aControlFontColor [i] , _HMG_acontrolmiscdata1 [i] [13] )
                  EndIf

               EndIf

            Case GetGridvKey(lParam) == 46 // DEL

               If _HMG_aControlMiscData1 [i] [12] == .t.
                  If MsgYesNo (_HMG_BRWLangMessage [1] , _HMG_BRWLangMessage [2] ) == .t.
                     _BrowseDelete('','',i)
                  EndIf
               EndIf

            Case GetGridvKey(lParam) == 36 // HOME

               _BrowseHome('','',i)
               Return 1

            Case GetGridvKey(lParam) == 35 // END

               _BrowseEnd('','',i)
               Return 1

            Case GetGridvKey(lParam) == 33 // PGUP

               _BrowsePrior('','',i)
               Return 1

            Case GetGridvKey(lParam) == 34 // PGDN

               _BrowseNext('','',i)
               Return 1

            Case GetGridvKey(lParam) == 38 // UP

               _BrowseUp('','',i)
               Return 1

            Case GetGridvKey(lParam) == 40 // DOWN

               _BrowseDown('','',i)
               Return 1

            EndCase

            Return 0

         EndIf

            * Browse Double Click .........................

         If GetNotifyCode ( lParam ) == NM_DBLCLK

            _PushEventInfo()
            _HMG_ThisFormIndex := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles[i] )
            _HMG_ThisType := 'C'
            _HMG_ThisIndex := i
            _HMG_ThisFormName :=  _HMG_aFormNames [ _HMG_ThisFormIndex ]
            _HMG_ThisControlName := _HMG_aControlNames [_HMG_THISIndex ]
            r := ListView_HitTest ( _HMG_aControlHandles [i] , GetCursorRow() - GetWindowRow ( _HMG_aControlHandles [i] ) , GetCursorCol() - GetWindowCol ( _HMG_aControlHandles [i] ) )
            If r [2] == 1
               ListView_Scroll( _HMG_aControlHandles [i] , -10000 , 0 )
               r := ListView_HitTest ( _HMG_aControlHandles [i] , GetCursorRow() - GetWindowRow ( _HMG_aControlHandles [i] ) , GetCursorCol() - GetWindowCol ( _HMG_aControlHandles [i] ) )
            Else
               r := LISTVIEW_GETSUBITEMRECT ( _HMG_aControlHandles [i] , r[1] - 1 , r[2] - 1 )
                                                      *   CellCol            CellWidth
               xs := ( ( _HMG_aControlCol [i] + r [2] ) +( r[3] ))  -  ( _HMG_aControlCol [i] + _HMG_aControlWidth [i] )
               xd := 20
               If xs > -xd
                  ListView_Scroll( _HMG_aControlHandles [i] , xs + xd , 0 )
               Else
                  If r [2] < 0
                     ListView_Scroll( _HMG_aControlHandles [i] , r[2] , 0 )
                  EndIf
               EndIf
               r := ListView_HitTest ( _HMG_aControlHandles [i] , GetCursorRow() - GetWindowRow ( _HMG_aControlHandles [i] ) , GetCursorCol() - GetWindowCol ( _HMG_aControlHandles [i] ) )
            EndIf

            _HMG_ThisItemRowIndex := r[1]
            _HMG_ThisItemColIndex := r[2]
            If r [2] == 1
               r := LISTVIEW_GETITEMRECT ( _HMG_aControlHandles [i]  , r[1] - 1 )
            Else
               r := LISTVIEW_GETSUBITEMRECT ( _HMG_aControlHandles [i]  , r[1] - 1 , r[2] - 1 )
            EndIf
            _HMG_ThisItemCellRow := _HMG_aControlRow [i] + r [1]
            _HMG_ThisItemCellCol := _HMG_aControlCol [i] + r [2]
            _HMG_ThisItemCellWidth := r[3]
            _HMG_ThisItemCellHeight := r[4]

            if _hmg_acontrolmiscdata1 [i] [6] == .T.
               _BrowseEdit ( _hmg_acontrolhandles[i] , _HMG_acontrolmiscdata1 [i] [4] , _HMG_acontrolmiscdata1 [i] [5] , _HMG_acontrolmiscdata1 [i] [3] , _HMG_aControlInputMask [i] , .f. ,;
                  _HMG_aControlFontColor [i] , _HMG_acontrolmiscdata1 [i] [13] )
            Else
               if valtype( _HMG_aControlDblClick [i] ) == 'B'
                  Eval( _HMG_aControlDblClick [i]  )
               EndIf
            Endif

            _PopEventInfo()
            _HMG_ThisItemRowIndex := 0
            _HMG_ThisItemColIndex := 0
            _HMG_ThisItemCellRow := 0
            _HMG_ThisItemCellCol := 0
            _HMG_ThisItemCellWidth := 0
            _HMG_ThisItemCellHeight := 0

         EndIf

            * Browse LostFocus ............................

         If GetNotifyCode ( lParam ) = NM_KILLFOCUS
            _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
            Return 0
         EndIf

            * Browse GotFocus ..............................

         If GetNotifyCode ( lParam ) = NM_SETFOCUS
            VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] , _HMG_aControlParentHandles [i] )
            _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
            Return 0
         EndIf

            * Browse Header Click .........................

         If GetNotifyCode ( lParam ) =  LVN_COLUMNCLICK
            if ValType ( _HMG_aControlHeadClick [i] ) == 'A'
               lvc := GetGridColumn(lParam) + 1
               if len (_HMG_aControlHeadClick [i]) >= lvc
                  _DoControlEventProcedure ( _HMG_aControlHeadClick [i] [lvc] , i , , lvc )
               EndIf
            EndIf
            Return 0
         EndIf

      EndIf

         * ToolBar DropDown Button Click .......................

      If GetNotifyCode ( lParam ) == TBN_DROPDOWN

         DefWindowProc( hWnd, TBN_DROPDOWN, wParam, lParam )
         x  := Ascan ( _HMG_aControlIds , GetButtonPos( lParam ) )
         k  := _HMG_aControlValue [x]
         if ( x > 0 ) .And. _HMG_aControlType [x] = "TOOLBUTTON"
            aPos := {0,0,0,0}
            GetWindowRect( _HMG_aControlHandles [i], aPos )
            hws := GetButtonBarRect( _HMG_aControlHandles [i], k-1 )
            TrackPopupMenu ( _HMG_aControlRangeMax [x] , aPos[1]+LoWord(hws) ,aPos[2]+HiWord(hws)+(aPos[4]-aPos[2]-HiWord(hws))/2 , hWnd )
         EndIf

         Return 0

      EndIf

         * RichEdit Selection Change ......................

      if _HMG_aControlType [i] = "RICHEDIT"

         If GetNotifyCode ( lParam ) = EN_MSGFILTER   // for typing text
            if valtype(_HMG_aControlChangeProcedure [i] ) == 'B'
               _HMG_ThisType := 'C'
               _HMG_ThisIndex := i
               Eval( _HMG_aControlChangeProcedure [i] )
               _HMG_ThisIndex := 0
               _HMG_ThisType := ''
            Endif
         EndIf
         If GetNotifyCode ( lParam ) = EN_DRAGDROPDONE  //For change text by drag
            if valtype( _HMG_aControlChangeProcedure [i] ) == 'B'
               _HMG_ThisType := 'C'
               _HMG_ThisIndex := i
               Eval( _HMG_aControlChangeProcedure [i] )
               _HMG_ThisIndex := 0
               _HMG_ThisType := ''
            EndIf
         EndIf
         If GetNotifyCode ( lParam ) = EN_SELCHANGE  //For change text
            if valtype(_HMG_aControlDblClick [i] ) == 'B'
               _HMG_ThisType := 'C'
               _HMG_ThisIndex := i
               Eval( _HMG_aControlDblClick [i] )
               _HMG_ThisIndex := 0
               _HMG_ThisType := ''
            EndIf
         EndIf
      Endif

         * MonthCalendar Selection Change ......................

      if _HMG_aControlType [i] = "MONTHCAL"
         If GetNotifyCode ( lParam ) = MCN_SELECT
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
            Return 0
         EndIf
      EndIf

         * Grid Processing .....................................

      if _HMG_aControlType [i] = "GRID" .Or. _HMG_aControlType [i] = "MULTIGRID"

         dBc :=   __MVGET( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICBACKCOLOR' )
         dFc :=   __MVGET( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DYNAMICFORECOLOR' )

         If GetNotifyCode ( lParam ) = NM_CUSTOMDRAW .and. ( valtype (dBc) == 'A' .or. valtype (dFc) == 'A' )
            if ( r := GetDs ( lParam ) ) <> -1
               Return r
            else
               a := GetRc (lParam)

               if a[1] >= 1 .and. a[1] <= ListViewGetItemCount( _HMG_aControlHandles [i] ) .and. ; // MaxGridRows
                  a[2] >= 1 .and. a[2] <= Len ( _HMG_aControlPageMap [i] )      // MaxGridCols
                  aTemp := __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DBC' )
                  aTemp2 := __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_DFC' )
                  if valtype ( aTemp ) == 'A' .and. valtype ( aTemp2 ) <> 'A'
                     if len ( aTemp ) >= a[1]
                        if aTemp [a[1]] [a[2]] <> -1
                           Return SetBcBc ( lParam , aTemp [a[1]] [a[2]] , RGB(0, 0, 0) )
                        else
                           Return SETBRCCD(lParam)
                        endif
                     endif
                  elseif valtype ( aTemp ) <> 'A' .and. valtype ( aTemp2 ) == 'A'
                     if len ( aTemp2 ) >= a[1]
                        if aTemp2 [a[1]] [a[2]] <> -1
                           Return SetBcBc ( lParam , RGB(255, 255, 255) , aTemp2 [a[1]] [a[2]] )
                        else
                           Return SETBRCCD(lParam)
                        endif
                     endif
                  elseif valtype ( aTemp ) == 'A' .and. valtype ( aTemp2 ) == 'A'
                     if len ( aTemp ) >= a[1] .and. len ( aTemp2 ) >= a[1]
                        if aTemp [a[1]] [a[2]] <> -1
                           Return SetBcBc ( lParam , aTemp [a[1]] [a[2]] , aTemp2 [a[1]] [a[2]] )
                        else
                           Return SETBRCCD(lParam)
                        endif
                     endif
                  endif
               else
                  Return SETBRCCD(lParam)
               endif

            endif

         EndIf

         If GetNotifyCode ( lParam ) = -181
            ReDrawWindow ( _hmg_acontrolhandles [i] )
         endif

            * Grid OnQueryData ............................

         If GetNotifyCode ( lParam ) = LVN_GETDISPINFO

            if valtype( _HMG_aControlProcedures [i] ) == 'B'

               _PushEventInfo()
               _HMG_ThisFormIndex := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles[i] )
               _HMG_ThisType := 'C'
               _HMG_ThisIndex := i
               _HMG_ThisFormName :=  _HMG_aFormNames [ _HMG_ThisFormIndex ]
               _HMG_ThisControlName :=  _HMG_aControlNames [_HMG_THISIndex]
               _ThisQueryTemp  := GETGRIDDISPINFOINDEX ( lParam )
               _HMG_ThisQueryRowIndex  := _ThisQueryTemp [1]
               _HMG_ThisQueryColIndex  := _ThisQueryTemp [2]
               Eval( _HMG_aControlProcedures [i]  )
               if Len ( _HMG_aControlBkColor [i] ) > 0 .And. _HMG_ThisQueryColIndex == 1
                  SetGridQueryImage ( lParam , _HMG_ThisQueryData )
               Else
                  SetGridQueryData ( lParam , _HMG_ThisQueryData )
               EndIf
               _HMG_ThisQueryRowIndex  := 0
               _HMG_ThisQueryColIndex  := 0
               _HMG_ThisQueryData := ""
               _PopEventInfo()

            EndIf

         EndIf

            * Grid LostFocus ..............................

         If GetNotifyCode ( lParam ) = NM_KILLFOCUS
            _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
            Return 0
         EndIf

            * Grid GotFocus ...............................

         If GetNotifyCode ( lParam ) = NM_SETFOCUS
            VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] , _HMG_aControlParentHandles [i] )
            _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
            Return 0
         EndIf

            * Grid Change .................................

         If GetNotifyCode ( lParam ) = LVN_ITEMCHANGED
            If GetGridOldState(lParam) == 0 .and. GetGridNewState(lParam) != 0
               _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
               Return 0
            EndIf
         EndIf

            * Grid Header Click ..........................

         If GetNotifyCode ( lParam ) =  LVN_COLUMNCLICK
            if ValType ( _HMG_aControlHeadClick [i] ) == 'A'
               lvc := GetGridColumn(lParam) + 1
               if len (_HMG_aControlHeadClick [i]) >= lvc
                  _DoControlEventProcedure ( _HMG_aControlHeadClick [i] [lvc] , i , , lvc )
                  Return 0
               EndIf
            EndIf
         EndIf

            * Grid Double Click ...........................

         If GetNotifyCode ( lParam ) == NM_DBLCLK

            if _hmg_acontrolspacing [i] == .T.
               if __MVGET ( '_HMG_' + ALLTRIM(STR(_HMG_aControlhandles[i])) + '_' + 'INPLACE' ) == .T.

                  _PushEventInfo()
                  _HMG_ThisFormIndex := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles[i] )
                  _HMG_ThisType := 'C'
                  _HMG_ThisIndex := i
                  _HMG_ThisFormName :=  _HMG_aFormNames [ _HMG_ThisFormIndex ]
                  _HMG_ThisControlName :=  _HMG_aControlNames [_HMG_ThisIndex]
                  aCellData := _GetGridCellData(i)

                  _HMG_ThisItemRowIndex := aCellData [1]
                  _HMG_ThisItemColIndex := aCellData [2]
                  _HMG_ThisItemCellRow := aCellData [3]
                  _HMG_ThisItemCellCol := aCellData [4]
                  _HMG_ThisItemCellWidth := aCellData [5]
                  _HMG_ThisItemCellHeight := aCellData [6]

                  _GridInplaceEdit(i)

                  _PopEventInfo()
                  _HMG_ThisItemRowIndex := 0
                  _HMG_ThisItemColIndex := 0
                  _HMG_ThisItemCellRow := 0
                  _HMG_ThisItemCellCol := 0
                  _HMG_ThisItemCellWidth := 0
                  _HMG_ThisItemCellHeight := 0

               Else
                  _EditItem ( _hmg_acontrolhandles [i] )
               EndIf
            Else

               if valtype(_HMG_aControlDblClick [i]  ) == 'B'

                  _PushEventInfo()
                  _HMG_ThisFormIndex := ascan ( _HMG_aFormHandles , _HMG_aControlParentHandles[i] )
                  _HMG_ThisType := 'C'
                  _HMG_ThisIndex := i
                  _HMG_ThisFormName :=  _HMG_aFormNames [ _HMG_ThisFormIndex ]
                  _HMG_ThisControlName :=  _HMG_aControlNames [_HMG_ThisIndex]
                  aCellData := _GetGridCellData(i)

                  _HMG_ThisItemRowIndex := aCellData [1]
                  _HMG_ThisItemColIndex := aCellData [2]
                  _HMG_ThisItemCellRow := aCellData [3]
                  _HMG_ThisItemCellCol := aCellData [4]
                  _HMG_ThisItemCellWidth := aCellData [5]
                  _HMG_ThisItemCellHeight := aCellData [6]

                  Eval( _HMG_aControlDblClick [i]  )

                  _PopEventInfo()
                  _HMG_ThisItemRowIndex := 0
                  _HMG_ThisItemColIndex := 0
                  _HMG_ThisItemCellRow := 0
                  _HMG_ThisItemCellCol := 0
                  _HMG_ThisItemCellWidth := 0
                  _HMG_ThisItemCellHeight := 0

               EndIf

            EndIf

            Return 0

         EndIf

      EndIf

         * DatePicker Process ..................................

      if _HMG_aControlType [i] = "DATEPICK" .or. _HMG_aControlType [i] = "TIMEPICK"

            * DatePicker Change ............................

         If GetNotifyCode ( lParam ) == DTN_DATETIMECHANGE .and. SendMessage( _HMG_aControlHandles [i] , DTM_GETMONTHCAL , 0 , 0 ) == 0 .or. GetNotifyCode ( lParam ) == DTN_CLOSEUP
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
            Return 0
         EndIf

            * DatePicker LostFocus ........................

         If GetNotifyCode ( lParam ) = NM_KILLFOCUS
            _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
            Return 0
         EndIf

            * DatePicker GotFocus .........................

         If GetNotifyCode ( lParam ) = NM_SETFOCUS
            VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] , _HMG_aControlParentHandles [i] )
            _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
            Return 0
         EndIf

      EndIf

         * Tab Processing ......................................

      if _HMG_aControlType [i] = "TAB"

            * Tab Change ..................................

         If GetNotifyCode ( lParam ) = TCN_SELCHANGE
            if Len (_HMG_aControlPageMap [i]) > 0
               UpdateTab (i)
            EndIf
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
            Return 0
         EndIf

      EndIf

         * Tree Processing .....................................

      if _HMG_aControlType [i] = "TREE"

            * Tree LostFocus .............................

         If GetNotifyCode ( lParam ) = NM_KILLFOCUS
            _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
            Return 0
         EndIf

            * Tree GotFocus ..............................

         If GetNotifyCode ( lParam ) = NM_SETFOCUS
            VirtualChildControlFocusProcess ( _HMG_aControlHandles [i] , _HMG_aControlParentHandles [i] )
            _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
            Return 0
         EndIf

            * Tree Change ................................

         If GetNotifyCode ( lParam ) = TVN_SELCHANGED
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
            Return 0
         EndIf

            * Tree Double Click .........................

         If GetNotifyCode ( lParam ) == NM_DBLCLK
            _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
            Return 0
         EndIf

      EndIf

#ifdef _PROPGRID_
         * PropGrid Processing .....................................

      if _HMG_aControlType [i] = "PROPGRID"

            * PropGrid LostFocus .............................

         If GetNotifyCode ( lParam ) = NM_KILLFOCUS
            _DoControlEventProcedure ( _HMG_aControlLostFocusProcedure [i] , i )
            Return 0
         EndIf

            * PropGrid GotFocus ..............................

         If GetNotifyCode ( lParam ) = NM_SETFOCUS
            _DoControlEventProcedure ( _HMG_aControlGotFocusProcedure [i] , i )
            Return 0
         EndIf


            * PropGrid Double Click .........................

         If GetNotifyCode ( lParam ) == NM_DBLCLK
            _DoControlEventProcedure ( _HMG_aControlDblClick [i] , i )
            Return 0
         EndIf

            * PropGrid Change ................................

         If GetNotifyCode ( lParam ) = TVN_SELCHANGED
            _DoControlEventProcedure ( _HMG_aControlChangeProcedure [i] , i , 'CONTROL_ONCHANGE' )
            Return 0
         EndIf

            * PropGrid CustomDraw ................................

         If GetNotifyCode ( lParam ) == NM_CUSTOMDRAW
            mVar := "PropGridOnCustomDraw"

            If Type ( mVar + '()' ) $ 'U,UE'
               MsgMiniGuiError("Function "+ mVar + "() is not defined. Program terminated" )
            Else
               Return ( &mVar ( GetHwndFrom (lParam) , lParam ) )
            Endif
         EndIf

         If GetNotifyCode ( lParam ) = -181
            ReDrawWindow ( _hmg_acontrolhandles [i] )
         EndIf

      EndIf
#endif
         * StatusBar Process ...................................

      if _HMG_aControlType [i] = "MESSAGEBAR"

            * StatusBar Click

         If GetNotifyCode ( lParam ) == NM_CLICK
            DefWindowProc( hWnd, NM_CLICK, wParam, lParam )
            x := GetItemPos( lParam ) + 1
            For i := 1 to Len ( _HMG_aControlHandles )
               if _HMG_aControlType [i] == "ITEMMESSAGE" .And. _HMG_aControlParentHandles [i] == hWnd
                  If _HMG_aControlHandles [i] == x
                     if _DoControlEventProcedure ( _HMG_aControlProcedures [i] , i )
                        Return 0
                     EndIf
                  EndIf
               EndIf
            Next i
         EndIf

      EndIf

   EndIf
   exit
***********************************************************************
case WM_CLOSE
***********************************************************************

   If GetEscapeState() < 0
      Return (1)
   EndIf

   i := Ascan ( _HMG_aFormhandles , hWnd )

   if i > 0

      * Process Interactive Close Event / Setting

      If ValType ( _HMG_aFormInteractiveCloseProcedure [i] ) == 'B'
         xRetVal := _DoWindowEventProcedure ( _HMG_aFormInteractiveCloseProcedure [i] , i , 'WINDOW_ONINTERACTIVECLOSE' )
         If ValType (xRetVal) = 'L'
            If !xRetVal
               Return (1)
            EndIf
         EndIf
      EndIf

      If lParam <> 1
         Do Case
         Case _HMG_InteractiveClose == 0
            MsgStop ( _HMG_MESSAGE [3] )
            Return (1)
         Case _HMG_InteractiveClose == 2
            If ! MsgYesNo ( _HMG_MESSAGE [1] , _HMG_MESSAGE [2] )
               Return (1)
            EndIf
         Case _HMG_InteractiveClose == 3
            if _HMG_aFormType [i] == 'A'
               If ! MsgYesNo ( _HMG_MESSAGE [1] , _HMG_MESSAGE [2] )
                  Return (1)
               EndIf
            EndIf
         EndCase
      EndIf

      * Process AutoRelease Property

      if _HMG_aFormAutoRelease [i] == .F.
         _HideWindow ( _HMG_aFormNames [i] )
         Return (1)
      EndIf

      * If Not AutoRelease Destroy Window

      if _HMG_aFormType [i] == 'A'
         ReleaseAllWindows()
      Else
         if valtype( _HMG_aFormReleaseProcedure [i] ) == 'B'
            _HMG_InteractiveCloseStarted := .T.
            _DoWindowEventProcedure ( _HMG_aFormReleaseProcedure [i] , i , 'WINDOW_RELEASE' )
         EndIf

         _hmg_OnHideFocusManagement(i)

      EndIf

   EndIf
   exit
***********************************************************************
case WM_DESTROY
***********************************************************************

   ControlCount    := Len (_HMG_aControlHandles)

   i := Ascan ( _HMG_aFormhandles , hWnd )

   if i > 0

         * Remove Child Controls

      For x:=1 To ControlCount
         if _HMG_aControlParentHandles [x] == hWnd
            _EraseControl(x,i)
         EndIf
      Next x

         * Delete Brush

      DeleteObject ( _HMG_aFormBrushHandle [i] )

         * Update/Release Form Index Variable

      mVar := '_' + _HMG_aFormNames [i]
      If Type ( mVar ) != 'U'
#ifdef _ZEROPUBLIC_
         __MVPUT ( mVar , 0 )
         #else
         __MVXRELEASE( mVar )
#endif
      EndIf

         * If Window Was Multi-Activated, Determine If It Is The
         * Last One. If Yes, Post Quit Message To Finish The
         * Message Loop

         * Quit Message, will be posted always for single
         * activated windows.

      If _HMG_aFormActivateId [i] > 0

         TmpStr := '_HMG_ACTIVATE_' + AllTrim(Str(_HMG_aFormActivateId [i]))

         If __MVEXIST ( TmpStr )

            Tmp := __MVGET ( TmpStr )

            If ValType(Tmp) == 'N'
               __MVPUT ( TmpStr , Tmp - 1 )
               If Tmp - 1 == 0
                  PostQuitMessage(0)
                  __MVXRELEASE(TmpStr)
               Endif
            Endif

         Endif

      Else

         PostQuitMessage(0)

      Endif

      _HMG_aFormDeleted		[i]   := .T.
      _HMG_aFormhandles		[i]   := 0
      _HMG_aFormNames		[i]   := ""
      _HMG_aFormActive		[i]   := .f.
      _HMG_aFormType			[i]   := ""
      _HMG_aFormParenthandle		[i]   := 0
      _HMG_aFormInitProcedure	[i]   := ""
      _HMG_aFormReleaseProcedure	[i]   := ""
      _HMG_aFormToolTipHandle	[i]   := 0
      _HMG_aFormContextMenuHandle	[i]   := 0
      _HMG_aFormMouseDragProcedure	[i]   := ""
      _HMG_aFormSizeProcedure	[i]   := ""
      _HMG_aFormClickProcedure	[i]   := ""
      _HMG_aFormMouseMoveProcedure	[i]   := ""
      _HMG_aFormMoveProcedure	[i]   := ""
      _HMG_aFormDropProcedure	[i]   := ""
      _HMG_aFormBkColor		[i]   := Nil
      _HMG_aFormPaintProcedure	[i]   := ""
      _HMG_aFormNoShow		[i]   := .F.
      _HMG_aFormNotifyIconName	[i]   := ''
      _HMG_aFormNotifyIconToolTip	[i]   := ''
      _HMG_aFormNotifyIconLeftClick	[i]   := ''
      _HMG_aFormNotifyIconDblClick	[i]   := ''
      _HMG_aFormReBarHandle		[i]   := 0
      _HMG_aFormNotifyMenuHandle	[i]   := 0
      _HMG_aFormBrowseList		[i]   := {}
      _HMG_aFormSplitChildList	[i]   := {}
      _HMG_aFormVirtualHeight	[i]   := 0
      _HMG_aFormGotFocusProcedure	[i]   := ""
      _HMG_aFormLostFocusProcedure	[i]   := ""
      _HMG_aFormVirtualWidth		[i]   := 0
      _HMG_aFormFocused		[i]   := .f.
      _HMG_aFormScrollUp		[i]   := ""
      _HMG_aFormScrollDown		[i]   := ""
      _HMG_aFormScrollLeft		[i]   := ""
      _HMG_aFormScrollRight		[i]   := ""
      _HMG_aFormHScrollBox		[i]   := ""
      _HMG_aFormVScrollBox		[i]   := ""
      _HMG_aFormBrushHandle		[i]   := 0
      _HMG_aFormFocusedControl	[i]   := 0
      _HMG_aFormGraphTasks		[i]   := {}
      _HMG_aFormMaximizeProcedure	[i]   := Nil
      _HMG_aFormMinimizeProcedure	[i]   := Nil
      _HMG_aFormRestoreProcedure	[i]   := Nil
      _HMG_aFormAutoRelease		[i]   := .F.
      _HMG_aFormInteractiveCloseProcedure [i] := ""
      _HMG_aFormMinMaxInfo		[i]   := {}
      _HMG_aFormActivateId		[i]   := 0

      _HMG_InteractiveCloseStarted := .F.

   Endif

end

Return (0)

*-----------------------------------------------------------------------------*
Procedure _SetNextFocus()
*-----------------------------------------------------------------------------*
   Local NextControlHandle := GetNextDlgTabITem ( GetActiveWindow() , GetFocus() , 0 )
   Local lShift := CheckBit( GetKeyState( VK_SHIFT ), 32768 )    // Is Shift key pressed?
   Local i := ascan ( _HMG_aControlHandles , NextControlHandle )

   If i > 0
      If _HMG_aControlType [i] == 'BUTTON'
         setfocus( NextControlHandle )
         SendMessage ( NextControlHandle , BM_SETSTYLE , LOWORD ( BS_DEFPUSHBUTTON ) , 1 )
      Else
         if lshift
            InsertShiftTab()
         else
            InsertTab()
         endif
      EndIf
   Else
      if lshift
         InsertShiftTab()
      else
         InsertTab()
      endif
   EndIf

Return

*-----------------------------------------------------------------------------*
Procedure _PushEventInfo
*-----------------------------------------------------------------------------*
   aadd ( _HMG_aEventInfo , { _HMG_ThisFormIndex , _HMG_ThisEventType , _HMG_ThisType , _HMG_ThisIndex , _HMG_ThisFormName , _HMG_ThisControlName } )
Return

*-----------------------------------------------------------------------------*
Procedure _PopEventInfo
*-----------------------------------------------------------------------------*
   Local l := Len ( _HMG_aEventInfo )

   if l > 0

      _HMG_ThisFormIndex   := _HMG_aEventInfo [l] [1]
      _HMG_ThisEventType    := _HMG_aEventInfo [l] [2]
      _HMG_ThisType       := _HMG_aEventInfo [l] [3]
      _HMG_ThisIndex       := _HMG_aEventInfo [l] [4]
      _HMG_ThisFormName    := _HMG_aEventInfo [l] [5]
      _HMG_ThisControlName    := _HMG_aEventInfo [l] [6]

      asize ( _HMG_aEventInfo , l - 1 )

   Else

      _HMG_ThisIndex := 0
      _HMG_ThisFormIndex := 0
      _HMG_ThisType := ''
      _HMG_ThisEventType := ''
      _HMG_ThisFormName :=  ''
      _HMG_ThisControlName := ''

   EndIf

Return

#ifdef _TSBROWSE_
*-----------------------------------------------------------------------------*
FUNCTION GetObjectByHandle( hWnd )
*-----------------------------------------------------------------------------*
   LOCAL oWnd := 0, nPos
   IF ( nPos := AScan( _TSB_aControlhWnd, hWnd ) ) > 0
      oWnd := _TSB_aControlObjects[ nPos ]
   ENDIF
RETURN oWnd
#endif

#ifdef _USERINIT_
*-----------------------------------------------------------------------------*
Procedure InstallEventHandler ( cProcedure )
*-----------------------------------------------------------------------------*
   aAdd ( _HMG_aCustomEventProcedure , AllTrim ( Upper ( cProcedure ) ) )
Return

*-----------------------------------------------------------------------------*
Procedure InstallPropertyHandler ( cPropertyName , cSetProcedure , cGetProcedure )
*-----------------------------------------------------------------------------*
   aAdd ( _HMG_aCustomPropertyProcedure , { AllTrim ( Upper ( cPropertyName ) ) , AllTrim ( Upper ( cSetProcedure ) ) , AllTrim ( Upper ( cGetProcedure ) ) } )
Return

*-----------------------------------------------------------------------------*
Procedure InstallMethodHandler ( cEventName , cMethodProcedure )
*-----------------------------------------------------------------------------*
   aAdd ( _HMG_aCustomMethodProcedure , { AllTrim ( Upper ( cEventName ) ) , AllTrim ( Upper ( cMethodProcedure ) ) } )
Return
#endif

*-----------------------------------------------------------------------------*
FUNCTION _OnGetMinMaxInfo( hWnd, pMinMaxInfo )
*-----------------------------------------------------------------------------*
   LOCAL i := Ascan ( _HMG_aFormhandles , hWnd ), nRet := 0
   if i > 0
      If Len ( _HMG_aFormMinMaxInfo [i] ) > 0
         nRet := SetMinMaxInfo ( pMinMaxInfo, _HMG_aFormMinMaxInfo [i] )
      EndIf
   endif
RETURN nRet

*-----------------------------------------------------------------------------*
Procedure _AutoAdjust( hWnd )
*-----------------------------------------------------------------------------*
   LOCAL i, k, ParentForm, ControlCount, ControlName, ControlType, nWidth, nHeight, lvisible:=.T., nDivw, nDivh
#ifdef _TSBROWSE_
   LOCAL oBrw
#endif

   IF GetDesktopWidth() < GetWindowWidth ( hWnd )
      nWidth := GetDesktopWidth()
   ELSE
      nWidth := GetWindowWidth ( hWnd )
   ENDIF

   IF GetDesktopHeight() < GetWindowHeight ( hWnd )
      nHeight := GetDesktopHeight()
   ELSE
      nHeight := GetWindowHeight ( hWnd )
   ENDIF

   IF IsWindowVisible ( hWnd ) .And. ! IsAppXPThemed()
      HideWindow ( hWnd )
   ELSE
      lvisible := .F.
   ENDIF

   i := aScan ( _HMG_aFormHandles , hWnd )
   ParentForm := _HMG_aFormNames [i]

   if _HMG_aFormVirtualWidth [i] > 0 .and. _HMG_aFormVirtualHeight [i] > 0
      nDivw := nWidth / _HMG_aFormVirtualWidth [i]
      nDivh := nHeight / _HMG_aFormVirtualHeight [i]
   else
      nDivw := 1
      nDivh := 1
   endif

   ControlCount := Len ( _HMG_aControlHandles )

   FOR k:=1 TO ControlCount

      ControlName := _HMG_aControlNames [k]

      if _IsControlDefined ( ControlName, ParentForm )

         ControlType := _HMG_aControlType [k]

         if !empty(ControlName) .and. !(ControlType $ "MENU,HOTKEY,TOOLBAR,MESSAGEBAR,ITEMMESSAGE,TIMER")

            if ControlType == 'RADIOGROUP'
               _HMG_aControlSpacing [k] := _HMG_aControlSpacing [k] * iif(_HMG_aControlMiscData1 [k], nDivw, nDivh)
            endif

            _SetControlSizePos ( ControlName, ParentForm, ;
                _GetControlRow ( ControlName, ParentForm ) * nDivh, _GetControlCol ( ControlName, ParentForm ) * nDivw, ;
                _GetControlWidth ( ControlName, ParentForm ) * nDivw, _GetControlHeight ( ControlName, ParentForm ) * nDivh )

#ifdef _TSBROWSE_
            if ControlType == 'TBROWSE'
               oBrw := _HMG_aControlIds [k]
               If oBrw:lIsDbf
                  oBrw:UpStable()
               else
                  oBrw:Refresh( .T. )
                  oBrw:DrawSelect()
               endif
            elseif ControlType <> 'SLIDER'
#else
            if ControlType <> 'SLIDER'
#endif
               _SetFontSize ( ControlName, ParentForm , _HMG_aControlFontSize [k] * nDivh )
            endif

         endif

      endif

   NEXT

   _HMG_aFormVirtualWidth  [i] := nWidth
   _HMG_aFormVirtualHeight [i] := nHeight

   IF lvisible
      ShowWindow ( hWnd )
   ENDIF

Return
