/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include 'minigui.ch'

*-----------------------------------------------------------------------------*
Function _DefineFont ( FontName, fname, fsize, bold, italic, underline, strikeout, nAngle, default )
*-----------------------------------------------------------------------------*
   Local mVar , k
   Local FontHandle

   Default fName  := 'Arial',;
      fSize       := 10,;
      bold        := .f.,;
      italic      := .f.,;
      underline   := .f.,;
      strikeout   := .f.,;
      nAngle      := 0,;
      default     := .f.

   If _IsControlDefined (FontName,"Main")
      MsgMiniGuiError ("Font: " + FontName + " Of Main Already defined. Program Terminated" )
   endif

   if default
      _HMG_DefaultFontName := fName
      _HMG_DefaultFontSize := fSize
   endif

   mVar := '_Main'+'_' + FontName

   FontHandle := InitFont ( fname, fsize, bold, italic, underline , strikeout , nAngle*10 )

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_aControlType [k] := "FONT"
   _HMG_aControlNames [k] :=   FontName
   _HMG_aControlHandles [k] :=   FontHandle
   _HMG_aControlParenthandles [k] :=   0
   _HMG_aControlIds [k] :=   _GetId()
   _HMG_aControlProcedures  [k] :=  ""
   _HMG_aControlPageMap  [k] :=  {}
   _HMG_aControlValue  [k] :=  0
   _HMG_aControlInputMask  [k] :=  ""
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  ""
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor   [k] := Nil
   _HMG_aControlFontColor   [k] := Nil
   _HMG_aControlDblClick   [k] := ""
   _HMG_aControlHeadClick   [k] := {}
   _HMG_aControlRow  [k] :=  0
   _HMG_aControlCol  [k] :=  0
   _HMG_aControlWidth   [k] := 0
   _HMG_aControlHeight  [k] :=  0
   _HMG_aControlSpacing  [k] :=  0
   _HMG_aControlContainerRow  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 )
   _HMG_aControlContainerCol  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 )
   _HMG_aControlPicture  [k] :=  ""
   _HMG_aControlContainerHandle  [k] :=  0
   _HMG_aControlFontName  [k] :=  fName
   _HMG_aControlFontSize  [k] :=  fSize
   _HMG_aControlFontAttributes  [k] :=  {bold,italic,underline,strikeout,nAngle}
   _HMG_aControlToolTip   [k] :=  ''
   _HMG_aControlRangeMin  [k] :=   0
   _HMG_aControlRangeMax  [k] :=   0
   _HMG_aControlCaption  [k] :=   ''
   _HMG_aControlVisible  [k] :=   .t.
   _HMG_aControlHelpId  [k] :=   0
   _HMG_aControlFontHandle  [k] :=   FontHandle
   _HMG_aControlBrushHandle  [k] :=  0
   _HMG_aControlEnabled  [k] :=   .T.
   _HMG_aControlMiscData1 [k] := 0

Return Nil

*-----------------------------------------------------------------------------*
Function _ReleaseFont( FontName )
*-----------------------------------------------------------------------------*
   Local i
   i := Ascan ( _HMG_aControlNames, FontName )
   If i > 0
      If _HMG_aControlType [i] = "FONT"
         _EraseFontDef (i)	
      endif
   endif
Return Nil

*-----------------------------------------------------------------------------*
Function _EraseFontDef (i)
*-----------------------------------------------------------------------------*
   Local mVar

   DeleteObject ( _HMG_aControlFontHandle [i] )

   mVar := '_Main' + '_' + _HMG_aControlNames [i]
   if type ( mVar ) != 'U'
      __MVPUT ( mVar , 0 )
   EndIf

   _HMG_aControlDeleted      [i] := .T.
   _HMG_aControlType          [i] := ""
   _HMG_aControlNames          [i] := ""
   _HMG_aControlHandles       [i] := 0
   _HMG_aControlParentHandles       [i] := 0
   _HMG_aControlIds           [i] := 0
   _HMG_aControlProcedures        [i] := ""
   _HMG_aControlPageMap        [i] := {}
   _HMG_aControlValue        [i] := Nil
   _HMG_aControlInputMask        [i] := ""
   _HMG_aControllostFocusProcedure    [i] := ""
   _HMG_aControlGotFocusProcedure     [i] := ""
   _HMG_aControlChangeProcedure     [i] := ""
   _HMG_aControlBkColor            [i] := Nil
   _HMG_aControlFontColor          [i] := Nil
   _HMG_aControlDblClick          [i] := ""
   _HMG_aControlHeadClick          [i] := {}
   _HMG_aControlRow          [i] := 0
   _HMG_aControlCol          [i] := 0
   _HMG_aControlWidth          [i] := 0
   _HMG_aControlHeight       [i] := 0
   _HMG_aControlSpacing      [i] := 0
   _HMG_aControlContainerRow       [i] := 0
   _HMG_aControlContainerCol           [i] := 0
   _HMG_aControlPicture              [i] := ''
   _HMG_aControlContainerHandle        [i] := 0
   _HMG_aControlFontName              [i] := ''
   _HMG_aControlFontSize               [i] := 0
   _HMG_aControlToolTip              [i] := ''
   _HMG_aControlRangeMin      [i] := 0
   _HMG_aControlRangeMax      [i] := 0
   _HMG_aControlCaption      [i] := ''
   _HMG_aControlVisible      [i] := .f.
   _HMG_aControlHelpId         [i] := 0
   _HMG_aControlFontHandle      [i] := 0
   _HMG_aControlFontAttributes      [i] := {}
   _HMG_aControlBrushHandle       [i] := 0
   _HMG_aControlEnabled        [I] := .F.
   _HMG_aControlMiscData1 [i] := 0

Return Nil

*-----------------------------------------------------------------------------*
Function GetFontHandle( FontName )
*-----------------------------------------------------------------------------*
   Local c := 0, i
   i := Ascan ( _HMG_aControlNames, FontName )
   If i > 0
      If _HMG_aControlType [i] = "FONT"
         c := _HMG_aControlHandles [i]
      endif
   endif
Return c

*-----------------------------------------------------------------------------*
Function GetFontParam(FontHandle)
*-----------------------------------------------------------------------------*
   Local aFont, i
   aFont := { _HMG_DefaultFontName,_HMG_DefaultFontSize, .f., .f., .f., .f., 0}
   i := Ascan ( _HMG_aControlHandles , FontHandle )
   If i > 0
      If _HMG_aControlType [i] = "FONT"
         aFont := { _HMG_aControlFontName  [i], _HMG_aControlFontSize  [i],;
            _HMG_aControlFontAttributes  [i,1], _HMG_aControlFontAttributes  [i,2],;
            _HMG_aControlFontAttributes  [i,3], _HMG_aControlFontAttributes  [i,4],;
            if(len(_HMG_aControlFontAttributes  [i]) == 5,_HMG_aControlFontAttributes  [i,5],0)}
      endif
   endif

Return aFont

*-----------------------------------------------------------------------------*
Function _GetFontName ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i

   i := GetControlIndex ( ControlName, ParentForm )

Return	( _HMG_aControlFontName [i] )
*-----------------------------------------------------------------------------*
Function _GetFontSize ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i

   i := GetControlIndex ( ControlName, ParentForm )

Return	( _HMG_aControlFontSize [i] )
*-----------------------------------------------------------------------------*
Function _GetFontBold ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i

   i := GetControlIndex ( ControlName, ParentForm )

Return	( _HMG_aControlFontAttributes [i] [1] )
*-----------------------------------------------------------------------------*
Function _GetFontItalic ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i

   i := GetControlIndex ( ControlName, ParentForm )

Return	( _HMG_aControlFontAttributes [i] [2] )
*-----------------------------------------------------------------------------*
Function _GetFontUnderline ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i

   i := GetControlIndex ( ControlName, ParentForm )

Return	( _HMG_aControlFontAttributes [i] [3] )
*-----------------------------------------------------------------------------*
Function _GetFontStrikeOut ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
   Local i

   i := GetControlIndex ( ControlName, ParentForm )

Return	( _HMG_aControlFontAttributes [i] [4] )

#define WM_SETFONT                      0x0030
*-----------------------------------------------------------------------------*
Function _SetFontName ( ControlName, ParentForm , Value )
*-----------------------------------------------------------------------------*
   Local i , h , s, ab , ai , au , as , x

   i := GetControlIndex ( ControlName, ParentForm )
   DeleteObject ( _HMG_aControlFontHandle [i] )
   h := _HMG_aControlHandles [i]
   s := _HMG_aControlFontSize [i]
   ab := _HMG_aControlFontAttributes [i] [1]
   ai := _HMG_aControlFontAttributes [i] [2]
   au := _HMG_aControlFontAttributes [i] [3]
   as := _HMG_aControlFontAttributes [i] [4]
   _HMG_aControlFontName [i] := Value
   do case
   case _HMG_aControlType [i] == "SPINNER"
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1] , Value , s , ab , ai , au , as )

   case _HMG_aControlType [i] == "RADIOGROUP"

      _HMG_aControlFontHandle [i]:=SetFontNameSize ( h [1] , Value , s , ab , ai , au , as )
      For x := 2 To Len (h)
         SendMessage( h[x], WM_SETFONT , _HMG_aControlFontHandle [i] , 1 )
      Next x

   otherwise
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h , Value , s , ab , ai , au , as )
   Endcase

Return Nil
*-----------------------------------------------------------------------------*
Function _SetFontSize ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , n , ab , ai , au , as , x

   i := GetControlIndex ( ControlName, ParentForm )
   DeleteObject ( _HMG_aControlFontHandle [i] )
   h := _HMG_aControlHandles [i]
   n := _HMG_aControlFontName [i]
   ab := _HMG_aControlFontAttributes [i] [1]
   ai := _HMG_aControlFontAttributes [i] [2]
   au := _HMG_aControlFontAttributes [i] [3]
   as := _HMG_aControlFontAttributes [i] [4]
   _HMG_aControlFontSize [i] := Value
   do case
   case _HMG_aControlType [i] == "SPINNER"
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , Value , ab , ai , au , as )

   case _HMG_aControlType [i] == "RADIOGROUP"

      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , Value , ab , ai , au , as )
      For x := 2 To Len (h)
         SendMessage( h[x], WM_SETFONT , _HMG_aControlFontHandle [i] , 1 )
      Next x

   otherwise
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h , n , Value , ab , ai , au , as )
   Endcase

Return Nil
*-----------------------------------------------------------------------------*
Function _SetFontBold ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , n , s , ai , au , as , x

   i := GetControlIndex ( ControlName, ParentForm )
   DeleteObject ( _HMG_aControlFontHandle [i] )
   h := _HMG_aControlHandles [i]
   n := _HMG_aControlFontName [i]
   s := _HMG_aControlFontSize [i]
   ai := _HMG_aControlFontAttributes [i] [2]
   au := _HMG_aControlFontAttributes [i] [3]
   as := _HMG_aControlFontAttributes [i] [4]
   _HMG_aControlFontAttributes [i] [1] := Value
   do case
   case _HMG_aControlType [i] == "SPINNER"

      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , s , Value , ai , au , as )

   case _HMG_aControlType [i] == "RADIOGROUP"

      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , s , Value , ai , au , as )
      For x := 2 To Len (h)
         SendMessage( h[x], WM_SETFONT , _HMG_aControlFontHandle [i] , 1 )
      Next x

   otherwise
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h , n , s , Value , ai , au , as )
   Endcase

Return Nil
*-----------------------------------------------------------------------------*
Function _SetFontItalic ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , n , s , ab , au , as , x

   i := GetControlIndex ( ControlName, ParentForm )
   DeleteObject ( _HMG_aControlFontHandle [i] )
   h := _HMG_aControlHandles [i]
   n := _HMG_aControlFontName [i]
   s := _HMG_aControlFontSize [i]
   ab := _HMG_aControlFontAttributes [i] [1]
   au := _HMG_aControlFontAttributes [i] [3]
   as := _HMG_aControlFontAttributes [i] [4]
   _HMG_aControlFontAttributes [i] [2] := Value
   do case
   case _HMG_aControlType [i] == "SPINNER"

      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , s , ab , Value , au , as )

   case _HMG_aControlType [i] == "RADIOGROUP"

      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , s , ab , Value , au , as )
      For x := 2 To Len (h)
         SendMessage( h[x], WM_SETFONT , _HMG_aControlFontHandle [i] , 1 )
      Next x

   otherwise
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h , n , s , ab , Value , au , as )
   Endcase

Return Nil
*-----------------------------------------------------------------------------*
Function _SetFontUnderline ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , n , s , ab , ai , as , x

   i := GetControlIndex ( ControlName, ParentForm )
   DeleteObject ( _HMG_aControlFontHandle [i] )
   h := _HMG_aControlHandles [i]
   n := _HMG_aControlFontName [i]
   s := _HMG_aControlFontSize [i]
   ab := _HMG_aControlFontAttributes [i] [1]
   ai := _HMG_aControlFontAttributes [i] [2]
   as := _HMG_aControlFontAttributes [i] [4]
   _HMG_aControlFontAttributes [i] [3] := Value
   do case
   case _HMG_aControlType [i] == "SPINNER"
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , s , ab , ai , Value , as )

   case _HMG_aControlType [i] == "RADIOGROUP"

      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , s , ab , ai , Value , as )
      For x := 2 To Len (h)
         SendMessage( h[x], WM_SETFONT , _HMG_aControlFontHandle [i] , 1 )
      Next x

   otherwise
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h , n , s , ab , ai , Value , as )
   Endcase

Return Nil
*-----------------------------------------------------------------------------*
Function _SetFontStrikeOut ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
   Local i , h , n , s , ab , ai , au , x

   i := GetControlIndex ( ControlName, ParentForm )
   DeleteObject ( _HMG_aControlFontHandle [i] )
   h := _HMG_aControlHandles [i]
   n := _HMG_aControlFontName [i]
   s := _HMG_aControlFontSize [i]
   ab := _HMG_aControlFontAttributes [i] [1]
   ai := _HMG_aControlFontAttributes [i] [2]
   au := _HMG_aControlFontAttributes [i] [3]
   _HMG_aControlFontAttributes [i] [4] := Value
   do case
   case _HMG_aControlType [i] == "SPINNER"
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , s , ab , ai , au , Value )

   case _HMG_aControlType [i] == "RADIOGROUP"

      _HMG_aControlFontHandle [i] := SetFontNameSize ( h [1], n , s , ab , ai , au , Value )
      For x := 2 To Len (h)
         SendMessage( h[x], WM_SETFONT , _HMG_aControlFontHandle [i] , 1 )
      Next x

   otherwise
      _HMG_aControlFontHandle [i] := SetFontNameSize ( h , n , s , ab , ai , au , Value )
   Endcase

Return Nil