/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"
#include "fileio.ch"

*-----------------------------------------------------------------------------*
Procedure SetHelpFile( cFile )
*-----------------------------------------------------------------------------*
   Local hFile

   if File( cFile )

      hFile := FOpen( cFile, FO_READ + FO_SHARED )

      If FError() == 0
         _HMG_ActiveHelpFile := cFile
      Else
         _HMG_ActiveHelpFile := ""
         MsgAlert( "Error opening of help file. Error: " + Str( FError(), 2, 0 ), "Alert" )
      EndIf

      FClose( hFile )

   else

      MsgAlert( "Help file " + cFile + " is not found!", "Warning" )

   endif

Return

*-----------------------------------------------------------------------------*
Procedure DisplayHelpTopic( xTopic , nMet )
*-----------------------------------------------------------------------------*
   Local cParam := ""

   If Empty( _HMG_ActiveHelpFile )
      Return
   EndIf

   _HMG_nTopic := xTopic
   _HMG_nMet   := nMet

   If ValType(nMet) == 'U'
      nMet := 0
   EndIf

   If Right( Alltrim( Upper( _HMG_ActiveHelpFile ) ) , 4 ) == '.CHM'

      Do Case
      Case ValType( xTopic ) == 'N'
         cParam := '-mapid ' + LTrim( Str( xTopic ) ) +  ' ' + _HMG_ActiveHelpFile

      Case ValType( xTopic ) == 'C'
         cParam :=  '"' + _HMG_ActiveHelpFile + '::/' + AllTrim( xTopic ) + '.htm"'

      Case ValType( xTopic ) == 'U'
         cParam := '"' + _HMG_ActiveHelpFile + '"'
      EndCase

      _Execute( _HMG_MainHandle , "open" , "hh.exe" , cParam , , 5 )

   Else

      If ValType( xTopic ) == 'U'
         xTopic := 0
      EndIf

      WinHelp( _HMG_MainHandle , _HMG_ActiveHelpFile , nMet , xTopic )

   EndIf

Return
