/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include 'minigui.ch'

*-----------------------------------------------------------------------------*
Procedure _DefineHotKey ( cParentForm , nMod , nKey , bAction )
*-----------------------------------------------------------------------------*
   Local nParentForm , nId , i , nControlCount , k , z

   //JP MDI HotKey
   If _HMG_BeginWindowMDIActive
      nParentForm := GetActiveMdiHandle()
      if nParentForm == 0
         cParentForm := _HMG_MainClientMDIName
      else
         cParentForm := _GetWindowProperty ( nParentForm, "PROP_FORMNAME" )
      endif
   ElseIf _HMG_BeginWindowActive = .T.
      cParentForm := _HMG_ActiveFormName
   EndIf
   //End JP
   If ValType ( cParentForm ) == 'U'
      MsgMiniGuiError ("ON KEY: Parent Window Not Specified. Program Terminated")
   EndIf

   // Check if the window/form is defined.
   If .not. _IsWindowDefined( cParentForm )
      MsgMiniGuiError( "Window: " + cParentForm + " is not defined. Program terminated." )
   Endif

   //JP MDI HotKey
   if _HMG_BeginWindowMDIActive
      nParentForm := GetActiveMdiHandle()
      If nParentForm == 0
         nParentForm := GetFormHandle ( cParentForm )
      EndIf
   else
      nParentForm := GetFormHandle ( cParentForm )
   endif
   //End JP
   nControlCount := Len ( _HMG_aControlhandles )
   z := GetFormIndex ( cParentForm )

   For i := 1 To nControlCount
      If _HMG_aControlType [i] == 'HOTKEY' .and. _HMG_aControlParenthandles [i] == nParentForm .and. _HMG_aControlPageMap [i] == nMod .and. _HMG_aControlValue [i] == nKey
         _EraseControl( i, z )
         Exit
      EndIf
   Next i

   nId := _GetId( 49151 )

   InitHotKey ( nParentForm , nMod , nKey , nId )

   k := _GetControlFree()

   _HMG_aControlType [k] :=  "HOTKEY"
   _HMG_aControlNames  [k] :=   ''
   _HMG_aControlHandles  [k] :=   0
   _HMG_aControlParentHandles  [k] :=   nParentForm
   _HMG_aControlIds  [k] :=   nId
   _HMG_aControlProcedures  [k] :=   bAction
   _HMG_aControlPageMap  [k] :=   nMod
   _HMG_aControlValue  [k] :=   nKey
   _HMG_aControlInputMask  [k] :=   ""
   _HMG_aControllostFocusProcedure  [k] :=   ""
   _HMG_aControlGotFocusProcedure   [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=   ""
   _HMG_aControlDeleted  [k] :=   .F.
   _HMG_aControlBkColor  [k] :=   Nil
   _HMG_aControlFontColor  [k] :=   Nil
   _HMG_aControlDblClick   [k] :=  ""
   _HMG_aControlHeadClick  [k] :=   {}
   _HMG_aControlRow  [k] :=   0
   _HMG_aControlCol   [k] :=  0
   _HMG_aControlWidth  [k] :=   0
   _HMG_aControlHeight  [k] :=   0
   _HMG_aControlSpacing   [k] :=  0
   _HMG_aControlContainerRow  [k] :=   0
   _HMG_aControlContainerCol   [k] :=  0
   _HMG_aControlPicture   [k] :=  ""
   _HMG_aControlContainerHandle   [k] :=  0
   _HMG_aControlFontName   [k] :=  ''
   _HMG_aControlFontSize  [k] :=   0
   _HMG_aControlFontAttributes  [k] :=   {.f.,.f.,.f.,.f.}
   _HMG_aControlToolTip   [k] :=   ''
   _HMG_aControlRangeMin   [k] :=   0
   _HMG_aControlRangeMax   [k] :=   0
   _HMG_aControlCaption   [k] :=   ''
   _HMG_aControlVisible   [k] :=   .t.
   _HMG_aControlHelpId  [k] :=    0
   _HMG_aControlFontHandle  [k] :=    0
   _HMG_aControlBrushHandle  [k] :=    0
   _HMG_aControlEnabled  [k] :=    .T.
   _HMG_aControlMiscData1 [k] := 0

Return

*-----------------------------------------------------------------------------*
Procedure _ReleaseHotKey ( cParentForm, nMod , nKey )
*-----------------------------------------------------------------------------*
   Local i , nParentFormHandle , nControlCount , z

   nParentFormHandle := GetFormhandle ( cParentForm )
   nControlCount := Len ( _HMG_aControlhandles )
   z := GetFormIndex (cParentForm)

   For i := 1 To nControlCount
      If _HMG_aControlType [i] == 'HOTKEY' .and. _HMG_aControlParenthandles [i] == nParentFormHandle .and. _HMG_aControlPageMap [i] == nMod .and. _HMG_aControlValue [i] == nKey
         _EraseControl(i,z)
         Exit
      EndIf
   Next i

Return

*-----------------------------------------------------------------------------*
Function _GetHotKey ( cParentForm, nMod , nKey )
*-----------------------------------------------------------------------------*
   Local i , nParentFormHandle , nControlCount , bRetVal := Nil

   nParentFormHandle := GetFormhandle ( cParentForm )
   nControlCount := Len ( _HMG_aControlhandles )

   For i := 1 To nControlCount
      If _HMG_aControlType [i] == 'HOTKEY' .and. _HMG_aControlParenthandles [i] == nParentFormHandle .and. _HMG_aControlPageMap [i] == nMod .and. _HMG_aControlValue [i] == nKey
         bRetVal := _HMG_aControlProcedures [i]
         Exit
      EndIf
   Next i

Return ( bRetVal )

*-----------------------------------------------------------------------------*
Procedure _PushKey (nKey)
*-----------------------------------------------------------------------------*

   Keybd_Event ( nKey, .f. )
   Keybd_Event ( nKey, .t. )

Return