/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

*-----------------------------------------------------------------------------*
Function _DefineHyperLink ( ControlName, ParentForm, x, y, Caption, url, w, h,;
   fontname, fontsize, bold, BORDER, CLIENTEDGE,;
   HSCROLL, VSCROLL, TRANSPARENT, aRGB_bk, aRGB_font,;
   tooltip, HelpId, invisible, italic,;
   autosize , handcursor )
*-----------------------------------------------------------------------------*
   Local cParentForm , mVar , k
   Local ControlHandle , FontHandle , aFont, underline, strikeout, link

   DEFAULT w             TO 120
   DEFAULT h             TO 24
   DEFAULT Url           TO ""
   DEFAULT invisible     TO FALSE
   DEFAULT bold          TO FALSE
   DEFAULT italic        TO FALSE
   DEFAULT aRGB_font     TO {0,0,255}

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
   endif

   strikeout := .f.
   underline := .t.
   link := .t.

   if _HMG_BeginWindowActive = .T.
      ParentForm := _HMG_ActiveFormName
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(FontName) == "U"
         FontName := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(FontSize) == "U"
         FontSize := _HMG_ActiveFontSize
      EndIf
   endif
   if _HMG_FrameLevel > 0
      x 	:= x + _HMG_ActiveFrameCol [_HMG_FrameLevel]
      y 	:= y + _HMG_ActiveFrameRow [_HMG_FrameLevel]
      ParentForm := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
      if IsXpThemeActive() .and. aRGB_bk == NIL
         Transparent := .t.
      EndIf
   EndIf

   If .Not. _IsWindowDefined (ParentForm)
      MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated")
   Endif

   If _IsControlDefined (ControlName,ParentForm)
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program Terminated")
   endif

   mVar := '_' + ParentForm + '_' + ControlName

   cParentForm := ParentForm

   ParentForm = GetFormHandle (ParentForm)

   Controlhandle := InitHyperLink ( ParentForm, Caption, 0, x, y, w, h, '', 0, Nil , border , clientedge , HSCROLL , VSCROLL , TRANSPARENT , invisible, link , handcursor)

   If FontHandle != 0
      _SetFontHandle(ControlHandle,FontHandle)
   Else
      if valtype(fontname) == "U"
         Fontname := _HMG_DefaultFontName
      endif
      if valtype(fontsize) == "U"
         FontSize := _HMG_DefaultFontSize
      endif
      FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
   EndIf

   If _HMG_BeginTabActive = .T.
      aAdd ( _HMG_ActiveTabCurrentPageMap , Controlhandle )
   EndIf

   if valtype(tooltip) != "U"
      SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
   endif

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_aControlType  [k] := "HYPERLINK"
   _HMG_aControlNames  [k] :=  ControlName
   _HMG_aControlHandles  [k] :=  ControlHandle
   _HMG_aControlParenthandles  [k] :=  ParentForm
   _HMG_aControlIds   [k] := 0
   _SetAddressControlProcedure ( ControlName , url , k )
   _HMG_aControlPageMap  [k] :=  {}
   _HMG_aControlValue  [k] :=  url
   _HMG_aControlInputMask  [k] :=  Transparent
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  ""
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor  [k] :=  aRGB_bk
   _HMG_aControlFontColor  [k] :=  aRGB_font
   _HMG_aControlDblClick  [k] :=  ""
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow   [k] := y
   _HMG_aControlCol   [k] := x
   _HMG_aControlWidth   [k] := w
   _HMG_aControlHeight   [k] := h
   _HMG_aControlSpacing  [k] :=  if ( autosize == .t. , 1 , 0 )
   _HMG_aControlContainerRow  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 )
   _HMG_aControlContainerCol  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 )
   _HMG_aControlPicture  [k] :=  ""
   _HMG_aControlContainerHandle  [k] :=  0
   _HMG_aControlFontName  [k] :=  fontname
   _HMG_aControlFontSize  [k] :=  fontsize
   _HMG_aControlFontAttributes  [k] :=  {bold,italic,underline,strikeout}
   _HMG_aControlToolTip   [k] :=  tooltip
   _HMG_aControlRangeMin  [k] :=   0
   _HMG_aControlRangeMax  [k] :=   0
   _HMG_aControlCaption  [k] :=   Caption
   _HMG_aControlVisible  [k] :=   if(invisible,FALSE,TRUE)
   _HMG_aControlHelpId  [k] :=   HelpId
   _HMG_aControlFontHandle  [k] :=   FontHandle
   _HMG_aControlBrushHandle  [k] :=   0
   _HMG_aControlEnabled  [k] :=   .T.
   _HMG_aControlMiscData1 [k] := 0

   If autosize == .t.
      _SetControlWidth ( ControlName , cParentForm , GetTextWidth( NIL, Caption, FontHandle ) +;
         IF( bold == .T. .And. IsXPThemeActive() == .T., GetTextWidth( NIL, " ", FontHandle ), 0 ) ) // Fixed for problem with display bold label at themed WinXP
      _SetControlHeight ( ControlName , cParentForm , FontSize + IF( FontSize < 12, 12, 16 ) )
      RedrawWindow (ControlHandle)
   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Procedure _SetAddress ( ControlName , ParentForm , url )
*-----------------------------------------------------------------------------*
   Local i

   i := GetControlIndex ( ControlName , ParentForm )

   If i > 0

      _SetAddressControlProcedure ( ControlName , url , i )
      _HMG_aControlValue [i] := url

   EndIf

Return

*-----------------------------------------------------------------------------*
Function _GetAddress ( ControlName , ParentForm )
*-----------------------------------------------------------------------------*
   Local i , RetVal := ''

   i := GetControlIndex ( ControlName , ParentForm )

   If i > 0

      RetVal := _HMG_aControlValue [i]

   EndIf

Return RetVal

*-----------------------------------------------------------------------------*
Procedure _SetAddressControlProcedure ( ControlName , url , i )
*-----------------------------------------------------------------------------*

   do case
   case at("@",url)>0

      _HMG_aControlProcedures [i] := {||ShellExecute(0, "open", "rundll32.exe", "url.dll,FileProtocolHandler mailto:"+url, ,1)}

   case at("http",url)>0 .or. file(url)

      _HMG_aControlProcedures [i] := {||ShellExecute(0, "open", url, , ,1)}

   case at("file:\\",url)>0

      if iswinnt()
         _HMG_aControlProcedures [i] := {||ShellExecute(0, "open", "explorer.exe", "/e,"+url, ,1)}
      else
         url := strtran(url,"file:\\","")
         _HMG_aControlProcedures [i] := {||ShellExecute(0, "open", "explorer.exe", "/e,/select,"+url+"\"+directory(url+"\*.*")[1][1], ,1)}
      endif

   otherwise

      MsgMiniGuiError ("Control: " + ControlName + " must have valid email, url or file defined. Program Terminated")

   endcase

Return