/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

#define WS_BORDER           0x800000
#define WS_TABSTOP          0x00010000
#define WS_VISIBLE          0x10000000
#define WS_CHILD            0x40000000
#define WS_VSCROLL          0x200000
#define WS_HSCROLL          0x100000
#define SS_NOTIFY           256
#define ES_CENTER           1
#define ES_RIGHT            2

*-----------------------------------------------------------------------------*
Function _DefineLabel ( ControlName, ParentFormName, x, y, Caption, w, h,;
   fontname, fontsize, bold, BORDER, CLIENTEDGE,;
   HSCROLL, VSCROLL, TRANSPARENT, aRGB_bk, aRGB_font,;
   ProcedureName, tooltip, HelpId, invisible, italic,;
   underline, strikeout , autosize , rightalign , centeralign , blink , nId )
*-----------------------------------------------------------------------------*
   Local ParentFormHandle , mVar , k := 0, Style, blInit
   Local ControlHandle , FontHandle, aFont
   Local lDialogInMemory

   DEFAULT w             TO 120
   DEFAULT h             TO 24
   DEFAULT ProcedureName TO ""
   DEFAULT invisible     TO FALSE
   DEFAULT bold          TO FALSE
   DEFAULT italic        TO FALSE
   DEFAULT underline     TO FALSE
   DEFAULT strikeout     TO FALSE

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
      underline     := aFont[5]
      strikeout     := aFont[6]
   endif

   if _HMG_BeginWindowActive = TRUE .or. _HMG_BeginDialogActive = TRUE
      ParentFormName := if(_HMG_BeginDialogActive,_HMG_ActiveDialogName,_HMG_ActiveFormName)
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(FontName) == "U"
         FontName := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(FontSize) == "U"
         FontSize := _HMG_ActiveFontSize
      EndIf
   endif
   if _HMG_FrameLevel > 0
      x    := x + _HMG_ActiveFrameCol [_HMG_FrameLevel]
      y    := y + _HMG_ActiveFrameRow [_HMG_FrameLevel]
      ParentFormName := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
      if IsXpThemeActive() .and. aRGB_bk == NIL
         Transparent := .t.
      EndIf
   EndIf
   lDialogInMemory := _HMG_DialogInMemory // ( GetWindowType ( ParentFormName ) == "L" )

   If .Not. _IsWindowDefined (ParentFormName) .and. .Not. lDialogInMemory
      MsgMiniGuiError("Window: "+ ParentFormName + " is not defined. Program terminated")
   Endif

   If _IsControlDefined (ControlName,ParentFormName) .and. .Not. lDialogInMemory
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentFormName + " Already defined. Program Terminated")
   endif

   mVar := '_' + ParentFormName + '_' + ControlName
   k := _GetControlFree()

   if _HMG_BeginDialogActive = TRUE
      ParentFormHandle = _HMG_ActiveDialogHandle

      Style := WS_CHILD + SS_NOTIFY

      if border
         Style += WS_BORDER
      endif

      if !invisible
         Style += WS_VISIBLE
      endif

      if HSCROLL
         Style += WS_HSCROLL
      endif

      if VSCROLL
         Style += WS_VSCROLL
      endif

      if rightalign
         Style += ES_RIGHT
      endif

      if centeralign
         Style += ES_CENTER
      endif

      if lDialogInMemory         //Dialog Template

//          {{'ID',k/hwnd,class,Style,ExStyle,x,y,w,h,caption,HelpId,tooltip,font,size, bold, italic, underline, strikeout}}  --->_HMG_aDialogItems
         blInit:= {|x,y,z| InitDialogLabel(x,y,z) }
         aadd(_HMG_aDialogItems,{nId,k,"static",style,0,x,y,w,h,caption,HelpId,tooltip,FontName,FontSize,bold,italic,underline,strikeout,blInit,_HMG_BeginTabActive,.f.,_HMG_ActiveTabPage })
/* JP 62
         if _HMG_aDialogTemplate[3]   // Modal
            _HMG_aControlDeleted [k] := .T.
            Return Nil
         endif
*/
      else

         ControlHandle := GetDialogItemHandle( ParentFormHandle, nId )

         x := GetWindowCol ( Controlhandle )
         y := GetWindowRow ( Controlhandle )
         w := GetWindowWidth  ( Controlhandle )
         h := GetWindowHeight ( Controlhandle )


         if valtype(caption) != "U"
            SetWindowText ( ControlHandle , caption )
         ENDIF

         SetWindowStyle ( ControlHandle, Style )

/*          TODO

         if ( hb_parl (12) )
            {
            ExStyle = ExStyle | WS_EX_CLIENTEDGE;
               }

            if ( hb_parl (15) )
               {
               ExStyle = ExStyle | WS_EX_TRANSPARENT;
                  }
*/
            endif

         else

            ParentFormHandle = GetFormHandle (ParentFormName)

            Controlhandle := InitLabel ( ParentFormHandle, Caption, 0, x, y, w, h, '', 0, Nil , border , clientedge , HSCROLL , VSCROLL , TRANSPARENT , invisible , rightalign , centeralign )
         endif

         if .Not. lDialogInMemory

            If FontHandle != 0
               _SetFontHandle(ControlHandle,FontHandle)
            Else
               if valtype(fontname) == "U"
                  Fontname := _HMG_DefaultFontName
               endif
               if valtype(fontsize) == "U"
                  FontSize := _HMG_DefaultFontSize
               endif
               FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
            EndIf

            If _HMG_BeginTabActive = .T.
               aAdd ( _HMG_ActiveTabCurrentPageMap , Controlhandle )
            EndIf

            if valtype(tooltip) != "U"
               SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (ParentFormName) )
            endif

         endif

         Public &mVar. := k

         _HMG_aControlType [k] :=  "LABEL"
         _HMG_aControlNames  [k] :=  ControlName
         _HMG_aControlHandles  [k] :=  ControlHandle
         _HMG_aControlParenthandles  [k] :=  ParentFormHandle
         _HMG_aControlIds  [k] :=  nId
         _HMG_aControlProcedures  [k] :=  ProcedureName
         _HMG_aControlPageMap  [k] :=  {}
         _HMG_aControlValue [k] :=   Nil
         _HMG_aControlInputMask  [k] :=  transparent
         _HMG_aControllostFocusProcedure  [k] :=  ""
         _HMG_aControlGotFocusProcedure [k] :=   ""
         _HMG_aControlChangeProcedure  [k] :=  ""
         _HMG_aControlDeleted  [k] :=  .F.
         _HMG_aControlBkColor  [k] :=  aRGB_bk
         _HMG_aControlFontColor  [k] :=  aRGB_font
         _HMG_aControlDblClick   [k] := ""
         _HMG_aControlHeadClick  [k] :=  {}
         _HMG_aControlRow  [k] :=  y
         _HMG_aControlCol  [k] :=  x
         _HMG_aControlWidth  [k] :=  w
         _HMG_aControlHeight   [k] :=  h
         _HMG_aControlSpacing  [k] :=  if ( autosize == .t. , 1 , 0 )
         _HMG_aControlContainerRow  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 )
         _HMG_aControlContainerCol  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 )
         _HMG_aControlPicture  [k] :=  ""
         _HMG_aControlContainerHandle  [k] :=  0
         _HMG_aControlFontName  [k] :=  fontname
         _HMG_aControlFontSize   [k] := fontsize
         _HMG_aControlFontAttributes  [k] :=  {bold,italic,underline,strikeout}
         _HMG_aControlToolTip  [k] :=  tooltip
         _HMG_aControlRangeMin  [k] :=  0
         _HMG_aControlRangeMax  [k] :=  0
         _HMG_aControlCaption  [k] :=  Caption
         _HMG_aControlVisible  [k] :=  if(invisible,FALSE,TRUE)
         _HMG_aControlHelpId  [k] :=  HelpId
         _HMG_aControlFontHandle  [k] :=  FontHandle
         _HMG_aControlBrushHandle   [k] :=  0
         _HMG_aControlEnabled   [k] :=  .T.
         _HMG_aControlMiscData1 [k] :=  { 0, blink, .T. }

         if blink == .t. .and. .Not. lDialogInMemory
            _DefineTimer ( 'BlinkTimer' + Ltrim( Str(k) ) , ParentFormName , 500 , {|| _HMG_aControlMiscData1 [k] [3] := ! _HMG_aControlMiscData1 [k] [3],;
               IF(_HMG_aControlMiscData1 [k] [3] == .t., _ShowControl ( ControlName , ParentFormName ), _HideControl ( ControlName , ParentFormName ) ) } )
         EndIf

         if autosize == .t. .and. .Not. lDialogInMemory
            _SetControlWidth ( ControlName , ParentFormName , GetTextWidth( NIL, Caption, FontHandle ) +;
               IF( bold == .T. .And. IsXPThemeActive() == .T., GetTextWidth( NIL, " ", FontHandle ), 0 ) ) // Fixed for problem with display bold label at themed WinXP
            _SetControlHeight ( ControlName , ParentFormName , FontSize + IF( FontSize < 12, 12, 16 ) )
            RedrawWindow (ControlHandle)
         EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function InitDialogLabel(ParentFormName, ControlHandle, k)
*-----------------------------------------------------------------------------*
   Local ControlName := _HMG_aControlNames  [k]

   if _HMG_aControlMiscData1 [k] [2] == .t.
      _DefineTimer ( 'BlinkTimer' + Ltrim( Str(k) ) , ParentFormName , 500 , {|| _HMG_aControlMiscData1 [k] [3] := ! _HMG_aControlMiscData1 [k] [3],;
         IF(_HMG_aControlMiscData1 [k] [3] == .t., _ShowControl ( ControlName , ParentFormName ), _HideControl ( ControlName , ParentFormName ) ) } )
   EndIf

   if _HMG_aControlSpacing  [k] == 1
      _SetControlWidth ( ControlName , ParentFormName , GetTextWidth( NIL, _HMG_aControlCaption [k] , _HMG_aControlFontHandle [k] ) +;
         IF( _HMG_aControlFontAttributes [k] [1] == .T. .And. IsXPThemeActive() == .T., GetTextWidth( NIL, " ", _HMG_aControlFontHandle [k] ), 0 ) ) // Fixed for problem with display bold label at themed WinXP
      _SetControlHeight ( ControlName , ParentFormName , _HMG_aControlFontSize [k] + IF( _HMG_aControlFontSize [k] < 12, 12, 16 ) )
      RedrawWindow (ControlHandle)
   EndIf
// JP 62
   if len(_HMG_aDialogTemplate) != 0 .and. _HMG_aDialogTemplate[3]   // Modal
      _HMG_aControlDeleted [k] := .T.
   endif

Return Nil