/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

#define WS_TABSTOP          0x00010000
#define WS_VISIBLE          0x10000000
#define WS_CHILD            0x40000000
#define WS_BORDER           0x800000

*-----------------------------------------------------------------------------*
Function _DefinePlayer ( ControlName, ParentFormName, file, x, y, w, h, noasw, noasm, noed, nom, noo, nop, sha, shm, shn, shp, HelpId )
*-----------------------------------------------------------------------------*
   Local hh , mVar , k

   if _HMG_BeginWindowActive = .T.
      ParentFormName := _HMG_ActiveFormName
   endif

   if _HMG_FrameLevel > 0
      x    := x + _HMG_ActiveFrameCol [_HMG_FrameLevel]
      y    := y + _HMG_ActiveFrameRow [_HMG_FrameLevel]
      ParentFormName := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
   EndIf

   If .Not. _IsWindowDefined (ParentFormName)
      MsgMiniGuiError("Window: "+ ParentFormName + " is not defined. Program terminated")
   Endif

   If _IsControlDefined (ControlName,ParentFormName)
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentFormName + " Already defined. Program Terminated")
   endif

   mVar := '_' + ParentFormName + '_' + ControlName

   Hh :=InitPlayer ( GetFormHandle(ParentFormName)   ,;
      file             ,;
      x             ,;
      y            ,;
      w            ,;
      h            ,;
      noasw            ,;
      noasm            ,;
      noed            ,;
      nom            ,;
      noo            ,;
      nop            ,;
      sha            ,;
      shm            ,;
      shn            ,;
      shp )

   If _HMG_BeginTabActive = .T.
      aAdd ( _HMG_ActiveTabCurrentPageMap , hh )
   EndIf

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_aControlType  [k] := "PLAYER"
   _HMG_aControlNames  [k] :=  ControlName
   _HMG_aControlHandles  [k] :=  hh
   _HMG_aControlParentHandles  [k] :=  GetFormHandle(ParentFormName)
   _HMG_aControlIds  [k] :=  0
   _HMG_aControlProcedures  [k] :=  ""
   _HMG_aControlPageMap  [k] :=  {}
   _HMG_aControlValue  [k] :=  Nil
   _HMG_aControlInputMask  [k] :=  ""
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  ""
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor  [k] :=  Nil
   _HMG_aControlFontColor  [k] :=  Nil
   _HMG_aControlDblClick   [k] := ""
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow  [k] :=  y
   _HMG_aControlCol  [k] :=  x
   _HMG_aControlWidth   [k] := w
   _HMG_aControlHeight  [k] :=  h
   _HMG_aControlSpacing   [k] := 0
   _HMG_aControlContainerRow  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 )
   _HMG_aControlContainerCol  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 )
   _HMG_aControlPicture  [k] :=  ""
   _HMG_aControlContainerHandle  [k] :=  0
   _HMG_aControlFontName  [k] :=  ''
   _HMG_aControlFontSize  [k] :=  0
   _HMG_aControlFontAttributes  [k] :=  {.f.,.f.,.f.,.f.}
   _HMG_aControlToolTip   [k] :=  ''
   _HMG_aControlRangeMin  [k] :=   0
   _HMG_aControlRangeMax  [k] :=   0
   _HMG_aControlCaption  [k] :=   ''
   _HMG_aControlVisible  [k] :=   .t.
   _HMG_aControlHelpId  [k] :=   HelpId
   _HMG_aControlFontHandle  [k] :=   0
   _HMG_aControlBrushHandle  [k] :=   0
   _HMG_aControlEnabled  [k] :=   .T.
   _HMG_aControlMiscData1 [k] := 0

Return Nil
*-----------------------------------------------------------------------------*
Function PlayWave(wave,r,s,ns,l,nd)
*-----------------------------------------------------------------------------*
   if PCount() == 1
      r := .F.
      s := .F.
      ns := .F.
      l := .F.
      nd := .F.
   endif

   c_PlayWave(wave,r,s,ns,l,nd)
Return Nil
*-----------------------------------------------------------------------------*
Function PlayWaveFromResource(wave)
*-----------------------------------------------------------------------------*
   c_PlayWave(wave,.t.,.f.,.f.,.f.,.f.)
Return Nil
*-----------------------------------------------------------------------------*
function _PlayPlayer ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 1 )
Return Nil
*-----------------------------------------------------------------------------*
function _StopPlayer ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 2 )
Return Nil
*-----------------------------------------------------------------------------*
function _PausePlayer ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 3 )
Return Nil
*-----------------------------------------------------------------------------*
function _ClosePlayer ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 4 )
Return Nil
*-----------------------------------------------------------------------------*
function _DestroyPlayer ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 5 )
Return Nil
*-----------------------------------------------------------------------------*
function _EjectPlayer ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 6 )
Return Nil
*-----------------------------------------------------------------------------*
function _SetPlayerPositionEnd ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 7 )
Return Nil
*-----------------------------------------------------------------------------*
function _SetPlayerPositionHome ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 8 )
Return Nil
*-----------------------------------------------------------------------------*
function _OpenPlayer ( ControlName , ParentFormName, file )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 9, file )
Return Nil
*-----------------------------------------------------------------------------*
function _OpenPlayerDialog ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 10 )
Return Nil
*-----------------------------------------------------------------------------*
function _PlayPlayerReverse ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 11 )
Return Nil
*-----------------------------------------------------------------------------*
function _ResumePlayer ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 12 )
Return Nil
*-----------------------------------------------------------------------------*
function _SetPlayerRepeatOn ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 13 , .T. )
Return Nil
*-----------------------------------------------------------------------------*
function _SetPlayerRepeatOff ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 13 , .F. )
Return Nil
*-----------------------------------------------------------------------------*
function _SetPlayerSpeed ( ControlName , ParentFormName , speed )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , , 14 , speed )
Return Nil
*-----------------------------------------------------------------------------*
function _SetPlayerVolume ( ControlName , ParentFormName , volume )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 15 , volume )
Return Nil
*-----------------------------------------------------------------------------*
function _SetPlayerZoom ( ControlName , ParentFormName , zoom )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   mcifunc ( h , 16 , zoom )
Return Nil
*-----------------------------------------------------------------------------*
function _GetPlayerLength ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar, nMCILength
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   nMCILength := mcifunc ( h , 17 )
Return( nMCILength )
*-----------------------------------------------------------------------------*
function _GetPlayerPosition ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar, nMCIPosition
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   nMCIPosition := mcifunc ( h , 18 )
Return( nMCIPosition )
*-----------------------------------------------------------------------------*
Function _DefineAnimateBox( ControlName, ParentFormName, x, y, w, h, autoplay, center, transparent, file, HelpId, nId )
*-----------------------------------------------------------------------------*
   Local ParentFormHandle , blInit , ControlHandle , mVar , k , tooltip := '' , Style
   Local lDialogInMemory

   if _HMG_BeginWindowActive = TRUE .or. _HMG_BeginDialogActive = TRUE
      ParentFormName := if(_HMG_BeginDialogActive,_HMG_ActiveDialogName,_HMG_ActiveFormName)
   endif

   if _HMG_FrameLevel > 0
      x    := x + _HMG_ActiveFrameCol [_HMG_FrameLevel]
      y    := y + _HMG_ActiveFrameRow [_HMG_FrameLevel]
      ParentFormName := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
   EndIf
   lDialogInMemory := _HMG_DialogInMemory // ( GetWindowType ( ParentFormName ) == "L" )

   If .Not. _IsWindowDefined (ParentFormName) .and. .Not. lDialogInMemory
      MsgMiniGuiError("Window: "+ ParentFormName + " is not defined. Program terminated")
   Endif

   If _IsControlDefined (ControlName,ParentFormName) .and. .Not. lDialogInMemory
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentFormName + " Already defined. Program Terminated")
   endif

   mVar := '_' + ParentFormName + '_' + ControlName

   k := _GetControlFree()

   if _HMG_BeginDialogActive = TRUE
      ParentFormHandle = _HMG_ActiveDialogHandle

      style := WS_CHILD +WS_BORDER +WS_TABSTOP +WS_VISIBLE

      if lDialogInMemory         //Dialog Template

//          {{'ID',k/hwnd,class,Style,ExStyle,x,y,w,h,caption,HelpId,tooltip,font,size, bold, italic, underline, strikeout,blInit,.f.}}  --->_HMG_aDialogItems
         blInit:= {|x,y,z| InitDialogAnimateBox(x,y,z) }
         aadd(_HMG_aDialogItems,{nId,k,"SysAnimate32",style,0,x,y,w,h,"",HelpId,tooltip,"",0,,,,, blInit,_HMG_BeginTabActive,.f.,_HMG_ActiveTabPage })
/* JP 62
         if _HMG_aDialogTemplate[3]   // Modal
            _HMG_aControlDeleted [k] := .T.
            Return Nil
         endif
*/
      else

         ControlHandle := GetDialogItemHandle( ParentFormHandle, nId )
         SetWindowStyle ( ControlHandle, style )

         x := GetWindowCol ( Controlhandle )
         y := GetWindowRow ( Controlhandle )
         w := GetWindowWidth  ( Controlhandle )
         h := GetWindowHeight ( Controlhandle )

      endif

   else
      ParentFormHandle = GetFormHandle (ParentFormName)
      ControlHandle:=InitAnimate(ParentFormHandle,x,y,w,h,autoplay,center,transparent)

   endif

   if .Not. lDialogInMemory

      If _HMG_BeginTabActive = .T.
         aAdd ( _HMG_ActiveTabCurrentPageMap , ControlHandle )
      EndIf
   endif

   Public &mVar. := k

   _HMG_aControlType [k] := "ANIMATEBOX"
   _HMG_aControlNames  [k] :=  ControlName
   _HMG_aControlHandles  [k] :=  ControlHandle
   _HMG_aControlParentHandles   [k] := ParentFormHandle
   _HMG_aControlIds   [k] := nId
   _HMG_aControlProcedures  [k] :=  ""
   _HMG_aControlPageMap  [k] :=  {}
   _HMG_aControlValue  [k] :=  Nil
   _HMG_aControlInputMask  [k] :=  ""
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  ""
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor  [k] :=  Nil
   _HMG_aControlFontColor  [k] :=  Nil
   _HMG_aControlDblClick  [k] :=  ""
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow  [k] :=  y
   _HMG_aControlCol  [k] :=  x
   _HMG_aControlWidth   [k] := w
   _HMG_aControlHeight   [k] := h
   _HMG_aControlSpacing   [k] := 0
   _HMG_aControlContainerRow  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 )
   _HMG_aControlContainerCol  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 )
   _HMG_aControlPicture  [k] :=  ""
   _HMG_aControlContainerHandle   [k] := 0
   _HMG_aControlFontName  [k] :=  ''
   _HMG_aControlFontSize  [k] :=  0
   _HMG_aControlFontAttributes  [k] :=  {.f.,.f.,.f.,.f.}
   _HMG_aControlToolTip   [k] :=  ''
   _HMG_aControlRangeMin  [k] :=   0
   _HMG_aControlRangeMax  [k] :=   0
   _HMG_aControlCaption  [k] :=   file
   _HMG_aControlVisible  [k] :=   .t.
   _HMG_aControlHelpId  [k] :=   HelpId
   _HMG_aControlFontHandle   [k] :=  0
   _HMG_aControlBrushHandle  [k] :=   0
   _HMG_aControlEnabled  [k] :=  .T.
   _HMG_aControlMiscData1 [k] := 0

   if .Not. lDialogInMemory
      if valtype(file) <> 'U'
         _OpenAnimateBox ( ControlName , ParentFormName , File )
      EndIf
   endif

Return Nil

*-----------------------------------------------------------------------------*
Function InitDialogAnimateBox(ParentName, ControlHandle, k)
*-----------------------------------------------------------------------------*
   Local File
   File := _HMG_aControlCaption [k]
   if valtype(file) <> 'U' .and. valtype(ControlHandle) <> 'U'
      _OpenAnimateBox ( _HMG_aControlNames [k]  , ParentName , File )
   EndIf
// JP 62
   if len(_HMG_aDialogTemplate) != 0 .and. _HMG_aDialogTemplate[3]   // Modal
      _HMG_aControlDeleted [k] := .T.
   endif
Return Nil

*-----------------------------------------------------------------------------*
function _OpenAnimateBox ( ControlName , ParentFormName , FileName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   openanimate ( h , FileName )
Return Nil

*-----------------------------------------------------------------------------*
function _PlayAnimateBox ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   playanimate ( h )
Return Nil

*-----------------------------------------------------------------------------*
function _SeekAnimateBox ( ControlName , ParentFormName , Frame )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   seekanimate ( h , Frame )
Return Nil

*-----------------------------------------------------------------------------*
function _StopAnimateBox ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   stopanimate ( h )
Return Nil

*-----------------------------------------------------------------------------*
function _CloseAnimateBox ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   closeanimate ( h )
Return Nil

*-----------------------------------------------------------------------------*
function _DestroyAnimateBox ( ControlName , ParentFormName )
*-----------------------------------------------------------------------------*
   Local h , mVar
   mVar := '_' + ParentFormName + '_' + ControlName
   h := _HMG_aControlhandles [&mVar]
   destroyanimate ( h )
Return Nil