/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

*-----------------------------------------------------------------------------*
Procedure _DefineMainMenu ( Parent )
*-----------------------------------------------------------------------------*

   _HMG_xMenuType := 'MAIN'
   _HMG_xMainMenuHandle := 0
   _HMG_xMainMenuParentHandle := 0
   _HMG_xMenuPopupLevel := 0
   _HMG_xMainMenuParentName := ""

   if valtype(Parent) == 'U'
      Parent := _HMG_ActiveFormName
   Endif

   _HMG_xMainMenuParentHandle := GetFormHandle ( Parent )
   _HMG_xMainMenuParentName := Parent
   _HMG_xMainMenuHandle := CreateMenu()

Return

*-----------------------------------------------------------------------------*
Procedure _DefineMenuPopup ( Caption , Name )
*-----------------------------------------------------------------------------*
   Local mVar , k

   If _HMG_xMenuType $ 'MAIN,CONTEXT,NOTIFY'

      SWITCH Left( _HMG_xMenuType, 1 )

   CASE 'M'
      _HMG_xMenuPopupLevel ++

      _HMG_xMenuPopuphandle[ _HMG_xMenuPopupLevel ] := CreatePopupMenu( 1 )
      _HMG_xMenuPopupCaption[ _HMG_xMenuPopupLevel ] := Caption

      If _HMG_xMenuPopupLevel > 1

         AppendMenuPopup ( _HMG_xMenuPopuphandle[_HMG_xMenuPopupLevel - 1 ],;
            _HMG_xMenuPopuphandle[ _HMG_xMenuPopupLevel ],;
            _HMG_xMenuPopupCaption[ _HMG_xMenuPopupLevel ], 2 )
      EndIf
      EXIT

   CASE 'C'
   CASE 'N'
      k := iif( Left( _HMG_xMenuType, 1 ) == 'C', 3, 4 )
      _HMG_xContextPopupLevel ++

      _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ] := CreatePopupMenu( k )
      _HMG_xContextPopupCaption[ _HMG_xContextPopupLevel ] := Caption

      If _HMG_xContextPopupLevel > 1

         AppendMenuPopup ( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel - 1 ],;
            _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ],;
            _HMG_xContextPopupCaption[ _HMG_xContextPopupLevel ], k )
      Endif
   END

   If valtype (name) != 'U'

      mVar := '_' + Iif( _HMG_xMenuType == 'MAIN', _HMG_xMainMenuParentName, _HMG_xContextMenuParentName ) + '_' + Name

      k := _GetControlFree()

      Public &mVar. := k

      _HMG_aControlType [k] :=  "POPUP"
      _HMG_aControlNames  [k] :=  Name
      _HMG_aControlHandles  [k] :=  0
      _HMG_aControlIds  [k] :=  0
      _HMG_aControlProcedures [k] :=   Nil
      _HMG_aControlValue  [k] :=  Nil
      _HMG_aControlInputMask   [k] := ""
      _HMG_aControllostFocusProcedure  [k] :=  ""
      _HMG_aControlGotFocusProcedure  [k] :=  ""
      _HMG_aControlChangeProcedure  [k] :=  ""
      _HMG_aControlDeleted  [k] :=  .F.
      _HMG_aControlBkColor  [k] :=  Nil
      _HMG_aControlFontColor  [k] :=  Nil
      _HMG_aControlDblClick   [k] := ""
      _HMG_aControlHeadClick  [k] :=  {}
      _HMG_aControlRow  [k] :=  0
      _HMG_aControlCol  [k] :=  0
      _HMG_aControlWidth  [k] :=  0
      _HMG_aControlHeight  [k] :=  0
      _HMG_aControlContainerRow  [k] :=  -1
      _HMG_aControlContainerCol  [k] :=  -1
      _HMG_aControlPicture  [k] :=  ""
      _HMG_aControlContainerHandle  [k] :=  0
      _HMG_aControlFontName  [k] :=  ''
      _HMG_aControlFontSize  [k] :=  0
      _HMG_aControlFontAttributes  [k] :=  {.f.,.f.,.f.,.f.}
      _HMG_aControlToolTip   [k] :=  ''
      _HMG_aControlRangeMin   [k] :=  0
      _HMG_aControlRangeMax  [k] :=   0
      _HMG_aControlCaption  [k] :=   Caption
      _HMG_aControlVisible  [k] :=   .t.
      _HMG_aControlHelpId  [k] :=   0
      _HMG_aControlFontHandle   [k] :=  0
      _HMG_aControlBrushHandle  [k] :=   0
      _HMG_aControlEnabled  [k] :=   .T.
      _HMG_aControlMiscData1 [k] := 0

      If _HMG_xMenuType == 'MAIN'
         _HMG_aControlParentHandles[ k ]	:= _HMG_xMainMenuParentHandle
         _HMG_aControlPageMap[ k ]	:= _HMG_xMainMenuHandle
         _HMG_aControlSpacing[ k ]	:= _HMG_xMenuPopupHandle[ _HMG_xMenuPopupLevel ]
      Else
         _HMG_aControlParentHandles[ k ] := _HMG_xContextMenuParentHandle
         _HMG_aControlPageMap[ k ]       := _HMG_xContextMenuHandle
         _HMG_aControlSpacing[ k ]       := _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ]
      Endif

   EndIf

Else

   MsgMiniGuiError( "Menu type incorrect. Program Terminated." )

EndIf

Return

*-----------------------------------------------------------------------------*
Procedure _EndMenuPopup()
*-----------------------------------------------------------------------------*

   If _HMG_xMenuType == 'MAIN'

      _HMG_xMenuPopupLevel --

      If _HMG_xMenuPopupLevel == 0

         AppendMenuPopup( _HMG_xMainMenuHandle       ,;
            _HMG_xMenuPopupHandle[ 1 ] ,;
            _HMG_xMenuPopupCaption[ 1 ], 1 )
      EndIf

   ElseIf _HMG_xMenuType == 'CONTEXT' .or. _HMG_xMenuType == 'NOTIFY'

      _HMG_xContextPopupLevel --

      If _HMG_xContextPopupLevel == 0

         AppendMenuPopup( _HMG_xContextMenuHandle       ,;
            _HMG_xContextPopupHandle[ 1 ] ,;
            _HMG_xContextPopupCaption[ 1 ], Iif( Left( _HMG_xMenuType, 1 ) == 'C', 3, 4 ) )
      Endif

   Else

      MsgMiniGuiError( "Menu type incorrect. Program Terminated." )

   EndIf

Return

*-----------------------------------------------------------------------------*
Procedure _DefineMenuItem ( caption , action , name , Image , checked , disabled , cMessage, font, check_image )
*-----------------------------------------------------------------------------*
   Local Controlhandle , mVar , k , id

   If _HMG_xMenuType == 'MAIN'

      id := _GetId()

      Controlhandle := AppendMenuString( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , id , caption , 6 )

      If Valtype ( image ) != 'U'
         MenuItem_SetBitMaps ( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , id , image , '' )
      EndIf

      If Valtype ( check_image ) != 'U'
         MenuItem_SetCheckMarks( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , id , check_image, '' )
      EndIf

      If Valtype ( font ) != 'U'
         MenuItem_SetFont( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , id , font )
      EndIf

      k := _GetControlFree()

      If Valtype ( name ) == 'U'
#ifdef _ZEROPUBLIC_
         Name := 'DummyMenuName' + Ltrim( Str(k) )
         #else
         Name := ''
#endif
      EndIf
      If !Empty ( name )
         mVar := '_' + _HMG_xMainMenuParentName + '_' + Name
         Public &mVar. := k
      EndIf

      _HMG_aControlType [k] := "MENU"
      _HMG_aControlNames  [k] :=  Name
      _HMG_aControlHandles  [k] :=  Controlhandle
      _HMG_aControlParentHandles  [k] :=  _HMG_xMainMenuParentHandle
      _HMG_aControlIds  [k] :=  id
      _HMG_aControlProcedures  [k] :=  action
      _HMG_aControlPageMap  [k] :=  _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ]
      _HMG_aControlValue  [k] := cMessage
      _HMG_aControlInputMask  [k] :=  ""
      _HMG_aControllostFocusProcedure  [k] :=  ""
      _HMG_aControlGotFocusProcedure  [k] :=  ""
      _HMG_aControlChangeProcedure  [k] :=  ""
      _HMG_aControlDeleted  [k] :=  .F.
      _HMG_aControlBkColor  [k] :=  Nil
      _HMG_aControlFontColor [k] :=   Nil
      _HMG_aControlDblClick   [k] := ""
      _HMG_aControlHeadClick  [k] :=  {}
      _HMG_aControlRow  [k] :=  0
      _HMG_aControlCol   [k] := 0
      _HMG_aControlWidth  [k] :=  0
      _HMG_aControlHeight  [k] :=  0
      _HMG_aControlSpacing  [k] :=  0
      _HMG_aControlContainerRow  [k] :=  -1
      _HMG_aControlContainerCol  [k] :=  -1
      _HMG_aControlPicture  [k] :=  ""
      _HMG_aControlContainerHandle  [k] :=  0
      _HMG_aControlFontName  [k] :=  ''
      _HMG_aControlFontSize  [k] :=  0
      _HMG_aControlFontAttributes  [k] :=  {.f.,.f.,.f.,.f.}
      _HMG_aControlToolTip   [k] :=  ''
      _HMG_aControlRangeMin  [k] :=   0
      _HMG_aControlRangeMax   [k] :=  0
      _HMG_aControlCaption  [k] :=   Caption
      _HMG_aControlVisible  [k] :=   .t.
      _HMG_aControlHelpId  [k] :=   0
      _HMG_aControlFontHandle  [k] :=   0
      _HMG_aControlBrushHandle   [k] :=  0
      _HMG_aControlEnabled  [k] :=   .T.
      _HMG_aControlMiscData1 [k] := 0

      If checked == .t.
         xCheckMenuItem ( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , id )
      EndIf

      If disabled == .t.
         xDisableMenuItem ( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] , id )
      EndIf

   Else

      id := _GetId()

      If _HMG_xContextPopupLevel > 0
         ControlHandle := AppendMenuString( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id,  caption, 7 )
      Else
         ControlHandle := AppendMenuString( _HMG_xContextMenuHandle, id,  caption, 8 )
      Endif

      if Valtype ( image ) != 'U'
         If _HMG_xContextPopupLevel > 0
            MenuItem_SetBitMaps( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id, image , '' )
         Else
            MenuItem_SetBitMaps( _HMG_xContextMenuHandle, id, image , '' )
         Endif
      EndIf

      If Valtype ( check_image ) != 'U'
         If _HMG_xContextPopupLevel > 0
            MenuItem_SetCheckMarks( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id, check_image , '' )
         Else
            MenuItem_SetCheckMarks( _HMG_xContextMenuHandle, id, check_image , '' )
         Endif
      EndIf

      If Valtype ( font ) != 'U'
         If _HMG_xContextPopupLevel > 0
            MenuItem_SetFont( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id, font )
         Else
            MenuItem_SetFont( _HMG_xContextMenuHandle, id, font )
         Endif
      EndIf

      k := _GetControlFree()

      If Valtype ( name ) == 'U'
#ifdef _ZEROPUBLIC_
         Name := 'DummyMenuName' + Ltrim( Str(k) )
         #else
         Name := ''
#endif
      EndIf
      If !Empty ( name )
         mVar := '_' + _HMG_xContextMenuParentName + '_' + Name
         Public &mVar. := k
      EndIf

      _HMG_aControlType  [k] :=   "MENU"
      _HMG_aControlNames  [k] :=   Name
      _HMG_aControlHandles  [k] :=   Controlhandle
      _HMG_aControlParentHandles  [k] :=  _HMG_xContextMenuParentHandle
      _HMG_aControlIds  [k] :=   id
      _HMG_aControlProcedures  [k] :=   action
      _HMG_aControlPageMap  [k] :=   _HMG_xContextMenuHandle
      _HMG_aControlValue  [k] :=   cMessage
      _HMG_aControlInputMask   [k] :=  ""
      _HMG_aControllostFocusProcedure  [k] :=   ""
      _HMG_aControlGotFocusProcedure  [k] :=   ""
      _HMG_aControlChangeProcedure  [k] :=   ""
      _HMG_aControlDeleted  [k] :=   .F.
      _HMG_aControlBkColor  [k] :=   Nil
      _HMG_aControlFontColor  [k] :=   Nil
      _HMG_aControlDblClick  [k] :=   ""
      _HMG_aControlHeadClick  [k] :=   {}
      _HMG_aControlRow  [k] :=   0
      _HMG_aControlCol  [k] :=   0
      _HMG_aControlWidth  [k] :=   0
      _HMG_aControlHeight   [k] :=  0
      _HMG_aControlSpacing   [k] :=  0
      _HMG_aControlContainerRow  [k] :=   -1
      _HMG_aControlContainerCol  [k] :=   -1
      _HMG_aControlPicture  [k] :=   ""
      _HMG_aControlContainerHandle [k] :=    0
      _HMG_aControlFontName  [k] :=   ''
      _HMG_aControlFontSize  [k] :=   0
      _HMG_aControlFontAttributes  [k] :=   {.f.,.f.,.f.,.f.}
      _HMG_aControlToolTip   [k] :=   ''
      _HMG_aControlRangeMin   [k] :=   0
      _HMG_aControlRangeMax  [k] :=    0
      _HMG_aControlCaption  [k] :=    Caption
      _HMG_aControlVisible  [k] :=    .t.
      _HMG_aControlHelpId   [k] :=   0
      _HMG_aControlFontHandle  [k] :=   0
      _HMG_aControlBrushHandle  [k] :=    0
      _HMG_aControlEnabled  [k] :=    .T.
      _HMG_aControlMiscData1 [k] := 0

      if checked == .t.
         If _HMG_xContextPopupLevel > 0
            xCheckMenuItem( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id )
         Else
            xCheckMenuItem( _HMG_xContextMenuHandle, id )
         Endif
      EndIf

      if disabled == .t.
         If _HMG_xContextPopupLevel > 0
            xDisableMenuItem( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ], id )
         Else
            xDisableMenuItem( _HMG_xContextMenuHandle, id )
         Endif
      EndIf

   EndIf

Return

*-----------------------------------------------------------------------------*
Procedure _DefineSeparator ()
*-----------------------------------------------------------------------------*

   If _HMG_xMenuType == 'MAIN'

      AppendMenuSeparator ( _HMG_xMenuPopuphandle [_HMG_xMenuPopupLevel ] )
   Else

      If _HMG_xContextPopupLevel > 0

         AppendMenuSeparator ( _HMG_xContextPopupHandle[ _HMG_xContextPopupLevel ] )
      Else
         AppendMenuSeparator ( _HMG_xContextMenuHandle )
      Endif

   EndIf

Return

*-----------------------------------------------------------------------------*
Procedure _EndMenu()
*-----------------------------------------------------------------------------*
   Local i, j

   SWITCH Left( _HMG_xMenuType, 1 )

CASE 'M' // MAIN

   SetMenu( _HMG_xMainMenuParentHandle , _HMG_xMainMenuHandle )
   EXIT

CASE 'C' // CONTEXT

   i := GetFormIndex ( _HMG_xContextMenuParentName )
   _HMG_aFormContextMenuHandle [i] := _HMG_xContextMenuHandle
   EXIT

CASE 'N' // NOTIFY

   i := GetFormIndex ( _HMG_xContextMenuParentName )
   _HMG_aFormNotifyMenuHandle [i] := _HMG_xContextMenuHandle
   EXIT

CASE 'D' // DROPDOWN

   _HMG_aControlRangeMax [_HMG_xContextMenuButtonIndex] := _HMG_xContextMenuHandle
   EXIT

CASE 'O' // OWNCONTEXT

   IF VALTYPE( _HMG_xContextMenuButtonIndex ) == "A"

      FOR j:= 1 TO LEN(_HMG_xContextMenuButtonIndex)

         i := _HMG_aControlHandles[ _HMG_xContextMenuButtonIndex[j] ]
         IF VALTYPE(i) == "A"
            AEVAL( i , {|x| AADD( _HMG_aControlsContextMenu , { x , _HMG_xContextMenuHandle , _HMG_xContextMenuButtonIndex[j] , .T. } ) } )
         ELSE
            AADD( _HMG_aControlsContextMenu , { i, _HMG_xContextMenuHandle , _HMG_xContextMenuButtonIndex[j] , .T. } )
         ENDIF

      NEXT
   ELSE
      i := _HMG_aControlHandles[ _HMG_xContextMenuButtonIndex ]
      IF VALTYPE(i) == "A"
         AEVAL( i , {|x| AADD( _HMG_aControlsContextMenu , { x , _HMG_xContextMenuHandle , _HMG_xContextMenuButtonIndex , .T. } ) } )
      ELSE
         AADD( _HMG_aControlsContextMenu , { i, _HMG_xContextMenuHandle , _HMG_xContextMenuButtonIndex , .T. } )
      ENDIF

   ENDIF
END

Return

*-----------------------------------------------------------------------------*
Function _DisableMenuItem ( ItemName , FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aControlType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

   xDisableMenuItem ( h , i )

Return Nil

*-----------------------------------------------------------------------------*
Function _EnableMenuItem ( ItemName , FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aControlType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

   xEnableMenuItem ( h , i )

Return Nil

*-----------------------------------------------------------------------------*
Function _CheckMenuItem ( ItemName , FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aControlType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

   xCheckMenuItem ( h , i )

Return Nil

*-----------------------------------------------------------------------------*
Function _UncheckMenuItem ( ItemName , FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aCOntrolType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

   xUncheckMenuItem ( h , i )

Return Nil

*-----------------------------------------------------------------------------*
Function _IsMenuItemChecked ( ItemName , FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aCOntrolType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

Return xGetMenuCheckState ( h , i )

*-----------------------------------------------------------------------------*
Function _IsMenuItemEnabled ( ItemName , FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aCOntrolType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

Return xGetMenuEnabledState ( h , i )

*-----------------------------------------------------------------------------*
Procedure _DefineContextMenu ( Parent )
*-----------------------------------------------------------------------------*

   _HMG_xContextMenuHandle := 0
   _HMG_xContextMenuParentHandle := 0
   _HMG_xContextPopupLevel := 0
   _HMG_xContextMenuParentName := ""

   _HMG_xMenuType := 'CONTEXT'

   _HMG_xMenuPopupLevel := 0

   If valtype(Parent) == 'U'
      Parent := _HMG_ActiveFormName
   Endif

   _HMG_xContextMenuParentHandle := GetFormHandle ( Parent )
   _HMG_xContextMenuParentName := Parent
   _HMG_xContextMenuHandle := CreatePopupMenu( 3 )

Return

*-----------------------------------------------------------------------------*
Procedure _DefineNotifyMenu ( Parent )
*-----------------------------------------------------------------------------*

   _HMG_xContextMenuHandle := 0
   _HMG_xContextMenuParentHandle := 0
   _HMG_xContextPopupLevel := 0
   _HMG_xContextMenuParentName := ""

   _HMG_xMenuType := 'NOTIFY'

   _HMG_xMenuPopupLevel := 0

   If valtype(Parent) == 'U'
      Parent := _HMG_ActiveFormName
   Endif

   _HMG_xContextMenuParentHandle := GetFormHandle ( Parent )
   _HMG_xContextMenuParentName := Parent
   _HMG_xContextMenuHandle := CreatePopupMenu( 4 )

Return

*-----------------------------------------------------------------------------*
Procedure _DefineDropDownMenu ( Button , Parent )
*-----------------------------------------------------------------------------*

   _HMG_xContextMenuHandle := 0
   _HMG_xContextMenuParentHandle := 0
   _HMG_xContextPopupLevel := 0
   _HMG_xContextMenuParentName := ""

   _HMG_xMenuType := 'DROPDOWN'

   _HMG_xMenuPopupLevel := 0

   If valtype(Parent) == 'U'
      Parent := _HMG_ActiveFormName
   Endif

   _HMG_xContextMenuButtonIndex := GetControlIndex ( Button , Parent )
   _HMG_xContextMenuParentHandle := GetFormHandle ( Parent )
   _HMG_xContextMenuParentName := Parent
   _HMG_xContextMenuHandle := CreatePopupMenu( 5 )

Return

/*
   Added HMG Ex v.1.3 build 38
*/
*-----------------------------------------------------------------------------*
Procedure _DefineControlContextMenu ( Control , Parent )
*-----------------------------------------------------------------------------*
   LOCAL i

   _HMG_xContextMenuHandle := 0
   _HMG_xContextMenuParentHandle := 0
   _HMG_xContextPopupLevel := 0
   _HMG_xContextMenuParentName := ""

   _HMG_xMenuType := 'OWNCONTEXT'

   _HMG_xMenuPopupLevel := 0

   If valtype(Parent) == 'U'
      Parent := _HMG_ActiveFormName
   Endif

   If valtype(Control) == "A"
      _HMG_xContextMenuButtonIndex := {}
      For i:=1 To Len(Control)
         AADD( _HMG_xContextMenuButtonIndex , GetControlIndex( Control[i] , Parent ) )
      Next
   Else
      _HMG_xContextMenuButtonIndex := GetControlIndex ( Control , Parent )
   Endif

   _HMG_xContextMenuParentHandle := GetFormHandle ( Parent )
   _HMG_xContextMenuParentName := Parent
   _HMG_xContextMenuHandle := CreatePopupMenu( 5 )

Return

*-----------------------------------------------------------------------------*
Procedure _ShowControlContextMenu( Control , Parent , lShow )
*-----------------------------------------------------------------------------*
   LOCAL h := GetControlHandle ( Control, Parent )
   LOCAL i, j

   IF VALTYPE(h) == "A"
      FOR j:= 1 TO LEN(h)
         FOR i:= 1 TO LEN( _HMG_aControlsContextMenu )
            IF _HMG_aControlsContextMenu[i,1] == h[j]
               _HMG_aControlsContextMenu[i,4] := lShow
            ENDIF
         NEXT
      NEXT
   ELSE
      FOR i:= 1 TO LEN( _HMG_aControlsContextMenu )
         IF _HMG_aControlsContextMenu[i,1] == h
            _HMG_aControlsContextMenu[i,4] := lShow
         ENDIF
      NEXT
   ENDIF

Return

/*
   Added HMG Ex v.1.3 build 35
*/
*-----------------------------------------------------------------------------*
Function _GetMenuItemCaption ( ItemName , FormName )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aControlType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

Return xGetMenuCaption( h , i )

*-----------------------------------------------------------------------------*
Function _SetMenuItemCaption ( ItemName , FormName , Caption )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aControlType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

Return xSetMenuCaption( h , i , Caption )

*-----------------------------------------------------------------------------*
Function _SetMenuItemBitmap( ItemName , FormName , Bitmap )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aControlType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

Return MenuItem_SetBitMaps ( h, i , Bitmap , '' )

*-----------------------------------------------------------------------------*
Function _SetMenuItemFont( ItemName , FormName , Font )
*-----------------------------------------------------------------------------*
   Local i
   Local x := GetControlIndex ( ItemName , FormName )
   Local h := _HMG_aControlPageMap [ x ]

   If _HMG_aControlType [ x ] == "MENU"
      i := _HMG_aControlIds [ x ]
   ElseIf _HMG_aControlType [ x ] == "POPUP"
      i := _HMG_aControlSpacing [ x ]
   EndIf

Return MenuItem_SetFont ( h, i , Font )