/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

#define BM_GETCHECK   240
#define BM_SETCHECK   241
#define BST_UNCHECKED   0
#define BST_CHECKED   1
#define BS_NOTIFY           0x00004000
#define WS_CHILD            0x40000000
#define WS_VISIBLE          0x10000000
#define WS_TABSTOP          0x00010000
#define BS_AUTORADIOBUTTON    9
#define WS_GROUP    0x20000

*-----------------------------------------------------------------------------*
Function _DefineRadioGroup ( ControlName, ParentFormName, x, y, aOptions, Value,;
   fontname, fontsize, tooltip, change, width,;
   spacing, HelpId, invisible, notabstop, bold, italic, underline, strikeout,;
   backcolor , fontcolor , transparent , horizontal , leftjustify , aReadOnly , aId )
*-----------------------------------------------------------------------------*
   Local i , ParentFormHandle , blInit , mVar , BackCol , BackRow , k , Style
   Local aHandles[ 0 ], ControlHandle, FontHandle, aFont, n
   Local lDialogInMemory

   DEFAULT Width     TO 120
   DEFAULT Spacing   TO 25
   DEFAULT change    TO ""
   DEFAULT invisible TO FALSE
   DEFAULT notabstop TO FALSE
   DEFAULT horizontal TO FALSE
   DEFAULT leftjustify TO FALSE

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
      underline     := aFont[5]
      strikeout     := aFont[6]
   endif

   if _HMG_BeginWindowActive = TRUE .or. _HMG_BeginDialogActive = TRUE
      ParentFormName := if(_HMG_BeginDialogActive,_HMG_ActiveDialogName,_HMG_ActiveFormName)
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(FontName) == "U"
         FontName := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(FontSize) == "U"
         FontSize := _HMG_ActiveFontSize
      EndIf
   endif
   if _HMG_FrameLevel > 0
      x    := x + _HMG_ActiveFrameCol [_HMG_FrameLevel]
      y    := y + _HMG_ActiveFrameRow [_HMG_FrameLevel]
      ParentFormName := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
   EndIf
   lDialogInMemory := _HMG_DialogInMemory // ( GetWindowType ( ParentFormName ) == "L" )

   If .Not. _IsWindowDefined (ParentFormName)  .and. .Not. lDialogInMemory
      MsgMiniGuiError("Window: "+ ParentFormName + " is not defined. Program terminated")
   Endif

   If _IsControlDefined (ControlName,ParentFormName)  .and. .Not. lDialogInMemory
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentFormName + " Already defined. Program Terminated")
   endif

   If Valtype ( aReadOnly ) != 'A'
      aReadOnly := Array ( Len( aOptions ) )
      Afill ( aReadOnly, .F. )
   Endif

   mVar := '_' + ParentFormName + '_' + ControlName
   k := _GetControlFree()

   if _HMG_BeginDialogActive = TRUE
      ParentFormHandle = _HMG_ActiveDialogHandle

      Style := BS_NOTIFY + WS_CHILD + BS_AUTORADIOBUTTON + WS_GROUP
      if !notabstop
         Style += WS_TABSTOP
      endif

      if !invisible
         Style += WS_VISIBLE
      endif

      if lDialogInMemory         //Dialog Template

//          {{'ID',k/hwnd,class,Style,ExStyle,x,y,w,h,caption,HelpId,tooltip,font,size, bold, italic, underline, strikeout}}  --->_HMG_aDialogItems

         style :=BS_NOTIFY + WS_CHILD + BS_AUTORADIOBUTTON
         if !invisible
            Style += WS_VISIBLE
         endif
         aHandles :={0}

         BackCol := x
         BackRow := y

         For n:=1 to len(aId)

            blInit:= if(n==len(aId),{|x,y,z| InitDialogRadioGroup(x,y,z) },{|| Nil } )
            aadd(_HMG_aDialogItems,{aId[n],k,"button",style,0,x,y,width,spacing,aOptions[n],HelpId,tooltip,FontName,FontSize,bold,italic,underline,strikeout,blInit,_HMG_BeginTabActive,.f.,_HMG_ActiveTabPage })
            if horizontal
               x += Width + Spacing
            else
               y += Spacing
            endif
         next
/* JP 62
         if _HMG_aDialogTemplate[3]   // Modal
            _HMG_aControlDeleted [k] := .T.
            Return Nil
         endif
*/
      else

         ControlHandle := GetDialogItemHandle( ParentFormHandle, aId[1] )

         SetWindowStyle ( ControlHandle, Style )

         x := GetWindowCol ( Controlhandle )
         y := GetWindowRow ( Controlhandle )
         width := GetWindowWidth  ( Controlhandle )
         spacing := GetWindowHeight ( Controlhandle )

         for i = 1 to len (aId)

            ControlHandle := GetDialogItemHandle( ParentFormHandle, aId[i] )
            SetWindowStyle ( ControlHandle, BS_NOTIFY + WS_CHILD + BS_AUTORADIOBUTTON )

            if !invisible
               SetWindowStyle ( ControlHandle, WS_VISIBLE )
            endif

            if valtype(aOptions) == "A"
               if i <= len(aOptions)
                  SetWindowText ( ControlHandle , aOptions[i] )
               endif
            endif

            If FontHandle != 0
               _SetFontHandle(ControlHandle,FontHandle)
            Else
               if valtype(fontname) == "U"
                  Fontname := _HMG_DefaultFontName
               endif
               if valtype(fontsize) == "U"
                  FontSize := _HMG_DefaultFontSize
               endif
               FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
            endif

            aAdd ( aHandles , ControlHandle )

         next i

      endif

   else

      ParentFormHandle := GetFormHandle (ParentFormName)

      BackCol := x
      BackRow := y

      ControlHandle := InitRadioGroup ( ParentFormHandle, aOptions[1], 0, x, y , '' , 0 , width, invisible, notabstop , leftjustify )

      If FontHandle != 0
         _SetFontHandle(ControlHandle,FontHandle)
      Else
         if valtype(fontname) == "U"
            Fontname := _HMG_DefaultFontName
         endif
         if valtype(fontsize) == "U"
            FontSize := _HMG_DefaultFontSize
         endif
         FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
      endif

      aAdd ( aHandles , ControlHandle )

      for i = 2 to len (aOptions)
         if horizontal
            x += Width + Spacing
         else
            y += Spacing
         endif

         ControlHandle := InitRadioButton ( ParentFormHandle, aOptions[i], 0, x, y , '' , 0 , width, invisible , leftjustify )

         If FontHandle != 0
            _SetFontHandle(ControlHandle,FontHandle)
         Else
            if valtype(fontname) == "U"
               Fontname := _HMG_DefaultFontName
            endif
            if valtype(fontsize) == "U"
               FontSize := _HMG_DefaultFontSize
            endif
            FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
         endif

         aAdd ( aHandles , ControlHandle )

         if valtype(tooltip) != "U"
            SetToolTip ( aHandles [i] , tooltip , GetFormToolTipHandle (ParentFormName) )
         endif

      next i
   endif

   if .Not. lDialogInMemory

      If _HMG_BeginTabActive = .T.
         aAdd ( _HMG_ActiveTabCurrentPageMap , aHandles )
      EndIf

      if valtype(tooltip) != "U"
         SetToolTip ( aHandles [1] , tooltip , GetFormToolTipHandle (ParentFormName) )
      endif
   endif

   Public &mVar. := k

   _HMG_aControlType [k] := "RADIOGROUP"
   _HMG_aControlNames  [k] :=  ControlName
   _HMG_aControlHandles  [k] :=  aHandles
   _HMG_aControlParenthandles [k] :=   ParentFormHandle
   _HMG_aControlIds  [k] :=  aId
   _HMG_aControlProcedures  [k] :=  ""
   _HMG_aControlPageMap  [k] := aReadOnly
   _HMG_aControlValue  [k] :=  Value
   _HMG_aControlInputMask  [k] :=  transparent
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  change
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor [k] :=   backcolor
   _HMG_aControlFontColor  [k] :=  fontcolor
   _HMG_aControlDblClick  [k] :=  _HMG_ActiveTabButtons
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow  [k] :=  BackRow
   _HMG_aControlCol  [k] :=  BackCol
   _HMG_aControlWidth  [k] :=  Width
   _HMG_aControlHeight  [k] :=  if(horizontal, 28, Spacing * len (aOptions) )
   _HMG_aControlSpacing  [k] :=  Spacing
   _HMG_aControlContainerRow  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 )
   _HMG_aControlContainerCol  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 )
   _HMG_aControlPicture  [k] :=  .Not. NoTabStop
   _HMG_aControlContainerHandle  [k] :=  0
   _HMG_aControlFontName  [k] :=  fontname
   _HMG_aControlFontSize  [k] :=  fontsize
   _HMG_aControlFontAttributes  [k] :=  {bold,italic,underline,strikeout}
   _HMG_aControlToolTip  [k] :=   tooltip
   _HMG_aControlRangeMin  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveTabName , '' )
   _HMG_aControlRangeMax  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameParentFormName [_HMG_FrameLevel] , '' )
   _HMG_aControlCaption  [k] :=   aOptions
   _HMG_aControlVisible  [k] :=   if(invisible,FALSE,TRUE)
   _HMG_aControlHelpId  [k] :=   HelpId
   _HMG_aControlFontHandle  [k] :=   FontHandle
   _HMG_aControlBrushHandle  [k] := 0
   _HMG_aControlEnabled  [k] :=   .T.
   _HMG_aControlMiscData1 [k] := horizontal

   if .Not. lDialogInMemory
      if valtype (Value) <> 'U'
         SendMessage( aHandles [value] , BM_SETCHECK  , BST_CHECKED , 0 )
         if notabstop .and. IsTabStop(aHandles [value])
            SetTabStop( aHandles [value], .f. )
         endif
      EndIf
      _SetRadioGroupReadOnly ( ControlName , ParentFormName , aReadOnly )
   endif

Return Nil

*-----------------------------------------------------------------------------*
Function InitDialogRadioGroup(ParentName, ControlHandle, k)
*-----------------------------------------------------------------------------*
   Local aHandles , tabstop , Value

   Value := _HMG_aControlValue  [k]
   aHandles := _HMG_aControlHandles [k]
   tabstop := _HMG_aControlPicture  [k]

   if valtype (Value) <> 'U' .and. valtype(ParentName) <> 'U'
      ControlHandle := aHandles [value]
      SendMessage( ControlHandle , BM_SETCHECK  , BST_CHECKED , 0 )
      if .Not. tabstop .and. IsTabStop(ControlHandle)
         SetTabStop( ControlHandle, .f. )
      endif
   EndIf
   //JP V40
   if len(_HMG_aControlIds [k]) == Len(aHandles) .and. valtype(ParentName) <> 'U'
      _SetRadioGroupReadOnly ( _HMG_aControlNames [k] , ParentName , _HMG_aControlPageMap [k] )
   endif
// JP 62
   if len(_HMG_aDialogTemplate) != 0 .and. _HMG_aDialogTemplate[3]   // Modal
      _HMG_aControlDeleted [k] := .T.
   endif


Return Nil

*-----------------------------------------------------------------------------*
Procedure _SetRadioGroupReadOnly ( ControlName , ParentForm , aReadOnly )
*-----------------------------------------------------------------------------*
   Local z , aHandles , aOptions , lError := .F. , i := GetControlIndex ( ControlName , ParentForm )

   aHandles := _HMG_aControlHandles [i]
   aOptions := _HMG_aControlCaption [i]

   IF VALTYPE ( aReadOnly ) = 'A'
      IF LEN ( aReadOnly ) == LEN ( aOptions )
         FOR z := 1 TO LEN ( aReadOnly )
            IF VALTYPE ( aReadOnly [z] ) == 'L'
               IF aReadOnly [z] == .T.
                  DisableWindow ( aHandles [z] )
               ELSE
                  EnableWindow ( aHandles [z] )
               ENDIF
            ELSE
               lError := .T.
               EXIT
            ENDIF
         NEXT Z
      ELSE
         lError := .T.
      ENDIF
   ELSE
      lError := .T.
   ENDIF

   If .Not. lError
      _HMG_aControlPageMap [i] := aReadOnly
   EndIf

Return

*-----------------------------------------------------------------------------*
Function _GetRadioGroupReadOnly ( ControlName , ParentForm )
*-----------------------------------------------------------------------------*
   Local i := GetControlIndex ( ControlName , ParentForm )

Return _HMG_aControlPageMap [i]