/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

*-----------------------------------------------------------------------------*
Function _DefineRichEditBox ( ControlName, ParentForm, x, y, w, h, value,;
   fontname, fontsize, tooltip, maxlength, gotfocus,;
   change, lostfocus, readonly, break, HelpId,;
   invisible, notabstop , bold, italic, underline, strikeout ,;
   file , field , backcolor , fontcolor , plaintext , nohscroll ,;
   novscroll , select , vscroll)
*-----------------------------------------------------------------------------*
   Local i , cParentForm , mVar , ContainerHandle := 0 , k
   Local ControlHandle , FontHandle , WorkArea , aFont

   DEFAULT w         TO 120
   DEFAULT h         TO 240
   DEFAULT file      TO ""
   DEFAULT field     TO ""
   DEFAULT value     TO ""
   DEFAULT change    TO ""
   DEFAULT lostfocus TO ""
   DEFAULT gotfocus  TO ""
   DEFAULT maxlength TO 64738
   DEFAULT invisible TO FALSE
   DEFAULT notabstop TO FALSE
   DEFAULT nohscroll      TO FALSE
   DEFAULT plaintext TO FALSE

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
      underline     := aFont[5]
      strikeout     := aFont[6]
   endif

   If !Empty( Field )
      if  at ( '>', Field ) == 0
         MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentForm + " : You must specify a fully qualified field name. Program Terminated")
      Else
         WorkArea := Left ( Field , at ( '>', Field ) - 2 )
         If Select (WorkArea) != 0
            Value := &(Field)
         EndIf
      EndIf
   EndIf

   if _HMG_BeginWindowActive = .T.
      ParentForm := _HMG_ActiveFormName
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(FontName) == "U"
         FontName := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(FontSize) == "U"
         FontSize := _HMG_ActiveFontSize
      EndIf
   endif
   if _HMG_FrameLevel > 0
      x 	:= x + _HMG_ActiveFrameCol [_HMG_FrameLevel]
      y 	:= y + _HMG_ActiveFrameRow [_HMG_FrameLevel]
      ParentForm := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
   EndIf

   If .Not. _IsWindowDefined (ParentForm)
      MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated")
   Endif

   If _IsControlDefined (ControlName,ParentForm)
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program Terminated")
   endif

   mVar := '_' + ParentForm + '_' + ControlName

   cParentForm := ParentForm

   ParentForm = GetFormHandle (ParentForm)

   if valtype(x) == "U" .or. valtype(y) == "U"

      If _HMG_SplitLastControl == 'TOOLBAR'
         Break := .T.
      EndIf

      _HMG_SplitLastControl	:= 'RICHEDIT'

      i := GetFormIndex ( cParentForm )

      if i > 0

         ControlHandle := InitRichEditBox ( _HMG_aFormReBarHandle [i] , 0, x, y, w, h, '', 0 , maxlength , readonly, invisible, notabstop, nohscroll, novscroll )
         If FontHandle != 0
            _SetFontHandle(ControlHandle,FontHandle)
         Else
            if valtype(fontname) == "U"
               Fontname := _HMG_DefaultFontName
            endif
            if valtype(fontsize) == "U"
               FontSize := _HMG_DefaultFontSize
            endif
            FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
         EndIf

         AddSplitBoxItem ( Controlhandle , _HMG_aFormReBarHandle [i] , w , break , , , , _HMG_ActiveSplitBoxInverted )
         Containerhandle := _HMG_aFormReBarHandle [i]

         if len(value) > 0
            SetWindowText ( ControlHandle , value )
         endif

      EndIf

   Else

      ControlHandle := InitRichEditBox ( ParentForm, 0, x, y, w, h, '', 0 , maxlength , readonly, invisible, notabstop, nohscroll, novscroll )
      If FontHandle != 0
         _SetFontHandle(ControlHandle,FontHandle)
      Else
         if valtype(fontname) == "U"
            Fontname := _HMG_DefaultFontName
         endif
         if valtype(fontsize) == "U"
            FontSize := _HMG_DefaultFontSize
         endif
         FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
      EndIf
      SetFontRTF(ControlHandle, 0, FontName, FontSize, bold, italic, , underline, strikeout)

      if len(value) > 0
         SetWindowText ( ControlHandle , value )
      endif

   endif

   If _HMG_BeginTabActive = .T.
      aAdd ( _HMG_ActiveTabCurrentPageMap , Controlhandle )
   EndIf

   if valtype(tooltip) != "U"
      SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
   endif
   if valtype(backcolor) == "A"
      SetBkgndColor(ControlHandle, .t., backcolor[1], backcolor[2], backcolor[3])
   endif

   if File(file)
      StreamIn( ControlHandle, File, if(plaintext,1,2))
   else
      file := ""
   endif

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_aControlType [k] := "RICHEDIT"
   _HMG_aControlNames [k] :=   ControlName
   _HMG_aControlHandles  [k] :=  ControlHandle
   _HMG_aControlParenthandles [k] :=   ParentForm
   _HMG_aControlIds  [k] :=  0
   _HMG_aControlProcedures  [k] :=  vscroll
   _HMG_aControlPageMap  [k] := Field
   _HMG_aControlValue  [k] :=  Nil
   _HMG_aControlInputMask  [k] :=  ""
   _HMG_aControllostFocusProcedure  [k] :=  lostfocus
   _HMG_aControlGotFocusProcedure  [k] :=  gotfocus
   _HMG_aControlChangeProcedure [k] :=   change
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor  [k] :=  backcolor
   _HMG_aControlFontColor  [k] :=  fontcolor
   _HMG_aControlDblClick  [k] :=  select
   _HMG_aControlHeadClick   [k] := {}
   _HMG_aControlRow  [k] :=  y
   _HMG_aControlCol  [k] :=  x
   _HMG_aControlWidth   [k] := w
   _HMG_aControlHeight   [k] := h
   _HMG_aControlSpacing   [k] := 0
   _HMG_aControlContainerRow  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 )
   _HMG_aControlContainerCol  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 )
   _HMG_aControlPicture  [k] :=  ""
   _HMG_aControlContainerHandle [k] :=   ContainerHandle
   _HMG_aControlFontName  [k] :=  fontname
   _HMG_aControlFontSize  [k] :=  fontsize
   _HMG_aControlFontAttributes  [k] :=  {bold,italic,underline,strikeout}
   _HMG_aControlToolTip   [k] :=  tooltip
   _HMG_aControlRangeMin  [k] :=   0
   _HMG_aControlRangeMax  [k] :=   0
   _HMG_aControlCaption   [k] :=  file
   _HMG_aControlVisible  [k] :=   if(invisible,FALSE,TRUE)
   _HMG_aControlHelpId  [k] :=   HelpId
   _HMG_aControlFontHandle  [k] :=   FontHandle
   _HMG_aControlBrushHandle  [k] :=   0
   _HMG_aControlEnabled  [k] :=   .T.
   _HMG_aControlMiscData1 [k] := 0

Return Nil

*-----------------------------------------------------------------------------*
Procedure _DataRichEditBoxRefresh (i)
*-----------------------------------------------------------------------------*
   Local Field

   Field		:= _HMG_aControlPageMap [i]
   _SetValue ( '' , '' , &Field , i )

Return

// Modified by Kevin Carmody <i@kevincarmody.com> 2007.04.23
*-----------------------------------------------------------------------------*
Procedure _DataBaseRichEditBoxSave ( ControlName , ParentForm, typ )
*-----------------------------------------------------------------------------*
   Local Field, i, cTempFolder := GetTempFolder()
   Local cTempFile := If(Empty(cTempFolder), '', cTempFolder + '\') + '_richtemp.txt'

   i := GetControlIndex ( ControlName , ParentForm )	

   Field := _HMG_aControlPageMap [i]

   _DataRichEditBoxSave ( ControlName , ParentForm, cTempFile, typ )

   REPLACE &Field WITH MemoRead( cTempFile )

   FERASE( cTempFile )

Return

// Kevin Carmody <i@kevincarmody.com> 2007.04.23
// Set rich value of rich edit box.
*-----------------------------------------------------------------------------*
Function _DataRichEditBoxSetValue ( ControlName , ParentForm, cRichValue, typ )
*-----------------------------------------------------------------------------*
   Local cTempFolder := GetTempFolder()
   Local cTempFile := If(Empty(cTempFolder), '', cTempFolder + '\') + '_richtemp.txt'

   MemoWrit( cTempFile, cRichValue, .F. )

   _DataRichEditBoxOpen ( ControlName , ParentForm, cTempFile, typ )

   FERASE( cTempFile )

Return cRichValue

// Kevin Carmody <i@kevincarmody.com> 2007.04.23
// Get rich value of rich edit box.
*-----------------------------------------------------------------------------*
Function _DataRichEditBoxGetValue ( ControlName , ParentForm, typ )
*-----------------------------------------------------------------------------*
   Local cRichValue, cTempFolder := GetTempFolder()
   Local cTempFile := If(Empty(cTempFolder), '', cTempFolder + '\') + '_richtemp.txt'

   _DataRichEditBoxSave ( ControlName , ParentForm, cTempFile, typ )

   cRichValue := MemoRead( cTempFile )

   FERASE( cTempFile )

Return cRichValue

// Kevin Carmody <i@kevincarmody.com> 2007.04.23
// Get auto font attribute of rich edit box.
*-----------------------------------------------------------------------------*
Function _DataRichEditBoxGetAutoFont ( ControlName , ParentForm )
*-----------------------------------------------------------------------------*
   Local h := GetControlHandle ( ControlName , ParentForm )

Return GetAutoFontRTF( h )

// Kevin Carmody <i@kevincarmody.com> 2007.04.23
// Set auto font attribute of rich edit box.
*-----------------------------------------------------------------------------*
Procedure _DataRichEditBoxSetAutoFont ( ControlName , ParentForm, lAuto )
*-----------------------------------------------------------------------------*
   Local h := GetControlHandle ( ControlName , ParentForm )

   SetAutoFontRTF( h, lAuto )

Return

*-----------------------------------------------------------------------------*
Procedure _DataRichEditBoxOpen ( ControlName , ParentForm, cFile, typ )
*-----------------------------------------------------------------------------*
   Local i , h

   h := GetControlHandle (ControlName , ParentForm )

   i := GetControlIndex ( ControlName , ParentForm )	

   _HMG_aControlCaption [i] := cFile

   if valtype(typ) == "U"
      typ := 2
   endif

   StreamIn( h, cFile , typ )

Return

*-----------------------------------------------------------------------------*
Procedure _DataRichEditBoxSave ( ControlName , ParentForm, cFile , typ )
*-----------------------------------------------------------------------------*
   Local i , h

   h := GetControlHandle (ControlName , ParentForm )

   i := GetControlIndex ( ControlName , ParentForm )	

   if valtype(cFile) == "U"
      cFile := _HMG_aControlCaption [i]
   endif

   if valtype(typ) == "U"
      typ := 2
   endif

   StreamOut( h, cFile, typ )

Return