/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

*-----------------------------------------------------------------------------*
Function _BeginMessageBar( ControlName, ParentForm, kbd, fontname, fontsize, bold, italic, underline, strikeout )
*-----------------------------------------------------------------------------*
   Local mVar , k , hParentForm
   Local ControlHandle , FontHandle , aFont

   _HMG_ActiveMessageBarName  := ControlName

   if valtype (ParentForm) == 'U'
      ParentForm := _HMG_ActiveFormName
   EndIf

   If .Not. _IsWindowDefined (ParentForm)
      MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated")
   Endif

   If _IsControlDefined (ControlName,ParentForm)
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program Terminated")
   endif

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
      underline     := aFont[5]
      strikeout     := aFont[6]
   endif

   if _HMG_BeginWindowActive = .T.
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(FontName) == "U"
         FontName := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(FontSize) == "U"
         FontSize := _HMG_ActiveFontSize
      EndIf
   endif

   mVar := '_' + ParentForm + '_' + ControlName

   hParentForm := GetFormHandle (ParentForm)

   ControlHandle := InitMessageBar ( hParentForm, "", 0 )

   _HMG_ActiveStatusHandle := ControlHandle // New Public Value JP MDI

   If FontHandle != 0
      _SetFontHandle(ControlHandle,FontHandle)
   Else
      if valtype(fontname) == "U"
         Fontname := _HMG_DefaultFontName
      endif
      if valtype(fontsize) == "U"
         FontSize := _HMG_DefaultFontSize
      endif
      FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
   EndIf

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_aControlType [k] := "MESSAGEBAR"
   _HMG_aControlNames  [k] :=  ControlName
   _HMG_aControlHandles  [k] :=  ControlHandle
   _HMG_aControlParenthandles [k] :=  hParentForm
   _HMG_aControlIds  [k] :=  0
   _HMG_aControlProcedures  [k] :=  ''
   _HMG_aControlPageMap  [k] :=  {}
   _HMG_aControlValue  [k] :=  Nil
   _HMG_aControlInputMask  [k] :=  ""
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  ""
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor [k] :=   Nil
   _HMG_aControlFontColor  [k] :=  Nil
   _HMG_aControlDblClick  [k] :=  ""
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow   [k] := 0
   _HMG_aControlCol   [k] := 0
   _HMG_aControlWidth   [k] := 0
   _HMG_aControlHeight   [k] := 0
   _HMG_aControlSpacing   [k] := 0
   _HMG_aControlContainerRow  [k] :=  -1
   _HMG_aControlContainerCol  [k] :=  -1
   _HMG_aControlPicture  [k] :=  ""
   _HMG_aControlContainerHandle [k] :=   0
   _HMG_aControlFontName  [k] :=  fontname
   _HMG_aControlFontSize  [k] :=  fontsize
   _HMG_aControlFontAttributes  [k] :=  {bold,italic,underline,strikeout}
   _HMG_aControlToolTip   [k] :=  ''
   _HMG_aControlRangeMin  [k] :=   0
   _HMG_aControlRangeMax  [k] :=   0
   _HMG_aControlCaption  [k] :=   ''
   _HMG_aControlVisible  [k] :=   .t.
   _HMG_aControlHelpId  [k] :=   0
   _HMG_aControlFontHandle  [k] :=   FontHandle
   _HMG_aControlBrushHandle  [k] :=   0
   _HMG_aControlEnabled  [k] :=   .T.
   _HMG_aControlMiscData1 [k] := 0

   _HMG_StatusItemCount := 0

   if kbd
      _SetStatusBarKbd ( ControlName, ParentForm )
   endif

Return Nil
*-----------------------------------------------------------------------------*
Function _EndMessageBar()
*-----------------------------------------------------------------------------*
	// JD 07/20/2007
	// Must have at least one StatusItem to prevent crash when:
	// Function Events(...) receives WM_SIZE message.
   if _HMG_StatusItemCount == 0
      _DefineItemMessage( "StatusItem", _HMG_ActiveMessageBarName, 0, 0, GetProperty(_HMG_ActiveFormName, "Title"),,, 0,,,, .F. )
   endif
   _HMG_ActiveMessageBarName 		:= ""
   _HMG_StatusItemCount			:= 0

Return Nil
*-----------------------------------------------------------------------------*
Function _DefineItemMessage ( ControlName, ParentControl, x, y, Caption, ProcedureName, w, h, icon, cstyl, tooltip, default )
*-----------------------------------------------------------------------------*
   Local i , cParentForm , mVar , ParentForm , hParentForm, styl , k
   Local ControlHandle , cCaption

   if _HMG_BeginWindowActive = .T.
      ParentForm := _HMG_ActiveFormName
   endif
   If .Not. _IsWindowDefined (ParentForm)
      MsgMiniGuiError( "Window: "+ ParentForm + " is not defined. Program terminated" )
   Endif

   if valtype (ParentControl) == 'U'
      ParentControl := _HMG_ActiveMessageBarName
   EndIf

   cParentForm := ParentForm
   hParentForm := GetFormHandle ( ParentForm )

   mVar := '_' + ParentForm + '_' + ControlName

   ParentForm = GetControlHandle (ParentControl,ParentForm)

   if valtype(w) == "U"
      w := Max( 70, GetTextWidth( NIL, Caption, _HMG_aControlFontHandle[ GetControlIndex( "StatusBar", cParentForm ) ] ) + 6 )
   endif

   if valtype(h) == "U"
      h := 0
   endif

   if valtype(cStyl) == "U"
      cStyl := ""
   endif

   styl := IF(Upper(cStyl) == "RAISED", 1, IF(Upper(cStyl) == "FLAT", 2, 0))

   cCaption := Upper ( Caption )

   i := at ( '&' , cCaption )

   If i > 0
      _DefineLetterOrDigitHotKey ( cCaption, i, cParentForm, ProcedureName )
   EndIf

   Caption := StrTran ( Caption, '&', '' )

   if valtype(default) == "U"
      default := .F.
   endif

   if default
      _HMG_DefaultStatusBarMessage := Caption
   endif

   _HMG_StatusItemCount++

   If _HMG_StatusItemCount == 1
      ControlHandle := InitItemBar ( ParentForm, Caption, 0, 0, 0, Icon, ToolTip, styl )
   Else
      ControlHandle := InitItemBar ( ParentForm, Caption, 0, w, 1, Icon, ToolTip, styl )
   EndIf

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_aControlType [k] :=  "ITEMMESSAGE"
   _HMG_aControlNames  [k] :=  ControlName
   _HMG_aControlHandles  [k] :=  ControlHandle
   _HMG_aControlParenthandles [k] :=   hParentForm
   _HMG_aControlIds [k] :=   0
   _HMG_aControlProcedures  [k] :=  ProcedureName
   _HMG_aControlPageMap   [k] := {}
   _HMG_aControlValue  [k] :=  Nil
   _HMG_aControlInputMask  [k] :=  ""
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  ""
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor [k] :=   Nil
   _HMG_aControlFontColor [k] :=   Nil
   _HMG_aControlDblClick  [k] :=  ""
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow  [k] :=  y
   _HMG_aControlCol   [k] := x
   _HMG_aControlWidth  [k] :=  w
   _HMG_aControlHeight   [k] := h
   _HMG_aControlSpacing   [k] := 0
   _HMG_aControlContainerRow  [k] :=  -1
   _HMG_aControlContainerCol [k] :=   -1
   _HMG_aControlPicture  [k] :=  ""
   _HMG_aControlContainerHandle  [k] :=  ParentForm
   _HMG_aControlFontName  [k] :=  ''
   _HMG_aControlFontSize  [k] :=  0
   _HMG_aControlFontAttributes  [k] :=  {.f.,.f.,.f.,.f.}
   _HMG_aControlToolTip  [k] :=   ToolTip
   _HMG_aControlRangeMin  [k] :=   0
   _HMG_aControlRangeMax  [k] :=   0
   _HMG_aControlCaption  [k] :=   Caption
   _HMG_aControlVisible  [k] :=   .t.
   _HMG_aControlHelpId   [k] :=  0
   _HMG_aControlFontHandle   [k] :=  0
   _HMG_aControlBrushHandle  [k] :=   0
   _HMG_aControlEnabled  [k] :=   .T.
   _HMG_aControlMiscData1 [k] := 0

Return ControlHandle

*-----------------------------------------------------------------------------*
Function _SetStatusClock ( BarName , FormName , Width , ToolTip , Action , lAMPM )
*-----------------------------------------------------------------------------*
   Local nrItem

   If ValType( lAMPM ) != "L"
      lAMPM := .F.
   EndIf
   If ValType (Width) == 'U'
      Width := IF(lAMPM, 92, 70)
   EndIf
   If ValType (ToolTip) == 'U'
      ToolTip := ''
   EndIf
   If ValType (Action) == 'U'
      Action := ''
   EndIf

   nrItem := _DefineItemMessage ( "TimerBar", BarName, 0, 0, IF(lAMPM, AMPM( Time() ), Time()), Action , Width, 0, "" , ToolTip )

   If lAMPM
      _DefineTimer ( 'StatusTimer' , FormName , 1000 , {|| _SetItem ( BarName , FormName , nrItem , AMPM( Time() ) ) } )
   Else
      _DefineTimer ( 'StatusTimer' , FormName , 1000 , {|| _SetItem ( BarName , FormName , nrItem , Time() ) } )
   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _SetStatusKeybrd ( BarName , FormName , Width , ToolTip , action )
*-----------------------------------------------------------------------------*
   Local nrItem1 , nrItem2 , nrItem3

   If ValType (Width) == 'U'
      Width := 75
   EndIf
   If ValType (ToolTip) == 'U'
      ToolTip := ''
   EndIf
   If ValType (Action) == 'U'
      Action := ''
   EndIf

   nrItem1 := _DefineItemMessage( "TimerNum", BarName, 0, 0, "NumLock",;
      IF( Empty(Action), {|| If( _HMG_IsXPorLater, KeyToggleNT( VK_NUMLOCK ), KeyToggle( VK_NUMLOCK ) ) }, Action ), Width + 20, 0,;
      IF( IsNumLockActive(), "zzz_led_on", "zzz_led_off" ), "", ToolTip )

   nrItem2 := _DefineItemMessage( "TimerCaps", BarName, 0, 0, "CapsLock",;
      IF( Empty(Action), {|| If( _HMG_IsXPorLater, KeyToggleNT( VK_CAPITAL ), KeyToggle( VK_CAPITAL ) ) }, Action ), Width + 25, 0,;
      IF( IsCapsLockActive(), "zzz_led_on", "zzz_led_off" ), "", ToolTip )

   nrItem3 := _DefineItemMessage( "TimerInsert", BarName, 0, 0, "Insert",;
      IF( Empty(Action), {|| If( _HMG_IsXPorLater, KeyToggleNT( VK_INSERT ), KeyToggle( VK_INSERT ) ) }, Action ), Width, 0,;
      IF( IsInsertActive(), "zzz_led_on", "zzz_led_off" ), "", ToolTip )

   _DefineTimer ( 'StatusKeyBrd' , FormName , 250 ,;
      {|| _SetStatusIcon ( BarName , FormName , nrItem1 , if ( IsNumLockActive() , "zzz_led_on" , "zzz_led_off" ) ),;
      _SetStatusIcon ( BarName , FormName , nrItem2 , if ( IsCapsLockActive() , "zzz_led_on" , "zzz_led_off" ) ),;
      _SetStatusIcon ( BarName , FormName , nrItem3 , if ( IsInsertActive() , "zzz_led_on" , "zzz_led_off" ) ) } )

Return Nil

// (JK) HMG 1.1 Experimental Build 12
*-----------------------------------------------------------------------------*
Function _GetDefinedStatusBarItemValue( ParentHandle , ItemID )
*-----------------------------------------------------------------------------*
   Local nStart := aScan( _HMG_aControlParenthandles, ParentHandle ), nLocID := 0, in

   IF EMPTY(ItemID) .or. ItemID == NIL
      ItemID := 1
   ENDIF

   for in = nStart to LEN( _HMG_aControlParenthandles )

      if  _HMG_aControlType[in]== "ITEMMESSAGE" .and. _HMG_aControlParenthandles [in] == ParentHandle
         nLocID ++
         If nLocID == ItemID
            Return (_HMG_aControlCaption [in])
         endif
      endif

   next in

Return ""

// (GF) HMG 1.2 Extended Build 25
*-----------------------------------------------------------------------------*
Function AMPM( cTime )
*-----------------------------------------------------------------------------*

   IF VAL( cTime ) == 0
      cTime := "12" + SUBSTR( cTime, 3 ) + " am"

   ELSEIF VAL( cTime ) < 12
      cTime += " am"

   ELSEIF VAL( cTime ) == 12
      cTime += " pm"

   ELSEIF VAL( cTime ) == 24
      cTime := "12" + SUBSTR( cTime, 3 ) + " am"

   ELSE
      cTime := STRZERO( VAL( cTime ) - 12, 2 ) + SUBSTR( cTime, 3 ) + " pm"

   ENDIF

RETURN cTime

// (GF) HMG 1.2 Extended Build 30
*-----------------------------------------------------------------------------*
Function _SetStatusBarKbd ( BarName , FormName )
*-----------------------------------------------------------------------------*

   _DefineItemMessage( "StatusItem", BarName, 0, 0, GetProperty(FormName, "Title"),,, 0,,,, .F. )

   _DefineItemMessage( "StatusItem", BarName, 0, 0, IF(IsCapsLockActive(), "CAP", ""),, 38 - IF(IsXPThemeActive(), 0, 2), 0,,,, .F. )

   _DefineItemMessage( "StatusItem", BarName, 0, 0, IF(IsNumLockActive(), "NUM", ""),, 42, 0,,,, .F. )

   _DefineItemMessage( "StatusItem", BarName, 0, 0, IF(IsScrollLockActive(), "SCRL", ""),, 44, 0,,,, .F. )

   _DefineTimer ( 'StatusBarKbd' , FormName , 250 ,;
      {|| _SetItem ( BarName, FormName, 2, IF(IsCapsLockActive(), "CAP", "") ),;
      _SetItem ( BarName, FormName, 3, IF(IsNumLockActive(), "NUM", "") ),;
      _SetItem ( BarName, FormName, 4, IF(IsScrollLockActive(), "SCRL", "") ) } )

Return Nil

*-----------------------------------------------------------------------------*
Function _GetStatusItemWidth( hWnd, nItem )
*-----------------------------------------------------------------------------*
   Local i, ControlCount, aItemWidth := {}

   ControlCount := Len ( _HMG_aControlHandles )

   For i := 1 To ControlCount
      if _HMG_aControlType [i] == "ITEMMESSAGE" .And. _HMG_aControlParentHandles [i] == hWnd
         aadd( aItemWidth, _HMG_aControlWidth [i] )
      endif
   Next i

Return IF( Pcount() > 1, aItemWidth[nItem], aItemWidth )

*-----------------------------------------------------------------------------*
Function _SetStatusItemWidth( nItem, nNewSize, hWnd )
*-----------------------------------------------------------------------------*
   Local i, ControlCount, nIndex := 0

   ControlCount := Len (_HMG_aControlHandles)

   For i := 1 To ControlCount
      if _HMG_aControlType [i] == "ITEMMESSAGE" .And. _HMG_aControlParentHandles [i] == hWnd
         nIndex++
         if nIndex == nItem
            _HMG_aControlWidth [i] := nNewSize
            Exit
         endif
      endif
   Next i

Return Nil

*-----------------------------------------------------------------------------*
Function _SetStatusItemAction( nItem, bAction, hWnd )
*-----------------------------------------------------------------------------*
   Local i, ControlCount, nIndex := 0

   ControlCount := Len (_HMG_aControlHandles)

   For i := 1 To ControlCount
      if _HMG_aControlType [i] == "ITEMMESSAGE" .And. _HMG_aControlParentHandles [i] == hWnd
         nIndex++
         if nIndex == nItem
            _HMG_aControlProcedures [i] := bAction
            Exit
         endif
      endif
   Next i

Return Nil