/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

#define WS_TABSTOP          0x00010000
#define WS_VISIBLE          0x10000000
#define WS_CHILD            0x40000000
#define TCS_FLATBUTTONS         0x0008
#define TCS_HOTTRACK            0x0040
#define TCS_VERTICAL            0x0080
#define TCS_BUTTONS             0x0100
#define TCS_MULTILINE           0x0200

STATIC lDialogInMemory := .f.
*-----------------------------------------------------------------------------*
Function _BeginTab( ControlName , ParentFormName , row , col , w , h , value , f , s , tooltip , change , buttons , flat , hottrack , vertical , bottom , notabstop , bold, italic, underline, strikeout, multiline , backcolor, nId )
*-----------------------------------------------------------------------------*
   Local aMnemonic := {}

   DEFAULT change       TO ""
   DEFAULT buttons      TO FALSE
   DEFAULT Flat         TO FALSE
   DEFAULT HotTrack     TO FALSE
   DEFAULT Vertical     TO FALSE
   DEFAULT Bottom       TO FALSE
   DEFAULT notabstop    TO FALSE
   DEFAULT multiline    TO FALSE

   If _HMG_BeginTabActive == .T.
      MsgMiniGuiError("DEFINE TAB Structures can't be nested. Program terminated")
   EndIf

   if _HMG_BeginWindowActive == TRUE .or. _HMG_BeginDialogActive == TRUE
      ParentFormName := if(_HMG_BeginDialogActive,_HMG_ActiveDialogName,_HMG_ActiveFormName)
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(F) == "U"
         F := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(S) == "U"
         S := _HMG_ActiveFontSize
      EndIf
   endif

   if _HMG_FrameLevel > 0
      col   := col + _HMG_ActiveFrameCol [_HMG_FrameLevel]
      row   := row + _HMG_ActiveFrameRow [_HMG_FrameLevel]
      ParentFormName := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
   EndIf
   lDialogInMemory := _HMG_DialogInMemory // ( GetWindowType ( ParentFormName ) == "L" )

   if valtype (ParentFormName) == 'U'
      ParentFormName := _HMG_ActiveFormName
   EndIf

   if valtype (value) == 'U' .or. value < 1
      value := 1
   EndIf

   _HMG_FrameLevel++

   _HMG_ActiveFrameParentFormName [_HMG_FrameLevel] := ParentFormName
   _HMG_ActiveFrameRow [_HMG_FrameLevel] := row
   _HMG_ActiveFrameCol [_HMG_FrameLevel] := col
   _HMG_BeginTabActive         := .T.
   _HMG_ActiveTabPage         := 0
   _HMG_ActiveTabFullPageMap      := {}
   _HMG_ActiveTabCaptions      := {}
   _HMG_ActiveTabImages      := {}
   _HMG_ActiveTabCurrentPageMap   := {}
   _HMG_ActiveTabName         := ControlName
   _HMG_ActiveTabParentFormName   := ParentFormName
   _HMG_ActiveTabRow         := row
   _HMG_ActiveTabCol         := col
   _HMG_ActiveTabWidth         := w
   _HMG_ActiveTabHeight      := h
   _HMG_ActiveTabValue         := value
   _HMG_ActiveTabFontName      := f
   _HMG_ActiveTabFontSize      := s
   _HMG_ActiveTabToolTip      := tooltip
   _HMG_ActiveTabChangeProcedure   := change
   _HMG_ActiveTabColor         := backcolor
   _HMG_ActiveTabnId         := nId

   _HMG_ActiveTabButtons      := Buttons
   _HMG_ActiveTabFlat         := Flat
   _HMG_ActiveTabHotTrack      := HotTrack
   _HMG_ActiveTabVertical      := Vertical
   _HMG_ActiveTabBottom      := Bottom
   _HMG_ActiveTabNoTabStop      := NotabStop
   _HMG_ActiveTabMultiline      := Multiline

   _HMG_ActiveTabBold         := Bold
   _HMG_ActiveTabItalic      := Italic
   _HMG_ActiveTabUnderline      := Underline
   _HMG_ActiveTabStrikeout      := Strikeout


   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 1 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 2 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 3 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 4 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 5 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 6 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 7 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 8 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 9 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 10 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 11 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 12 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 13 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 14 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 15 ) } )
   aAdd ( aMnemonic , {|| _SetValue ( ControlName , ParentFormName , 16 ) } )

   _HMG_ActiveTabMnemonic := aMnemonic

Return Nil

*-----------------------------------------------------------------------------*
Function _DefineTab ( ControlName, ParentFormName, x, y, w, h, aCaptions, aPageMap, value, fontname, fontsize, tooltip, change, Buttons, Flat, HotTrack, Vertical, Bottom, notabstop, aMnemonic, bold, italic, underline, strikeout, Images, multiline, backcolor, nId )
*-----------------------------------------------------------------------------*
   Local ParentFormHandle, mVar, ImageFlag := .F., k, Style
   Local ControlHandle, FontHandle, aFont, blInit, hBrush := 0

   DEFAULT Flat         TO FALSE
   DEFAULT HotTrack     TO FALSE
   DEFAULT Vertical     TO FALSE
   DEFAULT Bottom       TO FALSE
   DEFAULT notabstop    TO FALSE
   DEFAULT Buttons      TO FALSE

   If .Not. _IsWindowDefined (ParentFormName) .and. .Not. lDialogInMemory
      MsgMiniGuiError("Window: "+ ParentFormName + " is not defined. Program terminated")
   Endif

   If _IsControlDefined (ControlName,ParentFormName) .and. .Not. lDialogInMemory
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentFormName + " Already defined. Program Terminated")
   endif

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
      underline     := aFont[5]
      strikeout     := aFont[6]
   endif

   For k := 1 To Len (Images)

        // JD 11/05/2006
      If ValType (Images[k]) == "C" .and. !Empty(Images[k])
         ImageFlag := .T.
         Exit
      EndIf

   Next k

   if valtype(change) == "U"
      change := ""
   endif

   if IsXpThemeActive() .and. buttons == .f.
      vertical := .f.
   endif

   mVar := '_' + ParentFormName + '_' + ControlName
   k := _GetControlFree()

   if _HMG_BeginDialogActive = TRUE
      ParentFormHandle = _HMG_ActiveDialogHandle

      Style :=  WS_CHILD + WS_VISIBLE

      if Buttons
         Style += TCS_BUTTONS
      endif
      if  Flat
         Style += TCS_FLATBUTTONS
      endif
      if HotTrack
         Style += TCS_HOTTRACK
      endif
      if  Vertical
         Style += TCS_VERTICAL
      endif
      if  Multiline
         Style += TCS_MULTILINE
      endif
      if  !notabstop
         Style += WS_TABSTOP
      endif

      nId := _HMG_ActiveTabnId

      if len(_HMG_aDialogTemplate) > 0        //Dialog Template

//          {{'ID',k/hwnd,class,Style,ExStyle,x,y,w,h,caption,HelpId,tooltip,font,size, bold, italic, underline, strikeout}}  --->_HMG_aDialogItems
         blInit:= {|x,y,z| InitDialogTab(x,y,z) }
         aadd(_HMG_aDialogItems,{_HMG_ActiveTabnId,k,"SysTabControl32",style,0,;
            _HMG_ActiveTabCol,_HMG_ActiveTabRow,_HMG_ActiveTabWidth,_HMG_ActiveTabHeight,"",;
            0,_HMG_ActiveTabToolTip,_HMG_ActiveTabFontName,_HMG_ActiveTabFontSize,;
            _HMG_ActiveTabBold,_HMG_ActiveTabItalic,_HMG_ActiveTabUnderline,_HMG_ActiveTabStrikeout,blInit,_HMG_BeginTabActive,.f.,_HMG_ActiveTabPage })

/* JP 62
         if _HMG_aDialogTemplate[3]   // Modal
            _HMG_aControlDeleted [k] := .T.
            Return Nil
         endif
*/
      else

         ControlHandle := GetDialogItemHandle( ParentFormHandle, nId )

         SetWindowStyle ( ControlHandle, Style )

         x := GetWindowCol ( Controlhandle )
         y := GetWindowRow ( Controlhandle )
         w := GetWindowWidth  ( Controlhandle )
         h := GetWindowHeight ( Controlhandle )

      endif

   else

      ParentFormHandle = GetFormHandle (ParentFormName)

      ControlHandle = InitTabControl ( ParentFormHandle, 0, x, y, w, h, aCaptions, value, '', 0 , Buttons , Flat , HotTrack , Vertical , Bottom , Multiline , ISARRAY(backcolor), notabstop )
      IF ISARRAY(backcolor)
         hBrush := CreateSolidBrush( backcolor[1], backcolor[2], backcolor[3] )
         SetWindowBrush( ControlHandle, hBrush )
      ENDIF
   endif

   if .Not. lDialogInMemory

      If FontHandle != 0
         _SetFontHandle(ControlHandle,FontHandle)
      Else
         if valtype(fontname) == "U"
            Fontname := _HMG_DefaultFontName
         endif
         if valtype(fontsize) == "U"
            FontSize := _HMG_DefaultFontSize
         endif
         FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
      EndIf

      if valtype(tooltip) != "U"
         SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (ParentFormName) )
      endif

   endif

   Public &mVar. := k

   _HMG_aControlType [k] := "TAB"
   _HMG_aControlNames [k] :=   ControlName
   _HMG_aControlParenthandles [k] :=   ParentFormHandle
   _HMG_aControlHandles [k] :=   Controlhandle
   _HMG_aControlIds  [k] :=  nId
   _HMG_aControlPageMap  [k] :=  aPageMap
   _HMG_aControlProcedures  [k] :=  ""
   _HMG_aControlValue  [k] :=  Value
   _HMG_aControlInputMask  [k] :=  0
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  change
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor  [k] :=  backcolor
   _HMG_aControlFontColor  [k] :=  Nil
   _HMG_aControlDblClick  [k] :=  ""
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow  [k] :=  y
   _HMG_aControlCol  [k] :=  x
   _HMG_aControlWidth  [k] :=  w
   _HMG_aControlHeight   [k] := h
   _HMG_aControlSpacing  [k] :=  0
   _HMG_aControlContainerRow  [k] :=  -1
   _HMG_aControlContainerCol  [k] :=  -1
   _HMG_aControlPicture  [k] :=  Images
   _HMG_aControlContainerHandle  [k] :=  0
   _HMG_aControlFontName  [k] :=  fontname
   _HMG_aControlFontSize  [k] :=  fontsize
   _HMG_aControlFontAttributes  [k] :=  {bold,italic,underline,strikeout}
   _HMG_aControlToolTip   [k] :=  tooltip
   _HMG_aControlRangeMin   [k] :=  0
   _HMG_aControlRangeMax   [k] :=  0
   _HMG_aControlCaption   [k] :=  aCaptions
   _HMG_aControlVisible  [k] :=   .t.
   _HMG_aControlHelpId  [k] :=   0
   _HMG_aControlFontHandle   [k] :=  FontHandle
   _HMG_aControlBrushHandle    [k] := hBrush
   _HMG_aControlEnabled   [k] :=  .T.
   _HMG_aControlMiscData1 [k] := {0, ImageFlag, aMnemonic }

   if len(_HMG_aDialogTemplate) == 0   //Dialog Template
      InitDialogTab(ParentFormName, ControlHandle, k)
   endif

Return Nil

*-----------------------------------------------------------------------------*
Function InitDialogTab(ParentName, ControlHandle, k)
*-----------------------------------------------------------------------------*
   Local aCaptions, ImageFlag, Caption, r, c, z, i, aMnemonic

   ImageFlag := _HMG_aControlMiscData1 [k,2]
   aMnemonic := _HMG_aControlMiscData1 [k,3]
   aCaptions := _HMG_aControlCaption   [k]

   if len(_HMG_ActiveTabFullPageMap) < len(aCaptions)
      aAdd ( _HMG_ActiveTabFullPageMap , {} )
   endif

   _HMG_aControlPageMap [k] := _HMG_ActiveTabFullPageMap

   if _HMG_BeginDialogActive == TRUE
      AddDialogPages( ControlHandle, aCaptions, _HMG_aControlValue [k] )
   endif

   If ImageFlag == .T.
      _HMG_aControlInputMask [k] := AddTabBitMap ( ControlHandle, _HMG_aControlPicture [k] )
   EndIf

   For z = 1 To Len ( aCaptions )

      Caption := Upper ( aCaptions [z] )

      i := at ( '&' , Caption )

      If i > 0
         _DefineLetterOrDigitHotKey ( Caption, i, ParentName, aMnemonic [z] )
      EndIf

   Next z

    * Hide all except page to show

   For r = 1 to len ( _HMG_ActiveTabFullPageMap )

      if r <> _HMG_aControlValue [k]

         for c = 1 to len ( _HMG_ActiveTabFullPageMap [r])
            if valtype ( _HMG_ActiveTabFullPageMap [r] [c] ) <> "A"
               HideWindow ( _HMG_ActiveTabFullPageMap [r] [c] )
            else
               for z = 1 to len ( _HMG_ActiveTabFullPageMap [r] [c] )
                  HideWindow ( _HMG_ActiveTabFullPageMap [r] [c] [z] )
               next z
            endif
         Next c

      endif

   Next r
// JP 62
   if len(_HMG_aDialogTemplate) != 0 .and. _HMG_aDialogTemplate[3]   // Modal
      _HMG_aControlDeleted [k] := .T.
   ENDIF

Return Nil

*-----------------------------------------------------------------------------*
Function UpdateTab (y) // Internal Function
*-----------------------------------------------------------------------------*
   Local r,w,s,z

    * Hide All Pages
   for r = 1 to len ( _HMG_aControlPageMap [y] )
      for w = 1 to len (_HMG_aControlPageMap [y] [r])
         if valtype ( _HMG_aControlPageMap [y] [r] [w] ) <> "A"
            HideWindow ( _HMG_aControlPageMap [y] [r] [w] )
         else
            for z = 1 to len ( _HMG_aControlPageMap [y] [r] [w] )
               HideWindow ( _HMG_aControlPageMap [y] [r] [w] [z] )
            Next z
         endif
      Next w
   Next r

    * Show New Active Page
   s := TabCtrl_GetCurSel (_HMG_aControlHandles [y] )

   if s > 0

      for w = 1 to len (_HMG_aControlPageMap [y] [s])
         if valtype (_HMG_aControlPageMap [y] [s] [w]) <> "A"

            if _IsControlVisibleFromHandle ( _HMG_aControlPageMap [y] [s] [w] )

               CShowControl ( _HMG_aControlPageMap [y] [s] [w] )

            EndIf

         else

            if _IsControlVisibleFromHandle ( _HMG_aControlPageMap [y] [s] [w] [1] )

               for z = 1 to len ( _HMG_aControlPageMap [y] [s] [w] )
                  CShowControl ( _HMG_aControlPageMap [y] [s] [w] [z] )
               next z

            EndIf

         endif
      Next w

   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _BeginTabPage ( caption , image )
*-----------------------------------------------------------------------------*

    // JD 11/05/2006
   If ValType (Caption) == 'U'
      Caption := ''
   EndIf

    // JD 11/05/2006
   If ValType (Image) == 'U'
      Image := ''
   EndIf

   _HMG_ActiveTabPage++
   aAdd ( _HMG_ActiveTabCaptions , caption )
   aAdd ( _HMG_ActiveTabImages , image )

Return Nil
*-----------------------------------------------------------------------------*
Function _EndTabPage()
*-----------------------------------------------------------------------------*

   if lDialogInMemory
      _HMG_aDialogItems[len(_HMG_aDialogItems),21] :=.t.
   else
      aAdd ( _HMG_ActiveTabFullPageMap , _HMG_ActiveTabCurrentPageMap )
      _HMG_ActiveTabCurrentPageMap := {}
   endif

Return Nil
*-----------------------------------------------------------------------------*
Function _EndTab()
*-----------------------------------------------------------------------------*

   _DefineTab ( _HMG_ActiveTabName, _HMG_ActiveTabParentFormName, _HMG_ActiveTabCol,;
      _HMG_ActiveTabRow, _HMG_ActiveTabWidth, _HMG_ActiveTabHeight,;
      _HMG_ActiveTabCaptions, _HMG_ActiveTabFullPageMap, _HMG_ActiveTabValue,;
      _HMG_ActiveTabFontName, _HMG_ActiveTabFontSize, _HMG_ActiveTabToolTip,;
      _HMG_ActiveTabChangeProcedure, _HMG_ActiveTabButtons, _HMG_ActiveTabFlat,;
      _HMG_ActiveTabHotTrack, _HMG_ActiveTabVertical, _HMG_ActiveTabBottom,;
      _HMG_ActiveTabNoTabStop, _HMG_ActiveTabMnemonic, _HMG_ActiveTabBold,;
      _HMG_ActiveTabItalic, _HMG_ActiveTabUnderline, _HMG_ActiveTabStrikeout,;
      _HMG_ActiveTabImages, _HMG_ActiveTabMultiline, _HMG_ActiveTabColor, _HMG_ActiveTabnId )
   _HMG_BeginTabActive := .F.
   _HMG_FrameLevel--

Return Nil
*-----------------------------------------------------------------------------*
Function _AddTabPage ( ControlName , ParentForm , Position , Caption , Image )
*-----------------------------------------------------------------------------*
   Local i, j, ImageFlag := .F.        // JD 11/05/2006

   If ValType (Caption) == 'U'
      Caption := ''
   EndIf

   If ValType (Image) == 'U'
      Image := ''
   EndIf

   i := GetControlIndex ( Controlname , ParentForm )

    // JD 11/05/2006
   if i > 0

      TABCTRL_INSERTITEM ( _HMG_aControlHandles [i] , Position - 1 , Caption )

      aAdd ( _HMG_aControlPageMap [i] , Nil )
      aIns ( _HMG_aControlPageMap [i] , Position )
      _HMG_aControlPageMap [i] [Position] := {}

      aAdd ( _HMG_aControlCaption [i] , Nil )
      aIns ( _HMG_aControlCaption [i] , Position )
      _HMG_aControlCaption [i] [Position] := Caption

      aAdd ( _HMG_aControlPicture [i] , Nil )
      aIns ( _HMG_aControlPicture [i] , Position )
      _HMG_aControlPicture [i] [Position] := Image

        // JD 11/05/2006
      For j := 1 To Len ( _HMG_aControlPicture [i] )

         If ValType ( _HMG_aControlPicture [i] [j] ) == "C" .and. !Empty ( _HMG_aControlPicture [i] [j] )
            ImageFlag := .T.
            Exit
         EndIf

      Next j

      _HMG_aControlMiscData1 [i] [2] := ImageFlag       // JD 11/05/2006

        // JD 11/05/2006
      if ImageFlag == .T.

         if !EMPTY( _HMG_aControlInputMask [i] )
            IMAGELIST_DESTROY ( _HMG_aControlInputMask [i] )
         endif

         _HMG_aControlInputMask [i] := AddTabBitMap ( _HMG_aControlHandles [i], _HMG_aControlPicture [i] )

      endif

      UpdateTab (i)

   endif

Return Nil
*-----------------------------------------------------------------------------*
Function _AddTabControl ( TabName , ControlName , ParentForm , PageNumber , Row , Col )
*-----------------------------------------------------------------------------*
   Local i , x , t

   i := GetControlIndex ( TabName , ParentForm )

   x := GetControlIndex ( ControlName , ParentForm )

   if i * x > 0

      t := _HMG_aControlType [x]

        // JD 07/20/2007
      if t == "BROWSE" .and. _HMG_aControlMiscData1 [x,8] == .F.
         aadd ( _HMG_aControlPageMap [i] [PageNumber] , {_HMG_aControlHandles [x] , _HMG_aControlIds [x], _HMG_aControlMiscData1 [x] [1]} )
      else
         aadd ( _HMG_aControlPageMap [i] [PageNumber] , _HMG_aControlHandles [x] )
      endif

      if t == "SLIDER"

         _HMG_aControlFontHandle [x] :=  TabName
         _HMG_aControlMiscData1  [x] :=  ParentForm

      elseif t == "FRAME" .or. t == "CHECKBOX" .or. t == "RADIOGROUP"  // JD 07/20/2007

         _HMG_aControlRangeMin  [x] :=  TabName
         _HMG_aControlRangeMax  [x] :=  ParentForm

      endif

      _HMG_aControlContainerRow [x] := _HMG_aControlRow [i]
      _HMG_aControlContainerCol [x] := _HMG_aControlCol [i]

      _SetControlRow ( ControlName , ParentForm , Row )
      _SetControlCol ( ControlName , ParentForm , Col )

      UpdateTab (i)

   endif

Return Nil
*-----------------------------------------------------------------------------*
Function _DeleteTabPage ( ControlName , ParentForm , Position )
*-----------------------------------------------------------------------------*
   Local i , NewValue , j , NewMap := {} , ImageFlag := .F.

   i := GetControlIndex ( Controlname , ParentForm )

   if i > 0

        // Control Map

      For j := 1 To Len ( _HMG_aControlPageMap [i] )

         if j <> position
            aAdd ( NewMap , _HMG_aControlPageMap [i] [j] )
         endif

      Next j

      _HMG_aControlPageMap [i] := NewMap

        // Images

      NewMap := {}

      For j := 1 To Len ( _HMG_aControlPicture [i] )

         if j <> position
            aAdd ( NewMap , _HMG_aControlPicture [i] [j] )
         endif

      Next j

      _HMG_aControlPicture [i] := NewMap

        // Captions

      NewMap := {}

      For j := 1 To Len ( _HMG_aControlCaption [i] )

         if j <> position
            aAdd ( NewMap, _HMG_aControlCaption [i] [j] )
         endif

      Next j

      _HMG_aControlCaption [i] := NewMap

      TabCtrl_DeleteItem( _HMG_aControlhandles [i], Position - 1 )

      NewValue := Position - 1

      If NewValue == 0
         NewValue := 1
      EndIf

        // JD 11/05/2006
      For j := 1 To Len ( _HMG_aControlPicture [i] )

         If ValType ( _HMG_aControlPicture [i] [j] ) == "C" .and. !Empty ( _HMG_aControlPicture [i] [j] )
            ImageFlag := .T.
            Exit
         EndIf

      Next j

      _HMG_aControlMiscData1 [i,2] := ImageFlag    // JD 11/05/2006

        // JD 11/05/2006
      if ImageFlag == .T.

         if !EMPTY( _HMG_aControlInputMask [i] )
            IMAGELIST_DESTROY ( _HMG_aControlInputMask [i] )
         endif

         _HMG_aControlInputMask [i] := AddTabBitMap ( _HMG_aControlHandles [i], _HMG_aControlPicture [i] )

      endif

      TABCTRL_SETCURSEL ( _HMG_aControlhandles [i], NewValue )

      UpdateTab (i)

   EndIf

Return Nil

#define ODS_SELECTED  1
#define TRANSPARENT   1
#define DT_CENTER     1
#define COLOR_BTNTEXT 18
*------------------------------------------------------------------------------*
Function OwnTabPaint ( lParam )
*------------------------------------------------------------------------------*
Local i, hDC, hTabCtrl, nItemId, aBtnRc, hBrush, oldBkMode, bkColor, lSelected
Local hOldFont, aMetr, oldTextColor, ImageFlag, hImage, aBmp
Local x1, y1, x2, y2, xp1, yp1, xp2, yp2

   hDC := GETOWNBTNDC( lParam )
   if Empty( hDC )
      Return ( 1 )
   endif

   hTabCtrl  := GETOWNBTNHANDLE( lParam )
   nItemId   := GETOWNBTNITEMID( lParam )
   aBtnRc    := GETOWNBTNRECT( lParam )
   lSelected := AND( GETOWNBTNSTATE( lParam ), ODS_SELECTED ) == ODS_SELECTED

   i := ascan ( _HMG_aControlHandles , hTabCtrl )
   if i <= 0
      Return ( 1 )
   endif

   hOldFont := SelectObject( hDC, _HMG_aControlFontHandle [ i ] )
   aMetr := GetTextMetric( hDC )
   oldBkMode := setBkMode( hDC, TRANSPARENT )
   oldTextColor := SetTextColor( hDC, GetRed( GetSysColor( COLOR_BTNTEXT ) ), GetGreen( GetSysColor( COLOR_BTNTEXT ) ), GetBlue( GetSysColor( COLOR_BTNTEXT ) ) )

   hBrush := CreateSolidBrush( _HMG_aControlBkColor [i] [1], _HMG_aControlBkColor [i] [2], _HMG_aControlBkColor [i] [3] )
   FillRect(hDC, aBtnRc[ 1 ], aBtnRc[ 2 ], aBtnRc[ 3 ], aBtnRc[ 4 ], hBrush )
   DeleteObject( hBrush )

   bkColor := RGB( _HMG_aControlBkColor [i] [1],_HMG_aControlBkColor [i] [2],_HMG_aControlBkColor [i] [3] )
   SetBkColor( hDC, bkColor )

   x1 := aBtnRc[ 1 ]
   y1 := Round( aBtnRc[ 4 ] / 2, 0 ) - ( aMetr[ 1 ] - 10 )
   x2 := aBtnRc[ 3 ] - 2
   y2 := y1 + aMetr[ 1 ]

   ImageFlag := _HMG_aControlMiscData1 [i] [2]

   if ImageFlag
      hImage := LoadBitmap( _HMG_aControlPicture [i] [nItemId + 1] )
      aBmp := GetBitmapSize( hImage )

      xp1 := 4
      xp2 := IIF( ! Empty( aBmp ), aBmp[ 1 ], 0 )
      yp2 := IIF( ! Empty( aBmp ), aBmp[ 2 ], 0 )
      yp1 := Round( ( ( aBtnRc[ 4 ] / 2 ) - ( yp2 / 2 ) ), 0 )
      x1 += 2 * xp1 + xp2

      if lSelected
         DrawGlyph( hDC, aBtnRc[ 1 ] + 2 * xp1, yp1 - 2, xp2, yp2, hImage, bkColor, .f., .f. )
      else
         DrawGlyph( hDC, aBtnRc[ 1 ] + xp1, yp1 + 2, xp2, yp2, hImage, bkColor, .f., .f. )
      endif

      DeleteObject( hImage )
   endif

   if lSelected
      DrawText( hDC, _HMG_aControlCaption [i] [nItemId + 1], x1, y1 - 4, x2, y2, DT_CENTER )
   else
      DrawText( hDC, _HMG_aControlCaption [i] [nItemId + 1], x1, y1, x2, y2 + 1, DT_CENTER )
   endif

   SelectObject( hDC, hOldFont )
   SetBkMode( hDC, oldBkMode )
   SetTextColor( hDC, oldTextColor )

Return (0)
