/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

#define RBN_FIRST               (-831)
#define RBN_CHEVRONPUSHED   (RBN_FIRST - 10)

*-----------------------------------------------------------------------------*
Function _DefineToolBar ( ControlName, ParentForm, x, y, caption, ProcedureName, w, h, fontname, fontsize,tooltip, flat, bottom, righttext, break, bold, italic, underline, strikeout, border, mixedbuttons, rows, tbsize, imagelst, hotimagelst )
*-----------------------------------------------------------------------------*
   Local cParentForm , mVar , k
   Local FontHandle , aFont , ControlHandle , id

   If .Not. _IsWindowDefined (ParentForm)
      MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated" )
   Endif

   If _IsControlDefined (ControlName,ParentForm)
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentForm + " Already defined. Program Terminated" )
   EndIf

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
      underline     := aFont[5]
      strikeout     := aFont[6]
   endif

   _HMG_ActiveToolBarBreak := break

   mVar := '_' + ParentForm + '_' + ControlName

   cParentForm := ParentForm

   ParentForm = GetFormHandle (ParentForm)

   Id := _GetId()

   if _HMG_ActiveSplitBox == .T.
      _HMG_SplitLastControl := 'TOOLBAR'
   EndIf

   _HMG_ActiveToolBarCaption := Caption

   if _HMG_ActiveToolBarExtend
      ControlHandle := InitToolBarEx ( ParentForm, Caption, id, 0, 0, w, h, "" , 0 , flat , bottom , righttext , _HMG_ActiveSplitBox , border , mixedbuttons )
   else
      ControlHandle := InitToolBar ( ParentForm, Caption, id, 0, 0, w, h, "" , 0 , flat , bottom , righttext , _HMG_ActiveSplitBox , border )
   endif

   If FontHandle != 0
      _SetFontHandle(ControlHandle,FontHandle)
   Else
      if valtype(fontname) == "U"
         FontName := _HMG_DefaultFontName
      endif
      if valtype(fontsize) == "U"
         FontSize := _HMG_DefaultFontSize
      endif
      FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
   EndIf

   if valtype(tooltip) != "U"
      SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (cParentForm) )
   endif

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_aControlType  [k] := "TOOLBAR"
   _HMG_aControlNames   [k] := ControlName
   _HMG_aControlHandles  [k] :=  ControlHandle
   _HMG_aControlParenthandles  [k] :=  ParentForm
   _HMG_aControlIds  [k] :=  id
   _HMG_aControlProcedures  [k] :=  ProcedureName
   _HMG_aControlPageMap  [k] :=  {}
   _HMG_aControlValue  [k] :=  {imagelst,hotimagelst}
   _HMG_aControlInputMask   [k] := ""
   _HMG_aControllostFocusProcedure  [k] :=  ""
   _HMG_aControlGotFocusProcedure  [k] :=  ""
   _HMG_aControlChangeProcedure  [k] :=  ""
   _HMG_aControlDeleted  [k] :=  .F.	
   _HMG_aControlBkColor   [k] := Nil
   _HMG_aControlFontColor  [k] :=  Nil
   _HMG_aControlDblClick   [k] := ""
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow  [k] :=  y
   _HMG_aControlCol  [k] :=  x
   _HMG_aControlWidth   [k] := w
   _HMG_aControlHeight   [k] := h
   _HMG_aControlSpacing   [k] := rows
   _HMG_aControlContainerRow  [k] :=  -1
   _HMG_aControlContainerCol  [k] :=  -1
   _HMG_aControlPicture   [k] := ""
   _HMG_aControlContainerHandle  [k] :=  0
   _HMG_aControlFontName  [k] :=  ''
   _HMG_aControlFontSize   [k] := 0
   _HMG_aControlFontAttributes  [k] :=  {.f.,.f.,.f.,.f.}
   _HMG_aControlToolTip  [k] :=   ''
   _HMG_aControlRangeMin   [k] :=  tbsize
   _HMG_aControlRangeMax  [k] :=   0
   _HMG_aControlCaption  [k] :=   Caption
   _HMG_aControlVisible  [k] :=   .t.
   _HMG_aControlHelpId   [k] :=  0
   _HMG_aControlFontHandle  [k] :=   FontHandle
   _HMG_aControlBrushHandle [k] :=   0
   _HMG_aControlEnabled   [k] :=  .T.
   _HMG_aControlMiscData1 [k] := 0

Return Controlhandle

*-----------------------------------------------------------------------------*
Function _EndToolBar()
*-----------------------------------------------------------------------------*
   Local ix, c, i, ParentForm, nRow, nBand, aSize //, tbsize

   if _HMG_BeginWindowActive = .T.
      ParentForm := _HMG_ActiveFormName
   Else
      ParentForm := _HMG_ActiveToolBarFormName
   endif

   c := GetControlHandle ( _HMG_ActiveToolBarName , ParentForm )

   if _HMG_ActiveSplitBox == .T.
      _AddToolBarToSpliBox ( _HMG_ActiveToolBarName , _HMG_ActiveToolBarBreak , _HMG_ActiveToolBarCaption , ParentForm )
      ix     := GetControlIndex ( _HMG_ActiveToolBarName, ParentForm )
      nRow   := _HMG_aControlSpacing [ix]
      //tbsize := _HMG_aControlRangeMin [ix]
      if nRow > 1
         aSize  := SetRowsButton( c , nRow , .t. )
         i      := GetFormIndex ( _HMG_ActiveSplitBoxParentFormName )
         nBand  := GetBandCount ( _HMG_aFormReBarHandle [i] )
         //tbsize := if(tbsize == 0, aSize[1], tbsize)

         ResizeSplitBoxItem ( _HMG_aFormReBarHandle [i], nBand-1, aSize[1], aSize[2], aSize[1] )
      endif
   elseif !_HMG_ActiveToolBarExtend
      MaxTextBtnToolBar( c, _GetControlWidth (_HMG_ActiveToolBarName, ParentForm ), _GetControlHeight (_HMG_ActiveToolBarName, ParentForm) )
   EndIf

   _HMG_ActiveToolBarBreak		:= .F.
   _HMG_ActiveToolBarExtend	:= .F.

   _HMG_ActiveToolBarName		:= ""
   _HMG_ActiveToolBarFormName	:= ""

   _HMG_ToolBarActive		:= .F.

Return Nil

*-----------------------------------------------------------------------------*
Function _DefineToolButton ( ControlName, ParentControl, x, y, Caption, ProcedureName, w, h, image ,tooltip , gotfocus , lostfocus , flat , separator , autosize , check , group , dropdown , WHOLEDROPDOWN, adjust , imageindex )
*-----------------------------------------------------------------------------*
   Local i , cParentForm , mVar , ParentForm , hParentForm , k
   Local ControlHandle
   Local id, imagelst, hotimagelst, aImage
   Local npos, nToolBarIndex

   HB_SYMBOL_UNUSED( Flat )

   if _HMG_BeginWindowActive = .T.
      ParentForm := _HMG_ActiveFormName
   Else
      ParentForm := _HMG_ActiveToolBarFormName
   endif

   If valtype(ProcedureName) == 'U' .And. Dropdown == .T.
      MsgMiniGuiError ( "ToolBar DropDown buttons must have an associated action (Use WholeDropDown style for no action). Program Terminated" )
   EndIf

   If valtype(ProcedureName) != 'U' .And. WHOLEDROPDOWN == .T.
      MsgMiniGuiError ( "ToolBar Action and WholeDropDown clauses can't be used simultaneously. Program terminated" )
   endif

   cParentForm := ParentForm
   hParentForm := GetFormHandle ( ParentForm )

   mVar := '_' + ParentForm + '_' + ControlName

   ParentForm = GetControlHandle (ParentControl, ParentForm)

   id := _GetId()

   if valtype(Caption) == "U"
      Caption := ""
   endif

   if valtype(image) == "U"
      image := ""
   endif

   if valtype(w) == "U"
      w := _GetControlWidth (_HMG_ActiveToolBarName, cParentForm)
   endif
   if valtype(h) == "U"
      h := _GetControlHeight (_HMG_ActiveToolBarName, cParentForm)
   endif

   if valtype(lostfocus) == "U"
      lostfocus := ""
   endif
   if valtype(gotfocus) == "U"
      gotfocus := ""
   endif
   if valtype(tooltip) == "U"
      tooltip := ""
   endif

   if valtype(imageindex) != "U"
      aImage      := GetControlValue (_HMG_ActiveToolBarName, cParentForm)
      imagelst    := aImage[1]
      hotimagelst := aImage[2]
   else
      imageindex := -1
   endif

   if _HMG_ActiveToolBarExtend
      ControlHandle := InitToolButtonEx ( ParentForm, Caption, id, 0, 0, w, h, image, 0, separator, autosize, check, group, dropdown, WHOLEDROPDOWN, adjust, imageindex, imagelst, hotimagelst )
   else
      ControlHandle := InitToolButton ( ParentForm, Caption, id, 0, 0, 0, 0, image, 0, separator, autosize, check, group, dropdown, WHOLEDROPDOWN )
   endif

   nPos := GetButtonBarCount ( ParentForm ) - if(separator, 1, 0)

   k := _GetControlFree()

   Public &mVar. := k

   _HMG_aControlType [k] := "TOOLBUTTON"
   _HMG_aControlNames  [k] :=  ControlName
   _HMG_aControlHandles  [k] :=  ControlHandle
   _HMG_aControlParenthandles [k] :=   hParentForm
   _HMG_aControlIds  [k] :=  id
   _HMG_aControlProcedures  [k] :=  ProcedureName
   _HMG_aControlPageMap  [k] :=  {}
   _HMG_aControlValue  [k] :=  nPos
   _HMG_aControlInputMask  [k] :=  ""
   _HMG_aControllostFocusProcedure  [k] :=  lostfocus
   _HMG_aControlGotFocusProcedure [k] :=   gotfocus
   _HMG_aControlChangeProcedure  [k] :=  ""
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor  [k] :=  Nil
   _HMG_aControlFontColor  [k] :=  Nil
   _HMG_aControlDblClick  [k] :=  ""
   _HMG_aControlHeadClick  [k] :=  {}
   _HMG_aControlRow  [k] :=  y
   _HMG_aControlCol  [k] :=  x
   _HMG_aControlWidth   [k] := w
   _HMG_aControlHeight   [k] := h
   _HMG_aControlSpacing  [k] :=  0
   _HMG_aControlContainerRow  [k] :=  -1
   _HMG_aControlContainerCol  [k] :=  -1
   _HMG_aControlPicture  [k] := image
   _HMG_aControlContainerHandle  [k] :=  ParentForm
   _HMG_aControlFontName  [k] :=  ''
   _HMG_aControlFontSize   [k] := 0
   _HMG_aControlFontAttributes  [k] :=  {.f.,.f.,.f.,.f.}
   _HMG_aControlToolTip  [k] := tooltip
   _HMG_aControlRangeMin [k] := 0
   _HMG_aControlRangeMax [k] := 0
   _HMG_aControlCaption  [k] := Caption
   _HMG_aControlVisible  [k] := .t.
   _HMG_aControlHelpId   [k] := 0
   _HMG_aControlFontHandle   [k] := 0
   _HMG_aControlBrushHandle  [k] := 0
   _HMG_aControlEnabled  [k] := .T.
   _HMG_aControlMiscData1 [k] := 0

   Caption := Upper ( Caption )

   i := at ( '&' , Caption )

   If i > 0
      If WholeDropDown == .T.
         nToolBarIndex := aScan ( _HMG_aControlHandles , ParentForm )
         ProcedureName := { || _DropDownShortcut ( Id , hParentForm , nToolBarIndex , nPos ) }
      EndIf
      _DefineLetterOrDigitHotKey ( Caption, i, cParentForm, ProcedureName )
   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _AddToolBarToSpliBox ( ControlName , break , Caption , ParentForm )
*-----------------------------------------------------------------------------*
   Local i, c, w, MinWidth, MinHeight, ix, tbsize

   i := GetFormIndex ( _HMG_ActiveSplitBoxParentFormName )

   c := GetControlHandle (ControlName, _HMG_ActiveSplitBoxParentFormName)

   if !_HMG_ActiveToolBarExtend
      MaxTextBtnToolBar( c, _GetControlWidth (ControlName, ParentForm ), _GetControlHeight (ControlName, ParentForm ) )
   endif

   w := GetSizeToolBar(c)

   MinWidth  := HiWord(w)
   MinHeight := LoWord(w) + if( _HMG_ActiveToolBarExtend, 2, 0 )

   w := GetWindowWidth (c)

   ix	:= GetControlIndex ( ControlName, ParentForm  )
   tbsize	:= _HMG_aControlRangeMin [ix]

   if i > 0
      AddSplitBoxItem ( c , _HMG_aFormReBarHandle [i] , w , break , Caption, MinWidth, MinHeight , _HMG_ActiveSplitBoxInverted , tbsize )
   EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _BeginToolBar ( name, parent, row, col, w, h, caption, ProcedureName, fontname, fontsize, tooltip, flat, bottom, righttext, break, bold, italic, underline, strikeout, border )
*-----------------------------------------------------------------------------*

   _HMG_ToolBarActive		:= .T.
   _HMG_ActiveToolBarExtend	:= .F.

   If _HMG_SplitChildActive == .t.
      MsgMiniGuiError("ToolBars Can't Be Defined Inside SplitChild Windows. Program terminated" )
   Endif

   if _HMG_BeginWindowActive = .T.
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(FontName) == "U"
         FontName := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(FontSize) == "U"
         FontSize := _HMG_ActiveFontSize
      EndIf
   endif

   if valtype (parent) == 'U'
      parent := _HMG_ActiveFormName
   EndIf

   _HMG_ActiveToolBarFormName := parent

   if valtype (caption) == 'U'
      caption := ""
   EndIf

   if valtype (w) == 'U'
      w := 0
   EndIf

   if valtype (h) == 'U'
      h := 0
   EndIf

   If valtype (break) == 'U'
      break := iif( _HMG_ActiveSplitBox , .f. , .t. )
   Endif

   _HMG_ActiveToolBarName := name

   _DefineToolBar ( name , parent , col , row , caption , ProcedureName , w , h , fontname , fontsize , tooltip , flat , bottom , righttext , break , bold , italic , underline , strikeout , border , .F. , 0 , 0 )

Return Nil

*-----------------------------------------------------------------------------*
Function _BeginToolBarEx( name, parent, row, col, w, h, caption, ProcedureName, fontname, fontsize, tooltip, flat, bottom, righttext, break, bold, italic, underline, strikeout, border , mixedbuttons , rows , tbsize, imagelst , hotimagelst)
*-----------------------------------------------------------------------------*

   _HMG_ToolBarActive		:= .T.
   _HMG_ActiveToolBarExtend	:= .T.

   If _HMG_SplitChildActive == .T.
      MsgMiniGuiError("ToolBars Can't Be Defined Inside SplitChild Windows. Program terminated" )
   Endif

   if _HMG_BeginWindowActive = .T.
      if .Not. Empty(_HMG_ActiveFontName) .and. ValType(FontName) == "U"
         FontName := _HMG_ActiveFontName
      EndIf
      if .Not. Empty(_HMG_ActiveFontSize) .and. ValType(FontSize) == "U"
         FontSize := _HMG_ActiveFontSize
      EndIf
   endif

   if valtype (parent) == 'U'
      parent := _HMG_ActiveFormName
   EndIf

   _HMG_ActiveToolBarFormName := parent

   if valtype (caption) == 'U'
      caption := ""
   EndIf

   if valtype (w) == 'U'
      w := 0
   EndIf

   if valtype (h) == 'U'
      h := 0
   EndIf

   if valtype (rows) == 'U'
      rows := 1
   EndIf

   if valtype (tbsize) == 'U'
      tbsize := 0
   EndIf

   if valtype(imagelst) != 'U'
      if valtype(imagelst) == 'C'
         imagelst := GetControlHandle (imagelst , parent )
      endif
   endif

   if valtype(hotimagelst) != 'U'
      if valtype(hotimagelst) == 'C'
         hotimagelst := GetControlHandle (hotimagelst , parent )
      endif
   endif

   If valtype (break) == 'U'
      break := iif( _HMG_ActiveSplitBox , .f. , .t. )
   Endif

   _HMG_ActiveToolBarName := name

   _DefineToolBar ( name , parent , col , row , caption , ProcedureName , w , h , fontname , fontsize , tooltip , flat , bottom , righttext , break , bold , italic , underline , strikeout , border , mixedbuttons , rows , tbsize, imagelst , hotimagelst )

Return Nil

*-----------------------------------------------------------------------------*
Function _CreatePopUpChevron ( hWnd, wParam, lParam )
*-----------------------------------------------------------------------------*
   LOCAL aChevronInfo, i, k, n, hMenu, aBtnInfo, hImage, aPos, cMenu, TbHwnd, image, lEnable

   i := Ascan ( _HMG_aFormhandles , hWnd )

   if i > 0
      aChevronInfo := CreatePopUpChevron( _HMG_aFormReBarHandle [i] , lParam )
      TbHwnd := aChevronInfo[5]
      hMenu := CreatePopupMenu()

      for n := aChevronInfo[6] to aChevronInfo[7] - 1
         aBtnInfo := GetButtonBar( TbHwnd, n )
         lEnable  := IsButtonEnabled( TbHwnd, n )
         hImage := GetImageList( tbhwnd, aBtnInfo[1] )
         k := Ascan ( _HMG_aControlIds , aBtnInfo[2] )
         if k > 0 .and. !aBtnInfo[3]
            if !empty(_HMG_aControlToolTip [k])
               cMenu := _HMG_aControlToolTip [k]
            elseif !empty(_HMG_aControlCaption [k])
               cMenu := _HMG_aControlCaption [k]
            else
               cMenu := 'Button ' + alltrim(str(n))
            endif
            AppendMenuString ( hMenu , aBtnInfo[2] , cMenu )
            image := _HMG_aControlPicture  [k]
            If len( image ) != 0
               MenuItem_SetBitMaps ( hMenu , aBtnInfo[2] , image , image )
            else
               SetChevronImage( hMenu, aBtnInfo[2], hImage )
            EndIf
            If lEnable == .f.
               xDisableMenuItem ( hMenu, aBtnInfo[2] )
            EndIf
         endif
      next

      aPos := {0,0,0,0}
      GetWindowRect( _HMG_aFormReBarHandle [i], aPos )
      TrackPopupMenu ( hMenu , aPos[1] + aChevronInfo[1] , aPos[2] + aChevronInfo[4] + 3 , hWnd )
   endif

   DefWindowProc( hWnd, RBN_CHEVRONPUSHED, wParam, lParam )
   DestroyMenu( hMenu )

Return Nil

#define TB_SETHOTITEM	(WM_USER+72)
*-----------------------------------------------------------------------------*
Procedure _DropDownShortcut ( nToolButtonId , nParentWindowHandle , i , nButtonPos )
*-----------------------------------------------------------------------------*
   Local aPos
   Local aSize
   Local x := Ascan ( _HMG_aControlIds , nToolButtonId )

   if x > 0 .And. _HMG_aControlType [x] = "TOOLBUTTON"
      aPos := {0,0,0,0}
      GetWindowRect ( _HMG_aControlHandles [i], aPos )

      SendMessage( _HMG_aControlHandles [i] , TB_SETHOTITEM, nButtonPos - 1 ,  0 )

      aSize := GetButtonBarRect ( _HMG_aControlHandles [i] , nButtonPos - 1 )
      TrackPopupMenu ( _HMG_aControlRangeMax [x] , aPos[1]+LoWord(aSize) , aPos[2]+HiWord(aSize)+(aPos[4]-aPos[2]-HiWord(aSize))/2 , nParentWindowHandle )

      SendMessage( _HMG_aControlHandles [i] , TB_SETHOTITEM, -1 ,  0 )

   EndIf

Return