/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

#define WS_TABSTOP          0x00010000
#define WS_VISIBLE          0x10000000
#define WS_CHILD            0x40000000
#define WS_BORDER    0x800000
#define TVS_HASBUTTONS          0x0001
#define TVS_HASLINES            0x0002
#define TVS_LINESATROOT         0x0004
#define TVS_EDITLABELS          0x0008
#define TVS_DISABLEDRAGDROP     0x0010
#define TVS_SHOWSELALWAYS       0x0020

#define TVM_EXPAND   4354
#define TVE_COLLAPSE   1
#define TVE_EXPAND   2

#define TV_FIRST           4352
#define TVM_SETITEMHEIGHT       (TV_FIRST + 27)
#define TVM_GETITEMHEIGHT       (TV_FIRST + 28)
#define TVM_SETBKCOLOR     (TV_FIRST + 29)
#define TVM_SETTEXTCOLOR   (TV_FIRST + 30)
#define TVM_SETLINECOLOR        (TV_FIRST + 40)
#define TVM_SETINSERTMARKCOLOR  (TV_FIRST + 37)
#define TVM_GETINDENT           (TV_FIRST + 6)
#define TVM_SETINDENT           (TV_FIRST + 7)
#define TVM_SELECTITEM          (TV_FIRST + 11)
#define TVM_GETLINECOLOR        (TV_FIRST + 41)
#define TVM_GETTEXTCOLOR        (TV_FIRST + 32)
#define TVM_GETBKCOLOR          (TV_FIRST + 31)

   STATIC lDialogInMemory := .f.
*-----------------------------------------------------------------------------*
Function _DefineTree ( ControlName, ParentFormName, row, col, width, height, change, tooltip, fontname, fontsize,;
   gotfocus, lostfocus, dblclick, break, value, HelpId, aImgNode, aImgItem, noBot, bold, italic, underline, strikeout, itemids, backcolor, fontcolor, linecolor , indent, itemheight, nId )
*-----------------------------------------------------------------------------*
   Local i , ParentFormHandle , Controlhandle , mVar, ImgDefNode, ImgDefItem, aBitmaps := array(4)
   Local FontHandle , aFont , k , Style , Mask , blInit

   _HMG_ActiveTreeHandle := 0
   _HMG_NodeIndex := 1
   _HMG_NodeHandle [1] := 0
   _HMG_aTreeMap := {}
   _HMG_aTreeIdMap := {}
   _HMG_ActiveTreeItemIds := itemids

   if ( FontHandle := GetFontHandle( FontName ) ) != 0
      aFont := GetFontParam(FontHandle)
      FontName      := aFont[1]
      FontSize      := aFont[2]
      bold          := aFont[3]
      italic        := aFont[4]
      underline     := aFont[5]
      strikeout     := aFont[6]
   endif

   if _HMG_BeginWindowActive = TRUE .or. _HMG_BeginDialogActive = TRUE
      ParentFormName := if(_HMG_BeginDialogActive,_HMG_ActiveDialogName,_HMG_ActiveFormName)
      if .Not. Empty (_HMG_ActiveFontName) .And. ValType(FontName) == "U"
         FontName := _HMG_ActiveFontName
      EndIf
      if .Not. Empty (_HMG_ActiveFontSize) .And. ValType(FontSize) == "U"
         FontSize := _HMG_ActiveFontSize
      EndIf
   endif
   if _HMG_FrameLevel > 0
      col    := col + _HMG_ActiveFrameCol [_HMG_FrameLevel]
      row    := row + _HMG_ActiveFrameRow [_HMG_FrameLevel]
      ParentFormName := _HMG_ActiveFrameParentFormName [_HMG_FrameLevel]
   EndIf
   lDialogInMemory := _HMG_DialogInMemory // ( GetWindowType ( ParentFormName ) == "L" )

   If .Not. _IsWindowDefined (ParentFormName)  .and. .Not. lDialogInMemory
      MsgMiniGuiError("Window: "+ ParentFormName + " is not defined. Program terminated" )
   Endif

   If _IsControlDefined (ControlName,ParentFormName)  .and. .Not. lDialogInMemory
      MsgMiniGuiError ("Control: " + ControlName + " Of " + ParentFormName + " Already defined. Program Terminated" )
   endif

   if valtype(Value) == "U"
      _HMG_ActiveTreeValue := 0
   Else
      _HMG_ActiveTreeValue := Value
   EndIf
   if valtype(Width) == "U"
      Width := 120
   endif
   if valtype(Height) == "U"
      Height := 120
   endif
   if valtype(change) == "U"
      change := ""
   endif
   if valtype(gotfocus) == "U"
      gotfocus := ""
   endif
   if valtype(lostfocus) == "U"
      lostfocus := ""
   endif
   if valtype(dblclick) == "U"
      dblclick := ""
   endif

   mVar := '_' + ParentFormName + '_' + ControlName
   k := _GetControlFree()

   if _HMG_BeginDialogActive = TRUE
      ParentFormHandle = _HMG_ActiveDialogHandle

      if valtype(nobot) == "L"
         if nobot
            mask := 0
         ELSE
            mask := TVS_LINESATROOT
         endif
      endif
      Style :=WS_BORDER + WS_VISIBLE + WS_TABSTOP + WS_CHILD + TVS_HASLINES + TVS_HASBUTTONS + mask + TVS_SHOWSELALWAYS

      if len(_HMG_aDialogTemplate) > 0        //Dialog Template

//          {{'ID',k/hwnd,class,Style,ExStyle,col,row,width,height,caption,HelpId,tooltip,font,size, bold, italic, underline, strikeout}}  --->_HMG_aDialogItems
         blInit:= {|x,y,z| InitDialogTree(x,y,z) }
         _HMG_aDialogTreeItem :={}
         aadd(_HMG_aDialogItems,{nId,k,"SysTreeView32",style,0,col,row,width,height,"",HelpId,tooltip,FontName,FontSize,bold,italic,underline,strikeout,blInit,_HMG_BeginTabActive,.f.,_HMG_ActiveTabPage })
/* JP 62
         if _HMG_aDialogTemplate[3]   // Modal
            _HMG_aControlDeleted [k] := .T.
            Return Nil
         endif
*/
      else

         ControlHandle := GetDialogItemHandle( ParentFormHandle, nId )

         SetWindowStyle ( ControlHandle, Style )

         col := GetWindowCol ( Controlhandle )
         row := GetWindowRow ( Controlhandle )
         Width := GetWindowWidth  ( Controlhandle )
         Height := GetWindowHeight ( Controlhandle )

         ImgDefNode := iif( valtype( aImgNode ) == "A" , len( aImgNode ), 0 )  //Tree+
         ImgDefItem := iif( valtype( aImgItem ) == "A" , len( aImgItem ), 0 )  //Tree+

         if ImgDefNode > 0

            aBitmaps[1] := aImgNode[1]              // Node default
            aBitmaps[2] := aImgNode[ImgDefNode]

            if ImgDefItem > 0

               aBitmaps[3] := aImgItem[1]          // Item default
               aBitmaps[4] := aImgItem[ImgDefItem]

            else

               aBitmaps[3] := aImgNode[1]           // Copy Node def if no Item def
               aBitmaps[4] := aImgNode[ImgDefNode]

            endif

            InitTreeViewBitmap( ControlHandle, aBitmaps ) //Init Bitmap List
         endif

         _HMG_ActiveTreeHandle := ControlHandle
      endif

   else

      ParentFormHandle = GetFormHandle (ParentFormName)

      if valtype(Row) == "U" .or. valtype(Col) == "U"

         If _HMG_SplitLastControl == 'TOOLBAR'
            Break := .T.
         EndIf

         i := GetFormIndex ( ParentFormName )

         if i > 0

            ControlHandle := InitTree ( _HMG_aFormReBarHandle [i] , col , row , width , height , 0 , '' , 0, iif(noBot,1,0) )

            If FontHandle != 0
               _SetFontHandle(ControlHandle,FontHandle)
            Else
               if valtype(fontname) == "U"
                  FontName := _HMG_DefaultFontName
               endif
               if valtype(fontsize) == "U"
                  FontSize := _HMG_DefaultFontSize
               endif
               FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
            EndIf

            AddSplitBoxItem ( Controlhandle , _HMG_aFormReBarHandle [i] , Width , break , , , , _HMG_ActiveSplitBoxInverted )

            _HMG_SplitLastControl := 'TREE'

         EndIf

      else

         ControlHandle := InitTree ( ParentFormHandle , col , row , width , height , 0 , '' , 0, iif(noBot,1,0) )

      endif

      ImgDefNode := iif( valtype( aImgNode ) == "A" , len( aImgNode ), 0 )  //Tree+
      ImgDefItem := iif( valtype( aImgItem ) == "A" , len( aImgItem ), 0 )  //Tree+

      if ImgDefNode > 0

         aBitmaps[1] := aImgNode[1]          // Node default
         aBitmaps[2] := aImgNode[ImgDefNode]

         if ImgDefItem > 0

            aBitmaps[3] := aImgItem[1]        // Item default
            aBitmaps[4] := aImgItem[ImgDefItem]
         else

            aBitmaps[3] := aImgNode[1]      // Copy Node def if no Item def
            aBitmaps[4] := aImgNode[ImgDefNode]

         endif

         InitTreeViewBitmap( ControlHandle, aBitmaps )   //Init Bitmap List
      endif

      _HMG_ActiveTreeHandle := ControlHandle

   endif

   if .Not. lDialogInMemory

      If FontHandle != 0
         _SetFontHandle(ControlHandle,FontHandle)
      Else
         if valtype(fontname) == "U"
            FontName := _HMG_DefaultFontName
         endif
         if valtype(fontsize) == "U"
            FontSize := _HMG_DefaultFontSize
         endif
         FontHandle := _SetFont (ControlHandle,FontName,FontSize,bold,italic,underline,strikeout)
      EndIf

      If _HMG_BeginTabActive = .T.
         aAdd ( _HMG_ActiveTabCurrentPageMap , ControlHandle )
      EndIf

      if valtype(tooltip) != "U"
         SetToolTip ( ControlHandle , tooltip , GetFormToolTipHandle (ParentFormName) )
      endif

      if valtype(backcolor) == "A"
         TreeView_SetBkColor( ControlHandle, backcolor)
      endif

      if valtype(fontcolor) == "A"
         TreeView_SetTextColor( ControlHandle, fontcolor)
      endif

      if valtype(linecolor) == "A"
         TreeView_SetLineColor( ControlHandle, linecolor)
      endif

      if valtype(indent) == "N"
         TreeView_SetIndent( ControlHandle, indent)
      endif

      if valtype(itemheight) == "N"
         TreeView_SetItemHeight( ControlHandle, itemheight)
      endif

   endif

   Public &mVar. := k

   _HMG_ActiveTreeIndex := k

   _HMG_aControlType [k] := "TREE"
   _HMG_aControlNames [k] :=   ControlName
   _HMG_aControlHandles [k] :=   ControlHandle
   _HMG_aControlParentHandles [k] :=   ParentFormHandle
   _HMG_aControlIds [k] :=   nId
   _HMG_aControlProcedures [k] :=   ""
   _HMG_aControlPageMap  [k] :=  {}
   _HMG_aControlValue  [k] :=  Nil
   _HMG_aControlInputMask  [k] :=  itemids
   _HMG_aControllostFocusProcedure [k] :=   lostfocus
   _HMG_aControlGotFocusProcedure  [k] :=  gotfocus
   _HMG_aControlChangeProcedure  [k] :=  change
   _HMG_aControlDeleted  [k] :=  .F.
   _HMG_aControlBkColor  [k] :=  backcolor
   _HMG_aControlFontColor  [k] :=  fontcolor
   _HMG_aControlDblClick   [k] := dblclick
   _HMG_aControlHeadClick   [k] := {}
   _HMG_aControlRow   [k] := Row
   _HMG_aControlCol   [k] := Col
   _HMG_aControlWidth   [k] := Width
   _HMG_aControlHeight   [k] := Height
   _HMG_aControlSpacing   [k] := 0
   _HMG_aControlContainerRow  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameRow [_HMG_FrameLevel] , -1 )
   _HMG_aControlContainerCol  [k] :=  iif ( _HMG_FrameLevel > 0 ,_HMG_ActiveFrameCol [_HMG_FrameLevel] , -1 )
   _HMG_aControlPicture  [k] :=  {}
   _HMG_aControlContainerHandle  [k] :=  0
   _HMG_aControlFontName  [k] :=  fontname
   _HMG_aControlFontSize  [k] :=  fontsize
   _HMG_aControlFontAttributes   [k] := {bold,italic,underline,strikeout}
   _HMG_aControlToolTip   [k] :=  tooltip
   _HMG_aControlRangeMin   [k] :=  0
   _HMG_aControlRangeMax   [k] :=  0
   _HMG_aControlCaption   [k] :=  ''
   _HMG_aControlVisible  [k] :=   .t.
   _HMG_aControlHelpId   [k] :=   HelpId
   _HMG_aControlFontHandle   [k] :=  FontHandle
   _HMG_aControlBrushHandle  [k] :=   0
   _HMG_aControlEnabled  [k] :=   .T.
   _HMG_aControlMiscData1 [k] := {0, aImgNode, aImgItem }

Return Nil

*-----------------------------------------------------------------------------*
Function InitDialogTree(ParentName, ControlHandle, k)
*-----------------------------------------------------------------------------*
   Local ImgDefNode, ImgDefItem, aBitmaps := array(4), aImgNode, aImgItem
   Local text, ImgDef, Id, aImage, iUnsel, iSel,NodeHandle, n, NodeIndex, Handle

   ParentName := Nil

   aImgNode := _HMG_aControlMiscData1 [k,2]
   aImgItem := _HMG_aControlMiscData1 [k,3]

   ImgDefNode := iif( valtype( aImgNode ) == "A" , len( aImgNode ), 0 )  //Tree+
   ImgDefItem := iif( valtype( aImgItem ) == "A" , len( aImgItem ), 0 )  //Tree+

   if ImgDefNode > 0
      aBitmaps[1] := aImgNode[1]              // Node default
      aBitmaps[2] := aImgNode[ImgDefNode]
      if ImgDefItem > 0
         aBitmaps[3] := aImgItem[1]          // Item default
         aBitmaps[4] := aImgItem[ImgDefItem]
      else
         aBitmaps[3] := aImgNode[1]           // Copy Node def if no Item def
         aBitmaps[4] := aImgNode[ImgDefNode]
      endif
      InitTreeViewBitmap( ControlHandle, aBitmaps ) //Init Bitmap List
   endif

   _HMG_ActiveTreeHandle := ControlHandle

   for n:=1 to len(_HMG_aDialogTreeItem )
      aImage  := _HMG_aDialogTreeItem[n,2]
      text    := _HMG_aDialogTreeItem[n,1]
      id      := _HMG_aDialogTreeItem[n,3]
      NodeIndex := _HMG_aDialogTreeItem[n,4]
      ImgDef  := iif( valtype( aImage ) == "A" , len( aImage ), 0 )  //Tree+
      NodeHandle := _HMG_NodeHandle [NodeIndex]

      if ImgDef == 0
         if _HMG_aDialogTreeItem[n,5] == 'NODE'
            iUnsel := 0   // Pointer to defalut Node Bitmaps, no Bitmap loaded
            iSel   := 1
         else
            iUnsel := 2   // Pointer to defalut Item Bitmaps, no Bitmap loaded
            iSel   := 3
         endif
      else
         iUnSel := AddTreeViewBitmap( _HMG_ActiveTreeHandle, aImage[1] ) -1
         iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( _HMG_ActiveTreeHandle, aImage[2] ) -1 )
           // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
      endif
      if _HMG_aDialogTreeItem[n,5] == 'NODE'
         _HMG_NodeHandle [NodeIndex]:= AddTreeItem ( _HMG_ActiveTreeHandle, _HMG_NodeHandle [NodeIndex-1], text, iUnsel, iSel, Id )
         aAdd ( _HMG_aTreeMap , _HMG_NodeHandle [NodeIndex] )
         aAdd ( _HMG_aTreeIdMap , Id )
      else
         handle := AddTreeItem ( _HMG_ActiveTreeHandle, NodeHandle, text, iUnSel, iSel, Id )
         aAdd ( _HMG_aTreeMap , Handle )
         aAdd ( _HMG_aTreeIdMap , Id )
      endif
   next

   _HMG_aControlPageMap [ _HMG_ActiveTreeIndex ] := _HMG_aTreeMap
   _HMG_aControlPicture [ _HMG_ActiveTreeIndex ] := _HMG_aTreeIdMap

   If _HMG_ActiveTreeValue > 0

      If _HMG_ActiveTreeItemIds == .F.
         TreeView_SelectItem ( _HMG_ActiveTreeHandle , _HMG_aTreeMap [ _HMG_ActiveTreeValue ] )
      Else
         TreeView_SelectItem ( _HMG_ActiveTreeHandle , _HMG_aTreeMap [ ascan ( _HMG_aTreeIdMap , _HMG_ActiveTreeValue ) ] )
      EndIf
   EndIf
// JP 62
   if len(_HMG_aDialogTemplate) != 0 .and. _HMG_aDialogTemplate[3]   // Modal
      _HMG_aControlDeleted [k] := .T.
   endif

Return Nil

*-----------------------------------------------------------------------------*
Function _DefineTreeNode ( text, aImage , Id )
*-----------------------------------------------------------------------------*
   Local ImgDef, iUnSel, iSel

   If ValType ( Id ) == 'U'
      Id := 0
   EndIf

   if lDialogInMemory

      _HMG_NodeIndex++
      aAdd ( _HMG_aDialogTreeItem, {text, aImage, Id, _HMG_NodeIndex, 'NODE'} )

   else

      ImgDef := iif( valtype( aImage ) == "A" , len( aImage ), 0 )  //Tree+

      if ImgDef == 0

         iUnsel := 0   // Pointer to defalut Node Bitmaps, no Bitmap loaded
         iSel   := 1

      else
         iUnSel := AddTreeViewBitmap( _HMG_ActiveTreeHandle, aImage[1] ) -1
         iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( _HMG_ActiveTreeHandle, aImage[2] ) -1 )
          // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
      endif

      _HMG_NodeIndex++
      _HMG_NodeHandle [_HMG_NodeIndex]:= AddTreeItem ( _HMG_ActiveTreeHandle, _HMG_NodeHandle [_HMG_NodeIndex-1], text, iUnsel, iSel, Id )
      aAdd ( _HMG_aTreeMap , _HMG_NodeHandle [_HMG_NodeIndex] )
      aAdd ( _HMG_aTreeIdMap , Id )
   endif

Return Nil

*-----------------------------------------------------------------------------*
Function _EndTreeNode()
*-----------------------------------------------------------------------------*

   _HMG_NodeIndex--

Return Nil

*-----------------------------------------------------------------------------*
Function _DefineTreeItem ( text, aImage , Id )
*-----------------------------------------------------------------------------*
   Local handle, ImgDef, iUnSel, iSel

   If ValType ( Id ) == 'U'
      Id := 0
   EndIf

   if lDialogInMemory

      aAdd ( _HMG_aDialogTreeItem, {text, aImage, Id, _HMG_NodeIndex, 'ITEM'} )

   else

      ImgDef := iif( valtype( aImage ) == "A" , len( aImage ), 0 )  //Tree+

      if ImgDef == 0
         iUnsel := 2   // Pointer to defalut Item Bitmaps, no Bitmap loaded
         iSel   := 3
      else
         iUnSel := AddTreeViewBitmap( _HMG_ActiveTreeHandle, aImage[1] ) -1
         iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( _HMG_ActiveTreeHandle, aImage[2] ) -1 )
          // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
      endif

      handle := AddTreeItem ( _HMG_ActiveTreeHandle, _HMG_NodeHandle [_HMG_NodeIndex], text, iUnSel, iSel, Id )
      aAdd ( _HMG_aTreeMap , Handle )
      aAdd ( _HMG_aTreeIdMap , Id )
   endif

Return Nil

*-----------------------------------------------------------------------------*
Function _EndTree()
*-----------------------------------------------------------------------------*

   If .Not. lDialogInMemory

      _HMG_aControlPageMap [ _HMG_ActiveTreeIndex ] := _HMG_aTreeMap
      _HMG_aControlPicture [ _HMG_ActiveTreeIndex ] := _HMG_aTreeIdMap

      If _HMG_ActiveTreeValue > 0

         If _HMG_ActiveTreeItemIds == .F.
            TreeView_SelectItem ( _HMG_ActiveTreeHandle , _HMG_aTreeMap [ _HMG_ActiveTreeValue ] )
         Else
            TreeView_SelectItem ( _HMG_ActiveTreeHandle , _HMG_aTreeMap [ ascan ( _HMG_aTreeIdMap , _HMG_ActiveTreeValue ) ] )
         EndIf
      EndIf
   Endif

Return Nil

*-----------------------------------------------------------------------------*
Procedure _Collapse ( ControlName , ParentForm , Item )
*-----------------------------------------------------------------------------*
   Local i , ItemHandle := 0 , Pos

   i := GetControlIndex( ControlName , ParentForm )

   If i > 0

      if _HMG_aControlInputmask [i] == .F.
         If Item <= Len ( _HMG_aControlPageMap [i] )
            ItemHandle := _HMG_aControlPageMap [i] [Item]
         EndIf
      Else
         Pos := ascan ( _HMG_aControlPicture [i] , Item )
         If Pos > 0
            ItemHandle := _HMG_aControlPageMap [ i ] [ Pos ]
         EndIf
      EndIf

      If ItemHandle > 0

         SendMessage (   _HMG_aControlhandles [i] ,;
            TVM_EXPAND,;
            TVE_COLLAPSE,;
            ItemHandle )

      EndIf

   EndIf

Return

*-----------------------------------------------------------------------------*
Procedure _Expand ( ControlName , ParentForm , Item )
*-----------------------------------------------------------------------------*
   Local i , ItemHandle := 0 , Pos

   i := GetControlIndex( ControlName , ParentForm )

   If i > 0

      If _HMG_aControlInputmask [i] == .F.
         If Item <= Len ( _HMG_aControlPageMap [i] )
            ItemHandle := _HMG_aControlPageMap [i] [Item]
         EndIf
      Else
         Pos := ascan ( _HMG_aControlPicture [i] , Item )
         If Pos > 0
            ItemHandle := _HMG_aControlPageMap [ i ] [ Pos ]
         EndIf
      EndIf

      If ItemHandle > 0

         SendMessage ( _HMG_aControlHandles [i], TVM_EXPAND, TVE_EXPAND, ItemHandle )

      EndIf

   EndIf

Return

*-----------------------------------------------------------------------------*
Procedure TreeView_SetBkColor( hWnd, aColor )
*-----------------------------------------------------------------------------*
   Local ColorRef := RGB(aColor[1], aColor[2], aColor[3])
   SendMessage(hWnd, TVM_SETBKCOLOR, 0, ColorRef)
Return

*-----------------------------------------------------------------------------*
Function TreeView_GetBkColor ( hWnd )
*-----------------------------------------------------------------------------*
   Local ColorRef := SendMessage(hWnd, TVM_GETBKCOLOR, 0, 0)
Return {GetRed(ColorRef), GetGreen(ColorRef), GetBlue(ColorRef)}

*-----------------------------------------------------------------------------*
Procedure TreeView_SetTextColor ( hWnd, aColor )
*-----------------------------------------------------------------------------*
   Local ColorRef := RGB(aColor[1], aColor[2], aColor[3])
   SendMessage(hWnd, TVM_SETTEXTCOLOR, 0, ColorRef)
Return

*-----------------------------------------------------------------------------*
Function TreeView_GetTextColor ( hWnd )
*-----------------------------------------------------------------------------*
   Local ColorRef := SendMessage(hWnd, TVM_GETTEXTCOLOR, 0, 0)
Return {GetRed(ColorRef), GetGreen(ColorRef), GetBlue(ColorRef)}

*-----------------------------------------------------------------------------*
Procedure TreeView_SetLineColor ( hWnd, aColor )
*-----------------------------------------------------------------------------*
   Local ColorRef := RGB(aColor[1], aColor[2], aColor[3])
   SendMessage(hWnd, TVM_SETLINECOLOR, 0, ColorRef)
Return

*-----------------------------------------------------------------------------*
Function TreeView_GetLineColor ( hWnd )
*-----------------------------------------------------------------------------*
   Local ColorRef := SendMessage(hWnd, TVM_GETLINECOLOR, 0, 0)
Return {GetRed(ColorRef), GetGreen(ColorRef), GetBlue(ColorRef)}

*-----------------------------------------------------------------------------*
Procedure TreeView_SetItemHeight( hWnd, nHeight )
*-----------------------------------------------------------------------------*
   SendMessage(hWnd, TVM_SETITEMHEIGHT, nHeight, 0)
Return

*-----------------------------------------------------------------------------*
Function TreeView_GetItemHeight( hWnd )
*-----------------------------------------------------------------------------*
Return SendMessage(hWnd, TVM_GETITEMHEIGHT, 0, 0)

*-----------------------------------------------------------------------------*
Procedure TreeView_SetIndent( hWnd, nIndent )
*-----------------------------------------------------------------------------*
   SendMessage(hWnd, TVM_SETINDENT, nIndent, 0)
Return

*-----------------------------------------------------------------------------*
Function TreeView_GetIndent( hWnd )
*-----------------------------------------------------------------------------*
Return SendMessage(hWnd, TVM_GETINDENT, 0, 0)