/*----------------------------------------------------------------------------
MINIGUI - Harbour Win32 GUI library source code

Copyright 2002-2008 Roberto Lopez <harbourminigui@gmail.com>
http://harbourminigui.googlepages.com/

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along with
   this software; see the file COPYING. If not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or
   visit the web site http://www.gnu.org/).

   As a special exception, you have permission for additional uses of the text
   contained in this release of Harbour Minigui.

   The exception is that, if you link the Harbour Minigui library with other
   files to produce an executable, this does not by itself cause the resulting
   executable to be covered by the GNU General Public License.
   Your use of that executable is in no way restricted on account of linking the
   Harbour-Minigui library code into it.

   Parts of this project are based upon:

   "Harbour GUI framework for Win32"
   Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
   Copyright 2001 Antonio Linares <alinares@fivetech.com>
   www - http://www.harbour-project.org

   "Harbour Project"
   Copyright 1999-2008, http://www.harbour-project.org/

   "WHAT32"
   Copyright 2002 AJ Wos <andrwos@aust1.net>

   "HWGUI"
   Copyright 2001-2007 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#include "minigui.ch"

*-----------------------------------------------------------------------------*
Function _SetWindowProperty ( ParentForm, PropName, Value, lDirect )
*-----------------------------------------------------------------------------*
   Default lDirect := .f.

   If Valtype( ParentForm ) == 'U'
      if _HMG_BeginWindowMdiActive = TRUE
         ParentForm := GetActiveMdiHandle()
      else
         if _HMG_BeginWindowActive = TRUE .or. _HMG_BeginDialogActive = TRUE
            ParentForm := if(_HMG_BeginDialogActive, _HMG_ActiveDialogName, _HMG_ActiveFormName)
         endif
      endif
   endif
   if Valtype(ParentForm) == 'C'
      If .Not. _IsWindowDefined (ParentForm)
         MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated")
      Endif
      ParentForm := GetFormHandle (ParentForm)
   endif

   if !SetProp( ParentForm, PropName, Value, lDirect )
      MsgMiniGuiError("Property: "+PropName+ " in Window: "+ ParentForm + " is not defined. Program terminated")
   Endif

Return Nil

*-----------------------------------------------------------------------------*
Function _GetWindowProperty ( ParentForm, PropName, lDirect )
*-----------------------------------------------------------------------------*
   Local Value

   If Valtype( ParentForm ) == 'U'
      if _HMG_BeginWindowMdiActive = TRUE
         ParentForm := GetActiveMdiHandle()
      else
         if _HMG_BeginWindowActive = TRUE .or. _HMG_BeginDialogActive = TRUE
            ParentForm := if(_HMG_BeginDialogActive, _HMG_ActiveDialogName, _HMG_ActiveFormName)
         endif
      endif
   endif
   if Valtype(ParentForm) == 'C'
      If .Not. _IsWindowDefined (ParentForm)
         MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated")
      Endif
      ParentForm := GetFormHandle (ParentForm)
   endif

   Value := GetProp( ParentForm, PropName, Value, lDirect )
   IF Valtype(Value) == "U"
      MsgMiniGuiError("Property: "+PropName+ " in Window: "+ ParentForm + " is not defined. Program terminated")
   Endif

Return Value

*-----------------------------------------------------------------------------*
Function _RemoveProperty ( ParentForm, PropName , lNoFree)
*-----------------------------------------------------------------------------*
   Default lNoFree := .f.

   If Valtype( ParentForm ) == 'U'
      if _HMG_BeginWindowMdiActive = TRUE
         ParentForm := GetActiveMdiHandle()
      else
         if _HMG_BeginWindowActive = TRUE .or. _HMG_BeginDialogActive = TRUE
            ParentForm := if(_HMG_BeginDialogActive, _HMG_ActiveDialogName, _HMG_ActiveFormName)
         endif
      endif
   endif
   if Valtype(ParentForm) == 'C'
      If .Not. _IsWindowDefined (ParentForm)
         MsgMiniGuiError("Window: "+ ParentForm + " is not defined. Program terminated")
      Endif
      ParentForm := GetFormHandle (ParentForm)
   endif

   RemoveProp( ParentForm, PropName, lNoFree )

Return Nil