/*
 *
 * MINIGUI EXTENDED PROJECT MANAGER
 *
 * Based on Harbour MiniGui Project Manager by Roberto Lopez
 * Copyright (c) 2003 Roberto Lopez <roblez@ciudad.com.ar>
 *
 * MiniGUI Extended version by the MiniGUI team
 * Last modifed 2008.01.07 by 
 * Grigory Filatov <gfilatov@freemail.ru> and
 * Kevin Carmody <i@kevincarmody.com>
 *
*/

//***************************************************************************

ANNOUNCE RDDSYS

#include "minigui.ch"
#include "directry.ch"

#define SOUFILE_NAME      1
#define SOUFILE_BASE      2
#define SOUFILE_EXT       3
#define SOUFILE_DEPEND    4
#define SOUFILE_TOTAL     4

#DEFINE MPMB_NOLOCFILE    -101
#DEFINE MPMB_NOLOCREAD    -102
#DEFINE MPMB_NOBUILDFILE  -103

STATIC cProjFile  := ''
STATIC cProjName  := ''
STATIC aFileHist  := {'', '', '', '', '', '', '', '', ''}
STATIC aSouFiles  := {}
STATIC lProcess   := .N.
STATIC lProjMod   := .N.
STATIC lEnvir     := .N.
STATIC lGo        := .N.
STATIC cMpmTitle  := 'MiniGUI Extended Project Manager'
STATIC cMpmDate   := '2008.01.07'

STATIC cBccFolder      := ''
STATIC cMiniGuiFolder  := ''
STATIC cOHarbourFolder := ''
STATIC cXHarbourFolder := ''
STATIC cEditorExe      := ''

STATIC nMpmWidth     := 0
STATIC nMpmHeight    := 0
STATIC nMpmCol       := 0
STATIC nMpmRow       := 0
STATIC nRecentWidth  := 0
STATIC nRecentHeight := 0
STATIC nRecentCol    := 0
STATIC nRecentRow    := 0
STATIC nEnvirWidth   := 0
STATIC nEnvirHeight  := 0
STATIC nEnvirCol     := 0
STATIC nEnvirRow     := 0
STATIC nHelpWidth    := 0
STATIC nHelpHeight   := 0
STATIC nHelpCol      := 0
STATIC nHelpRow      := 0

//***************************************************************************

PROCEDURE Main(cProjArg)
  
  LOCAL cTab := CHR(9)
  
  LoadEnvironment()
  SET FONT TO 'MS Sans Serif', 9

  DEFINE WINDOW Mpm ;
    AT nMpmRow, nMpmCol ;
    WIDTH  nMpmWidth ;
    HEIGHT nMpmHeight ;
    TITLE  cMpmTitle ;
    MAIN ;
    ICON 'MAIN' ;
    ON INIT     (SizeMpm(), IF(lEnvir, NIL, SetEnvironment(.Y.))) ;
    ON MOVE     SizeMpm() ;
    ON SIZE     SizeMpm() ;
    ON MAXIMIZE SizeMpm(.Y.) ;
    ON RELEASE  SaveEnvironment()

    DEFINE MAIN MENU 
      POPUP '&File'
        ITEM '&New'                     ACTION New()
        ITEM '&Open...'  + cTab + 'F3'  ACTION Open()
        ITEM '&Save'     + cTab + 'F2'  ACTION Save()
        ITEM 'Save &As...'              ACTION SaveAs()
        SEPARATOR
        ITEM '&Recent...'               ACTION Recent()
        SEPARATOR
        ITEM '&Exit'     + cTab + 'F10' ACTION Exit()
      END POPUP
      POPUP '&Project'
        ITEM '&Build'    + cTab + 'F4'  ACTION Build()
        ITEM '&Stop...'  + cTab + 'F5'  ACTION StopBuild()
        ITEM '&Run'      + cTab + 'F6'  ACTION Execute()
        SEPARATOR
        ITEM '&Debug'                   ACTION SwitchDebug(.Y., .Y.) ;
          NAME miDebug
        ITEM 'R&ebuild'                 ACTION SwitchRebuild(.Y., .Y.) ;
          NAME miRebuild
        SEPARATOR
        ITEM '&Cleanup'                 ACTION Cleanup()
      END POPUP
      POPUP '&Tools'
        ITEM '&Environment...'          ACTION SetEnvironment()
      END POPUP
      POPUP '&Help'
        ITEM '&Contents' + cTab + 'F1'  ACTION Contents()
        SEPARATOR
        ITEM '&About'                   ACTION About()
      END POPUP
    END MENU

    DEFINE TOOLBAR ToolBarMain BUTTONSIZE 45,30 FLAT

      BUTTON New          ;
        CAPTION 'New'     ;
        PICTURE 'new'     ;
        ACTION New()

      BUTTON Open         ;
        CAPTION 'Open'    ;
        PICTURE 'open'    ;
        ACTION Open()

      BUTTON Save         ;
        CAPTION 'Save'    ;
        PICTURE 'save'    ;
        ACTION Save()     ;
        SEPARATOR

      BUTTON Build        ;
        CAPTION 'Build'   ;
        PICTURE 'build'   ;
        ACTION Build() 

      BUTTON Stop         ;
        CAPTION 'Stop'    ;
        PICTURE 'stop'    ;
        ACTION StopBuild() 

      BUTTON Run          ;
        CAPTION 'Run'     ;
        PICTURE 'run'     ;
        ACTION Execute()  ;
        SEPARATOR

      BUTTON Help         ;
        CAPTION 'Help'    ;
        PICTURE 'help'    ;
        ACTION Contents() ;
        SEPARATOR

    END TOOLBAR

    DEFINE FRAME frMpm
      ROW     40
      COL     1
      WIDTH   nMpmWidth  - 10
      HEIGHT  nMpmHeight - 90
    END FRAME

    DEFINE TAB Project ;
      AT     50, 10 ;
      WIDTH  310 ;
      HEIGHT nMpmHeight - 110

      PAGE 'Sources'

        DEFINE LABEL lbBaseFolder
          ROW   30
          COL   11
          VALUE   'Base folder'
        END LABEL

        DEFINE TEXTBOX BaseFolder
          ROW     55
          COL     11
          WIDTH   250
          HEIGHT  22
        END TEXTBOX

        DEFINE BUTTON btBaseFolder
          ROW     55
          COL     270
          WIDTH   25
          HEIGHT  25
          PICTURE 'folderselect'
          TOOLTIP 'Select base folder'
          ONCLICK GetBaseFolder()
        END BUTTON

        DEFINE BUTTON AddSource
          ROW     90
          COL     11
          WIDTH   41
          HEIGHT  25
          PICTURE 'add'
          TOOLTIP 'Add source files'
          ONCLICK AddSourceFiles()
        END BUTTON

        DEFINE BUTTON RemoveSource
          ROW     90
          COL     60
          WIDTH   41
          HEIGHT  25
          PICTURE 'remove'
          TOOLTIP 'Remove source file'
          ONCLICK RemoveSourceFile()
        END BUTTON

        DEFINE BUTTON EditSource
          ROW     90
          COL     108
          WIDTH   41
          HEIGHT  25
          PICTURE 'Edit'
          TOOLTIP 'Edit source file'
          ONCLICK EditProgram()
        END BUTTON

        DEFINE BUTTON SetMainSource
          ROW     90
          COL     156
          WIDTH   41
          HEIGHT  25
          PICTURE 'SetTop'
          TOOLTIP 'Set main source file'
          ONCLICK SetMain()
        END BUTTON

        DEFINE BUTTON MoveUpSource
          ROW     90
          COL     205
          WIDTH   41
          HEIGHT  25
          PICTURE 'Up'
          TOOLTIP 'Move source file up'
          ONCLICK MoveSource(.Y.)
        END BUTTON

        DEFINE BUTTON MoveDownSource
          ROW     90
          COL     253
          WIDTH   41
          HEIGHT  25
          PICTURE 'Down'
          TOOLTIP 'Move source file down'
          ONCLICK MoveSource(.N.)
        END BUTTON

        DEFINE LISTBOX SourceList
          ROW     125
          COL     11
          WIDTH   283
          HEIGHT  Mpm.Height - 250
          ONCHANGE    LoadDependents()
          ONDBLCLICK  EditProgram()
        END LISTBOX

      END PAGE

      PAGE 'Dependents'

        DEFINE LABEL lbFile
          ROW   30
          COL   11
          WIDTH 290
          VALUE 'No source file selected'
        END LABEL

        DEFINE BUTTON AddDependent
          ROW     55
          COL     11
          WIDTH   50
          HEIGHT  25
          PICTURE 'add'
          TOOLTIP 'Add dependent files'
          ONCLICK AddDependents()
        END BUTTON

        DEFINE BUTTON RemoveDependent
          ROW     55
          COL     70
          WIDTH   50
          HEIGHT  25
          PICTURE 'remove'
          TOOLTIP 'Remove dependent file'
          ONCLICK RemoveDependent()
        END BUTTON

        DEFINE BUTTON EditDependent
          ROW     55
          COL     128
          WIDTH   50
          HEIGHT  25
          PICTURE 'Edit'
          TOOLTIP 'Edit dependent file'
          ONCLICK EditDependent()
        END BUTTON

        DEFINE BUTTON MoveUpDependent
          ROW     55
          COL     186
          WIDTH   50
          HEIGHT  25
          PICTURE 'Up'
          TOOLTIP 'Move dependent file up'
          ONCLICK MoveDependent(.Y.)
        END BUTTON

        DEFINE BUTTON MoveDownDependent
          ROW     55
          COL     244
          WIDTH   50
          HEIGHT  25
          PICTURE 'Down'
          TOOLTIP 'Move dependent file down'
          ONCLICK MoveDependent(.N.)
        END BUTTON

        DEFINE LISTBOX DependList
          ROW     90
          COL     10
          WIDTH   283
          HEIGHT  Mpm.Height - 220
          ONDBLCLICK  EditDependent()
        END LISTBOX

      END PAGE

      PAGE 'Options' 

        DEFINE CHECKBOX Debug
          ROW     30
          COL     12
          WIDTH   160
          CAPTION 'Create debug EXE'
          TOOLTIP 'Compile and link in debug mode'
          ON CHANGE SwitchDebug(.N., .Y.)
        END CHECKBOX

        DEFINE CHECKBOX Rebuild
          ROW     55
          COL     12
          WIDTH   160
          CAPTION 'Always rebuild project'
          TOOLTIP 'Rebuild project regardless of source file dates'
          ON CHANGE SwitchRebuild(.N., .Y.)
        END CHECKBOX

        DEFINE CHECKBOX RunAfter
          ROW     80
          COL     12
          WIDTH   160
          CAPTION 'Run after build'
          VALUE   .Y.
          TOOLTIP 'Run EXE immediately after successful build'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE CHECKBOX HideBuild
          ROW     105
          COL     12
          WIDTH   160
          CAPTION 'Hide build window'
          VALUE   .Y.
          TOOLTIP 'Hide the temporary window in which the build process runs'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE CHECKBOX DeleteTemp
          ROW     130
          COL     12
          WIDTH   160
          CAPTION 'Delete temporary files'
          VALUE   .Y.
          TOOLTIP 'Delete temporary files created by the build process'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE CHECKBOX UseXHarbour
          ROW     155
          COL     12
          WIDTH   160
          CAPTION 'Use xHarbour'
          TOOLTIP 'Use xHarbour instead of Harbour - requires xHarbour path'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE CHECKBOX GenPpo
          ROW     180
          COL     12
          WIDTH   160
          CAPTION 'Generate PPO'
          TOOLTIP 'Generate preprocessor output file (PPO) ' + ;
            'for each PRG file'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE LABEL lbPrgParams
          ROW     215
          COL     12
          WIDTH   160
          VALUE   'Additional compiler options'
        END LABEL

        DEFINE TEXTBOX PrgParams
          ROW     235
          COL     12
          WIDTH   160
          HEIGHT  22
          TOOLTIP 'Parameters to add to command line when compiling PRG files'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END TEXTBOX

        DEFINE LABEL lbExeParams
          ROW     265
          COL     12
          WIDTH   160
          VALUE   'EXE command line options'
        END LABEL

        DEFINE TEXTBOX ExeParams
          ROW     285
          COL     12
          WIDTH   160
          HEIGHT  22
          TOOLTIP 'Parameters to add to command line when running EXE'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END TEXTBOX

        DEFINE LABEL lbExeType
          ROW     40
          COL     182
          WIDTH   120
          VALUE   'Executable type'
        END LABEL

        DEFINE RADIOGROUP ExeType
          ROW     65
          COL     202
          WIDTH   100
          SPACING 25
          OPTIONS {'GUI', 'Console', 'Mixed'}
          VALUE   1
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END RADIOGROUP

        DEFINE LABEL lbWarnings
          ROW     155
          COL     182
          WIDTH   120
          VALUE   'Compiler warnings'
        END LABEL

        DEFINE RADIOGROUP Warnings
          ROW     180
          COL     202
          WIDTH   100
          SPACING 25
          OPTIONS {'None', 'Basic', 'Strong', 'Typed'}
          VALUE   1
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END RADIOGROUP

        DEFINE CHECKBOX GenLib
          ROW     295
          COL     182
          WIDTH   120
          CAPTION 'Generate library'
          TOOLTIP 'Generate library (LIB) file instead of executable (EXE)'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

      END PAGE

      PAGE 'Libraries and object files'

        DEFINE CHECKBOX ZipLib
          ROW     30
          COL     12
          WIDTH   160
          CAPTION 'ZIP support'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE CHECKBOX OdbcLib
          ROW     55
          COL     12
          WIDTH   160
          CAPTION 'ODBC support'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE CHECKBOX AdsLib
          ROW     80
          COL     12
          WIDTH   160
          CAPTION 'ADS support'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE CHECKBOX MySqlLib
          ROW     105
          COL     12
          WIDTH   160
          CAPTION 'MySQL support'
          ON CHANGE (lProjMod := .Y., StatusLabel())
        END CHECKBOX

        DEFINE LABEL lbAddLib
          ROW     140
          COL     12
          WIDTH   160
          VALUE   'Additional libraries and object files'
        END LABEL

        DEFINE BUTTON AddHarbour
          ROW     165
          COL     12
          WIDTH   41
          HEIGHT  25
          PICTURE 'addh'
          TOOLTIP 'Add additional (x)Harbour library to link script'
          ONCLICK AddLibFiles('H')
        END BUTTON

        DEFINE BUTTON AddMiniGui
          ROW     165
          COL     60
          WIDTH   41
          HEIGHT  25
          PICTURE 'addm'
          TOOLTIP 'Add additional MiniGui library to link script'
          ONCLICK AddLibFiles('M')
        END BUTTON

        DEFINE BUTTON AddOther
          ROW     165
          COL     108
          WIDTH   41
          HEIGHT  25
          PICTURE 'addo'
          TOOLTIP 'Add additional library or object file to link script'
          ONCLICK AddLibFiles('O')
        END BUTTON

        DEFINE BUTTON RemoveLib
          ROW     165
          COL     156
          WIDTH   41
          HEIGHT  25
          PICTURE 'remove'
          TOOLTIP 'Remove library or object file'
          ONCLICK RemoveLib()
        END BUTTON

        DEFINE BUTTON MoveUpLib
          ROW     165
          COL     204
          WIDTH   41
          HEIGHT  25
          PICTURE 'up'
          TOOLTIP 'Move library or object file up'
          ONCLICK MoveLib(.Y.)
        END BUTTON

        DEFINE BUTTON MoveDownLib
          ROW     165
          COL     252
          WIDTH   41
          HEIGHT  25
          PICTURE 'down'
          TOOLTIP 'Move library or object file down'
          ONCLICK MoveLib(.N.)
        END BUTTON

        DEFINE LISTBOX LibList
          ROW     200
          COL     11
          WIDTH   282
          HEIGHT  Mpm.Height - 330
        END LISTBOX

      END PAGE

    END TAB

    DEFINE LABEL lbStatus
      ROW     15
      COL     355
      WIDTH   140
      VALUE   ''
      FONTBOLD .Y.
    END LABEL

    DEFINE LABEL lbDebug
      ROW     15
      COL     505
      WIDTH   45
      VALUE   ''
      FONTCOLOR PURPLE
    END LABEL

    DEFINE LABEL lbRebuild
      ROW     15
      COL     555
      WIDTH   45  
      VALUE   ''
      FONTCOLOR BLUE
    END LABEL

    DEFINE EDITBOX Log
      ROW     60
      COL     335
      WIDTH   Mpm.Width  - 354
      HEIGHT  Mpm.Height - 140
      READONLY   .Y.
      HSCROLLBAR .N.
    END EDITBOX

    DEFINE LABEL Keys
      ROW     Mpm.Height - 70
      COL     335
      WIDTH   Mpm.Width  - 354
      VALUE   'F1 Help - F2 Save - F3 Open - F4 Build - F5 Stop - F6 Run - F10 Exit'
    END LABEL

    DEFINE TIMER tmStatus ;
      INTERVAL 500 ;
      ACTION StatusRefresh()

    ON KEY F1  ACTION Contents()
    ON KEY F2  ACTION Save()
    ON KEY F3  ACTION Open()
    ON KEY F4  ACTION Build()
    ON KEY F5  ACTION StopBuild()
    ON KEY F6  ACTION Execute()
    ON KEY F10 ACTION Exit()

  END WINDOW

  IF !EMPTY(cProjArg)
    Open(cProjArg)
  ENDIF

  Mpm.MinWidth  := 675
  Mpm.MinHeight := 480

  ACTIVATE WINDOW Mpm

RETURN

//***************************************************************************

PROCEDURE SizeMpm(lMax)

LOCAL lThemed := IsXPThemeActive()
LOCAL nWidth  := Mpm.Width
LOCAL nHeight := Mpm.Height
LOCAL nCol    := Mpm.Col   
LOCAL nRow    := Mpm.Row   

  IF EMPTY(lMax)
    nMpmWidth  := nWidth
    nMpmHeight := nHeight
    nMpmCol    := nCol   
    nMpmRow    := nRow   
  ENDIF
  Mpm.frMpm.Width       := Mpm.Width  - 10
  Mpm.frMpm.Height      := Mpm.Height - 90 - IF(lThemed, 5, 0)
  Mpm.Project.Height    := Mpm.Height - 110 - IF(lThemed, 5, 0)
  Mpm.SourceList.Height := MAX(50, nHeight - 250 - IF(lThemed, 20, 0))
  Mpm.DependList.Height := MAX(50, nHeight - 220 - IF(lThemed, 15, 0))
  Mpm.LibList.Height    := MAX(50, nHeight - 330 - IF(lThemed, 15, 0))
  Mpm.Log.Width         := MAX(90, nWidth  - 354)
  Mpm.Log.Height        := MAX(50, nHeight - 140 - IF(lThemed, 7, 0))
  Mpm.Keys.Row          := MAX(50, nHeight -  70 - IF(lThemed, 7, 0))
  Mpm.Keys.Width        := MAX(50, nWidth  - 354)

RETURN

//***************************************************************************

PROCEDURE GetBaseFolder

  LOCAL cFolder := GetFolder('Base folder', Mpm.BaseFolder.Value)

  IF !EMPTY(cFolder)
    Mpm.BaseFolder.Value := cFolder
    lProjMod := .Y.
  ENDIF

RETURN

//***************************************************************************

PROCEDURE New

  SaveCheck()
  cProjName := ''
  Mpm.Title := cMpmTitle
  Mpm.BaseFolder.Value  := ''
  Mpm.Debug.Value       := .N.
  Mpm.Rebuild.Value     := .N.
  Mpm.RunAfter.Value    := .Y.
  Mpm.HideBuild.Value   := .Y.
  Mpm.DeleteTemp.Value  := .Y.
  Mpm.UseXHarbour.Value := .N.
  Mpm.GenPpo.Value      := .N.
  Mpm.ExeType.Value     := 1
  Mpm.Warnings.Value    := 2
  Mpm.GenLib.Value      := .N.
  Mpm.PrgParams.Value   := ''
  Mpm.ExeParams.Value   := ''
  Mpm.ZipLib.Value      := .N.
  Mpm.OdbcLib.Value     := .N.
  Mpm.AdsLib.Value      := .N.
  Mpm.MySqlLib.Value    := .N.
  Mpm.Log.Value         := ''
  Mpm.LibList.DeleteAllItems
  aSouFiles := {}
  RefreshSource()
  SwitchDebug(.N., .N.)
  SwitchRebuild(.N., .N.)
  StatusLabel()
  lProjMod := .N.
  GetBaseFolder()

RETURN

//***************************************************************************

PROCEDURE Open(cProjOpen)

  LOCAL aExeType  := {'GUI', 'CONSOLE', 'MIXED'}
  LOCAL aWarnings := {'NONE', 'BASIC', 'STRONG', 'TYPED'}
  LOCAL aDepend   := {}
  LOCAL cProjExt
  LOCAL cCont
  LOCAL cExt
  LOCAL cLine
  LOCAL cLineU
  LOCAL cKey
  LOCAL cVal
  LOCAL cValU
  LOCAL nLine
  LOCAL nPos

  BEGIN SEQUENCE
    
    SaveCheck()
    IF EMPTY(cProjOpen)
      cProjOpen := GetFile({ ;
        {'Harbour MiniGUI project files (*.mpm)', '*.mpm'}, ;
        {'(x)Harbour source files (*.prg)'      , '*.prg'}, ;
        {'C source files (*.c)'                 , '*.c'  }},;
        'Open project or source file', Mpm.BaseFolder.Value)
    ENDIF
    IF EMPTY(cProjOpen)
      BREAK
    END
    IF !FILE(cProjOpen)
      MpmStop('Cannot find ' + cProjOpen + '.')
      BREAK
    ENDIF
    
    Mpm.BaseFolder.Value  := ''
    Mpm.Debug.Value       := .N.
    Mpm.Rebuild.Value     := .N.
    Mpm.RunAfter.Value    := .Y.
    Mpm.HideBuild.Value   := .Y.
    Mpm.DeleteTemp.Value  := .Y.
    Mpm.UseXHarbour.Value := .N.
    Mpm.GenPpo.Value      := .N.
    Mpm.ExeType.Value     := 1
    Mpm.Warnings.Value    := 2
    Mpm.GenLib.Value      := .N.
    Mpm.PrgParams.Value   := ''
    Mpm.ExeParams.Value   := ''
    Mpm.ZipLib.Value      := .N.
    Mpm.OdbcLib.Value     := .N.
    Mpm.AdsLib.Value      := .N.
    Mpm.MySqlLib.Value    := .N.
    Mpm.Log.Value         := ''
    Mpm.LibList.DeleteAllItems
    aSouFiles := {}
    cProjExt  := UPPER(GetExt(cProjOpen))

    DO CASE
    CASE cProjExt == '.MPM'
      
      cCont := MEMOREAD(cProjOpen)
      IF EMPTY(cCont)
        MpmStop('Cannot read ' + cProjOpen + '.')
        BREAK
      ENDIF

      cProjFile := GetPath(cProjOpen)
      cProjName := GetName(cProjFile)
      Mpm.Title := cProjName + ' - ' + cMpmTitle

      FOR nLine := 1 TO MLCOUNT(cCont)
        cLine  := ALLTRIM(MEMOLINE(cCont,, nLine))
        cLineU := UPPER(cLine)
        nPos   := AT('=', cLine)
        cKey   := STRTRAN(LEFT(cLineU, nPos - 1), ' ')
        cVal   := ALLTRIM(SUBSTR(cLine, nPos + 1))
        cValU  := UPPER(cVal)
        cExt   := UPPER(GetExt(cLine))
        DO CASE
        CASE cKey == 'PROJECTFOLDER'
          Mpm.BaseFolder.Value := cVal
        CASE cKey == 'DEBUG'
          Mpm.Debug.Value       := ('Y' $ cValU)
        CASE cKey == 'REBUILD'
          Mpm.Rebuild.Value     := ('Y' $ cValU)
        CASE cKey == 'RUNAFTER'
          Mpm.RunAfter.Value    := ('Y' $ cValU)
        CASE cKey == 'HIDEBUILD'
          Mpm.HideBuild.Value   := ('Y' $ cValU)
        CASE cKey == 'DELETETEMP'
          Mpm.DeleteTemp.Value  := ('Y' $ cValU)
        CASE cKey == 'XHARBOUR'
          Mpm.UseXHarbour.Value := ('Y' $ cValU)
        CASE cKey == 'GENPPO'
          Mpm.GenPpo.Value      := ('Y' $ cValU)
        CASE cKey == 'EXETYPE'
          nPos := ASCAN(aExeType , cValU)
          Mpm.ExeType.Value     := IF(EMPTY(nPos), 1, nPos)
        CASE cKey == 'WARNINGS'
          nPos := ASCAN(aWarnings, cValU)
          Mpm.Warnings.Value    := IF(EMPTY(nPos), 2, nPos)
        CASE cKey == 'GENLIB'
          Mpm.GenLib.Value      := ('Y' $ cValU)
        CASE cKey == 'PRGPARAMS'
          Mpm.PrgParams.Value   := cVal
        CASE cKey == 'EXEPARAMS'
          Mpm.ExeParams.Value   := cVal
        CASE cKey == 'ZIPSUPPORT' 
          Mpm.ZipLib.Value      := ('Y' $ cValU)
        CASE cKey == 'ODBCSUPPORT'
          Mpm.OdbcLib.Value     := ('Y' $ cValU)
        CASE cKey == 'ADSSUPPORT'
          Mpm.AdsLib.Value      := ('Y' $ cValU)
        CASE cKey == 'MYSQLSUPPORT'
          Mpm.MySqlLib.Value    := ('Y' $ cValU)
        CASE LEFT(cLine, 1) == '/'
          AADD(aDepend, ALLTRIM(SUBSTR(cLine, 2)))
        CASE cExt $ '.LIB/.OBJ/.RES'
          Mpm.LibList.AddItem(cLine)
        CASE cExt $ '.PRG/.CH/.FMG/.RC/.C/.H'
          aDepend := {}
          AddSourceFile(cLine, aDepend)
        ENDCASE
      NEXT

      UpdateFileHist()
      lProjMod := .N.

    CASE cProjExt $ '.PRG/.C'
      
      cProjFile := ''
      cProjName := ''
      Mpm.Title := cMpmTitle
      Mpm.BaseFolder.Value := GetSub(cProjOpen, .Y.)
      AddSourceFile(GetName(cProjOpen))
      UpdateFileHist()
      lProjMod  := .Y.

    ENDCASE

    RefreshSource()
    SwitchDebug(.N., .N.)
    SwitchRebuild(.N., .N.)
    StatusLabel()

  END SEQUENCE

RETURN


//***************************************************************************

PROCEDURE Save

  LOCAL aExeType  := {'GUI', 'CONSOLE', 'MIXED'}
  LOCAL aWarnings := {'NONE', 'BASIC', 'STRONG', 'TYPED'}
  LOCAL bYesNo    := {|lVal| IF(lVal, 'YES', 'NO')}
  LOCAL cCont     := ''
  LOCAL aFile
  LOCAL nFiles
  LOCAL nFile

  BEGIN SEQUENCE
    
    IF EMPTY(cProjFile)
      SaveAs()
      BREAK
    ENDIF

    cCont += 'PROJECTFOLDER=' + ALLTRIM(Mpm.BaseFolder.Value)      + CRLF
    cCont += 'DEBUG='         + bYesNo:EVAL(Mpm.Debug.Value      ) + CRLF
    cCont += 'REBUILD='       + bYesNo:EVAL(Mpm.Rebuild.Value    ) + CRLF
    cCont += 'RUNAFTER='      + bYesNo:EVAL(Mpm.RunAfter.Value   ) + CRLF
    cCont += 'HIDEBUILD='     + bYesNo:EVAL(Mpm.HideBuild.Value  ) + CRLF
    cCont += 'DELETETEMP='    + bYesNo:EVAL(Mpm.DeleteTemp.Value ) + CRLF
    cCont += 'XHARBOUR='      + bYesNo:EVAL(Mpm.UseXHarbour.Value) + CRLF
    cCont += 'GENPPO='        + bYesNo:EVAL(Mpm.GenPpo.Value     ) + CRLF
    cCont += 'EXETYPE='       + aExeType[Mpm.ExeType.Value]        + CRLF
    cCont += 'WARNINGS='      + aWarnings[Mpm.Warnings.Value]      + CRLF
    cCont += 'GENLIB='        + bYesNo:EVAL(Mpm.GenLib.Value     ) + CRLF
    cCont += 'PRGPARAMS='     + ALLTRIM(Mpm.PrgParams.Value)       + CRLF
    cCont += 'EXEPARAMS='     + ALLTRIM(Mpm.ExeParams.Value)       + CRLF
    cCont += 'ZIPSUPPORT='    + bYesNo:EVAL(Mpm.ZipLib.Value   )   + CRLF
    cCont += 'ODBCSUPPORT='   + bYesNo:EVAL(Mpm.OdbcLib.Value  )   + CRLF
    cCont += 'ADSSUPPORT='    + bYesNo:EVAL(Mpm.AdsLib.Value   )   + CRLF
    cCont += 'MYSQLSUPPORT='  + bYesNo:EVAL(Mpm.MySqlLib.Value )   + CRLF

    nFiles := Mpm.LibList.ItemCount
    FOR nFile := 1 TO nFiles
      cCont += ALLTRIM(Mpm.LibList.Item(nFile)) + CRLF
    NEXT

    nFiles := LEN(aSouFiles)
    FOR nFile := 1 TO nFiles
      aFile   := aSouFiles[nFile]
      cCont   += aFile[SOUFILE_NAME] + CRLF
      AEVAL(aFile[SOUFILE_DEPEND], {|cRow| cCont += '/ ' + cRow + CRLF})
    NEXT

    IF MemoWrite(cProjFile, cCont)
      StatusLabel('Save successful', 0)
      lProjMod := .N.
    ELSE
      StatusLabel('Save unsuccessful', 1)
    ENDIF   

    UpdateFileHist()

  END SEQUENCE
  
RETURN

//***************************************************************************

PROCEDURE SaveAs

  LOCAL cProjFolder    := Mpm.BaseFolder.Value
  LOCAL nSouFiles      := LEN(aSouFiles)
  LOCAL cDefProjFile   := IF(EMPTY(cProjFile), IF(EMPTY(nSouFiles), '', ;
    aSouFiles[1][SOUFILE_BASE] + '.mpm'), cProjFile)
  LOCAL cGetProjFile   := ALLTRIM( ;
    PutFile({{'Harbour MiniGUI project files (*.mpm)','*.mpm'}}, ;
    'Save Project', Mpm.BaseFolder.Value,, cDefProjFile))

  IF !EMPTY(cGetProjFile)
    IF !(UPPER(GetExt(cGetProjFile)) == '.MPM')
      cGetProjFile += '.mpm'
    ENDIF
    IF !FILE(cGetProjFile) .OR. ;
      MpmYesNo(cGetProjFile + ' already exists.  Replace it?')
      cProjFile := cGetProjFile
      cProjName := GetName(cProjFile)
      Mpm.Title := cProjName + ' - ' + cMpmTitle
      Save()
    ENDIF
  ENDIF

RETURN

//***************************************************************************

PROCEDURE SaveCheck
  
  IF lProjMod .AND. MpmYesNo('Save the current project?')
    IF EMPTY(cProjFile)
      SaveAs()  
    ELSE
      Save()
    ENDIF
  ENDIF

RETURN

//***************************************************************************

PROCEDURE Recent
  
  LOCAL nFile

  DEFINE WINDOW Recent ;
    AT     nRecentRow, nRecentCol ;
    WIDTH  nRecentWidth ;
    HEIGHT nRecentHeight ;
    TITLE  'Recent projects' ;
    ICON   'MAIN' ;
    MODAL ;
    ON INIT RecentSize() ;
    ON MOVE RecentSize() ;
    ON SIZE RecentSize()
  
    DEFINE LISTBOX ProjList
      ROW     10
      COL     10
      WIDTH   300
      HEIGHT  140
      ITEMS   aFileHist
      VALUE   1
      ONDBLCLICK (nFile := Recent.ProjList.Value, Recent.Release)
    END LISTBOX

    DEFINE BUTTON Open
      ROW     160
      COL     85
      WIDTH   65
      HEIGHT  25
      CAPTION '&Open'
      ONCLICK (nFile := Recent.ProjList.Value, Recent.Release)
    END BUTTON

    DEFINE BUTTON Cancel
      ROW     160
      COL     175
      WIDTH   65
      HEIGHT  25
      CAPTION '&Cancel'
      ONCLICK Recent.Release
    END BUTTON

    ON KEY RETURN ACTION (nFile := Recent.ProjList.Value, Recent.Release)
    ON KEY ESCAPE ACTION Recent.Release

  END WINDOW

  Recent.MinWidth  := 185
  Recent.MinHeight := 135

  ACTIVATE WINDOW Recent

  IF !EMPTY(nFile)
    Open(aFileHist[nFile])
  ENDIF

RETURN

//***************************************************************************

PROCEDURE RecentSize
  
LOCAL lThemed := IsXPThemeActive()

  nRecentWidth  := Recent.Width
  nRecentHeight := Recent.Height
  nRecentCol    := Recent.Col
  nRecentRow    := Recent.Row
  Recent.ProjList.Width  := MAX(50, nRecentWidth  - 30)
  Recent.ProjList.Height := MAX(50, nRecentHeight - 80 - IF(lThemed, 7, 0))
  Recent.Open.Col        := MAX(10, INT(nRecentWidth / 2 ) - 80)
  Recent.Open.Row        := MAX(70, nRecentHeight - 60 - IF(lThemed, 7, 0))
  Recent.Cancel.Col      := MAX(10, INT(nRecentWidth / 2 ) + 10)
  Recent.Cancel.Row      := MAX(70, nRecentHeight - 60 - IF(lThemed, 7, 0))

RETURN

//***************************************************************************

PROCEDURE Exit

  IF MpmYesNo('Exit MPM?')
    Mpm.Release
  ENDIF

RETURN

//***************************************************************************

PROCEDURE UpdateFileHist

  LOCAL cProjFolder := AddSlash(Mpm.BaseFolder.Value)
  LOCAL lProjFile   := !EMPTY(cProjFile)      
  LOCAL cProjFileU  := UPPER(cProjFile)
  LOCAL lSouMain    := !EMPTY(aSouFiles)      
  LOCAL cSouMain    := IF(lSouMain, ;
    cProjFolder + aSouFiles[1][SOUFILE_NAME], '')
  LOCAL cSouMainU   := UPPER(cSouMain)
  LOCAL nPos

  DO CASE
  CASE lProjFile .AND. lSouMain
    nPos := ASCAN(aFileHist, {|cVal| ;
      UPPER(cVal) == cProjFileU .OR. UPPER(cVal) == cSouMainU})
  CASE lProjFile
    nPos := ASCAN(aFileHist, {|cVal| UPPER(cVal) == cProjFileU})
  CASE lSouMain
    nPos := ASCAN(aFileHist, {|cVal| UPPER(cVal) == cSouMainU})
  ENDCASE
    
  IF !EMPTY(nPos)
    ADEL(aFileHist, nPos)
  ENDIF
  IF lProjFile .OR. lSouMain
    AINS(aFileHist, 1)
    aFileHist[1] := IF(lProjFile, cProjFile, cSouMain)
  ENDIF

RETURN

//***************************************************************************

PROCEDURE AddSourceFile(cAddFile, aDepend)

  LOCAL aFile := ARRAY(SOUFILE_TOTAL)
  LOCAL cFile := ALLTRIM(cAddFile)

  IF EMPTY(ASCAN(aSouFiles, ;
    {|aRow| UPPER(aRow[SOUFILE_NAME]) == UPPER(cFile)}))
    aFile[SOUFILE_NAME]   := cFile
    aFile[SOUFILE_BASE]   := DelExt(GetName(cFile))
    aFile[SOUFILE_EXT]    := UPPER(GetExt(cFile))
    aFile[SOUFILE_DEPEND] := IF(aDepend == NIL, {}, aDepend)
    AADD(aSouFiles, aFile)
    RefreshSource()
  ENDIF

RETURN

//***************************************************************************

PROCEDURE AddSourceFiles

  LOCAL cBaseFolder  := Mpm.BaseFolder.Value
  LOCAL cBaseFolderU := UPPER(AddSlash(cBaseFolder))
  LOCAL nBaseFolderU := LEN(cBaseFolderU)
  LOCAL lOutBase     := .N.
  LOCAL aNewFiles
  LOCAL aTypes
  LOCAL cNewFile
  LOCAL nFile
  LOCAL nFiles

  BEGIN SEQUENCE

    IF EMPTY(aSouFiles)
      aTypes := { ;
        {'(x)Harbour source files (*.prg)', '*.prg'}, ;
        {'C source files (*.c)'           , '*.c'  }  }
    ELSE
      aTypes := { ;
        {'(x)Harbour source files (*.prg)', '*.prg'}, ;
        {'(x)Harbour header files (*.ch)' , '*.ch' }, ;
        {'Window definition files (*.fmg)', '*.fmg'}, ;
        {'Resource script files (*.rc)'   , '*.rc' }, ;
        {'C source files (*.c)'           , '*.c'  }, ;
        {'C header files (*.h)'           , '*.h'  }  }
    ENDIF
    aNewFiles := GetFile(aTypes, 'Select source files', cBaseFolder, .Y.)

    IF EMPTY(aNewFiles)
      BREAK
    ENDIF

    nFiles := LEN(aNewFiles)
    FOR nFile := 1 TO nFiles
      cNewFile := ALLTRIM(aNewFiles[nFile])
      IF LEFT(UPPER(cNewFile), nBaseFolderU) == cBaseFolderU
        aNewFiles[nFile] := SUBSTR(cNewFile, nBaseFolderU + 1)
      ELSE  
        lOutBase := .Y.
      ENDIF
    NEXT
    IF lOutBase
      MpmStop('Source files must be in the base folder or in folders under it.')
      BREAK
    ENDIF
    
    IF EMPTY(cBaseFolder)
      cNewFile     := ALLTRIM(aNewFiles[1])
      cBaseFolder  := GetSub(cNewFile, .Y.)
      cBaseFolderU := UPPER(AddSlash(cBaseFolder))
      nBaseFolderU := LEN(cBaseFolderU)
      Mpm.BaseFolder.Value := cBaseFolder
    ENDIF 

    ASORT(aNewFiles,,, {|cRow1, cRow2| UPPER(cRow1) <= UPPER(cRow2)})
    FOR nFile := 1 TO nFiles
      AddSourceFile(aNewFiles[nFile])
      lProjMod := .Y.
    NEXT

    StatusLabel()

  END SEQUENCE

RETURN 

//***************************************************************************

PROCEDURE RemoveSourceFile

  LOCAL nFile  := Mpm.SourceList.Value
  LOCAL nFiles := Mpm.SourceList.ItemCount

  BEGIN SEQUENCE
    IF EMPTY(aSouFiles)
      MpmStop('You must add at least one source file.')
      BREAK
    ENDIF
    IF EMPTY(nFile)
      MpmStop('You must select a source file.')
      BREAK
    ENDIF
    IF nFile == 1 .AND. nFiles > 1
      MpmStop('You must remove the main source file last.')
      BREAK
    ENDIF
    IF !MpmYesNo('Remove file ' + ;
      aSouFiles[nFile][SOUFILE_NAME] + ' from this project?')
      BREAK
    ENDIF
    ADelete(aSouFiles, nFile)
    RefreshSource()
    lProjMod := .Y.
    StatusLabel()
  END SEQUENCE

RETURN

//***************************************************************************

PROCEDURE EditProgram

  LOCAL cFolder := AddSlash(Mpm.BaseFolder.Value)
  LOCAL nFile   := Mpm.SourceList.Value
  LOCAL cFile

  BEGIN SEQUENCE
    IF EMPTY(aSouFiles)
      MpmStop('You must add at least one source file.')
      BREAK
    ENDIF
    IF EMPTY(nFile)
      MpmStop('You must select a source file.')
      BREAK
    ENDIF
    IF EMPTY(cEditorExe)
      MpmStop('You must select a program editor.')
      BREAK
    ENDIF
    IF !FILE(cEditorExe) .AND. !FileInPath(cEditorExe)
      MpmStop('Cannot find program editor ' + cEditorExe + '.')
      BREAK
    ENDIF
    cFile := AddQuote(cFolder + aSouFiles[nFile][SOUFILE_NAME])
    MpmRun(cEditorExe, cFile, .Y.)
    StatusLabel()
  END SEQUENCE

RETURN

//***************************************************************************

FUNCTION FileInPath(cFile)
  
  LOCAL cPath  := GETENV('PATH') + ';'
  LOCAL lFound := .N.
  LOCAL nLPos  := 0
  LOCAL nRPos  := 0
  LOCAL cSearch

  WHILE nRPos < LEN(cPath) .AND. !lFound
    nRPos   := AT(';', cPath, nLPos + 1)
    cSearch := AddSlash(SUBSTR(cPath, nLPos + 1, nRPos - nLPos - 1))
    lFound  := FILE(cSearch + cFile)
    nLPos   := nRPos
  END WHILE

RETURN lFound

//***************************************************************************

PROCEDURE SetMain

  LOCAL aItem1
  LOCAL aItemN
  LOCAL nItem := Mpm.SourceList.Value

  BEGIN SEQUENCE
    IF EMPTY(aSouFiles)
      MpmStop('You must add at least one source file.')
      BREAK
    ENDIF
    IF EMPTY(nItem)
      MpmStop('You must select a source file.')
      BREAK
    ENDIF
    IF nItem == 1
      MpmStop(aSouFiles[1][SOUFILE_NAME] + ' is already the main file.')
      BREAK
    ENDIF
    aItem1 := aSouFiles[1]
    aItemN := aSouFiles[nItem]
    IF !(aItemN[SOUFILE_EXT] $ '.PRG/.C')
      MpmStop('You must select a PRG or C file as the main source file.')
      BREAK
    ENDIF
    aSouFiles[nItem] := aItem1
    aSouFiles[1]     := aItemN
    RefreshSource()
    Mpm.SourceList.SetFocus
    lProjMod := .Y.
    StatusLabel('Main changed', 0)
  END SEQUENCE

RETURN

//***************************************************************************

PROCEDURE MoveSource(lUp)
  
  LOCAL aItem1
  LOCAL aItem2
  LOCAL nItem  := Mpm.SourceList.Value
  LOCAL nItems := LEN(aSouFiles)

  BEGIN SEQUENCE
    IF nItems < 2
      MpmStop('You must add at least two source files.')
      BREAK
    ENDIF
    IF EMPTY(nItem)
      MpmStop('You must select a source file.')
      BREAK
    ENDIF
    IF lUp
      IF nItem == 1
        BREAK
      ENDIF
      aItem1 := aSouFiles[nItem]
      aItem2 := aSouFiles[nItem - 1]
      IF nItem == 2
        IF !(aItem1[SOUFILE_EXT] $ '.PRG/.C')
          MpmStop('You must select a PRG or C file as the main source file.')
          BREAK
        ENDIF
        StatusLabel('Main changed', 0)
      ENDIF
      aSouFiles[nItem - 1] := aItem1
      aSouFiles[nItem]     := aItem2
      RefreshSource()
      Mpm.SourceList.Value := nItem - 1
    ELSE  
      IF nItem == nItems
        BREAK
      ENDIF
      aItem1 := aSouFiles[nItem]
      aItem2 := aSouFiles[nItem + 1]
      IF nItem == 1
        IF !(aItem2[SOUFILE_EXT] $ '.PRG/.C')
          MpmStop('You must select a PRG or C file as the main source file.')
          BREAK
        ENDIF
        StatusLabel('Main changed', 0)
      ENDIF
      aSouFiles[nItem + 1] := aItem1
      aSouFiles[nItem]     := aItem2
      RefreshSource()
      Mpm.SourceList.Value := nItem + 1
    ENDIF
    Mpm.SourceList.SetFocus
    lProjMod := .Y.
  END SEQUENCE

RETURN
  
//***************************************************************************

PROCEDURE RefreshSource

  LOCAL nSouFiles := LEN(aSouFiles)
  LOCAL nSouFile  := Mpm.SourceList.Value
  LOCAL aSouFile
  LOCAL cSouFile
  LOCAL aDepend
  LOCAL nDepFiles
  LOCAL nFile

  Mpm.SourceList.DeleteAllItems()
  FOR nFile := 1 TO nSouFiles
    aSouFile  := aSouFiles[nFile]
    cSouFile  := aSouFile[SOUFILE_NAME]
    aDepend   := aSouFile[SOUFILE_DEPEND]
    nDepFiles := LEN(aDepend)
    Mpm.SourceList.AddItem(cSouFile + ;
      IF(EMPTY(nDepFiles), '', ' [' + LTRIM(STR(nDepFiles)) + ;
      ' dependent file' + IF(nDepFiles == 1, '', 's') + ']'))
  NEXT
  Mpm.SourceList.Value := MIN(nSouFile, nSouFiles)

RETURN

//***************************************************************************

PROCEDURE LoadDependents

  LOCAL nSouFile := Mpm.SourceList.Value
  LOCAL aDepend
  LOCAL aSouFile
  LOCAL cSouFile
  LOCAL nDepFile
  LOCAL nDepFiles

  IF EMPTY(nSouFile)
    Mpm.lbFile.Value := 'No source file selected'
    Mpm.DependList.DeleteAllItems()
  ELSE
    aSouFile  := aSouFiles[nSouFile]
    cSouFile  := aSouFile[SOUFILE_NAME]
    aDepend   := aSouFile[SOUFILE_DEPEND]
    nDepFiles := LEN(aDepend)
    Mpm.lbFile.Value := 'Dependent files for ' + cSouFile
    Mpm.DependList.DeleteAllItems()
    FOR nDepFile := 1 TO nDepFiles
      Mpm.DependList.AddItem(aDepend[nDepFile])
    NEXT
  ENDIF

RETURN

//***************************************************************************

PROCEDURE AddDependents

  LOCAL cBaseFolder  := Mpm.BaseFolder.Value
  LOCAL cBaseFolderU := UPPER(AddSlash(cBaseFolder))
  LOCAL nBaseFolderU := LEN(cBaseFolderU)
  LOCAL nSouFile     := Mpm.SourceList.Value
  LOCAL aNewFiles
  LOCAL aDepend
  LOCAL aSouFile
  LOCAL aTypes
  LOCAL cNewFile
  LOCAL cSouExt
  LOCAL cSouFile
  LOCAL nFile
  LOCAL nFiles

  BEGIN SEQUENCE

    IF EMPTY(cBaseFolder)
      MpmStop('You must select a base folder.')
      BREAK
    ENDIF
    IF EMPTY(aSouFiles)
      MpmStop('You must add at least one source file.')
      BREAK
    ENDIF
    IF EMPTY(nSouFile)
      MpmStop('You must select a source file.')
      BREAK
    ENDIF
    aSouFile := aSouFiles[nSouFile]
    cSouFile := aSouFile[SOUFILE_NAME]
    cSouExt  := aSouFile[SOUFILE_EXT]
    aDepend  := aSouFile[SOUFILE_DEPEND]
    IF !(cSouExt $ '.PRG/.C/.RC')
      MpmStop('You may add dependents only for a PRG, C, or RC file.')
      BREAK
    ENDIF

    DO CASE
    CASE cSouExt == '.PRG'
      aTypes := { ;
        {'(x)Harbour header files (*.ch)' , '*.ch' },  ;
        {'Window definition files (*.fmg)', '*.fmg'},  ;
        {'(x)Harbour source files (*.prg)', '*.prg'},  ;
        {'C header files (*.h)'           , '*.h'  },  ;
        {'All files (*.*)'                , '*.*'  }   }
    CASE cSouExt == '.C'
      aTypes := { ;
        {'C header files (*.h)'           , '*.h'  },  ;
        {'All files (*.*)'                , '*.*'  }   }
    OTHERWISE
      aTypes := { ;
        {'All files (*.*)'                , '*.*'  }   }
    ENDCASE 
    aNewFiles := GetFile(aTypes, ;
      'Select dependent files for ' + cSouFile, cBaseFolder, .Y.)

    IF EMPTY(aNewFiles)
      BREAK
    ENDIF

    ASORT(aNewFiles,,, {|cRow1, cRow2| UPPER(cRow1) <= UPPER(cRow2)})
    nFiles := LEN(aNewFiles)
    FOR nFile := 1 TO nFiles
      cNewFile := ALLTRIM(aNewFiles[nFile])
      IF LEFT(UPPER(cNewFile), nBaseFolderU) == cBaseFolderU
        cNewFile := SUBSTR(cNewFile, nBaseFolderU + 1)
      ENDIF
      IF EMPTY(ASCAN(aDepend, {|cRow| UPPER(cRow) == UPPER(cNewFile)}))
        Mpm.DependList.AddItem(cNewFile)
      ENDIF
    NEXT
    StoreDependents()

  END SEQUENCE

RETURN 

//***************************************************************************

PROCEDURE RemoveDependent

  LOCAL nSouFile  := Mpm.SourceList.Value
  LOCAL nDepFile  := Mpm.DependList.Value
  LOCAL nDepFiles := Mpm.DependList.ItemCount
  LOCAL aSouFile
  LOCAL cSouFile

  BEGIN SEQUENCE
    IF EMPTY(nSouFile)
      MpmStop('You must select a source file.')
      BREAK
    ENDIF
    IF EMPTY(nDepFiles)
      MpmStop('You must add at least one dependent file.')
      BREAK
    ENDIF
    IF EMPTY(nDepFile)
      MpmStop('You must select a dependent file.')
      BREAK
    ENDIF
    aSouFile := aSouFiles[nSouFile]
    cSouFile := aSouFile[SOUFILE_NAME]
    IF !MpmYesNo('Remove ' + ;
      Mpm.DependList.Item(nDepFile) + ' as a dependent for ' + cSouFile + '?')
      BREAK
    ENDIF
    Mpm.DependList.DeleteItem(nDepFile)
    Mpm.DependList.Value := MIN(nDepFile, nDepFiles - 1)
    StoreDependents()
  END SEQUENCE

RETURN

//***************************************************************************

PROCEDURE EditDependent

  LOCAL cFolder := AddSlash(Mpm.BaseFolder.Value)
  LOCAL nFile   := Mpm.DependList.Value
  LOCAL nFiles  := Mpm.DependList.ItemCount
  LOCAL cFile

  BEGIN SEQUENCE
    IF EMPTY(nFiles)
      MpmStop('You must add at least one dependent file.')
      BREAK
    ENDIF
    IF EMPTY(nFile)
      MpmStop('You must select a dependent file.')
      BREAK
    ENDIF
    IF EMPTY(cEditorExe)
      MpmStop('You must select a program editor.')
      BREAK
    ENDIF
    IF !FILE(cEditorExe) .AND. !FileInPath(cEditorExe)
      MpmStop('Cannot find program editor ' + cEditorExe + '.')
      BREAK
    ENDIF
    cFile := AddQuote(cFolder + Mpm.DependList.Item(nFile))
    MpmRun(cEditorExe, cFile, .Y.)
    StatusLabel()
  END SEQUENCE

RETURN

//***************************************************************************

PROCEDURE MoveDependent(lUp)

  LOCAL cItem1
  LOCAL cItem2
  LOCAL nItem  := Mpm.DependList.Value
  LOCAL nItems := Mpm.DependList.ItemCount

  BEGIN SEQUENCE
    IF nItems < 2
      MpmStop('You must add at least two dependent files.')
      BREAK
    ENDIF
    IF EMPTY(nItem)
      MpmStop('You must select a dependent file.')
      BREAK
    ENDIF
    IF lUp
      IF nItem == 1
        BREAK
      ENDIF
      cItem1 := Mpm.DependList.Item(nItem)
      cItem2 := Mpm.DependList.Item(nItem - 1)
      Mpm.DependList.Item(nItem - 1) := cItem1
      Mpm.DependList.Item(nItem)     := cItem2
      Mpm.DependList.Value           := nItem - 1
    ELSE  
      IF nItem == nItems
        BREAK
      ENDIF
      cItem1 := Mpm.DependList.Item(nItem)
      cItem2 := Mpm.DependList.Item(nItem + 1)
      Mpm.DependList.Item(nItem + 1) := cItem1
      Mpm.DependList.Item(nItem)     := cItem2
      Mpm.DependList.Value           := nItem + 1
    ENDIF
    StoreDependents()
  END SEQUENCE

RETURN
  
//***************************************************************************

PROCEDURE StoreDependents

  LOCAL nSouFile := Mpm.SourceList.Value
  LOCAL aSouFile
  LOCAL aDepend
  LOCAL nDepFiles
  LOCAL nDepFile
  
  IF !EMPTY(nSouFile)
    aSouFile  := aSouFiles[nSouFile]
    aDepend   := aSouFile[SOUFILE_DEPEND]
    nDepFiles := Mpm.DependList.ItemCount
    ASIZE(aDepend, 0)
    FOR nDepFile := 1 TO nDepFiles
      AADD(aDepend, Mpm.DependList.Item(nDepFile))
    NEXT
    RefreshSource()
    lProjMod := .Y.
    StatusLabel()
  ENDIF 

RETURN

//***************************************************************************

PROCEDURE AddLibFiles(cType)

  LOCAL cBaseFolder  := Mpm.BaseFolder.Value
  LOCAL cBaseFolderU := UPPER(AddSlash(cBaseFolder))
  LOCAL nBaseFolderU := LEN(cBaseFolderU)
  LOCAL lXHarbour    := Mpm.UseXHarbour.Value
  LOCAL aCurFiles    := {}
  LOCAL aNewFiles
  LOCAL aTypes
  LOCAL cLibFolder
  LOCAL cLibLabel
  LOCAL cNewFile
  LOCAL nFile

  BEGIN SEQUENCE

    FOR nFile := 1 TO Mpm.LibList.ItemCount
      AADD(aCurFiles, ALLTRIM(Mpm.LibList.Item(nFile)))
    NEXT

    DO CASE
    CASE cType == 'H'
      cLibLabel  := 'additional ' + IF(lXHarbour, 'x', '') + 'Harbour libraries'
      cLibFolder := ;
        AddSlash(IF(lXHarbour, cXHarbourFolder, cOHarbourFolder)) + 'LIB'
      aTypes     := {{'Library files (*.lib)', '*.lib'}}
    CASE cType == 'M'
      cLibLabel  := 'additional MiniGui libraries'
      cLibFolder := AddSlash(cMiniGuiFolder) + IF(lXHarbour, 'XLIB', 'LIB')
      aTypes     := {{'Library files (*.lib)', '*.lib'}}
    CASE cType == 'O'
      cLibLabel  := 'other additional libraries or object files'
      cLibFolder := Mpm.BaseFolder.Value
      aTypes     := { ;
        {'Library files (*.lib)'                 , '*.lib'}, ;
        {'(x)Harbour or C object files (*.obj)'  , '*.obj'}, ;
        {'Resource compiler object files (*.res)', '*.res'}  }
    ENDCASE 
    aNewFiles := GetFile(aTypes, 'Select ' + cLibLabel, cLibFolder, .Y.)

    IF EMPTY(aNewFiles)
      BREAK
    ENDIF

    ASORT(aNewFiles,,, {|cRow1, cRow2| UPPER(cRow1) <= UPPER(cRow2)})
    FOR nFile := 1 TO LEN(aNewFiles)
      cNewFile := ALLTRIM(aNewFiles[nFile])
      IF LEFT(UPPER(cNewFile), nBaseFolderU) == cBaseFolderU
        cNewFile := SUBSTR(cNewFile, nBaseFolderU + 1)
      ENDIF
      IF EMPTY(ASCAN(aCurFiles, {|cRow| UPPER(cRow) == UPPER(cNewFile)}))
        Mpm.LibList.AddItem(cNewFile) 
      ENDIF
    NEXT

    lProjMod := .Y.
    StatusLabel()

  END SEQUENCE

RETURN

//***************************************************************************

PROCEDURE RemoveLib

  LOCAL nFile  := Mpm.LibList.Value
  LOCAL nFiles := Mpm.LibList.ItemCount

  BEGIN SEQUENCE
    IF EMPTY(nFiles)
      MpmStop('You must add at least one library or object file.')
      BREAK
    ENDIF
    IF EMPTY(nFile)
      MpmStop('You must select a library or object file.')
      BREAK
    ENDIF
    IF !MpmYesNo('Remove ' + Mpm.LibList.Item(nFile) + '?')
      BREAK
    ENDIF
    Mpm.LibList.DeleteItem(nFile)
    lProjMod := .Y.
    StatusLabel()
  END SEQUENCE

RETURN

//***************************************************************************

PROCEDURE MoveLib(lUp)
  
  LOCAL cItem1
  LOCAL cItem2
  LOCAL nItem  := Mpm.LibList.Value
  LOCAL nItems := Mpm.LibList.ItemCount

  BEGIN SEQUENCE
    IF nItems < 2
      MpmStop('You must add at least two libraries or object files.')
      BREAK
    ENDIF
    IF EMPTY(nItem)
      MpmStop('You must select a library or object file.')
      BREAK
    ENDIF
    IF lUp
      IF nItem == 1 .OR. nItems == 1
        BREAK
      ENDIF
      cItem1 := Mpm.LibList.Item(nItem)
      cItem2 := Mpm.LibList.Item(nItem - 1)
      Mpm.LibList.Item(nItem - 1) := cItem1
      Mpm.LibList.Item(nItem)     := cItem2
      Mpm.LibList.Value           := nItem - 1
    ELSE  
      IF nItem == nItems
        BREAK
      ENDIF
      cItem1 := Mpm.LibList.Item(nItem)
      cItem2 := Mpm.LibList.Item(nItem + 1)
      Mpm.LibList.Item(nItem + 1) := cItem1
      Mpm.LibList.Item(nItem)     := cItem2
      Mpm.LibList.Value           := nItem + 1
    ENDIF
    lProjMod := .Y.
  END SEQUENCE

RETURN
  
//***************************************************************************

PROCEDURE Build

  LOCAL lDebug         := Mpm.Debug.Value
  LOCAL lRebuild       := Mpm.Rebuild.Value
  LOCAL lHide          := Mpm.HideBuild.Value
  LOCAL lXHarbour      := Mpm.UseXHarbour.Value
  LOCAL lGenLib        := Mpm.GenLib.Value
  LOCAL lXp            := IsXpPlus()
  LOCAL lBlank         := BlankTest()
  LOCAL lShow          := !lHide .OR. (!lXp .AND. (lBlank .OR. lXHarbour))
  LOCAL cProjFolder    := AddSlash(Mpm.BaseFolder.Value)
  LOCAL cObjFolder     := cProjFolder + IF(lDebug, 'Deb\', 'Obj\')
  LOCAL cHarbourFolder := IF(lXHarbour, cXHarbourFolder, cOHarbourFolder)
  LOCAL cMpmFolder     := GetSub(GETEXEFILENAME())
  LOCAL cRBUILD        := AddQuote(cMpmFolder + '\mpmbuild.exe')
  LOCAL cREDIR         := AddQuote(cMpmFolder + '\cmdredir.exe')
  LOCAL cHRB           := AddQuote(cHarbourFolder + '\Bin\harbour.exe')
  LOCAL cBCC           := AddQuote(cBccFolder + '\Bin\bcc32.exe')
  LOCAL cBRC           := AddQuote(cBccFolder + '\Bin\brc32.exe')
  LOCAL cILINK         := AddQuote(cBccFolder + '\Bin\ilink32.exe')
  LOCAL cTLIB          := AddQuote(cBccFolder + '\Bin\tlib.exe')
  LOCAL cLocFile       := AddSlash(GetTempFolder()) + '_MpmBuild.txt'
  LOCAL nFiles         := LEN(aSouFiles)
  LOCAL cSpace         := ' '
  LOCAL lSpace         := .N.
  LOCAL cBatFile
  LOCAL cCldFile
  LOCAL nExit

  BEGIN SEQUENCE

    IF lProcess .AND. !MpmYesNo('Start another build process?')
      BREAK
    ENDIF
    IF EMPTY(cProjFolder) .AND. EMPTY(nFiles) 
      MpmStop('You must start a project before building it.')
      BREAK
    ENDIF
    IF EMPTY(cProjFolder)
      MpmStop('You must select a base folder.')
      BREAK
    ENDIF
    IF EMPTY(nFiles)
      MpmStop('You must add at least one source file.')
      BREAK
    ENDIF
    IF EMPTY(cBccFolder)
      MpmStop('You must specify the BCC folder.')
      BREAK
    ENDIF
    IF EMPTY(cMiniGuiFolder)
      MpmStop('You must specify the MiniGui folder.')
      BREAK
    ENDIF
    IF EMPTY(cHarbourFolder)
      MpmStop('You must specify the ' + ;
        IF(lXHarbour, 'x', '') + 'Harbour folder.')
      BREAK
    ENDIF
    IF !FILE(cRBUILD)
      MpmStop('Cannot find build process program file ' + cRBUILD)
      BREAK
    ENDIF
    IF !IsXpPlus() .AND. !FILE(cREDIR)
      MpmStop('Cannot find redirection program file ' + cREDIR)
      BREAK
    ENDIF
    IF !FILE(cHRB)
      MpmStop('Cannot find ' + IF(lXHarbour, 'x', '') + 'Harbour compiler ' + ;
        cHRB)
      BREAK
    ENDIF
    IF !FILE(cBCC)
      MpmStop('Cannot find BCC compiler ' + cBCC)
      BREAK
    ENDIF
    IF !FILE(cBRC)
      MpmStop('Cannot find resource compiler ' + cBRC)
      BREAK
    ENDIF
    IF !lGenLib .AND. !FILE(cILINK)
      MpmStop('Cannot find linker ' + cILINK)
      BREAK
    ENDIF
    IF lGenLib .AND. !FILE(cTLIB)
      MpmStop('Cannot find library manager ' + cTLIB)
      BREAK
    ENDIF

    StatusLabel()
    SETCURRENTFOLDER(cProjFolder)
    DELETE FILE (cProjFolder + '_Build.log')
    DELETE FILE (cProjFolder + '_Build.rsp')
    DELETE FILE (cProjFolder + '_End.txt')

    CREATEFOLDER(cObjFolder)
    cBatFile := cProjFolder + '_Build.bat'
    IF !MemoWrite(cLocFile, cBatFile)
      MpmStop('Cannot write ' + cLocFile + '.')  
      BREAK
    ENDIF
    IF !MemoWrite(cBatFile, BuildBatch( ;
      lDebug, lRebuild, lXHarbour, lGenLib, lXp, lShow, ;
      cProjFolder, cHarbourFolder, cREDIR, cHRB, cBCC, cBRC, cILINK, cTLIB))
      MpmStop('Cannot write ' + cBatFile + '.')  
      BREAK
    ENDIF

    cCldFile := cProjFolder + 'Init.cld'
    IF lDebug .AND. !FILE(cCldFile)
      MemoWrite(cCldFile, 'OPTIONS NORUNATSTARTUP')
    ENDIF

    Mpm.Log.Value := ''
    lProcess := .Y.
    lGo      := .Y.
    nExit    := WaitRunTerm(AddQuote(cRBUILD),,, {|| BuildWait()}, 500)

    IF nExit < -1 .OR. nExit > 255
      DO CASE
      CASE nExit == MPMB_NOLOCFILE
        MpmStop('Cannot find build location file ' + cLocFile + '.')
      CASE nExit == MPMB_NOLOCREAD
        MpmStop('Cannot read build location file ' + cLocFile + '.')
      CASE nExit == MPMB_NOBUILDFILE
        MpmStop('Cannot find build file ' + cBatFile + '.')
      OTHERWISE  
        MpmStop('Build run error ' + LTRIM(STR(nExit)))
      ENDCASE
    ENDIF

  END SEQUENCE

RETURN

//***************************************************************************

FUNCTION BuildBatch( ;
  lDebug, lRebuild, lXHarbour, lGenLib, lXp, lShow, ;
  cProjFolder, cHarbourFolder, cREDIR, cHRB, cBCC, cBRC, cILINK, cTLIB)
  
  LOCAL aWarnings      := {'', '/w/es2', '/w2/es2', '/w3/es2'}
  LOCAL nExeType       := Mpm.ExeType.Value
  LOCAL lConsole       := nExeType == 2 .OR. nExeType == 3 .OR. lDebug
  LOCAL lGui           := nExeType == 1 .OR. nExeType == 3
  LOCAL cMainSuffix    := IF(lDebug, '_deb', '')
  LOCAL cMainExt       := IF(lGenLib, '.lib', '.exe')
  LOCAL nSouFiles      := LEN(aSouFiles)
  LOCAL nLibFiles      := Mpm.LibList.ItemCount
  LOCAL cHarbourLib    := cHarbourFolder + '\Lib'
  LOCAL cMiniGuiLib    := cMiniGuiFolder + IF(lXHarbour, '\XLib', '\Lib')
  LOCAL lZipSupport    := Mpm.ZipLib.Value
  LOCAL lOdbcSupport   := Mpm.OdbcLib.Value
  LOCAL lAdsSupport    := Mpm.AdsLib.Value
  LOCAL lMySqlSupport  := Mpm.MySqlLib.Value
  LOCAL cINCDIRS       := ;
    AddQuote(cHarbourFolder + '\Include') + ';' + ;
    AddQuote(cMiniGuiFolder + '\Include')
  LOCAL cBCCLIB        := cBccFolder + '\Lib\'
  LOCAL cHRBLIB        := AddSlash(cHarbourLib)
  LOCAL cMGLIB         := AddSlash(cMiniGuiLib)
  LOCAL cMGRES         := cMiniGuiFolder + '\Resources\'
  LOCAL cOBJDIR        := IF(lDebug, 'Deb\', 'Obj\')
  LOCAL cOBJBASE
  LOCAL cHRBFLAGS      := IF(lGenLib, '/n1', '/n') + IF(lDebug, '/b', '') + ;
    IF(Mpm.GenPpo.Value, '/p', '') + ;
    aWarnings[Mpm.Warnings.Value] + Mpm.PrgParams.Value + ;
    '/i' + cINCDIRS
  LOCAL cBCCFLAGS      := '-c -O2 -tW -M -L' + AddQuote(cBccFolder + '\Lib') + ;
    ' -I' + AddQuote(cBccFolder + '\Include') + ';' + cINCDIRS
  LOCAL cHLog          := IF(lShow, '', ;
    IF(lXp, '', cREDIR + ' -o _Build.log -eo '))
  LOCAL cTLog          := IF(lShow, '', ;
    IF(lXp, ' > _Build.log 2>&1', ''))
  LOCAL cLLog          := ' > _Build.log'
  LOCAL cRsp           := '_Build.rsp'
  LOCAL cErr           := 'if errorlevel 1 goto err'
  LOCAL cOut           := '@echo off' + CRLF
  LOCAL aDepend
  LOCAL aFile
  LOCAL aSeaFiles
  LOCAL cBase
  LOCAL cFile
  LOCAL cFileSub
  LOCAL cExt
  LOCAL cMainBase
  LOCAL nDepFiles
  LOCAL nFile
  LOCAL nSeaFile

  cMainBase := aSouFiles[1][SOUFILE_BASE] + cMainSuffix
  aSeaFiles := {}
  FOR nFile := 1 TO nSouFiles
    aFile     := aSouFiles[nFile]
    cFile     := UPPER(aFile[SOUFILE_NAME])
    aDepend   := aFile[SOUFILE_DEPEND]
    nDepFiles := LEN(aDepend)
    IF EMPTY(ASCAN(aSeaFiles, {|cRow| UPPER(cRow) == cFile}))
      AADD(aSeaFiles, cFile)      
    ENDIF
    FOR nSeaFile := 1 TO nDepFiles
      cFile := UPPER(aDepend[nSeaFile])
      IF EMPTY(ASCAN(aSeaFiles, {|cRow| UPPER(cRow) == cFile}))
        AADD(aSeaFiles, cFile)      
      ENDIF
    NEXT
  NEXT

  IF DateTest(lRebuild, cProjFolder, cMainBase + cMainExt, aSeaFiles)

    FOR nFile := 1 TO nSouFiles

      aFile     := aSouFiles[nFile]
      cFile     := aFile[SOUFILE_NAME]
      cBase     := aFile[SOUFILE_BASE]
      cExt      := aFile[SOUFILE_EXT]
      aDepend   := aFile[SOUFILE_DEPEND]
      nDepFiles := LEN(aDepend)

      DO CASE
      CASE cExt == '.PRG'

        aSeaFiles := {cFile}
        FOR nSeaFile := 1 TO nDepFiles
          AADD(aSeaFiles, aDepend[nSeaFile])
        NEXT
        FOR nSeaFile := 1 TO nSouFiles
          IF aSouFiles[nSeaFile][SOUFILE_EXT] $ '.CH/.H/.FMG'
            AADD(aSeaFiles, aSouFiles[nSeaFile][SOUFILE_NAME])
          ENDIF
        NEXT
        cOBJBASE := cOBJDIR + cBase
        cFileSub := GetSub(cFile)
        IF DateTest(lRebuild, cProjFolder, cOBJBASE + '.obj', aSeaFiles)
          cOut += CRLF
          cOut += cHLog + cHRB + ' ' + ;
            cHRBFLAGS + ';' + IF(EMPTY(cFileSub), '.', cFileSub) + ;
            ' -o' + AddQuote(cOBJBASE + '.c') + ' ' + AddQuote(cFile) + ;
            cTLog + CRLF
          cOut += cErr + CRLF
          cOut += CRLF
          cOut += cHLog + cBCC + ' ' + cBCCFLAGS + ;
            ' -o' + AddQuote(cOBJBASE + '.obj') + ;
            ' ' + AddQuote(cOBJBASE + '.c') + cTLog + CRLF
          cOut += cErr + CRLF
        ENDIF

      CASE cExt == '.RC'

        aSeaFiles := {cFile}
        FOR nSeaFile := 1 TO nDepFiles
          AADD(aSeaFiles, aDepend[nSeaFile])
        NEXT
        cOBJBASE := cOBJDIR + cBase
        cFileSub := GetSub(cFile)
        IF DateTest(lRebuild, cProjFolder, cOBJBASE + '.res', aSeaFiles)
          cOut += CRLF
          cOut += cHLog + cBRC + ' -d__BORLANDC__ -r ' + ;
            '-fo' + AddQuote(cOBJBASE + '.res') + ' ' + AddQuote(cFile) + ;
            cTLog + CRLF
          cOut += cErr + CRLF
        ENDIF

      CASE cExt == '.C'

        aSeaFiles := {cFile}
        FOR nSeaFile := 1 TO nDepFiles
          AADD(aSeaFiles, aDepend[nSeaFile])
        NEXT
        FOR nSeaFile := 1 TO nSouFiles
          IF aSouFiles[nSeaFile][SOUFILE_EXT] == '.H'
            AADD(aSeaFiles, aSouFiles[nSeaFile][SOUFILE_NAME])
          ENDIF
        NEXT
        cOBJBASE := cOBJDIR + cBase
        cFileSub := GetSub(cFile)
        IF DateTest(lRebuild, cProjFolder, cOBJBASE + '.obj', aSeaFiles)
          cOut += CRLF
          cOut += cHLog + cBCC + ' ' + ;
            cBCCFLAGS + ';' + IF(EMPTY(cFileSub), '.', cFileSub) + ;
            ' -o' + AddQuote(cOBJBASE + '.obj') + ' ' + AddQuote(cFile) + ;
            cTLog + CRLF
          cOut += cErr + CRLF
        ENDIF

      ENDCASE 

    NEXT

    IF lGenLib
      
      cOut += CRLF
      cOut += 'del ' + AddQuote(cMainBase + cMainExt) + CRLF
      FOR nFile := 1 TO nSouFiles
        IF aSouFiles[nFile][SOUFILE_EXT] $ '.PRG/.C'
          nSeaFile := nFile
        ENDIF
      NEXT
      FOR nFile := 1 TO nSouFiles
        aFile := aSouFiles[nFile]
        IF aFile[SOUFILE_EXT] $ '.PRG/.C'
          cOBJBASE := cOBJDIR + aFile[SOUFILE_BASE]
          cOut     += 'echo + ' + AddQuote(cOBJBASE + '.obj') + ;
            IF(nFile == nSeaFile, ' ', ' & ') + ;
            IF(nFile == 1, '> ', '>> ') + cRsp + CRLF
        ENDIF
      NEXT
      cOut += cHLog + cTLIB + ' ' + cMainBase + cMainExt + ;
        ' @' + cRsp + cTLog + CRLF
      cOut += cErr + CRLF

    ELSE  

      cOut += CRLF
      FOR nFile := 1 TO nSouFiles
        aFile := aSouFiles[nFile]
        IF aFile[SOUFILE_EXT] $ '.PRG/.C'
          cOBJBASE := cOBJDIR + aFile[SOUFILE_BASE]
          cOut     += 'echo ' + AddQuote(cOBJBASE + '.obj') + ;
            ' + ' + IF(nFile == 1, '> ', '>> ') + cRsp + CRLF
        ENDIF
      NEXT
      FOR nFile := 1 TO nLibFiles
        cFile := ALLTRIM(Mpm.LibList.Item(nFile))
        IF UPPER(GetExt(cFile)) == '.OBJ'
          cOut  += 'echo ' + AddQuote(cFile) + ' + >> ' + cRsp + CRLF
        ENDIF
      NEXT
      cOut += 'echo ' + AddQuote(cBCCLIB + 'c0w32.obj') + ', + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cMainBase + cMainExt) + ',' + ;
        AddQuote(cMainBase + '.map') + ', + >> ' + cRsp + CRLF
      IF lGui
        cOut += 'echo ' + AddQuote(cMGLIB + 'tsbrowse.lib')  + ' + >> ' + cRsp + CRLF
        cOut += 'echo ' + AddQuote(cMGLIB + 'propgrid.lib')  + ' + >> ' + cRsp + CRLF
        cOut += 'echo ' + AddQuote(cMGLIB + 'minigui.lib')   + ' + >> ' + cRsp + CRLF
        cOut += 'echo ' + AddQuote(cHRBLIB + 'dll.lib')      + ' + >> ' + cRsp + CRLF
      ENDIF
      IF lConsole
        cOut += 'echo ' + AddQuote(cHRBLIB + 'gtwin.lib')    + ' + >> ' + cRsp + CRLF
      ENDIF
      IF lGui
        cOut += 'echo ' + AddQuote(cHRBLIB + 'gtgui.lib')    + ' + >> ' + cRsp + CRLF
      ENDIF
      IF !lXHarbour
        cOut += 'echo ' + AddQuote(cHRBLIB + 'compiler.lib') + ' + >> ' + cRsp + CRLF
      ENDIF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'rtl.lib')      + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'vm.lib')       + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'lang.lib')     + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'codepage.lib') + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'macro.lib')    + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'rdd.lib')      + ' + >> ' + cRsp + CRLF
      IF !lXHarbour
        cOut += 'echo ' + AddQuote(cHRBLIB + 'hsx.lib')      + ' + >> ' + cRsp + CRLF
      ENDIF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'dbfntx.lib')   + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'dbfcdx.lib')   + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'dbffpt.lib')   + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'hbsix.lib')    + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'common.lib')   + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'debug.lib')    + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'pp.lib')       + ' + >> ' + cRsp + CRLF
      IF lXHarbour
        cOut += 'echo ' + AddQuote(cHRBLIB + 'pcrepos.lib')  + ' + >> ' + cRsp + CRLF
      ELSE
        cOut += 'echo ' + AddQuote(cHRBLIB + 'hbpcre.lib')   + ' + >> ' + cRsp + CRLF
      ENDIF
      IF lXHarbour
        cOut += 'echo ' + AddQuote(cHRBLIB + 'ct.lib')       + ' + >> ' + cRsp + CRLF
      ELSE
        cOut += 'echo ' + AddQuote(cHRBLIB + 'libct.lib')    + ' + >> ' + cRsp + CRLF
      ENDIF
      cOut += 'echo ' + AddQuote(cHRBLIB + 'libmisc.lib')    + ' + >> ' + cRsp + CRLF
      IF !lXHarbour
        cOut += 'echo ' + AddQuote(cHRBLIB + 'hbole.lib')    + ' + >> ' + cRsp + CRLF
      ENDIF
      IF lGui
        cOut += 'echo ' + AddQuote(cHRBLIB + 'hbprinter.lib')  + ' + >> ' + cRsp + CRLF
        cOut += 'echo ' + AddQuote(cHRBLIB + 'socket.lib')     + ' + >> ' + cRsp + CRLF
        cOut += 'echo ' + AddQuote(cHRBLIB + 'miniprint.lib')  + ' + >> ' + cRsp + CRLF
      ENDIF
      IF Mpm.ZipLib.Value
        cOut += 'echo ' + AddQuote(cHRBLIB + 'ziparchive.lib') + ' + >> ' + cRsp + CRLF
      ENDIF
      IF Mpm.OdbcLib.Value
        cOut += 'echo ' + AddQuote(cHRBLIB + 'hbodbc.lib')     + ' + >> ' + cRsp + CRLF
        cOut += 'echo ' + AddQuote(cHRBLIB + 'odbc32.lib')     + ' + >> ' + cRsp + CRLF
      ENDIF
      IF Mpm.AdsLib.Value
        cOut += 'echo ' + AddQuote(cHRBLIB + 'rddads.lib')     + ' + >> ' + cRsp + CRLF
        cOut += 'echo ' + AddQuote(cHRBLIB + 'ace32.lib')      + ' + >> ' + cRsp + CRLF
      ENDIF
      IF Mpm.MySqlLib.Value
        cOut += 'echo ' + AddQuote(cHRBLIB + 'mysql.lib')      + ' + >> ' + cRsp + CRLF
        cOut += 'echo ' + AddQuote(cHRBLIB + 'libmysql.lib')   + ' + >> ' + cRsp + CRLF
      ENDIF
      FOR nFile := 1 TO nLibFiles
        cFile := ALLTRIM(Mpm.LibList.Item(nFile))
        IF UPPER(GetExt(cFile)) == '.LIB'
          cOut  += 'echo ' + AddQuote(cFile) + ' + >> ' + cRsp + CRLF
        ENDIF
      NEXT
      cOut += 'echo ' + AddQuote(cBCCLIB + 'cw32.lib')     + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cBCCLIB + 'import32.lib') + ', >> ' + cRsp + CRLF
      FOR nFile := 1 TO nSouFiles
        aFile := aSouFiles[nFile]
        IF aFile[SOUFILE_EXT] == '.RC'
          cOBJBASE := cOBJDIR + aFile[SOUFILE_BASE]
          cOut     += 'echo ' + AddQuote(cOBJBASE + '.res') + ' + >> ' + cRsp + CRLF
        ENDIF
      NEXT
      FOR nFile := 1 TO nLibFiles
        cFile := ALLTRIM(Mpm.LibList.Item(nFile))
        IF UPPER(GetExt(cFile)) == '.RES'
          cOut  += 'echo ' + AddQuote(cFile) + ' + >> ' + cRsp + CRLF
        ENDIF
      NEXT
      cOut += 'echo ' + AddQuote(cMGRES + 'hbprinter.res') + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cMGRES + 'miniprint.res') + ' + >> ' + cRsp + CRLF
      cOut += 'echo ' + AddQuote(cMGRES + 'minigui.res')   + '   >> ' + cRsp + CRLF
      cOut += CRLF

      cOut += cHLog + cILINK + ' -x -Gn -Tpe ' + IF(lConsole, '-ap', '-aa') + ;
        ' -L' + AddQuote(DelSlash(cBCCLIB)) + ' @' + cRsp + cTLog + CRLF
      cOut += cErr + CRLF
      cOut += 'del ' + AddQuote(cMainBase + '.tds') + CRLF

    ENDIF

  ENDIF

  cOut += CRLF
  cOut += 'echo success > _End.txt' + CRLF
  cOut += 'echo.' + cLLog + CRLF
  cOut += 'goto end' + CRLF
  cOut += CRLF
  cOut += ':err' + CRLF
  cOut += 'echo error > _End.txt' + CRLF
  IF lShow
    cOut += 'pause' + CRLF
  ENDIF
  cOut += 'goto end' + CRLF
  cOut += CRLF
  cOut += ':end' + CRLF

RETURN cOut

//***************************************************************************

FUNCTION DateTest(lRebuild, cProjFolder, cTargFile, aDepFiles)
  
  LOCAL aDir   := DIRECTORY(cProjFolder + cTargFile)
  LOCAL nFiles := LEN(aDepFiles)
  LOCAL lTest  := .N.
  LOCAL cFile
  LOCAL nFile
  LOCAL nTargDate
  
  IF lRebuild .OR. EMPTY(aDir)
    lTest := .Y.  
  ELSE
    nTargDate := DateTime(aDir[1][F_DATE], aDir[1][F_TIME])
    FOR nFile := 1 TO nFiles
      cFile := aDepFiles[nFile]
      aDir  := DIRECTORY(IF(':' $ cFile, cFile, cProjFolder + cFile))
      IF EMPTY(aDir)
        lTest := .Y.
      ELSE
        IF DateTime(aDir[1][F_DATE], aDir[1][F_TIME]) > nTargDate
          lTest := .Y.
        ENDIF
      ENDIF
    NEXT
  ENDIF
  
RETURN lTest
  
//***************************************************************************

FUNCTION BuildWait
  
  DO EVENTS

RETURN lGo

//***************************************************************************

PROCEDURE StopBuild

  BEGIN SEQUENCE
    IF !lProcess
      MpmStop('No build process is currently running.')
      BREAK
    ENDIF
    IF !IsXpPlus()
      MpmStop('The stop feature requires Windows XP or higher.')
      BREAK
    ENDIF
    IF !MpmYesNo('Stop build process?')
      BREAK
    ENDIF
    lGo := .N.
  END SEQUENCE

RETURN
  
//***************************************************************************

FUNCTION BlankTest()

  LOCAL lXHarbour      := Mpm.UseXHarbour.Value
  LOCAL cHarbourFolder := IF(lXHarbour, cXHarbourFolder, cOHarbourFolder)
  LOCAL cProjFolder    := ALLTRIM(Mpm.BaseFolder.Value)
  LOCAL cMpmFolder     := GetSub(GETEXEFILENAME())
  LOCAL nSouFiles      := LEN(aSouFiles)
  LOCAL cSpace := ' '
  LOCAL lBlank := ;
    cSpace $ ALLTRIM(cBccFolder)     .OR. ;
    cSpace $ ALLTRIM(cHarbourFolder) .OR. ;
    cSpace $ ALLTRIM(cMiniGuiFolder) .OR. ;
    cSpace $ ALLTRIM(cProjFolder)    .OR. ;
    cSpace $ ALLTRIM(cMpmFolder)
  LOCAL nFile

  FOR nFile := 1 TO nSouFiles
    IF cSpace $ aSouFiles[nFile][SOUFILE_NAME]
      lBlank := .Y.
    ENDIF
  NEXT

RETURN lBlank

//***************************************************************************

PROCEDURE Execute

  LOCAL lDebug      := Mpm.Debug.Value
  LOCAL lMainSou    := !EMPTY(aSouFiles)
  LOCAL cProjFolder := AddSlash(Mpm.BaseFolder.Value)
  LOCAL cMainSou    := IF(lMainSou, aSouFiles[1][SOUFILE_BASE], '')
  LOCAL cMainSuffix := IF(lDebug, '_deb', '')
  LOCAL cMainFile   := cProjFolder + cMainSou + cMainSuffix + '.exe'
  LOCAL cParams     := ALLTRIM(Mpm.ExeParams.Value)

  BEGIN SEQUENCE

    IF Mpm.GenLib.Value
      MpmStop('You are building a library, which cannot be directly run.')
      BREAK
    ENDIF
    IF EMPTY(cProjFolder) .OR. EMPTY(cMainSou) 
      MpmStop('You must start and build a project before running it.')
      BREAK
    ENDIF
    IF !FILE(cMainFile)
      MpmStop('Executable file does not exist.  ' + ;
        'You must successfully build the project.')
      BREAK
    ENDIF

    SetCurrentFolder(cProjFolder)
    MpmRun(cMainFile, cParams, .Y.)

  END SEQUENCE
    
RETURN

//***************************************************************************

PROCEDURE Cleanup
  
  LOCAL lMainSou    := !EMPTY(aSouFiles)
  LOCAL cProjFolder := AddSlash(Mpm.BaseFolder.Value)
  LOCAL cMainSou    := IF(lMainSou, aSouFiles[1][SOUFILE_BASE], '')
  LOCAL nFiles      := LEN(aSouFiles)
  LOCAL aFiles
  LOCAL nFile

  StatusLabel('Cleaning up', 2)
  DELETE FILE (cProjFolder + cMainSou + '_deb.exe')
  DELETE FILE (cProjFolder + '_Build.bat')
  DELETE FILE (cProjFolder + '_Build.log')
  DELETE FILE (cProjFolder + '_Build.rsp')
  DELETE FILE (cProjFolder + '_End.txt'  )
  FOR nFile := 1 TO nFiles
    DELETE FILE (cProjFolder + DelExt(aSouFiles[nFile][SOUFILE_NAME]) + '.ppo')
  NEXT
  aFiles := DIRECTORY(cProjFolder + 'Deb\*.*')
  nFiles := LEN(aFiles)
  FOR nFile := 1 TO nFiles
    DELETE FILE (cProjFolder + 'Deb\' + aFiles[nFile][F_NAME])
  NEXT
  aFiles := DIRECTORY(cProjFolder + 'Obj\*.*')
  nFiles := LEN(aFiles)
  FOR nFile := 1 TO nFiles
    DELETE FILE (cProjFolder + 'Obj\' + aFiles[nFile][F_NAME])
  NEXT
  REMOVEFOLDER(cProjFolder + 'Deb')
  REMOVEFOLDER(cProjFolder + 'Obj')
  StatusLabel('Cleanup completed', 0)

RETURN  

//***************************************************************************

PROCEDURE SetEnvironment(lInit)
  
  LOCAL cFolder
  LOCAL cFileName
  LOCAL lAssocMpm := IsAssociated('.mpm', lInit)
  LOCAL lAssocPrg := IsAssociated('.prg', lInit)
  LOCAL lAssocC   := IsAssociated('.c'  , lInit)
  
  DEFINE WINDOW Environment ;
    AT     nEnvirRow, nEnvirCol ;
    WIDTH  nEnvirWidth ;
    HEIGHT nEnvirHeight ;
    TITLE 'Environment settings' ;
    ICON  'MAIN' ;
    MODAL ;
    ON INIT EnvironmentSize() ;
    ON MOVE EnvironmentSize() ;
    ON SIZE EnvironmentSize()

    DEFINE LABEL lbBccFolder
      ROW   10
      COL   10
      VALUE 'BCC folder'
    END LABEL

    DEFINE TEXTBOX BccFolder
      ROW     10
      COL     100
      WIDTH   180
      HEIGHT  22
      VALUE   cBccFolder
    END TEXTBOX

    DEFINE BUTTON btBccFolder
      ROW     10
      COL     290
      WIDTH   25
      HEIGHT  25
      PICTURE 'folderselect'
      TOOLTIP 'Select folder'
      ONCLICK (StatusLabel(), ;
        IF(!EMPTY(cFolder := GetFolder('BCC folder', ;
        Environment.BccFolder.Value)), ;
        Environment.BccFolder.Value := cFolder, ;
        NIL))
    END BUTTON

    DEFINE LABEL lbMiniGuiFolder
      ROW   40
      COL   10
      VALUE 'MiniGUI folder'
    END LABEL

    DEFINE TEXTBOX MiniGuiFolder
      ROW     40
      COL     100
      WIDTH   180
      HEIGHT  22
      VALUE   cMiniGuiFolder
    END TEXTBOX

    DEFINE BUTTON btMiniGuiFolder
      ROW     40
      COL     290
      WIDTH   25
      HEIGHT  25
      PICTURE 'folderselect'
      TOOLTIP 'Select folder'
      ONCLICK (StatusLabel(), ;
        IF(!EMPTY(cFolder := GetFolder('MiniGui folder', ;
        Environment.MiniGuiFolder.Value)), ;
        Environment.MiniGuiFolder.Value := cFolder, ;
        NIL))
    END BUTTON

    DEFINE LABEL lbHarbourFolder
      ROW   70
      COL   10
      VALUE 'Harbour folder'
    END LABEL

    DEFINE TEXTBOX OHarbourFolder
      ROW     70
      COL     100
      WIDTH   180
      HEIGHT  22
      VALUE   cOHarbourFolder
    END TEXTBOX

    DEFINE BUTTON btOHarbourFolder
      ROW     70
      COL     290
      WIDTH   25
      HEIGHT  25
      PICTURE 'folderselect'
      TOOLTIP 'Select folder'
      ONCLICK (StatusLabel(), ;
        IF(!EMPTY(cFolder := GetFolder('Harbour folder', ;
        Environment.OHarbourFolder.Value)), ;
        Environment.OHarbourFolder.Value := cFolder, ;
        NIL))
    END BUTTON

    DEFINE LABEL lbXHarbourFolder
      ROW   100
      COL   10
      VALUE 'xHarbour folder'
    END LABEL

    DEFINE TEXTBOX XHarbourFolder
      ROW     100
      COL     100
      WIDTH   180
      HEIGHT  22
      VALUE   cXHarbourFolder
    END TEXTBOX

    DEFINE BUTTON btXHarbourFolder
      ROW     100
      COL     290
      WIDTH   25
      HEIGHT  25
      PICTURE 'folderselect'
      TOOLTIP 'Select folder'
      ONCLICK (StatusLabel(), ;
        IF(!EMPTY(cFolder := GetFolder('xHarbour folder', ;
        Environment.XHarbourFolder.Value)), ;
        Environment.XHarbourFolder.Value := cFolder, ;
        NIL))
    END BUTTON

    DEFINE LABEL lbEditorExe
      ROW   130
      COL   10
      VALUE 'Program editor'
    END LABEL

    DEFINE TEXTBOX EditorExe
      ROW     130
      COL     100
      WIDTH   180
      HEIGHT  22
      VALUE   cEditorExe
    END TEXTBOX

    DEFINE BUTTON btEditorExe
      ROW     130
      COL     290
      WIDTH   25
      HEIGHT  25
      PICTURE 'folderselect'
      TOOLTIP 'Select editor'
      ONCLICK (StatusLabel(), ;
        IF(!EMPTY(cFileName := ;
        GetFile({{'Applications (*.exe)','*.exe'}}, ;
        'Select program editor', GetSub(Environment.EditorExe.Value))), ;
        Environment.EditorExe.Value := cFileName, ;
        NIL))
    END BUTTON

    DEFINE CHECKBOX MpmAssociation
      ROW     160
      COL     10
      WIDTH   180
      VALUE   lAssocMpm
      CAPTION 'Associate MPM files with MPM'
      TOOLTIP 'Double click on MPM file starts MPM'
    END CHECKBOX

    DEFINE CHECKBOX PrgAssociation
      ROW     190
      COL     10
      WIDTH   180
      VALUE   lAssocPrg
      CAPTION 'Associate PRG files with MPM'
      TOOLTIP 'Double click on PRG file starts MPM'
    END CHECKBOX

    DEFINE CHECKBOX CAssociation
      ROW     220
      COL     10
      WIDTH   180
      VALUE   lAssocC
      CAPTION 'Associate C files with MPM'
      TOOLTIP 'Double click on C file starts MPM'
    END CHECKBOX

    DEFINE BUTTON btMpmAssoc
      ROW     160
      COL     290
      WIDTH   25
      HEIGHT  25
      PICTURE 'registry'
      TOOLTIP 'Show current MPM file association'
      ONCLICK ShowAssociation('.mpm')
    END BUTTON

    DEFINE BUTTON btPrgAssoc
      ROW     190
      COL     290
      WIDTH   25
      HEIGHT  25
      PICTURE 'registry'
      TOOLTIP 'Show current PRG file association'
      ONCLICK ShowAssociation('.prg')
    END BUTTON

    DEFINE BUTTON btCAssoc
      ROW     220
      COL     290
      WIDTH   25
      HEIGHT  25
      PICTURE 'registry'
      TOOLTIP 'Show current C file association'
      ONCLICK ShowAssociation('.c')
    END BUTTON

    DEFINE BUTTON Ok
      ROW     260
      COL     85
      WIDTH   65
      HEIGHT  25
      CAPTION '&OK'
      ONCLICK (UpdateEnvironment(), Environment.Release)
    END BUTTON

    DEFINE BUTTON Cancel
      ROW     260
      COL     175
      WIDTH   65
      HEIGHT  25
      CAPTION '&Cancel'
      ONCLICK Environment.Release
    END BUTTON

    ON KEY RETURN ACTION (UpdateEnvironment(), Environment.Release)
    ON KEY ESCAPE ACTION Environment.Release

  END WINDOW 

  Environment.MinWidth  := 260
  Environment.MinHeight := 320

  ACTIVATE WINDOW Environment

RETURN

//***************************************************************************

PROCEDURE EnvironmentSize
  
LOCAL lThemed := IsXPThemeActive()

  nEnvirWidth  := Environment.Width
  nEnvirHeight := Environment.Height
  nEnvirCol    := Environment.Col
  nEnvirRow    := Environment.Row
  Environment.BccFolder.Width      := nEnvirWidth - 150
  Environment.btBccFolder.Col      := nEnvirWidth - 40
  Environment.MiniGuiFolder.Width  := nEnvirWidth - 150
  Environment.btMiniGuiFolder.Col  := nEnvirWidth - 40
  Environment.OHarbourFolder.Width := nEnvirWidth - 150
  Environment.btOHarbourFolder.Col := nEnvirWidth - 40
  Environment.XHarbourFolder.Width := nEnvirWidth - 150
  Environment.btXHarbourFolder.Col := nEnvirWidth - 40
  Environment.EditorExe.Width      := nEnvirWidth - 150
  Environment.btEditorExe.Col      := nEnvirWidth - 40
  Environment.btMpmAssoc.Col       := nEnvirWidth - 40
  Environment.btPrgAssoc.Col       := nEnvirWidth - 40
  Environment.btCAssoc.Col         := nEnvirWidth - 40
  Environment.Ok.Col     := MAX(10, INT(nEnvirWidth / 2 ) - 80)
  Environment.Ok.Row     := MAX(70, nEnvirHeight - 60 - IF(lThemed, 7, 0))
  Environment.Cancel.Col := MAX(10, INT(nEnvirWidth / 2 ) + 10)
  Environment.Cancel.Row := MAX(70, nEnvirHeight - 60 - IF(lThemed, 7, 0))

RETURN

//***************************************************************************

PROCEDURE UpdateEnvironment

  cBccFolder      := DelSlash(Environment.BccFolder.Value)
  cMiniGuiFolder  := DelSlash(Environment.MiniGuiFolder.Value)
  cOHarbourFolder := DelSlash(Environment.OHarbourFolder.Value)
  cXHarbourFolder := DelSlash(Environment.XHarbourFolder.Value)
  cEditorExe      := Environment.EditorExe.Value
  ChangeAssociation('.mpm', Environment.MpmAssociation.Value)
  ChangeAssociation('.prg', Environment.PrgAssociation.Value)
  ChangeAssociation('.c'  , Environment.CAssociation.Value)  
  StatusLabel()

RETURN  

//***************************************************************************

PROCEDURE ShowAssociation(cExt)

  LOCAL cKey
  LOCAL cVal

  BEGIN SEQUENCE
    cKey := 'Software\CLASSES\' + cExt
    IF !IsRegistryKey(HKEY_LOCAL_MACHINE, cKey)
      BREAK
    ENDIF
    cVal := GetRegistryValue(HKEY_LOCAL_MACHINE, cKey)
    IF EMPTY(cVal)
      BREAK
    ENDIF
    cKey := 'Software\CLASSES\' + cVal + '\Shell\Open\command'
    IF !IsRegistryKey(HKEY_LOCAL_MACHINE, cKey)
      BREAK
    ENDIF 
    cVal := GetRegistryValue(HKEY_LOCAL_MACHINE, cKey)
    IF EMPTY(cVal)
      BREAK
    ENDIF
    IF UPPER(cVal) == UPPER(GETEXEFILENAME())
      MpmInfo(UPPER(cExt) + ' files are currently associated with MPM.')
    ELSE  
      MpmInfo(UPPER(cExt) + ' files are currently associated with ' + ;
        cVal + '.')
    ENDIF
  RECOVER   
    MpmInfo(UPPER(cExt) + ;
      ' files are not currently associated with any program.')
  END SEQUENCE

RETURN

//***************************************************************************

FUNCTION IsAssociated(cExt, lInit)
  
  LOCAL cKey
  LOCAL cVal
  LOCAL lAssoc

  BEGIN SEQUENCE
    cKey := 'Software\CLASSES\' + cExt
    IF !IsRegistryKey(HKEY_LOCAL_MACHINE, cKey)
      BREAK
    ENDIF
    cVal := GetRegistryValue(HKEY_LOCAL_MACHINE, cKey)
    IF EMPTY(cVal)
      BREAK
    ENDIF
    cKey := 'Software\CLASSES\' + cVal + '\Shell\Open\command'
    IF !IsRegistryKey(HKEY_LOCAL_MACHINE, cKey)
      BREAK
    ENDIF 
    cVal := GetRegistryValue(HKEY_LOCAL_MACHINE, cKey)
    IF EMPTY(cVal)
      BREAK
    ENDIF
    cVal   := ALLTRIM(STRTRAN(STRTRAN(cVal, '"'), '%1'))
    lAssoc := (UPPER(cVal) == UPPER(GETEXEFILENAME()))
  RECOVER
    lAssoc := !EMPTY(lInit)
  END SEQUENCE

RETURN lAssoc

//***************************************************************************

PROCEDURE ChangeAssociation(cExt, lSet)
  
  LOCAL lAssoc := IsAssociated(cExt)
  LOCAL cKey

  DO CASE
  CASE lSet .AND. !lAssoc
    BEGIN SEQUENCE
      cKey := 'Software\CLASSES\' + cExt
      IF !CreateRegistryKey(HKEY_LOCAL_MACHINE, cKey)
        BREAK
      ENDIF
      IF !SetRegistryValue(HKEY_LOCAL_MACHINE, cKey,, 'mpmfile')
        BREAK
      ENDIF
      cKey := 'Software\CLASSES\mpmfile\Shell\Open\command'
      IF !CreateRegistryKey(HKEY_LOCAL_MACHINE, cKey)
        BREAK
      ENDIF
      IF !SetRegistryValue(HKEY_LOCAL_MACHINE, cKey,, ;
        AddQuote(GETEXEFILENAME()) + ' "%1"')
        BREAK
      ENDIF
    RECOVER
      MpmStop('Unable to associate ' + cExt + ' files with MPM.')
    END SEQUENCE
  CASE !lSet .AND. lAssoc
    BEGIN SEQUENCE
      cKey := 'Software\CLASSES'
      IF !DeleteRegistryKey(HKEY_LOCAL_MACHINE, cKey, cExt)
        BREAK
      ENDIF
    RECOVER
      MpmStop('Unable to disassociate ' + cExt + ' files from MPM.')
    END SEQUENCE
  ENDCASE

RETURN

//***************************************************************************

PROCEDURE StatusLabel(cLabel, nType)

  LOCAL lProjModOld := lProjMod
  
  DO CASE
  CASE EMPTY(cLabel)
    Mpm.lbStatus.Value := ''
  CASE EMPTY(nType)
    Mpm.lbStatus.Value     := cLabel
    Mpm.lbStatus.FontColor := {0x00, 0xC0, 0x00}
  CASE nType == 1
    Mpm.lbStatus.Value     := cLabel
    Mpm.lbStatus.FontColor := {0x80, 0x80, 0x00}
  CASE nType == 2
    Mpm.lbStatus.Value     := cLabel
    Mpm.lbStatus.FontColor := {0xC0, 0x00, 0x00}
  ENDCASE

  lProjMod := lProjModOld

RETURN

//***************************************************************************

PROCEDURE StatusRefresh

  LOCAL cProjFolder := AddSlash(Mpm.BaseFolder.Value)
  LOCAL cCR         := CHR(0x0D)
  LOCAL lSuccess

  IF lProcess
    IF FILE(cProjFolder + '_Build.bat')
      StatusLabel('Building', 2)
      DO CASE
      CASE FILE(cProjFolder + '_End.txt')
        lProcess := .N.
        lSuccess := 'success' $ MEMOREAD(cProjFolder + '_End.txt')
        Mpm.Log.Value := LogClean(MEMOREAD(cProjFolder + '_Build.log'))
        IF Mpm.DeleteTemp.Value
          DELETE FILE (cProjFolder + '_Build.bat')
          DELETE FILE (cProjFolder + '_Build.log')
          DELETE FILE (cProjFolder + '_Build.rsp')
          DELETE FILE (cProjFolder + '_End.txt'  )
        ENDIF
        IF lSuccess
          StatusLabel('Build successful', 0)
          IF Mpm.RunAfter.Value
            Execute()
          ENDIF 
        ELSE  
          StatusLabel('Build unsuccessful', 1)
        ENDIF
      CASE !lGo
        lProcess := .N.
        StatusLabel('Build stopped', 1)
      OTHERWISE
        Mpm.Log.Value := LogProg(MEMOREAD(cProjFolder + '_Build.log'))
      ENDCASE
    ELSE
      lProcess := .N.
      StatusLabel('Build unsuccessful', 1)
    ENDIF
  ENDIF

RETURN

//***************************************************************************

FUNCTION LogClean(cInLog)
  
  LOCAL lXHarbour := Mpm.UseXHarbour.Value
  LOCAL cCR       := CHR(0x0D)
  LOCAL cOutLog   := cInLog
  LOCAL cSearch   := IF(lXHarbour, '00' + cCR + ' ', '00' + cCR + cCR)
  LOCAL nLeft
  LOCAL nLen
  LOCAL nPos

  IF lXHarbour
    nPos := RAT(cSearch, cOutLog)
    WHILE !EMPTY(nPos)
      nLeft   := nPos + 2
      nLen    := AT(cCR, cInLog, nLeft) - nLeft
      cOutLog := STUFF(cOutLog, nLeft, nLen, '')
      nPos    := RAT(cSearch, cOutLog)
    ENDDO
  ELSE
    nPos := RAT(cSearch, cOutLog)
    WHILE !EMPTY(nPos)
      nLeft   := RAT(cCR, LEFT(cOutLog, nPos)) + 1
      nLen    := nPos - nLeft + 4
      cOutLog := STUFF(cOutLog, nLeft, nLen, '')
      nPos    := RAT(cSearch, cOutLog)
    ENDDO
    cOutLog := STRTRAN(STRTRAN(cOutLog, CRLF, cCR), cCR, CRLF)
  ENDIF
  
RETURN cOutLog

//***************************************************************************

FUNCTION LogProg(cLog)

  LOCAL cCR     := CHR(0x0D)
  LOCAL cProg   := MEMOLINE(cLog,, 1) + CRLF + MEMOLINE(cLog,, 2)
  LOCAL nComPos := AT('Compiling ', cLog)
  LOCAL nNumPos := RAT('00' + cCR, cLog)
  LOCAL nLeft
  LOCAL nLen
  LOCAL nLine

  IF !EMPTY(nComPos) .AND. !EMPTY(nNumPos)
    nLine := MPOSTOLC(cLog,, nComPos)[1]
    nLeft := RAT(cCR, LEFT(cLog, nNumPos)) + 1
    nLen  := AT(cCR, SUBSTR(cLog, nLeft) + cCR) - 1
    cProg += CRLF + RTRIM(MEMOLINE(cLog,, nLine)) + ' ' + ;
      SUBSTR(cLog, nLeft, nLen)
  ENDIF

RETURN cProg

//***************************************************************************

PROCEDURE LoadEnvironment

  LOCAL cWinFolder  := AddSlash(GetWindowsFolder())
  LOCAL cIniFile    := cWinFolder + 'mpm.ini'
  LOCAL nDeskWidth  := GetDesktopWidth()
  LOCAL nDeskHeight := GetDesktopHeight()
  LOCAL lThemed     := IsXPThemeActive()
  LOCAL cEnvir
  LOCAL nLine
  LOCAL nPos
  LOCAL cLine
  LOCAL cLineU
  LOCAL cKey
  LOCAL cVal
  LOCAL cValU

  IF lEnvir := FILE(cIniFile)
    
    cEnvir := MEMOREAD(cIniFile)
    FOR nLine := 1 TO MLCOUNT(cEnvir)
      cLine  := ALLTRIM(MEMOLINE(cEnvir,, nLine))
      cLineU := UPPER(cLine)
      nPos   := AT('=', cLine)
      cKey   := STRTRAN(LEFT(cLineU, nPos - 1), ' ')
      cVal   := ALLTRIM(SUBSTR(cLine, nPos + 1))
      cValU  := UPPER(cVal)
      DO CASE
      CASE cKey == 'BCCFOLDER'
        cBccFolder      := cVal
      CASE cKey == 'MINIGUIFOLDER'
        cMiniGuiFolder  := cVal
      CASE cKey == 'HARBOURFOLDER'
        cOHarbourFolder := cVal
      CASE cKey == 'XHARBOURFOLDER'
        cXHarbourFolder := cVal
      CASE cKey == 'PROGRAMEDITOR'
        cEditorExe      := cVal
      CASE cKey == 'PROGRAMEDITOR'
        cEditorExe      := cVal
      CASE cKey == 'MPMWIDTH'
        nMpmWidth     := MAX(640, VAL(cVal))
      CASE cKey == 'MPMHEIGHT'
        nMpmHeight    := MAX(480, VAL(cVal))
      CASE cKey == 'MPMCOL'
        nMpmCol       := VAL(cVal)
      CASE cKey == 'MPMROW'
        nMpmRow       := VAL(cVal)
      CASE cKey == 'RECENTWIDTH'
        nRecentWidth  := MAX(185, VAL(cVal))
      CASE cKey == 'RECENTHEIGHT'
        nRecentHeight := MAX(130, VAL(cVal))
      CASE cKey == 'RECENTCOL'
        nRecentCol    := VAL(cVal)
      CASE cKey == 'RECENTROW'
        nRecentRow    := VAL(cVal)
      CASE cKey == 'ENVIRWIDTH'
        nEnvirWidth   := MAX(185, VAL(cVal))
      CASE cKey == 'ENVIRHEIGHT'
        nEnvirHeight  := MAX(320, VAL(cVal))
      CASE cKey == 'ENVIRCOL'
        nEnvirCol     := VAL(cVal)
      CASE cKey == 'ENVIRROW'
        nEnvirRow     := VAL(cVal)
      CASE cKey == 'HELPWIDTH'
        nHelpWidth    := MAX(120, VAL(cVal))
      CASE cKey == 'HELPHEIGHT'
        nHelpHeight   := MAX(100, VAL(cVal))
      CASE cKey == 'HELPCOL'
        nHelpCol      := VAL(cVal)
      CASE cKey == 'HELPROW'
        nHelpRow      := VAL(cVal)
      CASE cKey == 'FILEHISTORY1'
        aFileHist[1]  := cVal
      CASE cKey == 'FILEHISTORY2'
        aFileHist[2]  := cVal
      CASE cKey == 'FILEHISTORY3'
        aFileHist[3]  := cVal
      CASE cKey == 'FILEHISTORY4'
        aFileHist[4]  := cVal
      CASE cKey == 'FILEHISTORY5'
        aFileHist[5]  := cVal
      CASE cKey == 'FILEHISTORY6'
        aFileHist[6]  := cVal
      CASE cKey == 'FILEHISTORY7'
        aFileHist[7]  := cVal
      CASE cKey == 'FILEHISTORY8'
        aFileHist[8]  := cVal
      CASE cKey == 'FILEHISTORY9'
        aFileHist[9]  := cVal
      ENDCASE
    NEXT

  ENDIF

  IF EMPTY(nMpmWidth)
    nMpmWidth  := MAX(640, MIN(750, nDeskWidth))
  ENDIF
  IF EMPTY(nMpmHeight)
    nMpmHeight := MAX(480, MIN(500, nDeskHeight))
  ENDIF
  IF EMPTY(nMpmCol)
    nMpmCol    := MAX(0, (nDeskWidth  - nMpmWidth ) / 2)
  ENDIF
  IF EMPTY(nMpmRow)
    nMpmRow    := MAX(0, (nDeskHeight - nMpmHeight) / 2)
  ENDIF

  IF EMPTY(nRecentWidth)
    nRecentWidth  := 330
  ENDIF
  IF EMPTY(nRecentHeight)
    nRecentHeight := 220 + IF(lThemed, 7, 0)
  ENDIF
  IF EMPTY(nRecentCol)
    nRecentCol    := MAX(0, (nDeskWidth  - nRecentWidth ) / 2)
  ENDIF
  IF EMPTY(nRecentRow)
    nRecentRow    := MAX(0, (nDeskHeight - nRecentHeight) / 2)
  ENDIF

  IF EMPTY(nEnvirWidth)
    nEnvirWidth   := 330
  ENDIF
  IF EMPTY(nEnvirHeight)
    nEnvirHeight  := 320 + IF(lThemed, 7, 0)
  ENDIF
  IF EMPTY(nEnvirCol)
    nEnvirCol     := MAX(0, (nDeskWidth  - nEnvirWidth ) / 2)
  ENDIF
  IF EMPTY(nEnvirRow)
    nEnvirRow     := MAX(0, (nDeskHeight - nEnvirHeight) / 2)
  ENDIF

  IF EMPTY(nHelpWidth)
    nHelpWidth    := 500
  ENDIF
  IF EMPTY(nHelpHeight)
    nHelpHeight   := 500
  ENDIF
  IF EMPTY(nHelpCol)
    nHelpCol      := 10
  ENDIF
  IF EMPTY(nHelpRow)
    nHelpRow      := 10
  ENDIF

  IF EMPTY(cBccFolder)
    cBccFolder      := 'C:\Borland\BCC55'
  ENDIF
  IF EMPTY(cMiniGuiFolder)
    cMiniGuiFolder  := 'C:\MiniGUI'
  ENDIF
  IF EMPTY(cOHarbourFolder)
    cOHarbourFolder := 'C:\MiniGUI\Harbour'
  ENDIF
  IF EMPTY(cXHarbourFolder)
    cXHarbourFolder := 'C:\xHarbour'
  ENDIF
  IF EMPTY(cEditorExe)
    cEditorExe      := 'NOTEPAD.EXE'
  ENDIF

  lProjMod := .N.

RETURN

//***************************************************************************

PROCEDURE SaveEnvironment

  LOCAL cWinFolder := AddSlash(GetWindowsFolder())
  LOCAL cEnvir     := ;
    'BCCFOLDER='      + ALLTRIM(cBccFolder)       + CRLF + ;
    'MINIGUIFOLDER='  + ALLTRIM(cMiniGuiFolder)   + CRLF + ;
    'HARBOURFOLDER='  + ALLTRIM(cOHarbourFolder)  + CRLF + ;
    'XHARBOURFOLDER=' + ALLTRIM(cXHarbourFolder)  + CRLF + ;
    'PROGRAMEDITOR='  + ALLTRIM(cEditorExe)       + CRLF + ;
    'MPMWIDTH='       + LTRIM(STR(nMpmWidth))     + CRLF + ;
    'MPMHEIGHT='      + LTRIM(STR(nMpmHeight))    + CRLF + ;
    'MPMCOL='         + LTRIM(STR(nMpmCol))       + CRLF + ;
    'MPMROW='         + LTRIM(STR(nMpmRow))       + CRLF + ;
    'RECENTWIDTH='    + LTRIM(STR(nRecentWidth))  + CRLF + ;
    'RECENTHEIGHT='   + LTRIM(STR(nRecentHeight)) + CRLF + ;
    'RECENTCOL='      + LTRIM(STR(nRecentCol))    + CRLF + ;
    'RECENTROW='      + LTRIM(STR(nRecentRow))    + CRLF + ;
    'ENVIRWIDTH='     + LTRIM(STR(nEnvirWidth))   + CRLF + ;
    'ENVIRHEIGHT='    + LTRIM(STR(nEnvirHeight))  + CRLF + ;
    'ENVIRCOL='       + LTRIM(STR(nEnvirCol))     + CRLF + ;
    'ENVIRROW='       + LTRIM(STR(nEnvirRow))     + CRLF + ;
    'HELPWIDTH='      + LTRIM(STR(nHelpWidth))    + CRLF + ;
    'HELPHEIGHT='     + LTRIM(STR(nHelpHeight))   + CRLF + ;
    'HELPCOL='        + LTRIM(STR(nHelpCol))      + CRLF + ;
    'HELPROW='        + LTRIM(STR(nHelpRow))      + CRLF + ;
    'FILEHISTORY1='   + aFileHist[1]              + CRLF + ;
    'FILEHISTORY2='   + aFileHist[2]              + CRLF + ;
    'FILEHISTORY3='   + aFileHist[3]              + CRLF + ;
    'FILEHISTORY4='   + aFileHist[4]              + CRLF + ;
    'FILEHISTORY5='   + aFileHist[5]              + CRLF + ;
    'FILEHISTORY6='   + aFileHist[6]              + CRLF + ;
    'FILEHISTORY7='   + aFileHist[7]              + CRLF + ;
    'FILEHISTORY8='   + aFileHist[8]              + CRLF + ;
    'FILEHISTORY9='   + aFileHist[9]              + CRLF

  SaveCheck()
  MemoWrite(cWinFolder + 'mpm.ini', cEnvir)

RETURN

//***************************************************************************

PROCEDURE MpmInfo(cMsg, cTitle)
  
  MsgInfo(cMsg, IF(EMPTY(cTitle), 'MPM', cTitle),, .N., .N.)

RETURN

//***************************************************************************

PROCEDURE MpmStop(cMsg, cTitle)
  
  MsgStop(cMsg, IF(EMPTY(cTitle), 'MPM', cTitle),, .N., .N.)

RETURN

//***************************************************************************

FUNCTION MpmYesNo(cMsg, cTitle)
  
  LOCAL lYesNo := MsgYesNo(cMsg, IF(EMPTY(cTitle), 'MPM', cTitle),,, .N., .N.)

RETURN lYesNo

//***************************************************************************

FUNCTION MpmRun(cFile, cParams, lShow)

  LOCAL hProcErr := { ;
    2  => 'File not found'          , ;
    3  => 'Path not found'          , ;
    5  => 'Access denied'           , ;
    8  => 'Out of memory'           , ;
    11 => 'Corrupt EXE file'        , ;
    26 => 'Sharing violation'       , ;
    27 => 'Invalid file association', ;
    28 => 'DDE timeout'             , ;
    29 => 'DDE transaction failed'  , ;
    30 => 'DDE busy'                , ;
    31 => 'No file association'     , ;
    32 => 'DLL not found'             }
  LOCAL nProc := _Execute(GetActiveWindow(),, ;
      AddQuote(cFile), cParams,, IF(lShow, 5, 0))
  LOCAL lRun := (nProc > 32)

  IF !lRun
    IF nProc $ hProcErr
      MpmStop('Run error ' + LTRIM(STR(nProc)) + ': ' + hProcErr[nProc])
    ELSE
      MpmStop('Unknown run error ' + LTRIM(STR(nProc)))
    ENDIF
  ENDIF 

RETURN lRun

//***************************************************************************

PROCEDURE SwitchDebug(lToggle, lMod)

  LOCAL cProjFolderE := AddSlash(Mpm.BaseFolder.Value)
  LOCAL cProjFolderD := DelSlash(Mpm.BaseFolder.Value)

  StatusLabel()
  IF lToggle
    Mpm.Debug.Value := !Mpm.Debug.Value
  ENDIF
  Mpm.miDebug.Checked := Mpm.Debug.Value
  Mpm.lbDebug.Value   := IF(Mpm.Debug.Value, 'Debug', '')
  IF lMod
    lProjMod := .Y.
  ENDIF 

RETURN

//***************************************************************************

PROCEDURE SwitchRebuild(lToggle, lMod)

  StatusLabel()
  IF lToggle
    Mpm.Rebuild.Value := !Mpm.Rebuild.Value
  ENDIF
  Mpm.miRebuild.Checked := Mpm.Rebuild.Value
  Mpm.lbRebuild.Value   := IF(Mpm.Rebuild.Value, 'Rebuild', '')
  IF lMod
    lProjMod := .Y.
  ENDIF 
  
RETURN    

//***************************************************************************

FUNCTION AddSlash(cInFolder)

  LOCAL cOutFolder := ALLTRIM(cInFolder)

  IF !EMPTY(cOutFolder) .AND. RIGHT(cOutfolder, 1) != '\'
    cOutFolder += '\'
  ENDIF

RETURN cOutFolder

//***************************************************************************

FUNCTION DelSlash(cInFolder)

  LOCAL cOutFolder := ALLTRIM(cInFolder)

  IF !EMPTY(cOutFolder) .AND. RIGHT(cOutfolder, 1) == '\'
    cOutFolder := LEFT(cOutFolder, LEN(cOutFolder) - 1)
  ENDIF

RETURN cOutFolder

//***************************************************************************

FUNCTION AddQuote(cInPath)

  LOCAL cOutPath := ALLTRIM(cInPath)
  LOCAL cQuote   := '"'
  LOCAL cSpace   := SPACE(1)

  IF cSpace $ cOutPath .AND. ;
    !(LEFT(cOutPath, 1) == cQuote) .AND. !(RIGHT(cOutPath, 1) == cQuote)
    cOutPath := cQuote + cOutPath + cQuote
  ENDIF

RETURN cOutPath

//***************************************************************************

FUNCTION GetPath(cFileName)

  LOCAL cTrim  := ALLTRIM(cFileName)  
  LOCAL nColon := AT(':', cTrim)
  LOCAL cDrive
  LOCAL cPath

  IF EMPTY(nColon)
    cDrive := DISKNAME()
    IF LEFT(cTrim, 1) == '\'
      cPath := cDrive + ':' + cTrim
    ELSE
      cPath := cDrive + ':\' + CURDIR(cDrive) + '\' + cTrim
    ENDIF
  ELSE
    IF SUBSTR(cTrim, nColon + 1, 1) == '\'
      cPath := cTrim
    ELSE
      cDrive := LEFT(cTrim, nColon - 1)
      cPath  := cDrive + ':\' + CURDIR(cDrive) + '\' + ;
        SUBSTR(cTrim, nColon + 1)
    ENDIF
  ENDIF

RETURN cPath

//***************************************************************************

FUNCTION GetSub(cFileName, lGetDefault)

  LOCAL cTrim  := ;
    IF(EMPTY(lGetDefault), ALLTRIM(cFileName), GetPath(cFileName))
  LOCAL nSlash := MAX(RAT('\', cTrim), AT(':', cTrim))
  LOCAL cSub   := LEFT(cTrim, nSlash - 1)

RETURN cSub

//***************************************************************************

FUNCTION GetName(cFileName)

  LOCAL cTrim  := ALLTRIM(cFileName)  
  LOCAL nSlash := MAX(RAT('\', cTrim), AT(':', cTrim))
  LOCAL cName  := IF(EMPTY(nSlash), cTrim, SUBSTR(cTrim, nSlash + 1))

RETURN cName

//***************************************************************************

FUNCTION GetExt(cFileName)

  LOCAL cTrim  := ALLTRIM(cFileName)  
  LOCAL nDot   := RAT('.', cTrim)
  LOCAL nSlash := MAX(RAT('\', cTrim), AT(':', cTrim))
  LOCAL cExt   := IF(nDot <= nSlash .OR. nDot == nSlash + 1, ;
    '', SUBSTR(cTrim, nDot))

RETURN cExt

//***************************************************************************

FUNCTION DelExt(cFileName)

  LOCAL cTrim  := ALLTRIM(cFileName)  
  LOCAL nDot   := RAT('.', cTrim)
  LOCAL nSlash := MAX(RAT('\', cTrim), AT(':', cTrim))
  LOCAL cBase  := IF(nDot <= nSlash .OR. nDot == nSlash + 1, ;
    cTrim, LEFT(cTrim, nDot - 1))

RETURN cBase

//***************************************************************************

FUNCTION DateTime(dDate, cTime)

  LOCAL nDateTime := (dDate - CTOD('')) + SECS(cTime)/86400

RETURN nDateTime

//***************************************************************************

FUNCTION MemoWrite(cFile, cCont)

  LOCAL lWrite := MEMOWRIT(cFile, cCont, .N.)

RETURN lWrite

//***************************************************************************

FUNCTION IsXpPlus

  LOCAL cVer := UPPER(WindowsVersion()[1])
  LOCAL lXp  := 'XP' $ cVer .OR. 'VISTA' $ cVer

RETURN lXp

//***************************************************************************

FUNCTION AInsert(aArray, nPos, xVal)

  AADD(aArray, NIL)
  AINS(aArray, nPos)
  aArray[nPos] := xVal

RETURN aArray

//***************************************************************************

FUNCTION ADelete(aArray, nPos)

  ADEL(aArray, nPos)
  ASIZE(aArray, LEN(aArray) - 1)

RETURN aArray

//***************************************************************************

PROCEDURE About

  MpmInfo( cMpmTitle + CRLF + ;
    CRLF + ;
    'Based on Harbour MiniGui Project Manager by Roberto Lopez' + CRLF + ;
    'Copyright (c) 2003 Roberto Lopez <roblez@ciudad.com.ar>' + CRLF + ;
    CRLF + ;
    'MiniGUI Extended version by the MiniGUI team' + CRLF + ;
    MiniGUIVersion() + CRLF + ;
    CRLF + ;
    'Last modified ' + cMpmDate + ' by' + CRLF + ;
    'Grigory Filatov <gfilatov@freemail.ru> and'  + CRLF + ;
    'Kevin Carmody <i@kevincarmody.com>', 'About MPM')

RETURN

//***************************************************************************

PROCEDURE Contents

  DEFINE WINDOW Help ;
    AT     nHelpRow, nHelpCol ;
    WIDTH  nHelpWidth ;
    HEIGHT nHelpHeight ;
    TITLE 'MPM Help' ;
    ICON  'MAIN' ;
    ON INIT SizeHelp() ;
    ON MAXIMIZE SizeHelp(.Y.) ;
    ON MOVE SizeHelp() ;
    ON SIZE SizeHelp()

    ON KEY ESCAPE ACTION Help.Release

    DEFINE EDITBOX Contents
      ROW     10
      COL     10
      WIDTH   520
      HEIGHT  500
      VALUE   HelpText()
      READONLY   .Y.
      HSCROLLBAR .N.
    END EDITBOX

  END WINDOW

  Help.MinWidth  := 120
  Help.MinHeight := 100

  ACTIVATE WINDOW Help

RETURN

//***************************************************************************

PROCEDURE SizeHelp(lMax)
  
  LOCAL lThemed := IsXPThemeActive()
  LOCAL nWidth  := Help.Width
  LOCAL nHeight := Help.Height
  LOCAL nCol    := Help.Col
  LOCAL nRow    := Help.Row

  IF EMPTY(lMax)
    nHelpWidth  := nWidth
    nHelpHeight := nHeight
    nHelpCol    := nCol
    nHelpRow    := nRow
  ENDIF
  Help.Contents.Width  := nWidth  - 30
  Help.Contents.Height := nHeight - 50 - IF(lThemed, 5, 0)

RETURN

//***************************************************************************

FUNCTION HelpText
  
  LOCAL cText := ;
    CRLF + ;
    'MINIGUI EXTENDED PROJECT MANAGER' + CRLF + ;
    CRLF + ;
    'CONTENTS' + CRLF + ;
    CRLF + ;
    'Introduction' + CRLF + ;
    'First time setup' + CRLF + ;
    'Basic operation' + CRLF + ;
    'Menus' + CRLF + ;
    'Toolbar' + CRLF + ;
    'Sources tab' + CRLF + ;
    'Dependents tab' + CRLF + ;
    'Options tab' + CRLF + ;
    'Libraries and object files tab' + CRLF + ;
    'Status information' + CRLF + ;
    'Hotkeys' + CRLF + ;
    'Environment window' + CRLF + ;
    'Optional command line parameter' + CRLF + ;
    'SET PROCEDURE statements' + CRLF + ;
    'LOAD WINDOW statements' + CRLF + ;
    'Libraries that are always linked in' + CRLF + ;
    CRLF
  cText += ;
    'INTRODUCTION' + CRLF + ;
    CRLF + ;
    'This program builds a set of (x)Harbour source files into an EXE, ' + ;
    'using Harbour MiniGUI Extended.  Source files may include .PRG, ' + ;
    '.CH, .FMG, .RC, .C, and .H files.' + CRLF + ;  
    CRLF + ;
    'Unless you request otherwise, this program builds the EXE only ' + ;
    'when at least one source file is newer than the EXE, and it ' + ;
    'compiles only the newer source files.  This is called incremental ' + ;
    'compiling.' + CRLF + ;
    CRLF + ;
    'Only .PRG, .C, and .RC files are actually compiled.  If any of ' + ;
    'the .FMG, .C, or .H files change, then all of the .PRG files are ' + ;
    'compiled.  If any .H file changes, then all of the .C files are ' + ;
    'compiled.  You can also specify a list of files that causes an ' + ;
    'individual .PRG, .C, or .RC to be compiled, with the Dependent ' + ;
    'files window, explained below.' + CRLF + ;
    CRLF + ;
    'You must select a base folder and use source files only from this ' + ;
    'folder and folders below it.  The EXE has the same base name as ' + ;
    'the first source file, called the main source file.  In debug ' + ;
    'mode, the base name of the EXE has "_deb" appended to it.  Object ' + ;
    'files are put into an OBJ folder under the base folder, except ' + ;
    'in debug mode, when they are put into a DEB folder.  Other files ' + ;
    'generated by the build process are deleted after the build ' + ;
    'finishes, unless you request otherwise.' + CRLF + ;
    CRLF + ;
    'You may save the settings for each set of source files into an MPM ' + ;
    'file, and then open the MPM file with this program later.' +  CRLF + ;
    CRLF
  cText += ;
    'FIRST TIME SETUP' + CRLF + ;
    CRLF + ;
    'The first time you use this program, the envronment window comes ' + ;
    'up.  In this window, you are prompted to set the locations of BCC, ' + ;
    '(x)Harbour, MiniGUI, and your program editor, and to decide ' + ;
    'whether to associate MPM with .MPM, .PRG, and .C files.  ' + ;
    'Association means that when you double click on a file with this ' + ;
    'extension, MPM opens the file.' + CRLF + ;
    CRLF + ;
    'It is recommended to always associate MPM with .MPM files, and to ' + ;
    'associate MPM with .PRG and .C files if you have no other program ' + ;
    'associated with them.  For more information, see below.' + CRLF + ;
    CRLF + ;
    'These settings are stored in the file MPM.INI in the Windows ' + ;
    'folder.  This file is created the first time you run MPM and is ' + ;
    'updated every time you run the program.' + CRLF + ;
    CRLF
  cText += ;
    'BASIC OPERATION' + CRLF + ;
    CRLF + ;
    '- For the base folder, select the folder containing source ' + ;
    'files.' + CRLF + ;
    '- Use the plus button to add source files the project.' + CRLF + ;
    '- Press the Build button to build the EXE.' + CRLF + ;
    '- Press the Run button to run the EXE.' + CRLF + ;
    '- If desired, press the Save button to save the project settings ' + ;
    'to an MPM file.' + CRLF + ;
    CRLF
  cText += ;
    'MENUS' + CRLF + ;
    CRLF + ;
    'File / New:  Starts a new project.  Clears the list of source ' + ;
    'files, resets options to defaults, and prompts for a new base ' + ;
    'folder.  Same as the New button.' + CRLF + ;
    CRLF + ;
    'File / Open:  Opens a saved project from an .MPM file, or a .PRG ' + ;
    'or .C file as the first file of a new project.  Same as the Open ' + ;
    'button, or F3.' + CRLF + ;
    CRLF + ;
    'File / Save:  Saves the current project to the current .MPM file ' + ;
    'if there is one, or a new one otherwise.  Same as the Save button, ' + ;
    'or F2.' + CRLF + ;
    CRLF + ;
    'File / Save As:  Saves the current project to a new .MPM file.' + CRLF + ;
    CRLF + ;
    'File / Recent:  Allows you to open a recently used project.' + CRLF + ;
    CRLF + ;
    'File / Exit:  Exits the program.  Same as F10.' + CRLF + ;
    CRLF + ;
    'Project / Build:  Compiles and links the source files into an ' + ;
    'EXE.  Same as the Build button, or F4.' + CRLF + ;
    CRLF + ;
    'Project / Stop:  Stops the build process if it is running.  Same ' + ;
    'as the Stop button, or F5.  This feature requires Windows XP or ' + ;
    'higher.' + CRLF + ;
    CRLF + ;
    'Project / Run:  Runs the EXE.  Same as the Run button, or F6.' + CRLF + ;
    CRLF + ;
    'Project / Debug:  Sets or clears the option to build a debug ' + ;
    'EXE.  Same as Options tab / Create debug EXE.' + CRLF + ;
    CRLF + ;
    'Project / Rebuild:  Sets or clears the option to always rebuild ' + ;
    'the EXE regardless of source file dates.  Same as Options tab / ' + ;
    'Always rebuild project.' + CRLF + ;
    CRLF + ;
    'Project menu / Cleanup:  Deletes files created by the build ' + ;
    'process, except the executable.  It is recommended to use this ' + ;
    'option only when you no longer need to compile or debug the ' + ;
    'program.  Files deleted include: ' + CRLF + ;
    '- Debug executable,' + CRLF + ;
    '- All files in the OBJ and DEB folders,' + CRLF + ;
    '- PPO files,' + CRLF + ;
    '- Temporary files created by the build process.' + CRLF + ;
    CRLF + ;
    'Tools / Environment:  Allows you to set the locations of BCC, (x)' + ;
    'Harbour, MiniGUI, and your program editor, and to decide whether ' + ;
    'to associate MPM with .MPM, .PRG, and .C files.  See below.' + CRLF + ;
    CRLF
  cText += ;
    'TOOLBAR' + CRLF + ;
    CRLF + ;
    'New:  Starts a new project.  Clears the list of source files, ' + ;
    'resets options to defaults, and prompts for a new base folder.  ' + ;
    'Same as File menu / New.' + CRLF + ;
    CRLF + ;
    'Open:  Opens a saved project from an .MPM file, or a .PRG or .C ' + ;
    'file as the first file of a new project.  Same as File menu / ' + ;
    'Open, or F3.' + CRLF + ;
    CRLF + ;
    'Save:  Saves the current project to the current .MPM file if there ' + ;
    'is one, or a new one otherwise.  Same as File menu / Save, or ' + ;
    'F2.' + CRLF + ;
    CRLF + ;
    'Build:  Compiles and links the source files into an EXE.  Same as ' + ;
    'Project menu / Build, or F4.' + CRLF + ;
    CRLF + ;
    'Stop:  Stops the build process if it is running.  Same as the Stop ' + ;
    'button, or F5.  This feature requires Windows XP or higher.' + CRLF + ;
    CRLF + ;
    'Run:  Runs the EXE.  Same as Project menu / Run, or F6.' + CRLF + ;
    CRLF
  cText += ;
    'SOURCES TAB' + CRLF + ;
    CRLF + ;
    'Project folder:  The folder that contains the source files.  If ' + ;
    'source files are in multiple folders, this is the topmost folder ' + ;
    'that contains the files.  The EXE is built in this folder.' + CRLF + ;
    CRLF + ;
    'Plus button:  Adds one or more source files from the project base ' + ;
    'folder to the source file list.  Source files may include .PRG, ' + ;
    '.CH, .FMG, .RC, .C, and .H files.  The first source file in the ' + ;
    'list becomes the main source file and must contain the main ' + ;
    'procedure.' + CRLF + ;
    CRLF + ;
    'X button:  Removes the highlighted source file from the list.' + CRLF + ;
    CRLF + ;
    'Write button:  Edits the highlighted source file.  Set the editor ' + ;
    'in the Environment window.' + CRLF + ;
    CRLF + ;
    'Up top button:  Moves the highlighted source file to the top of ' + ;
    'the list, making it the main source file.  Only a .PRG or .C file ' + ;
    'may be the main source file.' + CRLF + ;
    CRLF + ;
    'Up and down buttons:  Move the highlighted source file up or down ' + ;
    'one position within the list.' + CRLF + ;
    CRLF
  cText += ;
    'DEPENDENTS TAB' + CRLF + ;
    CRLF + ;
    'For each source file, you may specify a list of dependent files, ' + ;
    'which are files that trigger the source file to be compiled, even ' + ;
    'if the source file itself has not been changed.  This typically ' + ;
    'includes header files that the source file references, but it may ' + ;
    'include any type of file.' + CRLF + ;
    CRLF + ;
    'You may specify dependent files only for files that are compiled, ' + ;
    'namely .PRG, .C, and .RC files.  When dependent files have been ' + ;
    'specified for a source file, the number of dependent files appears ' + ;
    'in brackets after the source file name.' + CRLF + ;
    CRLF + ;
    'Plus button:  Adds one or more files to the dependent files ' + ;
    'list.  Dependent files may be of any file type.' + CRLF + ;
    CRLF + ;
    'X button:  Removes the highlighted file from the dependent files ' + ;
    'list.' + CRLF + ;
    CRLF + ;
    'Write button:  Edits the highlighted dependent file.  Set the ' + ;
    'editor in the Environment window.' + CRLF + ;
    CRLF + ;
    'Up and down buttons:  Move the highlighted file up or down ' + ;
    'one position within the dependent files list.' + CRLF + ;
    CRLF
  cText += ;
    'OPTIONS TAB' + CRLF + ;
    CRLF + ;
    'Create debug EXE:  Compile and link in debug mode.  Same as ' + ;
    'Project menu / Debug.' + CRLF + ;
    CRLF + ;
    'Always rebuild project:  Always rebuild the EXE regardless of ' + ;
    'source file dates.  Same as Project menu / Rebuild.' + CRLF + ;
    CRLF + ;
    'Run after build:  Run the EXE immediately after a successful ' + ;
    'build.' + CRLF + ;
    CRLF + ;
    'Hide build window:  Hide the temporary window that this program ' + ;
    'creates to run the build process.  Output from the build process ' + ;
    'is shown in the log instead.' + CRLF + ;
    CRLF + ;
    'Delete temporary files:  Delete temporary files created by the ' + ;
    'build process after the build is completed,' + CRLF + ;
    CRLF + ;
    'Use xHarbour:  Use xHarbour instead of Harbour.  Set the xHarbour ' + ;
    'path in the Environment window.' + CRLF + ;
    CRLF + ;
    'Generate PPO:  Generate preprocessor output in a PPO file for each ' + ;
    'PRG file.' + CRLF + ;
    CRLF + ;
    'Additional compiler options:  Additional parameters to add to the ' + ;
    'compiler when a .PRG file is compiled with (x)Harbour.' + CRLF + ;
    CRLF + ;
    'EXE ccmmand line options:  Parameters to add to the EXE command ' + ;
    'line when it is run.' + CRLF + ;
    CRLF + ;
    'Executable type' + CRLF + ;
    '- GUI:  A Windows program the uses the usual graphical user ' + ;
    'interface.' + CRLF + ;
    '- Console:  A Windows program that uses the character based ' + ;
    'interface.' + CRLF + ;
    '- Mixed:  A Windows program that uses both GUI and console ' + ;
    'modes.' + CRLF + ;
    CRLF + ;
    'Compiler warnings' + CRLF + ;
    '- None:  The compiler reports only errors.' + CRLF + ;
    '- Basic:  The compiler reports errors and undeclared or ambiguous ' + ;
    'names.' + CRLF + ;
    '- Strong:  The compiler generates basic warnings and additional ' + ;
    'warnings.' + CRLF + ;
    '- Typed:  The compiler generates strong warnings and does type ' + ;
    'checking.' + CRLF + ;
    CRLF + ;
    'Generate library:  Create a library from the source code instead ' + ;
    'of an EXE file.' + CRLF + ;
    CRLF
  cText += ;
    'LIBRARIES AND OBJECT FILES TAB' + CRLF + ;
    CRLF + ;
    'This tab allows you to link in libraries and object files that ' + ;
    'are not otherwise linked in.  See below for a list of libraries ' + ;
    'and object files that are always linked in.' + CRLF + ;
    CRLF + ;
    'ZIP support:  Add zip file support using the (x)Harbour library ' + ;
    'ziparchive.lib.' + CRLF + ;
    CRLF + ;
    'ODBC support:  Add ODBC support using the (x)Harbour libraries ' + ;
    'hdodbc.lib and odbc32.lib.' + CRLF + ;
    CRLF + ;
    'ADS support:  Add ADS support using the (x)Harbour libraries ' + ;
    'rddads.lib and ace32.lib.' + CRLF + ;
    CRLF + ;
    'MySQL support:  Add MySQL support using the (x)Harbour libraries ' + ;
    'mysql.lib and libmysql.lib.' + CRLF + ;
    CRLF + ;
    'Additional libraries and object files:  Add libraries and object ' + ;
    'files not in the above categories.' + CRLF + ;
    CRLF + ;
    'Plus-H button:  Add a (x)Harbour library.' + CRLF + ;
    CRLF + ;
    'Plus-M button:  Add a MiniGUI library.' + CRLF + ;
    CRLF + ;
    'Plus-O button:  Add any other library or object file.  A library ' + ;
    'may be any .LIB file.  An object file may be any .OBJ or .RES ' + ;
    'file.' + CRLF + ;
    CRLF + ;
    'X button:  Delete the highlighted library or object file from the ' + ;
    'list.' + CRLF + ;
    CRLF + ;
    'Up and down buttons:  Move the highlighted library or object file ' + ;
    'up or down one position within the list.' + CRLF + ;
    CRLF
  cText += ;
    'STATUS INFORMATION' + CRLF + ;
    CRLF + ;
    'Status line:  This line displays to the right of the toolbar and ' + ;
    'shows the following status indicators.' + CRLF + ;
    '- Building:  The current project is currently being built.' + CRLF + ;
    '- Debug:  The debug option has been selected.' + CRLF + ;
    '- Rebuild:  The rebuild option has been selected.' + CRLF + ;
    CRLF + ;
    'Log:  During a build process, the log displays progress output from ' + ;
    'the compiler or linker.  After a build process has completed, the ' + ;
    'log displays error and warning output from the compiler or ' + ;
    'linker.  You can show this output in a temporary window instead of ' + ;
    'this box by deselecting Options tab / Hide build window.' + CRLF + ;
    CRLF
  cText += ;
    'HOTKEYS' + CRLF + ;
    CRLF + ;
    '- F1 Help:  Same as Help menu / Contents.' + CRLF + ;
    '- F2 Save:  Same as File menu / Save, or the Save button.' + CRLF + ;
    '- F3 Open:  Same as File menu / Open, or the Open button.' + CRLF + ;
    '- F4 Build:  Same as Project menu / Build, or the Build ' + ;
    'button.' + CRLF + ;
    '- F5 Stop:  Same as Project menu / Stop, or the Stop button.  This ' + ;
    'feature requires Windows XP or higher.' + CRLF + ;
    '- F6 Run:  Same as Project menu / Run, or the Run button.' + CRLF + ;
    '- F10 Exit:  Same as File menu / Exit.' + CRLF + ;
    CRLF
  cText += ;
    'ENVIRONMENT WINDOW' + CRLF + ;
    CRLF + ;
    'This window comes up the first time you run the program.  After ' + ;
    'that, use Tools menu / Environment.' + CRLF + ;
    CRLF + ;
    'BCC folder:  Location of BCC, the folder cotaining its Bin, ' + ;
    'Include, and Lib folders.  Defaults to C:\Borland\BCC55.' + CRLF + ;
    CRLF + ;
    'MiniGUI folder:  Location of MiniGUI, the folder containing its ' + ;
    'Bin, Include, and Lib folders.  Defaults to C:\MiniGUI.' + CRLF + ;
    CRLF + ;
    'Harbour folder:  Location of Harbour, the folder containing its ' + ;
    'in, Include, and Lib folders.  Defaults to C:\MiniGUI\Harbour.' + CRLF + ;
    CRLF + ;
    'xHarbour folder:  Location of xHarbour, the folder containing its ' + ;
    'Bin, Include, and Lib folders.  Defaults to C:\xHarbour.' + CRLF + ;
    CRLF + ;
    'Program editor:  Location and file name of the editor for the edit ' + ;
    'button to use to edit a PRG file.  Defaults to NOTEPAD.EXE.' + CRLF + ;
    CRLF + ;
    'Associate MPM files with MPM:  Whether a double click on an .MPM ' + ;
    'file opens the file with this program.  It is recommended to ' + ;
    'always associate .MPM files with MPM.' + CRLF + ;
    CRLF + ;
    'Associate PRG files with MPM:  Whether a double click on a .PRG ' + ;
    'file opens the file with this program.  It is recommended to ' + ;
    'associate .PRG files with MPM if you have no other program ' + ;
    'associated with them.  To check the current association, click on ' + ;
    'the button to the right of the checkbox.' + CRLF + ;
    CRLF + ;
    'Associate C files with MPM:  Whether a double click on an .MPM ' + ;
    'file opens the file with this program.  It is recommended to ' + ;
    'associate .C files with MPM if you have no other program ' + ;
    'associated with them.  To check the current association, click on ' + ;
    'the button to the right of the checkbox.' + CRLF + ;
    CRLF
  cText += ;
    'OPTIONAL COMMAND LINE PARAMETER' + CRLF + ;
    CRLF + ;
    'This program accepts an MPM, PRG, or C file as an optional command ' + ;
    'line argument.  To associate any of these extensions with this ' + ;
    'program, use Tools menu / Environment.  An MPM file is created by ' + ;
    'the Save options of this program to contain the settings for a ' + ;
    'project.' + CRLF + ;
    CRLF
  cText += ;
    'SET PROCEDURE STATEMENTS' + CRLF + ;
    CRLF + ;
    'A SET PROCEDURE statement instructs (x)Harbour to compile one or ' + ;
    'more additional .PRG files.  It is recommended to put a PRG file ' + ;
    'containing a SET PROCEDURE into the source file list, and to put .' + ;
    'PRG files referenced by the SET PROCEDURE statement into the ' + ;
    'dependent files list for the source PRG.' + CRLF + ;
    CRLF
  cText += ;
    'LOAD WINDOW STATEMENTS' + CRLF + ;
    CRLF + ;
    'A LOAD WINDOW statement instructs (x)Harbour to load a window ' + ;
    'definition from an .FMG file.  It is recommended to put a PRG file ' + ;
    'containing a LOAD WINDOW statement into the source file list, and ' + ;
    'to put an FMG file referenced by the LOAD WINDOW statement into ' + ;
    'the dependent files list for the source PRG.' + CRLF + ;
    CRLF
  cText += ;
    'LIBRARIES THAT ARE ALWAYS LINKED IN' + CRLF + ;
    CRLF + ;
    'The following libraries and object files are linked into every ' + ;
    'project.' + CRLF + ;
    CRLF + ;
    '(x)Harbour libraries:' + CRLF + ;
    '- dll.lib' + CRLF + ;
    '- gtwin.lib (console programs only)' + CRLF + ;
    '- gtgui.lib (GUI programs only)' + CRLF + ;
    '- compiler.lib (Harbour only)' + CRLF + ;
    '- rtl.lib' + CRLF + ;
    '- vm.lib' + CRLF + ;
    '- lang.lib' + CRLF + ;
    '- codepage.lib' + CRLF + ;
    '- macro.lib' + CRLF + ;
    '- rdd.lib' + CRLF + ;
    '- hsx.lib' + CRLF + ;
    '- dbfntx.lib' + CRLF + ;
    '- dbfcdx.lib' + CRLF + ;
    '- dbffpt.lib' + CRLF + ;
    '- hbsix.lib' + CRLF + ;
    '- common.lib' + CRLF + ;
    '- debug.lib' + CRLF + ;
    '- pp.lib' + CRLF + ;
    '- hbpcre.lib (Harbour only)' + CRLF + ;
    '- pcrepos.lib (xHarbour only)' + CRLF + ;
    '- ct.lib (xHarbour only)' + CRLF + ;
    '- libct.lib (Harbour only)' + CRLF + ;
    '- libmisc.lib' + CRLF + ;
    '- hbole.lib (Harbour only)' + CRLF + ;
    '- hbprinter.lib (GUI programs only)' + CRLF + ;
    '- socket.lib (GUI programs only)' + CRLF + ;
    '- miniprint.lib (GUI programs only)' + CRLF + ;
    CRLF + ;
    'MiniGUI libraries and object files:' + CRLF + ;
    '- tsbrowse.lib' + CRLF + ;
    '- propgrid.lib' + CRLF + ;
    '- minigui.lib' + CRLF + ;
    '- hbprinter.res' + CRLF + ;
    '- miniprint.res' + CRLF + ;
    '- minigui.res' + CRLF + ;
    CRLF + ;
    'Borland libraries and object files:' + CRLF + ;
    '- c0w32.obj' + CRLF + ;
    '- cw32.lib' + CRLF + ;
    '- import32.lib' + CRLF
  
RETURN cText

//***************************************************************************