/*
 * HARBOUR MINIGUI PROJECT MANAGER - Command Line Version
 *
 * Copyright 2003-2004 Roberto Lopez <harbourminigui@gmail.com>
 *
 * MiniGUI Extended version by the MiniGUI team
*/

//***************************************************************************

ANNOUNCE RDDSYS

#include 'common.ch'

Memvar zs , os , as , ms , prg , pf , bf , mf , hf , DebugActive , CleanActive
Memvar DBS

//***************************************************************************

Procedure Main ( ProjectFile , Param1 , Param2 )
Local C , i , Line , WinFolder := GetWindowsFolder(), EnvironmentFile
Public zs , os , as , ms , prg := {} , pf , bf , mf , hf , DebugActive := .F. , CleanActive := .F.
Private DBS

	If pcount() = 0 .or. pcount() > 3
		? "Harbour MiniGUI Project Manager R.21 (Command Line Version)"
		? "(c) 2003-2004 Roberto Lopez <harbourminigui@gmail.com>"
		? ''
		? "MiniGUI Extended version by the MiniGUI team"
		? ''
		? "Usage: mpmc <ProjectFile> [/d] [/c]"
		? ''
		wait
		return
	endif

	if .not. file (ProjectFile)
		? 'Project File Is Not Found'
		? ''
		wait
		return
	EndIf

	If pcount() > 1
		If AllTrim(Upper(Param1)) = "/D" 
			DebugActive := .T.
		EndIf
		If Valtype(Param2) == 'C' .and. AllTrim(Upper(Param2)) = "/D" 
			DebugActive := .T.
		EndIf
		If AllTrim(Upper(Param1)) = "/C"
			CleanActive := .T.
		EndIf
		If  Valtype(Param2) == 'C' .and. AllTrim(Upper(Param2)) = "/C" 
			CleanActive := .T.
		EndIf
	EndIf

	WinFolder += If ( Right ( WinFolder , 1 ) != '\' , '\' , '' )
	EnvironmentFile := MemoRead ( WinFolder + 'mpm.ini' )

	If Empty ( EnvironmentFile )
		SaveEnvironment ( WinFolder )
		EnvironmentFile := MemoRead ( WinFolder + 'mpm.ini' )
	EndIf

	For i := 1 To MLCount ( EnvironmentFile )

		Line := AllTrim ( MEMOLINE ( EnvironmentFile , , i ) )

		If	Upper (Line) = 'BCCFOLDER'
			bf := SubStr ( Line , 11 , 255 )
		ElseIf	Upper (Line) = 'MINIGUIFOLDER'
			mf := SubStr ( Line , 15 , 255 )
		ElseIf	Upper (Line) = 'HARBOURFOLDER'
			hf := SubStr ( Line , 15 , 255 )
		EndIf

	Next i
		
	If ! Empty ( Projectfile )

		C := MemoRead ( ProjectFile )

		For i := 1 To MLCount ( C )

			Line := AllTrim ( MEMOLINE ( C , , i ) )

			If 	Upper (Line) = 'PROJECTFOLDER'
				pf := SubStr ( Line , 15 , 255 )
			ElseIf	Upper (Line) = 'ZIPSUPPORT' 
				zs := ( Upper ( SubStr ( Line , 12 , 3 ) ) = 'YES' )
			ElseIf	Upper (Line) = 'ODBCSUPPORT'
				os := ( Upper ( SubStr ( Line , 13 , 3 ) ) = 'YES' )
			ElseIf	Upper (Line) = 'ADSSUPPORT'
				as := ( Upper ( SubStr ( Line , 12 , 3 ) ) = 'YES' )
			ElseIf	Upper (Line) = 'MYSQLSUPPORT'
				ms := ( Upper ( SubStr ( Line , 14 , 3 ) ) = 'YES' )
			ElseIf	Right ( Upper ( Line) , 4 ) == '.PRG'
				aadd ( prg , AllTrim(Line) )
			EndIf

		Next i

	EndIf

	If File ('C:\MPM.TMP')

		RESTORE FROM C:\MPM.TMP ADDITIVE

		IF	( DBS = 'DEBUG' .AND. DebugActive == .F. ) ;
			.OR. ;
			( DBS = 'NODEBUG' .AND. DebugActive == .T. ) 
			Clean()
		ENDIF

	Else

		Clean()

	EndIf

	If DebugActive == .T.
		DBS := 'DEBUG'
	Else
		DBS := 'NODEBUG'
	EndIf

	SAVE TO C:\MPM.TMP ALL LIKE DBS 

	Build()

	? ''
	? 'Finished.'
	? ''
	wait

Return

//***************************************************************************

Procedure Build 

Local MakeName
Local ParamString
Local Out := ''
Local i
Local PROJECTFOLDER	:= pf + If ( Right ( pf , 1 ) != '\' , '\' , '' )
Local ZIPSUPPORT	:= zs
Local ODBCSUPPORT	:= os
Local ADSSUPPORT	:= as
Local MYSQLSUPPORT	:= ms
Local BCCFOLDER		:= bf + If ( Right ( bf , 1 ) != '\' , '\' , '' )
Local MINIGUIFOLDER	:= mf + If ( Right ( mf , 1 ) != '\' , '\' , '' )
Local HARBOURFOLDER	:= hf + If ( Right ( hf , 1 ) != '\' , '\' , '' )
Local PRGFILES		:= prg

	SetCurrentFolder ( pf )

	DELETE FILE ( PROJECTFOLDER + 'End.Txt' )

	CreateFolder ( PROJECTFOLDER + 'OBJ' )

	Out := Out + 'HARBOUR_EXE = ' + HARBOURFOLDER + 'BIN\HARBOUR.EXE'  + Chr(13) + Chr(10)
	Out := Out + 'CC = ' + BCCFOLDER + 'BIN\BCC32.EXE'  + Chr(13) + Chr(10)	
	Out := Out + 'ILINK_EXE = ' + BCCFOLDER + 'BIN\ILINK32.EXE'  + Chr(13) + Chr(10)	
	Out := Out + 'BRC_EXE = ' + BCCFOLDER + 'BIN\BRC32.EXE'  + Chr(13) + Chr(10)	
	Out := Out + 'APP_NAME = ' + PROJECTFOLDER + Left ( PRGFILES [1] , Len( PRGFILES [1] ) - 4 ) + '.Exe' + Chr(13) + Chr(10)	
	Out := Out + 'RC_FILE = ' + MINIGUIFOLDER + 'RESOURCES\MINIGUI.RC'  + Chr(13) + Chr(10)	
	Out := Out + 'INCLUDE_DIR = ' + HARBOURFOLDER + 'INCLUDE;' + MINIGUIFOLDER + 'INCLUDE' + ';' + pf + Chr(13) + Chr(10)	
	Out := Out + 'CC_LIB_DIR = ' + BCCFOLDER + 'LIB'  + Chr(13) + Chr(10)	
	Out := Out + 'HRB_LIB_DIR = ' + HARBOURFOLDER + 'LIB'  + Chr(13) + Chr(10)
	Out := Out + 'OBJ_DIR = ' + PROJECTFOLDER + 'OBJ' + Chr(13) + Chr(10)	
	Out := Out + 'C_DIR = ' + PROJECTFOLDER + 'OBJ' + Chr(13) + Chr(10)	
	Out := Out + 'USER_FLAGS = ' + Chr(13) + Chr(10)	

	If DebugActive == .T.
		MemoWrit ( PROJECTFOLDER +  'Init.Cld' , 'OPTIONS NORUNATSTARTUP' )
		Out := Out + 'HARBOUR_FLAGS = /i$(INCLUDE_DIR)  /n /b $(USER_FLAGS)' + Chr(13) + Chr(10)	
	Else
		Out := Out + 'HARBOUR_FLAGS = /i$(INCLUDE_DIR)  /n $(USER_FLAGS)' + Chr(13) + Chr(10)	
	EndIf

	Out := Out + 'COBJFLAGS =  -c -O2 -tW -M  -I' + BCCFOLDER + 'INCLUDE -I$(INCLUDE_DIR) -L' + BCCFOLDER + 'LIB' + Chr(13) + Chr(10)

	Out := Out + chr(13) + chr(10)
	Out := Out + '$(APP_NAME) : $(OBJ_DIR)\' + Left ( PRGFILES [1] , Len( PRGFILES [1] ) - 4 )  + '.obj \' + chr(13) + chr(10)
	For i := 2 To Len ( PrgFiles)

		If i == Len ( PrgFiles)
			Out := Out + '		$(OBJ_DIR)\' + Left ( PRGFILES [i] , Len( PRGFILES [i] ) - 4 )  + '.obj' + chr(13) + chr(10)
		Else
			Out := Out + '		$(OBJ_DIR)\' + Left ( PRGFILES [i] , Len( PRGFILES [i] ) - 4 )  + '.obj \' + chr(13) + chr(10)
		EndIf

	Next i
	Out := Out + chr(13) + chr(10)

	If File ( PROJECTFOLDER + Left ( PRGFILES [1] , Len( PRGFILES [1] ) - 4 ) + '.Rc' )
		Out := Out + ' $(BRC_EXE) -d__BORLANDC__ -r -fo' +  PROJECTFOLDER + Left ( PRGFILES [1] , Len( PRGFILES [1] ) - 4 ) + '.Res ' + PROJECTFOLDER + Left ( PRGFILES [1] , Len( PRGFILES [1] ) - 4 ) + '.Rc ' + chr(13) + chr(10)
	EndIf

	For i := 1 To Len ( PrgFiles )
		Out := Out + '     echo $(OBJ_DIR)\' +  Left ( PRGFILES [i] , Len( PRGFILES [i] ) - 4 ) +  '.obj + >' + if(i>1,'>','') +'b32.bc ' + chr(13) + chr(10)
	Next i 

	Out := Out + ' echo ' + BCCFOLDER + 'LIB\c0w32.obj, + >> b32.bc ' + chr(13) + chr(10)

	Out := Out + ' echo $(APP_NAME),' + Left ( PRGFILES [1] , Len( PRGFILES [1] ) - 4 ) + '.map, + >> b32.bc' + chr(13) + chr(10)

	Out := Out + ' echo ' + MINIGUIFOLDER + 'LIB\tsbrowse.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo ' + MINIGUIFOLDER + 'LIB\propgrid.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo ' + MINIGUIFOLDER + 'LIB\minigui.lib + >> b32.bc' + chr(13) + chr (10)

	Out := Out + ' echo $(HRB_LIB_DIR)\dll.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\calldll.lib + >> b32.bc' + chr(13) + chr (10)
#ifndef __XHARBOUR__
	Out := Out + ' echo $(HRB_LIB_DIR)\compiler.lib + >> b32.bc' + chr(13) + chr (10)
#endif
	Out := Out + ' echo $(HRB_LIB_DIR)\rtl.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\vm.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\gtgui.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\rdd.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\dbfntx.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\dbfcdx.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\dbffpt.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\hbsix.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\lang.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\codepage.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\macro.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\common.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\debug.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\pp.lib + >> b32.bc' + chr(13) + chr (10)
#ifdef __XHARBOUR__
	Out := Out + ' echo $(HRB_LIB_DIR)\pcrepos.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\ct.lib + >> b32.bc' + chr(13) + chr (10)
#else
	Out := Out + ' echo $(HRB_LIB_DIR)\hbpcre.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\libct.lib + >> b32.bc' + chr(13) + chr (10)
#endif
	Out := Out + ' echo $(HRB_LIB_DIR)\libmisc.lib + >> b32.bc' + chr(13) + chr (10)
#ifndef __XHARBOUR__
	Out := Out + ' echo $(HRB_LIB_DIR)\hbole.lib + >> b32.bc' + chr(13) + chr (10)
#endif
	Out := Out + ' echo $(HRB_LIB_DIR)\hbprinter.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\miniprint.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(HRB_LIB_DIR)\socket.lib + >> b32.bc' + chr(13) + chr (10)

	If zs == .T.					
		Out := Out + ' echo $(HRB_LIB_DIR)\ziparchive.lib + >> b32.bc' + chr(13) + chr (10)
	EndIf

	If os == .T.					
		Out := Out + ' echo $(HRB_LIB_DIR)\hbodbc.lib + >> b32.bc' + chr(13) + chr (10)
		Out := Out + ' echo $(HRB_LIB_DIR)\odbc32.lib + >> b32.bc' + chr(13) + chr (10)
	EndIf

	If as == .T.					
		Out := Out + ' echo $(HRB_LIB_DIR)\rddads.lib + >> b32.bc' + chr(13) + chr (10)
		Out := Out + ' echo $(HRB_LIB_DIR)\ace32.lib  + >> b32.bc' + chr(13) + chr (10)
	EndIf

	If ms == .T.					
		Out := Out + ' echo $(HRB_LIB_DIR)\mysql.lib + >> b32.bc' + chr(13) + chr (10)
		Out := Out + ' echo $(HRB_LIB_DIR)\libmysql.lib  + >> b32.bc' + chr(13) + chr (10)
	EndIf

	Out := Out + ' echo $(CC_LIB_DIR)\cw32.lib + >> b32.bc' + chr(13) + chr (10)
	Out := Out + ' echo $(CC_LIB_DIR)\import32.lib, >> b32.bc' + chr(13) + chr (10)

	If File ( PROJECTFOLDER + Left ( PRGFILES [1] , Len( PRGFILES [1] ) - 4 ) + '.Rc' )
		Out := Out + '      echo ' + PROJECTFOLDER + Left ( PRGFILES [1] , Len( PRGFILES [1] ) - 4 ) + '.Res' + ' + >> b32.bc' + chr(13) + chr(10)
	EndIf

	Out := Out + '     echo ' + MINIGUIFOLDER + 'RESOURCES\hbprinter.res + >> b32.bc' + chr(13) + chr(10)
	Out := Out + '     echo ' + MINIGUIFOLDER + 'RESOURCES\miniprint.res + >> b32.bc' + chr(13) + chr(10)
	Out := Out + '     echo ' + MINIGUIFOLDER + 'RESOURCES\minigui.res >> b32.bc' + chr(13) + chr(10)

	If DebugActive == .T.

		Out := Out + ' $(ILINK_EXE)  -Gn -Tpe -ap -L'+ BCCFOLDER + 'LIB' + ' @b32.bc' + chr(13) + chr(10)

	Else

		Out := Out + ' $(ILINK_EXE)  -Gn -Tpe -aa -L'+ BCCFOLDER + 'LIB' + ' @b32.bc' + chr(13) + chr(10)

	EndIf

	Out := Out + chr(13) + chr(10)

	For i := 1 To Len ( PrgFiles )

		Out := Out + chr(13) + chr(10)
		Out := Out + '$(C_DIR)\' + Left ( PRGFILES [i] , Len( PRGFILES [i] ) - 4 ) + '.c : ' + PROJECTFOLDER + Left ( PRGFILES [i] , Len( PRGFILES [i] ) - 4 ) + '.Prg' + chr(13) + chr(10)
		Out := Out + '    $(HARBOUR_EXE) $(HARBOUR_FLAGS) $** -o$@'  + chr(13) + chr(10)

		Out := Out + chr(13) + chr(10)
		Out := Out + '$(OBJ_DIR)\'  + Left ( PRGFILES [i] , Len( PRGFILES [i] ) - 4 ) + '.obj : $(C_DIR)\' +  Left ( PRGFILES [i] , Len( PRGFILES [i] ) - 4 ) + '.c'  + chr(13) + chr(10)
		Out := Out + '    $(CC) $(COBJFLAGS) -o$@ $**' + chr(13) + chr(10)

	Next i

	Memowrit ( PROJECTFOLDER +  '_Temp.Bc' , Out )

	MakeName := BCCFOLDER + 'BIN\MAKE.EXE'
	ParamString := '/f' + PROJECTFOLDER + '_Temp.Bc'  

	Memowrit ( PROJECTFOLDER + '_Build.Bat' , '@ECHO OFF' + chr(13) + chr(10) + MakeName + ' ' + ParamString + chr(13) + chr(10) + 'Echo End > ' + PROJECTFOLDER + 'End.Txt' + chr(13) + chr(10) )

	run ( PROJECTFOLDER + '_Build.Bat ' )

	DELETE FILE ( PROJECTFOLDER + '_Build.Bat' )
	DELETE FILE ( PROJECTFOLDER + '_Temp.Bc' )
	DELETE FILE ( PROJECTFOLDER + 'B32.Bc' )
	DELETE FILE ( PROJECTFOLDER + 'End.Txt' )

	If CleanActive == .T.

		Clean ( .f. )

	EndIf

Return

//***************************************************************************

Procedure Clean ( deleteexe )

LOCAL PROJECTFOLDER := pf + If ( Right ( pf , 1 ) != '\' , '\' , '' )

LOCAL aCFiles  [ ADIR ( PROJECTFOLDER + 'OBJ\*.C' ) ]
LOCAL aObjFiles[ ADIR ( PROJECTFOLDER + 'OBJ\*.OBJ' ) ]
LOCAL aMapFiles[ ADIR ( PROJECTFOLDER + '*.MAP' ) ]
LOCAL aTdsFiles[ ADIR ( PROJECTFOLDER + '*.TDS' ) ]

LOCAL i

	default deleteexe to .t.

	ADIR ( PROJECTFOLDER + 'OBJ\*.C'   , aCFiles )
	ADIR ( PROJECTFOLDER + 'OBJ\*.OBJ' , aObjFiles )
	ADIR ( PROJECTFOLDER + '*.MAP'     , aMapFiles )
	ADIR ( PROJECTFOLDER + '*.TDS'     , aTdsFiles )
	
	For i := 1 To Len (aCFiles)
		DELETE FILE ( PROJECTFOLDER + 'OBJ\' +  aCFiles[i] )
	Next i

	For i := 1 To Len (aObjFiles)
		DELETE FILE ( PROJECTFOLDER + 'OBJ\' +  aObjFiles[i] )
	Next i

	For i := 1 To Len (aMapFiles)
		DELETE FILE ( PROJECTFOLDER + aMapFiles[i] )
	Next i

	For i := 1 To Len (aTdsFiles)
		DELETE FILE ( PROJECTFOLDER + aTdsFiles[i] )
	Next i

	If deleteexe == .T.
		DELETE FILE ( PROJECTFOLDER + Left ( PRG [1] , Len(PRG [1] ) - 4 ) + '.exe' )
	EndIf

Return

//***************************************************************************

Procedure SaveEnvironment ( WinFolder )
Local c := ''

	c += 'BCCFOLDER=C:\BORLAND\BCC55' + Chr(13) + Chr(10)
	c += 'MINIGUIFOLDER=C:\MINIGUI' + Chr(13) + Chr(10)
	c += 'HARBOURFOLDER=C:\MINIGUI\HARBOUR' + Chr(13) + Chr(10)
	c += 'PROGRAMEDITOR=NOTEPAD.EXE' + Chr(13) + Chr(10)

	MemoWrit ( WinFolder + 'mpm.ini' , c )

Return

//***************************************************************************

#pragma BEGINDUMP

#define HB_OS_WIN_32_USED
#define _WIN32_WINNT   0x0400

#include <windows.h>
#include "hbapi.h"
#include "hbapiitm.h"

HB_FUNC( GETWINDOWSFOLDER )
{
	char szBuffer[ MAX_PATH + 1 ] = {0};

	GetWindowsDirectory( szBuffer, MAX_PATH );

	hb_retc( szBuffer );
}

HB_FUNC ( CREATEFOLDER )
{
	CreateDirectory( (LPCTSTR) hb_parc(1) , NULL );
}

HB_FUNC ( SETCURRENTFOLDER )
{
	SetCurrentDirectory( (LPCTSTR) hb_parc(1) );
}

#pragma ENDDUMP

//***************************************************************************
